var forum;
(function (forum) {
    const ipc = require("electron").ipcRenderer;
    let callback_listener = [];
    ipc.on('teaforo-update', (event, data) => {
        console.log("Got data update: %o", data);
        profiles.identities.set_static_identity(data ? new profiles.identities.TeaForumIdentity(data.application_data, data.application_data_sign) : undefined);
        try {
            for (let listener of callback_listener)
                setImmediate(listener);
        }
        catch (e) {
            console.log(e);
        }
        callback_listener = [];
    });
    function register_callback(callback) {
        callback_listener.push(callback);
    }
    forum.register_callback = register_callback;
    function open() {
        ipc.send("teaforo-login");
    }
    forum.open = open;
    function logout() {
        ipc.send("teaforo-logout");
    }
    forum.logout = logout;
    function sync_main() {
        ipc.send("teaforo-update");
    }
    forum.sync_main = sync_main;
})(forum || (forum = {}));
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try {
            step(generator.next(value));
        }
        catch (e) {
            reject(e);
        } }
        function rejected(value) { try {
            step(generator["throw"](value));
        }
        catch (e) {
            reject(e);
        } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["ad22923ebcdb6c3772da59d8eb479de6244fac21cbb60ddb3c5f8f3f230b34bc"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["ad22923ebcdb6c3772da59d8eb479de6244fac21cbb60ddb3c5f8f3f230b34bc"] = "ad22923ebcdb6c3772da59d8eb479de6244fac21cbb60ddb3c5f8f3f230b34bc";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "KHA_Xt5B", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (68,48)" }, { name: "A4CUBvq1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (84,51)" }, { name: "gbh0OPNj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (90,51)" }, { name: "eGlj0HhJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (102,51)" }, { name: "QNgVL12c", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (118,38)" }, { name: "Gm4JEiK5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (222,43)" }, { name: "DNCmlQOd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (230,44)" }, { name: "QqrchW_d", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (237,39)" }, { name: "N5drRic1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (418,29)" }, { name: "SQ5EGQgG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (422,33)" }, { name: "vh9_WbXO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/BrowserIPC.ts (435,30)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var bipc;
(function (bipc) {
    function uuidv4() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            const r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }
    class BasicIPCHandler {
        constructor() {
            this._channels = [];
            this._query_results = {};
            this._cert_accept_callbacks = {};
            this._cert_accept_succeeded = {};
        }
        setup() {
            this.unique_id = uuidv4(); /* lets get an unique identifier */
        }
        get_local_address() { return this.unique_id; }
        handle_message(message) {
            console.log("Received: %o", message);
            if (message.receiver === BasicIPCHandler.BROADCAST_UNIQUE_ID) {
                if (message.type == "process-query") {
                    log.debug(LogCategory.IPC, _translations.KHA_Xt5B || (_translations.KHA_Xt5B = tr("Received a device query from %s.")), message.sender);
                    this.send_message("process-query-response", {
                        request_query_id: message.data.query_id,
                        request_timestamp: message.data.timestamp,
                        device_id: this.unique_id,
                        protocol: BasicIPCHandler.PROTOCOL_VERSION
                    }, message.sender);
                    return;
                }
            }
            else if (message.receiver === this.unique_id) {
                if (message.type == "process-query-response") {
                    const response = message.data;
                    if (this._query_results[response.request_query_id])
                        this._query_results[response.request_query_id].push(response);
                    else {
                        log.warn(LogCategory.IPC, _translations.A4CUBvq1 || (_translations.A4CUBvq1 = tr("Received a query response for an unknown request.")));
                    }
                    return;
                }
                else if (message.type == "certificate-accept-callback") {
                    const data = message.data;
                    if (!this._cert_accept_callbacks[data.request_id]) {
                        log.warn(LogCategory.IPC, _translations.gbh0OPNj || (_translations.gbh0OPNj = tr("Received certificate accept callback for an unknown request ID.")));
                        return;
                    }
                    this._cert_accept_callbacks[data.request_id]();
                    delete this._cert_accept_callbacks[data.request_id];
                    this.send_message("certificate-accept-succeeded", {}, message.sender);
                    return;
                }
                else if (message.type == "certificate-accept-succeeded") {
                    if (!this._cert_accept_succeeded[message.sender]) {
                        log.warn(LogCategory.IPC, _translations.eGlj0HhJ || (_translations.eGlj0HhJ = tr("Received certificate accept succeeded, but haven't a callback.")));
                        return;
                    }
                    this._cert_accept_succeeded[message.sender]();
                    return;
                }
                else if (message.type === "channel") {
                    const data = message.data;
                    let channel_invoked = false;
                    for (const channel of this._channels)
                        if (channel.channel_id === data.channel_id && (typeof (channel.target_id) === "undefined" || channel.target_id === message.sender)) {
                            if (channel.message_handler)
                                channel.message_handler(message.sender, data);
                            channel_invoked = true;
                        }
                    if (!channel_invoked) {
                        console.warn(_translations.QNgVL12c || (_translations.QNgVL12c = tr("Received channel message for unknown channel (%s)")), data.channel_id);
                    }
                }
            }
        }
        create_channel(target_id, channel_id) {
            let channel = {
                target_id: target_id,
                channel_id: channel_id || uuidv4(),
                message_handler: undefined,
                send_message: (key, message) => {
                    if (!channel.target_id)
                        throw "channel has no target!";
                    this.send_message("channel", {
                        key: key,
                        message: message,
                        channel_id: channel.channel_id
                    }, channel.target_id);
                }
            };
            this._channels.push(channel);
            return channel;
        }
        channels() { return this._channels; }
        delete_channel(channel) {
            this._channels = this._channels.filter(e => e !== channel);
        }
        query_processes(timeout) {
            return __awaiter(this, void 0, void 0, function* () {
                const query_id = uuidv4();
                this._query_results[query_id] = [];
                this.send_message("process-query", {
                    query_id: query_id,
                    timestamp: Date.now()
                });
                yield new Promise(resolve => setTimeout(resolve, timeout || 250));
                const result = this._query_results[query_id];
                delete this._query_results[query_id];
                return result;
            });
        }
        register_certificate_accept_callback(callback) {
            const id = uuidv4();
            this._cert_accept_callbacks[id] = callback;
            return this.unique_id + ":" + id;
        }
        post_certificate_accpected(id, timeout) {
            return new Promise((resolve, reject) => {
                const data = id.split(":");
                const timeout_id = setTimeout(() => {
                    delete this._cert_accept_succeeded[data[0]];
                    clearTimeout(timeout_id);
                    reject("timeout");
                }, timeout || 250);
                this._cert_accept_succeeded[data[0]] = () => {
                    delete this._cert_accept_succeeded[data[0]];
                    clearTimeout(timeout_id);
                    resolve();
                };
                this.send_message("certificate-accept-callback", {
                    request_id: data[1]
                }, data[0]);
            });
        }
    }
    BasicIPCHandler.BROADCAST_UNIQUE_ID = "00000000-0000-4000-0000-000000000000";
    BasicIPCHandler.PROTOCOL_VERSION = 1;
    bipc.BasicIPCHandler = BasicIPCHandler;
    class BroadcastChannelIPC extends BasicIPCHandler {
        constructor() {
            super();
        }
        setup() {
            super.setup();
            this.channel = new BroadcastChannel(BroadcastChannelIPC.CHANNEL_NAME);
            this.channel.onmessage = this.on_message.bind(this);
            this.channel.onmessageerror = this.on_error.bind(this);
        }
        on_message(event) {
            if (typeof (event.data) !== "string") {
                log.warn(LogCategory.IPC, _translations.Gm4JEiK5 || (_translations.Gm4JEiK5 = tr("Received message with an invalid type (%s): %o")), typeof (event.data), event.data);
                return;
            }
            let message;
            try {
                message = JSON.parse(event.data);
            }
            catch (error) {
                log.error(LogCategory.IPC, _translations.DNCmlQOd || (_translations.DNCmlQOd = tr("Received an invalid encoded message: %o")), event.data);
                return;
            }
            super.handle_message(message);
        }
        on_error(event) {
            log.warn(LogCategory.IPC, _translations.QqrchW_d || (_translations.QqrchW_d = tr("Received error: %o")), event);
        }
        send_message(type, data, target) {
            const message = {};
            message.sender = this.unique_id;
            message.receiver = target ? target : BasicIPCHandler.BROADCAST_UNIQUE_ID;
            message.timestamp = Date.now();
            message.type = type;
            message.data = data;
            this.channel.postMessage(JSON.stringify(message));
        }
    }
    BroadcastChannelIPC.CHANNEL_NAME = "TeaSpeak-Web";
    class MethodProxy {
        constructor(ipc_handler, connect_params) {
            this._proxied_methods = {};
            this._proxied_callbacks = {};
            this.ipc_handler = ipc_handler;
            this._ipc_parameters = connect_params;
            this._connected = false;
            this._slave = typeof (connect_params) !== "undefined";
            this._local = typeof (connect_params) !== "undefined" && connect_params.channel_id === "local" && connect_params.client_id === "local";
        }
        setup() {
            if (this._local) {
                this._connected = true;
                this.on_connected();
            }
            else {
                if (this._slave)
                    this._ipc_channel = this.ipc_handler.create_channel(this._ipc_parameters.client_id, this._ipc_parameters.channel_id);
                else
                    this._ipc_channel = this.ipc_handler.create_channel();
                this._ipc_channel.message_handler = this._handle_message.bind(this);
                if (this._slave)
                    this._ipc_channel.send_message("initialize", {});
            }
        }
        finalize() {
            if (!this._local) {
                if (this._connected)
                    this._ipc_channel.send_message("finalize", {});
                this.ipc_handler.delete_channel(this._ipc_channel);
                this._ipc_channel = undefined;
            }
            for (const promise of Object.values(this._proxied_callbacks))
                promise.reject("disconnected");
            this._proxied_callbacks = {};
            this._connected = false;
            this.on_disconnected();
        }
        register_method(method) {
            let method_name;
            if (typeof method === "function") {
                console.log("Proxy method: %o", method.name);
                method_name = method.name;
            }
            else {
                console.log("Proxy method: %o", method);
                method_name = method;
            }
            if (!this[method_name])
                throw "method is missing in current object";
            this._proxied_methods[method_name] = this[method_name];
            if (!this._local) {
                this[method_name] = (...args) => {
                    if (!this._connected)
                        return Promise.reject("not connected");
                    const proxy_callback = {
                        promise_id: uuidv4()
                    };
                    this._proxied_callbacks[proxy_callback.promise_id] = proxy_callback;
                    proxy_callback.promise = new Promise((resolve, reject) => {
                        proxy_callback.resolve = resolve;
                        proxy_callback.reject = reject;
                    });
                    this._ipc_channel.send_message("invoke", {
                        promise_id: proxy_callback.promise_id,
                        arguments: [...args],
                        method_name: method_name
                    });
                    return proxy_callback.promise;
                };
            }
        }
        _handle_message(remote_id, message) {
            if (message.key === "finalize") {
                this._handle_finalize();
            }
            else if (message.key === "initialize") {
                this._handle_remote_callback(remote_id);
            }
            else if (message.key === "invoke") {
                this._handle_invoke(message.message);
            }
            else if (message.key === "result") {
                this._handle_result(message.message);
            }
        }
        _handle_finalize() {
            this.on_disconnected();
            this.finalize();
            this._connected = false;
        }
        _handle_remote_callback(remote_id) {
            if (!this._ipc_channel.target_id) {
                if (this._slave)
                    throw "initialize wrong state!";
                this._ipc_channel.target_id = remote_id; /* now we're able to send messages */
                this.on_connected();
                this._ipc_channel.send_message("initialize", true);
            }
            else {
                if (!this._slave)
                    throw "initialize wrong state!";
                this.on_connected();
            }
            this._connected = true;
        }
        _send_result(promise_id, success, message) {
            this._ipc_channel.send_message("result", {
                promise_id: promise_id,
                result: message,
                success: success
            });
        }
        _handle_invoke(data) {
            if (this._proxied_methods[data.method_name])
                throw "we could not invoke a local proxied method!";
            if (!this[data.method_name]) {
                this._send_result(data.promise_id, false, "missing method");
                return;
            }
            try {
                console.log(_translations.N5drRic1 || (_translations.N5drRic1 = tr("Invoking method %s with arguments: %o")), data.method_name, data.arguments);
                const promise = this[data.method_name](...data.arguments);
                promise.then(result => {
                    console.log(_translations.SQ5EGQgG || (_translations.SQ5EGQgG = tr("Result: %o")), result);
                    this._send_result(data.promise_id, true, result);
                }).catch(error => {
                    this._send_result(data.promise_id, false, error);
                });
            }
            catch (error) {
                this._send_result(data.promise_id, false, error);
                return;
            }
        }
        _handle_result(data) {
            if (!this._proxied_callbacks[data.promise_id]) {
                console.warn(_translations.vh9_WbXO || (_translations.vh9_WbXO = tr("Received proxy method result for unknown promise")));
                return;
            }
            const callback = this._proxied_callbacks[data.promise_id];
            delete this._proxied_callbacks[data.promise_id];
            if (data.success)
                callback.resolve(data.result);
            else
                callback.reject(data.result);
        }
        generate_connect_parameters() {
            if (this._slave)
                throw "only masters can generate connect parameters!";
            if (!this._ipc_channel)
                throw "please call setup() before";
            return {
                channel_id: this._ipc_channel.channel_id,
                client_id: this.ipc_handler.get_local_address()
            };
        }
        is_slave() { return this._local || this._slave; } /* the popout modal */
        is_master() { return this._local || !this._slave; } /* the host (teaweb application) */
    }
    bipc.MethodProxy = MethodProxy;
    let handler;
    function setup() {
        if (!supported())
            return;
        /* TODO: test for support */
        handler = new BroadcastChannelIPC();
        handler.setup();
    }
    bipc.setup = setup;
    function get_handler() {
        return handler;
    }
    bipc.get_handler = get_handler;
    function supported() {
        /* ios does not support this */
        return typeof (window.BroadcastChannel) !== "undefined";
    }
    bipc.supported = supported;
})(bipc || (bipc = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["cac3c551a74ae6599511cc3f6e28e4c8495a8f0d0ae445f0a99c22d83c81067d"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["cac3c551a74ae6599511cc3f6e28e4c8495a8f0d0ae445f0a99c22d83c81067d"] = "cac3c551a74ae6599511cc3f6e28e4c8495a8f0d0ae445f0a99c22d83c81067d";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var LogCategory;
(function (LogCategory) {
    LogCategory[LogCategory["CHANNEL"] = 0] = "CHANNEL";
    LogCategory[LogCategory["CHANNEL_PROPERTIES"] = 1] = "CHANNEL_PROPERTIES";
    LogCategory[LogCategory["CLIENT"] = 2] = "CLIENT";
    LogCategory[LogCategory["SERVER"] = 3] = "SERVER";
    LogCategory[LogCategory["PERMISSIONS"] = 4] = "PERMISSIONS";
    LogCategory[LogCategory["GENERAL"] = 5] = "GENERAL";
    LogCategory[LogCategory["NETWORKING"] = 6] = "NETWORKING";
    LogCategory[LogCategory["VOICE"] = 7] = "VOICE";
    LogCategory[LogCategory["I18N"] = 8] = "I18N";
    LogCategory[LogCategory["IPC"] = 9] = "IPC";
    LogCategory[LogCategory["IDENTITIES"] = 10] = "IDENTITIES";
})(LogCategory || (LogCategory = {}));
var log;
(function (log_1) {
    let LogType;
    (function (LogType) {
        LogType[LogType["TRACE"] = 0] = "TRACE";
        LogType[LogType["DEBUG"] = 1] = "DEBUG";
        LogType[LogType["INFO"] = 2] = "INFO";
        LogType[LogType["WARNING"] = 3] = "WARNING";
        LogType[LogType["ERROR"] = 4] = "ERROR";
    })(LogType = log_1.LogType || (log_1.LogType = {}));
    let category_mapping = new Map([
        [LogCategory.CHANNEL, "Channel    "],
        [LogCategory.CHANNEL_PROPERTIES, "Channel    "],
        [LogCategory.CLIENT, "Client     "],
        [LogCategory.SERVER, "Server     "],
        [LogCategory.PERMISSIONS, "Permission "],
        [LogCategory.GENERAL, "General    "],
        [LogCategory.NETWORKING, "Network    "],
        [LogCategory.VOICE, "Voice      "],
        [LogCategory.I18N, "I18N       "],
        [LogCategory.IDENTITIES, "IDENTITIES "],
        [LogCategory.IPC, "IPC        "]
    ]);
    log_1.enabled_mapping = new Map([
        [LogCategory.CHANNEL, true],
        [LogCategory.CHANNEL_PROPERTIES, false],
        [LogCategory.CLIENT, true],
        [LogCategory.SERVER, true],
        [LogCategory.PERMISSIONS, true],
        [LogCategory.GENERAL, true],
        [LogCategory.NETWORKING, true],
        [LogCategory.VOICE, true],
        [LogCategory.I18N, false],
        [LogCategory.IDENTITIES, true],
        [LogCategory.IPC, true]
    ]);
    let GroupMode;
    (function (GroupMode) {
        GroupMode[GroupMode["NATIVE"] = 0] = "NATIVE";
        GroupMode[GroupMode["PREFIX"] = 1] = "PREFIX";
    })(GroupMode || (GroupMode = {}));
    const group_mode = GroupMode.PREFIX;
    loader.register_task(loader.Stage.LOADED, {
        name: "log enabled initialisation",
        function: () => __awaiter(this, void 0, void 0, function* () { return initialize(); }),
        priority: 10
    });
    //Example: <url>?log.i18n.enabled=0
    function initialize() {
        for (const category of Object.keys(LogCategory).map(e => parseInt(e))) {
            if (isNaN(category))
                continue;
            const category_name = LogCategory[category];
            log_1.enabled_mapping[category] = settings.static_global("log." + category_name.toLowerCase() + ".enabled", log_1.enabled_mapping.get(category));
        }
    }
    log_1.initialize = initialize;
    function logDirect(type, message, ...optionalParams) {
        switch (type) {
            case LogType.TRACE:
            case LogType.DEBUG:
                console.debug(message, ...optionalParams);
                break;
            case LogType.INFO:
                console.log(message, ...optionalParams);
                break;
            case LogType.WARNING:
                console.warn(message, ...optionalParams);
                break;
            case LogType.ERROR:
                console.error(message, ...optionalParams);
                break;
        }
        //console.log("This is %cMy stylish message", "color: yellow; font-style: italic; background-color: blue;padding: 2px");
    }
    function log(type, category, message, ...optionalParams) {
        if (!log_1.enabled_mapping[category])
            return;
        optionalParams.unshift(category_mapping.get(category));
        message = "[%s] " + message;
        logDirect(type, message, ...optionalParams);
    }
    log_1.log = log;
    function trace(category, message, ...optionalParams) {
        log(LogType.TRACE, category, message, ...optionalParams);
    }
    log_1.trace = trace;
    function debug(category, message, ...optionalParams) {
        log(LogType.DEBUG, category, message, ...optionalParams);
    }
    log_1.debug = debug;
    function info(category, message, ...optionalParams) {
        log(LogType.INFO, category, message, ...optionalParams);
    }
    log_1.info = info;
    function warn(category, message, ...optionalParams) {
        log(LogType.WARNING, category, message, ...optionalParams);
    }
    log_1.warn = warn;
    function error(category, message, ...optionalParams) {
        log(LogType.ERROR, category, message, ...optionalParams);
    }
    log_1.error = error;
    function group(level, category, name, ...optionalParams) {
        name = "[%s] " + name;
        optionalParams.unshift(category_mapping.get(category));
        return new Group(group_mode, level, category, name, optionalParams);
    }
    log_1.group = group;
    function table(title, arguments) {
        if (group_mode == GroupMode.NATIVE) {
            console.groupCollapsed(title);
            console.table(arguments);
            console.groupEnd();
        }
        else {
            console.log("Snipped table %s", title);
        }
    }
    log_1.table = table;
    class Group {
        constructor(mode, level, category, name, optionalParams, owner = undefined) {
            this.owner = undefined;
            this._collapsed = false;
            this.initialized = false;
            this.level = level;
            this.mode = mode;
            this.category = category;
            this.name = name;
            this.optionalParams = optionalParams;
            this.enabled = log_1.enabled_mapping[category];
        }
        group(level, name, ...optionalParams) {
            return new Group(this.mode, level, this.category, name, optionalParams, this);
        }
        collapsed(flag = true) {
            this._collapsed = flag;
            return this;
        }
        log(message, ...optionalParams) {
            if (!this.enabled)
                return this;
            if (!this.initialized) {
                if (this.mode == GroupMode.NATIVE) {
                    if (this._collapsed && console.groupCollapsed)
                        console.groupCollapsed(this.name, ...this.optionalParams);
                    else
                        console.group(this.name, ...this.optionalParams);
                }
                else {
                    this._log_prefix = "  ";
                    let parent = this.owner;
                    while (parent) {
                        if (parent.mode == GroupMode.PREFIX)
                            this._log_prefix = this._log_prefix + parent._log_prefix;
                        else
                            break;
                    }
                }
                this.initialized = true;
            }
            if (this.mode == GroupMode.NATIVE)
                logDirect(this.level, message, ...optionalParams);
            else
                logDirect(this.level, this._log_prefix + message, ...optionalParams);
            return this;
        }
        end() {
            if (this.initialized) {
                if (this.mode == GroupMode.NATIVE)
                    console.groupEnd();
            }
        }
        get prefix() {
            return this._log_prefix;
        }
        set prefix(prefix) {
            this._log_prefix = prefix;
        }
    }
    log_1.Group = Group;
})(log || (log = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["809edca220e9c076f8467b526e500f0865c383696db64491c7174b404b492532"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["809edca220e9c076f8467b526e500f0865c383696db64491c7174b404b492532"] = "809edca220e9c076f8467b526e500f0865c383696db64491c7174b404b492532";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "aiv7EvHX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (59,31)" }, { name: "TfTGyqTO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (63,31)" }, { name: "goK5MBcL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (82,27)" }, { name: "AHr7XFaU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (224,33)" }, { name: "frQChjfo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (226,32)" }, { name: "yzkELT53", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (228,33)" }, { name: "w0PKe6fj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (230,35)" }, { name: "ZQ9WbaJ_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (232,35)" }, { name: "cV0NZFIM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/proto.ts (234,18)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
if (!JSON.map_to) {
    JSON.map_to = function (object, json, variables, validator, variable_direction) {
        if (!validator)
            validator = (a, b) => true;
        if (!variables) {
            variables = [];
            if (!variable_direction || variable_direction == 0) {
                for (let field in json)
                    variables.push(field);
            }
            else if (variable_direction == 1) {
                for (let field in object)
                    variables.push(field);
            }
        }
        else if (!Array.isArray(variables)) {
            variables = [variables];
        }
        for (let field of variables) {
            if (!json[field]) {
                console.trace(_translations.aiv7EvHX || (_translations.aiv7EvHX = tr("Json does not contains %s")), field);
                continue;
            }
            if (!validator(field, json[field])) {
                console.trace(_translations.TfTGyqTO || (_translations.TfTGyqTO = tr("Validator results in false for %s")), field);
                continue;
            }
            JSON.map_field_to(object, json[field], field);
        }
        return object;
    };
}
if (!JSON.map_field_to) {
    JSON.map_field_to = function (object, value, field) {
        let field_type = typeof (object[field]);
        if (field_type == "string" || field_type == "object" || field_type == "undefined")
            object[field] = value;
        else if (field_type == "number")
            object[field] = parseFloat(value);
        else if (field_type == "boolean")
            object[field] = value == "1" || value == "true";
        else
            console.warn(_translations.goK5MBcL || (_translations.goK5MBcL = tr("Invalid object type %s for entry %s")), field_type, field);
        return object;
    };
}
if (!Array.prototype.remove) {
    Array.prototype.remove = function (elem) {
        const index = this.indexOf(elem, 0);
        if (index > -1) {
            this.splice(index, 1);
            return true;
        }
        return false;
    };
}
if (!Array.prototype.pop_front) {
    Array.prototype.pop_front = function () {
        if (this.length == 0)
            return undefined;
        return this.splice(0, 1)[0];
    };
}
if (!Array.prototype.last) {
    Array.prototype.last = function () {
        if (this.length == 0)
            return undefined;
        return this[this.length - 1];
    };
}
if (typeof ($) !== "undefined") {
    if (!$.spawn) {
        $.spawn = function (tagName) {
            return $(document.createElement(tagName));
        };
    }
    if (!$.fn.renderTag) {
        $.fn.renderTag = function (values) {
            let result;
            if (this.render) {
                result = $(this.render(values));
            }
            else {
                const template = window.jsrender.render[this.attr("id")];
                if (!template) {
                    console.error("Tried to render template %o, but template is not available!", this.attr("id"));
                    throw "missing template " + this.attr("id");
                }
                /*
                result = window.jsrender.templates("tmpl_permission_entry", $("#tmpl_permission_entry").html());
                result = window.jsrender.templates("xxx", this.html());
                */
                result = template(values);
                result = $(result);
            }
            result.find("node").each((index, element) => {
                $(element).replaceWith(values[$(element).attr("key")] || (values[0] || [])[$(element).attr("key")]);
            });
            return result;
        };
    }
    if (!$.fn.hasScrollBar)
        $.fn.hasScrollBar = function (direction) {
            if (this.length <= 0)
                return false;
            const scroll_height = this.get(0).scrollHeight > this.height();
            const scroll_width = this.get(0).scrollWidth > this.width();
            if (typeof (direction) === "string") {
                if (direction === "height")
                    return scroll_height;
                if (direction === "width")
                    return scroll_width;
            }
            return scroll_width || scroll_height;
        };
    if (!$.fn.visible_height)
        $.fn.visible_height = function () {
            const original_style = this.attr("style");
            this.css({
                position: 'absolute!important',
                visibility: 'hidden!important',
                display: 'block!important'
            });
            const result = this.height();
            this.attr("style", original_style || "");
            return result;
        };
    if (!$.fn.visible_width)
        $.fn.visible_width = function () {
            const original_style = this.attr("style");
            this.css({
                position: 'absolute!important',
                visibility: 'hidden!important',
                display: 'block!important'
            });
            const result = this.width();
            this.attr("style", original_style || "");
            return result;
        };
}
if (!String.prototype.format) {
    String.prototype.format = function () {
        const args = arguments;
        let array = args.length == 1 && $.isArray(args[0]);
        return this.replace(/\{\{|\}\}|\{(\d+)\}/g, function (m, n) {
            if (m == "{{") {
                return "{";
            }
            if (m == "}}") {
                return "}";
            }
            return array ? args[0][n] : args[n];
        });
    };
}
function concatenate(resultConstructor, ...arrays) {
    let totalLength = 0;
    for (const arr of arrays) {
        totalLength += arr.length;
    }
    const result = new resultConstructor(totalLength);
    let offset = 0;
    for (const arr of arrays) {
        result.set(arr, offset);
        offset += arr.length;
    }
    return result;
}
function formatDate(secs) {
    let years = Math.floor(secs / (60 * 60 * 24 * 365));
    let days = Math.floor(secs / (60 * 60 * 24)) % 365;
    let hours = Math.floor(secs / (60 * 60)) % 24;
    let minutes = Math.floor(secs / 60) % 60;
    let seconds = Math.floor(secs % 60);
    let result = "";
    if (years > 0)
        result += years + " " + (_translations.AHr7XFaU || (_translations.AHr7XFaU = tr("years"))) + " ";
    if (years > 0 || days > 0)
        result += days + " " + (_translations.frQChjfo || (_translations.frQChjfo = tr("days"))) + " ";
    if (years > 0 || days > 0 || hours > 0)
        result += hours + " " + (_translations.yzkELT53 || (_translations.yzkELT53 = tr("hours"))) + " ";
    if (years > 0 || days > 0 || hours > 0 || minutes > 0)
        result += minutes + " " + (_translations.w0PKe6fj || (_translations.w0PKe6fj = tr("minutes"))) + " ";
    if (years > 0 || days > 0 || hours > 0 || minutes > 0 || seconds > 0)
        result += seconds + " " + (_translations.ZQ9WbaJ_ || (_translations.ZQ9WbaJ_ = tr("seconds"))) + " ";
    else
        result = (_translations.cV0NZFIM || (_translations.cV0NZFIM = tr("now"))) + " ";
    return result.substr(0, result.length - 1);
}
function calculate_width(text) {
    let element = $.spawn("div");
    element.text(text)
        .css("display", "none")
        .css("margin", 0);
    $("body").append(element);
    let size = element.width();
    element.detach();
    return size;
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["5df1ee3b7482468479921c16a3cef9e0e4bf148cbfeb23dc991370bb1b697f77"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["5df1ee3b7482468479921c16a3cef9e0e4bf148cbfeb23dc991370bb1b697f77"] = "5df1ee3b7482468479921c16a3cef9e0e4bf148cbfeb23dc991370bb1b697f77";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var sha;
(function (sha) {
    /*
     * [js-sha1]{@link https://github.com/emn178/js-sha1}
     *
     * @version 0.6.0
     * @author Chen, Yi-Cyuan [emn178@gmail.com]
     * @copyright Chen, Yi-Cyuan 2014-2017
     * @license MIT
     */
    /*jslint bitwise: true */
    (function () {
        'use strict';
        let root = typeof window === 'object' ? window : {};
        let NODE_JS = !root.JS_SHA1_NO_NODE_JS && typeof process === 'object' && process.versions && process.versions.node;
        if (NODE_JS) {
            root = global;
        }
        let COMMON_JS = !root.JS_SHA1_NO_COMMON_JS && typeof module === 'object' && module.exports;
        let AMD = typeof define === 'function' && define.amd;
        let HEX_CHARS = '0123456789abcdef'.split('');
        let EXTRA = [-2147483648, 8388608, 32768, 128];
        let SHIFT = [24, 16, 8, 0];
        let OUTPUT_TYPES = ['hex', 'array', 'digest', 'arrayBuffer'];
        let blocks = [];
        let createOutputMethod = function (outputType) {
            return function (message) {
                return new Sha1(true).update(message)[outputType]();
            };
        };
        let createMethod = function () {
            let method = createOutputMethod('hex');
            if (NODE_JS) {
                method = nodeWrap(method);
            }
            method.create = function () {
                return new Sha1();
            };
            method.update = function (message) {
                return method.create().update(message);
            };
            for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
                var type = OUTPUT_TYPES[i];
                method[type] = createOutputMethod(type);
            }
            return method;
        };
        var nodeWrap = function (method) {
            var crypto = eval("require('crypto')");
            var Buffer = eval("require('buffer').Buffer");
            var nodeMethod = function (message) {
                if (typeof message === 'string') {
                    return crypto.createHash('sha1').update(message, 'utf8').digest('hex');
                }
                else if (message.constructor === ArrayBuffer) {
                    message = new Uint8Array(message);
                }
                else if (message.length === undefined) {
                    return method(message);
                }
                return crypto.createHash('sha1').update(new Buffer(message)).digest('hex');
            };
            return nodeMethod;
        };
        function Sha1(sharedMemory) {
            if (sharedMemory) {
                blocks[0] = blocks[16] = blocks[1] = blocks[2] = blocks[3] =
                    blocks[4] = blocks[5] = blocks[6] = blocks[7] =
                        blocks[8] = blocks[9] = blocks[10] = blocks[11] =
                            blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
                this.blocks = blocks;
            }
            else {
                this.blocks = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
            }
            this.h0 = 0x67452301;
            this.h1 = 0xEFCDAB89;
            this.h2 = 0x98BADCFE;
            this.h3 = 0x10325476;
            this.h4 = 0xC3D2E1F0;
            this.block = this.start = this.bytes = this.hBytes = 0;
            this.finalized = this.hashed = false;
            this.first = true;
        }
        Sha1.prototype.update = function (message) {
            if (this.finalized) {
                return;
            }
            var notString = typeof (message) !== 'string';
            if (notString && message.constructor === root.ArrayBuffer) {
                message = new Uint8Array(message);
            }
            var code, index = 0, i, length = message.length || 0, blocks = this.blocks;
            while (index < length) {
                if (this.hashed) {
                    this.hashed = false;
                    blocks[0] = this.block;
                    blocks[16] = blocks[1] = blocks[2] = blocks[3] =
                        blocks[4] = blocks[5] = blocks[6] = blocks[7] =
                            blocks[8] = blocks[9] = blocks[10] = blocks[11] =
                                blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
                }
                if (notString) {
                    for (i = this.start; index < length && i < 64; ++index) {
                        blocks[i >> 2] |= message[index] << SHIFT[i++ & 3];
                    }
                }
                else {
                    for (i = this.start; index < length && i < 64; ++index) {
                        code = message.charCodeAt(index);
                        if (code < 0x80) {
                            blocks[i >> 2] |= code << SHIFT[i++ & 3];
                        }
                        else if (code < 0x800) {
                            blocks[i >> 2] |= (0xc0 | (code >> 6)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                        }
                        else if (code < 0xd800 || code >= 0xe000) {
                            blocks[i >> 2] |= (0xe0 | (code >> 12)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                        }
                        else {
                            code = 0x10000 + (((code & 0x3ff) << 10) | (message.charCodeAt(++index) & 0x3ff));
                            blocks[i >> 2] |= (0xf0 | (code >> 18)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | ((code >> 12) & 0x3f)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
                            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
                        }
                    }
                }
                this.lastByteIndex = i;
                this.bytes += i - this.start;
                if (i >= 64) {
                    this.block = blocks[16];
                    this.start = i - 64;
                    this.hash();
                    this.hashed = true;
                }
                else {
                    this.start = i;
                }
            }
            if (this.bytes > 4294967295) {
                this.hBytes += this.bytes / 4294967296 << 0;
                this.bytes = this.bytes % 4294967296;
            }
            return this;
        };
        Sha1.prototype.finalize = function () {
            if (this.finalized) {
                return;
            }
            this.finalized = true;
            var blocks = this.blocks, i = this.lastByteIndex;
            blocks[16] = this.block;
            blocks[i >> 2] |= EXTRA[i & 3];
            this.block = blocks[16];
            if (i >= 56) {
                if (!this.hashed) {
                    this.hash();
                }
                blocks[0] = this.block;
                blocks[16] = blocks[1] = blocks[2] = blocks[3] =
                    blocks[4] = blocks[5] = blocks[6] = blocks[7] =
                        blocks[8] = blocks[9] = blocks[10] = blocks[11] =
                            blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
            }
            blocks[14] = this.hBytes << 3 | this.bytes >>> 29;
            blocks[15] = this.bytes << 3;
            this.hash();
        };
        Sha1.prototype.hash = function () {
            var a = this.h0, b = this.h1, c = this.h2, d = this.h3, e = this.h4;
            var f, j, t, blocks = this.blocks;
            for (j = 16; j < 80; ++j) {
                t = blocks[j - 3] ^ blocks[j - 8] ^ blocks[j - 14] ^ blocks[j - 16];
                blocks[j] = (t << 1) | (t >>> 31);
            }
            for (j = 0; j < 20; j += 5) {
                f = (b & c) | ((~b) & d);
                t = (a << 5) | (a >>> 27);
                e = t + f + e + 1518500249 + blocks[j] << 0;
                b = (b << 30) | (b >>> 2);
                f = (a & b) | ((~a) & c);
                t = (e << 5) | (e >>> 27);
                d = t + f + d + 1518500249 + blocks[j + 1] << 0;
                a = (a << 30) | (a >>> 2);
                f = (e & a) | ((~e) & b);
                t = (d << 5) | (d >>> 27);
                c = t + f + c + 1518500249 + blocks[j + 2] << 0;
                e = (e << 30) | (e >>> 2);
                f = (d & e) | ((~d) & a);
                t = (c << 5) | (c >>> 27);
                b = t + f + b + 1518500249 + blocks[j + 3] << 0;
                d = (d << 30) | (d >>> 2);
                f = (c & d) | ((~c) & e);
                t = (b << 5) | (b >>> 27);
                a = t + f + a + 1518500249 + blocks[j + 4] << 0;
                c = (c << 30) | (c >>> 2);
            }
            for (; j < 40; j += 5) {
                f = b ^ c ^ d;
                t = (a << 5) | (a >>> 27);
                e = t + f + e + 1859775393 + blocks[j] << 0;
                b = (b << 30) | (b >>> 2);
                f = a ^ b ^ c;
                t = (e << 5) | (e >>> 27);
                d = t + f + d + 1859775393 + blocks[j + 1] << 0;
                a = (a << 30) | (a >>> 2);
                f = e ^ a ^ b;
                t = (d << 5) | (d >>> 27);
                c = t + f + c + 1859775393 + blocks[j + 2] << 0;
                e = (e << 30) | (e >>> 2);
                f = d ^ e ^ a;
                t = (c << 5) | (c >>> 27);
                b = t + f + b + 1859775393 + blocks[j + 3] << 0;
                d = (d << 30) | (d >>> 2);
                f = c ^ d ^ e;
                t = (b << 5) | (b >>> 27);
                a = t + f + a + 1859775393 + blocks[j + 4] << 0;
                c = (c << 30) | (c >>> 2);
            }
            for (; j < 60; j += 5) {
                f = (b & c) | (b & d) | (c & d);
                t = (a << 5) | (a >>> 27);
                e = t + f + e - 1894007588 + blocks[j] << 0;
                b = (b << 30) | (b >>> 2);
                f = (a & b) | (a & c) | (b & c);
                t = (e << 5) | (e >>> 27);
                d = t + f + d - 1894007588 + blocks[j + 1] << 0;
                a = (a << 30) | (a >>> 2);
                f = (e & a) | (e & b) | (a & b);
                t = (d << 5) | (d >>> 27);
                c = t + f + c - 1894007588 + blocks[j + 2] << 0;
                e = (e << 30) | (e >>> 2);
                f = (d & e) | (d & a) | (e & a);
                t = (c << 5) | (c >>> 27);
                b = t + f + b - 1894007588 + blocks[j + 3] << 0;
                d = (d << 30) | (d >>> 2);
                f = (c & d) | (c & e) | (d & e);
                t = (b << 5) | (b >>> 27);
                a = t + f + a - 1894007588 + blocks[j + 4] << 0;
                c = (c << 30) | (c >>> 2);
            }
            for (; j < 80; j += 5) {
                f = b ^ c ^ d;
                t = (a << 5) | (a >>> 27);
                e = t + f + e - 899497514 + blocks[j] << 0;
                b = (b << 30) | (b >>> 2);
                f = a ^ b ^ c;
                t = (e << 5) | (e >>> 27);
                d = t + f + d - 899497514 + blocks[j + 1] << 0;
                a = (a << 30) | (a >>> 2);
                f = e ^ a ^ b;
                t = (d << 5) | (d >>> 27);
                c = t + f + c - 899497514 + blocks[j + 2] << 0;
                e = (e << 30) | (e >>> 2);
                f = d ^ e ^ a;
                t = (c << 5) | (c >>> 27);
                b = t + f + b - 899497514 + blocks[j + 3] << 0;
                d = (d << 30) | (d >>> 2);
                f = c ^ d ^ e;
                t = (b << 5) | (b >>> 27);
                a = t + f + a - 899497514 + blocks[j + 4] << 0;
                c = (c << 30) | (c >>> 2);
            }
            this.h0 = this.h0 + a << 0;
            this.h1 = this.h1 + b << 0;
            this.h2 = this.h2 + c << 0;
            this.h3 = this.h3 + d << 0;
            this.h4 = this.h4 + e << 0;
        };
        Sha1.prototype.hex = function () {
            this.finalize();
            var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3, h4 = this.h4;
            return HEX_CHARS[(h0 >> 28) & 0x0F] + HEX_CHARS[(h0 >> 24) & 0x0F] +
                HEX_CHARS[(h0 >> 20) & 0x0F] + HEX_CHARS[(h0 >> 16) & 0x0F] +
                HEX_CHARS[(h0 >> 12) & 0x0F] + HEX_CHARS[(h0 >> 8) & 0x0F] +
                HEX_CHARS[(h0 >> 4) & 0x0F] + HEX_CHARS[h0 & 0x0F] +
                HEX_CHARS[(h1 >> 28) & 0x0F] + HEX_CHARS[(h1 >> 24) & 0x0F] +
                HEX_CHARS[(h1 >> 20) & 0x0F] + HEX_CHARS[(h1 >> 16) & 0x0F] +
                HEX_CHARS[(h1 >> 12) & 0x0F] + HEX_CHARS[(h1 >> 8) & 0x0F] +
                HEX_CHARS[(h1 >> 4) & 0x0F] + HEX_CHARS[h1 & 0x0F] +
                HEX_CHARS[(h2 >> 28) & 0x0F] + HEX_CHARS[(h2 >> 24) & 0x0F] +
                HEX_CHARS[(h2 >> 20) & 0x0F] + HEX_CHARS[(h2 >> 16) & 0x0F] +
                HEX_CHARS[(h2 >> 12) & 0x0F] + HEX_CHARS[(h2 >> 8) & 0x0F] +
                HEX_CHARS[(h2 >> 4) & 0x0F] + HEX_CHARS[h2 & 0x0F] +
                HEX_CHARS[(h3 >> 28) & 0x0F] + HEX_CHARS[(h3 >> 24) & 0x0F] +
                HEX_CHARS[(h3 >> 20) & 0x0F] + HEX_CHARS[(h3 >> 16) & 0x0F] +
                HEX_CHARS[(h3 >> 12) & 0x0F] + HEX_CHARS[(h3 >> 8) & 0x0F] +
                HEX_CHARS[(h3 >> 4) & 0x0F] + HEX_CHARS[h3 & 0x0F] +
                HEX_CHARS[(h4 >> 28) & 0x0F] + HEX_CHARS[(h4 >> 24) & 0x0F] +
                HEX_CHARS[(h4 >> 20) & 0x0F] + HEX_CHARS[(h4 >> 16) & 0x0F] +
                HEX_CHARS[(h4 >> 12) & 0x0F] + HEX_CHARS[(h4 >> 8) & 0x0F] +
                HEX_CHARS[(h4 >> 4) & 0x0F] + HEX_CHARS[h4 & 0x0F];
        };
        Sha1.prototype.toString = Sha1.prototype.hex;
        Sha1.prototype.digest = function () {
            this.finalize();
            var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3, h4 = this.h4;
            return [
                (h0 >> 24) & 0xFF, (h0 >> 16) & 0xFF, (h0 >> 8) & 0xFF, h0 & 0xFF,
                (h1 >> 24) & 0xFF, (h1 >> 16) & 0xFF, (h1 >> 8) & 0xFF, h1 & 0xFF,
                (h2 >> 24) & 0xFF, (h2 >> 16) & 0xFF, (h2 >> 8) & 0xFF, h2 & 0xFF,
                (h3 >> 24) & 0xFF, (h3 >> 16) & 0xFF, (h3 >> 8) & 0xFF, h3 & 0xFF,
                (h4 >> 24) & 0xFF, (h4 >> 16) & 0xFF, (h4 >> 8) & 0xFF, h4 & 0xFF
            ];
        };
        Sha1.prototype.array = Sha1.prototype.digest;
        Sha1.prototype.arrayBuffer = function () {
            this.finalize();
            var buffer = new ArrayBuffer(20);
            var dataView = new DataView(buffer);
            dataView.setUint32(0, this.h0);
            dataView.setUint32(4, this.h1);
            dataView.setUint32(8, this.h2);
            dataView.setUint32(12, this.h3);
            dataView.setUint32(16, this.h4);
            return buffer;
        };
        var exports = createMethod();
        if (COMMON_JS) {
            module.exports = exports;
        }
        else {
            root._sha1 = exports;
            if (AMD) {
                define(function () {
                    return exports;
                });
            }
        }
    })();
    function encode_text(buffer) {
        if (window.TextEncoder) {
            return new TextEncoder().encode(buffer).buffer;
        }
        let utf8 = unescape(encodeURIComponent(buffer));
        let result = new Uint8Array(utf8.length);
        for (let i = 0; i < utf8.length; i++) {
            result[i] = utf8.charCodeAt(i);
        }
        return result.buffer;
    }
    sha.encode_text = encode_text;
    function sha1(message) {
        if (!(typeof (message) === "string" || message instanceof ArrayBuffer))
            throw "Invalid type!";
        let buffer = message instanceof ArrayBuffer ? message : encode_text(message);
        if (!crypto || !crypto.subtle || !crypto.subtle.digest || /Edge/.test(navigator.userAgent))
            return new Promise(resolve => {
                resolve(_sha1.arrayBuffer(buffer));
            });
        else
            return crypto.subtle.digest("SHA-1", buffer);
    }
    sha.sha1 = sha1;
})(sha || (sha = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["8a0d389c307fd59a55043539cb74ffa820fb2c68be5c1ffcacb2e6a8579db6d8"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["8a0d389c307fd59a55043539cb74ffa820fb2c68be5c1ffcacb2e6a8579db6d8"] = "8a0d389c307fd59a55043539cb74ffa820fb2c68be5c1ffcacb2e6a8579db6d8";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "DhdsWN3b", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/utils/helpers.ts (64,17)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../crypto/sha.ts" />
var helpers;
(function (helpers) {
    function hashPassword(password) {
        return new Promise((resolve, reject) => {
            sha.sha1(password).then(result => {
                resolve(btoa(String.fromCharCode.apply(null, new Uint8Array(result))));
            });
        });
    }
    helpers.hashPassword = hashPassword;
})(helpers || (helpers = {}));
class LaterPromise extends Promise {
    constructor() {
        super((resolve, reject) => { });
        this._handle = new Promise((resolve, reject) => {
            this._resolve = resolve;
            this._reject = reject;
        });
        this._time = Date.now();
    }
    resolved(object) {
        this._resolve(object);
    }
    rejected(reason) {
        this._reject(reason);
    }
    function_rejected() {
        return error => this.rejected(error);
    }
    time() { return this._time; }
    /**
     * Attaches callbacks for the resolution and/or rejection of the Promise.
     * @param onfulfilled The callback to execute when the Promise is resolved.
     * @param onrejected The callback to execute when the Promise is rejected.
     * @returns A Promise for the completion of which ever callback is executed.
     */
    then(onfulfilled, onrejected) {
        return this._handle.then(onfulfilled, onrejected);
    }
    /**
     * Attaches a callback for only the rejection of the Promise.
     * @param onrejected The callback to execute when the Promise is rejected.
     * @returns A Promise for the completion of the callback.
     */
    catch(onrejected) {
        return this._handle.then(onrejected);
    }
}
const copy_to_clipboard = str => {
    console.log(_translations.DhdsWN3b || (_translations.DhdsWN3b = tr("Copy text to clipboard: %s")), str);
    const el = document.createElement('textarea');
    el.value = str;
    el.setAttribute('readonly', '');
    el.style.position = 'absolute';
    el.style.left = '-9999px';
    document.body.appendChild(el);
    const selected = document.getSelection().rangeCount > 0
        ? document.getSelection().getRangeAt(0)
        : false;
    el.select();
    document.execCommand('copy');
    document.body.removeChild(el);
    if (selected) {
        document.getSelection().removeAllRanges();
        document.getSelection().addRange(selected);
    }
};
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e123c1798ff60a6f786c2e4800e0ae0e286488fcc5a168686b4d63c282907d83"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e123c1798ff60a6f786c2e4800e0ae0e286488fcc5a168686b4d63c282907d83"] = "e123c1798ff60a6f786c2e4800e0ae0e286488fcc5a168686b4d63c282907d83";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Ij28fXwP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (246,36)" }, { name: "_TVD0tbG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (253,36)" }, { name: "ZapXznZK", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (260,36)" }, { name: "uT3cHwv6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (267,36)" }, { name: "Fs50vlYp", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (274,36)" }, { name: "ktVc6xHo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (457,23)" }, { name: "aDLFGWs4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (471,23)" }, { name: "ubL7tTRj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (482,35)" }, { name: "VHJ9HmoE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (489,35)" }, { name: "mYSb7NC7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (496,35)" }, { name: "oC37kcG7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (507,23)" }, { name: "hAq3YEH3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (514,59)" }, { name: "TxVb7JNF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (541,23)" }, { name: "Q8x8wea4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (553,23)" }, { name: "bGgJOR0P", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (556,41)" }, { name: "Jn7H_QkP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (556,73)" }, { name: "qb3HB3VD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (562,42)" }, { name: "zgxESN34", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (562,98)" }, { name: "qSIiy4Q5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (570,23)" }, { name: "qK1pswRX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (576,23)" }, { name: "_wI84Npb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (601,25)" }, { name: "j8fkddoU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (626,25)" }, { name: "CafVtWjf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (657,59)" }, { name: "JcFXvV8h", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (664,21)" }, { name: "gh0r9yWV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (673,82)" }, { name: "RNP11uFE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (778,30)" }, { name: "g14bQ0Vc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/channel.ts (778,54)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="view.ts" />
/// <reference path="../utils/helpers.ts" />
var ChannelType;
(function (ChannelType) {
    ChannelType[ChannelType["PERMANENT"] = 0] = "PERMANENT";
    ChannelType[ChannelType["SEMI_PERMANENT"] = 1] = "SEMI_PERMANENT";
    ChannelType[ChannelType["TEMPORARY"] = 2] = "TEMPORARY";
})(ChannelType || (ChannelType = {}));
(function (ChannelType) {
    function normalize(mode) {
        let value = ChannelType[mode];
        value = value.toLowerCase();
        return value[0].toUpperCase() + value.substr(1);
    }
    ChannelType.normalize = normalize;
})(ChannelType || (ChannelType = {}));
var ChannelSubscribeMode;
(function (ChannelSubscribeMode) {
    ChannelSubscribeMode[ChannelSubscribeMode["SUBSCRIBED"] = 0] = "SUBSCRIBED";
    ChannelSubscribeMode[ChannelSubscribeMode["UNSUBSCRIBED"] = 1] = "UNSUBSCRIBED";
    ChannelSubscribeMode[ChannelSubscribeMode["INHERITED"] = 2] = "INHERITED";
})(ChannelSubscribeMode || (ChannelSubscribeMode = {}));
class ChannelProperties {
    constructor() {
        this.channel_order = 0;
        this.channel_name = "";
        this.channel_name_phonetic = "";
        this.channel_topic = "";
        this.channel_password = "";
        this.channel_codec = 4;
        this.channel_codec_quality = 0;
        this.channel_codec_is_unencrypted = false;
        this.channel_maxclients = -1;
        this.channel_maxfamilyclients = -1;
        this.channel_needed_talk_power = 1;
        this.channel_flag_permanent = false;
        this.channel_flag_semi_permanent = false;
        this.channel_flag_default = false;
        this.channel_flag_password = false;
        this.channel_flag_maxclients_unlimited = false;
        this.channel_flag_maxfamilyclients_inherited = false;
        this.channel_flag_maxfamilyclients_unlimited = false;
        this.channel_icon_id = 0;
        this.channel_delete_delay = 0;
        //Only after request
        this.channel_description = "";
    }
}
class ChannelEntry {
    constructor(channelId, channelName, parent = null) {
        this.properties = new ChannelProperties();
        this._channel_name_alignment = undefined;
        this._channel_name_formatted = undefined;
        this._family_index = 0;
        this._cached_channel_description = undefined;
        this._cached_channel_description_promise = undefined;
        this._cached_channel_description_promise_resolve = undefined;
        this._cached_channel_description_promise_reject = undefined;
        this.properties = new ChannelProperties();
        this.channelId = channelId;
        this.properties.channel_name = channelName;
        this.parent = parent;
        this.channelTree = null;
        this.initializeTag();
        this.__updateChannelName();
    }
    channelName() {
        return this.properties.channel_name;
    }
    formattedChannelName() {
        return this._channel_name_formatted || this.properties.channel_name;
    }
    getChannelDescription() {
        if (this._cached_channel_description)
            return new Promise(resolve => resolve(this._cached_channel_description));
        if (this._cached_channel_description_promise)
            return this._cached_channel_description_promise;
        this.channelTree.client.serverConnection.send_command("channelgetdescription", { cid: this.channelId }).catch(error => {
            this._cached_channel_description_promise_reject(error);
        });
        return this._cached_channel_description_promise = new Promise((resolve, reject) => {
            this._cached_channel_description_promise_resolve = resolve;
            this._cached_channel_description_promise_reject = reject;
        });
    }
    parent_channel() { return this.parent; }
    hasParent() { return this.parent != null; }
    getChannelId() { return this.channelId; }
    children(deep = false) {
        const result = [];
        if (this.channelTree == null)
            return [];
        const self = this;
        this.channelTree.channels.forEach(function (entry) {
            let current = entry;
            if (deep) {
                while (current) {
                    if (current.parent_channel() == self) {
                        result.push(entry);
                        break;
                    }
                    current = current.parent_channel();
                }
            }
            else if (current.parent_channel() == self)
                result.push(entry);
        });
        return result;
    }
    clients(deep = false) {
        const result = [];
        if (this.channelTree == null)
            return [];
        const self = this;
        this.channelTree.clients.forEach(function (entry) {
            let current = entry.currentChannel();
            if (deep) {
                while (current) {
                    if (current == self) {
                        result.push(entry);
                        break;
                    }
                    current = current.parent_channel();
                }
            }
            else if (current == self)
                result.push(entry);
        });
        return result;
    }
    clients_ordered() {
        const clients = this.clients(false);
        clients.sort((a, b) => {
            if (a.properties.client_talk_power < b.properties.client_talk_power)
                return 1;
            if (a.properties.client_talk_power > b.properties.client_talk_power)
                return -1;
            if (a.properties.client_nickname > b.properties.client_nickname)
                return 1;
            if (a.properties.client_nickname < b.properties.client_nickname)
                return -1;
            return 0;
        });
        return clients;
    }
    update_family_index(enforce) {
        const current_index = this._family_index;
        const new_index = this.calculate_family_index(true);
        if (current_index == new_index && !enforce)
            return;
        this._tag_channel.css("z-index", this._family_index);
        this._tag_channel.css("padding-left", (this._family_index + 1) * 16 + "px");
    }
    calculate_family_index(enforce_recalculate = false) {
        if (this._family_index !== undefined && !enforce_recalculate)
            return this._family_index;
        this._family_index = 0;
        let channel = this.parent_channel();
        while (channel) {
            this._family_index++;
            channel = channel.parent_channel();
        }
        return this._family_index;
    }
    initializeTag() {
        const tag_channel = $.spawn("div").addClass("tree-entry channel");
        {
            const container_entry = $.spawn("div").addClass("container-channel");
            container_entry.attr("channel-id", this.channelId);
            container_entry.addClass(this._channel_name_alignment);
            /* channel icon (type) */
            {
                container_entry.append($.spawn("div")
                    .addClass("show-channel-normal-only channel-type icon client-channel_green_subscribed"));
            }
            /* channel name */
            {
                container_entry.append($.spawn("div")
                    .addClass("container-channel-name")
                    .append($.spawn("a")
                    .addClass("channel-name")
                    .text(this.channelName())));
            }
            /* all icons (last element) */
            {
                //Icons
                let container_icons = $.spawn("span").addClass("icons");
                //Default icon (5)
                container_icons.append($.spawn("div")
                    .addClass("show-channel-normal-only icon_entry icon_default icon client-channel_default")
                    .attr("title", _translations.Ij28fXwP || (_translations.Ij28fXwP = tr("Default channel"))));
                //Password icon (4)
                container_icons.append($.spawn("div")
                    .addClass("show-channel-normal-only icon_entry icon_password icon client-register")
                    .attr("title", _translations._TVD0tbG || (_translations._TVD0tbG = tr("The channel is password protected"))));
                //Music icon (3)
                container_icons.append($.spawn("div")
                    .addClass("show-channel-normal-only icon_entry icon_music icon client-music")
                    .attr("title", _translations.ZapXznZK || (_translations.ZapXznZK = tr("Music quality"))));
                //Channel moderated (2)
                container_icons.append($.spawn("div")
                    .addClass("show-channel-normal-only icon_entry icon_moderated icon client-moderated")
                    .attr("title", _translations.uT3cHwv6 || (_translations.uT3cHwv6 = tr("Channel is moderated"))));
                //Channel Icon (1)
                container_icons.append($.spawn("div")
                    .addClass("show-channel-normal-only icon_entry channel_icon")
                    .attr("title", _translations.Fs50vlYp || (_translations.Fs50vlYp = tr("Channel icon"))));
                //Default no sound (0)
                let container = $.spawn("div")
                    .css("position", "relative")
                    .addClass("icon_no_sound");
                let noSound = $.spawn("div")
                    .addClass("icon_entry icon client-conflict-icon")
                    .attr("title", "You don't support the channel codec");
                let bg = $.spawn("div")
                    .width(10)
                    .height(14)
                    .css("background", "red")
                    .css("position", "absolute")
                    .css("top", "1px")
                    .css("left", "3px")
                    .css("z-index", "-1");
                bg.appendTo(container);
                noSound.appendTo(container);
                container_icons.append(container);
                container_icons.appendTo(container_entry);
            }
            tag_channel.append(this._tag_channel = container_entry);
            this.update_family_index(true);
        }
        {
            const container_client = $.spawn("div").addClass("container-clients");
            tag_channel.append(this._tag_clients = container_client);
        }
        {
            const container_children = $.spawn("div").addClass("container-children");
            tag_channel.append(this._tag_siblings = container_children);
        }
        /*
        setInterval(() => {
            let color = (Math.random() * 10000000).toString(16).substr(0, 6);
            bg.css("background", "#" + color);
        }, 150);
        */
        this._tag_root = tag_channel;
    }
    rootTag() {
        return this._tag_root;
    }
    channelTag() {
        return this._tag_channel;
    }
    siblingTag() {
        return this._tag_siblings;
    }
    clientTag() {
        return this._tag_clients;
    }
    reorderClients() {
        let clients = this.clients();
        if (clients.length > 1) {
            clients.sort((a, b) => {
                if (a.properties.client_talk_power < b.properties.client_talk_power)
                    return 1;
                if (a.properties.client_talk_power > b.properties.client_talk_power)
                    return -1;
                if (a.properties.client_nickname > b.properties.client_nickname)
                    return 1;
                if (a.properties.client_nickname < b.properties.client_nickname)
                    return -1;
                return 0;
            });
            clients.reverse();
            for (let index = 0; index + 1 < clients.length; index++)
                clients[index].tag.before(clients[index + 1].tag);
            for (let client of clients) {
                console.log("- %i %s", client.properties.client_talk_power, client.properties.client_nickname);
            }
        }
    }
    initializeListener() {
        const tag_channel = this.channelTag();
        tag_channel.on('click', () => this.channelTree.onSelect(this));
        tag_channel.on('dblclick', () => {
            if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                return;
            }
            this.joinChannel();
        });
        let last_touch = 0;
        let touch_start = 0;
        tag_channel.on('touchend', event => {
            /* if over 250ms then its not a click its more a drag */
            if (Date.now() - touch_start > 250) {
                touch_start = 0;
                return;
            }
            if (Date.now() - last_touch > 750) {
                last_touch = Date.now();
                return;
            }
            last_touch = Date.now();
            /* double touch */
            tag_channel.trigger('dblclick');
        });
        tag_channel.on('touchstart', event => {
            touch_start = Date.now();
        });
        if (!settings.static(Settings.KEY_DISABLE_CONTEXT_MENU, false)) {
            this.channelTag().on("contextmenu", (event) => {
                event.preventDefault();
                if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                    (this.channelTree.currently_selected_context_callback || ((_) => null))(event);
                    return;
                }
                this.channelTree.onSelect(this, true);
                this.showContextMenu(event.pageX, event.pageY, () => {
                    this.channelTree.onSelect(undefined, true);
                });
            });
        }
    }
    showContextMenu(x, y, on_close = undefined) {
        let channelCreate = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_TEMPORARY).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_SEMI_PERMANENT).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_PERMANENT).granted(1);
        let channelModify = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_DEFAULT).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_PERMANENT).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_SEMI_PERMANENT).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_TEMPORARY).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_NAME).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_TOPIC).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_DESCRIPTION).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_PASSWORD).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_CODEC).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_CODEC_QUALITY).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_CODEC_LATENCY_FACTOR).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAXCLIENTS).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAXFAMILYCLIENTS).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_SORTORDER).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_NEEDED_TALK_POWER).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_CODEC_ENCRYPTED).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_TEMP_DELETE_DELAY).granted(1) ||
            this.channelTree.client.permissions.neededPermission(PermissionType.B_ICON_MANAGE).granted(1);
        let flagDelete = true;
        if (this.clients(true).length > 0)
            flagDelete = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_DELETE_FLAG_FORCE).granted(1);
        if (flagDelete) {
            if (this.properties.channel_flag_permanent)
                flagDelete = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_DELETE_PERMANENT).granted(1);
            else if (this.properties.channel_flag_semi_permanent)
                flagDelete = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_DELETE_PERMANENT).granted(1);
            else
                flagDelete = this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_DELETE_TEMPORARY).granted(1);
        }
        let trigger_close = true;
        spawn_context_menu(x, y, {
            type: MenuEntryType.ENTRY,
            name: _translations.ktVc6xHo || (_translations.ktVc6xHo = tr("Show channel info")),
            callback: () => {
                trigger_close = false;
                this.channelTree.client.select_info.open_popover();
            },
            icon: "client-about",
            visible: this.channelTree.client.select_info.is_popover()
        }, {
            type: MenuEntryType.HR,
            visible: this.channelTree.client.select_info.is_popover(),
            name: ''
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_switch",
            name: _translations.aDLFGWs4 || (_translations.aDLFGWs4 = tr("<b>Switch to channel</b>")),
            callback: () => this.joinChannel()
        }, ...(() => {
            const local_client = this.channelTree.client.getClient();
            if (!local_client || local_client.currentChannel() !== this)
                return [
                    MenuEntry.HR(),
                    {
                        type: MenuEntryType.ENTRY,
                        icon: "client-subscribe_to_channel",
                        name: _translations.ubL7tTRj || (_translations.ubL7tTRj = tr("<b>Subscribe to channel</b>")),
                        callback: () => this.subscribe(),
                        visible: !this.flag_subscribed
                    },
                    {
                        type: MenuEntryType.ENTRY,
                        icon: "client-channel_unsubscribed",
                        name: _translations.VHJ9HmoE || (_translations.VHJ9HmoE = tr("<b>Unsubscribe from channel</b>")),
                        callback: () => this.unsubscribe(),
                        visible: this.flag_subscribed
                    },
                    {
                        type: MenuEntryType.ENTRY,
                        icon: "client-subscribe_mode",
                        name: _translations.mYSb7NC7 || (_translations.mYSb7NC7 = tr("<b>Use inherited subscribe mode</b>")),
                        callback: () => this.unsubscribe(true),
                        visible: this.subscribe_mode != ChannelSubscribeMode.INHERITED
                    }
                ];
            return [];
        })(), MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_edit",
            name: _translations.oC37kcG7 || (_translations.oC37kcG7 = tr("Edit channel")),
            invalidPermission: !channelModify,
            callback: () => {
                Modals.createChannelModal(this.channelTree.client, this, undefined, this.channelTree.client.permissions, (changes, permissions) => {
                    if (changes) {
                        changes["cid"] = this.channelId;
                        this.channelTree.client.serverConnection.send_command("channeledit", changes);
                        log.info(LogCategory.CHANNEL, _translations.hAq3YEH3 || (_translations.hAq3YEH3 = tr("Changed channel properties of channel %s: %o")), this.channelName(), changes);
                    }
                    if (permissions && permissions.length > 0) {
                        let perms = [];
                        for (let perm of permissions) {
                            perms.push({
                                permvalue: perm.value,
                                permnegated: false,
                                permskip: false,
                                permid: perm.type.id
                            });
                        }
                        perms[0]["cid"] = this.channelId;
                        this.channelTree.client.serverConnection.send_command("channeladdperm", perms, {
                            flagset: ["continueonerror"]
                        }).then(() => {
                            this.channelTree.client.sound.play(Sound.CHANNEL_EDITED_SELF);
                        });
                    }
                });
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_delete",
            name: _translations.TxVb7JNF || (_translations.TxVb7JNF = tr("Delete channel")),
            invalidPermission: !flagDelete,
            callback: () => {
                this.channelTree.client.serverConnection.send_command("channeldelete", { cid: this.channelId }).then(() => {
                    this.channelTree.client.sound.play(Sound.CHANNEL_DELETED);
                });
            }
        }, MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-addon-collection",
            name: _translations.Q8x8wea4 || (_translations.Q8x8wea4 = tr("Create music bot")),
            callback: () => {
                this.channelTree.client.serverConnection.send_command("musicbotcreate", { cid: this.channelId }).then(() => {
                    createInfoModal(_translations.bGgJOR0P || (_translations.bGgJOR0P = tr("Bot successfully created")), _translations.Jn7H_QkP || (_translations.Jn7H_QkP = tr("Bot has been successfully created."))).open();
                }).catch(error => {
                    if (error instanceof CommandResult) {
                        error = error.extra_message || error.message;
                    }
                    createErrorModal(_translations.qb3HB3VD || (_translations.qb3HB3VD = tr("Failed to create bot")), MessageHelper.formatMessage(_translations.zgxESN34 || (_translations.zgxESN34 = tr("Failed to create the music bot:<br>{0}")), error)).open();
                });
            }
        }, MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_create_sub",
            name: _translations.qSIiy4Q5 || (_translations.qSIiy4Q5 = tr("Create sub channel")),
            invalidPermission: !(channelCreate && this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_CHILD).granted(1)),
            callback: () => this.channelTree.spawnCreateChannel(this)
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_create",
            name: _translations.qK1pswRX || (_translations.qK1pswRX = tr("Create channel")),
            invalidPermission: !channelCreate,
            callback: () => this.channelTree.spawnCreateChannel()
        }, MenuEntry.CLOSE(() => (trigger_close ? on_close : () => { })()));
    }
    handle_frame_resized() {
        this.__updateChannelName();
    }
    __updateChannelName() {
        this._channel_name_formatted = undefined;
        parseType: if (this.parent_channel() == null && this.properties.channel_name.charAt(0) == '[') {
            let end = this.properties.channel_name.indexOf(']');
            if (end == -1)
                break parseType;
            let options = this.properties.channel_name.substr(1, end - 1);
            if (options.indexOf("spacer") == -1)
                break parseType;
            options = options.substr(0, options.indexOf("spacer"));
            console.log(_translations._wI84Npb || (_translations._wI84Npb = tr("Channel options: '%o'")), options);
            if (options.length == 0)
                options = "l";
            else if (options.length > 1)
                options = options[0];
            switch (options) {
                case "r":
                    this._channel_name_alignment = "align-right";
                    break;
                case "l":
                    this._channel_name_alignment = "align-left";
                    break;
                case "c":
                    this._channel_name_alignment = "align-center";
                    break;
                case "*":
                    this._channel_name_alignment = "align-repetitive";
                    break;
                default:
                    this._channel_name_alignment = undefined;
                    break parseType;
            }
            this._channel_name_formatted = this.properties.channel_name.substr(end + 1) || "";
            console.log(_translations.j8fkddoU || (_translations.j8fkddoU = tr("Got formated channel name: %o")), this._channel_name_formatted);
        }
        this._tag_channel.find(".show-channel-normal-only").toggleClass("channel-normal", this._channel_name_formatted === undefined);
        const tag_container_name = this._tag_channel.find(".container-channel-name");
        tag_container_name.removeClass(ChannelEntry.NAME_ALIGNMENTS.join(" "));
        const tag_name = tag_container_name.find(".channel-name");
        tag_name.text(this._channel_name_formatted === undefined ? this.properties.channel_name : this._channel_name_formatted);
        if (this._channel_name_formatted !== undefined) {
            tag_container_name.addClass(this._channel_name_alignment);
            if (this._channel_name_alignment == "align-repetitive") {
                if (tag_name.parent().width() != 0) {
                    let lastSuccess = "";
                    let index = 6;
                    let name = this._channel_name_formatted;
                    if (name.length < 1)
                        throw "invalid name!";
                    while (index-- > 0)
                        name = name + name;
                    tag_name.text(name);
                    do {
                        tag_name.text(name = name + name);
                        if (name.length > 1024 * 8)
                            index = 63;
                    } while (tag_name.parent().width() >= tag_name.width() && ++index < 64);
                    if (index == 64)
                        console.warn(LogCategory.CHANNEL, _translations.CafVtWjf || (_translations.CafVtWjf = tr("Repeating spacer took too much repeats!")));
                    if (lastSuccess.length > 0) {
                        tag_name.text(lastSuccess);
                    }
                }
            }
        }
        console.log(_translations.JcFXvV8h || (_translations.JcFXvV8h = tr("Align: %s")), this._channel_name_alignment);
    }
    recalculate_repetitive_name() {
        if (this._channel_name_alignment == "align-repetitive")
            this.__updateChannelName();
    }
    updateVariables(...variables) {
        let group = log.group(log.LogType.DEBUG, LogCategory.CHANNEL_PROPERTIES, _translations.gh0r9yWV || (_translations.gh0r9yWV = tr("Update properties (%i) of %s (%i)")), variables.length, this.channelName(), this.getChannelId());
        {
            const entries = [];
            for (const variable of variables)
                entries.push({
                    key: variable.key,
                    value: variable.value,
                    type: typeof (this.properties[variable.key])
                });
            log.table("Clannel update properties", entries);
        }
        for (let variable of variables) {
            let key = variable.key;
            let value = variable.value;
            JSON.map_field_to(this.properties, value, variable.key);
            if (key == "channel_name") {
                this.__updateChannelName();
            }
            else if (key == "channel_order") {
                let order = this.channelTree.findChannel(this.properties.channel_order);
                this.channelTree.moveChannel(this, order, this.parent);
            }
            else if (key == "channel_icon_id") {
                /* For more detail lookup client::updateVariables and client_icon_id!
                 * ATTENTION: This is required!
                 */
                this.properties.channel_icon_id = variable.value >>> 0;
                let tag = this.channelTag().find(".icons .channel_icon");
                (this.properties.channel_icon_id > 0 ? $.fn.show : $.fn.hide).apply(tag);
                if (this.properties.channel_icon_id > 0) {
                    tag.children().detach();
                    this.channelTree.client.fileManager.icons.generateTag(this.properties.channel_icon_id).appendTo(tag);
                }
            }
            else if (key == "channel_codec") {
                (this.properties.channel_codec == 5 || this.properties.channel_codec == 3 ? $.fn.show : $.fn.hide).apply(this.channelTag().find(".icons .icon_music"));
                this.channelTag().find(".icons .icon_no_sound").toggle(!(this.channelTree.client.serverConnection.support_voice() &&
                    this.channelTree.client.serverConnection.voice_connection().decoding_supported(this.properties.channel_codec)));
            }
            else if (key == "channel_flag_default") {
                (this.properties.channel_flag_default ? $.fn.show : $.fn.hide).apply(this.channelTag().find(".icons .icon_default"));
            }
            else if (key == "channel_flag_password")
                (this.properties.channel_flag_password ? $.fn.show : $.fn.hide).apply(this.channelTag().find(".icons .icon_password"));
            else if (key == "channel_needed_talk_power")
                (this.properties.channel_needed_talk_power > 0 ? $.fn.show : $.fn.hide).apply(this.channelTag().find(".icons .icon_moderated"));
            else if (key == "channel_description") {
                this._cached_channel_description = undefined;
                if (this._cached_channel_description_promise_resolve)
                    this._cached_channel_description_promise_resolve(value);
                this._cached_channel_description_promise = undefined;
                this._cached_channel_description_promise_resolve = undefined;
                this._cached_channel_description_promise_reject = undefined;
            }
            if (key == "channel_maxclients" || key == "channel_maxfamilyclients" || key == "channel_flag_private" || key == "channel_flag_password")
                this.updateChannelTypeIcon();
        }
        group.end();
    }
    updateChannelTypeIcon() {
        let tag = this.channelTag().find(".channel-type");
        tag.removeAttr('class');
        tag.addClass("show-channel-normal-only channel-type icon");
        if (this._channel_name_formatted === undefined)
            tag.addClass("channel-normal");
        let type;
        if (this.properties.channel_flag_password == true && !this._cachedPassword)
            type = "yellow";
        else if ((!this.properties.channel_flag_maxclients_unlimited && this.clients().length >= this.properties.channel_maxclients) ||
            (!this.properties.channel_flag_maxfamilyclients_unlimited && this.properties.channel_maxfamilyclients >= 0 && this.clients(true).length >= this.properties.channel_maxfamilyclients))
            type = "red";
        else
            type = "green";
        tag.addClass("client-channel_" + type + (this._flag_subscribed ? "_subscribed" : ""));
    }
    generate_bbcode() {
        return "[url=channel://" + this.channelId + "/" + encodeURIComponent(this.properties.channel_name) + "]" + this.formattedChannelName() + "[/url]";
    }
    generate_tag(braces = false) {
        return $(htmltags.generate_channel({
            channel_name: this.properties.channel_name,
            channel_id: this.channelId,
            add_braces: braces
        }));
    }
    channelType() {
        if (this.properties.channel_flag_permanent == true)
            return ChannelType.PERMANENT;
        if (this.properties.channel_flag_semi_permanent == true)
            return ChannelType.SEMI_PERMANENT;
        return ChannelType.TEMPORARY;
    }
    joinChannel() {
        if (this.properties.channel_flag_password == true &&
            !this._cachedPassword &&
            !this.channelTree.client.permissions.neededPermission(PermissionType.B_CHANNEL_JOIN_IGNORE_PASSWORD).granted(1)) {
            createInputModal(_translations.RNP11uFE || (_translations.RNP11uFE = tr("Channel password")), _translations.g14bQ0Vc || (_translations.g14bQ0Vc = tr("Channel password:")), () => true, text => {
                if (typeof (text) == typeof (true))
                    return;
                helpers.hashPassword(text).then(result => {
                    this._cachedPassword = result;
                    this.joinChannel();
                    this.updateChannelTypeIcon();
                });
            }).open();
        }
        else if (this.channelTree.client.getClient().currentChannel() != this)
            this.channelTree.client.getServerConnection().command_helper.joinChannel(this, this._cachedPassword).then(() => {
                this.channelTree.client.sound.play(Sound.CHANNEL_JOINED);
            }).catch(error => {
                if (error instanceof CommandResult) {
                    if (error.id == 781) { //Invalid password
                        this._cachedPassword = undefined;
                        this.updateChannelTypeIcon();
                    }
                }
            });
    }
    cached_password() { return this._cachedPassword; }
    subscribe() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.subscribe_mode == ChannelSubscribeMode.SUBSCRIBED)
                return;
            this.subscribe_mode = ChannelSubscribeMode.SUBSCRIBED;
            const connection = this.channelTree.client.getServerConnection();
            if (!this.flag_subscribed && connection)
                yield connection.send_command('channelsubscribe', {
                    'cid': this.getChannelId()
                });
            else
                this.flag_subscribed = false;
        });
    }
    unsubscribe(inherited_subscription_mode) {
        return __awaiter(this, void 0, void 0, function* () {
            const connection = this.channelTree.client.getServerConnection();
            let unsubscribe;
            if (inherited_subscription_mode) {
                this.subscribe_mode = ChannelSubscribeMode.INHERITED;
                unsubscribe = this.flag_subscribed && !this.channelTree.client.client_status.channel_subscribe_all;
            }
            else {
                this.subscribe_mode = ChannelSubscribeMode.UNSUBSCRIBED;
                unsubscribe = this.flag_subscribed;
            }
            if (unsubscribe) {
                if (connection)
                    yield connection.send_command('channelunsubscribe', {
                        'cid': this.getChannelId()
                    });
                else
                    this.flag_subscribed = false;
                for (const client of this.clients(false))
                    this.channelTree.deleteClient(client, false);
            }
        });
    }
    get flag_subscribed() {
        return this._flag_subscribed;
    }
    set flag_subscribed(flag) {
        if (this._flag_subscribed == flag)
            return;
        this._flag_subscribed = flag;
        this.updateChannelTypeIcon();
    }
    get subscribe_mode() {
        return typeof (this._subscribe_mode) !== 'undefined' ? this._subscribe_mode : (this._subscribe_mode = this.channelTree.client.settings.server(Settings.FN_SERVER_CHANNEL_SUBSCRIBE_MODE(this), ChannelSubscribeMode.INHERITED));
    }
    set subscribe_mode(mode) {
        if (this.subscribe_mode == mode)
            return;
        this._subscribe_mode = mode;
        this.channelTree.client.settings.changeServer(Settings.FN_SERVER_CHANNEL_SUBSCRIBE_MODE(this), mode);
    }
}
ChannelEntry.NAME_ALIGNMENTS = ["align-left", "align-center", "align-right", "align-repetitive"];
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e8a9d5f150bfafcf08e670d87b3006c4da8c5aa43bc288d769f2d43e0a44c233"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e8a9d5f150bfafcf08e670d87b3006c4da8c5aa43bc288d769f2d43e0a44c233"] = "e8a9d5f150bfafcf08e670d87b3006c4da8c5aa43bc288d769f2d43e0a44c233";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var ElementType;
(function (ElementType) {
    ElementType[ElementType["HEADER"] = 0] = "HEADER";
    ElementType[ElementType["BODY"] = 1] = "BODY";
    ElementType[ElementType["FOOTER"] = 2] = "FOOTER";
})(ElementType || (ElementType = {}));
const ModalFunctions = {
    divify: function (val) {
        if (val.length > 1)
            return $.spawn("div").append(val);
        return val;
    },
    jqueriefy: function (val, type) {
        if ($.isFunction(val))
            val = val();
        if ($.isArray(val)) {
            let result = $.spawn("div");
            for (let element of val)
                this.jqueriefy(element, type).appendTo(result);
            return result;
        }
        switch (typeof val) {
            case "string":
                if (type == ElementType.HEADER)
                    return $.spawn("h5").addClass("modal-title").text(val);
                return $("<div>" + val + "</div>");
            case "object": return val;
            case "undefined":
                return undefined;
            default:
                console.error(("Invalid type %o"), typeof val);
                return $();
        }
    },
    warpProperties(data) {
        if (data instanceof ModalProperties)
            return data;
        else {
            const props = new ModalProperties();
            for (const key of Object.keys(data))
                props[key] = data[key];
            return props;
        }
    }
};
class ModalProperties {
    constructor() {
        this.header = () => "HEADER";
        this.body = () => "BODY";
        this.footer = () => "FOOTER";
        this.closeListener = () => { };
        this.width = "60%";
        this.height = "auto";
        this.closeable = true;
        this.template_properties = {};
        this.trigger_tab = true;
        this.full_size = false;
    }
    registerCloseListener(listener) {
        if (this.closeListener) {
            if ($.isArray(this.closeListener))
                this.closeListener.push(listener);
            else
                this.closeListener = [this.closeListener, listener];
        }
        else
            this.closeListener = listener;
        return this;
    }
    triggerClose() {
        if ($.isArray(this.closeListener))
            for (let listener of this.closeListener)
                listener();
        else
            this.closeListener();
    }
}
class Modal {
    constructor(props) {
        this.open_listener = [];
        this.close_listener = [];
        this.properties = props;
        this.shown = false;
    }
    get htmlTag() {
        if (!this._htmlTag)
            this._create();
        return this._htmlTag;
    }
    _create() {
        const header = ModalFunctions.jqueriefy(this.properties.header, ElementType.HEADER);
        const body = ModalFunctions.jqueriefy(this.properties.body, ElementType.BODY);
        const footer = ModalFunctions.jqueriefy(this.properties.footer, ElementType.FOOTER);
        //FIXME: cache template
        const template = $(this.properties.template || "#tmpl_modal");
        const properties = {
            modal_header: header,
            modal_body: body,
            modal_footer: footer,
            closeable: this.properties.closeable,
            full_size: this.properties.full_size
        };
        if (this.properties.template_properties)
            Object.assign(properties, this.properties.template_properties);
        const tag = template.renderTag(properties);
        this.close_elements = tag.find(".button-modal-close");
        this.close_elements.toggle(this.properties.closeable);
        this._htmlTag = tag;
        this._htmlTag.on('shown.bs.modal', event => {
            for (const listener of this.open_listener)
                listener();
        });
        this._htmlTag.on('hide.bs.modal', event => !this.properties.closeable || this.close());
        this._htmlTag.on('hidden.bs.modal', event => this._htmlTag.detach());
    }
    open() {
        this.shown = true;
        this.htmlTag.appendTo($("body"));
        this.htmlTag.bootstrapMaterialDesign().modal(this.properties.closeable ? 'show' : {
            backdrop: 'static',
            keyboard: false,
        });
        if (this.properties.trigger_tab)
            this.htmlTag.one('shown.bs.modal', () => this.htmlTag.find(".tab").trigger('tab.resize'));
    }
    close() {
        if (!this.shown)
            return;
        this.shown = false;
        this.htmlTag.modal('hide');
        this.properties.triggerClose();
        for (const listener of this.close_listener)
            listener();
    }
    set_closeable(flag) {
        if (flag === this.properties.closeable)
            return;
        this.properties.closeable = flag;
        this.close_elements.toggle(flag);
    }
}
function createModal(data) {
    return new Modal(ModalFunctions.warpProperties(data));
}
class InputModalProperties extends ModalProperties {
}
function createInputModal(headMessage, question, validator, callback, props = {}) {
    props = ModalFunctions.warpProperties(props);
    props.template_properties || (props.template_properties = {});
    props.template_properties.field_title = props.field_title;
    props.template_properties.field_label = props.field_label;
    props.template_properties.field_placeholder = props.field_placeholder;
    props.template_properties.error_message = props.error_message;
    props.template = "#tmpl_modal_input";
    props.header = headMessage;
    props.template_properties.question = ModalFunctions.jqueriefy(question);
    const modal = createModal(props);
    const input = modal.htmlTag.find(".container-value input");
    const button_cancel = modal.htmlTag.find(".button-cancel");
    const button_submit = modal.htmlTag.find(".button-submit");
    let submited = false;
    input.on('keyup change', event => {
        const str = input.val();
        const valid = str !== undefined && validator(str);
        input.attr("pattern", valid ? null : "^[a]{1000}$").toggleClass("is-invalid", !valid);
        button_submit.prop("disabled", !valid);
    });
    input.on('keydown', event => {
        if (event.keyCode !== KeyCode.KEY_RETURN || event.shiftKey)
            return;
        if (button_submit.prop("disabled"))
            return;
        button_submit.trigger('click');
    });
    button_submit.on('click', event => {
        if (!submited) {
            submited = true;
            const str = input.val();
            if (str !== undefined && validator(str))
                callback(str);
            else
                callback(false);
        }
        modal.close();
    }).prop("disabled", !validator("")); /* disabled if empty input isn't allowed */
    button_cancel.on('click', event => {
        if (!submited) {
            submited = true;
            callback(false);
        }
        modal.close();
    });
    modal.open_listener.push(() => input.focus());
    modal.close_listener.push(() => button_cancel.trigger('click'));
    return modal;
}
function createErrorModal(header, message, props = { footer: undefined }) {
    props = ModalFunctions.warpProperties(props);
    (props.template_properties || (props.template_properties = {})).header_class = "modal-header-error";
    props.header = header;
    props.body = message;
    return createModal(props);
}
function createInfoModal(header, message, props = { footer: undefined }) {
    props = ModalFunctions.warpProperties(props);
    (props.template_properties || (props.template_properties = {})).header_class = "modal-header-info";
    props.header = header;
    props.body = message;
    return createModal(props);
}
$.fn.modalize = function (entry_callback, properties) {
    properties = properties || {};
    entry_callback = entry_callback || ((a, b, c) => undefined);
    let tag_modal = this[0].tagName.toLowerCase() == "modal" ? this : undefined; /* TODO may throw exception? */
    let tag_head = tag_modal ? tag_modal.find("modal-header") : ModalFunctions.jqueriefy(properties.header);
    let tag_body = tag_modal ? tag_modal.find("modal-body") : this;
    let tag_footer = tag_modal ? tag_modal.find("modal-footer") : ModalFunctions.jqueriefy(properties.footer);
    const result = entry_callback(tag_head, tag_body, tag_footer) || {};
    properties.header = result.header || tag_head;
    properties.body = result.body || tag_body;
    properties.footer = result.footer || tag_footer;
    return createModal(properties);
};
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["7c6932440aae09de6df1f2bcb71a93d11c0e3812c472ce35185a9576498c58b6"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["7c6932440aae09de6df1f2bcb71a93d11c0e3812c472ce35185a9576498c58b6"] = "7c6932440aae09de6df1f2bcb71a93d11c0e3812c472ce35185a9576498c58b6";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "CsEiON8E", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (11,29)" }, { name: "ridSCDhc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (32,34)" }, { name: "AZCqMKuP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (40,35)" }, { name: "Etcm_yDf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (49,31)" }, { name: "S0GE8Gdw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (78,29)" }, { name: "J84yKKOX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (99,39)" }, { name: "i082uJ6r", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (108,39)" }, { name: "tA1SJ0VZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (116,40)" }, { name: "av1zmQOP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalChangeVolume.ts (124,36)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnChangeVolume(current, callback) {
        let updateCallback;
        const connectModal = createModal({
            header: function () {
                let header = $.spawn("div");
                header.text(_translations.CsEiON8E || (_translations.CsEiON8E = tr("Change volume")));
                return header;
            },
            body: function () {
                let tag = $("#tmpl_change_volume").renderTag({
                    max_volume: 200
                });
                tag.find(".volume_slider").on("change", _ => updateCallback(tag.find(".volume_slider").val()));
                tag.find(".volume_slider").on("input", _ => updateCallback(tag.find(".volume_slider").val()));
                //connect_address
                return tag;
            },
            footer: function () {
                let tag = $.spawn("div");
                tag.css("text-align", "right");
                tag.css("margin-top", "3px");
                tag.css("margin-bottom", "6px");
                tag.addClass("modal-button-group");
                let buttonReset = $.spawn("button");
                buttonReset.text(_translations.ridSCDhc || (_translations.ridSCDhc = tr("Reset")));
                buttonReset.on("click", function () {
                    updateCallback(100);
                });
                tag.append(buttonReset);
                let buttonCancel = $.spawn("button");
                buttonCancel.text(_translations.AZCqMKuP || (_translations.AZCqMKuP = tr("Cancel")));
                buttonCancel.on("click", function () {
                    updateCallback(current * 100);
                    connectModal.close();
                });
                tag.append(buttonCancel);
                let buttonOk = $.spawn("button");
                buttonOk.text(_translations.Etcm_yDf || (_translations.Etcm_yDf = tr("OK")));
                buttonOk.on("click", function () {
                    connectModal.close();
                });
                tag.append(buttonOk);
                return tag;
            },
            width: 600
        });
        updateCallback = value => {
            connectModal.htmlTag.find(".volume_slider").val(value);
            let display = connectModal.htmlTag.find(".display_volume");
            let number = (value - 100);
            display.html((number == 0 ? "&plusmn;" : number > 0 ? "+" : "") + number + " %");
            callback(value / 100);
        };
        connectModal.open();
        updateCallback(current * 100);
    }
    Modals.spawnChangeVolume = spawnChangeVolume;
    /* Units are between 0 and 1 */
    function spawnChangeRemoteVolume(current, max_value, callback) {
        let update_volume;
        let current_value = current; /* between 0 and 100! */
        const modal = createModal({
            header: function () {
                let header = $.spawn("div");
                header.text(_translations.S0GE8Gdw || (_translations.S0GE8Gdw = tr("Change volume")));
                return header;
            },
            body: function () {
                let tag = $("#tmpl_change_volume").renderTag({
                    max_volume: Math.ceil(max_value * 100)
                });
                tag.find(".volume_slider").on("change", _ => update_volume(tag.find(".volume_slider").val()));
                tag.find(".volume_slider").on("input", _ => update_volume(tag.find(".volume_slider").val()));
                //connect_address
                return tag;
            },
            footer: function () {
                let tag = $.spawn("div");
                tag.css("text-align", "right");
                tag.css("margin-top", "3px");
                tag.css("margin-bottom", "6px");
                tag.addClass("modal-button-group");
                {
                    let button_apply = $.spawn("button");
                    button_apply.text(_translations.J84yKKOX || (_translations.J84yKKOX = tr("Apply")));
                    button_apply.on("click", () => {
                        callback(current_value / 100);
                    });
                    tag.append(button_apply);
                }
                {
                    let button_reset = $.spawn("button");
                    button_reset.text(_translations.i082uJ6r || (_translations.i082uJ6r = tr("Reset")));
                    button_reset.on("click", () => update_volume(max_value * 100));
                    tag.append(button_reset);
                }
                {
                    let button_cancel = $.spawn("button");
                    button_cancel.text(_translations.tA1SJ0VZ || (_translations.tA1SJ0VZ = tr("Cancel")));
                    button_cancel.on("click", () => modal.close());
                    tag.append(button_cancel);
                }
                {
                    let button_ok = $.spawn("button");
                    button_ok.text(_translations.av1zmQOP || (_translations.av1zmQOP = tr("OK")));
                    button_ok.on("click", () => {
                        callback(current_value / 100);
                        modal.close();
                    });
                    tag.append(button_ok);
                }
                return tag;
            },
            width: 600
        });
        update_volume = value => {
            modal.htmlTag.find(".volume_slider").val(value);
            const tag_display = modal.htmlTag.find(".display_volume");
            tag_display.html(value + " %");
            current_value = value;
        };
        modal.open();
        update_volume(current * 100);
    }
    Modals.spawnChangeRemoteVolume = spawnChangeRemoteVolume;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["820822e77b61f4d6a63deed22f5a225024e982a9ac0381466884f30727bb4d48"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["820822e77b61f4d6a63deed22f5a225024e982a9ac0381466884f30727bb4d48"] = "820822e77b61f4d6a63deed22f5a225024e982a9ac0381466884f30727bb4d48";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "cUAUW0ks", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalServerGroupDialog.ts (4,21)" }, { name: "V5TBOMze", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalServerGroupDialog.ts (31,42)" }, { name: "v1dAuIyW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalServerGroupDialog.ts (48,35)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var Modals;
(function (Modals) {
    function createServerGroupAssignmentModal(client, callback) {
        const modal = createModal({
            header: _translations.cUAUW0ks || (_translations.cUAUW0ks = tr("Server Groups")),
            body: () => {
                let tag = {};
                let groups = tag["groups"] = [];
                tag["client_name"] = client.clientNickName();
                for (let group of client.channelTree.client.groups.serverGroups.sort(GroupManager.sorter())) {
                    if (group.type != GroupType.NORMAL)
                        continue;
                    let entry = {};
                    entry["id"] = group.id;
                    entry["name"] = group.name;
                    entry["assigned"] = client.groupAssigned(group);
                    entry["disabled"] = !client.channelTree.client.permissions.neededPermission(PermissionType.I_GROUP_MEMBER_ADD_POWER).granted(group.requiredMemberRemovePower);
                    tag["icon_" + group.id] = client.channelTree.client.fileManager.icons.generateTag(group.properties.iconid);
                    groups.push(entry);
                }
                let template = $("#tmpl_server_group_assignment").renderTag(tag);
                template.find(".group-entry input").each((_idx, _entry) => {
                    let entry = $(_entry);
                    entry.on('change', event => {
                        let group_id = parseInt(entry.attr("group-id"));
                        let group = client.channelTree.client.groups.serverGroup(group_id);
                        if (!group) {
                            console.warn(_translations.V5TBOMze || (_translations.V5TBOMze = tr("Could not resolve target group!")));
                            return false;
                        }
                        let target = entry.prop("checked");
                        callback(group, target).then(flag => flag ? Promise.resolve() : Promise.reject()).catch(error => entry.prop("checked", !target));
                    });
                });
                return template;
            },
            footer: () => {
                let footer = $.spawn("div");
                footer.addClass("modal-button-group");
                footer.css("margin", "5px");
                let button_close = $.spawn("button");
                button_close.text(_translations.v1dAuIyW || (_translations.v1dAuIyW = tr("Close"))).addClass("button_close");
                footer.append(button_close);
                return footer;
            },
            width: "max-content"
        });
        modal.htmlTag.find(".button_close").click(() => {
            modal.close();
        });
        modal.open();
    }
    Modals.createServerGroupAssignmentModal = createServerGroupAssignmentModal;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["1c33ba9d8a52c8c4df14fbaf5db6424fa6ba4599f7e8b06c572234f40ca5ec56"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["1c33ba9d8a52c8c4df14fbaf5db6424fa6ba4599f7e8b06c572234f40ca5ec56"] = "1c33ba9d8a52c8c4df14fbaf5db6424fa6ba4599f7e8b06c572234f40ca5ec56";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "FcGK32kI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client_move.ts (53,21)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="client.ts" />
class ClientMover {
    constructor(tree) {
        this.enabled = true;
        this._active = false;
        this.origin_point = undefined;
        this.channel_tree = tree;
    }
    is_active() { return this._active; }
    hover_text() {
        if ($.isArray(this.selected_client)) {
            return this.selected_client.filter(client => !!client).map(client => client.clientNickName()).join(", ");
        }
        else if (this.selected_client) {
            return this.selected_client.clientNickName();
        }
        else
            return "";
    }
    bbcode_text() {
        if ($.isArray(this.selected_client)) {
            return this.selected_client.filter(client => !!client).map(client => client.create_bbcode()).join(", ");
        }
        else if (this.selected_client) {
            return this.selected_client.create_bbcode();
        }
        else
            return "";
    }
    activate(client, callback, event) {
        this.finish_listener(undefined);
        if (!this.enabled)
            return false;
        this.selected_client = client;
        this.callback = callback;
        console.log(_translations.FcGK32kI || (_translations.FcGK32kI = tr("Starting mouse move")));
        ClientMover.listener_root.on('mouseup', this._bound_finish = this.finish_listener.bind(this)).on('mousemove', this._bound_move = this.move_listener.bind(this));
        {
            const content = ClientMover.move_element.find(".container");
            content.empty();
            content.append($.spawn("a").text(this.hover_text()));
        }
        this.move_listener(event);
    }
    move_listener(event) {
        if (!this.enabled)
            return;
        //console.log("Mouse move: " + event.pageX + " - " + event.pageY);
        if (!event.pageX || !event.pageY)
            return;
        if (!this.origin_point)
            this.origin_point = { x: event.pageX, y: event.pageY };
        ClientMover.move_element.css({
            "top": (event.pageY - 1) + "px",
            "left": (event.pageX + 10) + "px"
        });
        if (!this._active) {
            const d_x = this.origin_point.x - event.pageX;
            const d_y = this.origin_point.y - event.pageY;
            this._active = Math.sqrt(d_x * d_x + d_y * d_y) > 5 * 5;
            if (this._active) {
                if ($.isArray(this.selected_client)) {
                    this.channel_tree.onSelect(this.selected_client[0], true);
                    for (const client of this.selected_client.slice(1))
                        this.channel_tree.onSelect(client, false, true);
                }
                else {
                    this.channel_tree.onSelect(this.selected_client, true);
                }
                ClientMover.move_element.show();
            }
        }
        const elements = document.elementsFromPoint(event.pageX, event.pageY);
        while (elements.length > 0) {
            if (elements[0].classList.contains("container-channel"))
                break;
            elements.pop_front();
        }
        if (this.hovered_channel) {
            this.hovered_channel.classList.remove("move-selected");
            this.hovered_channel = undefined;
        }
        if (elements.length > 0) {
            elements[0].classList.add("move-selected");
            this.hovered_channel = elements[0];
        }
    }
    finish_listener(event) {
        ClientMover.move_element.hide();
        const channel_id = this.hovered_channel ? parseInt(this.hovered_channel.getAttribute("channel-id")) : 0;
        ClientMover.listener_root.unbind('mouseleave', this._bound_finish);
        ClientMover.listener_root.unbind('mouseup', this._bound_finish);
        ClientMover.listener_root.unbind('mousemove', this._bound_move);
        if (this.hovered_channel) {
            this.hovered_channel.classList.remove("move-selected");
            this.hovered_channel = undefined;
        }
        this.origin_point = undefined;
        if (!this._active) {
            this.selected_client = undefined;
            this.callback = undefined;
            return;
        }
        this._active = false;
        if (this.callback) {
            if (!channel_id)
                this.callback(undefined);
            else {
                this.callback(this.channel_tree.findChannel(channel_id));
            }
            this.callback = undefined;
        }
        /* test for the chat box */
        {
            const elements = document.elementsFromPoint(event.pageX, event.pageY);
            console.error(elements);
            while (elements.length > 0) {
                if (elements[0].classList.contains("client-chat-box-field"))
                    break;
                elements.pop_front();
            }
            if (elements.length > 0) {
                const element = $(elements[0]);
                element.val((element.val() || "") + this.bbcode_text());
            }
        }
    }
    deactivate() {
        this.callback = undefined;
        this.finish_listener(undefined);
    }
}
ClientMover.listener_root = $(document);
ClientMover.move_element = $("#mouse-move");
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["5d9ce50ce3dc9d940fe2283b52e655cb3efe01a27ad767c1a1862f610f916980"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["5d9ce50ce3dc9d940fe2283b52e655cb3efe01a27ad767c1a1862f610f916980"] = "5d9ce50ce3dc9d940fe2283b52e655cb3efe01a27ad767c1a1862f610f916980";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "dcA0kTll", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (235,19)" }, { name: "CxdwSpDd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (262,19)" }, { name: "Lti8UbaV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (269,19)" }, { name: "wbOesMC5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (280,23)" }, { name: "B_eP8M45", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (294,23)" }, { name: "xWBM4786", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (302,23)" }, { name: "cFYFWmlh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (304,38)" }, { name: "eucIyoOu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (304,57)" }, { name: "GIdgNXOZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (319,23)" }, { name: "tyXGRXaP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (321,38)" }, { name: "HJeZEV0R", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (321,71)" }, { name: "o2X97wNF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (339,23)" }, { name: "rvDFMPYb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (349,23)" }, { name: "g4JkrXI9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (351,38)" }, { name: "VTGgSH0B", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (351,70)" }, { name: "yzNfX7Da", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (367,23)" }, { name: "VBSHgpQY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (369,38)" }, { name: "z53uB9YR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (369,69)" }, { name: "evpkuEFw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (385,23)" }, { name: "f5GNSKXV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (423,23)" }, { name: "V0lmIPQ0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (584,70)" }, { name: "j0Qjz1Kb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (628,51)" }, { name: "SkMpd9DI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (630,50)" }, { name: "U26KC2Ss", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (720,55)" }, { name: "wB4JtPCT", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (832,23)" }, { name: "ynq6IOYx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (837,23)" }, { name: "rWzGIlKo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (840,38)" }, { name: "ITWWlms3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (840,68)" }, { name: "rSJ23NIR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (842,41)" }, { name: "XI7csXq6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (905,73)" }, { name: "T7guya8x", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (907,71)" }, { name: "UJNTJOOv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (962,23)" }, { name: "PKjjpv6N", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (974,23)" }, { name: "CVclUzQS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (978,38)" }, { name: "ksLK51Yw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (978,72)" }, { name: "ScmrgG8i", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (990,23)" }, { name: "nx08C8rd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (994,38)" }, { name: "ca5Ihski", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (994,75)" }, { name: "QkER2pmt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1016,23)" }, { name: "E8E_2obC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1027,42)" }, { name: "brEdJN45", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1027,69)" }, { name: "WN6Ci4jW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1029,42)" }, { name: "ejhsGCiv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1029,75)" }, { name: "bbnBOQXT", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1035,23)" }, { name: "pqw8NKxG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1039,38)" }, { name: "fqTJs80S", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1039,66)" }, { name: "J9vszfk_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1050,50)" }, { name: "yFmz7Vd2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1062,23)" }, { name: "wCjAmI5l", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1072,23)" }, { name: "H99KnPv2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1074,38)" }, { name: "c7kZyuPs", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1074,70)" }, { name: "kS2rtqHz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1076,41)" }, { name: "Ya5QMCsu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1090,23)" }, { name: "QW29mGyf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1103,23)" }, { name: "sL3Q72sz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1125,23)" }, { name: "jCVebDGW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1129,83)" }, { name: "O6ZylGXm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/client.ts (1130,39)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var ClientType;
(function (ClientType) {
    ClientType[ClientType["CLIENT_VOICE"] = 0] = "CLIENT_VOICE";
    ClientType[ClientType["CLIENT_QUERY"] = 1] = "CLIENT_QUERY";
    ClientType[ClientType["CLIENT_INTERNAL"] = 2] = "CLIENT_INTERNAL";
    ClientType[ClientType["CLIENT_WEB"] = 3] = "CLIENT_WEB";
    ClientType[ClientType["CLIENT_MUSIC"] = 4] = "CLIENT_MUSIC";
    ClientType[ClientType["CLIENT_UNDEFINED"] = 5] = "CLIENT_UNDEFINED";
})(ClientType || (ClientType = {}));
class ClientProperties {
    constructor() {
        this.client_type = ClientType.CLIENT_VOICE; //TeamSpeaks type
        this.client_type_exact = ClientType.CLIENT_VOICE;
        this.client_database_id = 0;
        this.client_version = "";
        this.client_platform = "";
        this.client_nickname = "unknown";
        this.client_unique_identifier = "unknown";
        this.client_description = "";
        this.client_servergroups = "";
        this.client_channel_group_id = 0;
        this.client_lastconnected = 0;
        this.client_flag_avatar = "";
        this.client_icon_id = 0;
        this.client_away_message = "";
        this.client_away = false;
        this.client_input_hardware = false;
        this.client_output_hardware = false;
        this.client_input_muted = false;
        this.client_output_muted = false;
        this.client_is_channel_commander = false;
        this.client_teaforum_id = 0;
        this.client_teaforum_name = "";
        this.client_talk_power = 0;
    }
}
class ClientEntry {
    constructor(clientId, clientName, properties = new ClientProperties()) {
        this.lastVariableUpdate = 0;
        this._speaking = false;
        this._properties = properties;
        this._properties.client_nickname = clientName;
        this._clientId = clientId;
        this.channelTree = null;
        this._channel = null;
    }
    set_audio_handle(handle) {
        if (this._audio_handle === handle)
            return;
        //TODO may ensure that the id is the same?
        this._audio_handle = handle;
        if (!handle) {
            this.speaking = false;
            return;
        }
        handle.callback_playback = () => this.speaking = true;
        handle.callback_stopped = () => this.speaking = false;
    }
    get_audio_handle() {
        return this._audio_handle;
    }
    get properties() {
        return this._properties;
    }
    currentChannel() { return this._channel; }
    clientNickName() { return this.properties.client_nickname; }
    clientUid() { return this.properties.client_unique_identifier; }
    clientId() { return this._clientId; }
    initializeListener() {
        if (this._listener_initialized)
            return;
        this._listener_initialized = true;
        this.tag.on('mouseup', event => {
            if (!this.channelTree.client_mover.is_active()) {
                this.channelTree.onSelect(this);
            }
        });
        this.tag.on('click', event => {
            console.log("I've been clicked!");
        });
        if (!(this instanceof LocalClientEntry) && !(this instanceof MusicClientEntry))
            this.tag.dblclick(event => {
                if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                    return;
                }
                this.chat(true).focus();
            });
        if (!settings.static(Settings.KEY_DISABLE_CONTEXT_MENU, false)) {
            this.tag.on("contextmenu", (event) => {
                event.preventDefault();
                if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                    (this.channelTree.currently_selected_context_callback || ((_) => null))(event);
                    return;
                }
                this.channelTree.onSelect(this, true);
                this.showContextMenu(event.pageX, event.pageY, () => { });
                return false;
            });
        }
        this.tag.on('mousedown', event => {
            if (event.which != 1)
                return; //Only the left button
            let clients = this.channelTree.currently_selected;
            if (ppt.key_pressed(ppt.SpecialKey.SHIFT)) {
                if (clients != this && !($.isArray(clients) && clients.indexOf(this) != -1))
                    clients = $.isArray(clients) ? [...clients, this] : [clients, this];
            }
            else {
                clients = this;
            }
            this.channelTree.client_mover.activate(clients, target => {
                if (!target)
                    return;
                for (const client of $.isArray(clients) ? clients : [clients]) {
                    if (target == client._channel)
                        continue;
                    const source = client._channel;
                    const self = this.channelTree.client.getClient();
                    this.channelTree.client.serverConnection.send_command("clientmove", {
                        clid: client.clientId(),
                        cid: target.getChannelId()
                    }).then(event => {
                        if (client.clientId() == this.channelTree.client.clientId)
                            this.channelTree.client.sound.play(Sound.CHANNEL_JOINED);
                        else if (target !== source && target != self.currentChannel())
                            this.channelTree.client.sound.play(Sound.USER_MOVED);
                    });
                }
                this.channelTree.onSelect();
            }, event);
        });
    }
    assignment_context() {
        let server_groups = [];
        for (let group of this.channelTree.client.groups.serverGroups.sort(GroupManager.sorter())) {
            if (group.type != GroupType.NORMAL)
                continue;
            let entry = {};
            {
                let tag = $.spawn("label").addClass("checkbox");
                $.spawn("input").attr("type", "checkbox").prop("checked", this.groupAssigned(group)).appendTo(tag);
                $.spawn("span").addClass("checkmark").appendTo(tag);
                entry.icon = tag;
            }
            entry.name = group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]";
            if (this.groupAssigned(group)) {
                entry.callback = () => {
                    this.channelTree.client.serverConnection.send_command("servergroupdelclient", {
                        sgid: group.id,
                        cldbid: this.properties.client_database_id
                    });
                };
                entry.disabled = !this.channelTree.client.permissions.neededPermission(PermissionType.I_GROUP_MEMBER_ADD_POWER).granted(group.requiredMemberRemovePower);
            }
            else {
                entry.callback = () => {
                    this.channelTree.client.serverConnection.send_command("servergroupaddclient", {
                        sgid: group.id,
                        cldbid: this.properties.client_database_id
                    });
                };
                entry.disabled = !this.channelTree.client.permissions.neededPermission(PermissionType.I_GROUP_MEMBER_REMOVE_POWER).granted(group.requiredMemberAddPower);
            }
            entry.type = MenuEntryType.ENTRY;
            server_groups.push(entry);
        }
        let channel_groups = [];
        for (let group of this.channelTree.client.groups.channelGroups.sort(GroupManager.sorter())) {
            if (group.type != GroupType.NORMAL)
                continue;
            let entry = {};
            {
                let tag = $.spawn("label").addClass("checkbox");
                $.spawn("input").attr("type", "checkbox").prop("checked", this.assignedChannelGroup() == group.id).appendTo(tag);
                $.spawn("span").addClass("checkmark").appendTo(tag);
                entry.icon = tag;
            }
            entry.name = group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]";
            entry.callback = () => {
                this.channelTree.client.serverConnection.send_command("setclientchannelgroup", {
                    cldbid: this.properties.client_database_id,
                    cgid: group.id,
                    cid: this.currentChannel().channelId
                });
            };
            entry.disabled = !this.channelTree.client.permissions.neededPermission(PermissionType.I_GROUP_MEMBER_ADD_POWER).granted(group.requiredMemberRemovePower);
            entry.type = MenuEntryType.ENTRY;
            channel_groups.push(entry);
        }
        return [{
                type: MenuEntryType.SUB_MENU,
                icon: "client-permission_server_groups",
                name: _translations.dcA0kTll || (_translations.dcA0kTll = tr("Set server group")),
                sub_menu: [
                    {
                        type: MenuEntryType.ENTRY,
                        icon: "client-permission_server_groups",
                        name: "Server groups dialog",
                        callback: () => {
                            Modals.createServerGroupAssignmentModal(this, (group, flag) => {
                                if (flag) {
                                    return this.channelTree.client.serverConnection.send_command("servergroupaddclient", {
                                        sgid: group.id,
                                        cldbid: this.properties.client_database_id
                                    }).then(result => true);
                                }
                                else
                                    return this.channelTree.client.serverConnection.send_command("servergroupdelclient", {
                                        sgid: group.id,
                                        cldbid: this.properties.client_database_id
                                    }).then(result => true);
                            });
                        }
                    },
                    MenuEntry.HR(),
                    ...server_groups
                ]
            }, {
                type: MenuEntryType.SUB_MENU,
                icon: "client-permission_channel",
                name: _translations.CxdwSpDd || (_translations.CxdwSpDd = tr("Set channel group")),
                sub_menu: [
                    ...channel_groups
                ]
            }, {
                type: MenuEntryType.SUB_MENU,
                icon: "client-permission_client",
                name: _translations.Lti8UbaV || (_translations.Lti8UbaV = tr("Permissions")),
                disabled: true,
                sub_menu: []
            }];
    }
    showContextMenu(x, y, on_close = undefined) {
        let trigger_close = true;
        spawn_context_menu(x, y, {
            type: MenuEntryType.ENTRY,
            name: _translations.wbOesMC5 || (_translations.wbOesMC5 = tr("Show client info")),
            callback: () => {
                trigger_close = false;
                this.channelTree.client.select_info.open_popover();
            },
            icon: "client-about",
            visible: this.channelTree.client.select_info.is_popover()
        }, {
            type: MenuEntryType.HR,
            visible: this.channelTree.client.select_info.is_popover(),
            name: ''
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-change_nickname",
            name: _translations.B_eP8M45 || (_translations.B_eP8M45 = tr("<b>Open text chat</b>")),
            callback: () => {
                this.channelTree.client.chat.activeChat = this.chat(true);
                this.channelTree.client.chat.focus();
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-poke",
            name: _translations.xWBM4786 || (_translations.xWBM4786 = tr("Poke client")),
            callback: () => {
                createInputModal(_translations.cFYFWmlh || (_translations.cFYFWmlh = tr("Poke client")), _translations.eucIyoOu || (_translations.eucIyoOu = tr("Poke message:<br>")), text => true, result => {
                    if (typeof (result) === "string") {
                        //TODO tr
                        console.log("Poking client " + this.clientNickName() + " with message " + result);
                        this.channelTree.client.serverConnection.send_command("clientpoke", {
                            clid: this.clientId(),
                            msg: result
                        });
                    }
                }, { width: 400, maxLength: 512 }).open();
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-edit",
            name: _translations.GIdgNXOZ || (_translations.GIdgNXOZ = tr("Change description")),
            callback: () => {
                createInputModal(_translations.tyXGRXaP || (_translations.tyXGRXaP = tr("Change client description")), _translations.HJeZEV0R || (_translations.HJeZEV0R = tr("New description:<br>")), text => true, result => {
                    if (typeof (result) === "string") {
                        //TODO tr
                        console.log("Changing " + this.clientNickName() + "'s description to " + result);
                        this.channelTree.client.serverConnection.send_command("clientedit", {
                            clid: this.clientId(),
                            client_description: result
                        });
                    }
                }, { width: 400, maxLength: 1024 }).open();
            }
        }, MenuEntry.HR(), ...this.assignment_context(), MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-move_client_to_own_channel",
            name: _translations.o2X97wNF || (_translations.o2X97wNF = tr("Move client to your channel")),
            callback: () => {
                this.channelTree.client.serverConnection.send_command("clientmove", {
                    clid: this.clientId(),
                    cid: this.channelTree.client.getClient().currentChannel().getChannelId()
                });
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-kick_channel",
            name: _translations.rvDFMPYb || (_translations.rvDFMPYb = tr("Kick client from channel")),
            callback: () => {
                createInputModal(_translations.g4JkrXI9 || (_translations.g4JkrXI9 = tr("Kick client from channel")), _translations.VTGgSH0B || (_translations.VTGgSH0B = tr("Kick reason:<br>")), text => true, result => {
                    if (typeof (result) !== 'boolean' || result) {
                        //TODO tr
                        console.log("Kicking client " + this.clientNickName() + " from channel with reason " + result);
                        this.channelTree.client.serverConnection.send_command("clientkick", {
                            clid: this.clientId(),
                            reasonid: ViewReasonId.VREASON_CHANNEL_KICK,
                            reasonmsg: result
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-kick_server",
            name: _translations.yzNfX7Da || (_translations.yzNfX7Da = tr("Kick client fom server")),
            callback: () => {
                createInputModal(_translations.VBSHgpQY || (_translations.VBSHgpQY = tr("Kick client from server")), _translations.z53uB9YR || (_translations.z53uB9YR = tr("Kick reason:<br>")), text => true, result => {
                    if (typeof (result) !== 'boolean' || result) {
                        //TODO tr
                        console.log("Kicking client " + this.clientNickName() + " from server with reason " + result);
                        this.channelTree.client.serverConnection.send_command("clientkick", {
                            clid: this.clientId(),
                            reasonid: ViewReasonId.VREASON_SERVER_KICK,
                            reasonmsg: result
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-ban_client",
            name: _translations.evpkuEFw || (_translations.evpkuEFw = tr("Ban client")),
            invalidPermission: !this.channelTree.client.permissions.neededPermission(PermissionType.I_CLIENT_BAN_MAX_BANTIME).granted(1),
            callback: () => {
                Modals.spawnBanClient(this.properties.client_nickname, (data) => {
                    this.channelTree.client.serverConnection.send_command("banclient", {
                        uid: this.properties.client_unique_identifier,
                        banreason: data.reason,
                        time: data.length
                    }, {
                        flagset: [data.no_ip ? "no-ip" : "", data.no_hwid ? "no-hardware-id" : "", data.no_name ? "no-nickname" : ""]
                    }).then(() => {
                        this.channelTree.client.sound.play(Sound.USER_BANNED);
                    });
                });
            }
        }, MenuEntry.HR(), 
        /*
        {
            type: MenuEntryType.ENTRY,
            icon: "client-kick_server",
            name: "Add group to client",
            invalidPermission: true, //!this.channelTree.client.permissions.neededPermission(PermissionType.I_CLIENT_BAN_MAX_BANTIME).granted(1),
            callback: () => {
                Modals.spawnBanClient(this.properties.client_nickname, (duration, reason) => {
                    this.channelTree.client.serverConnection.send_command("banclient", {
                        uid: this.properties.client_unique_identifier,
                        banreason: reason,
                        time: duration
                    });
                });
            }
        },
        MenuEntry.HR(),
        */
        {
            type: MenuEntryType.ENTRY,
            icon: "client-volume",
            name: _translations.f5GNSKXV || (_translations.f5GNSKXV = tr("Change Volume")),
            callback: () => {
                Modals.spawnChangeVolume(this._audio_handle.get_volume(), volume => {
                    this.channelTree.client.settings.changeServer("volume_client_" + this.clientUid(), volume);
                    this._audio_handle.set_volume(volume);
                    if (this.channelTree.client.select_info.currentSelected == this)
                        this.channelTree.client.select_info.update();
                });
            }
        }, MenuEntry.CLOSE(() => (trigger_close ? on_close : () => { })()));
    }
    get tag() {
        if (this._tag)
            return this._tag;
        let container_client = $.spawn("div")
            .addClass("tree-entry client")
            .attr("client-id", this.clientId());
        container_client.append($.spawn("div")
            .addClass("icon_client_state")
            .attr("title", "Client state"));
        container_client.append($.spawn("div")
            .addClass("group-prefix")
            .attr("title", "Server groups prefixes")
            .hide());
        container_client.append($.spawn("div")
            .addClass("client-name")
            .text(this.clientNickName()));
        container_client.append($.spawn("div")
            .addClass("group-suffix")
            .attr("title", "Server groups suffix")
            .hide());
        container_client.append($.spawn("div")
            .addClass("client-away-message")
            .text(this.clientNickName()));
        let container_icons = $.spawn("div").addClass("container-icons");
        container_icons.append($.spawn("div")
            .addClass("icon icon_talk_power client-input_muted")
            .hide());
        container_icons.append($.spawn("div")
            .addClass("container-icons-group"));
        container_icons.append($.spawn("div")
            .addClass("container-icon-client"));
        container_client.append(container_icons);
        this._tag = container_client;
        this.initializeListener();
        return this._tag;
    }
    static bbcodeTag(id, name, uid) {
        return "[url=client://" + id + "/" + uid + "~" + encodeURIComponent(name) + "]" + name + "[/url]";
    }
    static chatTag(id, name, uid, braces = false) {
        return $(htmltags.generate_client({
            client_name: name,
            client_id: id,
            client_unique_id: uid,
            add_braces: braces
        }));
    }
    create_bbcode() {
        return ClientEntry.bbcodeTag(this.clientId(), this.clientNickName(), this.clientUid());
    }
    createChatTag(braces = false) {
        return ClientEntry.chatTag(this.clientId(), this.clientNickName(), this.clientUid(), braces);
    }
    set speaking(flag) {
        if (flag == this._speaking)
            return;
        this._speaking = flag;
        this.updateClientSpeakIcon();
    }
    updateClientStatusIcons() {
        let talk_power = this.properties.client_talk_power >= this._channel.properties.channel_needed_talk_power;
        if (talk_power)
            this.tag.find(".icon_talk_power").hide();
        else
            this.tag.find(".icon_talk_power").show();
    }
    updateClientSpeakIcon() {
        let icon = "";
        let clicon = "";
        if (this.properties.client_type_exact == ClientType.CLIENT_QUERY) {
            icon = "client-server_query";
            console.log("Server query!");
        }
        else {
            if (this.properties.client_away) {
                icon = "client-away";
            }
            else if (!this.properties.client_output_hardware) {
                icon = "client-hardware_output_muted";
            }
            else if (this.properties.client_output_muted) {
                icon = "client-output_muted";
            }
            else if (!this.properties.client_input_hardware) {
                icon = "client-hardware_input_muted";
            }
            else if (this.properties.client_input_muted) {
                icon = "client-input_muted";
            }
            else {
                if (this._speaking) {
                    if (this.properties.client_is_channel_commander)
                        clicon = "client_cc_talk";
                    else
                        clicon = "client_talk";
                }
                else {
                    if (this.properties.client_is_channel_commander)
                        clicon = "client_cc_idle";
                    else
                        clicon = "client_idle";
                }
            }
        }
        if (clicon.length > 0)
            this.tag.find(".icon_client_state").attr('class', 'icon_client_state clicon ' + clicon);
        else if (icon.length > 0)
            this.tag.find(".icon_client_state").attr('class', 'icon_client_state icon ' + icon);
        else
            this.tag.find(".icon_client_state").attr('class', 'icon_client_state icon_empty');
    }
    updateAwayMessage() {
        let tag = this.tag.find(".client-away-message");
        if (this.properties.client_away == true && this.properties.client_away_message) {
            tag.text("[" + this.properties.client_away_message + "]");
            tag.show();
        }
        else {
            tag.hide();
        }
    }
    updateVariables(...variables) {
        let group = log.group(log.LogType.DEBUG, LogCategory.CLIENT, _translations.V0lmIPQ0 || (_translations.V0lmIPQ0 = tr("Update properties (%i) of %s (%i)")), variables.length, this.clientNickName(), this.clientId());
        let update_icon_status = false;
        let update_icon_speech = false;
        let update_away = false;
        let reorder_channel = false;
        {
            const entries = [];
            for (const variable of variables)
                entries.push({
                    key: variable.key,
                    value: variable.value,
                    type: typeof (this.properties[variable.key])
                });
            log.table("Client update properties", entries);
        }
        for (const variable of variables) {
            JSON.map_field_to(this._properties, variable.value, variable.key);
            if (variable.key == "client_nickname") {
                this.tag.find(".client-name").text(variable.value);
                let chat = this.chat(false);
                if (chat)
                    chat.name = variable.value;
                reorder_channel = true;
            }
            if (variable.key == "client_away" ||
                variable.key == "client_input_hardware" ||
                variable.key == "client_output_hardware" ||
                variable.key == "client_output_muted" ||
                variable.key == "client_input_muted" ||
                variable.key == "client_is_channel_commander") {
                update_icon_speech = true;
            }
            if (variable.key == "client_away_message" || variable.key == "client_away") {
                update_away = true;
            }
            if (variable.key == "client_unique_identifier") {
                if (this._audio_handle) {
                    const volume = parseFloat(this.channelTree.client.settings.server("volume_client_" + this.clientUid(), "1"));
                    this._audio_handle.set_volume(volume);
                    log.debug(LogCategory.CLIENT, _translations.j0Qjz1Kb || (_translations.j0Qjz1Kb = tr("Loaded client volume %d for client %s from config.")), volume, this.clientUid());
                }
                else {
                    log.warn(LogCategory.CLIENT, _translations.SkMpd9DI || (_translations.SkMpd9DI = tr("Visible client got unique id assigned, but hasn't yet an audio handle. Ignoring volume assignment.")));
                }
            }
            if (variable.key == "client_talk_power") {
                reorder_channel = true;
                update_icon_status = true;
            }
            if (variable.key == "client_icon_id") {
                /* yeah we like javascript. Due to JS wiered integer behaviour parsing for example fails for 18446744073409829863.
                *  parseInt("18446744073409829863") evaluates to  18446744073409829000.
                *  In opposite "18446744073409829863" >>> 0 evaluates to 3995244544, which is the icon id :)
                */
                this.properties.client_icon_id = variable.value >>> 0;
                this.updateClientIcon();
            }
            if (variable.key == "client_channel_group_id" || variable.key == "client_servergroups")
                this.update_displayed_client_groups();
        }
        /* process updates after variables have been set */
        if (this._channel && reorder_channel)
            this._channel.reorderClients();
        if (update_icon_speech)
            this.updateClientSpeakIcon();
        if (update_icon_status)
            this.updateClientStatusIcons();
        if (update_away)
            this.updateAwayMessage();
        group.end();
    }
    update_displayed_client_groups() {
        this.tag.find(".container-icons-group").children().detach();
        for (let id of this.assignedServerGroupIds())
            this.updateGroupIcon(this.channelTree.client.groups.serverGroup(id));
        this.updateGroupIcon(this.channelTree.client.groups.channelGroup(this.properties.client_channel_group_id));
        let prefix_groups = [];
        let suffix_groups = [];
        for (const group_id of this.assignedServerGroupIds()) {
            const group = this.channelTree.client.groups.serverGroup(group_id);
            if (!group)
                continue;
            if (group.properties.namemode == 1)
                prefix_groups.push(group.name);
            else if (group.properties.namemode == 2)
                suffix_groups.push(group.name);
        }
        const tag_group_prefix = this.tag.find(".group-prefix");
        const tag_group_suffix = this.tag.find(".group-suffix");
        if (prefix_groups.length > 0) {
            tag_group_prefix.text("[" + prefix_groups.join("][") + "]").show();
        }
        else {
            tag_group_prefix.hide();
        }
        if (suffix_groups.length > 0) {
            tag_group_suffix.text("[" + suffix_groups.join("][") + "]").show();
        }
        else {
            tag_group_suffix.hide();
        }
    }
    updateClientVariables() {
        if (this.lastVariableUpdate == 0 || new Date().getTime() - 10 * 60 * 1000 > this.lastVariableUpdate) { //Cache these only 10 min
            this.lastVariableUpdate = new Date().getTime();
            this.channelTree.client.serverConnection.send_command("clientgetvariables", { clid: this.clientId() });
        }
    }
    chat(create = false) {
        let chatName = "client_" + this.clientUid() + ":" + this.clientId();
        let chat = this.channelTree.client.chat.findChat(chatName);
        if (!chat && create) {
            chat = this.channelTree.client.chat.createChat(chatName);
            chat.flag_closeable = true;
            chat.name = this.clientNickName();
            chat.owner_unique_id = this.properties.client_unique_identifier;
            chat.onMessageSend = text => {
                this.channelTree.client.serverConnection.command_helper.sendMessage(text, ChatType.CLIENT, this);
            };
            chat.onClose = () => {
                if (!chat.flag_offline)
                    this.channelTree.client.serverConnection.send_command("clientchatclosed", { "clid": this.clientId() }, { process_result: false }).catch(error => {
                        log.warn(LogCategory.GENERAL, _translations.U26KC2Ss || (_translations.U26KC2Ss = tr("Failed to notify chat participant (%o) that the chat has been closed. Error: %o")), this, error);
                    });
                return true;
            };
        }
        return chat;
    }
    updateClientIcon() {
        this.tag.find(".container-icon-client").children().detach();
        if (this.properties.client_icon_id > 0) {
            this.channelTree.client.fileManager.icons.generateTag(this.properties.client_icon_id).attr("title", "Client icon")
                .appendTo(this.tag.find(".container-icon-client"));
        }
    }
    updateGroupIcon(group) {
        if (!group)
            return;
        //TODO group icon order
        this.tag.find(".container-icons-group .icon_group_" + group.id).detach();
        if (group.properties.iconid > 0) {
            this.tag.find(".container-icons-group").append($.spawn("div")
                .addClass("container-group-icon icon_group_" + group.id)
                .append(this.channelTree.client.fileManager.icons.generateTag(group.properties.iconid)).attr("title", group.name));
        }
    }
    assignedServerGroupIds() {
        let result = [];
        for (let id of this.properties.client_servergroups.split(",")) {
            if (id.length == 0)
                continue;
            result.push(Number.parseInt(id));
        }
        return result;
    }
    assignedChannelGroup() {
        return this.properties.client_channel_group_id;
    }
    groupAssigned(group) {
        if (group.target == GroupTarget.SERVER) {
            for (let id of this.assignedServerGroupIds())
                if (id == group.id)
                    return true;
            return false;
        }
        else
            return group.id == this.assignedChannelGroup();
    }
    onDelete() { }
    calculateOnlineTime() {
        return Date.now() / 1000 - this.properties.client_lastconnected;
    }
    avatarId() {
        function str2ab(str) {
            let buf = new ArrayBuffer(str.length); // 2 bytes for each char
            let bufView = new Uint8Array(buf);
            for (let i = 0, strLen = str.length; i < strLen; i++) {
                bufView[i] = str.charCodeAt(i);
            }
            return buf;
        }
        try {
            let raw = atob(this.properties.client_unique_identifier);
            let input = hex.encode(str2ab(raw));
            let result = "";
            for (let index = 0; index < input.length; index++) {
                let c = input.charAt(index);
                let offset = 0;
                if (c >= '0' && c <= '9')
                    offset = c.charCodeAt(0) - '0'.charCodeAt(0);
                else if (c >= 'A' && c <= 'F')
                    offset = c.charCodeAt(0) - 'A'.charCodeAt(0) + 0x0A;
                else if (c >= 'a' && c <= 'f')
                    offset = c.charCodeAt(0) - 'a'.charCodeAt(0) + 0x0A;
                result += String.fromCharCode('a'.charCodeAt(0) + offset);
            }
            return result;
        }
        catch (e) { //invalid base 64 (like music bot etc)
            return undefined;
        }
    }
    update_family_index() {
        if (!this._channel)
            return;
        const index = this._channel.calculate_family_index();
        this.tag.css('padding-left', (index + 2) * 16 + "px");
    }
}
class LocalClientEntry extends ClientEntry {
    constructor(handle) {
        super(0, "local client");
        this.handle = handle;
    }
    showContextMenu(x, y, on_close = undefined) {
        const _self = this;
        spawn_context_menu(x, y, {
            name: _translations.wB4JtPCT || (_translations.wB4JtPCT = tr("<b>Change name</b>")),
            icon: "client-change_nickname",
            callback: () => _self.openRename(),
            type: MenuEntryType.ENTRY
        }, {
            name: _translations.ynq6IOYx || (_translations.ynq6IOYx = tr("Change description")),
            icon: "client-edit",
            callback: () => {
                createInputModal(_translations.rWzGIlKo || (_translations.rWzGIlKo = tr("Change own description")), _translations.ITWWlms3 || (_translations.ITWWlms3 = tr("New description:<br>")), text => true, result => {
                    if (result) {
                        console.log(_translations.rSJ23NIR || (_translations.rSJ23NIR = tr("Changing own description to %s")), result);
                        _self.channelTree.client.serverConnection.send_command("clientedit", {
                            clid: _self.clientId(),
                            client_description: result
                        });
                    }
                }, { width: 400, maxLength: 1024 }).open();
            },
            type: MenuEntryType.ENTRY
        }, MenuEntry.HR(), ...this.assignment_context(), MenuEntry.CLOSE(on_close));
    }
    initializeListener() {
        super.initializeListener();
        this.tag.find(".client-name").addClass("client-name-own");
        this.tag.dblclick(() => {
            if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                return;
            }
            this.openRename();
        });
    }
    openRename() {
        const _self = this;
        this.channelTree.client_mover.enabled = false;
        const elm = this.tag.find(".client-name");
        elm.attr("contenteditable", "true");
        elm.removeClass("client-name-own");
        elm.css("background-color", "white");
        elm.focus();
        _self.renaming = true;
        elm.keypress(function (e) {
            if (e.keyCode == KeyCode.KEY_RETURN) {
                $(this).trigger("focusout");
                return false;
            }
        });
        elm.focusout(e => {
            this.channelTree.client_mover.enabled = true;
            if (!_self.renaming)
                return;
            _self.renaming = false;
            elm.css("background-color", "");
            elm.removeAttr("contenteditable");
            elm.addClass("client-name-own");
            let text = elm.text().toString();
            if (_self.clientNickName() == text)
                return;
            elm.text(_self.clientNickName());
            _self.handle.serverConnection.command_helper.updateClient("client_nickname", text).then((e) => {
                settings.changeGlobal(Settings.KEY_CONNECT_USERNAME, text);
                this.channelTree.client.chat.serverChat().appendMessage(_translations.XI7csXq6 || (_translations.XI7csXq6 = tr("Nickname successfully changed")));
            }).catch((e) => {
                this.channelTree.client.chat.serverChat().appendError(_translations.T7guya8x || (_translations.T7guya8x = tr("Could not change nickname ({})")), e.extra_message);
                _self.openRename();
            });
        });
    }
}
class MusicClientProperties extends ClientProperties {
    constructor() {
        super(...arguments);
        this.player_state = 0;
        this.player_volume = 0;
        this.client_playlist_id = 0;
        this.client_disabled = false;
    }
}
class MusicClientPlayerInfo {
    constructor() {
        this.bot_id = 0;
        this.player_state = 0;
        this.player_buffered_index = 0;
        this.player_replay_index = 0;
        this.player_max_index = 0;
        this.player_seekable = false;
        this.player_title = "";
        this.player_description = "";
        this.song_id = 0;
        this.song_url = "";
        this.song_invoker = 0;
        this.song_loaded = false;
        this.song_title = "";
        this.song_thumbnail = "";
        this.song_length = 0;
    }
}
class MusicClientEntry extends ClientEntry {
    constructor(clientId, clientName) {
        super(clientId, clientName, new MusicClientProperties());
        this._info_promise_age = 0;
    }
    get properties() {
        return this._properties;
    }
    showContextMenu(x, y, on_close = undefined) {
        let trigger_close = true;
        spawn_context_menu(x, y, {
            type: MenuEntryType.ENTRY,
            name: _translations.UJNTJOOv || (_translations.UJNTJOOv = tr("Show bot info")),
            callback: () => {
                trigger_close = false;
                this.channelTree.client.select_info.open_popover();
            },
            icon: "client-about",
            visible: this.channelTree.client.select_info.is_popover()
        }, {
            type: MenuEntryType.HR,
            visible: this.channelTree.client.select_info.is_popover(),
            name: ''
        }, {
            name: _translations.PKjjpv6N || (_translations.PKjjpv6N = tr("<b>Change bot name</b>")),
            icon: "client-change_nickname",
            disabled: false,
            callback: () => {
                createInputModal(_translations.CVclUzQS || (_translations.CVclUzQS = tr("Change music bots nickname")), _translations.ksLK51Yw || (_translations.ksLK51Yw = tr("New nickname:<br>")), text => text.length >= 3 && text.length <= 31, result => {
                    if (result) {
                        this.channelTree.client.serverConnection.send_command("clientedit", {
                            clid: this.clientId(),
                            client_nickname: result
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            },
            type: MenuEntryType.ENTRY
        }, {
            name: _translations.ScmrgG8i || (_translations.ScmrgG8i = tr("Change bot description")),
            icon: "client-edit",
            disabled: false,
            callback: () => {
                createInputModal(_translations.nx08C8rd || (_translations.nx08C8rd = tr("Change music bots description")), _translations.ca5Ihski || (_translations.ca5Ihski = tr("New description:<br>")), text => true, result => {
                    if (typeof (result) === 'string') {
                        this.channelTree.client.serverConnection.send_command("clientedit", {
                            clid: this.clientId(),
                            client_description: result
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            },
            type: MenuEntryType.ENTRY
        }, 
        /*
        {
            name: tr("Open music panel"),
            icon: "client-edit",
            disabled: true,
            callback: () => {},
            type: MenuEntryType.ENTRY
        },
        */
        {
            name: _translations.QkER2pmt || (_translations.QkER2pmt = tr("Open bot's playlist")),
            icon: "client-edit",
            disabled: false,
            callback: () => {
                this.channelTree.client.serverConnection.command_helper.request_playlist_list().then(lists => {
                    for (const entry of lists) {
                        if (entry.playlist_id == this.properties.client_playlist_id) {
                            Modals.spawnPlaylistEdit(this.channelTree.client, entry);
                            return;
                        }
                    }
                    createErrorModal(_translations.E8E_2obC || (_translations.E8E_2obC = tr("Invalid permissions")), _translations.brEdJN45 || (_translations.brEdJN45 = tr("You dont have to see the bots playlist."))).open();
                }).catch(error => {
                    createErrorModal(_translations.WN6Ci4jW || (_translations.WN6Ci4jW = tr("Failed to query playlist.")), _translations.ejhsGCiv || (_translations.ejhsGCiv = tr("Failed to query playlist info."))).open();
                });
            },
            type: MenuEntryType.ENTRY
        }, {
            name: _translations.bbnBOQXT || (_translations.bbnBOQXT = tr("Quick url replay")),
            icon: "client-edit",
            disabled: false,
            callback: () => {
                createInputModal(_translations.pqw8NKxG || (_translations.pqw8NKxG = tr("Please enter the URL")), _translations.fqTJs80S || (_translations.fqTJs80S = tr("URL:")), text => true, result => {
                    if (result) {
                        this.channelTree.client.serverConnection.send_command("musicbotqueueadd", {
                            bot_id: this.properties.client_database_id,
                            type: "yt",
                            url: result
                        }).catch(error => {
                            if (error instanceof CommandResult) {
                                error = error.extra_message || error.message;
                            }
                            //TODO tr
                            createErrorModal(_translations.J9vszfk_ || (_translations.J9vszfk_ = tr("Failed to replay url")), "Failed to enqueue url:<br>" + error).open();
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            },
            type: MenuEntryType.ENTRY
        }, MenuEntry.HR(), ...super.assignment_context(), MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-move_client_to_own_channel",
            name: _translations.yFmz7Vd2 || (_translations.yFmz7Vd2 = tr("Move client to your channel")),
            callback: () => {
                this.channelTree.client.serverConnection.send_command("clientmove", {
                    clid: this.clientId(),
                    cid: this.channelTree.client.getClient().currentChannel().getChannelId()
                });
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-kick_channel",
            name: _translations.wCjAmI5l || (_translations.wCjAmI5l = tr("Kick client from channel")),
            callback: () => {
                createInputModal(_translations.H99KnPv2 || (_translations.H99KnPv2 = tr("Kick client from channel")), _translations.c7kZyuPs || (_translations.c7kZyuPs = tr("Kick reason:<br>")), text => true, result => {
                    if (typeof (result) !== 'boolean' || result) {
                        console.log(_translations.kS2rtqHz || (_translations.kS2rtqHz = tr("Kicking client %o from channel with reason %o")), this.clientNickName(), result);
                        this.channelTree.client.serverConnection.send_command("clientkick", {
                            clid: this.clientId(),
                            reasonid: ViewReasonId.VREASON_CHANNEL_KICK,
                            reasonmsg: result
                        });
                    }
                }, { width: 400, maxLength: 255 }).open();
            }
        }, MenuEntry.HR(), {
            type: MenuEntryType.ENTRY,
            icon: "client-volume",
            name: _translations.Ya5QMCsu || (_translations.Ya5QMCsu = tr("Change local volume")),
            callback: () => {
                Modals.spawnChangeVolume(this._audio_handle.get_volume(), volume => {
                    this.channelTree.client.settings.changeServer("volume_client_" + this.clientUid(), volume);
                    this._audio_handle.set_volume(volume);
                    if (this.channelTree.client.select_info.currentSelected == this)
                        this.channelTree.client.select_info.current_manager().update_local_volume(volume);
                });
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-volume",
            name: _translations.QW29mGyf || (_translations.QW29mGyf = tr("Change remote volume")),
            callback: () => {
                let max_volume = this.channelTree.client.permissions.neededPermission(PermissionType.I_CLIENT_MUSIC_CREATE_MODIFY_MAX_VOLUME).value;
                if (max_volume < 0)
                    max_volume = 100;
                Modals.spawnChangeRemoteVolume(this.properties.player_volume, max_volume / 100, value => {
                    if (typeof (value) !== "number")
                        return;
                    this.channelTree.client.serverConnection.send_command("clientedit", {
                        clid: this.clientId(),
                        player_volume: value,
                    }).then(() => {
                        if (this.channelTree.client.select_info.currentSelected == this)
                            this.channelTree.client.select_info.current_manager().update_remote_volume(value);
                    });
                });
            }
        }, MenuEntry.HR(), {
            name: _translations.sL3Q72sz || (_translations.sL3Q72sz = tr("Delete bot")),
            icon: "client-delete",
            disabled: false,
            callback: () => {
                const tag = $.spawn("div").append(MessageHelper.formatMessage(_translations.jCVebDGW || (_translations.jCVebDGW = tr("Do you really want to delete {0}")), this.createChatTag(false)));
                Modals.spawnYesNo(_translations.O6ZylGXm || (_translations.O6ZylGXm = tr("Are you sure?")), $.spawn("div").append(tag), result => {
                    if (result) {
                        this.channelTree.client.serverConnection.send_command("musicbotdelete", {
                            bot_id: this.properties.client_database_id
                        });
                    }
                });
            },
            type: MenuEntryType.ENTRY
        }, MenuEntry.CLOSE(() => (trigger_close ? on_close : () => { })()));
    }
    initializeListener() {
        super.initializeListener();
    }
    handlePlayerInfo(json) {
        if (json) {
            let info = JSON.map_to(new MusicClientPlayerInfo(), json);
            if (this._info_promise_resolve)
                this._info_promise_resolve(info);
            this._info_promise_reject = undefined;
        }
        if (this._info_promise) {
            if (this._info_promise_reject)
                this._info_promise_reject("timeout");
            this._info_promise = undefined;
            this._info_promise_age = undefined;
            this._info_promise_reject = undefined;
            this._info_promise_resolve = undefined;
        }
    }
    requestPlayerInfo(max_age = 1000) {
        if (this._info_promise && this._info_promise_age && Date.now() - max_age <= this._info_promise_age)
            return this._info_promise;
        this._info_promise_age = Date.now();
        this._info_promise = new Promise((resolve, reject) => {
            this._info_promise_reject = reject;
            this._info_promise_resolve = resolve;
        });
        this.channelTree.client.serverConnection.send_command("musicbotplayerinfo", { bot_id: this.properties.client_database_id });
        return this._info_promise;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["c8c31684c83b59f87cc784f6537fff86c90e864cec77ab33ff38c10015cfee45"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["c8c31684c83b59f87cc784f6537fff86c90e864cec77ab33ff38c10015cfee45"] = "c8c31684c83b59f87cc784f6537fff86c90e864cec77ab33ff38c10015cfee45";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "qudBz4Dc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (7,31)" }, { name: "JUzb7BfV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (7,52)" }, { name: "s3E1tv74", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (26,35)" }, { name: "EGvHoGHx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (29,31)" }, { name: "qAXasKDd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (53,56)" }, { name: "xm2CvX5Q", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (60,25)" }, { name: "mgwsglE5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (193,25)" }, { name: "jqFNXxKF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (205,56)" }, { name: "AWeR5y8C", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalCreateChannel.ts (212,33)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
var Modals;
(function (Modals) {
    function createChannelModal(connection, channel, parent, permissions, callback) {
        let properties = {}; //The changes properties
        const modal = createModal({
            header: channel ? _translations.qudBz4Dc || (_translations.qudBz4Dc = tr("Edit channel")) : _translations.JUzb7BfV || (_translations.JUzb7BfV = tr("Create channel")),
            body: () => {
                const render_properties = {};
                Object.assign(render_properties, channel ? channel.properties : {
                    channel_flag_maxfamilyclients_unlimited: true,
                    channel_flag_maxclients_unlimited: true,
                });
                render_properties["channel_icon_tab"] = connection.fileManager.icons.generateTag(channel ? channel.properties.channel_icon_id : 0);
                render_properties["channel_icon_general"] = connection.fileManager.icons.generateTag(channel ? channel.properties.channel_icon_id : 0);
                let template = $("#tmpl_channel_edit").renderTag(render_properties);
                return template.tabify();
            },
            footer: () => {
                let footer = $.spawn("div");
                footer.addClass("modal-button-group");
                footer.css("margin", "5px");
                let buttonCancel = $.spawn("button");
                buttonCancel.text(_translations.s3E1tv74 || (_translations.s3E1tv74 = tr("Cancel"))).addClass("button_cancel");
                let buttonOk = $.spawn("button");
                buttonOk.text(_translations.EGvHoGHx || (_translations.EGvHoGHx = tr("Ok"))).addClass("button_ok");
                footer.append(buttonCancel);
                footer.append(buttonOk);
                return footer;
            },
            width: 500
        });
        applyGeneralListener(connection, properties, modal.htmlTag.find(".general_properties"), modal.htmlTag.find(".button_ok"), channel);
        applyStandardListener(connection, properties, modal.htmlTag.find(".settings_standard"), modal.htmlTag.find(".button_ok"), parent, !channel);
        applyPermissionListener(connection, properties, modal.htmlTag.find(".settings_permissions"), modal.htmlTag.find(".button_ok"), permissions, channel);
        applyAudioListener(connection, properties, modal.htmlTag.find(".container-channel-settings-audio"), modal.htmlTag.find(".button_ok"), channel);
        applyAdvancedListener(connection, properties, modal.htmlTag.find(".settings_advanced"), modal.htmlTag.find(".button_ok"), channel);
        let updated = [];
        modal.htmlTag.find(".button_ok").click(() => {
            modal.htmlTag.find(".settings_permissions").find("input[permission]").each((index, _element) => {
                let element = $(_element);
                if (!element.prop("changed"))
                    return;
                let permission = permissions.resolveInfo(element.attr("permission"));
                if (!permission) {
                    log.error(LogCategory.PERMISSIONS, _translations.qAXasKDd || (_translations.qAXasKDd = tr("Failed to resolve channel permission for name %o")), element.attr("permission"));
                    element.prop("disabled", true);
                    return;
                }
                updated.push(new PermissionValue(permission, element.val()));
            });
            console.log(_translations.xm2CvX5Q || (_translations.xm2CvX5Q = tr("Updated permissions %o")), updated);
        }).click(() => {
            modal.close();
            callback(properties, updated); //First may create the channel
        });
        modal.htmlTag.find(".button_cancel").click(() => {
            modal.close();
            callback();
        });
        modal.open();
        if (!channel)
            modal.htmlTag.find(".channel_name").focus();
    }
    Modals.createChannelModal = createChannelModal;
    function applyGeneralListener(connection, properties, tag, button, channel) {
        let updateButton = () => {
            const status = tag.find(".input_error").length != 0;
            console.log("Disabled: %o", status);
            button.prop("disabled", status);
        };
        {
            const channel_name = tag.find(".channel_name");
            tag.find(".channel_name").on('change keyup', function () {
                properties.channel_name = this.value;
                channel_name.toggleClass("input_error", this.value.length < 1 || this.value.length > 40);
                updateButton();
            }).prop("disabled", channel && !connection.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_NAME).granted(1));
        }
        tag.find(".button-select-icon").on('click', event => {
            Modals.spawnIconSelect(connection, id => {
                const icon_node = tag.find(".button-select-icon").find(".icon-node");
                icon_node.empty();
                icon_node.append(connection.fileManager.icons.generateTag(id));
                console.log("Selected icon ID: %d", id);
                properties.channel_icon_id = id;
            }, channel ? channel.properties.channel_icon_id : 0);
        });
        {
            const channel_password = tag.find(".channel_password");
            tag.find(".channel_password").change(function () {
                properties.channel_flag_password = this.value.length != 0;
                if (properties.channel_flag_password)
                    helpers.hashPassword(this.value).then(pass => properties.channel_password = pass);
                channel_password.removeClass("input_error");
                if (!properties.channel_flag_password)
                    if (connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_FORCE_PASSWORD).granted(1))
                        channel_password.addClass("input_error");
                updateButton();
            }).prop("disabled", !connection.permissions.neededPermission(!channel ? PermissionType.B_CHANNEL_CREATE_WITH_PASSWORD : PermissionType.B_CHANNEL_MODIFY_PASSWORD).granted(1));
        }
        tag.find(".channel_topic").change(function () {
            properties.channel_topic = this.value;
        }).prop("disabled", !connection.permissions.neededPermission(!channel ? PermissionType.B_CHANNEL_CREATE_WITH_TOPIC : PermissionType.B_CHANNEL_MODIFY_TOPIC).granted(1));
        tag.find(".channel_description").change(function () {
            properties.channel_description = this.value;
        }).prop("disabled", !connection.permissions.neededPermission(!channel ? PermissionType.B_CHANNEL_CREATE_WITH_DESCRIPTION : PermissionType.B_CHANNEL_MODIFY_DESCRIPTION).granted(1));
        if (!channel) {
            setTimeout(() => {
                tag.find(".channel_name").trigger("change");
                tag.find(".channel_password").trigger('change');
            }, 0);
        }
    }
    function applyStandardListener(connection, properties, tag, button, parent, create) {
        tag.find("input[name=\"channel_type\"]").change(function () {
            switch (this.value) {
                case "semi":
                    properties.channel_flag_permanent = false;
                    properties.channel_flag_semi_permanent = true;
                    break;
                case "perm":
                    properties.channel_flag_permanent = true;
                    properties.channel_flag_semi_permanent = false;
                    break;
                default:
                    properties.channel_flag_permanent = false;
                    properties.channel_flag_semi_permanent = false;
                    break;
            }
        });
        tag.find("input[name=\"channel_type\"][value=\"temp\"]")
            .prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_TEMPORARY : PermissionType.B_CHANNEL_MODIFY_MAKE_TEMPORARY).granted(1));
        tag.find("input[name=\"channel_type\"][value=\"semi\"]")
            .prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_SEMI_PERMANENT : PermissionType.B_CHANNEL_MODIFY_MAKE_SEMI_PERMANENT).granted(1));
        tag.find("input[name=\"channel_type\"][value=\"perm\"]")
            .prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_PERMANENT : PermissionType.B_CHANNEL_MODIFY_MAKE_PERMANENT).granted(1));
        if (create)
            tag.find("input[name=\"channel_type\"]:not(:disabled)").last().prop("checked", true).trigger('change');
        tag.find("input[name=\"channel_default\"]").change(function () {
            console.log(this.checked);
            properties.channel_flag_default = this.checked;
            let elements = tag.find("input[name=\"channel_type\"]");
            elements.prop("disabled", this.checked);
            if (this.checked) {
                elements.prop("checked", false);
                tag.find("input[name=\"channel_type\"][value=\"perm\"]").prop("checked", true).trigger("change");
            }
        }).prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_PERMANENT : PermissionType.B_CHANNEL_MODIFY_MAKE_PERMANENT).granted(1) ||
            !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_WITH_DEFAULT : PermissionType.B_CHANNEL_MODIFY_MAKE_DEFAULT).granted(1));
        tag.find("input[name=\"talk_power\"]").change(function () {
            properties.channel_needed_talk_power = parseInt(this.value);
        }).prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_WITH_NEEDED_TALK_POWER : PermissionType.B_CHANNEL_MODIFY_NEEDED_TALK_POWER).granted(1));
        let orderTag = tag.find(".order_id");
        for (let channel of (parent ? parent.children() : connection.channelTree.rootChannel()))
            $.spawn("option").attr("channelId", channel.channelId.toString()).text(channel.channelName()).appendTo(orderTag);
        orderTag.change(function () {
            let selected = $(this.options.item(this.selectedIndex));
            properties.channel_order = parseInt(selected.attr("channelId"));
        }).prop("disabled", !connection.permissions.neededPermission(create ? PermissionType.B_CHANNEL_CREATE_WITH_SORTORDER : PermissionType.B_CHANNEL_MODIFY_SORTORDER).granted(1));
        orderTag.find("option").last().prop("selected", true);
    }
    function applyPermissionListener(connection, properties, tag, button, permissions, channel) {
        let apply_permissions = (channel_permissions) => {
            console.log(_translations.mgwsglE5 || (_translations.mgwsglE5 = tr("Got permissions: %o")), channel_permissions);
            let required_power = -2;
            for (let cperm of channel_permissions)
                if (cperm.type.name == PermissionType.I_CHANNEL_NEEDED_MODIFY_POWER) {
                    required_power = cperm.value;
                    break;
                }
            tag.find("input[permission]").each((index, _element) => {
                let element = $(_element);
                let permission = permissions.resolveInfo(element.attr("permission"));
                if (!permission) {
                    log.error(LogCategory.PERMISSIONS, _translations.jqFNXxKF || (_translations.jqFNXxKF = tr("Failed to resolve channel permission for name %o")), element.attr("permission"));
                    element.prop("disabled", true);
                    return;
                }
                let old_value = 0;
                element.on("click keyup", () => {
                    console.log(_translations.AWeR5y8C || (_translations.AWeR5y8C = tr("Permission triggered! %o")), element.val() != old_value);
                    element.prop("changed", element.val() != old_value);
                });
                for (let cperm of channel_permissions)
                    if (cperm.type == permission) {
                        element.val(old_value = cperm.value);
                        return;
                    }
                element.val(0);
            });
            if (!permissions.neededPermission(PermissionType.I_CHANNEL_MODIFY_POWER).granted(required_power, false)) {
                tag.find("input[permission]").prop("disabled", false); //No permissions
            }
        };
        if (channel) {
            permissions.requestChannelPermissions(channel.getChannelId()).then(apply_permissions).catch((error) => {
                tag.find("input[permission]").prop("disabled", true);
                console.log("Failed to receive channel permissions (%o)", error);
            });
        }
        else
            apply_permissions([]);
    }
    function applyAudioListener(connection, properties, tag, button, channel) {
        let update_template = () => {
            let codec = properties.channel_codec;
            if (!codec && channel)
                codec = channel.properties.channel_codec;
            if (!codec)
                return;
            let quality = properties.channel_codec_quality;
            if (!quality && channel)
                quality = channel.properties.channel_codec_quality;
            if (!quality)
                return;
            if (codec == 4 && quality == 4)
                tag.find("input[name=\"voice_template\"][value=\"voice_mobile\"]").prop("checked", true);
            else if (codec == 4 && quality == 6)
                tag.find("input[name=\"voice_template\"][value=\"voice_desktop\"]").prop("checked", true);
            else if (codec == 5 && quality == 6)
                tag.find("input[name=\"voice_template\"][value=\"music\"]").prop("checked", true);
            else
                tag.find("input[name=\"voice_template\"][value=\"custom\"]").prop("checked", true);
        };
        let change_codec = codec => {
            if (properties.channel_codec == codec)
                return;
            tag.find(".voice_codec option").prop("selected", false).eq(codec).prop("selected", true);
            properties.channel_codec = codec;
            update_template();
        };
        let quality_slider = tag.find(".voice_quality_slider");
        let quality_number = tag.find(".voice_quality_number");
        let change_quality = (quality) => {
            if (properties.channel_codec_quality == quality)
                return;
            properties.channel_codec_quality = quality;
            if (quality_slider.val() != quality)
                quality_slider.val(quality);
            if (parseInt(quality_number.text()) != quality)
                quality_number.text(quality);
            update_template();
        };
        tag.find("input[name=\"voice_template\"]").change(function () {
            switch (this.value) {
                case "custom":
                    break;
                case "music":
                    change_codec(5);
                    change_quality(6);
                    break;
                case "voice_desktop":
                    change_codec(4);
                    change_quality(6);
                    break;
                case "voice_mobile":
                    change_codec(4);
                    change_quality(4);
                    break;
            }
        });
        tag.find("input[name=\"voice_template\"][value=\"voice_mobile\"]")
            .prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSVOICE).granted(1));
        tag.find("input[name=\"voice_template\"][value=\"voice_desktop\"]")
            .prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSVOICE).granted(1));
        tag.find("input[name=\"voice_template\"][value=\"music\"]")
            .prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSMUSIC).granted(1));
        let codecs = tag.find(".voice_codec option");
        codecs.eq(0).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX8).granted(1));
        codecs.eq(1).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX16).granted(1));
        codecs.eq(2).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX32).granted(1));
        codecs.eq(3).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_CELTMONO48).granted(1));
        codecs.eq(4).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSVOICE).granted(1));
        codecs.eq(5).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSMUSIC).granted(1));
        tag.find(".voice_codec").change(function () {
            if ($(this.item(this.selectedIndex)).prop("disabled"))
                return false;
            change_codec(this.selectedIndex);
        });
        if (!channel) {
            change_codec(4);
            change_quality(6);
        }
        else {
            change_codec(channel.properties.channel_codec);
            change_quality(channel.properties.channel_codec_quality);
        }
        update_template();
        quality_slider.on('input', event => change_quality(parseInt(quality_slider.val())));
    }
    function applyAdvancedListener(connection, properties, tag, button, channel) {
        tag.find(".channel_name_phonetic").change(function () {
            properties.channel_topic = this.value;
        });
        tag.find(".channel_delete_delay").change(function () {
            properties.channel_delete_delay = parseInt(this.value);
        }).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_TEMP_DELETE_DELAY).granted(1));
        tag.find(".channel_codec_is_unencrypted").change(function () {
            properties.channel_codec_is_unencrypted = parseInt(this.value) == 0;
        }).prop("disabled", !connection.permissions.neededPermission(PermissionType.B_CHANNEL_MODIFY_MAKE_CODEC_ENCRYPTED).granted(1));
        {
            let tag_infinity = tag.find("input[name=\"max_users\"][value=\"infinity\"]");
            let tag_limited = tag.find("input[name=\"max_users\"][value=\"limited\"]");
            let tag_limited_value = tag.find(".channel_maxclients");
            if (!connection.permissions.neededPermission(!channel ? PermissionType.B_CHANNEL_CREATE_WITH_MAXCLIENTS : PermissionType.B_CHANNEL_MODIFY_MAXCLIENTS).granted(1)) {
                tag_infinity.prop("disabled", true);
                tag_limited.prop("disabled", true);
                tag_limited_value.prop("disabled", true);
            }
            else {
                tag.find("input[name=\"max_users\"]").change(function () {
                    console.log(this.value);
                    let infinity = this.value == "infinity";
                    tag_limited_value.prop("disabled", infinity);
                    properties.channel_flag_maxclients_unlimited = infinity;
                });
                tag_limited_value.change(event => properties.channel_maxclients = parseInt(tag_limited_value.val()));
                tag.find("input[name=\"max_users\"]:checked").trigger('change');
            }
        }
        {
            let tag_inherited = tag.find("input[name=\"max_users_family\"][value=\"inherited\"]");
            let tag_infinity = tag.find("input[name=\"max_users_family\"][value=\"infinity\"]");
            let tag_limited = tag.find("input[name=\"max_users_family\"][value=\"limited\"]");
            let tag_limited_value = tag.find(".channel_maxfamilyclients");
            if (!connection.permissions.neededPermission(!channel ? PermissionType.B_CHANNEL_CREATE_WITH_MAXCLIENTS : PermissionType.B_CHANNEL_MODIFY_MAXCLIENTS).granted(1)) {
                tag_inherited.prop("disabled", true);
                tag_infinity.prop("disabled", true);
                tag_limited.prop("disabled", true);
                tag_limited_value.prop("disabled", true);
            }
            else {
                tag.find("input[name=\"max_users_family\"]").change(function () {
                    console.log(this.value);
                    tag_limited_value.prop("disabled", this.value != "limited");
                    properties.channel_flag_maxfamilyclients_unlimited = this.value == "infinity";
                    properties.channel_flag_maxfamilyclients_inherited = this.value == "inherited";
                });
                tag_limited_value.change(event => properties.channel_maxfamilyclients = parseInt(tag_limited_value.val()));
                tag.find("input[name=\"max_users_family\"]:checked").trigger('change');
            }
        }
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["622c2f3731091601c8559588a83fc1e20c3595aaa795692bbb0ca55d9530d3c4"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["622c2f3731091601c8559588a83fc1e20c3595aaa795692bbb0ca55d9530d3c4"] = "622c2f3731091601c8559588a83fc1e20c3595aaa795692bbb0ca55d9530d3c4";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "txzdKD20", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (97,23)" }, { name: "hpmRs0ue", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (227,27)" }, { name: "MQvJY0re", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (309,45)" }, { name: "hSz_Or70", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (455,21)" }, { name: "KHU1gYH3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (458,21)" }, { name: "TBkeitSj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (463,21)" }, { name: "L9dCpuHj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (469,23)" }, { name: "uSB6rZxC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (471,38)" }, { name: "Hu49UTyC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (471,58)" }, { name: "HNFiSWVf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (487,19)" }, { name: "_pcdEcPQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (502,23)" }, { name: "dfSh4e1D", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (504,38)" }, { name: "XCzqC85A", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (504,71)" }, { name: "OyA8imQt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (522,27)" }, { name: "oY53uayE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (524,42)" }, { name: "ZU23lFOM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (524,74)" }, { name: "j4bN7u5K", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (539,27)" }, { name: "D56CBX4U", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (560,27)" }, { name: "qpNpnuMM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (566,90)" }, { name: "bUlZ7kOX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (568,43)" }, { name: "LQdmWKkv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (620,44)" }, { name: "EKzk40OR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (624,52)" }, { name: "aTLBXXJT", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (646,61)" }, { name: "CXRbtcqM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (793,34)" }, { name: "iPtA1BZQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (797,26)" }, { name: "Ex4qLn2h", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (814,34)" }, { name: "ST0BD1oa", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/view.ts (818,26)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../ConnectionHandler.ts" />
/// <reference path="../proto.ts" />
/// <reference path="channel.ts" />
/// <reference path="client.ts" />
/// <reference path="modal/ModalCreateChannel.ts" />
class ChannelTree {
    constructor(client) {
        this.currently_selected = undefined;
        this.currently_selected_context_callback = undefined;
        this._tree_detached = false;
        document.addEventListener("touchstart", function () { }, true);
        this.client = client;
        this._tag_container = $.spawn("div").addClass("channel-tree-container");
        this._tag_entries = $.spawn("div").addClass("channel-tree");
        this.client_mover = new ClientMover(this);
        this.reset();
        if (!settings.static(Settings.KEY_DISABLE_CONTEXT_MENU, false)) {
            this._tag_container.on("contextmenu", (event) => {
                if (event.isDefaultPrevented())
                    return;
                for (const element of document.elementsFromPoint(event.pageX, event.pageY))
                    if (element.classList.contains("channelLine") || element.classList.contains("client"))
                        return;
                event.preventDefault();
                if ($.isArray(this.currently_selected)) { //Multiselect
                    (this.currently_selected_context_callback || ((_) => null))(event);
                }
                else {
                    this.onSelect(undefined);
                    this.showContextMenu(event.pageX, event.pageY);
                }
            });
        }
        this._tag_container.on('resize', this.handle_resized.bind(this));
        /* TODO release these events again when ChannelTree get deinitialized */
        $(document).on('click', event => {
            if (this.selected_event != event.originalEvent)
                this.selected_event = undefined;
        });
        $(document).on('keydown', this.handle_key_press.bind(this));
        this._tag_container.on('click', event => {
            {
                this.selected_event = event.originalEvent;
            }
        });
    }
    tag_tree() {
        return this._tag_container;
    }
    hide_channel_tree() {
        this._tag_entries.detach();
        this._tree_detached = true;
    }
    show_channel_tree() {
        this._tree_detached = false;
        this._tag_entries.appendTo(this._tag_container);
        this.channels.forEach(e => e.recalculate_repetitive_name());
    }
    showContextMenu(x, y, on_close = undefined) {
        let channelCreate = this.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_TEMPORARY).granted(1) ||
            this.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_SEMI_PERMANENT).granted(1) ||
            this.client.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_PERMANENT).granted(1);
        spawn_context_menu(x, y, {
            type: MenuEntryType.ENTRY,
            icon: "client-channel_create",
            name: _translations.txzdKD20 || (_translations.txzdKD20 = tr("Create channel")),
            invalidPermission: !channelCreate,
            callback: () => this.spawnCreateChannel()
        }, MenuEntry.CLOSE(on_close));
    }
    initialiseHead(serverName, address) {
        this.server = new ServerEntry(this, serverName, address);
        this.server.htmlTag.appendTo(this._tag_entries);
        this.server.initializeListener();
    }
    __deleteAnimation(element) {
        let tag = element instanceof ChannelEntry ? element.rootTag() : element.tag;
        tag.fadeOut("slow", () => {
            tag.detach();
        });
    }
    rootChannel() {
        return this.channels.filter(e => e.parent == undefined);
    }
    deleteChannel(channel) {
        const _this = this;
        for (let index = 0; index < this.channels.length; index++) {
            let entry = this.channels[index];
            let currentEntry = this.channels[index];
            while (currentEntry != undefined && currentEntry != null) {
                if (currentEntry == channel) {
                    _this.channels.remove(entry);
                    _this.__deleteAnimation(entry);
                    entry.channelTree = null;
                    index--;
                    break;
                }
                else
                    currentEntry = currentEntry.parent_channel();
            }
        }
        this.channels.remove(channel);
        this.__deleteAnimation(channel);
        channel.channelTree = null;
        if (channel.channel_previous)
            channel.channel_previous.channel_next = channel.channel_next;
        if (channel.channel_next)
            channel.channel_next.channel_previous = channel.channel_previous;
        if (channel == this.channel_first)
            this.channel_first = channel.channel_next;
        if (channel == this.channel_last)
            this.channel_last = channel.channel_previous;
    }
    insertChannel(channel) {
        channel.channelTree = this;
        this.channels.push(channel);
        let elm = undefined;
        let tag = this._tag_entries;
        let previous_channel = null;
        if (channel.hasParent()) {
            let parent = channel.parent_channel();
            let siblings = parent.children();
            if (siblings.length == 0) {
                elm = parent.rootTag();
                previous_channel = null;
            }
            else {
                previous_channel = siblings.last();
                elm = previous_channel.tag;
            }
            tag = parent.siblingTag();
        }
        else {
            previous_channel = this.channel_last;
            if (!this.channel_last)
                this.channel_last = channel;
            if (!this.channel_first)
                this.channel_first = channel;
        }
        channel.channel_previous = previous_channel;
        channel.channel_next = undefined;
        if (previous_channel) {
            channel.channel_next = previous_channel.channel_next;
            previous_channel.channel_next = channel;
            if (channel.channel_next)
                channel.channel_next.channel_previous = channel;
        }
        let entry = channel.rootTag();
        if (!this._tree_detached)
            entry.css({ display: "none" }).fadeIn("slow");
        entry.appendTo(tag);
        if (elm != undefined)
            elm.after(entry);
        if (channel.channel_previous == channel) /* shall never happen */
            channel.channel_previous = undefined;
        if (channel.channel_next == channel) /* shall never happen */
            channel.channel_next = undefined;
        channel.initializeListener();
        channel.update_family_index();
    }
    findChannel(channelId) {
        for (let index = 0; index < this.channels.length; index++)
            if (this.channels[index].getChannelId() == channelId)
                return this.channels[index];
        return undefined;
    }
    find_channel_by_name(name, parent, force_parent = true) {
        for (let index = 0; index < this.channels.length; index++)
            if (this.channels[index].channelName() == name && (!force_parent || parent == this.channels[index].parent))
                return this.channels[index];
        return undefined;
    }
    moveChannel(channel, channel_previous, parent) {
        if (channel_previous != null && channel_previous.parent != parent) {
            console.error(_translations.hpmRs0ue || (_translations.hpmRs0ue = tr("Invalid channel move (different parents! (%o|%o)")), channel_previous.parent, parent);
            return;
        }
        if (channel.channel_next)
            channel.channel_next.channel_previous = channel.channel_previous;
        if (channel.channel_previous)
            channel.channel_previous.channel_next = channel.channel_next;
        if (channel == this.channel_last)
            this.channel_last = channel.channel_previous;
        if (channel == this.channel_first)
            this.channel_first = channel.channel_next;
        channel.channel_next = undefined;
        channel.channel_previous = channel_previous;
        channel.parent = parent;
        if (channel_previous) {
            if (channel_previous == this.channel_last)
                this.channel_last = channel;
            channel.channel_next = channel_previous.channel_next;
            channel_previous.channel_next = channel;
            channel_previous.rootTag().after(channel.rootTag());
            if (channel.channel_next)
                channel.channel_next.channel_previous = channel;
        }
        else {
            if (parent) {
                let children = parent.children();
                if (children.length <= 1) { //Self should be already in there
                    let left = channel.rootTag();
                    left.appendTo(parent.siblingTag());
                    channel.channel_next = undefined;
                }
                else {
                    channel.channel_previous = undefined;
                    channel.rootTag().prependTo(parent.siblingTag());
                    channel.channel_next = children[1]; /* children 0 shall be the channel itself */
                    channel.channel_next.channel_previous = channel;
                }
            }
            else {
                this._tag_entries.find(".server").after(channel.rootTag());
                channel.channel_next = this.channel_first;
                if (this.channel_first)
                    this.channel_first.channel_previous = channel;
                this.channel_first = channel;
            }
        }
        channel.update_family_index();
        channel.children(true).forEach(e => e.update_family_index());
        channel.clients(true).forEach(e => e.update_family_index());
        if (channel.channel_previous == channel) { /* shall never happen */
            channel.channel_previous = undefined;
            debugger;
        }
        if (channel.channel_next == channel) { /* shall never happen */
            channel.channel_next = undefined;
            debugger;
        }
    }
    deleteClient(client, animate_tag) {
        this.clients.remove(client);
        if (typeof (animate_tag) !== "boolean" || animate_tag)
            this.__deleteAnimation(client);
        else
            client.tag.detach();
        client.onDelete();
        const voice_connection = this.client.serverConnection.voice_connection();
        if (client.get_audio_handle()) {
            if (!voice_connection) {
                log.warn(LogCategory.VOICE, _translations.MQvJY0re || (_translations.MQvJY0re = tr("Deleting client with a voice handle, but we haven't a voice connection!")));
            }
            else {
                voice_connection.unregister_client(client.get_audio_handle());
            }
        }
        client.set_audio_handle(undefined); /* just to be sure */
    }
    registerClient(client) {
        this.clients.push(client);
        client.channelTree = this;
        const voice_connection = this.client.serverConnection.voice_connection();
        if (voice_connection)
            client.set_audio_handle(voice_connection.register_client(client.clientId()));
    }
    insertClient(client, channel) {
        let newClient = this.findClient(client.clientId());
        if (newClient)
            client = newClient; //Got new client :)
        else {
            this.registerClient(client);
        }
        client["_channel"] = channel;
        let tag = client.tag;
        if (!this._show_queries && client.properties.client_type == ClientType.CLIENT_QUERY)
            client.tag.hide();
        else if (!this._tree_detached)
            tag.css("display", "none").fadeIn("slow");
        tag.appendTo(channel.clientTag());
        client.currentChannel().reorderClients();
        channel.updateChannelTypeIcon();
        client.update_family_index();
        return client;
    }
    moveClient(client, channel) {
        let oldChannel = client.currentChannel();
        client["_channel"] = channel;
        let tag = client.tag;
        tag.detach();
        tag.appendTo(client.currentChannel().clientTag());
        if (oldChannel) {
            oldChannel.updateChannelTypeIcon();
        }
        if (client.currentChannel()) {
            client.currentChannel().reorderClients();
            client.currentChannel().updateChannelTypeIcon();
        }
        client.updateClientStatusIcons();
        client.update_family_index();
    }
    findClient(clientId) {
        for (let index = 0; index < this.clients.length; index++) {
            if (this.clients[index].clientId() == clientId)
                return this.clients[index];
        }
        return undefined;
    }
    find_client_by_dbid(client_dbid) {
        for (let index = 0; index < this.clients.length; index++) {
            if (this.clients[index].properties.client_database_id == client_dbid)
                return this.clients[index];
        }
        return undefined;
    }
    find_client_by_unique_id(unique_id) {
        for (let index = 0; index < this.clients.length; index++) {
            if (this.clients[index].properties.client_unique_identifier == unique_id)
                return this.clients[index];
        }
        return undefined;
    }
    static same_selected_type(a, b) {
        if (a instanceof ChannelEntry)
            return b instanceof ChannelEntry;
        if (a instanceof ClientEntry)
            return b instanceof ClientEntry;
        if (a instanceof ServerEntry)
            return b instanceof ServerEntry;
        return a == b;
    }
    onSelect(entry, enforce_single, flag_shift) {
        console.log("Select: " + entry);
        if (this.currently_selected && (ppt.key_pressed(ppt.SpecialKey.SHIFT) || flag_shift) && entry instanceof ClientEntry) { //Currently we're only supporting client multiselects :D
            if (!entry)
                return; //Nowhere
            if ($.isArray(this.currently_selected)) {
                if (!ChannelTree.same_selected_type(this.currently_selected[0], entry))
                    return; //Not the same type
            }
            else if (ChannelTree.same_selected_type(this.currently_selected, entry)) {
                this.currently_selected = [this.currently_selected];
            }
            if (entry instanceof ChannelEntry)
                this.currently_selected_context_callback = this.callback_multiselect_channel.bind(this);
            if (entry instanceof ClientEntry)
                this.currently_selected_context_callback = this.callback_multiselect_client.bind(this);
        }
        else
            this.currently_selected = undefined;
        if (!$.isArray(this.currently_selected) || enforce_single) {
            this.currently_selected = entry;
            this._tag_entries.find(".selected").each(function (idx, e) {
                $(e).removeClass("selected");
            });
        }
        else {
            for (const e of this.currently_selected)
                if (e == entry) {
                    this.currently_selected.remove(e);
                    if (entry instanceof ChannelEntry)
                        entry.channelTag().removeClass("selected");
                    else if (entry instanceof ClientEntry)
                        entry.tag.removeClass("selected");
                    else if (entry instanceof ServerEntry)
                        entry.htmlTag.removeClass("selected");
                    if (this.currently_selected.length == 1)
                        this.currently_selected = this.currently_selected[0];
                    else if (this.currently_selected.length == 0)
                        this.currently_selected = undefined;
                    //Already selected
                    return;
                }
            this.currently_selected.push(entry);
        }
        if (entry instanceof ChannelEntry)
            entry.channelTag().addClass("selected");
        else if (entry instanceof ClientEntry)
            entry.tag.addClass("selected");
        else if (entry instanceof ServerEntry)
            entry.htmlTag.addClass("selected");
        this.client.select_info.setCurrentSelected($.isArray(this.currently_selected) ? undefined : entry);
    }
    callback_multiselect_channel(event) {
        console.log(_translations.hSz_Or70 || (_translations.hSz_Or70 = tr("Multiselect channel")));
    }
    callback_multiselect_client(event) {
        console.log(_translations.KHU1gYH3 || (_translations.KHU1gYH3 = tr("Multiselect client")));
        const clients = this.currently_selected;
        const music_only = clients.map(e => e instanceof MusicClientEntry ? 0 : 1).reduce((a, b) => a + b, 0) == 0;
        const music_entry = clients.map(e => e instanceof MusicClientEntry ? 1 : 0).reduce((a, b) => a + b, 0) > 0;
        const local_client = clients.map(e => e instanceof LocalClientEntry ? 1 : 0).reduce((a, b) => a + b, 0) > 0;
        console.log(_translations.TBkeitSj || (_translations.TBkeitSj = tr("Music only: %o | Container music: %o | Container local: %o")), music_entry, music_entry, local_client);
        let entries = [];
        if (!music_entry && !local_client) { //Music bots or local client cant be poked
            entries.push({
                type: MenuEntryType.ENTRY,
                icon: "client-poke",
                name: _translations.L9dCpuHj || (_translations.L9dCpuHj = tr("Poke clients")),
                callback: () => {
                    createInputModal(_translations.uSB6rZxC || (_translations.uSB6rZxC = tr("Poke clients")), _translations.Hu49UTyC || (_translations.Hu49UTyC = tr("Poke message:<br>")), text => true, result => {
                        if (typeof (result) === "string") {
                            for (const client of this.currently_selected)
                                this.client.serverConnection.send_command("clientpoke", {
                                    clid: client.clientId(),
                                    msg: result
                                });
                        }
                    }, { width: 400, maxLength: 512 }).open();
                }
            });
        }
        entries.push({
            type: MenuEntryType.ENTRY,
            icon: "client-move_client_to_own_channel",
            name: _translations.HNFiSWVf || (_translations.HNFiSWVf = tr("Move clients to your channel")),
            callback: () => {
                const target = this.client.getClient().currentChannel().getChannelId();
                for (const client of clients)
                    this.client.serverConnection.send_command("clientmove", {
                        clid: client.clientId(),
                        cid: target
                    });
            }
        });
        if (!local_client) { //local client cant be kicked and/or banned or kicked
            entries.push(MenuEntry.HR());
            entries.push({
                type: MenuEntryType.ENTRY,
                icon: "client-kick_channel",
                name: _translations._pcdEcPQ || (_translations._pcdEcPQ = tr("Kick clients from channel")),
                callback: () => {
                    createInputModal(_translations.dfSh4e1D || (_translations.dfSh4e1D = tr("Kick clients from channel")), _translations.XCzqC85A || (_translations.XCzqC85A = tr("Kick reason:<br>")), text => true, result => {
                        if (result) {
                            for (const client of clients)
                                this.client.serverConnection.send_command("clientkick", {
                                    clid: client.clientId(),
                                    reasonid: ViewReasonId.VREASON_CHANNEL_KICK,
                                    reasonmsg: result
                                });
                        }
                    }, { width: 400, maxLength: 255 }).open();
                }
            });
            if (!music_entry) { //Music bots  cant be banned or kicked
                entries.push({
                    type: MenuEntryType.ENTRY,
                    icon: "client-kick_server",
                    name: _translations.OyA8imQt || (_translations.OyA8imQt = tr("Kick clients fom server")),
                    callback: () => {
                        createInputModal(_translations.oY53uayE || (_translations.oY53uayE = tr("Kick clients from server")), _translations.ZU23lFOM || (_translations.ZU23lFOM = tr("Kick reason:<br>")), text => true, result => {
                            if (result) {
                                for (const client of clients)
                                    this.client.serverConnection.send_command("clientkick", {
                                        clid: client.clientId(),
                                        reasonid: ViewReasonId.VREASON_SERVER_KICK,
                                        reasonmsg: result
                                    });
                            }
                        }, { width: 400, maxLength: 255 }).open();
                    }
                }, {
                    type: MenuEntryType.ENTRY,
                    icon: "client-ban_client",
                    name: _translations.j4bN7u5K || (_translations.j4bN7u5K = tr("Ban clients")),
                    invalidPermission: !this.client.permissions.neededPermission(PermissionType.I_CLIENT_BAN_MAX_BANTIME).granted(1),
                    callback: () => {
                        Modals.spawnBanClient((clients).map(entry => entry.clientNickName()), (data) => {
                            for (const client of clients)
                                this.client.serverConnection.send_command("banclient", {
                                    uid: client.properties.client_unique_identifier,
                                    banreason: data.reason,
                                    time: data.length
                                }, {
                                    flagset: [data.no_ip ? "no-ip" : "", data.no_hwid ? "no-hardware-id" : "", data.no_name ? "no-nickname" : ""]
                                }).then(() => {
                                    this.client.sound.play(Sound.USER_BANNED);
                                });
                        });
                    }
                });
            }
            if (music_only) {
                entries.push(MenuEntry.HR());
                entries.push({
                    name: _translations.D56CBX4U || (_translations.D56CBX4U = tr("Delete bots")),
                    icon: "client-delete",
                    disabled: false,
                    callback: () => {
                        const param_string = clients.map((_, index) => "{" + index + "}").join(', ');
                        const param_values = clients.map(client => client.createChatTag(true));
                        const tag = $.spawn("div").append(...MessageHelper.formatMessage((_translations.qpNpnuMM || (_translations.qpNpnuMM = tr("Do you really want to delete "))) + param_string, ...param_values));
                        const tag_container = $.spawn("div").append(tag);
                        Modals.spawnYesNo(_translations.bUlZ7kOX || (_translations.bUlZ7kOX = tr("Are you sure?")), tag_container, result => {
                            if (result) {
                                for (const client of clients)
                                    this.client.serverConnection.send_command("musicbotdelete", {
                                        botid: client.properties.client_database_id
                                    });
                            }
                        });
                    },
                    type: MenuEntryType.ENTRY
                });
            }
        }
        spawn_context_menu(event.pageX, event.pageY, ...entries);
    }
    clientsByGroup(group) {
        let result = [];
        for (let client of this.clients) {
            if (client.groupAssigned(group))
                result.push(client);
        }
        return result;
    }
    clientsByChannel(channel) {
        let result = [];
        for (let client of this.clients) {
            if (client.currentChannel() == channel)
                result.push(client);
        }
        return result;
    }
    reset() {
        this.server = null;
        this.clients = [];
        this.channels = [];
        this._tag_entries.children().detach(); //Do not remove the listener!
        this.channel_first = undefined;
        this.channel_last = undefined;
    }
    spawnCreateChannel(parent) {
        Modals.createChannelModal(this.client, undefined, parent, this.client.permissions, (properties, permissions) => {
            if (!properties)
                return;
            properties["cpid"] = parent ? parent.channelId : 0;
            log.debug(LogCategory.CHANNEL, _translations.LQdmWKkv || (_translations.LQdmWKkv = tr("Creating a new channel.\nProperties: %o\nPermissions: %o")), properties);
            this.client.serverConnection.send_command("channelcreate", properties).then(() => {
                let channel = this.find_channel_by_name(properties.channel_name, parent, true);
                if (!channel) {
                    log.error(LogCategory.CHANNEL, _translations.EKzk40OR || (_translations.EKzk40OR = tr("Failed to resolve channel after creation. Could not apply permissions!")));
                    return;
                }
                if (permissions && permissions.length > 0) {
                    let perms = [];
                    for (let perm of permissions) {
                        perms.push({
                            permvalue: perm.value,
                            permnegated: false,
                            permskip: false,
                            permid: perm.type.id
                        });
                    }
                    perms[0]["cid"] = channel.channelId;
                    return this.client.serverConnection.send_command("channeladdperm", perms, {
                        flagset: ["continueonerror"]
                    }).then(() => new Promise(resolve => { resolve(channel); }));
                }
                return new Promise(resolve => { resolve(channel); });
            }).then(channel => {
                this.client.chat.serverChat().appendMessage(_translations.aTLBXXJT || (_translations.aTLBXXJT = tr("Channel {} successfully created!")), true, channel.generate_tag(true));
                this.client.sound.play(Sound.CHANNEL_CREATED);
            });
        });
    }
    handle_resized() {
        for (let channel of this.channels)
            channel.handle_frame_resized();
    }
    select_next_channel(channel, select_client) {
        if (select_client) {
            const clients = channel.clients_ordered();
            if (clients.length > 0) {
                this.onSelect(clients[0], true);
                return;
            }
        }
        const children = channel.children();
        if (children.length > 0) {
            this.onSelect(children[0], true);
            return;
        }
        const next = channel.channel_next;
        if (next) {
            this.onSelect(next, true);
            return;
        }
        let parent = channel.parent_channel();
        while (parent) {
            const p_next = parent.channel_next;
            if (p_next) {
                this.onSelect(p_next, true);
                return;
            }
            parent = parent.parent_channel();
        }
    }
    handle_key_press(event) {
        if (!this.selected_event || !this.currently_selected || $.isArray(this.currently_selected))
            return;
        if (event.keyCode == KeyCode.KEY_UP) {
            event.preventDefault();
            if (this.currently_selected instanceof ChannelEntry) {
                let previous = this.currently_selected.channel_previous;
                if (previous) {
                    while (true) {
                        const siblings = previous.children();
                        if (siblings.length == 0)
                            break;
                        previous = siblings.last();
                    }
                    const clients = previous.clients_ordered();
                    if (clients.length > 0) {
                        this.onSelect(clients.last(), true);
                        return;
                    }
                    else {
                        this.onSelect(previous, true);
                        return;
                    }
                }
                else if (this.currently_selected.hasParent()) {
                    const channel = this.currently_selected.parent_channel();
                    const clients = channel.clients_ordered();
                    if (clients.length > 0) {
                        this.onSelect(clients.last(), true);
                        return;
                    }
                    else {
                        this.onSelect(channel, true);
                        return;
                    }
                }
                else
                    this.onSelect(this.server, true);
            }
            else if (this.currently_selected instanceof ClientEntry) {
                const channel = this.currently_selected.currentChannel();
                const clients = channel.clients_ordered();
                const index = clients.indexOf(this.currently_selected);
                if (index > 0) {
                    this.onSelect(clients[index - 1], true);
                    return;
                }
                this.onSelect(channel, true);
                return;
            }
        }
        else if (event.keyCode == KeyCode.KEY_DOWN) {
            event.preventDefault();
            if (this.currently_selected instanceof ChannelEntry) {
                this.select_next_channel(this.currently_selected, true);
            }
            else if (this.currently_selected instanceof ClientEntry) {
                const channel = this.currently_selected.currentChannel();
                const clients = channel.clients_ordered();
                const index = clients.indexOf(this.currently_selected);
                if (index + 1 < clients.length) {
                    this.onSelect(clients[index + 1], true);
                    return;
                }
                this.select_next_channel(channel, false);
            }
            else if (this.currently_selected instanceof ServerEntry)
                this.onSelect(this.channel_first, true);
        }
        else if (event.keyCode == KeyCode.KEY_RETURN) {
            if (this.currently_selected instanceof ChannelEntry) {
                this.currently_selected.joinChannel();
            }
        }
    }
    toggle_server_queries(flag) {
        if (this._show_queries == flag)
            return;
        this._show_queries = flag;
        const channels = [];
        for (const client of this.clients)
            if (client.properties.client_type == ClientType.CLIENT_QUERY) {
                if (this._show_queries)
                    client.tag.show();
                else
                    client.tag.hide();
                if (channels.indexOf(client.currentChannel()) == -1)
                    channels.push(client.currentChannel());
            }
    }
    get_first_channel() {
        return this.channel_first;
    }
    unsubscribe_all_channels(subscribe_specified) {
        if (!this.client.serverConnection || !this.client.serverConnection.connected())
            return;
        this.client.serverConnection.send_command('channelunsubscribeall').then(() => {
            const channels = [];
            for (const channel of this.channels) {
                if (channel.subscribe_mode == ChannelSubscribeMode.SUBSCRIBED)
                    channels.push(channel.getChannelId());
            }
            if (channels.length > 0) {
                this.client.serverConnection.send_command('channelsubscribe', channels.map(e => { return { cid: e }; })).catch(error => {
                    console.warn(_translations.CXRbtcqM || (_translations.CXRbtcqM = tr("Failed to subscribe to specific channels (%o)")), channels);
                });
            }
        }).catch(error => {
            console.warn(_translations.iPtA1BZQ || (_translations.iPtA1BZQ = tr("Failed to unsubscribe to all channels! (%o)")), error);
        });
    }
    subscribe_all_channels() {
        if (!this.client.serverConnection || !this.client.serverConnection.connected())
            return;
        this.client.serverConnection.send_command('channelsubscribeall').then(() => {
            const channels = [];
            for (const channel of this.channels) {
                if (channel.subscribe_mode == ChannelSubscribeMode.UNSUBSCRIBED)
                    channels.push(channel.getChannelId());
            }
            if (channels.length > 0) {
                this.client.serverConnection.send_command('channelunsubscribe', channels.map(e => { return { cid: e }; })).catch(error => {
                    console.warn(_translations.Ex4qLn2h || (_translations.Ex4qLn2h = tr("Failed to unsubscribe to specific channels (%o)")), channels);
                });
            }
        }).catch(error => {
            console.warn(_translations.ST0BD1oa || (_translations.ST0BD1oa = tr("Failed to subscribe to all channels! (%o)")), error);
        });
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["881b450ece1382ae3c8182d855ae1a2fc12e6bc1dafd1a64cec45012f838083c"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["881b450ece1382ae3c8182d855ae1a2fc12e6bc1dafd1a64cec45012f838083c"] = "881b450ece1382ae3c8182d855ae1a2fc12e6bc1dafd1a64cec45012f838083c";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
if (typeof (customElements) !== "undefined") {
    try {
        class X_Properties extends HTMLElement {
        }
        class X_Property extends HTMLElement {
        }
        customElements.define('x-properties', X_Properties, { extends: 'div' });
        customElements.define('x-property', X_Property, { extends: 'div' });
    }
    catch (error) {
        console.warn("failed to define costum elements");
    }
}
class SettingsBase {
    static transformStO(input, _default, default_type) {
        default_type = default_type || typeof _default;
        if (typeof input === "undefined")
            return _default;
        if (default_type === "string")
            return input;
        else if (default_type === "number")
            return parseInt(input);
        else if (default_type === "boolean")
            return (input == "1" || input == "true");
        else if (default_type === "undefined")
            return input;
        return JSON.parse(input);
    }
    static transformOtS(input) {
        if (typeof input === "string")
            return input;
        else if (typeof input === "number")
            return input.toString();
        else if (typeof input === "boolean")
            return input ? "1" : "0";
        else if (typeof input === "undefined")
            return undefined;
        return JSON.stringify(input);
    }
    static resolveKey(key, _default, resolver, default_type) {
        let value = resolver(key.key);
        if (!value) {
            /* trying fallbacks */
            for (const fallback of key.fallback_keys || []) {
                value = resolver(fallback);
                if (typeof (value) === "string") {
                    /* fallback key succeeded */
                    const importer = (key.fallback_imports || {})[fallback];
                    if (importer)
                        return importer(value);
                    break;
                }
            }
        }
        if (typeof (value) !== 'string')
            return _default;
        return SettingsBase.transformStO(value, _default, default_type);
    }
    static keyify(key) {
        if (typeof (key) === "string")
            return { key: key };
        if (typeof (key) === "object" && key.key)
            return key;
        throw "key is not a key";
    }
}
SettingsBase.UPDATE_DIRECT = true;
class StaticSettings extends SettingsBase {
    static get instance() {
        if (!this._instance)
            this._instance = new StaticSettings(true);
        return this._instance;
    }
    constructor(_reserved = undefined) {
        super();
        if (_reserved && !StaticSettings._instance) {
            this._staticPropsTag = $("#properties");
            this.initializeStatic();
        }
        else {
            this._handle = StaticSettings.instance;
        }
    }
    initializeStatic() {
        let search;
        if (window.opener && window.opener !== window) {
            search = new URL(window.location.href).search;
        }
        else {
            search = location.search;
        }
        search.substr(1).split("&").forEach(part => {
            let item = part.split("=");
            $("<x-property></x-property>")
                .attr("key", item[0])
                .attr("value", item[1])
                .appendTo(this._staticPropsTag);
        });
    }
    static(key, _default, default_type) {
        if (this._handle)
            return this._handle.static(key, _default, default_type);
        key = StaticSettings.keyify(key);
        return StaticSettings.resolveKey(key, _default, key => {
            let result = this._staticPropsTag.find("[key='" + key + "']");
            if (result.length > 0)
                return decodeURIComponent(result.last().attr('value'));
            return false;
        }, default_type);
    }
    deleteStatic(key) {
        if (this._handle) {
            this._handle.deleteStatic(key);
            return;
        }
        key = StaticSettings.keyify(key);
        let result = this._staticPropsTag.find("[key='" + key.key + "']");
        if (result.length != 0)
            result.detach();
    }
}
class Settings extends StaticSettings {
    constructor() {
        super();
        this.cacheGlobal = {};
        this.updated = false;
        this.cacheGlobal = JSON.parse(localStorage.getItem("settings.global"));
        if (!this.cacheGlobal)
            this.cacheGlobal = {};
        this.saveWorker = setInterval(() => {
            if (this.updated)
                this.save();
        }, 5 * 1000);
    }
    static_global(key, _default) {
        const default_object = { seed: Math.random() };
        let _static = this.static(key, default_object, typeof _default);
        if (_static !== default_object)
            return StaticSettings.transformStO(_static, _default);
        return this.global(key, _default);
    }
    global(key, _default) {
        return StaticSettings.resolveKey(Settings.keyify(key), _default, key => this.cacheGlobal[key]);
    }
    changeGlobal(key, value) {
        key = Settings.keyify(key);
        if (this.cacheGlobal[key.key] == value)
            return;
        this.updated = true;
        this.cacheGlobal[key.key] = StaticSettings.transformOtS(value);
        if (Settings.UPDATE_DIRECT)
            this.save();
    }
    save() {
        this.updated = false;
        let global = JSON.stringify(this.cacheGlobal);
        localStorage.setItem("settings.global", global);
        if (localStorage.save)
            localStorage.save();
    }
}
Settings.KEY_DISABLE_COSMETIC_SLOWDOWN = {
    key: 'disable_cosmetic_slowdown',
    description: 'Disable the cosmetic slowdows in some processes, like icon upload.'
};
Settings.KEY_DISABLE_CONTEXT_MENU = {
    key: 'disableContextMenu',
    description: 'Disable the context menu for the channel tree which allows to debug the DOM easier'
};
Settings.KEY_DISABLE_UNLOAD_DIALOG = {
    key: 'disableUnloadDialog',
    description: 'Disables the unload popup on side closing'
};
Settings.KEY_DISABLE_VOICE = {
    key: 'disableVoice',
    description: 'Disables the voice bridge. If disabled, the audio and codec workers aren\'t required anymore'
};
Settings.KEY_DISABLE_MULTI_SESSION = {
    key: 'disableMultiSession',
};
Settings.KEY_LOAD_DUMMY_ERROR = {
    key: 'dummy_load_error',
    description: 'Triggers a loading error at the end of the loading process.'
};
/* Control bar */
Settings.KEY_CONTROL_MUTE_INPUT = {
    key: 'mute_input'
};
Settings.KEY_CONTROL_MUTE_OUTPUT = {
    key: 'mute_output'
};
Settings.KEY_CONTROL_SHOW_QUERIES = {
    key: 'show_server_queries'
};
Settings.KEY_CONTROL_CHANNEL_SUBSCRIBE_ALL = {
    key: 'channel_subscribe_all'
};
/* Connect parameters */
Settings.KEY_FLAG_CONNECT_DEFAULT = {
    key: 'connect_default'
};
Settings.KEY_CONNECT_ADDRESS = {
    key: 'connect_address'
};
Settings.KEY_CONNECT_PROFILE = {
    key: 'connect_profile'
};
Settings.KEY_CONNECT_USERNAME = {
    key: 'connect_username'
};
Settings.KEY_CONNECT_PASSWORD = {
    key: 'connect_password'
};
Settings.KEY_FLAG_CONNECT_PASSWORD = {
    key: 'connect_password_hashed'
};
Settings.KEY_CERTIFICATE_CALLBACK = {
    key: 'certificate_callback'
};
/* sounds */
Settings.KEY_SOUND_MASTER = {
    key: 'audio_master_volume'
};
Settings.KEY_SOUND_MASTER_SOUNDS = {
    key: 'audio_master_volume_sounds'
};
Settings.FN_SERVER_CHANNEL_SUBSCRIBE_MODE = channel => {
    return {
        key: 'channel_subscribe_mode_' + channel.getChannelId()
    };
};
Settings.FN_PROFILE_RECORD = name => {
    return {
        key: 'profile_record' + name
    };
};
Settings.KEYS = (() => {
    const result = [];
    for (const key in Settings) {
        if (!key.toUpperCase().startsWith("KEY_"))
            continue;
        if (key.toUpperCase() == "KEYS")
            continue;
        result.push(key);
    }
    return result;
})();
class ServerSettings extends SettingsBase {
    constructor() {
        super();
        this.cacheServer = {};
        this._server_settings_updated = false;
        this._server_save_worker = setInterval(() => {
            if (this._server_settings_updated)
                this.save();
        }, 5 * 1000);
    }
    server(key, _default) {
        return StaticSettings.resolveKey(Settings.keyify(key), _default, key => this.cacheServer[key]);
    }
    changeServer(key, value) {
        key = Settings.keyify(key);
        if (this.cacheServer[key.key] == value)
            return;
        this._server_settings_updated = true;
        this.cacheServer[key.key] = StaticSettings.transformOtS(value);
        if (Settings.UPDATE_DIRECT)
            this.save();
    }
    setServer(server) {
        if (this.currentServer) {
            this.save();
            this.cacheServer = {};
            this.currentServer = undefined;
        }
        this.currentServer = server;
        if (this.currentServer) {
            let serverId = this.currentServer.properties.virtualserver_unique_identifier;
            this.cacheServer = JSON.parse(localStorage.getItem("settings.server_" + serverId));
            if (!this.cacheServer)
                this.cacheServer = {};
        }
    }
    save() {
        this._server_settings_updated = false;
        if (this.currentServer) {
            let serverId = this.currentServer.properties.virtualserver_unique_identifier;
            let server = JSON.stringify(this.cacheServer);
            localStorage.setItem("settings.server_" + serverId, server);
            if (localStorage.save)
                localStorage.save();
        }
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["0c84702a3fc79cd3b3c6ef35a13be6f5a99bf9c13e579528745506fe7657bbc1"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["0c84702a3fc79cd3b3c6ef35a13be6f5a99bf9c13e579528745506fe7657bbc1"] = "0c84702a3fc79cd3b3c6ef35a13be6f5a99bf9c13e579528745506fe7657bbc1";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/*
Copyright (C) 2011 Patrick Gillespie, http://patorjk.com/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/
/*
    Extendible BBCode Parser v1.0.0
    By Patrick Gillespie (patorjk@gmail.com)
    Website: http://patorjk.com/

    This module allows you to parse BBCode and to extend to the mark-up language
    to add in your own tags.
*/
var XBBCODE;
(function (XBBCODE) {
    // -----------------------------------------------------------------------------
    // Set up private variables
    // -----------------------------------------------------------------------------
    const urlPattern = /^(?:https?|file|c):(?:\/{1,3}|\\{1})[-a-zA-Z0-9:;,@#%&()~_?\+=\/\\\.]*$/, colorNamePattern = /^(?:aliceblue|antiquewhite|aqua|aquamarine|azure|beige|bisque|black|blanchedalmond|blue|blueviolet|brown|burlywood|cadetblue|chartreuse|chocolate|coral|cornflowerblue|cornsilk|crimson|cyan|darkblue|darkcyan|darkgoldenrod|darkgray|darkgreen|darkkhaki|darkmagenta|darkolivegreen|darkorange|darkorchid|darkred|darksalmon|darkseagreen|darkslateblue|darkslategray|darkturquoise|darkviolet|deeppink|deepskyblue|dimgray|dodgerblue|firebrick|floralwhite|forestgreen|fuchsia|gainsboro|ghostwhite|gold|goldenrod|gray|green|greenyellow|honeydew|hotpink|indianred|indigo|ivory|khaki|lavender|lavenderblush|lawngreen|lemonchiffon|lightblue|lightcoral|lightcyan|lightgoldenrodyellow|lightgray|lightgreen|lightpink|lightsalmon|lightseagreen|lightskyblue|lightslategray|lightsteelblue|lightyellow|lime|limegreen|linen|magenta|maroon|mediumaquamarine|mediumblue|mediumorchid|mediumpurple|mediumseagreen|mediumslateblue|mediumspringgreen|mediumturquoise|mediumvioletred|midnightblue|mintcream|mistyrose|moccasin|navajowhite|navy|oldlace|olive|olivedrab|orange|orangered|orchid|palegoldenrod|palegreen|paleturquoise|palevioletred|papayawhip|peachpuff|peru|pink|plum|powderblue|purple|red|rosybrown|royalblue|saddlebrown|salmon|sandybrown|seagreen|seashell|sienna|silver|skyblue|slateblue|slategray|snow|springgreen|steelblue|tan|teal|thistle|tomato|turquoise|violet|wheat|white|whitesmoke|yellow|yellowgreen)$/, colorCodePattern = /^#?[a-fA-F0-9]{6}$/, emailPattern = /[^\s@]+@[^\s@]+\.[^\s@]+/, fontFacePattern = /^([a-z][a-z0-9_]+|"[a-z][a-z0-9_\s]+")$/i;
    let tagList, tagsNoParseList = [], bbRegExp, pbbRegExp, pbbRegExp2, openTags, closeTags;
    /* -----------------------------------------------------------------------------
     * _tags
     * This object contains a list of _tags that your code will be able to understand.
     * Each tag object has the following properties:
     *
     *   openTag - A function that takes in the tag's parameters (if any) and its
     *             contents, and returns what its HTML open tag should be.
     *             Example: [color=red]test[/color] would take in "=red" as a
     *             parameter input, and "test" as a content input.
     *             It should be noted that any BBCode inside of "content" will have
     *             been processed by the time it enter the openTag function.
     *
     *   closeTag - A function that takes in the tag's parameters (if any) and its
     *              contents, and returns what its HTML close tag should be.
     *
     *   displayContent - Defaults to true. If false, the content for the tag will
     *                    not be displayed. This is useful for _tags like IMG where
     *                    its contents are actually a parameter input.
     *
     *   restrictChildrenTo - A list of BBCode _tags which are allowed to be nested
     *                        within this BBCode tag. If this property is omitted,
     *                        any BBCode tag may be nested within the tag.
     *
     *   restrictParentsTo - A list of BBCode _tags which are allowed to be parents of
     *                       this BBCode tag. If this property is omitted, any BBCode
     *                       tag may be a parent of the tag.
     *
     *   noParse - true or false. If true, none of the content WITHIN this tag will be
     *             parsed by the XBBCode parser.
     *
     *
     *
     * LIMITIONS on adding NEW TAGS:
     *  - Tag names should be alphanumeric (including underscores) and all _tags should have an opening tag
     *    and a closing tag.
     *    The [*] tag is an exception because it was already a standard
     *    bbcode tag. Technecially _tags don't *have* to be alphanumeric, but since
     *    regular expressions are used to parse the text, if you use a non-alphanumeric
     *    tag names, just make sure the tag name gets escaped properly (if needed).
     * --------------------------------------------------------------------------- */
    let _tags = {
        "b": {
            openTag: function (params, content) {
                return '<span class="xbbcode-b">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        /*
            This tag does nothing and is here mostly to be used as a classification for
            the bbcode input when evaluating parent-child tag relationships
        */
        "bbcode": {
            openTag: function (params, content) {
                return '';
            },
            closeTag: function (params, content) {
                return '';
            }
        },
        "center": {
            openTag: function (params, content) {
                return '<span class="xbbcode-center">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "code": {
            openTag: function (params, content) {
                return '<span class="xbbcode-code">';
            },
            closeTag: function (params, content) {
                return '</span>';
            },
            noParse: true
        },
        "color": {
            openTag: function (params, content) {
                params = params || '';
                var colorCode = (params.substr(1)).toLowerCase() || "black";
                colorNamePattern.lastIndex = 0;
                colorCodePattern.lastIndex = 0;
                if (!colorNamePattern.test(colorCode)) {
                    if (!colorCodePattern.test(colorCode)) {
                        colorCode = "black";
                    }
                    else {
                        if (colorCode.substr(0, 1) !== "#") {
                            colorCode = "#" + colorCode;
                        }
                    }
                }
                return '<span style="color:' + colorCode + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "email": {
            openTag: function (params, content) {
                var myEmail;
                if (!params) {
                    myEmail = content.replace(/<.*?>/g, "");
                }
                else {
                    myEmail = params.substr(1);
                }
                emailPattern.lastIndex = 0;
                if (!emailPattern.test(myEmail)) {
                    return '<a>';
                }
                return '<a href="mailto:' + myEmail + '">';
            },
            closeTag: function (params, content) {
                return '</a>';
            }
        },
        "face": {
            openTag: function (params, content) {
                params = params || '';
                var faceCode = params.substr(1) || "inherit";
                fontFacePattern.lastIndex = 0;
                if (!fontFacePattern.test(faceCode)) {
                    faceCode = "inherit";
                }
                return '<span style="font-family:' + faceCode + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "font": {
            openTag: function (params, content) {
                params = params || '';
                var faceCode = params.substr(1) || "inherit";
                fontFacePattern.lastIndex = 0;
                if (!fontFacePattern.test(faceCode)) {
                    faceCode = "inherit";
                }
                return '<span style="font-family:' + faceCode + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "i": {
            openTag: function (params, content) {
                return '<span class="xbbcode-i">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "img": {
            openTag: function (params, content) {
                var myUrl = content;
                urlPattern.lastIndex = 0;
                if (!urlPattern.test(myUrl)) {
                    myUrl = "";
                }
                return '<img src="' + myUrl + '" />';
            },
            closeTag: function (params, content) {
                return '';
            },
            displayContent: false
        },
        "justify": {
            openTag: function (params, content) {
                return '<span class="xbbcode-justify">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "large": {
            openTag: function (params, content) {
                params = params || '';
                var colorCode = params.substr(1) || "inherit";
                colorNamePattern.lastIndex = 0;
                colorCodePattern.lastIndex = 0;
                if (!colorNamePattern.test(colorCode)) {
                    if (!colorCodePattern.test(colorCode)) {
                        colorCode = "inherit";
                    }
                    else {
                        if (colorCode.substr(0, 1) !== "#") {
                            colorCode = "#" + colorCode;
                        }
                    }
                }
                return '<span class="xbbcode-size-36" style="color:' + colorCode + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "left": {
            openTag: function (params, content) {
                return '<span class="xbbcode-left">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "li": {
            openTag: function (params, content) {
                return "<li>";
            },
            closeTag: function (params, content) {
                return "</li>";
            },
            restrictParentsTo: ["list", "ul", "ol"]
        },
        "list": {
            openTag: function (params, content) {
                return '<ul>';
            },
            closeTag: function (params, content) {
                return '</ul>';
            },
            restrictChildrenTo: ["*", "li"]
        },
        "noparse": {
            openTag: function (params, content) {
                return '';
            },
            closeTag: function (params, content) {
                return '';
            },
            noParse: true
        },
        "ol": {
            openTag: function (params, content) {
                return '<ol>';
            },
            closeTag: function (params, content) {
                return '</ol>';
            },
            restrictChildrenTo: ["*", "li"]
        },
        "php": {
            openTag: function (params, content) {
                return '<span class="xbbcode-code">';
            },
            closeTag: function (params, content) {
                return '</span>';
            },
            noParse: true
        },
        "quote": {
            openTag: function (params, content) {
                return '<blockquote class="xbbcode-blockquote">';
            },
            closeTag: function (params, content) {
                return '</blockquote>';
            }
        },
        "right": {
            openTag: function (params, content) {
                return '<span class="xbbcode-right">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "s": {
            openTag: function (params, content) {
                return '<span class="xbbcode-s">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "size": {
            openTag: function (params, content) {
                params = params || '';
                var mySize = parseInt(params.substr(1), 10) || 0;
                if (mySize < 4 || mySize > 40) {
                    mySize = 14;
                }
                return '<span class="xbbcode-size-' + mySize + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "small": {
            openTag: function (params, content) {
                params = params || '';
                var colorCode = params.substr(1) || "inherit";
                colorNamePattern.lastIndex = 0;
                colorCodePattern.lastIndex = 0;
                if (!colorNamePattern.test(colorCode)) {
                    if (!colorCodePattern.test(colorCode)) {
                        colorCode = "inherit";
                    }
                    else {
                        if (colorCode.substr(0, 1) !== "#") {
                            colorCode = "#" + colorCode;
                        }
                    }
                }
                return '<span class="xbbcode-size-10" style="color:' + colorCode + '">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "sub": {
            openTag: function (params, content) {
                return '<sub>';
            },
            closeTag: function (params, content) {
                return '</sub>';
            }
        },
        "sup": {
            openTag: function (params, content) {
                return '<sup>';
            },
            closeTag: function (params, content) {
                return '</sup>';
            }
        },
        "table": {
            openTag: function (params, content) {
                return '<table class="xbbcode-table">';
            },
            closeTag: function (params, content) {
                return '</table>';
            },
            restrictChildrenTo: ["tbody", "thead", "tfoot", "tr"]
        },
        "tbody": {
            openTag: function (params, content) {
                return '<tbody>';
            },
            closeTag: function (params, content) {
                return '</tbody>';
            },
            restrictChildrenTo: ["tr"],
            restrictParentsTo: ["table"]
        },
        "tfoot": {
            openTag: function (params, content) {
                return '<tfoot>';
            },
            closeTag: function (params, content) {
                return '</tfoot>';
            },
            restrictChildrenTo: ["tr"],
            restrictParentsTo: ["table"]
        },
        "thead": {
            openTag: function (params, content) {
                return '<thead class="xbbcode-thead">';
            },
            closeTag: function (params, content) {
                return '</thead>';
            },
            restrictChildrenTo: ["tr"],
            restrictParentsTo: ["table"]
        },
        "td": {
            openTag: function (params, content) {
                return '<td class="xbbcode-td">';
            },
            closeTag: function (params, content) {
                return '</td>';
            },
            restrictParentsTo: ["tr"]
        },
        "th": {
            openTag: function (params, content) {
                return '<th class="xbbcode-th">';
            },
            closeTag: function (params, content) {
                return '</th>';
            },
            restrictParentsTo: ["tr"]
        },
        "tr": {
            openTag: function (params, content) {
                return '<tr class="xbbcode-tr">';
            },
            closeTag: function (params, content) {
                return '</tr>';
            },
            restrictChildrenTo: ["td", "th"],
            restrictParentsTo: ["table", "tbody", "tfoot", "thead"]
        },
        "u": {
            openTag: function (params, content) {
                return '<span class="xbbcode-u">';
            },
            closeTag: function (params, content) {
                return '</span>';
            }
        },
        "ul": {
            openTag: function (params, content) {
                return '<ul>';
            },
            closeTag: function (params, content) {
                return '</ul>';
            },
            restrictChildrenTo: ["*", "li"]
        },
        "url": {
            openTag: function (params, content) {
                let myUrl;
                if (!params) {
                    myUrl = content.replace(/<.*?>/g, "");
                }
                else {
                    myUrl = params.substr(1);
                }
                urlPattern.lastIndex = 0;
                if (!urlPattern.test(myUrl)) {
                    myUrl = "#";
                }
                return '<a href="' + myUrl + '" target="_blank">';
            },
            closeTag: function (params, content) {
                return '</a>';
            }
        },
        "hr": {
            openTag: (params, content) => {
                return "<hr/>";
            },
            closeTag: (params, content) => {
                return "";
            }
        },
        /*
            The [*] tag is special since the user does not define a closing [/*] tag when writing their bbcode.
            Instead this module parses the code and adds the closing [/*] tag in for them. None of the _tags you
            add will act like this and this tag is an exception to the others.
        */
        "*": {
            openTag: function (params, content) {
                return "<li>";
            },
            closeTag: function (params, content) {
                return "</li>";
            },
            restrictParentsTo: ["list", "ul", "ol"]
        }
    };
    // create tag list and lookup fields
    function initTags() {
        tagList = [];
        let prop, ii, len;
        for (prop in _tags) {
            if (_tags.hasOwnProperty(prop)) {
                if (prop === "*") {
                    tagList.push("\\" + prop);
                }
                else {
                    tagList.push(prop);
                    if (_tags[prop].noParse) {
                        tagsNoParseList.push(prop);
                    }
                }
                _tags[prop].validChildLookup = {};
                _tags[prop].validParentLookup = {};
                _tags[prop].restrictParentsTo = _tags[prop].restrictParentsTo || [];
                _tags[prop].restrictChildrenTo = _tags[prop].restrictChildrenTo || [];
                len = _tags[prop].restrictChildrenTo.length;
                for (ii = 0; ii < len; ii++) {
                    _tags[prop].validChildLookup[_tags[prop].restrictChildrenTo[ii]] = true;
                }
                len = _tags[prop].restrictParentsTo.length;
                for (ii = 0; ii < len; ii++) {
                    _tags[prop].validParentLookup[_tags[prop].restrictParentsTo[ii]] = true;
                }
            }
        }
        bbRegExp = new RegExp("<bbcl=([0-9]+) (" + tagList.join("|") + ")([ =][^>]*?)?>((?:.|[\\r\\n])*?)<bbcl=\\1 /\\2>", "gi");
        pbbRegExp = new RegExp("\\[(" + tagList.join("|") + ")([ =][^\\]]*?)?\\]([^\\[]*?)\\[/\\1\\]", "gi");
        pbbRegExp2 = new RegExp("\\[(" + tagsNoParseList.join("|") + ")([ =][^\\]]*?)?\\]([\\s\\S]*?)\\[/\\1\\]", "gi");
        // create the regex for escaping ['s that aren't apart of _tags
        (function () {
            var closeTagList = [];
            for (var ii = 0; ii < tagList.length; ii++) {
                if (tagList[ii] !== "\\*") { // the * tag doesn't have an offical closing tag
                    closeTagList.push("/" + tagList[ii]);
                }
            }
            openTags = new RegExp("(\\[)((?:" + tagList.join("|") + ")(?:[ =][^\\]]*?)?)(\\])", "gi");
            closeTags = new RegExp("(\\[)(" + closeTagList.join("|") + ")(\\])", "gi");
        })();
    }
    initTags();
    // -----------------------------------------------------------------------------
    // private functions
    // -----------------------------------------------------------------------------
    function checkParentChildRestrictions(parentTag, bbcode, bbcodeLevel, tagName, tagParams, tagContents, errQueue) {
        errQueue = errQueue || [];
        bbcodeLevel++;
        // get a list of all of the child _tags to this tag
        var reTagNames = new RegExp("(<bbcl=" + bbcodeLevel + " )(" + tagList.join("|") + ")([ =>])", "gi"), reTagNamesParts = new RegExp("(<bbcl=" + bbcodeLevel + " )(" + tagList.join("|") + ")([ =>])", "i"), matchingTags = tagContents.match(reTagNames) || [], cInfo, errStr, ii, childTag, pInfo = _tags[parentTag] || {};
        reTagNames.lastIndex = 0;
        if (!matchingTags) {
            tagContents = "";
        }
        for (ii = 0; ii < matchingTags.length; ii++) {
            reTagNamesParts.lastIndex = 0;
            childTag = (matchingTags[ii].match(reTagNamesParts))[2].toLowerCase();
            if (pInfo && pInfo.restrictChildrenTo && pInfo.restrictChildrenTo.length > 0) {
                if (!pInfo.validChildLookup[childTag]) {
                    errStr = "The tag \"" + childTag + "\" is not allowed as a child of the tag \"" + parentTag + "\".";
                    errQueue.push(errStr);
                }
            }
            cInfo = _tags[childTag] || {};
            if (cInfo.restrictParentsTo.length > 0) {
                if (!cInfo.validParentLookup[parentTag]) {
                    errStr = "The tag \"" + parentTag + "\" is not allowed as a parent of the tag \"" + childTag + "\".";
                    errQueue.push(errStr);
                }
            }
        }
        tagContents = tagContents.replace(bbRegExp, function (matchStr, bbcodeLevel, tagName, tagParams, tagContents) {
            errQueue = checkParentChildRestrictions(tagName.toLowerCase(), matchStr, bbcodeLevel, tagName, tagParams, tagContents, errQueue);
            return matchStr;
        });
        return errQueue;
    }
    /*
        This function updates or adds a piece of metadata to each tag called "bbcl" which
        indicates how deeply nested a particular tag was in the bbcode. This property is removed
        from the HTML code _tags at the end of the processing.
    */
    function updateTagDepths(tagContents) {
        tagContents = tagContents.replace(/\<([^\>][^\>]*?)\>/gi, function (matchStr, subMatchStr) {
            var bbCodeLevel = subMatchStr.match(/^bbcl=([0-9]+) /);
            if (bbCodeLevel === null) {
                return "<bbcl=0 " + subMatchStr + ">";
            }
            else {
                return "<" + subMatchStr.replace(/^(bbcl=)([0-9]+)/, function (matchStr, m1, m2) {
                    return m1 + (parseInt(m2, 10) + 1);
                }) + ">";
            }
        });
        return tagContents;
    }
    /*
        This function removes the metadata added by the updateTagDepths function
    */
    function unprocess(tagContent) {
        return tagContent.replace(/<bbcl=[0-9]+ \/\*>/gi, "").replace(/<bbcl=[0-9]+ /gi, "&#91;").replace(/>/gi, "&#93;");
    }
    var replaceFunct = function (matchStr, bbcodeLevel, tagName, tagParams, tagContents) {
        tagName = tagName.toLowerCase();
        var processedContent = _tags[tagName].noParse ? unprocess(tagContents) : tagContents.replace(bbRegExp, replaceFunct), openTag = _tags[tagName].openTag(tagParams, processedContent), closeTag = _tags[tagName].closeTag(tagParams, processedContent);
        if (_tags[tagName].displayContent === false) {
            processedContent = "";
        }
        return openTag + processedContent + closeTag;
    };
    function parse(config) {
        var output = config.text;
        output = output.replace(bbRegExp, replaceFunct);
        return output;
    }
    /*
        The star tag [*] is special in that it does not use a closing tag. Since this parser requires that _tags to have a closing
        tag, we must pre-process the input and add in closing _tags [/*] for the star tag.
        We have a little levaridge in that we know the text we're processing wont contain the <> characters (they have been
        changed into their HTML entity form to prevent XSS and code injection), so we can use those characters as markers to
        help us define boundaries and figure out where to place the [/*] _tags.
    */
    function fixStarTag(text) {
        text = text.replace(/\[(?!\*[ =\]]|list([ =][^\]]*)?\]|\/list[\]])/ig, "<");
        text = text.replace(/\[(?=list([ =][^\]]*)?\]|\/list[\]])/ig, ">");
        while (text !== (text = text.replace(/>list([ =][^\]]*)?\]([^>]*?)(>\/list])/gi, function (matchStr, contents, endTag) {
            var innerListTxt = matchStr;
            while (innerListTxt !== (innerListTxt = innerListTxt.replace(/\[\*\]([^\[]*?)(\[\*\]|>\/list])/i, function (matchStr, contents, endTag) {
                if (endTag.toLowerCase() === ">/list]") {
                    endTag = "</*]</list]";
                }
                else {
                    endTag = "</*][*]";
                }
                return "<*]" + contents + endTag;
            })))
                ;
            innerListTxt = innerListTxt.replace(/>/g, "<");
            return innerListTxt;
        })))
            ;
        // add ['s for our _tags back in
        text = text.replace(/</g, "[");
        return text;
    }
    function addBbcodeLevels(text) {
        while (text !== (text = text.replace(pbbRegExp, function (matchStr, tagName, tagParams, tagContents) {
            matchStr = matchStr.replace(/\[/g, "<");
            matchStr = matchStr.replace(/\]/g, ">");
            return updateTagDepths(matchStr);
        })))
            ;
        return text;
    }
    // -----------------------------------------------------------------------------
    // public functions
    // -----------------------------------------------------------------------------
    // API, Expose all available _tags
    function tags() {
        return _tags;
    }
    XBBCODE.tags = tags;
    ;
    function addTags(...tags) {
        for (const tag of tags)
            _tags[tag.tag] = tag.function;
        initTags();
    }
    XBBCODE.addTags = addTags;
    ;
    class ProcessResult {
    }
    XBBCODE.ProcessResult = ProcessResult;
    function process(config) {
        let result = new ProcessResult();
        result.errorQueue = [];
        config.text = config.text.replace(/</g, "&lt;"); // escape HTML tag brackets
        config.text = config.text.replace(/>/g, "&gt;"); // escape HTML tag brackets
        config.text = config.text.replace(openTags, function (matchStr, openB, contents, closeB) {
            return "<" + contents + ">";
        });
        config.text = config.text.replace(closeTags, function (matchStr, openB, contents, closeB) {
            return "<" + contents + ">";
        });
        config.text = config.text.replace(/\[/g, "&#91;"); // escape ['s that aren't apart of _tags
        config.text = config.text.replace(/\]/g, "&#93;"); // escape ['s that aren't apart of _tags
        config.text = config.text.replace(/</g, "["); // escape ['s that aren't apart of _tags
        config.text = config.text.replace(/>/g, "]"); // escape ['s that aren't apart of _tags
        // process _tags that don't have their content parsed
        while (config.text !== (config.text = config.text.replace(pbbRegExp2, function (matchStr, tagName, tagParams, tagContents) {
            tagContents = tagContents.replace(/\[/g, "&#91;");
            tagContents = tagContents.replace(/\]/g, "&#93;");
            tagParams = tagParams || "";
            tagContents = tagContents || "";
            return "[" + tagName + tagParams + "]" + tagContents + "[/" + tagName + "]";
        })))
            ;
        config.text = fixStarTag(config.text); // add in closing _tags for the [*] tag
        config.text = config.text.replace(/\[hr](?!.*\[\/hr])/gmi, "[hr][/hr]"); /* fix hr tag */
        config.text = addBbcodeLevels(config.text); // add in level metadata
        result.errorQueue = checkParentChildRestrictions("bbcode", config.text, -1, "", "", config.text);
        result.html = parse(config);
        if (result.html.indexOf("[") !== -1 || result.html.indexOf("]") !== -1) {
            result.errorQueue.push("Some _tags appear to be misaligned.");
        }
        if (config.removeMisalignedTags) {
            result.html = result.html.replace(/\[.*?\]/g, "");
        }
        if (config.addInLineBreaks) {
            result.html = '<div style="white-space:pre-wrap;" class="xbbcode">' + result.html + '</div>';
        }
        if (!config.escapeHtml) {
            result.html = result.html.replace("&#91;", "["); // put ['s back in
            result.html = result.html.replace("&#93;", "]"); // put ['s back in
        }
        if (result.errorQueue.length == 0) {
            result.error = false;
            result.errorQueue = undefined;
        }
        else {
            result.error = true;
        }
        return result;
    }
    XBBCODE.process = process;
    ;
})(XBBCODE || (XBBCODE = {}));
// for node
if (typeof module !== "undefined") {
    module.exports = XBBCODE;
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["c5a4df251acb643eb28106ce8717f45175419ab35716306c47205feed36d9f63"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["c5a4df251acb643eb28106ce8717f45175419ab35716306c47205feed36d9f63"] = "c5a4df251acb643eb28106ce8717f45175419ab35716306c47205feed36d9f63";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "duU0vpBu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (115,21)" }, { name: "eYao7XSD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (195,30)" }, { name: "McakOHHo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (229,30)" }, { name: "ZU72MfS4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (242,46)" }, { name: "riQmmREd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (288,58)" }, { name: "L8dZ6yuP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (294,55)" }, { name: "hBG8lx6q", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (300,51)" }, { name: "O1LcFZnd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (302,50)" }, { name: "QUm3F08S", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (307,27)" }, { name: "BDzWXOTZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (557,49)" }, { name: "GQBbA4d2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (559,60)" }, { name: "giI2uwWn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (567,69)" }, { name: "TkCCwlnO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (587,54)" }, { name: "eaqkBo8T", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (587,112)" }, { name: "gjItfEcC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (600,54)" }, { name: "mJM2N4ze", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (600,113)" }, { name: "X5wfUw7U", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (612,50)" }, { name: "J5WyCjGp", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (612,108)" }, { name: "Mp4pSKFf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (635,50)" }, { name: "Ep_UONzI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (635,83)" }, { name: "dQtgLsWM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (644,50)" }, { name: "sBLlmSIc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (644,81)" }, { name: "BCFHX2Ud", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (656,50)" }, { name: "n0_CRBtr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (656,77)" }, { name: "Ir7GxIW2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (658,50)" }, { name: "ytXwnL7h", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (658,83)" }, { name: "lkcd64pV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (821,25)" }, { name: "gPd_YgqP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (822,25)" }, { name: "oEO53aVK", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/SelectedItemInfo.ts (823,25)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../../../vendor/bbcode/xbbcode.ts" />
class InfoManagerBase {
    constructor() {
        this.timers = [];
        this.intervals = [];
    }
    resetTimers() {
        for (let timer of this.timers)
            clearTimeout(timer);
        this.timers = [];
    }
    resetIntervals() {
        for (let interval of this.intervals)
            clearInterval(interval);
        this.intervals = [];
    }
    registerTimer(timer) {
        this.timers.push(timer);
    }
    registerInterval(interval) {
        this.intervals.push(interval);
    }
}
class InfoManager extends InfoManagerBase {
    createFrame(handle, object, html_tag) {
        this.handle = handle;
    }
    finalizeFrame(object, frame) {
        this.resetIntervals();
        this.resetTimers();
        this.handle = undefined;
    }
    triggerUpdate() {
        if (this.handle)
            this.handle.update();
    }
}
class InfoBar {
    constructor(client) {
        this._current_manager = undefined;
        this.managers = [];
        this.handle = client;
        this._tag = $("#tmpl_select_info").renderTag();
        this._tag_info = this._tag.find(".container-select-info");
        this._tag_banner = this._tag.find(".container-banner");
        this.managers.push(new MusicInfoManager());
        this.managers.push(new ClientInfoManager());
        this.managers.push(new ChannelInfoManager());
        this.managers.push(new ServerInfoManager());
        this.banner_manager = new Hostbanner(client, this._tag_banner);
        this._tag.find("button.close").on('click', () => this.close_popover());
    }
    get_tag() {
        return this._tag;
    }
    handle_resize() {
        /* test if the popover isn't a popover anymore */
        if (this._tag.parent().hasClass('shown')) {
            this._tag.parent().removeClass('shown');
            if (this.is_popover())
                this._tag.parent().addClass('shown');
        }
        this.banner_manager.handle_resize();
    }
    setCurrentSelected(entry) {
        if (this.current_selected == entry)
            return;
        if (this._current_manager) {
            this._current_manager.finalizeFrame(this.current_selected, this._tag_info);
            this._current_manager = null;
            this.current_selected = null;
        }
        this._tag_info.empty();
        this.current_selected = entry;
        for (let manager of this.managers) {
            if (manager.available(this.current_selected)) {
                this._current_manager = manager;
                break;
            }
        }
        console.log(_translations.duU0vpBu || (_translations.duU0vpBu = tr("Using info manager: %o")), this._current_manager);
        if (this._current_manager)
            this._current_manager.createFrame(this, this.current_selected, this._tag_info);
    }
    get currentSelected() {
        return this.current_selected;
    }
    update() {
        if (this._current_manager && this.current_selected)
            this._current_manager.updateFrame(this.current_selected, this._tag_info);
    }
    update_banner() {
        this.banner_manager.update();
    }
    current_manager() { return this._current_manager; }
    is_popover() {
        return !this._tag.parent().is(':visible') || this._tag.parent().hasClass('shown');
    }
    open_popover() {
        this._tag.parent().toggleClass('shown', true);
        this.banner_manager.handle_resize();
    }
    close_popover() {
        this._tag.parent().toggleClass('shown', false);
    }
    rendered_tag() {
        return this._tag_info;
    }
}
class Hostbanner {
    constructor(client, htmlTag) {
        this.client = client;
        this.html_tag = htmlTag;
    }
    update() {
        if (this.updater) {
            clearTimeout(this.updater);
            this.updater = undefined;
        }
        const tag = this.generate_tag();
        if (tag) {
            tag.then(element => {
                const children = this.html_tag.children();
                this.html_tag.append(element).removeClass("disabled");
                /* allow the new image be loaded from cache URL */
                {
                    children
                        .css('z-index', '2')
                        .css('position', 'absolute')
                        .css('height', '100%')
                        .css('width', '100%');
                    setTimeout(() => {
                        children.detach();
                    }, 250);
                }
            }).catch(error => {
                console.warn(_translations.eYao7XSD || (_translations.eYao7XSD = tr("Failed to load hostbanner: %o")), error);
                this.html_tag.empty().addClass("disabled");
            });
        }
        else {
            this.html_tag.empty().addClass("disabled");
        }
    }
    handle_resize() {
        this.html_tag.find("[x-divider-require-resize]").trigger('resize');
    }
    generate_tag() {
        if (!this.client.connected)
            return undefined;
        const server = this.client.channelTree.server;
        if (!server)
            return undefined;
        if (!server.properties.virtualserver_hostbanner_gfx_url)
            return undefined;
        let properties = {};
        for (let key in server.properties)
            properties["property_" + key] = server.properties[key];
        properties["hostbanner_gfx_url"] = server.properties.virtualserver_hostbanner_gfx_url;
        if (server.properties.virtualserver_hostbanner_gfx_interval > 0) {
            const update_interval = Math.max(server.properties.virtualserver_hostbanner_gfx_interval, 60);
            const update_timestamp = (Math.floor((Date.now() / 1000) / update_interval) * update_interval).toString();
            try {
                const url = new URL(server.properties.virtualserver_hostbanner_gfx_url);
                if (url.search.length == 0)
                    properties["hostbanner_gfx_url"] += "?_ts=" + update_timestamp;
                else
                    properties["hostbanner_gfx_url"] += "&_ts=" + update_timestamp;
            }
            catch (error) {
                console.warn(_translations.McakOHHo || (_translations.McakOHHo = tr("Failed to parse banner URL: %o")), error);
                properties["hostbanner_gfx_url"] += "&_ts=" + update_timestamp;
            }
            this.updater = setTimeout(() => this.update(), update_interval * 1000);
        }
        const rendered = $("#tmpl_selected_hostbanner").renderTag(properties);
        /* ration watcher */
        if (server.properties.virtualserver_hostbanner_mode == 2) {
            const jimage = rendered.find(".meta-image");
            if (jimage.length == 0) {
                log.warn(LogCategory.SERVER, _translations.ZU72MfS4 || (_translations.ZU72MfS4 = tr("Missing hostbanner meta image tag")));
            }
            else {
                const image = jimage[0];
                image.onload = event => {
                    const image = jimage[0];
                    rendered.on('resize', event => {
                        const container = rendered.parent();
                        container.css('height', null);
                        container.css('flex-grow', '1');
                        const max_height = rendered.visible_height();
                        const max_width = rendered.visible_width();
                        container.css('flex-grow', '0');
                        const original_height = image.naturalHeight;
                        const original_width = image.naturalWidth;
                        const ratio_height = max_height / original_height;
                        const ratio_width = max_width / original_width;
                        const ratio = Math.min(ratio_height, ratio_width);
                        if (ratio == 0)
                            return;
                        const hostbanner_height = ratio * original_height;
                        container.css('height', Math.ceil(hostbanner_height) + "px");
                        /* the width is ignorable*/
                    });
                    setTimeout(() => rendered.trigger('resize'), 100);
                };
            }
        }
        if (window.fetch) {
            return (() => __awaiter(this, void 0, void 0, function* () {
                const start = Date.now();
                const tag_image = rendered.find(".hostbanner-image");
                _fetch: try {
                    const result = yield fetch(properties["hostbanner_gfx_url"]);
                    if (!result.ok) {
                        if (result.type === 'opaque' || result.type === 'opaqueredirect') {
                            log.warn(LogCategory.SERVER, _translations.riQmmREd || (_translations.riQmmREd = tr("Could not load hostbanner because 'Access-Control-Allow-Origin' isnt valid!")));
                            break _fetch;
                        }
                    }
                    if (this._hostbanner_url) {
                        log.debug(LogCategory.SERVER, _translations.L8dZ6yuP || (_translations.L8dZ6yuP = tr("Revoked old hostbanner url %s")), this._hostbanner_url);
                        URL.revokeObjectURL(this._hostbanner_url);
                    }
                    const url = (this._hostbanner_url = URL.createObjectURL(yield result.blob()));
                    tag_image.css('background-image', 'url(' + url + ')');
                    tag_image.attr('src', url);
                    log.debug(LogCategory.SERVER, _translations.hBG8lx6q || (_translations.hBG8lx6q = tr("Fetsched hostbanner successfully (%o, type: %o, url: %o)")), Date.now() - start, result.type, url);
                }
                catch (error) {
                    log.warn(LogCategory.SERVER, _translations.O1LcFZnd || (_translations.O1LcFZnd = tr("Failed to fetch hostbanner image: %o")), error);
                }
                return rendered;
            }))();
        }
        else {
            console.debug(_translations.QUm3F08S || (_translations.QUm3F08S = tr("Hostbanner has been loaded")));
            return Promise.resolve(rendered);
        }
    }
}
class ClientInfoManager extends InfoManager {
    available(object) {
        return typeof object == "object" && object instanceof ClientEntry;
    }
    createFrame(handle, client, html_tag) {
        super.createFrame(handle, client, html_tag);
        client.updateClientVariables();
        this.updateFrame(client, html_tag);
    }
    updateFrame(client, html_tag) {
        this.resetIntervals();
        html_tag.empty();
        let properties = this.buildProperties(client);
        let rendered = $("#tmpl_selected_client").renderTag(properties);
        html_tag.append(rendered);
        this.registerInterval(setInterval(() => {
            html_tag.find(".update_onlinetime").text(formatDate(client.calculateOnlineTime()));
        }, 1000));
    }
    buildProperties(client) {
        let properties = {};
        properties["client_name"] = client.createChatTag()[0];
        properties["client_onlinetime"] = formatDate(client.calculateOnlineTime());
        properties["sound_volume"] = client.get_audio_handle() ? client.get_audio_handle().get_volume() * 100 : -1;
        properties["client_is_query"] = client.properties.client_type == ClientType.CLIENT_QUERY;
        properties["client_is_web"] = client.properties.client_type_exact == ClientType.CLIENT_WEB;
        properties["group_server"] = [];
        for (let groupId of client.assignedServerGroupIds()) {
            let group = client.channelTree.client.groups.serverGroup(groupId);
            if (!group)
                continue;
            let group_property = {};
            group_property["group_id"] = groupId;
            group_property["group_name"] = group.name;
            properties["group_server"].push(group_property);
            properties["group_" + groupId + "_icon"] = client.channelTree.client.fileManager.icons.generateTag(group.properties.iconid);
        }
        let group = client.channelTree.client.groups.channelGroup(client.assignedChannelGroup());
        if (group) {
            properties["group_channel"] = group.id;
            properties["group_" + group.id + "_name"] = group.name;
            properties["group_" + group.id + "_icon"] = client.channelTree.client.fileManager.icons.generateTag(group.properties.iconid);
        }
        for (let key in client.properties)
            properties["property_" + key] = client.properties[key];
        if (client.properties.client_teaforum_id > 0) {
            properties["teaspeak_forum"] = $.spawn("a")
                .attr("href", "//forum.teaspeak.de/index.php?members/" + client.properties.client_teaforum_id)
                .attr("target", "_blank")
                .text(client.properties.client_teaforum_id);
        }
        if (client.properties.client_flag_avatar && client.properties.client_flag_avatar.length > 0) {
            properties["client_avatar"] = client.channelTree.client.fileManager.avatars.generate_client_tag(client);
        }
        return properties;
    }
}
class ServerInfoManager extends InfoManager {
    createFrame(handle, server, html_tag) {
        super.createFrame(handle, server, html_tag);
        if (server.shouldUpdateProperties())
            server.updateProperties();
        this.updateFrame(server, html_tag);
    }
    updateFrame(server, html_tag) {
        this.resetIntervals();
        html_tag.empty();
        let properties = {};
        properties["server_name"] = $.spawn("a").text(server.properties.virtualserver_name);
        properties["server_onlinetime"] = formatDate(server.calculateUptime());
        properties["server_address"] = server.remote_address.host + (server.remote_address.port == 9987 ? "" : ":" + server.remote_address.port);
        const peer_address = server.channelTree.client.serverConnection.remote_address();
        properties["server_peer_address"] = peer_address.host + (peer_address.port == 9987 ? "" : ":" + server.remote_address.port);
        properties["hidden_clients"] = Math.max(0, server.properties.virtualserver_clientsonline - server.channelTree.clients.length);
        for (let key in server.properties)
            properties["property_" + key] = server.properties[key];
        let rendered = $("#tmpl_selected_server").renderTag([properties]);
        this.registerInterval(setInterval(() => {
            html_tag.find(".update_onlinetime").text(formatDate(server.calculateUptime()));
        }, 1000));
        {
            const disabled = !server.shouldUpdateProperties();
            let requestUpdate = rendered.find(".button-update");
            requestUpdate
                .prop("disabled", disabled)
                .toggleClass('btn-success', !disabled)
                .toggleClass('btn-danger', disabled);
            requestUpdate.click(() => {
                server.updateProperties();
                this.triggerUpdate();
            });
            this.registerTimer(setTimeout(function () {
                requestUpdate
                    .prop("disabled", false)
                    .toggleClass('btn-success', true)
                    .toggleClass('btn-danger', false);
            }, server.nextInfoRequest - Date.now()));
        }
        html_tag.append(rendered);
    }
    available(object) {
        return typeof object == "object" && object instanceof ServerEntry;
    }
}
class ChannelInfoManager extends InfoManager {
    createFrame(handle, channel, html_tag) {
        super.createFrame(handle, channel, html_tag);
        this.updateFrame(channel, html_tag);
    }
    updateFrame(channel, html_tag) {
        this.resetIntervals();
        html_tag.empty();
        let properties = {};
        properties["channel_name"] = channel.generate_tag(false);
        properties["channel_type"] = ChannelType.normalize(channel.channelType());
        properties["channel_clients"] = channel.channelTree.clientsByChannel(channel).length;
        properties["channel_subscribed"] = true; //TODO
        properties["server_encryption"] = channel.channelTree.server.properties.virtualserver_codec_encryption_mode;
        for (let key in channel.properties)
            properties["property_" + key] = channel.properties[key];
        let tag_channel_description = $.spawn("div");
        properties["bbcode_channel_description"] = tag_channel_description;
        channel.getChannelDescription().then(description => {
            let result = XBBCODE.process({
                text: description,
                escapeHtml: true,
                addInLineBreaks: true
            });
            if (result.error) {
                console.log("BBCode parse error: %o", result.errorQueue);
            }
            tag_channel_description.html(result.html)
                .css("overflow-y", "auto")
                .css("flex-grow", "1");
        });
        let rendered = $("#tmpl_selected_channel").renderTag([properties]);
        html_tag.append(rendered);
    }
    available(object) {
        return typeof object == "object" && object instanceof ChannelEntry;
    }
}
function format_time(time) {
    let hours = 0, minutes = 0, seconds = 0;
    if (time >= 60 * 60) {
        hours = Math.floor(time / (60 * 60));
        time -= hours * 60 * 60;
    }
    if (time >= 60) {
        minutes = Math.floor(time / 60);
        time -= minutes * 60;
    }
    seconds = time;
    if (hours > 9)
        hours = hours.toString();
    else if (hours > 0)
        hours = '0' + hours.toString();
    else
        hours = '';
    if (minutes > 9)
        minutes = minutes.toString();
    else if (minutes > 0)
        minutes = '0' + minutes.toString();
    else
        minutes = '00';
    if (seconds > 9)
        seconds = seconds.toString();
    else if (seconds > 0)
        seconds = '0' + seconds.toString();
    else
        seconds = '00';
    return (hours ? hours + ":" : "") + minutes + ':' + seconds;
}
var MusicPlayerState;
(function (MusicPlayerState) {
    MusicPlayerState[MusicPlayerState["SLEEPING"] = 0] = "SLEEPING";
    MusicPlayerState[MusicPlayerState["LOADING"] = 1] = "LOADING";
    MusicPlayerState[MusicPlayerState["PLAYING"] = 2] = "PLAYING";
    MusicPlayerState[MusicPlayerState["PAUSED"] = 3] = "PAUSED";
    MusicPlayerState[MusicPlayerState["STOPPED"] = 4] = "STOPPED";
})(MusicPlayerState || (MusicPlayerState = {}));
class MusicInfoManager extends ClientInfoManager {
    createFrame(handle, channel, html_tag) {
        super.createFrame(handle, channel, html_tag);
        this.updateFrame(channel, html_tag);
    }
    updateFrame(bot, html_tag) {
        if (this.single_handler) {
            this.handle.handle.serverConnection.command_handler_boss().remove_single_handler(this.single_handler);
            this.single_handler = undefined;
        }
        this.resetIntervals();
        html_tag.empty();
        let properties = super.buildProperties(bot);
        { //Render info frame
            if (bot.properties.player_state < MusicPlayerState.PLAYING) {
                properties["music_player"] = $("#tmpl_music_frame_empty").renderTag().css("align-self", "center");
            }
            else {
                let frame = $.spawn("div").text(_translations.BDzWXOTZ || (_translations.BDzWXOTZ = tr("loading...")));
                properties["music_player"] = frame;
                properties["song_url"] = $.spawn("a").text(_translations.GQBbA4d2 || (_translations.GQBbA4d2 = tr("loading...")));
                bot.requestPlayerInfo().then(info => {
                    let timestamp = Date.now();
                    console.log(info);
                    let _frame = $("#tmpl_music_frame").renderTag({
                        song_name: info.player_title ? info.player_title :
                            info.song_url ? info.song_url : _translations.giI2uwWn || (_translations.giI2uwWn = tr("No title or url")),
                        song_url: info.song_url,
                        thumbnail: info.song_thumbnail && info.song_thumbnail.length > 0 ? info.song_thumbnail : undefined
                    }).css("align-self", "center");
                    properties["song_url"].text(info.song_url);
                    frame.replaceWith(_frame);
                    frame = _frame;
                    /* Play/Pause logic */
                    {
                        let button_play = frame.find(".button_play");
                        let button_pause = frame.find(".button_pause");
                        let button_stop = frame.find('.button_stop');
                        button_play.click(handler => {
                            if (!button_play.hasClass("active")) {
                                this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                    bot_id: bot.properties.client_database_id,
                                    action: 1
                                }).then(updated => this.triggerUpdate()).catch(error => {
                                    createErrorModal(_translations.TkCCwlnO || (_translations.TkCCwlnO = tr("Failed to execute play")), MessageHelper.formatMessage(_translations.eaqkBo8T || (_translations.eaqkBo8T = tr("Failed to execute play.<br>{}")), error)).open();
                                    this.triggerUpdate();
                                });
                            }
                            button_pause.show();
                            button_play.hide();
                        });
                        button_pause.click(handler => {
                            if (!button_pause.hasClass("active")) {
                                this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                    bot_id: bot.properties.client_database_id,
                                    action: 2
                                }).then(updated => this.triggerUpdate()).catch(error => {
                                    createErrorModal(_translations.gjItfEcC || (_translations.gjItfEcC = tr("Failed to execute pause")), MessageHelper.formatMessage(_translations.mJM2N4ze || (_translations.mJM2N4ze = tr("Failed to execute pause.<br>{}")), error)).open();
                                    this.triggerUpdate();
                                });
                            }
                            button_play.show();
                            button_pause.hide();
                        });
                        button_stop.click(handler => {
                            this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                bot_id: bot.properties.client_database_id,
                                action: 0
                            }).then(updated => this.triggerUpdate()).catch(error => {
                                createErrorModal(_translations.X5wfUw7U || (_translations.X5wfUw7U = tr("Failed to execute stop")), MessageHelper.formatMessage(_translations.J5WyCjGp || (_translations.J5WyCjGp = tr("Failed to execute stop.<br>{}")), error)).open();
                                this.triggerUpdate();
                            });
                        });
                        if (bot.properties.player_state == 2) {
                            button_play.hide();
                            button_pause.show();
                        }
                        else if (bot.properties.player_state == 3) {
                            button_pause.hide();
                            button_play.show();
                        }
                        else if (bot.properties.player_state == 4) {
                            button_pause.hide();
                            button_play.show();
                        }
                    }
                    { /* Button functions */
                        _frame.find(".btn-forward").click(() => {
                            this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                bot_id: bot.properties.client_database_id,
                                action: 3
                            }).then(updated => this.triggerUpdate()).catch(error => {
                                createErrorModal(_translations.Mp4pSKFf || (_translations.Mp4pSKFf = tr("Failed to execute forward")), (_translations.Ep_UONzI || (_translations.Ep_UONzI = tr("Failed to execute pause.<br>{}"))).format(error)).open();
                                this.triggerUpdate();
                            });
                        });
                        _frame.find(".btn-rewind").click(() => {
                            this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                bot_id: bot.properties.client_database_id,
                                action: 4
                            }).then(updated => this.triggerUpdate()).catch(error => {
                                createErrorModal(_translations.dQtgLsWM || (_translations.dQtgLsWM = tr("Failed to execute rewind")), (_translations.sBLlmSIc || (_translations.sBLlmSIc = tr("Failed to execute pause.<br>{}"))).format(error)).open();
                                this.triggerUpdate();
                            });
                        });
                        _frame.find(".btn-settings").click(() => {
                            this.handle.handle.serverConnection.command_helper.request_playlist_list().then(lists => {
                                for (const entry of lists) {
                                    if (entry.playlist_id == bot.properties.client_playlist_id) {
                                        Modals.spawnPlaylistEdit(bot.channelTree.client, entry);
                                        return;
                                    }
                                }
                                createErrorModal(_translations.BCFHX2Ud || (_translations.BCFHX2Ud = tr("Invalid permissions")), _translations.n0_CRBtr || (_translations.n0_CRBtr = tr("You don't have to see the bots playlist."))).open();
                            }).catch(error => {
                                createErrorModal(_translations.Ir7GxIW2 || (_translations.Ir7GxIW2 = tr("Failed to query playlist.")), _translations.ytXwnL7h || (_translations.ytXwnL7h = tr("Failed to query playlist info."))).open();
                            });
                        });
                    }
                    /* Required flip card javascript */
                    frame.find(".right").mouseenter(() => {
                        frame.find(".controls-overlay").addClass("flipped");
                    });
                    frame.find(".right").mouseleave(() => {
                        frame.find(".controls-overlay").removeClass("flipped");
                    });
                    /* Slider */
                    frame.find(".timeline .slider").on('mousedown', ev => {
                        let timeline = frame.find(".timeline");
                        let time = frame.find(".time");
                        let slider = timeline.find(".slider");
                        let slider_old = slider.css("margin-left");
                        let time_max = parseInt(timeline.attr("time-max"));
                        slider.prop("editing", true);
                        let target_timestamp = 0;
                        let move_handler = (event) => {
                            let max = timeline.width();
                            let current = event.pageX - timeline.offset().left - slider.width() / 2;
                            if (current < 0)
                                current = 0;
                            else if (current > max)
                                current = max;
                            target_timestamp = current / max * time_max;
                            time.text(format_time(Math.floor(target_timestamp / 1000)));
                            slider.css("margin-left", current / max * 100 + "%");
                        };
                        let finish_handler = event => {
                            console.log("Event (%i | %s): %o", event.button, event.type, event);
                            if (event.type == "mousedown" && event.button != 2)
                                return;
                            $(document).unbind("mousemove", move_handler);
                            $(document).unbind("mouseup mouseleave mousedown", finish_handler);
                            if (event.type != "mousedown") {
                                slider.prop("editing", false);
                                slider.prop("edited", true);
                                let current_timestamp = info.player_replay_index + Date.now() - timestamp;
                                this.handle.handle.serverConnection.send_command("musicbotplayeraction", {
                                    bot_id: bot.properties.client_database_id,
                                    action: current_timestamp > target_timestamp ? 6 : 5,
                                    units: current_timestamp < target_timestamp ? target_timestamp - current_timestamp : current_timestamp - target_timestamp
                                }).then(() => this.triggerUpdate()).catch(error => {
                                    slider.prop("edited", false);
                                });
                            }
                            else { //Restore old
                                event.preventDefault();
                                slider.css("margin-left", slider_old + "%");
                            }
                        };
                        $(document).on('mousemove', move_handler);
                        $(document).on('mouseup mouseleave mousedown', finish_handler);
                        ev.preventDefault();
                        return false;
                    });
                    {
                        frame.find(".timeline").attr("time-max", info.player_max_index);
                        let timeline = frame.find(".timeline");
                        let time_bar = timeline.find(".played");
                        let buffered_bar = timeline.find(".buffered");
                        let slider = timeline.find(".slider");
                        let player_time = _frame.find(".player_time");
                        let update_handler = (played, buffered) => {
                            let time_index = played || info.player_replay_index + (bot.properties.player_state == 2 ? Date.now() - timestamp : 0);
                            let buffered_index = buffered || 0;
                            time_bar.css("width", time_index / info.player_max_index * 100 + "%");
                            buffered_bar.css("width", buffered_index / info.player_max_index * 100 + "%");
                            if (!slider.prop("editing") && !slider.prop("edited")) {
                                player_time.text(format_time(Math.floor(time_index / 1000)));
                                slider.css("margin-left", time_index / info.player_max_index * 100 + "%");
                            }
                        };
                        let interval = setInterval(update_handler, 1000);
                        this.registerInterval(interval);
                        update_handler();
                        /* register subscription */
                        this.handle.handle.serverConnection.send_command("musicbotsetsubscription", { bot_id: bot.properties.client_database_id }).catch(error => {
                            console.error("Failed to subscribe to displayed music bot! Using pseudo timeline");
                        }).then(() => {
                            clearInterval(interval);
                        });
                        this.single_handler = {
                            command: "notifymusicstatusupdate",
                            function: command => {
                                const json = command.arguments[0];
                                update_handler(parseInt(json["player_replay_index"]), parseInt(json["player_buffered_index"]));
                                return false; /* do not unregister me! */
                            }
                        };
                        this.handle.handle.serverConnection.command_handler_boss().register_single_handler(this.single_handler);
                    }
                });
            }
            const player = properties["music_player"];
            const player_transformer = $.spawn("div").append(player);
            player_transformer.css({
                'display': 'block',
                //'width': "100%",
                'height': '100%'
            });
            properties["music_player"] = player_transformer;
        }
        let rendered = $("#tmpl_selected_music").renderTag([properties]);
        html_tag.append(rendered);
        {
            const player = properties["music_player"];
            const player_width = 400; //player.width();
            const player_height = 400; //player.height();
            const parent = player.parent();
            parent.css({
                'flex-grow': 1,
                'display': 'flex',
                'flex-direction': 'row',
                'justify-content': 'space-around',
            });
            const padding = 14;
            const scale_x = Math.min((parent.width() - padding) / player_width, 1.5);
            const scale_y = Math.min((parent.height() - padding) / player_height, 1.5);
            let scale = Math.min(scale_x, scale_y);
            let translate_x = 50, translate_y = 50;
            if (scale_x == scale_y && scale_x == scale) {
                //Equal scale
            }
            else if (scale_x == scale) {
                //We scale on the x-Axis
                //We have to adjust the y-Axis
            }
            else {
                //We scale on the y-Axis
                //We have to adjust the x-Axis
            }
            //1 => 0 | 0
            //1.5 => 0 | 25
            //0.5 => 0 | -25
            //const translate_x = scale_x != scale ? 0 : undefined || 50 - (50 * ((parent.width() - padding) / player_width));
            //const translate_y = scale_y != scale || scale_y > 1 ? 0 : undefined || 50 - (50 * ((parent.height() - padding) / player_height));
            const transform = ("translate(0%, " + (scale * 50 - 50) + "%) scale(" + scale.toPrecision(2) + ")");
            console.log(_translations.lkcd64pV || (_translations.lkcd64pV = tr("Parents: %o | %o")), parent.width(), parent.height());
            console.log(_translations.gPd_YgqP || (_translations.gPd_YgqP = tr("Player: %o | %o")), player_width, player_height);
            console.log(_translations.oEO53aVK || (_translations.oEO53aVK = tr("Scale: %f => translate: %o | %o")), scale, translate_x, translate_y);
            player.css({
                transform: transform
            });
            console.log("Transform: " + transform);
        }
        this.registerInterval(setInterval(() => {
            html_tag.find(".update_onlinetime").text(formatDate(bot.calculateOnlineTime()));
        }, 1000));
    }
    update_local_volume(volume) {
        this.handle.rendered_tag().find(".property-volume-local").text(Math.floor(volume * 100) + "%");
    }
    update_remote_volume(volume) {
        this.handle.rendered_tag().find(".property-volume-remote").text(Math.floor(volume * 100) + "%");
    }
    available(object) {
        return typeof object == "object" && object instanceof MusicClientEntry;
    }
    finalizeFrame(object, frame) {
        if (this.single_handler) {
            this.handle.handle.serverConnection.command_handler_boss().remove_single_handler(this.single_handler);
            this.single_handler = undefined;
        }
        super.finalizeFrame(object, frame);
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["056f06be22a935a8fe9b6fbfd2cf053a8ca22fcb11af36dc603220d77d090fed"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["056f06be22a935a8fe9b6fbfd2cf053a8ca22fcb11af36dc603220d77d090fed"] = "056f06be22a935a8fe9b6fbfd2cf053a8ca22fcb11af36dc603220d77d090fed";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "EB4UTtE2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/ConnectionBase.ts (142,30)" }, { name: "cC3ZNRLt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/ConnectionBase.ts (171,35)" }, { name: "NwpmO0ub", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/ConnectionBase.ts (183,35)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var connection;
(function (connection_1) {
    connection_1.CommandOptionDefaults = {
        flagset: [],
        process_result: true,
        timeout: 1000
    };
    class AbstractServerConnection {
        constructor(client) {
            this.client = client;
            this.command_helper = new connection_1.CommandHelper(this);
        }
    }
    connection_1.AbstractServerConnection = AbstractServerConnection;
    let voice;
    (function (voice) {
        let PlayerState;
        (function (PlayerState) {
            PlayerState[PlayerState["PREBUFFERING"] = 0] = "PREBUFFERING";
            PlayerState[PlayerState["PLAYING"] = 1] = "PLAYING";
            PlayerState[PlayerState["BUFFERING"] = 2] = "BUFFERING";
            PlayerState[PlayerState["STOPPING"] = 3] = "STOPPING";
            PlayerState[PlayerState["STOPPED"] = 4] = "STOPPED";
        })(PlayerState = voice.PlayerState || (voice.PlayerState = {}));
        class AbstractVoiceConnection {
            constructor(connection) {
                this.connection = connection;
            }
        }
        voice.AbstractVoiceConnection = AbstractVoiceConnection;
    })(voice = connection_1.voice || (connection_1.voice = {}));
    class ServerCommand {
    }
    connection_1.ServerCommand = ServerCommand;
    class AbstractCommandHandler {
        constructor(connection) {
            this.volatile_handler_boss = false; /* if true than the command handler could be registered twice to two or more handlers */
            this.ignore_consumed = false;
            this.connection = connection;
        }
    }
    connection_1.AbstractCommandHandler = AbstractCommandHandler;
    class AbstractCommandHandlerBoss {
        constructor(connection) {
            this.command_handlers = [];
            /* TODO: Timeout */
            this.single_command_handler = [];
            this.connection = connection;
        }
        register_handler(handler) {
            if (!handler.volatile_handler_boss && handler.handler_boss)
                throw "handler already registered";
            this.command_handlers.remove(handler); /* just to be sure */
            this.command_handlers.push(handler);
            handler.handler_boss = this;
        }
        unregister_handler(handler) {
            if (!handler.volatile_handler_boss && handler.handler_boss !== this) {
                console.warn(_translations.EB4UTtE2 || (_translations.EB4UTtE2 = tr("Tried to unregister command handler which does not belong to the handler boss")));
                return;
            }
            this.command_handlers.remove(handler);
            handler.handler_boss = undefined;
        }
        register_single_handler(handler) {
            this.single_command_handler.push(handler);
        }
        remove_single_handler(handler) {
            this.single_command_handler.remove(handler);
        }
        handlers() {
            return this.command_handlers;
        }
        invoke_handle(command) {
            let flag_consumed = false;
            for (const handler of this.command_handlers) {
                try {
                    if (!flag_consumed || handler.ignore_consumed)
                        flag_consumed = flag_consumed || handler.handle_command(command);
                }
                catch (error) {
                    console.error(_translations.cC3ZNRLt || (_translations.cC3ZNRLt = tr("Failed to invoke command handler. Invocation results in an exception: %o")), error);
                }
            }
            for (const handler of [...this.single_command_handler]) {
                if (handler.command && handler.command != command.command)
                    continue;
                try {
                    if (handler.function(command))
                        this.single_command_handler.remove(handler);
                }
                catch (error) {
                    console.error(_translations.NwpmO0ub || (_translations.NwpmO0ub = tr("Failed to invoke single command handler. Invocation results in an exception: %o")), error);
                }
            }
            return flag_consumed;
        }
    }
    connection_1.AbstractCommandHandlerBoss = AbstractCommandHandlerBoss;
})(connection || (connection = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["f47ba1b45e90d1a97ca693e80b8202e314ee7d63076143ed3af65b0e2fe850c7"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["f47ba1b45e90d1a97ca693e80b8202e314ee7d63076143ed3af65b0e2fe850c7"] = "f47ba1b45e90d1a97ca693e80b8202e314ee7d63076143ed3af65b0e2fe850c7";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "klE2gXlH", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (60,47)" }, { name: "qLrKi0AB", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (61,87)" }, { name: "ZXtomfjt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (68,79)" }, { name: "kPlOxnIY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (70,39)" }, { name: "JnN5O78N", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (102,29)" }, { name: "U13nD8qv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (122,29)" }, { name: "a91ZcOT8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (124,29)" }, { name: "YjEoWoq5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (147,69)" }, { name: "zBSjQToR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (161,39)" }, { name: "UBHQXyAg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (168,35)" }, { name: "FTtI5My5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (200,25)" }, { name: "fvT17QQG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (221,25)" }, { name: "Ix4ibq6c", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (225,35)" }, { name: "woXXjHwN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (235,25)" }, { name: "dc5pn_Tf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (239,35)" }, { name: "fKMNz2gH", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (293,85)" }, { name: "R_KG33GO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (295,85)" }, { name: "_hV6_tXz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (301,81)" }, { name: "edMQVOgL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (311,81)" }, { name: "azuedz8W", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (319,38)" }, { name: "g64i7oa4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (356,39)" }, { name: "sUvSnP1M", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (376,35)" }, { name: "mi7QZ4Kl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (400,81)" }, { name: "E1G2vi44", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (405,81)" }, { name: "RplgTmry", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (413,79)" }, { name: "QFvRuwg8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (421,79)" }, { name: "ZuRfw1Wm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (435,79)" }, { name: "nRIDwWuX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (445,79)" }, { name: "ZDM0I2mq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (453,39)" }, { name: "O0xfq1oI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (464,43)" }, { name: "HD5x55eH", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (482,31)" }, { name: "zp6q0e1H", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (487,31)" }, { name: "BVqDiPwL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (491,31)" }, { name: "OBH2gEn8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (508,80)" }, { name: "OHTKAoQ9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (508,133)" }, { name: "iEDIiXJN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (521,80)" }, { name: "zR9KVg4C", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (521,125)" }, { name: "YMNeADME", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (532,80)" }, { name: "s1TK0yMe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (532,151)" }, { name: "Mo1aVAwY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (546,30)" }, { name: "ipdzhSFm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (558,31)" }, { name: "cyZRRyz2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (564,31)" }, { name: "precY3Tr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (570,31)" }, { name: "iNFBwih2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (583,31)" }, { name: "iRbFmoSL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (610,35)" }, { name: "eXnQDoO0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (614,35)" }, { name: "PC7JLHc6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (645,47)" }, { name: "ayAz3afI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (649,47)" }, { name: "dMSXWlRv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (655,47)" }, { name: "dAAIZamK", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (663,27)" }, { name: "l_YCyIWk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (672,31)" }, { name: "FY6R2us2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (735,46)" }, { name: "tEIB6y1U", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (787,34)" }, { name: "orwLe7yE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHandler.ts (799,34)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="ConnectionBase.ts" />
var connection;
(function (connection_2) {
    class ServerConnectionCommandBoss extends connection_2.AbstractCommandHandlerBoss {
        constructor(connection) {
            super(connection);
        }
    }
    connection_2.ServerConnectionCommandBoss = ServerConnectionCommandBoss;
    class ConnectionCommandHandler extends connection_2.AbstractCommandHandler {
        constructor(connection) {
            super(connection);
            this.connection_handler = connection.client;
            this["error"] = this.handleCommandResult;
            this["channellist"] = this.handleCommandChannelList;
            this["channellistfinished"] = this.handleCommandChannelListFinished;
            this["notifychannelcreated"] = this.handleCommandChannelCreate;
            this["notifychanneldeleted"] = this.handleCommandChannelDelete;
            this["notifychannelhide"] = this.handleCommandChannelHide;
            this["notifychannelshow"] = this.handleCommandChannelShow;
            this["notifycliententerview"] = this.handleCommandClientEnterView;
            this["notifyclientleftview"] = this.handleCommandClientLeftView;
            this["notifyclientmoved"] = this.handleNotifyClientMoved;
            this["initserver"] = this.handleCommandServerInit;
            this["notifychannelmoved"] = this.handleNotifyChannelMoved;
            this["notifychanneledited"] = this.handleNotifyChannelEdited;
            this["notifytextmessage"] = this.handleNotifyTextMessage;
            this["notifyclientchatclosed"] = this.handleNotifyClientChatClosed;
            this["notifyclientupdated"] = this.handleNotifyClientUpdated;
            this["notifyserveredited"] = this.handleNotifyServerEdited;
            this["notifyserverupdated"] = this.handleNotifyServerUpdated;
            this["notifyclientpoke"] = this.handleNotifyClientPoke;
            this["notifymusicplayerinfo"] = this.handleNotifyMusicPlayerInfo;
            this["notifyservergroupclientadded"] = this.handleNotifyServerGroupClientAdd;
            this["notifyservergroupclientdeleted"] = this.handleNotifyServerGroupClientRemove;
            this["notifyclientchannelgroupchanged"] = this.handleNotifyClientChannelGroupChanged;
            this["notifychannelsubscribed"] = this.handleNotifyChannelSubscribed;
            this["notifychannelunsubscribed"] = this.handleNotifyChannelUnsubscribed;
        }
        proxy_command_promise(promise, options) {
            if (!options.process_result)
                return promise;
            return promise.catch(ex => {
                if (options.process_result) {
                    if (ex instanceof CommandResult) {
                        let res = ex;
                        if (!res.success) {
                            if (res.id == 2568) { //Permission error
                                res.message = (_translations.klE2gXlH || (_translations.klE2gXlH = tr("Insufficient client permissions. Failed on permission "))) + this.connection_handler.permissions.resolveInfo(res.json["failed_permid"]).name;
                                this.connection_handler.chat.serverChat().appendError(_translations.qLrKi0AB || (_translations.qLrKi0AB = tr("Insufficient client permissions. Failed on permission {}")), this.connection_handler.permissions.resolveInfo(res.json["failed_permid"]).name);
                                this.connection_handler.sound.play(Sound.ERROR_INSUFFICIENT_PERMISSIONS);
                            }
                            else {
                                this.connection_handler.chat.serverChat().appendError(res.extra_message.length == 0 ? res.message : res.extra_message);
                            }
                        }
                    }
                    else if (typeof (ex) === "string") {
                        this.connection_handler.chat.serverChat().appendError((_translations.ZXtomfjt || (_translations.ZXtomfjt = tr("Command execution results in "))) + ex);
                    }
                    else {
                        console.error(_translations.kPlOxnIY || (_translations.kPlOxnIY = tr("Invalid promise result type: %o. Result:")), typeof (ex));
                        console.error(ex);
                    }
                }
                return Promise.reject(ex);
            });
        }
        handle_command(command) {
            if (this[command.command]) {
                this[command.command](command.arguments);
                return true;
            }
            return false;
        }
        set_handler(command, handler) {
            this[command] = handler;
        }
        unset_handler(command, handler) {
            if (handler && this[command] != handler)
                return;
            this[command] = undefined;
        }
        handleCommandResult(json) {
            json = json[0]; //Only one bulk
            let code = json["return_code"];
            if (!code || code.length == 0) {
                console.log(_translations.JnN5O78N || (_translations.JnN5O78N = tr("Invalid return code! (%o)")), json);
                return;
            }
            let retListeners = this.connection["_retListener"];
            for (let e of retListeners) {
                if (e.code != code)
                    continue;
                retListeners.remove(e);
                let result = new CommandResult(json);
                if (result.success)
                    e.resolve(result);
                else
                    e.reject(result);
                break;
            }
        }
        handleCommandServerInit(json) {
            //We could setup the voice channel
            if (this.connection.support_voice()) {
                console.log(_translations.U13nD8qv || (_translations.U13nD8qv = tr("Setting up voice")));
            }
            else {
                console.log(_translations.a91ZcOT8 || (_translations.a91ZcOT8 = tr("Skipping voice setup (No voice bridge available)")));
            }
            json = json[0]; //Only one bulk
            this.connection.client.clientId = parseInt(json["aclid"]);
            this.connection.client.getClient().updateVariables({ key: "client_nickname", value: json["acn"] });
            let updates = [];
            for (let key in json) {
                if (key === "aclid")
                    continue;
                if (key === "acn")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            this.connection.client.channelTree.server.updateVariables(false, ...updates);
            this.connection_handler.chat.serverChat().name = this.connection.client.channelTree.server.properties["virtualserver_name"];
            this.connection_handler.chat.serverChat().appendMessage(_translations.YjEoWoq5 || (_translations.YjEoWoq5 = tr("Connected as {0}")), true, this.connection.client.getClient().createChatTag(true));
            this.connection_handler.sound.play(Sound.CONNECTION_CONNECTED);
            this.connection.client.onConnected();
        }
        createChannelFromJson(json, ignoreOrder = false) {
            let tree = this.connection.client.channelTree;
            let channel = new ChannelEntry(parseInt(json["cid"]), json["channel_name"], tree.findChannel(json["cpid"]));
            tree.insertChannel(channel);
            if (json["channel_order"] !== "0") {
                let prev = tree.findChannel(json["channel_order"]);
                if (!prev && json["channel_order"] != 0) {
                    if (!ignoreOrder) {
                        console.error(_translations.zBSjQToR || (_translations.zBSjQToR = tr("Invalid channel order id!")));
                        return;
                    }
                }
                let parent = tree.findChannel(json["cpid"]);
                if (!parent && json["cpid"] != 0) {
                    console.error(_translations.UBHQXyAg || (_translations.UBHQXyAg = tr("Invalid channel parent")));
                    return;
                }
                tree.moveChannel(channel, prev, parent); //TODO test if channel exists!
            }
            if (ignoreOrder) {
                for (let ch of tree.channels) {
                    if (ch.properties.channel_order == channel.channelId) {
                        tree.moveChannel(ch, channel, channel.parent); //Corrent the order :)
                    }
                }
            }
            let updates = [];
            for (let key in json) {
                if (key === "cid")
                    continue;
                if (key === "cpid")
                    continue;
                if (key === "invokerid")
                    continue;
                if (key === "invokername")
                    continue;
                if (key === "invokeruid")
                    continue;
                if (key === "reasonid")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            channel.updateVariables(...updates);
        }
        handleCommandChannelList(json) {
            this.connection.client.channelTree.hide_channel_tree(); /* dont perform channel inserts on the dom to prevent style recalculations */
            console.log(_translations.FTtI5My5 || (_translations.FTtI5My5 = tr("Got %d new channels")), json.length);
            for (let index = 0; index < json.length; index++)
                this.createChannelFromJson(json[index], true);
        }
        handleCommandChannelListFinished(json) {
            this.connection.client.channelTree.show_channel_tree();
        }
        handleCommandChannelCreate(json) {
            this.createChannelFromJson(json[0]);
        }
        handleCommandChannelShow(json) {
            this.createChannelFromJson(json[0]); //TODO may chat?
        }
        handleCommandChannelDelete(json) {
            let tree = this.connection.client.channelTree;
            console.log(_translations.fvT17QQG || (_translations.fvT17QQG = tr("Got %d channel deletions")), json.length);
            for (let index = 0; index < json.length; index++) {
                let channel = tree.findChannel(json[index]["cid"]);
                if (!channel) {
                    console.error(_translations.Ix4ibq6c || (_translations.Ix4ibq6c = tr("Invalid channel onDelete (Unknown channel)")));
                    continue;
                }
                tree.deleteChannel(channel);
            }
        }
        handleCommandChannelHide(json) {
            let tree = this.connection.client.channelTree;
            console.log(_translations.woXXjHwN || (_translations.woXXjHwN = tr("Got %d channel hides")), json.length);
            for (let index = 0; index < json.length; index++) {
                let channel = tree.findChannel(json[index]["cid"]);
                if (!channel) {
                    console.error(_translations.dc5pn_Tf || (_translations.dc5pn_Tf = tr("Invalid channel on hide (Unknown channel)")));
                    continue;
                }
                tree.deleteChannel(channel);
            }
        }
        handleCommandClientEnterView(json) {
            let tree = this.connection.client.channelTree;
            let client;
            let channel = undefined;
            let old_channel = undefined;
            let reason_id, reason_msg;
            let invokerid, invokername, invokeruid;
            for (const entry of json) {
                /* attempt to update properties if given */
                channel = typeof (entry["ctid"]) !== "undefined" ? tree.findChannel(parseInt(entry["ctid"])) : channel;
                old_channel = typeof (entry["cfid"]) !== "undefined" ? tree.findChannel(parseInt(entry["cfid"])) : old_channel;
                reason_id = typeof (entry["reasonid"]) !== "undefined" ? entry["reasonid"] : reason_id;
                reason_msg = typeof (entry["reason_msg"]) !== "undefined" ? entry["reason_msg"] : reason_msg;
                invokerid = typeof (entry["invokerid"]) !== "undefined" ? parseInt(entry["invokerid"]) : invokerid;
                invokername = typeof (entry["invokername"]) !== "undefined" ? entry["invokername"] : invokername;
                invokeruid = typeof (entry["invokeruid"]) !== "undefined" ? entry["invokeruid"] : invokeruid;
                client = tree.findClient(parseInt(entry["clid"]));
                if (!client) {
                    if (parseInt(entry["client_type_exact"]) == ClientType.CLIENT_MUSIC) {
                        client = new MusicClientEntry(parseInt(entry["clid"]), entry["client_nickname"]);
                    }
                    else {
                        client = new ClientEntry(parseInt(entry["clid"]), entry["client_nickname"]);
                    }
                    client.properties.client_type = parseInt(entry["client_type"]);
                    client = tree.insertClient(client, channel);
                }
                else {
                    if (client == this.connection.client.getClient())
                        this.connection_handler.chat.channelChat().name = channel.channelName();
                    tree.moveClient(client, channel);
                }
                if (this.connection_handler.client_status.queries_visible || client.properties.client_type != ClientType.CLIENT_QUERY) {
                    const own_channel = this.connection.client.getClient().currentChannel();
                    if (reason_id == ViewReasonId.VREASON_USER_ACTION) {
                        if (own_channel == channel)
                            if (old_channel)
                                this.connection_handler.sound.play(Sound.USER_ENTERED);
                            else
                                this.connection_handler.sound.play(Sound.USER_ENTERED_CONNECT);
                        if (old_channel) {
                            this.connection_handler.chat.serverChat().appendMessage(_translations.fKMNz2gH || (_translations.fKMNz2gH = tr("{0} appeared from {1} to {2}")), true, client.createChatTag(true), old_channel.generate_tag(true), channel.generate_tag(true));
                        }
                        else {
                            this.connection_handler.chat.serverChat().appendMessage(_translations.R_KG33GO || (_translations.R_KG33GO = tr("{0} connected to channel {1}")), true, client.createChatTag(true), channel.generate_tag(true));
                        }
                    }
                    else if (reason_id == ViewReasonId.VREASON_MOVED) {
                        if (own_channel == channel)
                            this.connection_handler.sound.play(Sound.USER_ENTERED_MOVED);
                        this.connection_handler.chat.serverChat().appendMessage(_translations._hV6_tXz || (_translations._hV6_tXz = tr("{0} appeared from {1} to {2}, moved by {3}")), true, client.createChatTag(true), old_channel ? old_channel.generate_tag(true) : undefined, channel.generate_tag(true), ClientEntry.chatTag(invokerid, invokername, invokeruid));
                    }
                    else if (reason_id == ViewReasonId.VREASON_CHANNEL_KICK) {
                        if (own_channel == channel)
                            this.connection_handler.sound.play(Sound.USER_ENTERED_KICKED);
                        this.connection_handler.chat.serverChat().appendMessage(_translations.edMQVOgL || (_translations.edMQVOgL = tr("{0} appeared from {1} to {2}, kicked by {3}{4}")), true, client.createChatTag(true), old_channel ? old_channel.generate_tag(true) : undefined, channel.generate_tag(true), ClientEntry.chatTag(invokerid, invokername, invokeruid), reason_msg.length > 0 ? " (" + entry["msg"] + ")" : "");
                    }
                    else {
                        console.warn(_translations.azuedz8W || (_translations.azuedz8W = tr("Unknown reasonid for %o")), reason_id);
                    }
                }
                let updates = [];
                for (let key in entry) {
                    if (key == "cfid")
                        continue;
                    if (key == "ctid")
                        continue;
                    if (key === "invokerid")
                        continue;
                    if (key === "invokername")
                        continue;
                    if (key === "invokeruid")
                        continue;
                    if (key === "reasonid")
                        continue;
                    updates.push({ key: key, value: entry[key] });
                }
                client.updateVariables(...updates);
                {
                    let client_chat = client.chat(false);
                    if (!client_chat) {
                        for (const c of this.connection_handler.chat.open_chats()) {
                            if (c.owner_unique_id == client.properties.client_unique_identifier && c.flag_offline) {
                                client_chat = c;
                                break;
                            }
                        }
                    }
                    if (client_chat) {
                        client_chat.appendMessage("{0}", true, $.spawn("div")
                            .addClass("event-message event-partner-connect")
                            .text(_translations.g64i7oa4 || (_translations.g64i7oa4 = tr("Your chat partner has reconnected"))));
                        client_chat.flag_offline = false;
                    }
                }
                if (client instanceof LocalClientEntry) {
                    this.connection_handler.update_voice_status();
                }
            }
        }
        handleCommandClientLeftView(json) {
            let reason_id;
            for (const entry of json) {
                reason_id = entry["reasonid"] || reason_id;
                let tree = this.connection.client.channelTree;
                let client = tree.findClient(entry["clid"]);
                if (!client) {
                    console.error(_translations.sUvSnP1M || (_translations.sUvSnP1M = tr("Unknown client left!")));
                    return 0;
                }
                if (client == this.connection.client.getClient()) {
                    if (reason_id == ViewReasonId.VREASON_BAN) {
                        this.connection.client.handleDisconnect(DisconnectReason.CLIENT_BANNED, entry);
                    }
                    else if (reason_id == ViewReasonId.VREASON_SERVER_KICK) {
                        this.connection.client.handleDisconnect(DisconnectReason.CLIENT_KICKED, entry);
                    }
                    else if (reason_id == ViewReasonId.VREASON_SERVER_SHUTDOWN) {
                        this.connection.client.handleDisconnect(DisconnectReason.SERVER_CLOSED, entry);
                    }
                    else if (reason_id == ViewReasonId.VREASON_SERVER_STOPPED) {
                        this.connection.client.handleDisconnect(DisconnectReason.SERVER_CLOSED, entry);
                    }
                    else
                        this.connection.client.handleDisconnect(DisconnectReason.UNKNOWN, entry);
                    return;
                }
                if (this.connection_handler.client_status.queries_visible || client.properties.client_type != ClientType.CLIENT_QUERY) {
                    const own_channel = this.connection.client.getClient().currentChannel();
                    let channel_from = tree.findChannel(entry["cfid"]);
                    let channel_to = tree.findChannel(entry["ctid"]);
                    if (reason_id == ViewReasonId.VREASON_USER_ACTION) {
                        this.connection_handler.chat.serverChat().appendMessage(_translations.mi7QZ4Kl || (_translations.mi7QZ4Kl = tr("{0} disappeared from {1} to {2}")), true, client.createChatTag(true), channel_from.generate_tag(true), channel_to.generate_tag(true));
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT);
                    }
                    else if (reason_id == ViewReasonId.VREASON_SERVER_LEFT) {
                        this.connection_handler.chat.serverChat().appendMessage(_translations.E1G2vi44 || (_translations.E1G2vi44 = tr("{0} left the server{1}")), true, client.createChatTag(true), entry["reasonmsg"] ? " (" + entry["reasonmsg"] + ")" : "");
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT_DISCONNECT);
                    }
                    else if (json["reasonid"] == ViewReasonId.VREASON_SERVER_KICK) {
                        this.connection_handler.chat.serverChat().appendError(_translations.RplgTmry || (_translations.RplgTmry = tr("{0} was kicked from the server by {1}.{2}")), client.createChatTag(true), ClientEntry.chatTag(entry["invokerid"], entry["invokername"], entry["invokeruid"]), entry["reasonmsg"] ? " (" + entry["reasonmsg"] + ")" : "");
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT_KICKED_SERVER);
                    }
                    else if (reason_id == ViewReasonId.VREASON_CHANNEL_KICK) {
                        this.connection_handler.chat.serverChat().appendError(_translations.QFvRuwg8 || (_translations.QFvRuwg8 = tr("{0} was kicked from your channel by {1}.{2}")), client.createChatTag(true), ClientEntry.chatTag(entry["invokerid"], entry["invokername"], entry["invokeruid"]), entry["reasonmsg"] ? " (" + entry["reasonmsg"] + ")" : "");
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT_KICKED_CHANNEL);
                    }
                    else if (reason_id == ViewReasonId.VREASON_BAN) {
                        //"Mulus" was banned for 1 second from the server by "WolverinDEV" (Sry brauchte kurz ein opfer :P <3 (Nohomo))
                        let duration = "permanently";
                        if (entry["bantime"])
                            duration = "for " + formatDate(Number.parseInt(entry["bantime"]));
                        this.connection_handler.chat.serverChat().appendError(_translations.ZuRfw1Wm || (_translations.ZuRfw1Wm = tr("{0} was banned {1} by {2}.{3}")), client.createChatTag(true), duration, ClientEntry.chatTag(entry["invokerid"], entry["invokername"], entry["invokeruid"]), entry["reasonmsg"] ? " (" + entry["reasonmsg"] + ")" : "");
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT_BANNED);
                    }
                    else if (reason_id == ViewReasonId.VREASON_TIMEOUT) {
                        this.connection_handler.chat.serverChat().appendError(_translations.nRIDwWuX || (_translations.nRIDwWuX = tr("{0} timed out ({1})")), client.createChatTag(true), entry["reasonmsg"] ? " (" + entry["reasonmsg"] + ")" : "");
                        if (channel_from == own_channel)
                            this.connection_handler.sound.play(Sound.USER_LEFT_TIMEOUT);
                    }
                    else {
                        console.error(_translations.ZDM0I2mq || (_translations.ZDM0I2mq = tr("Unknown client left reason!")));
                    }
                    {
                        const chat = client.chat(false);
                        if (chat) {
                            chat.flag_offline = true;
                            chat.appendMessage("{0}", true, $.spawn("div")
                                .addClass("event-message event-partner-disconnect")
                                .text(_translations.O0xfq1oI || (_translations.O0xfq1oI = tr("Your chat partner has disconnected"))));
                        }
                    }
                }
                tree.deleteClient(client);
            }
        }
        handleNotifyClientMoved(json) {
            json = json[0]; //Only one bulk
            let tree = this.connection.client.channelTree;
            let client = tree.findClient(json["clid"]);
            let channel_to = tree.findChannel(json["ctid"]);
            let channel_from = tree.findChannel(json["cfid"]);
            if (!client) {
                console.error(_translations.HD5x55eH || (_translations.HD5x55eH = tr("Unknown client move (Client)!")));
                return 0;
            }
            if (!channel_to) {
                console.error(_translations.zp6q0e1H || (_translations.zp6q0e1H = tr("Unknown client move (Channel to)!")));
                return 0;
            }
            if (!channel_from) //Not critical
                console.error(_translations.BVqDiPwL || (_translations.BVqDiPwL = tr("Unknown client move (Channel from)!")));
            let self = client instanceof LocalClientEntry;
            let current_clients;
            if (self) {
                this.connection_handler.chat.channelChat().name = channel_to.channelName();
                current_clients = client.channelTree.clientsByChannel(client.currentChannel());
                this.connection_handler.update_voice_status(channel_to);
            }
            tree.moveClient(client, channel_to);
            for (const entry of current_clients || [])
                if (entry !== client && entry.get_audio_handle())
                    entry.get_audio_handle().abort_replay();
            const own_channel = this.connection.client.getClient().currentChannel();
            if (json["reasonid"] == ViewReasonId.VREASON_MOVED) {
                this.connection_handler.chat.serverChat().appendMessage(self ? _translations.OBH2gEn8 || (_translations.OBH2gEn8 = tr("You was moved by {3} from channel {1} to {2}")) : _translations.OHTKAoQ9 || (_translations.OHTKAoQ9 = tr("{0} was moved from channel {1} to {2} by {3}")), true, client.createChatTag(true), channel_from ? channel_from.generate_tag(true) : undefined, channel_to.generate_tag(true), ClientEntry.chatTag(json["invokerid"], json["invokername"], json["invokeruid"]));
                if (self)
                    this.connection_handler.sound.play(Sound.USER_MOVED_SELF);
                else if (own_channel == channel_to)
                    this.connection_handler.sound.play(Sound.USER_ENTERED_MOVED);
                else if (own_channel == channel_from)
                    this.connection_handler.sound.play(Sound.USER_LEFT_MOVED);
            }
            else if (json["reasonid"] == ViewReasonId.VREASON_USER_ACTION) {
                this.connection_handler.chat.serverChat().appendMessage(self ? _translations.iEDIiXJN || (_translations.iEDIiXJN = tr("You switched from channel {1} to {2}")) : _translations.zR9KVg4C || (_translations.zR9KVg4C = tr("{0} switched from channel {1} to {2}")), true, client.createChatTag(true), channel_from ? channel_from.generate_tag(true) : undefined, channel_to.generate_tag(true));
                if (self) { } //If we do an action we wait for the error response
                else if (own_channel == channel_to)
                    this.connection_handler.sound.play(Sound.USER_ENTERED);
                else if (own_channel == channel_from)
                    this.connection_handler.sound.play(Sound.USER_LEFT);
            }
            else if (json["reasonid"] == ViewReasonId.VREASON_CHANNEL_KICK) {
                this.connection_handler.chat.serverChat().appendMessage(self ? _translations.YMNeADME || (_translations.YMNeADME = tr("You got kicked out of the channel {1} to channel {2} by {3}{4}")) : _translations.s1TK0yMe || (_translations.s1TK0yMe = tr("{0} got kicked from channel {1} to {2} by {3}{4}")), true, client.createChatTag(true), channel_from ? channel_from.generate_tag(true) : undefined, channel_to.generate_tag(true), ClientEntry.chatTag(json["invokerid"], json["invokername"], json["invokeruid"]), json["reasonmsg"] ? " (" + json["reasonmsg"] + ")" : "");
                if (self) {
                    this.connection_handler.sound.play(Sound.CHANNEL_KICKED);
                }
                else if (own_channel == channel_to)
                    this.connection_handler.sound.play(Sound.USER_ENTERED_KICKED);
                else if (own_channel == channel_from)
                    this.connection_handler.sound.play(Sound.USER_LEFT_KICKED_CHANNEL);
            }
            else {
                console.warn(_translations.Mo1aVAwY || (_translations.Mo1aVAwY = tr("Unknown reason id %o")), json["reasonid"]);
            }
        }
        handleNotifyChannelMoved(json) {
            json = json[0]; //Only one bulk
            for (let key in json)
                console.log("Key: " + key + " Value: " + json[key]);
            let tree = this.connection.client.channelTree;
            let channel = tree.findChannel(json["cid"]);
            if (!channel) {
                console.error(_translations.ipdzhSFm || (_translations.ipdzhSFm = tr("Unknown channel move (Channel)!")));
                return 0;
            }
            let prev = tree.findChannel(json["order"]);
            if (!prev && json["order"] != 0) {
                console.error(_translations.cyZRRyz2 || (_translations.cyZRRyz2 = tr("Unknown channel move (prev)!")));
                return 0;
            }
            let parent = tree.findChannel(json["cpid"]);
            if (!parent && json["cpid"] != 0) {
                console.error(_translations.precY3Tr || (_translations.precY3Tr = tr("Unknown channel move (parent)!")));
                return 0;
            }
            tree.moveChannel(channel, prev, parent);
        }
        handleNotifyChannelEdited(json) {
            json = json[0]; //Only one bulk
            let tree = this.connection.client.channelTree;
            let channel = tree.findChannel(json["cid"]);
            if (!channel) {
                console.error(_translations.iNFBwih2 || (_translations.iNFBwih2 = tr("Unknown channel edit (Channel)!")));
                return 0;
            }
            let updates = [];
            for (let key in json) {
                if (key === "cid")
                    continue;
                if (key === "invokerid")
                    continue;
                if (key === "invokername")
                    continue;
                if (key === "invokeruid")
                    continue;
                if (key === "reasonid")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            channel.updateVariables(...updates);
        }
        handleNotifyTextMessage(json) {
            json = json[0]; //Only one bulk
            let mode = json["targetmode"];
            if (mode == 1) {
                let invoker = this.connection.client.channelTree.findClient(json["invokerid"]);
                let target = this.connection.client.channelTree.findClient(json["target"]);
                if (!invoker) { //TODO spawn chat (Client is may invisible)
                    console.error(_translations.iRbFmoSL || (_translations.iRbFmoSL = tr("Got private message from invalid client!")));
                    return;
                }
                if (!target) { //TODO spawn chat (Client is may invisible)
                    console.error(_translations.eXnQDoO0 || (_translations.eXnQDoO0 = tr("Got private message from invalid client!")));
                    return;
                }
                if (invoker == this.connection.client.getClient()) {
                    this.connection_handler.sound.play(Sound.MESSAGE_SEND, { default_volume: .5 });
                    target.chat(true).appendMessage("{0}: {1}", true, this.connection.client.getClient().createChatTag(true), MessageHelper.bbcode_chat(json["msg"]));
                }
                else {
                    this.connection_handler.sound.play(Sound.MESSAGE_RECEIVED, { default_volume: .5 });
                    invoker.chat(true).appendMessage("{0}: {1}", true, ClientEntry.chatTag(json["invokerid"], json["invokername"], json["invokeruid"], true), MessageHelper.bbcode_chat(json["msg"]));
                }
            }
            else if (mode == 2) {
                if (json["invokerid"] == this.connection.client.clientId)
                    this.connection_handler.sound.play(Sound.MESSAGE_SEND, { default_volume: .5 });
                else
                    this.connection_handler.sound.play(Sound.MESSAGE_RECEIVED, { default_volume: .5 });
                this.connection_handler.chat.channelChat().appendMessage("{0}: {1}", true, ClientEntry.chatTag(json["invokerid"], json["invokername"], json["invokeruid"], true), MessageHelper.bbcode_chat(json["msg"]));
            }
            else if (mode == 3) {
                this.connection_handler.chat.serverChat().appendMessage("{0}: {1}", true, ClientEntry.chatTag(json["invokerid"], json["invokername"], json["invokeruid"], true), MessageHelper.bbcode_chat(json["msg"]));
            }
        }
        handleNotifyClientChatClosed(json) {
            json = json[0]; //Only one bulk
            //Chat partner has closed the conversation
            //clid: "6"
            //cluid: "YoWmG+dRGKD+Rxb7SPLAM5+B9tY="
            const client = this.connection.client.channelTree.findClient(json["clid"]);
            if (!client) {
                log.warn(LogCategory.GENERAL, _translations.PC7JLHc6 || (_translations.PC7JLHc6 = tr("Received chat close for unknown client")));
                return;
            }
            if (client.properties.client_unique_identifier !== json["cluid"]) {
                log.warn(LogCategory.GENERAL, _translations.ayAz3afI || (_translations.ayAz3afI = tr("Received chat close for client, but unique ids dosn't match. (expected %o, received %o)")), client.properties.client_unique_identifier, json["cluid"]);
                return;
            }
            const chat = client.chat(false);
            if (!chat) {
                log.warn(LogCategory.GENERAL, _translations.dMSXWlRv || (_translations.dMSXWlRv = tr("Received chat close for client, but we haven't a chat open.")));
                return;
            }
            chat.flag_offline = true;
            chat.appendMessage("{0}", true, $.spawn("div")
                .addClass("event-message event-partner-closed")
                .text(_translations.dAAIZamK || (_translations.dAAIZamK = tr("Your chat partner has close the conversation"))));
        }
        handleNotifyClientUpdated(json) {
            json = json[0]; //Only one bulk
            let client = this.connection.client.channelTree.findClient(json["clid"]);
            if (!client) {
                console.error(_translations.l_YCyIWk || (_translations.l_YCyIWk = tr("Tried to update an non existing client")));
                return;
            }
            let updates = [];
            for (let key in json) {
                if (key == "clid")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            client.updateVariables(...updates);
            if (this.connection.client.select_info.currentSelected == client)
                this.connection.client.select_info.update();
        }
        handleNotifyServerEdited(json) {
            json = json[0];
            let updates = [];
            for (let key in json) {
                if (key === "invokerid")
                    continue;
                if (key === "invokername")
                    continue;
                if (key === "invokeruid")
                    continue;
                if (key === "reasonid")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            this.connection.client.channelTree.server.updateVariables(false, ...updates);
            if (this.connection.client.select_info.currentSelected == this.connection.client.channelTree.server)
                this.connection.client.select_info.update();
        }
        handleNotifyServerUpdated(json) {
            json = json[0];
            let updates = [];
            for (let key in json) {
                if (key === "invokerid")
                    continue;
                if (key === "invokername")
                    continue;
                if (key === "invokeruid")
                    continue;
                if (key === "reasonid")
                    continue;
                updates.push({ key: key, value: json[key] });
            }
            this.connection.client.channelTree.server.updateVariables(true, ...updates);
            let info = this.connection.client.select_info;
            if (info.currentSelected instanceof ServerEntry)
                info.update();
        }
        handleNotifyMusicPlayerInfo(json) {
            json = json[0];
            let bot = this.connection.client.channelTree.find_client_by_dbid(json["bot_id"]);
            if (!bot || !(bot instanceof MusicClientEntry)) {
                log.warn(LogCategory.CLIENT, _translations.FY6R2us2 || (_translations.FY6R2us2 = tr("Got music player info for unknown or invalid bot! (ID: %i, Entry: %o)")), json["bot_id"], bot);
                return;
            }
            bot.handlePlayerInfo(json);
        }
        handleNotifyClientPoke(json) {
            json = json[0];
            Modals.spawnPoke(this.connection_handler, {
                id: parseInt(json["invokerid"]),
                name: json["invokername"],
                unique_id: json["invokeruid"]
            }, json["msg"]);
            this.connection_handler.sound.play(Sound.USER_POKED_SELF);
        }
        //TODO server chat message
        handleNotifyServerGroupClientAdd(json) {
            json = json[0];
            const self = this.connection.client.getClient();
            if (json["clid"] == self.clientId())
                this.connection_handler.sound.play(Sound.GROUP_SERVER_ASSIGNED_SELF);
        }
        //TODO server chat message
        handleNotifyServerGroupClientRemove(json) {
            json = json[0];
            const self = this.connection.client.getClient();
            if (json["clid"] == self.clientId()) {
                this.connection_handler.sound.play(Sound.GROUP_SERVER_REVOKED_SELF);
            }
            else {
            }
        }
        //TODO server chat message
        handleNotifyClientChannelGroupChanged(json) {
            json = json[0];
            const self = this.connection.client.getClient();
            if (json["clid"] == self.clientId()) {
                this.connection_handler.sound.play(Sound.GROUP_CHANNEL_CHANGED_SELF);
            }
        }
        handleNotifyChannelSubscribed(json) {
            for (const entry of json) {
                const channel = this.connection.client.channelTree.findChannel(entry["cid"]);
                if (!channel) {
                    console.warn(_translations.tEIB6y1U || (_translations.tEIB6y1U = tr("Received channel subscribed for not visible channel (cid: %d)")), entry['cid']);
                    continue;
                }
                channel.flag_subscribed = true;
            }
        }
        handleNotifyChannelUnsubscribed(json) {
            for (const entry of json) {
                const channel = this.connection.client.channelTree.findChannel(entry["cid"]);
                if (!channel) {
                    console.warn(_translations.orwLe7yE || (_translations.orwLe7yE = tr("Received channel unsubscribed for not visible channel (cid: %d)")), entry['cid']);
                    continue;
                }
                channel.flag_subscribed = false;
                for (const client of channel.clients(false))
                    this.connection.client.channelTree.deleteClient(client);
            }
        }
    }
    connection_2.ConnectionCommandHandler = ConnectionCommandHandler;
})(connection || (connection = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["74f8b0542c63e14016794f3577510e4fdabc67cd6223d3ef848890db1427a464"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["74f8b0542c63e14016794f3577510e4fdabc67cd6223d3ef848890db1427a464"] = "74f8b0542c63e14016794f3577510e4fdabc67cd6223d3ef848890db1427a464";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "DXgCDdis", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (216,27)" }, { name: "jmtWNbIA", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (239,27)" }, { name: "ZHtru4yM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (590,31)" }, { name: "fOGmVdpj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (599,31)" }, { name: "fgC3AZau", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (641,27)" }, { name: "jcEX58cb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (686,31)" }, { name: "_czrVTo1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (757,21)" }, { name: "fX2zZDi8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (766,27)" }, { name: "m2Zt0JoJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (775,27)" }, { name: "AqIGJEgR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (811,55)" }, { name: "v6PSs1kg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (854,31)" }, { name: "sLZZxeiD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/FileManager.ts (856,74)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="connection/CommandHandler.ts" />
/// <reference path="connection/ConnectionBase.ts" />
class FileEntry {
}
class FileListRequest {
}
var transfer;
(function (transfer) {
    function spawn_download_transfer(key) {
        return new RequestFileDownload(key);
    }
    transfer.spawn_download_transfer = spawn_download_transfer;
    function spawn_upload_transfer(key) {
        return new RequestFileUpload(key);
    }
    transfer.spawn_upload_transfer = spawn_upload_transfer;
})(transfer || (transfer = {}));
class RequestFileDownload {
    constructor(key) {
        this.transfer_key = key;
    }
    request_file() {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.try_fetch("https://" + this.transfer_key.peer.hosts[0] + ":" + this.transfer_key.peer.port);
        });
    }
    try_fetch(url) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield fetch(url, {
                method: 'GET',
                cache: "no-cache",
                mode: 'cors',
                headers: {
                    'transfer-key': this.transfer_key.key,
                    'download-name': this.transfer_key.file_name,
                    'Access-Control-Allow-Headers': '*',
                    'Access-Control-Expose-Headers': '*'
                }
            });
            if (!response.ok) {
                debugger;
                throw (response.type == 'opaque' || response.type == 'opaqueredirect' ? "invalid cross origin flag! May target isn't a TeaSpeak server?" : response.statusText || "response is not ok");
            }
            return response;
        });
    }
    get_key() {
        return this.transfer_key;
    }
}
class RequestFileUpload {
    constructor(key) {
        this.transfer_key = key;
    }
    put_data(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const form_data = new FormData();
            if (data instanceof File) {
                if (data.size != this.transfer_key.total_size)
                    throw "invalid size";
                form_data.append("file", data);
            }
            else {
                const buffer = data;
                if (buffer.byteLength != this.transfer_key.total_size)
                    throw "invalid size";
                form_data.append("file", new Blob([buffer], { type: "application/octet-stream" }));
            }
            yield this.try_put(form_data, "https://" + this.transfer_key.peer.hosts[0] + ":" + this.transfer_key.peer.port);
        });
    }
    try_put(data, url) {
        return __awaiter(this, void 0, void 0, function* () {
            const response = yield fetch(url, {
                method: 'POST',
                cache: "no-cache",
                mode: 'cors',
                body: data,
                headers: {
                    'transfer-key': this.transfer_key.key,
                    'Access-Control-Allow-Headers': '*',
                    'Access-Control-Expose-Headers': '*'
                }
            });
            if (!response.ok)
                throw (response.type == 'opaque' || response.type == 'opaqueredirect' ? "invalid cross origin flag! May target isn't a TeaSpeak server?" : response.statusText || "response is not ok");
        });
    }
}
class FileManager extends connection.AbstractCommandHandler {
    constructor(client) {
        super(client.serverConnection);
        this.listRequests = [];
        this.pending_download_requests = [];
        this.pending_upload_requests = [];
        this.transfer_counter = 1;
        this.handle = client;
        this.icons = new IconManager(this);
        this.avatars = new AvatarManager(this);
        this.connection.command_handler_boss().register_handler(this);
    }
    handle_command(command) {
        switch (command.command) {
            case "notifyfilelist":
                this.notifyFileList(command.arguments);
                return true;
            case "notifyfilelistfinished":
                this.notifyFileListFinished(command.arguments);
                return true;
            case "notifystartdownload":
                this.notifyStartDownload(command.arguments);
                return true;
            case "notifystartupload":
                this.notifyStartUpload(command.arguments);
                return true;
        }
        return false;
    }
    /******************************** File list ********************************/
    //TODO multiple requests (same path)
    requestFileList(path, channel, password) {
        const _this = this;
        return new Promise((accept, reject) => {
            let req = new FileListRequest();
            req.path = path;
            req.entries = [];
            req.callback = accept;
            _this.listRequests.push(req);
            _this.handle.serverConnection.send_command("ftgetfilelist", { "path": path, "cid": (channel ? channel.channelId : "0"), "cpw": (password ? password : "") }).then(() => { }).catch(reason => {
                _this.listRequests.remove(req);
                if (reason instanceof CommandResult) {
                    if (reason.id == 0x0501) {
                        accept([]); //Empty result
                        return;
                    }
                }
                reject(reason);
            });
        });
    }
    notifyFileList(json) {
        let entry = undefined;
        for (let e of this.listRequests) {
            if (e.path == json[0]["path"]) {
                entry = e;
                break;
            }
        }
        if (!entry) {
            console.error(_translations.DXgCDdis || (_translations.DXgCDdis = tr("Invalid file list entry. Path: %s")), json[0]["path"]);
            return;
        }
        for (let e of json) {
            e.datetime = parseInt(e.datetime + "");
            e.size = parseInt(e.size + "");
            e.type = parseInt(e.type + "");
            entry.entries.push(e);
        }
    }
    notifyFileListFinished(json) {
        let entry = undefined;
        for (let e of this.listRequests) {
            if (e.path == json[0]["path"]) {
                entry = e;
                this.listRequests.remove(e);
                break;
            }
        }
        if (!entry) {
            console.error(_translations.jmtWNbIA || (_translations.jmtWNbIA = tr("Invalid file list entry finish. Path: ")), json[0]["path"]);
            return;
        }
        entry.callback(entry.entries);
    }
    /******************************** File download/upload ********************************/
    download_file(path, file, channel, password) {
        const transfer_data = {
            file_name: file,
            file_path: path,
            client_transfer_id: this.transfer_counter++
        };
        this.pending_download_requests.push(transfer_data);
        return new Promise((resolve, reject) => {
            transfer_data["_callback"] = resolve;
            this.handle.serverConnection.send_command("ftinitdownload", {
                "path": path,
                "name": file,
                "cid": (channel ? channel.channelId : "0"),
                "cpw": (password ? password : ""),
                "clientftfid": transfer_data.client_transfer_id,
                "seekpos": 0,
                "proto": 1
            }).catch(reason => {
                this.pending_download_requests.remove(transfer_data);
                reject(reason);
            });
        });
    }
    upload_file(options) {
        const transfer_data = {
            file_path: options.path,
            file_name: options.name,
            client_transfer_id: this.transfer_counter++,
            total_size: options.size
        };
        this.pending_upload_requests.push(transfer_data);
        return new Promise((resolve, reject) => {
            transfer_data["_callback"] = resolve;
            this.handle.serverConnection.send_command("ftinitupload", {
                "path": options.path,
                "name": options.name,
                "cid": (options.channel ? options.channel.channelId : "0"),
                "cpw": options.channel_password || "",
                "clientftfid": transfer_data.client_transfer_id,
                "size": options.size,
                "overwrite": options.overwrite,
                "resume": false,
                "proto": 1
            }).catch(reason => {
                this.pending_upload_requests.remove(transfer_data);
                reject(reason);
            });
        });
    }
    notifyStartDownload(json) {
        json = json[0];
        let clientftfid = parseInt(json["clientftfid"]);
        let transfer;
        for (let e of this.pending_download_requests)
            if (e.client_transfer_id == clientftfid) {
                transfer = e;
                break;
            }
        transfer.server_transfer_id = parseInt(json["serverftfid"]);
        transfer.key = json["ftkey"];
        transfer.total_size = json["size"];
        transfer.peer = {
            hosts: (json["ip"] || "").split(","),
            port: parseInt(json["port"])
        };
        if (transfer.peer.hosts.length == 0)
            transfer.peer.hosts.push("0.0.0.0");
        if (transfer.peer.hosts[0].length == 0 || transfer.peer.hosts[0] == '0.0.0.0')
            transfer.peer.hosts[0] = this.handle.serverConnection.remote_address().host;
        transfer["_callback"](transfer);
        this.pending_download_requests.remove(transfer);
    }
    notifyStartUpload(json) {
        json = json[0];
        let transfer;
        let clientftfid = parseInt(json["clientftfid"]);
        for (let e of this.pending_upload_requests)
            if (e.client_transfer_id == clientftfid) {
                transfer = e;
                break;
            }
        transfer.server_transfer_id = parseInt(json["serverftfid"]);
        transfer.key = json["ftkey"];
        transfer.peer = {
            hosts: (json["ip"] || "").split(","),
            port: parseInt(json["port"])
        };
        if (transfer.peer.hosts.length == 0)
            transfer.peer.hosts.push("0.0.0.0");
        if (transfer.peer.hosts[0].length == 0 || transfer.peer.hosts[0] == '0.0.0.0')
            transfer.peer.hosts[0] = this.handle.serverConnection.remote_address().host;
        transfer["_callback"](transfer);
        this.pending_upload_requests.remove(transfer);
    }
    /** File management **/
    delete_file(props) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!props.name)
                throw "invalid name!";
            try {
                yield this.handle.serverConnection.send_command("ftdeletefile", {
                    cid: props.cid || 0,
                    cpw: props.cpw,
                    path: props.path || "",
                    name: props.name
                });
            }
            catch (error) {
                throw error;
            }
        });
    }
}
class Icon {
}
var ImageType;
(function (ImageType) {
    ImageType[ImageType["UNKNOWN"] = 0] = "UNKNOWN";
    ImageType[ImageType["BITMAP"] = 1] = "BITMAP";
    ImageType[ImageType["PNG"] = 2] = "PNG";
    ImageType[ImageType["GIF"] = 3] = "GIF";
    ImageType[ImageType["SVG"] = 4] = "SVG";
    ImageType[ImageType["JPEG"] = 5] = "JPEG";
})(ImageType || (ImageType = {}));
function media_image_type(type, file) {
    switch (type) {
        case ImageType.BITMAP:
            return "bmp";
        case ImageType.GIF:
            return "gif";
        case ImageType.SVG:
            return file ? "svg" : "svg+xml";
        case ImageType.JPEG:
            return "jpeg";
        case ImageType.UNKNOWN:
        case ImageType.PNG:
        default:
            return "png";
    }
}
function image_type(base64) {
    const ab2str10 = () => {
        const buf = new Uint8Array(base64);
        if (buf.byteLength < 10)
            return "";
        let result = "";
        for (let index = 0; index < 10; index++)
            result += String.fromCharCode(buf[index]);
        return result;
    };
    const bin = typeof (base64) === "string" ? atob(base64) : ab2str10();
    if (bin.length < 10)
        return ImageType.UNKNOWN;
    if (bin[0] == String.fromCharCode(66) && bin[1] == String.fromCharCode(77)) {
        return ImageType.BITMAP;
    }
    else if (bin.substr(0, 8) == "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a") {
        return ImageType.PNG;
    }
    else if (bin.substr(0, 4) == "\x47\x49\x46\x38" && (bin[4] == '\x37' || bin[4] == '\x39') && bin[5] == '\x61') {
        return ImageType.GIF;
    }
    else if (bin[0] == '\x3c') {
        return ImageType.SVG;
    }
    else if (bin[0] == '\xFF' && bin[1] == '\xd8') {
        return ImageType.JPEG;
    }
    return ImageType.UNKNOWN;
}
class CacheManager {
    constructor(name) {
        this.cache_name = name;
    }
    setupped() { return !!this._cache_category; }
    reset() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!window.caches)
                return;
            try {
                yield caches.delete(this.cache_name);
            }
            catch (error) {
                throw "Failed to delete cache: " + error;
            }
            try {
                yield this.setup();
            }
            catch (error) {
                throw "Failed to reinitialize cache!";
            }
        });
    }
    setup() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!window.caches)
                throw "Missing caches!";
            this._cache_category = yield caches.open(this.cache_name);
        });
    }
    cleanup(max_age) {
        return __awaiter(this, void 0, void 0, function* () {
            /* FIXME: TODO */
        });
    }
    resolve_cached(key, max_age) {
        return __awaiter(this, void 0, void 0, function* () {
            max_age = typeof (max_age) === "number" ? max_age : -1;
            const request = new Request("https://_local_cache/cache_request_" + key);
            const cached_response = yield this._cache_category.match(request);
            if (!cached_response)
                return undefined;
            /* FIXME: Max age */
            return cached_response;
        });
    }
    put_cache(key, value, type, headers) {
        return __awaiter(this, void 0, void 0, function* () {
            const request = new Request("https://_local_cache/cache_request_" + key);
            const new_headers = new Headers();
            for (const key of value.headers.keys())
                new_headers.set(key, value.headers.get(key));
            if (type)
                new_headers.set("Content-type", type);
            for (const key of Object.keys(headers || {}))
                new_headers.set(key, headers[key]);
            yield this._cache_category.put(request, new Response(value.body, {
                headers: new_headers
            }));
        });
    }
}
class IconManager {
    constructor(handle) {
        this._id_urls = {};
        this._loading_promises = {};
        this.handle = handle;
        if (!IconManager.cache)
            IconManager.cache = new CacheManager("icons");
    }
    clear_cache() {
        return __awaiter(this, void 0, void 0, function* () {
            yield IconManager.cache.reset();
            if (URL.revokeObjectURL) {
                for (const id of Object.keys(this._id_urls))
                    URL.revokeObjectURL(this._id_urls[id]);
            }
            this._id_urls = {};
            this._loading_promises = {};
        });
    }
    delete_icon(id) {
        return __awaiter(this, void 0, void 0, function* () {
            if (id <= 1000)
                throw "invalid id!";
            yield this.handle.delete_file({
                name: '/icon_' + id
            });
        });
    }
    iconList() {
        return this.handle.requestFileList("/icons");
    }
    create_icon_download(id) {
        return this.handle.download_file("", "/icon_" + id);
    }
    _response_url(response) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!response.headers.has('X-media-bytes'))
                throw "missing media bytes";
            const type = image_type(response.headers.get('X-media-bytes'));
            const media = media_image_type(type);
            const blob = yield response.blob();
            if (blob.type !== "image/" + media)
                return URL.createObjectURL(blob.slice(0, blob.size, "image/" + media));
            else
                return URL.createObjectURL(blob);
        });
    }
    resolved_cached(id) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this._id_urls[id])
                return {
                    id: id,
                    url: this._id_urls[id]
                };
            if (!IconManager.cache.setupped())
                yield IconManager.cache.setup();
            const response = yield IconManager.cache.resolve_cached('icon_' + id); //TODO age!
            if (response)
                return {
                    id: id,
                    url: (this._id_urls[id] = yield this._response_url(response))
                };
            return undefined;
        });
    }
    _load_icon(id) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let download_key;
                try {
                    download_key = yield this.create_icon_download(id);
                }
                catch (error) {
                    console.error(_translations.ZHtru4yM || (_translations.ZHtru4yM = tr("Could not request download for icon %d: %o")), id, error);
                    throw "Failed to request icon";
                }
                const downloader = transfer.spawn_download_transfer(download_key);
                let response;
                try {
                    response = yield downloader.request_file();
                }
                catch (error) {
                    console.error(_translations.fOGmVdpj || (_translations.fOGmVdpj = tr("Could not download icon %d: %o")), id, error);
                    throw "failed to download icon";
                }
                const type = image_type(response.headers.get('X-media-bytes'));
                const media = media_image_type(type);
                yield IconManager.cache.put_cache('icon_' + id, response.clone(), "image/" + media);
                const url = (this._id_urls[id] = yield this._response_url(response.clone()));
                this._loading_promises[id] = undefined;
                return {
                    id: id,
                    url: url
                };
            }
            catch (error) {
                setTimeout(() => {
                    this._loading_promises[id] = undefined;
                }, 1000 * 60); /* try again in 60 seconds */
                throw error;
            }
        });
    }
    download_icon(id) {
        return this._loading_promises[id] || (this._loading_promises[id] = this._load_icon(id));
    }
    resolve_icon(id) {
        return __awaiter(this, void 0, void 0, function* () {
            id = id >>> 0;
            try {
                const result = yield this.resolved_cached(id);
                if (result)
                    return result;
                throw "";
            }
            catch (error) { }
            try {
                const result = yield this.download_icon(id);
                if (result)
                    return result;
                throw "load result is empty";
            }
            catch (error) {
                console.error(_translations.fgC3AZau || (_translations.fgC3AZau = tr("Icon download failed of icon %d: %o")), id, error);
            }
            throw "icon not found";
        });
    }
    generateTag(id, options) {
        options = options || {};
        id = id >>> 0;
        if (id == 0 || !id)
            return $.spawn("div").addClass("icon_empty");
        else if (id < 1000)
            return $.spawn("div").addClass("icon client-group_" + id);
        const icon_container = $.spawn("div").addClass("icon-container icon_empty");
        const icon_image = $.spawn("img").attr("width", 16).attr("height", 16).attr("alt", "");
        if (this._id_urls[id]) {
            icon_image.attr("src", this._id_urls[id]).appendTo(icon_container);
            icon_container.removeClass("icon_empty");
        }
        else {
            const icon_load_image = $.spawn("div").addClass("icon_loading");
            icon_load_image.appendTo(icon_container);
            (() => __awaiter(this, void 0, void 0, function* () {
                let icon = yield this.resolve_icon(id);
                icon_image.attr("src", icon.url);
                icon_container.append(icon_image).removeClass("icon_empty");
                if (typeof (options.animate) !== "boolean" || options.animate) {
                    icon_image.css("opacity", 0);
                    icon_load_image.animate({ opacity: 0 }, 50, function () {
                        icon_load_image.detach();
                        icon_image.animate({ opacity: 1 }, 150);
                    });
                }
                else {
                    icon_load_image.detach();
                }
            }))().catch(reason => {
                console.error(_translations.jcEX58cb || (_translations.jcEX58cb = tr("Could not load icon %o. Reason: %s")), id, reason);
                icon_load_image.removeClass("icon_loading").addClass("icon client-warning").attr("tag", "Could not load icon " + id);
            });
        }
        return icon_container;
    }
}
class Avatar {
}
class AvatarManager {
    constructor(handle) {
        this._cached_avatars = {};
        this._loading_promises = {};
        this.handle = handle;
        if (!AvatarManager.cache)
            AvatarManager.cache = new CacheManager("avatars");
    }
    _response_url(response, type) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!response.headers.has('X-media-bytes'))
                throw "missing media bytes";
            const media = media_image_type(type);
            const blob = yield response.blob();
            if (blob.type !== "image/" + media)
                return URL.createObjectURL(blob.slice(0, blob.size, "image/" + media));
            else
                return URL.createObjectURL(blob);
        });
    }
    resolved_cached(client_avatar_id, avatar_id) {
        return __awaiter(this, void 0, void 0, function* () {
            let avatar = this._cached_avatars[avatar_id];
            if (avatar) {
                if (typeof (avatar_id) !== "string" || avatar.avatar_id == avatar_id)
                    return avatar;
                this._cached_avatars[avatar_id] = (avatar = undefined);
            }
            if (!AvatarManager.cache.setupped())
                yield AvatarManager.cache.setup();
            const response = yield AvatarManager.cache.resolve_cached('avatar_' + client_avatar_id); //TODO age!
            if (!response)
                return undefined;
            let response_avatar_id = response.headers.has("X-avatar-id") ? response.headers.get("X-avatar-id") : undefined;
            if (typeof (avatar_id) === "string" && response_avatar_id != avatar_id)
                return undefined;
            const type = image_type(response.headers.get('X-media-bytes'));
            return this._cached_avatars[client_avatar_id] = {
                client_avatar_id: client_avatar_id,
                avatar_id: avatar_id || response_avatar_id,
                url: yield this._response_url(response, type),
                type: type
            };
        });
    }
    create_avatar_download(client_avatar_id) {
        console.log(_translations._czrVTo1 || (_translations._czrVTo1 = tr("Downloading avatar %s")), client_avatar_id);
        return this.handle.download_file("", "/avatar_" + client_avatar_id);
    }
    _load_avatar(client_avatar_id, avatar_id) {
        return __awaiter(this, void 0, void 0, function* () {
            let download_key;
            try {
                download_key = yield this.create_avatar_download(client_avatar_id);
            }
            catch (error) {
                console.error(_translations.fX2zZDi8 || (_translations.fX2zZDi8 = tr("Could not request download for avatar %s: %o")), client_avatar_id, error);
                throw "Failed to request icon";
            }
            const downloader = transfer.spawn_download_transfer(download_key);
            let response;
            try {
                response = yield downloader.request_file();
            }
            catch (error) {
                console.error(_translations.m2Zt0JoJ || (_translations.m2Zt0JoJ = tr("Could not download avatar %s: %o")), client_avatar_id, error);
                throw "failed to download avatar";
            }
            const type = image_type(response.headers.get('X-media-bytes'));
            const media = media_image_type(type);
            yield AvatarManager.cache.put_cache('avatar_' + client_avatar_id, response.clone(), "image/" + media, {
                "X-avatar-id": avatar_id
            });
            const url = yield this._response_url(response.clone(), type);
            this._loading_promises[client_avatar_id] = undefined;
            return this._cached_avatars[client_avatar_id] = {
                client_avatar_id: client_avatar_id,
                avatar_id: avatar_id,
                url: url,
                type: type
            };
        });
    }
    loadAvatar(client_avatar_id, avatar_id) {
        return this._loading_promises[client_avatar_id] || (this._loading_promises[client_avatar_id] = this._load_avatar(client_avatar_id, avatar_id));
    }
    generate_client_tag(client) {
        return this.generate_tag(client.avatarId(), client.properties.client_flag_avatar);
    }
    generate_tag(client_avatar_id, avatar_id, options) {
        options = options || {};
        let avatar_container = $.spawn("div");
        let avatar_image = $.spawn("img").attr("alt", _translations.AqIGJEgR || (_translations.AqIGJEgR = tr("Client avatar")));
        let cached_avatar = this._cached_avatars[client_avatar_id];
        if (cached_avatar && cached_avatar.avatar_id == avatar_id) {
            avatar_image.attr("src", cached_avatar.url);
            avatar_container.append(avatar_image);
            if (options.callback_image)
                options.callback_image(avatar_image);
            if (options.callback_avatar)
                options.callback_avatar(cached_avatar);
        }
        else {
            let loader_image = $.spawn("img");
            loader_image.attr("src", "img/loading_image.svg").css("width", "75%");
            avatar_container.append(loader_image);
            (() => __awaiter(this, void 0, void 0, function* () {
                let avatar;
                try {
                    avatar = yield this.resolved_cached(client_avatar_id, avatar_id);
                }
                catch (error) {
                    console.error(error);
                }
                if (!avatar)
                    avatar = yield this.loadAvatar(client_avatar_id, avatar_id);
                if (!avatar)
                    throw "failed to load avatar";
                if (options.callback_avatar)
                    options.callback_avatar(avatar);
                avatar_image.attr("src", avatar.url);
                avatar_image.css("opacity", 0);
                avatar_container.append(avatar_image);
                loader_image.animate({ opacity: 0 }, 50, () => {
                    loader_image.detach();
                    avatar_image.animate({ opacity: 1 }, 150, () => {
                        if (options.callback_image)
                            options.callback_image(avatar_image);
                    });
                });
            }))().catch(reason => {
                console.error(_translations.v6PSs1kg || (_translations.v6PSs1kg = tr("Could not load avatar for id %s. Reason: %s")), client_avatar_id, reason);
                //TODO Broken image
                loader_image.addClass("icon client-warning").attr("tag", (_translations.sLZZxeiD || (_translations.sLZZxeiD = tr("Could not load avatar "))) + client_avatar_id);
            });
        }
        return avatar_container;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["0ab33c775daeb6c8dc0bca90856462d6f7058f41d064e26390a20461ef094b32"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["0ab33c775daeb6c8dc0bca90856462d6f7058f41d064e26390a20461ef094b32"] = "0ab33c775daeb6c8dc0bca90856462d6f7058f41d064e26390a20461ef094b32";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "jgkf4lJo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (386,44)" }, { name: "RX5InTHF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (480,51)" }, { name: "NPu5rNZX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (552,75)" }, { name: "lxokiMWI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (561,30)" }, { name: "jkrTUtsb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (589,43)" }, { name: "jP28V5vV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (598,47)" }, { name: "LJi7kl_6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (607,75)" }, { name: "BsVGMqaN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (625,55)" }, { name: "Grfup0ih", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (659,43)" }, { name: "fUOWxSiS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (668,44)" }, { name: "M1_OSPsn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (788,44)" }, { name: "AAxaZC8p", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (791,47)" }, { name: "YY4WRh8z", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/PermissionManager.ts (813,27)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../ConnectionHandler.ts" />
/// <reference path="../connection/ConnectionBase.ts" />
var PermissionType;
(function (PermissionType) {
    PermissionType["B_SERVERINSTANCE_HELP_VIEW"] = "b_serverinstance_help_view";
    PermissionType["B_SERVERINSTANCE_VERSION_VIEW"] = "b_serverinstance_version_view";
    PermissionType["B_SERVERINSTANCE_INFO_VIEW"] = "b_serverinstance_info_view";
    PermissionType["B_SERVERINSTANCE_VIRTUALSERVER_LIST"] = "b_serverinstance_virtualserver_list";
    PermissionType["B_SERVERINSTANCE_BINDING_LIST"] = "b_serverinstance_binding_list";
    PermissionType["B_SERVERINSTANCE_PERMISSION_LIST"] = "b_serverinstance_permission_list";
    PermissionType["B_SERVERINSTANCE_PERMISSION_FIND"] = "b_serverinstance_permission_find";
    PermissionType["B_VIRTUALSERVER_CREATE"] = "b_virtualserver_create";
    PermissionType["B_VIRTUALSERVER_DELETE"] = "b_virtualserver_delete";
    PermissionType["B_VIRTUALSERVER_START_ANY"] = "b_virtualserver_start_any";
    PermissionType["B_VIRTUALSERVER_STOP_ANY"] = "b_virtualserver_stop_any";
    PermissionType["B_VIRTUALSERVER_CHANGE_MACHINE_ID"] = "b_virtualserver_change_machine_id";
    PermissionType["B_VIRTUALSERVER_CHANGE_TEMPLATE"] = "b_virtualserver_change_template";
    PermissionType["B_SERVERQUERY_LOGIN"] = "b_serverquery_login";
    PermissionType["B_SERVERINSTANCE_TEXTMESSAGE_SEND"] = "b_serverinstance_textmessage_send";
    PermissionType["B_SERVERINSTANCE_LOG_VIEW"] = "b_serverinstance_log_view";
    PermissionType["B_SERVERINSTANCE_LOG_ADD"] = "b_serverinstance_log_add";
    PermissionType["B_SERVERINSTANCE_STOP"] = "b_serverinstance_stop";
    PermissionType["B_SERVERINSTANCE_MODIFY_SETTINGS"] = "b_serverinstance_modify_settings";
    PermissionType["B_SERVERINSTANCE_MODIFY_QUERYGROUP"] = "b_serverinstance_modify_querygroup";
    PermissionType["B_SERVERINSTANCE_MODIFY_TEMPLATES"] = "b_serverinstance_modify_templates";
    PermissionType["B_VIRTUALSERVER_SELECT"] = "b_virtualserver_select";
    PermissionType["B_VIRTUALSERVER_SELECT_GODMODE"] = "b_virtualserver_select_godmode";
    PermissionType["B_VIRTUALSERVER_INFO_VIEW"] = "b_virtualserver_info_view";
    PermissionType["B_VIRTUALSERVER_CONNECTIONINFO_VIEW"] = "b_virtualserver_connectioninfo_view";
    PermissionType["B_VIRTUALSERVER_CHANNEL_LIST"] = "b_virtualserver_channel_list";
    PermissionType["B_VIRTUALSERVER_CHANNEL_SEARCH"] = "b_virtualserver_channel_search";
    PermissionType["B_VIRTUALSERVER_CLIENT_LIST"] = "b_virtualserver_client_list";
    PermissionType["B_VIRTUALSERVER_CLIENT_SEARCH"] = "b_virtualserver_client_search";
    PermissionType["B_VIRTUALSERVER_CLIENT_DBLIST"] = "b_virtualserver_client_dblist";
    PermissionType["B_VIRTUALSERVER_CLIENT_DBSEARCH"] = "b_virtualserver_client_dbsearch";
    PermissionType["B_VIRTUALSERVER_CLIENT_DBINFO"] = "b_virtualserver_client_dbinfo";
    PermissionType["B_VIRTUALSERVER_PERMISSION_FIND"] = "b_virtualserver_permission_find";
    PermissionType["B_VIRTUALSERVER_CUSTOM_SEARCH"] = "b_virtualserver_custom_search";
    PermissionType["B_VIRTUALSERVER_START"] = "b_virtualserver_start";
    PermissionType["B_VIRTUALSERVER_STOP"] = "b_virtualserver_stop";
    PermissionType["B_VIRTUALSERVER_TOKEN_LIST"] = "b_virtualserver_token_list";
    PermissionType["B_VIRTUALSERVER_TOKEN_ADD"] = "b_virtualserver_token_add";
    PermissionType["B_VIRTUALSERVER_TOKEN_USE"] = "b_virtualserver_token_use";
    PermissionType["B_VIRTUALSERVER_TOKEN_DELETE"] = "b_virtualserver_token_delete";
    PermissionType["B_VIRTUALSERVER_LOG_VIEW"] = "b_virtualserver_log_view";
    PermissionType["B_VIRTUALSERVER_LOG_ADD"] = "b_virtualserver_log_add";
    PermissionType["B_VIRTUALSERVER_JOIN_IGNORE_PASSWORD"] = "b_virtualserver_join_ignore_password";
    PermissionType["B_VIRTUALSERVER_NOTIFY_REGISTER"] = "b_virtualserver_notify_register";
    PermissionType["B_VIRTUALSERVER_NOTIFY_UNREGISTER"] = "b_virtualserver_notify_unregister";
    PermissionType["B_VIRTUALSERVER_SNAPSHOT_CREATE"] = "b_virtualserver_snapshot_create";
    PermissionType["B_VIRTUALSERVER_SNAPSHOT_DEPLOY"] = "b_virtualserver_snapshot_deploy";
    PermissionType["B_VIRTUALSERVER_PERMISSION_RESET"] = "b_virtualserver_permission_reset";
    PermissionType["B_VIRTUALSERVER_MODIFY_NAME"] = "b_virtualserver_modify_name";
    PermissionType["B_VIRTUALSERVER_MODIFY_WELCOMEMESSAGE"] = "b_virtualserver_modify_welcomemessage";
    PermissionType["B_VIRTUALSERVER_MODIFY_MAXCLIENTS"] = "b_virtualserver_modify_maxclients";
    PermissionType["B_VIRTUALSERVER_MODIFY_RESERVED_SLOTS"] = "b_virtualserver_modify_reserved_slots";
    PermissionType["B_VIRTUALSERVER_MODIFY_PASSWORD"] = "b_virtualserver_modify_password";
    PermissionType["B_VIRTUALSERVER_MODIFY_DEFAULT_SERVERGROUP"] = "b_virtualserver_modify_default_servergroup";
    PermissionType["B_VIRTUALSERVER_MODIFY_DEFAULT_MUSICGROUP"] = "b_virtualserver_modify_default_musicgroup";
    PermissionType["B_VIRTUALSERVER_MODIFY_DEFAULT_CHANNELGROUP"] = "b_virtualserver_modify_default_channelgroup";
    PermissionType["B_VIRTUALSERVER_MODIFY_DEFAULT_CHANNELADMINGROUP"] = "b_virtualserver_modify_default_channeladmingroup";
    PermissionType["B_VIRTUALSERVER_MODIFY_CHANNEL_FORCED_SILENCE"] = "b_virtualserver_modify_channel_forced_silence";
    PermissionType["B_VIRTUALSERVER_MODIFY_COMPLAIN"] = "b_virtualserver_modify_complain";
    PermissionType["B_VIRTUALSERVER_MODIFY_ANTIFLOOD"] = "b_virtualserver_modify_antiflood";
    PermissionType["B_VIRTUALSERVER_MODIFY_FT_SETTINGS"] = "b_virtualserver_modify_ft_settings";
    PermissionType["B_VIRTUALSERVER_MODIFY_FT_QUOTAS"] = "b_virtualserver_modify_ft_quotas";
    PermissionType["B_VIRTUALSERVER_MODIFY_HOSTMESSAGE"] = "b_virtualserver_modify_hostmessage";
    PermissionType["B_VIRTUALSERVER_MODIFY_HOSTBANNER"] = "b_virtualserver_modify_hostbanner";
    PermissionType["B_VIRTUALSERVER_MODIFY_HOSTBUTTON"] = "b_virtualserver_modify_hostbutton";
    PermissionType["B_VIRTUALSERVER_MODIFY_PORT"] = "b_virtualserver_modify_port";
    PermissionType["B_VIRTUALSERVER_MODIFY_HOST"] = "b_virtualserver_modify_host";
    PermissionType["B_VIRTUALSERVER_MODIFY_DEFAULT_MESSAGES"] = "b_virtualserver_modify_default_messages";
    PermissionType["B_VIRTUALSERVER_MODIFY_AUTOSTART"] = "b_virtualserver_modify_autostart";
    PermissionType["B_VIRTUALSERVER_MODIFY_NEEDED_IDENTITY_SECURITY_LEVEL"] = "b_virtualserver_modify_needed_identity_security_level";
    PermissionType["B_VIRTUALSERVER_MODIFY_PRIORITY_SPEAKER_DIMM_MODIFICATOR"] = "b_virtualserver_modify_priority_speaker_dimm_modificator";
    PermissionType["B_VIRTUALSERVER_MODIFY_LOG_SETTINGS"] = "b_virtualserver_modify_log_settings";
    PermissionType["B_VIRTUALSERVER_MODIFY_MIN_CLIENT_VERSION"] = "b_virtualserver_modify_min_client_version";
    PermissionType["B_VIRTUALSERVER_MODIFY_ICON_ID"] = "b_virtualserver_modify_icon_id";
    PermissionType["B_VIRTUALSERVER_MODIFY_WEBLIST"] = "b_virtualserver_modify_weblist";
    PermissionType["B_VIRTUALSERVER_MODIFY_CODEC_ENCRYPTION_MODE"] = "b_virtualserver_modify_codec_encryption_mode";
    PermissionType["B_VIRTUALSERVER_MODIFY_TEMPORARY_PASSWORDS"] = "b_virtualserver_modify_temporary_passwords";
    PermissionType["B_VIRTUALSERVER_MODIFY_TEMPORARY_PASSWORDS_OWN"] = "b_virtualserver_modify_temporary_passwords_own";
    PermissionType["B_VIRTUALSERVER_MODIFY_CHANNEL_TEMP_DELETE_DELAY_DEFAULT"] = "b_virtualserver_modify_channel_temp_delete_delay_default";
    PermissionType["B_VIRTUALSERVER_MODIFY_MUSIC_BOT_LIMIT"] = "b_virtualserver_modify_music_bot_limit";
    PermissionType["I_CHANNEL_MIN_DEPTH"] = "i_channel_min_depth";
    PermissionType["I_CHANNEL_MAX_DEPTH"] = "i_channel_max_depth";
    PermissionType["B_CHANNEL_GROUP_INHERITANCE_END"] = "b_channel_group_inheritance_end";
    PermissionType["I_CHANNEL_PERMISSION_MODIFY_POWER"] = "i_channel_permission_modify_power";
    PermissionType["I_CHANNEL_NEEDED_PERMISSION_MODIFY_POWER"] = "i_channel_needed_permission_modify_power";
    PermissionType["B_CHANNEL_INFO_VIEW"] = "b_channel_info_view";
    PermissionType["B_CHANNEL_CREATE_CHILD"] = "b_channel_create_child";
    PermissionType["B_CHANNEL_CREATE_PERMANENT"] = "b_channel_create_permanent";
    PermissionType["B_CHANNEL_CREATE_SEMI_PERMANENT"] = "b_channel_create_semi_permanent";
    PermissionType["B_CHANNEL_CREATE_TEMPORARY"] = "b_channel_create_temporary";
    PermissionType["B_CHANNEL_CREATE_PRIVATE"] = "b_channel_create_private";
    PermissionType["B_CHANNEL_CREATE_WITH_TOPIC"] = "b_channel_create_with_topic";
    PermissionType["B_CHANNEL_CREATE_WITH_DESCRIPTION"] = "b_channel_create_with_description";
    PermissionType["B_CHANNEL_CREATE_WITH_PASSWORD"] = "b_channel_create_with_password";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX8"] = "b_channel_create_modify_with_codec_speex8";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX16"] = "b_channel_create_modify_with_codec_speex16";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_SPEEX32"] = "b_channel_create_modify_with_codec_speex32";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_CELTMONO48"] = "b_channel_create_modify_with_codec_celtmono48";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSVOICE"] = "b_channel_create_modify_with_codec_opusvoice";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_CODEC_OPUSMUSIC"] = "b_channel_create_modify_with_codec_opusmusic";
    PermissionType["I_CHANNEL_CREATE_MODIFY_WITH_CODEC_MAXQUALITY"] = "i_channel_create_modify_with_codec_maxquality";
    PermissionType["I_CHANNEL_CREATE_MODIFY_WITH_CODEC_LATENCY_FACTOR_MIN"] = "i_channel_create_modify_with_codec_latency_factor_min";
    PermissionType["B_CHANNEL_CREATE_WITH_MAXCLIENTS"] = "b_channel_create_with_maxclients";
    PermissionType["B_CHANNEL_CREATE_WITH_MAXFAMILYCLIENTS"] = "b_channel_create_with_maxfamilyclients";
    PermissionType["B_CHANNEL_CREATE_WITH_SORTORDER"] = "b_channel_create_with_sortorder";
    PermissionType["B_CHANNEL_CREATE_WITH_DEFAULT"] = "b_channel_create_with_default";
    PermissionType["B_CHANNEL_CREATE_WITH_NEEDED_TALK_POWER"] = "b_channel_create_with_needed_talk_power";
    PermissionType["B_CHANNEL_CREATE_MODIFY_WITH_FORCE_PASSWORD"] = "b_channel_create_modify_with_force_password";
    PermissionType["I_CHANNEL_CREATE_MODIFY_WITH_TEMP_DELETE_DELAY"] = "i_channel_create_modify_with_temp_delete_delay";
    PermissionType["B_CHANNEL_MODIFY_PARENT"] = "b_channel_modify_parent";
    PermissionType["B_CHANNEL_MODIFY_MAKE_DEFAULT"] = "b_channel_modify_make_default";
    PermissionType["B_CHANNEL_MODIFY_MAKE_PERMANENT"] = "b_channel_modify_make_permanent";
    PermissionType["B_CHANNEL_MODIFY_MAKE_SEMI_PERMANENT"] = "b_channel_modify_make_semi_permanent";
    PermissionType["B_CHANNEL_MODIFY_MAKE_TEMPORARY"] = "b_channel_modify_make_temporary";
    PermissionType["B_CHANNEL_MODIFY_NAME"] = "b_channel_modify_name";
    PermissionType["B_CHANNEL_MODIFY_TOPIC"] = "b_channel_modify_topic";
    PermissionType["B_CHANNEL_MODIFY_DESCRIPTION"] = "b_channel_modify_description";
    PermissionType["B_CHANNEL_MODIFY_PASSWORD"] = "b_channel_modify_password";
    PermissionType["B_CHANNEL_MODIFY_CODEC"] = "b_channel_modify_codec";
    PermissionType["B_CHANNEL_MODIFY_CODEC_QUALITY"] = "b_channel_modify_codec_quality";
    PermissionType["B_CHANNEL_MODIFY_CODEC_LATENCY_FACTOR"] = "b_channel_modify_codec_latency_factor";
    PermissionType["B_CHANNEL_MODIFY_MAXCLIENTS"] = "b_channel_modify_maxclients";
    PermissionType["B_CHANNEL_MODIFY_MAXFAMILYCLIENTS"] = "b_channel_modify_maxfamilyclients";
    PermissionType["B_CHANNEL_MODIFY_SORTORDER"] = "b_channel_modify_sortorder";
    PermissionType["B_CHANNEL_MODIFY_NEEDED_TALK_POWER"] = "b_channel_modify_needed_talk_power";
    PermissionType["I_CHANNEL_MODIFY_POWER"] = "i_channel_modify_power";
    PermissionType["I_CHANNEL_NEEDED_MODIFY_POWER"] = "i_channel_needed_modify_power";
    PermissionType["B_CHANNEL_MODIFY_MAKE_CODEC_ENCRYPTED"] = "b_channel_modify_make_codec_encrypted";
    PermissionType["B_CHANNEL_MODIFY_TEMP_DELETE_DELAY"] = "b_channel_modify_temp_delete_delay";
    PermissionType["B_CHANNEL_DELETE_PERMANENT"] = "b_channel_delete_permanent";
    PermissionType["B_CHANNEL_DELETE_SEMI_PERMANENT"] = "b_channel_delete_semi_permanent";
    PermissionType["B_CHANNEL_DELETE_TEMPORARY"] = "b_channel_delete_temporary";
    PermissionType["B_CHANNEL_DELETE_FLAG_FORCE"] = "b_channel_delete_flag_force";
    PermissionType["I_CHANNEL_DELETE_POWER"] = "i_channel_delete_power";
    PermissionType["I_CHANNEL_NEEDED_DELETE_POWER"] = "i_channel_needed_delete_power";
    PermissionType["B_CHANNEL_JOIN_PERMANENT"] = "b_channel_join_permanent";
    PermissionType["B_CHANNEL_JOIN_SEMI_PERMANENT"] = "b_channel_join_semi_permanent";
    PermissionType["B_CHANNEL_JOIN_TEMPORARY"] = "b_channel_join_temporary";
    PermissionType["B_CHANNEL_JOIN_IGNORE_PASSWORD"] = "b_channel_join_ignore_password";
    PermissionType["B_CHANNEL_JOIN_IGNORE_MAXCLIENTS"] = "b_channel_join_ignore_maxclients";
    PermissionType["B_CHANNEL_IGNORE_VIEW_POWER"] = "b_channel_ignore_view_power";
    PermissionType["I_CHANNEL_JOIN_POWER"] = "i_channel_join_power";
    PermissionType["I_CHANNEL_NEEDED_JOIN_POWER"] = "i_channel_needed_join_power";
    PermissionType["B_CHANNEL_IGNORE_JOIN_POWER"] = "b_channel_ignore_join_power";
    PermissionType["I_CHANNEL_VIEW_POWER"] = "i_channel_view_power";
    PermissionType["I_CHANNEL_NEEDED_VIEW_POWER"] = "i_channel_needed_view_power";
    PermissionType["I_CHANNEL_SUBSCRIBE_POWER"] = "i_channel_subscribe_power";
    PermissionType["I_CHANNEL_NEEDED_SUBSCRIBE_POWER"] = "i_channel_needed_subscribe_power";
    PermissionType["I_CHANNEL_DESCRIPTION_VIEW_POWER"] = "i_channel_description_view_power";
    PermissionType["I_CHANNEL_NEEDED_DESCRIPTION_VIEW_POWER"] = "i_channel_needed_description_view_power";
    PermissionType["I_ICON_ID"] = "i_icon_id";
    PermissionType["I_MAX_ICON_FILESIZE"] = "i_max_icon_filesize";
    PermissionType["B_ICON_MANAGE"] = "b_icon_manage";
    PermissionType["B_GROUP_IS_PERMANENT"] = "b_group_is_permanent";
    PermissionType["I_GROUP_AUTO_UPDATE_TYPE"] = "i_group_auto_update_type";
    PermissionType["I_GROUP_AUTO_UPDATE_MAX_VALUE"] = "i_group_auto_update_max_value";
    PermissionType["I_GROUP_SORT_ID"] = "i_group_sort_id";
    PermissionType["I_GROUP_SHOW_NAME_IN_TREE"] = "i_group_show_name_in_tree";
    PermissionType["B_VIRTUALSERVER_SERVERGROUP_CREATE"] = "b_virtualserver_servergroup_create";
    PermissionType["B_VIRTUALSERVER_SERVERGROUP_LIST"] = "b_virtualserver_servergroup_list";
    PermissionType["B_VIRTUALSERVER_SERVERGROUP_PERMISSION_LIST"] = "b_virtualserver_servergroup_permission_list";
    PermissionType["B_VIRTUALSERVER_SERVERGROUP_CLIENT_LIST"] = "b_virtualserver_servergroup_client_list";
    PermissionType["B_VIRTUALSERVER_CHANNELGROUP_CREATE"] = "b_virtualserver_channelgroup_create";
    PermissionType["B_VIRTUALSERVER_CHANNELGROUP_LIST"] = "b_virtualserver_channelgroup_list";
    PermissionType["B_VIRTUALSERVER_CHANNELGROUP_PERMISSION_LIST"] = "b_virtualserver_channelgroup_permission_list";
    PermissionType["B_VIRTUALSERVER_CHANNELGROUP_CLIENT_LIST"] = "b_virtualserver_channelgroup_client_list";
    PermissionType["B_VIRTUALSERVER_CLIENT_PERMISSION_LIST"] = "b_virtualserver_client_permission_list";
    PermissionType["B_VIRTUALSERVER_CHANNEL_PERMISSION_LIST"] = "b_virtualserver_channel_permission_list";
    PermissionType["B_VIRTUALSERVER_CHANNELCLIENT_PERMISSION_LIST"] = "b_virtualserver_channelclient_permission_list";
    PermissionType["B_VIRTUALSERVER_PLAYLIST_PERMISSION_LIST"] = "b_virtualserver_playlist_permission_list";
    PermissionType["I_SERVER_GROUP_MODIFY_POWER"] = "i_server_group_modify_power";
    PermissionType["I_SERVER_GROUP_NEEDED_MODIFY_POWER"] = "i_server_group_needed_modify_power";
    PermissionType["I_SERVER_GROUP_MEMBER_ADD_POWER"] = "i_server_group_member_add_power";
    PermissionType["I_SERVER_GROUP_SELF_ADD_POWER"] = "i_server_group_self_add_power";
    PermissionType["I_SERVER_GROUP_NEEDED_MEMBER_ADD_POWER"] = "i_server_group_needed_member_add_power";
    PermissionType["I_SERVER_GROUP_MEMBER_REMOVE_POWER"] = "i_server_group_member_remove_power";
    PermissionType["I_SERVER_GROUP_SELF_REMOVE_POWER"] = "i_server_group_self_remove_power";
    PermissionType["I_SERVER_GROUP_NEEDED_MEMBER_REMOVE_POWER"] = "i_server_group_needed_member_remove_power";
    PermissionType["I_CHANNEL_GROUP_MODIFY_POWER"] = "i_channel_group_modify_power";
    PermissionType["I_CHANNEL_GROUP_NEEDED_MODIFY_POWER"] = "i_channel_group_needed_modify_power";
    PermissionType["I_CHANNEL_GROUP_MEMBER_ADD_POWER"] = "i_channel_group_member_add_power";
    PermissionType["I_CHANNEL_GROUP_SELF_ADD_POWER"] = "i_channel_group_self_add_power";
    PermissionType["I_CHANNEL_GROUP_NEEDED_MEMBER_ADD_POWER"] = "i_channel_group_needed_member_add_power";
    PermissionType["I_CHANNEL_GROUP_MEMBER_REMOVE_POWER"] = "i_channel_group_member_remove_power";
    PermissionType["I_CHANNEL_GROUP_SELF_REMOVE_POWER"] = "i_channel_group_self_remove_power";
    PermissionType["I_CHANNEL_GROUP_NEEDED_MEMBER_REMOVE_POWER"] = "i_channel_group_needed_member_remove_power";
    PermissionType["I_GROUP_MEMBER_ADD_POWER"] = "i_group_member_add_power";
    PermissionType["I_GROUP_NEEDED_MEMBER_ADD_POWER"] = "i_group_needed_member_add_power";
    PermissionType["I_GROUP_MEMBER_REMOVE_POWER"] = "i_group_member_remove_power";
    PermissionType["I_GROUP_NEEDED_MEMBER_REMOVE_POWER"] = "i_group_needed_member_remove_power";
    PermissionType["I_GROUP_MODIFY_POWER"] = "i_group_modify_power";
    PermissionType["I_GROUP_NEEDED_MODIFY_POWER"] = "i_group_needed_modify_power";
    PermissionType["I_PERMISSION_MODIFY_POWER"] = "i_permission_modify_power";
    PermissionType["B_PERMISSION_MODIFY_POWER_IGNORE"] = "b_permission_modify_power_ignore";
    PermissionType["B_VIRTUALSERVER_SERVERGROUP_DELETE"] = "b_virtualserver_servergroup_delete";
    PermissionType["B_VIRTUALSERVER_CHANNELGROUP_DELETE"] = "b_virtualserver_channelgroup_delete";
    PermissionType["I_CLIENT_PERMISSION_MODIFY_POWER"] = "i_client_permission_modify_power";
    PermissionType["I_CLIENT_NEEDED_PERMISSION_MODIFY_POWER"] = "i_client_needed_permission_modify_power";
    PermissionType["I_CLIENT_MAX_CLONES_UID"] = "i_client_max_clones_uid";
    PermissionType["I_CLIENT_MAX_CLONES_IP"] = "i_client_max_clones_ip";
    PermissionType["I_CLIENT_MAX_CLONES_HWID"] = "i_client_max_clones_hwid";
    PermissionType["I_CLIENT_MAX_IDLETIME"] = "i_client_max_idletime";
    PermissionType["I_CLIENT_MAX_AVATAR_FILESIZE"] = "i_client_max_avatar_filesize";
    PermissionType["I_CLIENT_MAX_CHANNEL_SUBSCRIPTIONS"] = "i_client_max_channel_subscriptions";
    PermissionType["I_CLIENT_MAX_CHANNELS"] = "i_client_max_channels";
    PermissionType["I_CLIENT_MAX_TEMPORARY_CHANNELS"] = "i_client_max_temporary_channels";
    PermissionType["I_CLIENT_MAX_SEMI_CHANNELS"] = "i_client_max_semi_channels";
    PermissionType["I_CLIENT_MAX_PERMANENT_CHANNELS"] = "i_client_max_permanent_channels";
    PermissionType["B_CLIENT_USE_PRIORITY_SPEAKER"] = "b_client_use_priority_speaker";
    PermissionType["B_CLIENT_SKIP_CHANNELGROUP_PERMISSIONS"] = "b_client_skip_channelgroup_permissions";
    PermissionType["B_CLIENT_FORCE_PUSH_TO_TALK"] = "b_client_force_push_to_talk";
    PermissionType["B_CLIENT_IGNORE_BANS"] = "b_client_ignore_bans";
    PermissionType["B_CLIENT_IGNORE_VPN"] = "b_client_ignore_vpn";
    PermissionType["B_CLIENT_IGNORE_ANTIFLOOD"] = "b_client_ignore_antiflood";
    PermissionType["B_CLIENT_ENFORCE_VALID_HWID"] = "b_client_enforce_valid_hwid";
    PermissionType["B_CLIENT_ALLOW_INVALID_PACKET"] = "b_client_allow_invalid_packet";
    PermissionType["B_CLIENT_ALLOW_INVALID_BADGES"] = "b_client_allow_invalid_badges";
    PermissionType["B_CLIENT_ISSUE_CLIENT_QUERY_COMMAND"] = "b_client_issue_client_query_command";
    PermissionType["B_CLIENT_USE_RESERVED_SLOT"] = "b_client_use_reserved_slot";
    PermissionType["B_CLIENT_USE_CHANNEL_COMMANDER"] = "b_client_use_channel_commander";
    PermissionType["B_CLIENT_REQUEST_TALKER"] = "b_client_request_talker";
    PermissionType["B_CLIENT_AVATAR_DELETE_OTHER"] = "b_client_avatar_delete_other";
    PermissionType["B_CLIENT_IS_STICKY"] = "b_client_is_sticky";
    PermissionType["B_CLIENT_IGNORE_STICKY"] = "b_client_ignore_sticky";
    PermissionType["B_CLIENT_MUSIC_CREATE_PERMANENT"] = "b_client_music_create_permanent";
    PermissionType["B_CLIENT_MUSIC_CREATE_SEMI_PERMANENT"] = "b_client_music_create_semi_permanent";
    PermissionType["B_CLIENT_MUSIC_CREATE_TEMPORARY"] = "b_client_music_create_temporary";
    PermissionType["B_CLIENT_MUSIC_MODIFY_PERMANENT"] = "b_client_music_modify_permanent";
    PermissionType["B_CLIENT_MUSIC_MODIFY_SEMI_PERMANENT"] = "b_client_music_modify_semi_permanent";
    PermissionType["B_CLIENT_MUSIC_MODIFY_TEMPORARY"] = "b_client_music_modify_temporary";
    PermissionType["I_CLIENT_MUSIC_CREATE_MODIFY_MAX_VOLUME"] = "i_client_music_create_modify_max_volume";
    PermissionType["I_CLIENT_MUSIC_LIMIT"] = "i_client_music_limit";
    PermissionType["I_CLIENT_MUSIC_NEEDED_DELETE_POWER"] = "i_client_music_needed_delete_power";
    PermissionType["I_CLIENT_MUSIC_DELETE_POWER"] = "i_client_music_delete_power";
    PermissionType["I_CLIENT_MUSIC_PLAY_POWER"] = "i_client_music_play_power";
    PermissionType["I_CLIENT_MUSIC_NEEDED_PLAY_POWER"] = "i_client_music_needed_play_power";
    PermissionType["I_CLIENT_MUSIC_MODIFY_POWER"] = "i_client_music_modify_power";
    PermissionType["I_CLIENT_MUSIC_NEEDED_MODIFY_POWER"] = "i_client_music_needed_modify_power";
    PermissionType["I_CLIENT_MUSIC_RENAME_POWER"] = "i_client_music_rename_power";
    PermissionType["I_CLIENT_MUSIC_NEEDED_RENAME_POWER"] = "i_client_music_needed_rename_power";
    PermissionType["B_PLAYLIST_CREATE"] = "b_playlist_create";
    PermissionType["I_PLAYLIST_VIEW_POWER"] = "i_playlist_view_power";
    PermissionType["I_PLAYLIST_NEEDED_VIEW_POWER"] = "i_playlist_needed_view_power";
    PermissionType["I_PLAYLIST_MODIFY_POWER"] = "i_playlist_modify_power";
    PermissionType["I_PLAYLIST_NEEDED_MODIFY_POWER"] = "i_playlist_needed_modify_power";
    PermissionType["I_PLAYLIST_PERMISSION_MODIFY_POWER"] = "i_playlist_permission_modify_power";
    PermissionType["I_PLAYLIST_NEEDED_PERMISSION_MODIFY_POWER"] = "i_playlist_needed_permission_modify_power";
    PermissionType["I_PLAYLIST_DELETE_POWER"] = "i_playlist_delete_power";
    PermissionType["I_PLAYLIST_NEEDED_DELETE_POWER"] = "i_playlist_needed_delete_power";
    PermissionType["I_PLAYLIST_SONG_ADD_POWER"] = "i_playlist_song_add_power";
    PermissionType["I_PLAYLIST_SONG_NEEDED_ADD_POWER"] = "i_playlist_song_needed_add_power";
    PermissionType["I_PLAYLIST_SONG_REMOVE_POWER"] = "i_playlist_song_remove_power";
    PermissionType["I_PLAYLIST_SONG_NEEDED_REMOVE_POWER"] = "i_playlist_song_needed_remove_power";
    PermissionType["B_CLIENT_INFO_VIEW"] = "b_client_info_view";
    PermissionType["B_CLIENT_PERMISSIONOVERVIEW_VIEW"] = "b_client_permissionoverview_view";
    PermissionType["B_CLIENT_PERMISSIONOVERVIEW_OWN"] = "b_client_permissionoverview_own";
    PermissionType["B_CLIENT_REMOTEADDRESS_VIEW"] = "b_client_remoteaddress_view";
    PermissionType["I_CLIENT_SERVERQUERY_VIEW_POWER"] = "i_client_serverquery_view_power";
    PermissionType["I_CLIENT_NEEDED_SERVERQUERY_VIEW_POWER"] = "i_client_needed_serverquery_view_power";
    PermissionType["B_CLIENT_CUSTOM_INFO_VIEW"] = "b_client_custom_info_view";
    PermissionType["B_CLIENT_MUSIC_CHANNEL_LIST"] = "b_client_music_channel_list";
    PermissionType["B_CLIENT_MUSIC_SERVER_LIST"] = "b_client_music_server_list";
    PermissionType["I_CLIENT_MUSIC_INFO"] = "i_client_music_info";
    PermissionType["I_CLIENT_MUSIC_NEEDED_INFO"] = "i_client_music_needed_info";
    PermissionType["I_CLIENT_KICK_FROM_SERVER_POWER"] = "i_client_kick_from_server_power";
    PermissionType["I_CLIENT_NEEDED_KICK_FROM_SERVER_POWER"] = "i_client_needed_kick_from_server_power";
    PermissionType["I_CLIENT_KICK_FROM_CHANNEL_POWER"] = "i_client_kick_from_channel_power";
    PermissionType["I_CLIENT_NEEDED_KICK_FROM_CHANNEL_POWER"] = "i_client_needed_kick_from_channel_power";
    PermissionType["I_CLIENT_BAN_POWER"] = "i_client_ban_power";
    PermissionType["I_CLIENT_NEEDED_BAN_POWER"] = "i_client_needed_ban_power";
    PermissionType["I_CLIENT_MOVE_POWER"] = "i_client_move_power";
    PermissionType["I_CLIENT_NEEDED_MOVE_POWER"] = "i_client_needed_move_power";
    PermissionType["I_CLIENT_COMPLAIN_POWER"] = "i_client_complain_power";
    PermissionType["I_CLIENT_NEEDED_COMPLAIN_POWER"] = "i_client_needed_complain_power";
    PermissionType["B_CLIENT_COMPLAIN_LIST"] = "b_client_complain_list";
    PermissionType["B_CLIENT_COMPLAIN_DELETE_OWN"] = "b_client_complain_delete_own";
    PermissionType["B_CLIENT_COMPLAIN_DELETE"] = "b_client_complain_delete";
    PermissionType["B_CLIENT_BAN_LIST"] = "b_client_ban_list";
    PermissionType["B_CLIENT_BAN_LIST_GLOBAL"] = "b_client_ban_list_global";
    PermissionType["B_CLIENT_BAN_TRIGGER_LIST"] = "b_client_ban_trigger_list";
    PermissionType["B_CLIENT_BAN_CREATE"] = "b_client_ban_create";
    PermissionType["B_CLIENT_BAN_CREATE_GLOBAL"] = "b_client_ban_create_global";
    PermissionType["B_CLIENT_BAN_NAME"] = "b_client_ban_name";
    PermissionType["B_CLIENT_BAN_IP"] = "b_client_ban_ip";
    PermissionType["B_CLIENT_BAN_HWID"] = "b_client_ban_hwid";
    PermissionType["B_CLIENT_BAN_EDIT"] = "b_client_ban_edit";
    PermissionType["B_CLIENT_BAN_EDIT_GLOBAL"] = "b_client_ban_edit_global";
    PermissionType["B_CLIENT_BAN_DELETE_OWN"] = "b_client_ban_delete_own";
    PermissionType["B_CLIENT_BAN_DELETE"] = "b_client_ban_delete";
    PermissionType["B_CLIENT_BAN_DELETE_OWN_GLOBAL"] = "b_client_ban_delete_own_global";
    PermissionType["B_CLIENT_BAN_DELETE_GLOBAL"] = "b_client_ban_delete_global";
    PermissionType["I_CLIENT_BAN_MAX_BANTIME"] = "i_client_ban_max_bantime";
    PermissionType["I_CLIENT_PRIVATE_TEXTMESSAGE_POWER"] = "i_client_private_textmessage_power";
    PermissionType["I_CLIENT_NEEDED_PRIVATE_TEXTMESSAGE_POWER"] = "i_client_needed_private_textmessage_power";
    PermissionType["B_CLIENT_EVEN_TEXTMESSAGE_SEND"] = "b_client_even_textmessage_send";
    PermissionType["B_CLIENT_SERVER_TEXTMESSAGE_SEND"] = "b_client_server_textmessage_send";
    PermissionType["B_CLIENT_CHANNEL_TEXTMESSAGE_SEND"] = "b_client_channel_textmessage_send";
    PermissionType["B_CLIENT_OFFLINE_TEXTMESSAGE_SEND"] = "b_client_offline_textmessage_send";
    PermissionType["I_CLIENT_TALK_POWER"] = "i_client_talk_power";
    PermissionType["I_CLIENT_NEEDED_TALK_POWER"] = "i_client_needed_talk_power";
    PermissionType["I_CLIENT_POKE_POWER"] = "i_client_poke_power";
    PermissionType["I_CLIENT_NEEDED_POKE_POWER"] = "i_client_needed_poke_power";
    PermissionType["B_CLIENT_SET_FLAG_TALKER"] = "b_client_set_flag_talker";
    PermissionType["I_CLIENT_WHISPER_POWER"] = "i_client_whisper_power";
    PermissionType["I_CLIENT_NEEDED_WHISPER_POWER"] = "i_client_needed_whisper_power";
    PermissionType["B_CLIENT_MODIFY_DESCRIPTION"] = "b_client_modify_description";
    PermissionType["B_CLIENT_MODIFY_OWN_DESCRIPTION"] = "b_client_modify_own_description";
    PermissionType["B_CLIENT_USE_BBCODE_ANY"] = "b_client_use_bbcode_any";
    PermissionType["B_CLIENT_USE_BBCODE_URL"] = "b_client_use_bbcode_url";
    PermissionType["B_CLIENT_USE_BBCODE_IMAGE"] = "b_client_use_bbcode_image";
    PermissionType["B_CLIENT_MODIFY_DBPROPERTIES"] = "b_client_modify_dbproperties";
    PermissionType["B_CLIENT_DELETE_DBPROPERTIES"] = "b_client_delete_dbproperties";
    PermissionType["B_CLIENT_CREATE_MODIFY_SERVERQUERY_LOGIN"] = "b_client_create_modify_serverquery_login";
    PermissionType["B_CLIENT_QUERY_CREATE"] = "b_client_query_create";
    PermissionType["B_CLIENT_QUERY_LIST"] = "b_client_query_list";
    PermissionType["B_CLIENT_QUERY_LIST_OWN"] = "b_client_query_list_own";
    PermissionType["B_CLIENT_QUERY_RENAME"] = "b_client_query_rename";
    PermissionType["B_CLIENT_QUERY_RENAME_OWN"] = "b_client_query_rename_own";
    PermissionType["B_CLIENT_QUERY_CHANGE_PASSWORD"] = "b_client_query_change_password";
    PermissionType["B_CLIENT_QUERY_CHANGE_OWN_PASSWORD"] = "b_client_query_change_own_password";
    PermissionType["B_CLIENT_QUERY_CHANGE_PASSWORD_GLOBAL"] = "b_client_query_change_password_global";
    PermissionType["B_CLIENT_QUERY_DELETE"] = "b_client_query_delete";
    PermissionType["B_CLIENT_QUERY_DELETE_OWN"] = "b_client_query_delete_own";
    PermissionType["B_FT_IGNORE_PASSWORD"] = "b_ft_ignore_password";
    PermissionType["B_FT_TRANSFER_LIST"] = "b_ft_transfer_list";
    PermissionType["I_FT_FILE_UPLOAD_POWER"] = "i_ft_file_upload_power";
    PermissionType["I_FT_NEEDED_FILE_UPLOAD_POWER"] = "i_ft_needed_file_upload_power";
    PermissionType["I_FT_FILE_DOWNLOAD_POWER"] = "i_ft_file_download_power";
    PermissionType["I_FT_NEEDED_FILE_DOWNLOAD_POWER"] = "i_ft_needed_file_download_power";
    PermissionType["I_FT_FILE_DELETE_POWER"] = "i_ft_file_delete_power";
    PermissionType["I_FT_NEEDED_FILE_DELETE_POWER"] = "i_ft_needed_file_delete_power";
    PermissionType["I_FT_FILE_RENAME_POWER"] = "i_ft_file_rename_power";
    PermissionType["I_FT_NEEDED_FILE_RENAME_POWER"] = "i_ft_needed_file_rename_power";
    PermissionType["I_FT_FILE_BROWSE_POWER"] = "i_ft_file_browse_power";
    PermissionType["I_FT_NEEDED_FILE_BROWSE_POWER"] = "i_ft_needed_file_browse_power";
    PermissionType["I_FT_DIRECTORY_CREATE_POWER"] = "i_ft_directory_create_power";
    PermissionType["I_FT_NEEDED_DIRECTORY_CREATE_POWER"] = "i_ft_needed_directory_create_power";
    PermissionType["I_FT_QUOTA_MB_DOWNLOAD_PER_CLIENT"] = "i_ft_quota_mb_download_per_client";
    PermissionType["I_FT_QUOTA_MB_UPLOAD_PER_CLIENT"] = "i_ft_quota_mb_upload_per_client";
})(PermissionType || (PermissionType = {}));
class PermissionInfo {
    is_boolean() { return this.name.startsWith("b_"); }
    id_grant() {
        return this.id | (1 << 15);
    }
}
class PermissionGroup {
}
class GroupedPermissions {
}
class PermissionValue {
    constructor(type, value) {
        this.type = type;
        this.value = value;
    }
    granted(requiredValue, required = true) {
        let result;
        result = this.value == -1 || this.value >= requiredValue || (this.value == -2 && requiredValue == -2 && !required);
        log.trace(LogCategory.PERMISSIONS, _translations.jgkf4lJo || (_translations.jgkf4lJo = tr("Test needed required: %o | %i | %o => %o")), this, requiredValue, required, result);
        return result;
    }
    hasValue() {
        return typeof (this.value) !== "undefined" && this.value != -2;
    }
    hasGrant() {
        return typeof (this.granted_value) !== "undefined" && this.granted_value != -2;
    }
}
class NeededPermissionValue extends PermissionValue {
    constructor(type, value) {
        super(type, value);
        this.changeListener = [];
    }
}
class ChannelPermissionRequest {
    constructor() {
        this.callback_success = [];
        this.callback_error = [];
    }
}
class TeaPermissionRequest {
}
class PermissionManager extends connection.AbstractCommandHandler {
    constructor(client) {
        super(client.serverConnection);
        this.permissionList = [];
        this.permissionGroups = [];
        this.neededPermissions = [];
        this.requests_channel_permissions = [];
        this.requests_client_permissions = [];
        this.requests_client_channel_permissions = [];
        this.requests_playlist_permissions = [];
        this.initializedListener = [];
        //FIXME? Dont register the handler like this?
        this.volatile_handler_boss = true;
        client.serverConnection.command_handler_boss().register_handler(this);
        this.handle = client;
    }
    static parse_permission_bulk(json, manager) {
        let permissions = [];
        for (let perm of json) {
            if (perm["permid"] === undefined)
                continue;
            let perm_id = parseInt(perm["permid"]);
            let perm_grant = (perm_id & (1 << 15)) > 0;
            if (perm_grant)
                perm_id &= ~(1 << 15);
            let perm_info = manager.resolveInfo(perm_id);
            if (!perm_info) {
                log.warn(LogCategory.PERMISSIONS, _translations.RX5InTHF || (_translations.RX5InTHF = tr("Got unknown permission id (%o/%o (%o))!")), perm["permid"], perm_id, perm["permsid"]);
                return;
            }
            let permission;
            for (let ref_perm of permissions) {
                if (ref_perm.type == perm_info) {
                    permission = ref_perm;
                    break;
                }
            }
            if (!permission) {
                permission = new PermissionValue(perm_info, 0);
                permission.granted_value = undefined;
                permission.value = undefined;
                permissions.push(permission);
            }
            if (perm_grant) {
                permission.granted_value = parseInt(perm["permvalue"]);
            }
            else {
                permission.value = parseInt(perm["permvalue"]);
                permission.flag_negate = perm["permnegated"] == "1";
                permission.flag_skip = perm["permskip"] == "1";
            }
        }
        return permissions;
    }
    handle_command(command) {
        switch (command.command) {
            case "notifyclientneededpermissions":
                this.onNeededPermissions(command.arguments);
                return true;
            case "notifypermissionlist":
                this.onPermissionList(command.arguments);
                return true;
            case "notifychannelpermlist":
                this.onChannelPermList(command.arguments);
                return true;
            case "notifyclientpermlist":
                this.onClientPermList(command.arguments);
                return true;
            case "notifyplaylistpermlist":
                this.onPlaylistPermList(command.arguments);
                return true;
        }
        return false;
    }
    initialized() {
        return this.permissionList.length > 0;
    }
    requestPermissionList() {
        this.handle.serverConnection.send_command("permissionlist");
    }
    onPermissionList(json) {
        this.permissionList = [];
        this.permissionGroups = [];
        this._group_mapping = PermissionManager.group_mapping.slice();
        let group = log.group(log.LogType.TRACE, LogCategory.PERMISSIONS, _translations.NPu5rNZX || (_translations.NPu5rNZX = tr("Permission mapping")));
        const table_entries = [];
        let permission_id = 0;
        for (let e of json) {
            if (e["group_id_end"]) {
                let group = new PermissionGroup();
                group.begin = this.permissionGroups.length ? this.permissionGroups.last().end : 0;
                group.end = parseInt(e["group_id_end"]);
                group.deep = 0;
                group.name = (_translations.lxokiMWI || (_translations.lxokiMWI = tr("Group "))) + e["group_id_end"];
                let info = this._group_mapping.pop_front();
                if (info) {
                    group.name = info.name;
                    group.deep = info.deep;
                }
                this.permissionGroups.push(group);
                continue;
            }
            let perm = new PermissionInfo();
            permission_id++;
            perm.name = e["permname"];
            perm.id = parseInt(e["permid"]) || permission_id; /* using permission_id as fallback if we dont have permid */
            perm.description = e["permdesc"];
            this.permissionList.push(perm);
            table_entries.push({
                "id": perm.id,
                "name": perm.name,
                "description": perm.description
            });
        }
        log.table("Permission list", table_entries);
        group.end();
        log.info(LogCategory.PERMISSIONS, _translations.jkrTUtsb || (_translations.jkrTUtsb = tr("Got %i permissions")), this.permissionList.length);
        if (this._cacheNeededPermissions)
            this.onNeededPermissions(this._cacheNeededPermissions);
        for (let listener of this.initializedListener)
            listener(true);
    }
    onNeededPermissions(json) {
        if (this.permissionList.length == 0) {
            log.warn(LogCategory.PERMISSIONS, _translations.jP28V5vV || (_translations.jP28V5vV = tr("Got needed permissions but don't have a permission list!")));
            this._cacheNeededPermissions = json;
            return;
        }
        this._cacheNeededPermissions = undefined;
        let copy = this.neededPermissions.slice();
        let addcount = 0;
        let group = log.group(log.LogType.TRACE, LogCategory.PERMISSIONS, _translations.LJi7kl_6 || (_translations.LJi7kl_6 = tr("Got %d needed permissions.")), json.length);
        const table_entries = [];
        for (let e of json) {
            let entry = undefined;
            for (let p of copy) {
                if (p.type.id == e["permid"]) {
                    entry = p;
                    copy.remove(p);
                    break;
                }
            }
            if (!entry) {
                let info = this.resolveInfo(e["permid"]);
                if (info) {
                    entry = new NeededPermissionValue(info, -2);
                    this.neededPermissions.push(entry);
                }
                else {
                    log.warn(LogCategory.PERMISSIONS, _translations.BsVGMqaN || (_translations.BsVGMqaN = tr("Could not resolve perm for id %s (%o|%o)")), e["permid"], e, info);
                    continue;
                }
                addcount++;
            }
            if (entry.value == parseInt(e["permvalue"]))
                continue;
            entry.value = parseInt(e["permvalue"]);
            for (let listener of entry.changeListener)
                listener(entry.value);
            table_entries.push({
                "permission": entry.type.name,
                "value": entry.value
            });
        }
        log.table("Needed client permissions", table_entries);
        group.end();
        //TODO tr
        log.debug(LogCategory.PERMISSIONS, "Dropping " + copy.length + " needed permissions and added " + addcount + " permissions.");
        for (let e of copy) {
            e.value = -2;
            for (let listener of e.changeListener)
                listener(e.value);
        }
    }
    onChannelPermList(json) {
        let channelId = parseInt(json[0]["cid"]);
        let permissions = PermissionManager.parse_permission_bulk(json, this.handle.permissions);
        log.debug(LogCategory.PERMISSIONS, _translations.Grfup0ih || (_translations.Grfup0ih = tr("Got channel permissions for channel %o")), channelId);
        for (let element of this.requests_channel_permissions) {
            if (element.channel_id == channelId) {
                for (let l of element.callback_success)
                    l(permissions);
                this.requests_channel_permissions.remove(element);
                return;
            }
        }
        log.debug(LogCategory.PERMISSIONS, _translations.fUOWxSiS || (_translations.fUOWxSiS = tr("Missing channel permission handle for requested channel id %o")), channelId);
    }
    resolveInfo(key) {
        for (let perm of this.permissionList)
            if (perm.id == key || perm.name == key)
                return perm;
        return undefined;
    }
    requestChannelPermissions(channelId) {
        return new Promise((resolve, reject) => {
            let request;
            for (let element of this.requests_channel_permissions)
                if (element.requested + 1000 < Date.now() && element.channel_id == channelId) {
                    request = element;
                    break;
                }
            if (!request) {
                request = new ChannelPermissionRequest();
                request.requested = Date.now();
                request.channel_id = channelId;
                this.handle.serverConnection.send_command("channelpermlist", { "cid": channelId });
                this.requests_channel_permissions.push(request);
            }
            request.callback_error.push(reject);
            request.callback_success.push(resolve);
        });
    }
    onClientPermList(json) {
        let client = parseInt(json[0]["cldbid"]);
        let permissions = PermissionManager.parse_permission_bulk(json, this);
        for (let req of this.requests_client_permissions.slice(0)) {
            if (req.client_id == client) {
                this.requests_client_permissions.remove(req);
                req.promise.resolved(permissions);
            }
        }
    }
    requestClientPermissions(client_id) {
        for (let request of this.requests_client_permissions)
            if (request.client_id == client_id && request.promise.time() + 1000 > Date.now())
                return request.promise;
        let request = {};
        request.client_id = client_id;
        request.promise = new LaterPromise();
        this.handle.serverConnection.send_command("clientpermlist", { cldbid: client_id }).catch(error => {
            if (error instanceof CommandResult && error.id == ErrorID.EMPTY_RESULT)
                request.promise.resolved([]);
            else
                request.promise.rejected(error);
        });
        this.requests_client_permissions.push(request);
        return request.promise;
    }
    requestClientChannelPermissions(client_id, channel_id) {
        for (let request of this.requests_client_channel_permissions)
            if (request.client_id == client_id && request.channel_id == channel_id && request.promise.time() + 1000 > Date.now())
                return request.promise;
        let request = {};
        request.client_id = client_id;
        request.channel_id = channel_id;
        request.promise = new LaterPromise();
        this.handle.serverConnection.send_command("channelclientpermlist", { cldbid: client_id, cid: channel_id }).catch(error => {
            if (error instanceof CommandResult && error.id == ErrorID.EMPTY_RESULT)
                request.promise.resolved([]);
            else
                request.promise.rejected(error);
        });
        this.requests_client_channel_permissions.push(request);
        return request.promise;
    }
    onPlaylistPermList(json) {
        let playlist_id = parseInt(json[0]["playlist_id"]);
        let permissions = PermissionManager.parse_permission_bulk(json, this);
        for (let req of this.requests_playlist_permissions.slice(0)) {
            if (req.playlist_id == playlist_id) {
                this.requests_playlist_permissions.remove(req);
                req.promise.resolved(permissions);
            }
        }
    }
    requestPlaylistPermissions(playlist_id) {
        for (let request of this.requests_playlist_permissions)
            if (request.playlist_id == playlist_id && request.promise.time() + 1000 > Date.now())
                return request.promise;
        let request = {};
        request.playlist_id = playlist_id;
        request.promise = new LaterPromise();
        this.handle.serverConnection.send_command("playlistpermlist", { playlist_id: playlist_id }).catch(error => {
            if (error instanceof CommandResult && error.id == ErrorID.EMPTY_RESULT)
                request.promise.resolved([]);
            else
                request.promise.rejected(error);
        });
        this.requests_playlist_permissions.push(request);
        return request.promise;
    }
    neededPermission(key) {
        for (let perm of this.neededPermissions)
            if (perm.type.id == key || perm.type.name == key || perm.type == key)
                return perm;
        log.debug(LogCategory.PERMISSIONS, _translations.M1_OSPsn || (_translations.M1_OSPsn = tr("Could not resolve grant permission %o. Creating a new one.")), key);
        let info = key instanceof PermissionInfo ? key : this.resolveInfo(key);
        if (!info) {
            log.warn(LogCategory.PERMISSIONS, _translations.AAxaZC8p || (_translations.AAxaZC8p = tr("Requested needed permission with invalid key! (%o)")), key);
            return new NeededPermissionValue(undefined, -2);
        }
        let result = new NeededPermissionValue(info, -2);
        this.neededPermissions.push(result);
        return result;
    }
    groupedPermissions() {
        let result = [];
        let current;
        for (let group of this.permissionGroups) {
            if (group.deep == 0) {
                current = new GroupedPermissions();
                current.group = group;
                current.parent = undefined;
                current.children = [];
                current.permissions = [];
                result.push(current);
            }
            else {
                if (!current) {
                    throw _translations.YY4WRh8z || (_translations.YY4WRh8z = tr("invalid order!"));
                }
                else {
                    while (group.deep <= current.group.deep)
                        current = current.parent;
                    let parent = current;
                    current = new GroupedPermissions();
                    current.group = group;
                    current.parent = parent;
                    current.children = [];
                    current.permissions = [];
                    parent.children.push(current);
                }
            }
            for (let permission of this.permissionList)
                if (permission.id > current.group.begin && permission.id <= current.group.end)
                    current.permissions.push(permission);
        }
        return result;
    }
    /**
     * Generates an enum with all know permission types, used for the enum above
     */
    export_permission_types() {
        let result = "";
        result = result + "enum PermissionType {\n";
        for (const permission of this.permissionList) {
            if (!permission.name)
                continue;
            result = result + "\t" + permission.name.toUpperCase() + " = \"" + permission.name.toLowerCase() + "\", /* Permission ID: " + permission.id + " */\n";
        }
        result = result + "}";
        return result;
    }
}
/* Static info mapping until TeaSpeak implements a detailed info */
//TODO tr
PermissionManager.group_mapping = [
    { name: "Global", deep: 0 },
    { name: "Information", deep: 1 },
    { name: "Virtual server management", deep: 1 },
    { name: "Administration", deep: 1 },
    { name: "Settings", deep: 1 },
    { name: "Virtual Server", deep: 0 },
    { name: "Information", deep: 1 },
    { name: "Administration", deep: 1 },
    { name: "Settings", deep: 1 },
    { name: "Channel", deep: 0 },
    { name: "Information", deep: 1 },
    { name: "Create", deep: 1 },
    { name: "Modify", deep: 1 },
    { name: "Delete", deep: 1 },
    { name: "Access", deep: 1 },
    { name: "Group", deep: 0 },
    { name: "Information", deep: 1 },
    { name: "Create", deep: 1 },
    { name: "Modify", deep: 1 },
    { name: "Delete", deep: 1 },
    { name: "Client", deep: 0 },
    { name: "Information", deep: 1 },
    { name: "Admin", deep: 1 },
    { name: "Basics", deep: 1 },
    { name: "Modify", deep: 1 },
    //TODO Music bot
    { name: "File Transfer", deep: 0 },
];
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["80c521208d299c583433cf530e366a68d47a53a40aa6239d35680d4b675061e3"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["80c521208d299c583433cf530e366a68d47a53a40aa6239d35680d4b675061e3"] = "80c521208d299c583433cf530e366a68d47a53a40aa6239d35680d4b675061e3";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "HSjoGbg6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/GroupManager.ts (127,27)" }, { name: "vla3UI5F", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/GroupManager.ts (197,48)" }, { name: "GnH_X2aS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/permission/GroupManager.ts (206,47)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../connection/ConnectionBase.ts" />
var GroupType;
(function (GroupType) {
    GroupType[GroupType["QUERY"] = 0] = "QUERY";
    GroupType[GroupType["TEMPLATE"] = 1] = "TEMPLATE";
    GroupType[GroupType["NORMAL"] = 2] = "NORMAL";
})(GroupType || (GroupType = {}));
var GroupTarget;
(function (GroupTarget) {
    GroupTarget[GroupTarget["SERVER"] = 0] = "SERVER";
    GroupTarget[GroupTarget["CHANNEL"] = 1] = "CHANNEL";
})(GroupTarget || (GroupTarget = {}));
class GroupProperties {
    constructor() {
        this.iconid = 0;
        this.sortid = 0;
        this.savedb = false;
        this.namemode = 0;
    }
}
class GroupPermissionRequest {
}
class Group {
    constructor(handle, id, target, type, name) {
        this.properties = new GroupProperties();
        this.requiredModifyPower = 0;
        this.requiredMemberAddPower = 0;
        this.requiredMemberRemovePower = 0;
        this.handle = handle;
        this.id = id;
        this.target = target;
        this.type = type;
        this.name = name;
    }
    updateProperty(key, value) {
        JSON.map_field_to(this.properties, value, key);
        if (key == "iconid") {
            this.properties.iconid = (new Uint32Array([this.properties.iconid]))[0];
            console.log("Icon id " + this.properties.iconid);
            this.handle.handle.channelTree.clientsByGroup(this).forEach(client => {
                client.updateGroupIcon(this);
            });
        }
    }
}
class GroupManager extends connection.AbstractCommandHandler {
    constructor(client) {
        super(client.serverConnection);
        this.serverGroups = [];
        this.channelGroups = [];
        this.requests_group_permissions = [];
        client.serverConnection.command_handler_boss().register_handler(this);
        this.handle = client;
    }
    handle_command(command) {
        switch (command.command) {
            case "notifyservergrouplist":
            case "notifychannelgrouplist":
                this.handle_grouplist(command.arguments);
                return true;
            case "notifyservergrouppermlist":
            case "notifychannelgrouppermlist":
                this.handle_group_permission_list(command.arguments);
                return true;
        }
        return false;
    }
    requestGroups() {
        this.handle.serverConnection.send_command("servergrouplist");
        this.handle.serverConnection.send_command("channelgrouplist");
    }
    static sorter() {
        return (a, b) => {
            if (a.properties.sortid > b.properties.sortid)
                return 1;
            if (a.properties.sortid < b.properties.sortid)
                return -1;
            if (a.id < b.id)
                return -1;
            if (a.id > b.id)
                return 1;
            return 0;
        };
    }
    serverGroup(id) {
        for (let group of this.serverGroups)
            if (group.id == id)
                return group;
        return undefined;
    }
    channelGroup(id) {
        for (let group of this.channelGroups)
            if (group.id == id)
                return group;
        return undefined;
    }
    handle_grouplist(json) {
        let target;
        if (json[0]["sgid"])
            target = GroupTarget.SERVER;
        else if (json[0]["cgid"])
            target = GroupTarget.CHANNEL;
        else {
            console.error(_translations.HSjoGbg6 || (_translations.HSjoGbg6 = tr("Could not resolve group target! => %o")), json[0]);
            return;
        }
        if (target == GroupTarget.SERVER)
            this.serverGroups = [];
        else
            this.channelGroups = [];
        for (let groupData of json) {
            let type;
            switch (Number.parseInt(groupData["type"])) {
                case 0:
                    type = GroupType.TEMPLATE;
                    break;
                case 1:
                    type = GroupType.NORMAL;
                    break;
                case 2:
                    type = GroupType.QUERY;
                    break;
                default:
                    //TODO tr
                    console.error("Invalid group type: " + groupData["type"] + " for group " + groupData["name"]);
                    continue;
            }
            let group = new Group(this, parseInt(target == GroupTarget.SERVER ? groupData["sgid"] : groupData["cgid"]), target, type, groupData["name"]);
            for (let key in groupData) {
                if (key == "sgid")
                    continue;
                if (key == "cgid")
                    continue;
                if (key == "type")
                    continue;
                if (key == "name")
                    continue;
                group.updateProperty(key, groupData[key]);
            }
            group.requiredMemberRemovePower = parseInt(groupData["n_member_removep"]);
            group.requiredMemberAddPower = parseInt(groupData["n_member_addp"]);
            group.requiredModifyPower = parseInt(groupData["n_modifyp"]);
            if (target == GroupTarget.SERVER)
                this.serverGroups.push(group);
            else
                this.channelGroups.push(group);
        }
        console.log("Got " + json.length + " new " + target + " groups:");
        for (const client of this.handle.channelTree.clients)
            client.update_displayed_client_groups();
    }
    request_permissions(group) {
        for (let request of this.requests_group_permissions)
            if (request.group_id == group.id && request.promise.time() + 1000 > Date.now())
                return request.promise;
        let req = new GroupPermissionRequest();
        req.group_id = group.id;
        req.promise = new LaterPromise();
        this.requests_group_permissions.push(req);
        this.handle.serverConnection.send_command(group.target == GroupTarget.SERVER ? "servergrouppermlist" : "channelgrouppermlist", {
            cgid: group.id,
            sgid: group.id
        }).catch(error => {
            if (error instanceof CommandResult && error.id == 0x0501)
                req.promise.resolved([]);
            else
                req.promise.rejected(error);
        });
        return req.promise;
    }
    handle_group_permission_list(json) {
        let group = json[0]["sgid"] ? this.serverGroup(parseInt(json[0]["sgid"])) : this.channelGroup(parseInt(json[0]["cgid"]));
        if (!group) {
            log.error(LogCategory.PERMISSIONS, _translations.vla3UI5F || (_translations.vla3UI5F = tr("Got group permissions for group %o/%o, but its not a registered group!")), json[0]["sgid"], json[0]["cgid"]);
            return;
        }
        let requests = [];
        for (let req of this.requests_group_permissions)
            if (req.group_id == group.id)
                requests.push(req);
        if (requests.length == 0) {
            log.warn(LogCategory.PERMISSIONS, _translations.GnH_X2aS || (_translations.GnH_X2aS = tr("Got group permissions for group %o/%o, but it was never requested!")), json[0]["sgid"], json[0]["cgid"]);
            return;
        }
        let permissions = PermissionManager.parse_permission_bulk(json, this.handle.permissions);
        for (let req of requests) {
            this.requests_group_permissions.remove(req);
            req.promise.resolved(permissions);
        }
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e0150eb8601336e981edbf10b09a8cb602b42d927819c18b53f3132a1c7a88f1"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e0150eb8601336e981edbf10b09a8cb602b42d927819c18b53f3132a1c7a88f1"] = "e0150eb8601336e981edbf10b09a8cb602b42d927819c18b53f3132a1c7a88f1";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "BHuLoMZv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/Identity.ts (79,30)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var profiles;
(function (profiles) {
    var identities;
    (function (identities) {
        let IdentitifyType;
        (function (IdentitifyType) {
            IdentitifyType[IdentitifyType["TEAFORO"] = 0] = "TEAFORO";
            IdentitifyType[IdentitifyType["TEAMSPEAK"] = 1] = "TEAMSPEAK";
            IdentitifyType[IdentitifyType["NICKNAME"] = 2] = "NICKNAME";
        })(IdentitifyType = identities.IdentitifyType || (identities.IdentitifyType = {}));
        function decode_identity(type, data) {
            return __awaiter(this, void 0, void 0, function* () {
                let identity;
                switch (type) {
                    case IdentitifyType.NICKNAME:
                        identity = new identities.NameIdentity();
                        break;
                    case IdentitifyType.TEAFORO:
                        identity = new identities.TeaForumIdentity(undefined, undefined);
                        break;
                    case IdentitifyType.TEAMSPEAK:
                        identity = new identities.TeaSpeakIdentity(undefined, undefined);
                        break;
                }
                if (!identity)
                    return undefined;
                try {
                    yield identity.decode(data);
                }
                catch (error) {
                    /* todo better error handling! */
                    console.error(error);
                    return undefined;
                }
                return identity;
            });
        }
        identities.decode_identity = decode_identity;
        function create_identity(type) {
            let identity;
            switch (type) {
                case IdentitifyType.NICKNAME:
                    identity = new identities.NameIdentity();
                    break;
                case IdentitifyType.TEAFORO:
                    identity = new identities.TeaForumIdentity(undefined, undefined);
                    break;
                case IdentitifyType.TEAMSPEAK:
                    identity = new identities.TeaSpeakIdentity(undefined, undefined);
                    break;
            }
            return identity;
        }
        identities.create_identity = create_identity;
        class HandshakeCommandHandler extends connection.AbstractCommandHandler {
            constructor(connection, handle) {
                super(connection);
                this.handle = handle;
            }
            handle_command(command) {
                if ($.isFunction(this[command.command]))
                    this[command.command](command.arguments);
                else if (command.command == "error") {
                    return false;
                }
                else {
                    console.warn(_translations.BHuLoMZv || (_translations.BHuLoMZv = tr("Received unknown command while handshaking (%o)")), command);
                }
                return true;
            }
        }
        identities.HandshakeCommandHandler = HandshakeCommandHandler;
        class AbstractHandshakeIdentityHandler {
            constructor(connection) {
                this.callbacks = [];
                this.connection = connection;
            }
            register_callback(callback) {
                this.callbacks.push(callback);
            }
            trigger_success() {
                for (const callback of this.callbacks)
                    callback(true);
            }
            trigger_fail(message) {
                for (const callback of this.callbacks)
                    callback(false, message);
            }
        }
        identities.AbstractHandshakeIdentityHandler = AbstractHandshakeIdentityHandler;
    })(identities = profiles.identities || (profiles.identities = {}));
})(profiles || (profiles = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e5cb5147503556b50d884515dd39805f9706f1469746653cf917f318d18256b7"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e5cb5147503556b50d884515dd39805f9706f1469746653cf917f318d18256b7"] = "e5cb5147503556b50d884515dd39805f9706f1469746653cf917f318d18256b7";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "NnaMnk_h", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (11,21)" }, { name: "SfBwprn1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (37,40)" }, { name: "afHO7SJI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (37,54)" }, { name: "oq0IypE8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (59,46)" }, { name: "Xn_LSD8V", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (59,80)" }, { name: "dKWOFa4g", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (72,53)" }, { name: "sBnOr7Y6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (72,119)" }, { name: "kZ3JebGh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (81,46)" }, { name: "eWJ1bFCC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (81,80)" }, { name: "S5qX2odr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (125,21)" }, { name: "qJkK3yUx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (163,43)" }, { name: "vLjQRngE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (164,39)" }, { name: "OwoW4dVI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (201,21)" }, { name: "W0p7E8CY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (234,80)" }, { name: "zBj0nyFU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (236,84)" }, { name: "W9XQ4R5g", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (323,43)" }, { name: "jfQBlsDw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (333,45)" }, { name: "yYzMFcFQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (384,31)" }, { name: "bkGFgHe8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (389,39)" }, { name: "CrJ9oyKf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (406,37)" }, { name: "qhYex1AJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (409,42)" }, { name: "ISBqZq0q", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (437,35)" }, { name: "Cxs1MLgF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (439,35)" }, { name: "yeoqBTHm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (451,33)" }, { name: "d03BhnH0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (454,39)" }, { name: "dzNqRbzc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (521,37)" }, { name: "cxNF8B72", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (590,37)" }, { name: "qG9rFIaO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (608,47)" }, { name: "mk4j4qbQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (631,51)" }, { name: "b_Dgf8JF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (631,72)" }, { name: "Dmkv9yTQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (659,45)" }, { name: "bEJvfypu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (681,55)" }, { name: "uP0CWNqd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (710,51)" }, { name: "z7JtBpgP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (719,75)" }, { name: "xZCh5_4a", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (855,41)" }, { name: "Ftyx9G01", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (855,66)" }, { name: "aECLXoii", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (859,36)" }, { name: "yDxNoAZO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (859,56)" }, { name: "fZsNrrbF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (870,38)" }, { name: "upjXyQ72", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (870,55)" }, { name: "UswKjbeN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (883,50)" }, { name: "A4KFsHXc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (883,83)" }, { name: "vR1NgPQQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (895,45)" }, { name: "H2DL3K0E", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (895,70)" }, { name: "TVmn_AYZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (897,43)" }, { name: "F4fQjf9I", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (898,46)" }, { name: "rjxFveTS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (898,81)" }, { name: "ERMdFStc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (903,36)" }, { name: "Etwz3HHV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (903,56)" }, { name: "GhJ1L8aE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (1021,34)" }, { name: "JVWXra6r", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (1021,61)" }, { name: "PPiAOZtY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (1041,32)" }, { name: "oHcq57l1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalSettings.ts (1041,53)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../proto.ts" />
/// <reference path="../../profiles/Identity.ts" />
var Modals;
(function (Modals) {
    function spawnTeamSpeakIdentityImprove(identity) {
        let modal;
        let elapsed_timer;
        modal = createModal({
            header: _translations.NnaMnk_h || (_translations.NnaMnk_h = tr("Improve identity")),
            body: () => {
                let template = $("#tmpl_settings-teamspeak_improve").renderTag();
                template = $.spawn("div").append(template);
                let active;
                const button_start_stop = template.find(".button-start-stop");
                const button_close = template.find(".button-close");
                const input_current_level = template.find(".identity-level input");
                const input_target_level = template.find(".identity-target-level input");
                const input_threads = template.find(".threads input");
                const input_hash_rate = template.find(".hash-rate input");
                const input_elapsed = template.find(".time-elapsed input");
                button_close.on('click', event => {
                    if (active)
                        button_start_stop.trigger('click');
                    if (modal.shown)
                        modal.close();
                });
                button_start_stop.on('click', event => {
                    button_start_stop
                        .toggleClass('btn-success', active)
                        .toggleClass('btn-danger', !active)
                        .text(active ? _translations.SfBwprn1 || (_translations.SfBwprn1 = tr("Start")) : _translations.afHO7SJI || (_translations.afHO7SJI = tr("Stop")));
                    input_threads.prop("disabled", !active);
                    input_target_level.prop("disabled", !active);
                    if (active) {
                        input_hash_rate.val(0);
                        clearInterval(elapsed_timer);
                        active = false;
                        return;
                    }
                    active = true;
                    input_hash_rate.val("nan");
                    const threads = parseInt(input_threads.val());
                    const target_level = parseInt(input_target_level.val());
                    if (target_level == 0) {
                        identity.improve_level(-1, threads, () => active, current_level => {
                            input_current_level.val(current_level);
                        }, hash_rate => {
                            input_hash_rate.val(hash_rate);
                        }).catch(error => {
                            console.error(error);
                            createErrorModal(_translations.oq0IypE8 || (_translations.oq0IypE8 = tr("Failed to improve identity")), (_translations.Xn_LSD8V || (_translations.Xn_LSD8V = tr("Failed to improve identity.<br>Error:"))) + error).open();
                            if (active)
                                button_start_stop.trigger('click');
                        });
                    }
                    else {
                        identity.improve_level(target_level, threads, () => active, current_level => {
                            input_current_level.val(current_level);
                        }, hash_rate => {
                            input_hash_rate.val(hash_rate);
                        }).then(success => {
                            if (success) {
                                identity.level().then(level => {
                                    input_current_level.val(level);
                                    createInfoModal(_translations.dKWOFa4g || (_translations.dKWOFa4g = tr("Identity successfully improved")), MessageHelper.formatMessage(_translations.sBnOr7Y6 || (_translations.sBnOr7Y6 = tr("Identity successfully improved to level {}")), level)).open();
                                }).catch(error => {
                                    input_current_level.val("error: " + error);
                                });
                            }
                            if (active)
                                button_start_stop.trigger('click');
                        }).catch(error => {
                            console.error(error);
                            createErrorModal(_translations.kZ3JebGh || (_translations.kZ3JebGh = tr("Failed to improve identity")), (_translations.eWJ1bFCC || (_translations.eWJ1bFCC = tr("Failed to improve identity.<br>Error:"))) + error).open();
                            if (active)
                                button_start_stop.trigger('click');
                        });
                    }
                    const begin = Date.now();
                    elapsed_timer = setInterval(() => {
                        const time = (Date.now() - begin) / 1000;
                        let seconds = Math.floor(time % 60).toString();
                        let minutes = Math.floor(time / 60).toString();
                        if (seconds.length < 2)
                            seconds = "0" + seconds;
                        if (minutes.length < 2)
                            minutes = "0" + minutes;
                        input_elapsed.val(minutes + ":" + seconds);
                    }, 1000);
                });
                template.find(".identity-unique-id input").val(identity.uid());
                identity.level().then(level => {
                    input_current_level.val(level);
                }).catch(error => {
                    input_current_level.val("error: " + error);
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.close_listener.push(() => modal.htmlTag.find(".button-close").trigger('click'));
        modal.open();
        return modal;
    }
    function spawnTeamSpeakIdentityImport(callback) {
        let modal;
        let loaded_identity;
        modal = createModal({
            header: _translations.S5qX2odr || (_translations.S5qX2odr = tr("Import identity")),
            body: () => {
                let template = $("#tmpl_settings-teamspeak_import").renderTag();
                template = $.spawn("div").append(template);
                template.find(".button-load-file").on('click', event => template.find(".input-file").trigger('click'));
                const button_import = template.find(".button-import");
                const set_error = message => {
                    template.find(".success").hide();
                    if (message) {
                        template.find(".error").text(message).show();
                        button_import.prop("disabled", true);
                    }
                    else
                        template.find(".error").hide();
                };
                const import_identity = (data, ini) => {
                    profiles.identities.TeaSpeakIdentity.import_ts(data, ini).then(identity => {
                        loaded_identity = identity;
                        set_error("");
                        button_import.prop("disabled", false);
                        template.find(".success").show();
                    }).catch(error => {
                        set_error("Failed to load identity: " + error);
                    });
                };
                { /* file select button */
                    template.find(".input-file").on('change', event => {
                        const element = event.target;
                        const file_reader = new FileReader();
                        file_reader.onload = function () {
                            import_identity(file_reader.result, true);
                        };
                        file_reader.onerror = ev => {
                            console.error(_translations.qJkK3yUx || (_translations.qJkK3yUx = tr("Failed to read give identity file: %o")), ev);
                            set_error(_translations.vLjQRngE || (_translations.vLjQRngE = tr("Failed to read file!")));
                            return;
                        };
                        if (element.files && element.files.length > 0)
                            file_reader.readAsText(element.files[0]);
                    });
                }
                { /* text input */
                    template.find(".button-load-text").on('click', event => {
                        createInputModal("Import identity from text", "Please paste your idenity bellow<br>", text => text.length > 0 && text.indexOf('V') != -1, result => {
                            if (result)
                                import_identity(result, false);
                        }).open();
                    });
                }
                button_import.on('click', event => {
                    modal.close();
                    callback(loaded_identity);
                });
                set_error("");
                button_import.prop("disabled", true);
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
        return modal;
    }
    function spawnSettingsModal() {
        let modal;
        modal = createModal({
            header: _translations.OwoW4dVI || (_translations.OwoW4dVI = tr("Settings")),
            body: () => {
                let template = $("#tmpl_settings").renderTag({
                    client: native_client,
                    valid_forum_identity: profiles.identities.valid_static_forum_identity(),
                    forum_path: settings.static("forum_path"),
                    voice_available: !settings.static_global(Settings.KEY_DISABLE_VOICE, false)
                });
                initialiseVoiceListeners(modal, (template = template.tabify()).find(".settings_audio"));
                initialise_translations(template.find(".settings-translations"));
                initialise_profiles(modal, template.find(".settings-profiles"));
                initialise_global(modal, template.find(".settings-general"));
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
        return modal;
    }
    Modals.spawnSettingsModal = spawnSettingsModal;
    function initialise_global(modal, tag) {
        console.log(tag);
        { /* setup the forum */
            const identity = profiles.identities.static_forum_identity();
            if (identity && identity.valid()) {
                tag.find(".not-connected").hide();
                tag.find(".property.username .value").text(identity.name());
                const premium_tag = tag.find(".property.premium .value").text("");
                if (identity.is_stuff() || identity.is_premium())
                    premium_tag.append($.spawn("div").addClass("premium").text(_translations.W0p7E8CY || (_translations.W0p7E8CY = tr("yes"))));
                else
                    premium_tag.append($.spawn("div").addClass("non-premium").text(_translations.zBj0nyFU || (_translations.zBj0nyFU = tr("no"))));
            }
            else {
                tag.find(".connected").hide();
            }
            tag.find(".button-logout").on('click', event => {
                if (native_client) {
                    modal.close(); /* we cant update the modal so we close it */
                    forum.logout();
                }
                else {
                    window.location.href = settings.static("forum_path") + "auth.php?type=logout";
                }
            });
            tag.find(".button-login").on('click', event => {
                if (native_client) {
                    modal.close(); /* we cant update the modal so we close it */
                    forum.open();
                }
                else {
                    window.location.href = settings.static("forum_path") + "login.php";
                }
            });
        }
    }
    let vad_mapping = {
        "threshold": "vad",
        "push_to_talk": "ppt",
        "active": "pt"
    };
    function initialiseVoiceListeners(modal, tag) {
        let currentVAD = vad_mapping[default_recorder.get_vad_type()] || "vad";
        const display_error = (message) => {
            const alert = tag.find(".settings-device-error").first();
            alert.clone()
                .alert()
                .css("display", "block")
                .insertAfter(alert)
                .find(".message")
                .text(message);
        };
        if (!settings.static_global(Settings.KEY_DISABLE_VOICE, false)) {
            { //Initialized voice activation detection
                const vad_tag = tag.find(".settings-vad-container");
                vad_tag.find('input[type=radio]').on('change', event => {
                    const select = event.currentTarget;
                    {
                        vad_tag.find(".settings-vad-impl-entry").hide();
                        vad_tag.find(".setting-vad-" + select.value).show();
                    }
                    switch (select.value) {
                        case "ppt":
                            default_recorder.set_vad_type("push_to_talk");
                            vad_tag.find(".vat_ppt_key").text(ppt.key_description(default_recorder.get_vad_ppt_key()));
                            vad_tag.find(".ppt-delay input").val(default_recorder.get_vad_ppt_delay());
                            break;
                        case "vad":
                            default_recorder.set_vad_type("threshold");
                            let slider = vad_tag.find(".vad_vad_slider");
                            slider.val(default_recorder.get_vad_threshold());
                            slider.trigger("change");
                            const filter = default_recorder.input.get_filter(audio.recorder.filter.Type.THRESHOLD);
                            filter.callback_level = level => vad_tag.find(".vad_vad_bar_filler").css("width", (100 - level) + "%");
                            break;
                        case "pt":
                            default_recorder.set_vad_type("active");
                            break;
                    }
                });
                { //Initialized push to talk
                    vad_tag.find(".vat_ppt_key").click(function () {
                        let modal = createModal({
                            body: "",
                            header: () => {
                                let head = $.spawn("div");
                                head.text(_translations.W9XQ4R5g || (_translations.W9XQ4R5g = tr("Type the key you wish")));
                                head.css("background-color", "blue");
                                return head;
                            },
                            footer: ""
                        });
                        let listener = (event) => {
                            if (event.type == ppt.EventType.KEY_TYPED) {
                                settings.changeGlobal('vad_ppt_key', undefined); //TODO remove that because its legacy shit
                                console.log(_translations.jfQBlsDw || (_translations.jfQBlsDw = tr("Got key %o")), event);
                                default_recorder.set_vad_ppt_key(event);
                                ppt.unregister_key_listener(listener);
                                modal.close();
                                vad_tag.find(".vat_ppt_key").text(ppt.key_description(event));
                            }
                        };
                        ppt.register_key_listener(listener);
                        modal.open();
                    });
                    vad_tag.find(".ppt-delay input").on('change', event => {
                        default_recorder.set_vad_ppt_delay(event.target.valueAsNumber);
                    });
                }
                { //Initialized voice activation detection
                    let slider = vad_tag.find(".vad_vad_slider");
                    slider.on("input change", () => {
                        settings.changeGlobal("vad_threshold", slider.val().toString());
                        default_recorder.set_vad_threshold(slider.val());
                        vad_tag.find(".vad_vad_slider_value").text(slider.val().toString());
                    });
                    modal.properties.registerCloseListener(() => {
                        const filter = default_recorder.input.get_filter(audio.recorder.filter.Type.THRESHOLD);
                        filter.callback_level = undefined;
                    });
                }
                let target_tag = vad_tag.find('input[type=radio][name="vad_type"][value="' + currentVAD + '"]');
                if (target_tag.length == 0) {
                    //TODO tr
                    console.warn("Failed to find tag for " + currentVAD + ". Using latest tag!");
                    target_tag = vad_tag.find('input[type=radio][name="vad_type"]').last();
                }
                target_tag.prop("checked", true);
                setTimeout(() => target_tag.trigger('change'), 0);
            }
            { //Initialize microphone
                const setting_tag = tag.find(".settings-microphone");
                const tag_select = setting_tag.find(".audio-select-microphone");
                const update_devices = () => {
                    tag_select.empty();
                    $.spawn("option")
                        .attr("device-id", "")
                        .text(_translations.yYzMFcFQ || (_translations.yYzMFcFQ = tr("No device")))
                        .appendTo(tag_select);
                    const active_device = default_recorder.current_device();
                    audio.recorder.devices().forEach(device => {
                        console.debug(_translations.bkGFgHe8 || (_translations.bkGFgHe8 = tr("Got device %o")), device);
                        $.spawn("option")
                            .attr("device-id", device.unique_id)
                            .text(device.name)
                            .prop("selected", active_device && device.unique_id == active_device.unique_id)
                            .appendTo(tag_select);
                    });
                    if (tag_select.find("option:selected").length == 0)
                        tag_select.find("option").prop("selected", true);
                };
                {
                    tag_select.on('change', event => {
                        let selected_tag = tag_select.find("option:selected");
                        let deviceId = selected_tag.attr("device-id");
                        console.log(_translations.CrJ9oyKf || (_translations.CrJ9oyKf = tr("Selected microphone device: id: %o")), deviceId);
                        const device = audio.recorder.devices().find(e => e.unique_id === deviceId);
                        if (!device)
                            console.warn(_translations.qhYex1AJ || (_translations.qhYex1AJ = tr("Failed to find device!")));
                        default_recorder.set_device(device);
                    });
                }
                update_devices();
                setting_tag.find(".button-device-update").on('click', event => update_devices());
            }
        }
        { //Initialize speaker
            const setting_tag = tag.find(".settings-speaker");
            const tag_select = setting_tag.find(".audio-select-speaker");
            const update_devices = () => {
                tag_select.empty();
                const active_device = audio.player.current_device();
                audio.player.available_devices().then(devices => {
                    for (const device of devices) {
                        $.spawn("option")
                            .attr("device-id", device.device_id)
                            .text(device.name)
                            .prop("selected", device.device_id == active_device.device_id)
                            .appendTo(tag_select);
                    }
                }).catch(error => {
                    console.error(_translations.ISBqZq0q || (_translations.ISBqZq0q = tr("Could not enumerate over devices!")));
                    console.error(error);
                    display_error(_translations.Cxs1MLgF || (_translations.Cxs1MLgF = tr("Could not get speaker device list!")));
                });
                if (tag_select.find("option:selected").length == 0)
                    tag_select.find("option").prop("selected", true);
            };
            {
                tag_select.on('change', event => {
                    let selected_tag = tag_select.find("option:selected");
                    let deviceId = selected_tag.attr("device-id");
                    console.log(_translations.yeoqBTHm || (_translations.yeoqBTHm = tr("Selected speaker device: id: %o")), deviceId);
                    audio.player.set_device(deviceId).catch(error => {
                        console.error(error);
                        display_error(_translations.d03BhnH0 || (_translations.d03BhnH0 = tr("Failed to change device!")));
                    });
                });
            }
            update_devices();
            setting_tag.find(".button-device-update").on('click', event => update_devices());
            { /* master sound volume */
                const master_tag = setting_tag.find(".master-volume");
                master_tag.find("input").on('change input', event => {
                    const value = parseInt(event.target.value);
                    master_tag.find('a').text("(" + value + "%)");
                    if (audio.player.set_master_volume)
                        audio.player.set_master_volume(value / 100);
                    settings.changeGlobal(Settings.KEY_SOUND_MASTER, value);
                }).val((audio.player.get_master_volume ? audio.player.get_master_volume() * 100 : 100).toString()).trigger('change');
            }
        }
        { /* initialize sounds */
            const sound_tag = tag.find(".sound-settings");
            { /* master sound volume */
                const master_tag = sound_tag.find(".sound-master-volume");
                master_tag.find("input").on('change input', event => {
                    const value = parseInt(event.target.value);
                    master_tag.find('a').text("(" + value + "%)");
                    sound.set_master_volume(value / 100);
                    settings.changeGlobal(Settings.KEY_SOUND_MASTER_SOUNDS, value);
                }).val((sound.get_master_volume() * 100).toString()).trigger('change');
            }
            {
                const overlap_tag = sound_tag.find(".overlap-sounds input");
                overlap_tag.on('change', event => {
                    const activated = event.target.checked;
                    sound.set_overlap_activated(activated);
                }).prop("checked", sound.overlap_activated());
            }
            {
                const muted_tag = sound_tag.find(".muted-sounds input");
                muted_tag.on('change', event => {
                    const activated = event.target.checked;
                    sound.set_ignore_output_muted(!activated);
                }).prop("checked", !sound.ignore_output_muted());
            }
            { /* sound elements */
                const template_tag = $("#tmpl_settings-sound_entry");
                const entry_tag = sound_tag.find(".sound-list-entries");
                for (const _sound in Sound) {
                    const sound_name = Sound[_sound];
                    console.log(sound.get_sound_volume(sound_name));
                    const data = {
                        name: sound_name,
                        activated: sound.get_sound_volume(sound_name) > 0
                    };
                    const entry = template_tag.renderTag(data);
                    entry.find("input").on('change', event => {
                        const activated = event.target.checked;
                        console.log(_translations.dzNqRbzc || (_translations.dzNqRbzc = tr("Sound %s had changed to %o")), sound_name, activated);
                        sound.set_sound_volume(sound_name, activated ? 1 : 0);
                    });
                    entry.find(".button-playback").on('click', event => {
                        sound.manager.play(sound_name);
                    });
                    entry_tag.append(entry);
                }
                setTimeout(() => {
                    const entry_container = sound_tag.find(".sound-list-entries-container");
                    if (entry_container.hasScrollBar())
                        entry_container.addClass("scrollbar");
                }, 100);
                /* filter */
                const filter_tag = sound_tag.find(".sound-list-filter input");
                filter_tag.on('change keyup', event => {
                    const filter = (event.target.value || "").toLowerCase();
                    if (!filter)
                        entry_tag.find(".entry").show();
                    else {
                        entry_tag.find(".entry").each((_, _entry) => {
                            const entry = $(_entry);
                            if (entry.text().toLowerCase().indexOf(filter) == -1)
                                entry.hide();
                            else
                                entry.show();
                        });
                    }
                });
            }
            modal.close_listener.push(sound.save);
        }
    }
    function initialise_translations(tag) {
        { //Initialize the list
            const tag_list = tag.find(".setting-list .list");
            const tag_loading = tag.find(".setting-list .loading");
            const template = $("#settings-translations-list-entry");
            const restart_hint = tag.find(".setting-list .restart-note");
            restart_hint.hide();
            const update_list = () => {
                tag_list.empty();
                const currently_selected = i18n.config.translation_config().current_translation_url;
                { //Default translation
                    const tag = template.renderTag({
                        type: "default",
                        selected: !currently_selected || currently_selected == "default"
                    });
                    tag.on('click', () => {
                        i18n.select_translation(undefined, undefined);
                        tag_list.find(".selected").removeClass("selected");
                        tag.addClass("selected");
                        restart_hint.show();
                    });
                    tag.appendTo(tag_list);
                }
                {
                    const display_repository_info = (repository) => {
                        const info_modal = createModal({
                            header: _translations.cxNF8B72 || (_translations.cxNF8B72 = tr("Repository info")),
                            body: () => {
                                return $("#settings-translations-list-entry-info").renderTag({
                                    type: "repository",
                                    name: repository.name,
                                    url: repository.url,
                                    contact: repository.contact,
                                    translations: repository.translations || []
                                });
                            },
                            footer: () => {
                                let footer = $.spawn("div");
                                footer.addClass("modal-button-group");
                                footer.css("margin-top", "5px");
                                footer.css("margin-bottom", "5px");
                                footer.css("text-align", "right");
                                let buttonOk = $.spawn("button");
                                buttonOk.text(_translations.qG9rFIaO || (_translations.qG9rFIaO = tr("Close")));
                                buttonOk.click(() => info_modal.close());
                                footer.append(buttonOk);
                                return footer;
                            }
                        });
                        info_modal.open();
                    };
                    tag_loading.show();
                    i18n.iterate_repositories(repo => {
                        let repo_tag = tag_list.find("[repository=\"" + repo.unique_id + "\"]");
                        if (repo_tag.length == 0) {
                            repo_tag = template.renderTag({
                                type: "repository",
                                name: repo.name || repo.url,
                                id: repo.unique_id
                            });
                            repo_tag.find(".button-delete").on('click', e => {
                                e.preventDefault();
                                Modals.spawnYesNo(_translations.mk4j4qbQ || (_translations.mk4j4qbQ = tr("Are you sure?")), _translations.b_Dgf8JF || (_translations.b_Dgf8JF = tr("Do you really want to delete this repository?")), answer => {
                                    if (answer) {
                                        i18n.delete_repository(repo);
                                        update_list();
                                    }
                                });
                            });
                            repo_tag.find(".button-info").on('click', e => {
                                e.preventDefault();
                                display_repository_info(repo);
                            });
                            tag_list.append(repo_tag);
                        }
                        for (const translation of repo.translations) {
                            const tag = template.renderTag({
                                type: "translation",
                                name: translation.name || translation.path,
                                id: repo.unique_id,
                                country_code: translation.country_code,
                                selected: i18n.config.translation_config().current_translation_path == translation.path
                            });
                            tag.find(".button-info").on('click', e => {
                                e.preventDefault();
                                const info_modal = createModal({
                                    header: _translations.Dmkv9yTQ || (_translations.Dmkv9yTQ = tr("Translation info")),
                                    body: () => {
                                        const tag = $("#settings-translations-list-entry-info").renderTag({
                                            type: "translation",
                                            name: translation.name,
                                            url: translation.path,
                                            repository_name: repo.name,
                                            contributors: translation.contributors || []
                                        });
                                        tag.find(".button-info").on('click', () => display_repository_info(repo));
                                        return tag;
                                    },
                                    footer: () => {
                                        let footer = $.spawn("div");
                                        footer.addClass("modal-button-group");
                                        footer.css("margin-top", "5px");
                                        footer.css("margin-bottom", "5px");
                                        footer.css("text-align", "right");
                                        let buttonOk = $.spawn("button");
                                        buttonOk.text(_translations.bEJvfypu || (_translations.bEJvfypu = tr("Close")));
                                        buttonOk.click(() => info_modal.close());
                                        footer.append(buttonOk);
                                        return footer;
                                    }
                                });
                                info_modal.open();
                            });
                            tag.on('click', e => {
                                if (e.isDefaultPrevented())
                                    return;
                                i18n.select_translation(repo, translation);
                                tag_list.find(".selected").removeClass("selected");
                                tag.addClass("selected");
                                restart_hint.show();
                            });
                            tag.insertAfter(repo_tag);
                        }
                    }).then(() => tag_loading.hide()).catch(error => {
                        console.error(error);
                        /* this should NEVER happen */
                    });
                }
            };
            {
                tag.find(".button-add-repository").on('click', () => {
                    createInputModal("Enter URL", _translations.uP0CWNqd || (_translations.uP0CWNqd = tr("Enter repository URL:<br>")), text => true, url => {
                        if (!url)
                            return;
                        tag_loading.show();
                        i18n.load_repository(url).then(repository => {
                            i18n.register_repository(repository);
                            update_list();
                        }).catch(error => {
                            tag_loading.hide();
                            createErrorModal("Failed to load repository", (_translations.z7JtBpgP || (_translations.z7JtBpgP = tr("Failed to query repository.<br>Ensure that this repository is valid and reachable.<br>Error: "))) + error).open();
                        });
                    }).open();
                });
            }
            restart_hint.find(".button-reload").on('click', () => {
                location.reload();
            });
            update_list();
        }
    }
    function initialise_profiles(modal, tag) {
        const settings_tag = tag.find(".profile-settings");
        let selected_profile;
        let nickname_listener;
        let status_listener;
        const display_settings = (profile) => {
            selected_profile = profile;
            settings_tag.find(".setting-name").val(profile.profile_name);
            settings_tag.find(".setting-default-nickname").val(profile.default_username);
            settings_tag.find(".setting-default-password").val(profile.default_password);
            {
                //change listener
                const select_tag = settings_tag.find(".select-container select")[0];
                const type = profile.selected_identity_type.toLowerCase();
                select_tag.onchange = () => {
                    console.log("Selected: " + select_tag.value);
                    settings_tag.find(".identity-settings.active").removeClass("active");
                    settings_tag.find(".identity-settings-" + select_tag.value).addClass("active");
                    profile.selected_identity_type = select_tag.value.toLowerCase();
                    const selected_type = profile.selected_type();
                    const identity = profile.selected_identity();
                    profiles.mark_need_save();
                    let tag;
                    if (selected_type == profiles.identities.IdentitifyType.TEAFORO) {
                        const forum_tag = tag = settings_tag.find(".identity-settings-teaforo");
                        forum_tag.find(".connected, .disconnected").hide();
                        if (identity && identity.valid()) {
                            forum_tag.find(".connected").show();
                        }
                        else {
                            forum_tag.find(".disconnected").show();
                        }
                    }
                    else if (selected_type == profiles.identities.IdentitifyType.TEAMSPEAK) {
                        console.log("Set: " + identity);
                        const teamspeak_tag = tag = settings_tag.find(".identity-settings-teamspeak");
                        teamspeak_tag.find(".identity_string").val("");
                        if (identity)
                            identity.export_ts().then(e => teamspeak_tag.find(".identity_string").val(e));
                    }
                    else if (selected_type == profiles.identities.IdentitifyType.NICKNAME) {
                        const name_tag = tag = settings_tag.find(".identity-settings-nickname");
                        if (identity)
                            name_tag.find("input").val(identity.name());
                        else
                            name_tag.find("input").val("");
                    }
                    if (tag)
                        tag.trigger('show');
                };
                select_tag.value = type;
                select_tag.onchange(undefined);
            }
        };
        const update_profile_list = () => {
            const profile_list = tag.find(".profile-list .list").empty();
            const profile_template = $("#settings-profile-list-entry");
            for (const profile of profiles.profiles()) {
                const list_tag = profile_template.renderTag({
                    profile_name: profile.profile_name,
                    id: profile.id
                });
                const profile_status_update = () => {
                    list_tag.find(".status").hide();
                    if (profile.valid())
                        list_tag.find(".status-valid").show();
                    else
                        list_tag.find(".status-invalid").show();
                };
                list_tag.on('click', event => {
                    /* update ui */
                    profile_list.find(".selected").removeClass("selected");
                    list_tag.addClass("selected");
                    if (profile == selected_profile)
                        return;
                    nickname_listener = () => list_tag.find(".name").text(profile.profile_name);
                    status_listener = profile_status_update;
                    display_settings(profile);
                });
                profile_list.append(list_tag);
                if ((!selected_profile && profile.id == "default") || selected_profile == profile)
                    setTimeout(() => list_tag.trigger('click'), 1);
                profile_status_update();
            }
        };
        const display_error = (error) => {
            if (error) {
                settings_tag.find(".settings-profile-error").show().find(".message").html(error);
            }
            else
                settings_tag.find(".settings-profile-error").hide();
            status_listener();
        };
        /* identity settings */
        {
            { //TeamSpeak change listener
                const teamspeak_tag = settings_tag.find(".identity-settings-teamspeak");
                const identity_info_tag = teamspeak_tag.find(".identity-info");
                const button_export = teamspeak_tag.find(".button-export");
                const button_import = teamspeak_tag.find(".button-import");
                const button_generate = teamspeak_tag.find(".button-generate");
                const button_improve = teamspeak_tag.find(".button-improve");
                button_import.on('click', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.TEAMSPEAK);
                    const set_identity = (identity) => {
                        selected_profile.set_identity(profiles.identities.IdentitifyType.TEAMSPEAK, identity);
                        teamspeak_tag.trigger('show');
                        createInfoModal(_translations.xZCh5_4a || (_translations.xZCh5_4a = tr("Identity imported")), _translations.Ftyx9G01 || (_translations.Ftyx9G01 = tr("Your identity has been successfully imported!"))).open();
                    };
                    if (profile && profile.valid()) {
                        Modals.spawnYesNo(_translations.aECLXoii || (_translations.aECLXoii = tr("Are you sure")), _translations.yDxNoAZO || (_translations.yDxNoAZO = tr("Do you really want to import a new identity and override the old identity?")), result => {
                            if (result)
                                spawnTeamSpeakIdentityImport(set_identity);
                        });
                    }
                    else
                        spawnTeamSpeakIdentityImport(set_identity);
                });
                button_export.on('click', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.TEAMSPEAK);
                    if (!profile)
                        return;
                    createInputModal(_translations.fZsNrrbF || (_translations.fZsNrrbF = tr("File name")), _translations.upjXyQ72 || (_translations.upjXyQ72 = tr("Please enter the file name")), text => !!text, name => {
                        if (name) {
                            profile.export_ts(true).then(data => {
                                const element = $.spawn("a")
                                    .text("donwload")
                                    .attr("href", "data:test/plain;charset=utf-8," + encodeURIComponent(data))
                                    .attr("download", name + ".ini")
                                    .css("display", "none")
                                    .appendTo($("body"));
                                element[0].click();
                                element.detach();
                            }).catch(error => {
                                console.error(error);
                                createErrorModal(_translations.UswKjbeN || (_translations.UswKjbeN = tr("Failed to export identity")), (_translations.A4KFsHXc || (_translations.A4KFsHXc = tr("Failed to export and save identity.<br>Error: "))) + error).open();
                            });
                        }
                    }).open();
                });
                button_generate.on('click', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.TEAMSPEAK);
                    const generate_identity = () => {
                        profiles.identities.TeaSpeakIdentity.generate_new().then(identity => {
                            selected_profile.set_identity(profiles.identities.IdentitifyType.TEAMSPEAK, identity);
                            teamspeak_tag.trigger('show');
                            createInfoModal(_translations.vR1NgPQQ || (_translations.vR1NgPQQ = tr("Identity generate")), _translations.H2DL3K0E || (_translations.H2DL3K0E = tr("A new identity had been successfully generated"))).open();
                        }).catch(error => {
                            console.error(_translations.TVmn_AYZ || (_translations.TVmn_AYZ = tr("Failed to generate a new identity. Error object: %o")), error);
                            createErrorModal(_translations.F4fQjf9I || (_translations.F4fQjf9I = tr("Failed to generate identity")), (_translations.rjxFveTS || (_translations.rjxFveTS = tr("Failed to generate a new identity.<br>Error:"))) + error).open();
                        });
                    };
                    if (profile && profile.valid()) {
                        Modals.spawnYesNo(_translations.ERMdFStc || (_translations.ERMdFStc = tr("Are you sure")), _translations.Etwz3HHV || (_translations.Etwz3HHV = tr("Do you really want to generate a new identity and override the old identity?")), result => {
                            if (result)
                                generate_identity();
                        });
                    }
                    else
                        generate_identity();
                });
                button_improve.on('click', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.TEAMSPEAK);
                    if (!profile)
                        return;
                    spawnTeamSpeakIdentityImprove(profile).close_listener.push(() => teamspeak_tag.trigger('show'));
                });
                /* updates the data */
                teamspeak_tag.on('show', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.TEAMSPEAK);
                    if (!profile || !profile.valid()) {
                        identity_info_tag.hide();
                        teamspeak_tag.find(".identity-undefined").show();
                        button_export.prop("disabled", true);
                    }
                    else {
                        identity_info_tag.show();
                        teamspeak_tag.find(".identity-undefined").hide();
                        button_export.prop("disabled", false);
                        identity_info_tag.find(".unique-id input").val(profile.uid());
                        const input_level = identity_info_tag.find(".level input").val("loading...");
                        profile.level().then(level => input_level.val(level.toString())).catch(error => input_level.val("error: " + error));
                    }
                    display_error();
                });
            }
            { //The
                const teaforo_tag = settings_tag.find(".identity-settings-teaforo");
                if (native_client) {
                    teaforo_tag.find(".native-teaforo-login").on('click', event => {
                        setTimeout(() => {
                            const call = () => {
                                if (modal.shown) {
                                    display_settings(selected_profile);
                                    status_listener();
                                }
                            };
                            forum.register_callback(call);
                            forum.open();
                        }, 0);
                    });
                }
                teaforo_tag.on('show', event => {
                    display_error();
                    /* clear error */
                });
            }
            { //The name
                const name_tag = settings_tag.find(".identity-settings-nickname");
                name_tag.find(".setting-name").on('change keyup', event => {
                    const name = name_tag.find(".setting-name").val();
                    selected_profile.set_identity(profiles.identities.IdentitifyType.NICKNAME, new profiles.identities.NameIdentity(name));
                    profiles.mark_need_save();
                    if (name.length < 3) {
                        display_error("Name must be at least 3 characters long!");
                        return;
                    }
                    display_error();
                });
                name_tag.on('show', event => {
                    const profile = selected_profile.selected_identity(profiles.identities.IdentitifyType.NICKNAME);
                    if (!profile)
                        display_error("invalid profile");
                    else if (!profile.valid())
                        display_error("Name must be at least 3 characters long!");
                    else
                        display_error();
                });
            }
        }
        /* general settings */
        {
            settings_tag.find(".setting-name").on('change', event => {
                const value = settings_tag.find(".setting-name").val();
                if (value && selected_profile) {
                    selected_profile.profile_name = value;
                    if (nickname_listener)
                        nickname_listener();
                    profiles.mark_need_save();
                    status_listener();
                }
            });
            settings_tag.find(".setting-default-nickname").on('change', event => {
                const value = settings_tag.find(".setting-default-nickname").val();
                if (value && selected_profile) {
                    selected_profile.default_username = value;
                    profiles.mark_need_save();
                    status_listener();
                }
            });
            settings_tag.find(".setting-default-password").on('change', event => {
                const value = settings_tag.find(".setting-default-password").val();
                if (value && selected_profile) {
                    selected_profile.default_username = value;
                    profiles.mark_need_save();
                    status_listener();
                }
            });
        }
        /* general buttons */
        {
            tag.find(".button-add-profile").on('click', event => {
                createInputModal(_translations.GhJ1L8aE || (_translations.GhJ1L8aE = tr("Please enter a name")), _translations.JVWXra6r || (_translations.JVWXra6r = tr("Please enter a name for the new profile:<br>")), text => text.length > 0 && !profiles.find_profile_by_name(text), value => {
                    if (value) {
                        display_settings(profiles.create_new_profile(value));
                        update_profile_list();
                        profiles.mark_need_save();
                    }
                }).open();
            });
            tag.find(".button-set-default").on('click', event => {
                if (selected_profile && selected_profile.id != 'default') {
                    profiles.set_default_profile(selected_profile);
                    update_profile_list();
                    profiles.mark_need_save();
                }
            });
            tag.find(".button-delete").on('click', event => {
                if (selected_profile && selected_profile.id != 'default') {
                    event.preventDefault();
                    Modals.spawnYesNo(_translations.PPiAOZtY || (_translations.PPiAOZtY = tr("Are you sure?")), _translations.oHcq57l1 || (_translations.oHcq57l1 = tr("Do you really want to delete this profile?")), result => {
                        if (result) {
                            profiles.delete_profile(selected_profile);
                            update_profile_list();
                        }
                    });
                }
            });
        }
        modal.close_listener.push(() => {
            if (profiles.requires_save())
                profiles.save();
        });
        update_profile_list();
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["0671a74f87ad53398520642635ae10eef20f83f760562c78a0efb6397db6eed6"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["0671a74f87ad53398520642635ae10eef20f83f760562c78a0efb6397db6eed6"] = "0671a74f87ad53398520642635ae10eef20f83f760562c78a0efb6397db6eed6";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "twTF1_OS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (36,29)" }, { name: "h6uPI7EA", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (50,38)" }, { name: "Q4Groq4b", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (54,25)" }, { name: "d519MZPj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (56,29)" }, { name: "bdyphYdl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (72,38)" }, { name: "AzeShYo0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (76,25)" }, { name: "x94MctiD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (84,34)" }, { name: "AvhtVtpW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (92,29)" }, { name: "hD9G8gN5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (176,26)" }, { name: "A33l_w7B", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (185,26)" }, { name: "cSI0hzCX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (191,21)" }, { name: "UOiuqDnl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanList.ts (233,25)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var Modals;
(function (Modals) {
    function openBanList(client) {
        let update;
        const modal = spawnBanListModal(() => update(), () => {
            Modals.spawnBanCreate(client, undefined, result => {
                if (result.server_id < 0)
                    result.server_id = undefined;
                console.log(_translations.twTF1_OS || (_translations.twTF1_OS = tr("Adding ban %o")), result);
                client.serverConnection.send_command("banadd", {
                    ip: result.ip,
                    name: result.name,
                    uid: result.unique_id,
                    hwid: result.hardware_id,
                    banreason: result.reason,
                    time: result.timestamp_expire.getTime() > 0 ? (result.timestamp_expire.getTime() - result.timestamp_created.getTime()) / 1000 : 0,
                    sid: result.server_id
                }).then(() => {
                    update();
                }).catch(error => {
                    //TODO tr
                    createErrorModal(_translations.h6uPI7EA || (_translations.h6uPI7EA = tr("Failed to add ban")), "Failed to add ban.<br>Reason: " + (error instanceof CommandResult ? error.extra_message || error.message : error)).open();
                });
            });
        }, ban => {
            console.log(_translations.Q4Groq4b || (_translations.Q4Groq4b = tr("Editing ban %o")), ban);
            Modals.spawnBanCreate(client, ban, result => {
                console.log(_translations.d519MZPj || (_translations.d519MZPj = tr("Apply edit changes %o")), result);
                if (result.server_id < 0)
                    result.server_id = undefined;
                client.serverConnection.send_command("banedit", {
                    banid: result.banid,
                    ip: result.ip,
                    name: result.name,
                    uid: result.unique_id,
                    hwid: result.hardware_id,
                    banreason: result.reason,
                    time: result.timestamp_expire.getTime() > 0 ? (result.timestamp_expire.getTime() - result.timestamp_created.getTime()) / 1000 : 0,
                    sid: result.server_id
                }).then(() => {
                    update();
                }).catch(error => {
                    //TODO tr
                    createErrorModal(_translations.bdyphYdl || (_translations.bdyphYdl = tr("Failed to edit ban")), "Failed to edit ban.<br>Reason: " + (error instanceof CommandResult ? error.extra_message || error.message : error)).open();
                });
            });
        }, ban => {
            console.log(_translations.AzeShYo0 || (_translations.AzeShYo0 = tr("Deleting ban %o")), ban);
            client.serverConnection.send_command("bandel", {
                banid: ban.banid,
                sid: ban.server_id
            }).then(() => {
                update();
            }).catch(error => {
                //TODO tr
                createErrorModal(_translations.x94MctiD || (_translations.x94MctiD = tr("Failed to delete ban")), "Failed to delete ban.<br>Reason: " + (error instanceof CommandResult ? error.extra_message || error.message : error)).open();
            });
        });
        const single_handler = {
            command: "notifybanlist",
            function: command => {
                const json = command.arguments;
                console.log(_translations.AvhtVtpW || (_translations.AvhtVtpW = tr("Got banlist: %o")), json);
                let bans = [];
                for (const entry of json) {
                    /*
                    notify[index]["sid"] = elm->serverId;
                    notify[index]["banid"] = elm->banId;
                    if(allow_ip)
                        notify[index]["ip"] = elm->ip;
                    else
                        notify[index]["ip"] = "hidden";
                    notify[index]["name"] = elm->name;
                    notify[index]["uid"] = elm->uid;
                    notify[index]["lastnickname"] = elm->name; //Maybe update?

                    notify[index]["created"] = chrono::duration_cast<chrono::seconds>(elm->created.time_since_epoch()).count();
                    if (elm->until.time_since_epoch().count() != 0)
                    notify[index]["duration"] = chrono::duration_cast<chrono::seconds>(elm->until - elm->created).count();
                    else
                    notify[index]["duration"] = 0;

                    notify[index]["reason"] = elm->reason;
                    notify[index]["enforcements"] = elm->triggered;

                    notify[index]["invokername"] = elm->invokerName;
                    notify[index]["invokercldbid"] = elm->invokerDbId;
                    notify[index]["invokeruid"] = elm->invokerUid;
                    */
                    bans.push({
                        server_id: parseInt(entry["sid"]),
                        banid: parseInt(entry["banid"]),
                        ip: entry["ip"],
                        name: entry["name"],
                        unique_id: entry["uid"],
                        hardware_id: entry["hwid"],
                        timestamp_created: new Date(parseInt(entry["created"]) * 1000),
                        timestamp_expire: new Date(parseInt(entry["duration"]) > 0 ? parseInt(entry["created"]) * 1000 + parseInt(entry["duration"]) * 1000 : 0),
                        invoker_name: entry["invokername"],
                        invoker_database_id: parseInt(entry["invokercldbid"]),
                        invoker_unique_id: entry["invokeruid"],
                        reason: entry["reason"],
                        enforcements: parseInt(entry["enforcements"]),
                        flag_own: entry["invokeruid"] == client.getClient().properties.client_unique_identifier
                    });
                }
                modal.addbans(bans);
                return false;
            }
        };
        client.serverConnection.command_handler_boss().register_single_handler(single_handler);
        modal.modal.close_listener.push(() => {
            client.serverConnection.command_handler_boss().remove_single_handler(single_handler);
        });
        update = () => {
            //TODO test permission
            modal.clear();
            client.serverConnection.send_command("banlist", { sid: 0 }); //Global ban list
            client.serverConnection.send_command("banlist").catch(error => {
                if (error instanceof CommandResult) {
                }
                else {
                    console.error(error);
                }
            });
        };
        update();
    }
    Modals.openBanList = openBanList;
    function spawnBanListModal(callback_update, callback_add, callback_edit, callback_delete) {
        let result = {};
        let entries = [];
        const _callback_edit = ban_id => {
            for (const entry of entries)
                if (entry.banid == ban_id) {
                    callback_edit(entry);
                    return;
                }
            console.warn(_translations.hD9G8gN5 || (_translations.hD9G8gN5 = tr("Missing ban entry with id %d")), ban_id);
        };
        const _callback_delete = ban_id => {
            for (const entry of entries)
                if (entry.banid == ban_id) {
                    callback_delete(entry);
                    return;
                }
            console.warn(_translations.A33l_w7B || (_translations.A33l_w7B = tr("Missing ban entry with id %d")), ban_id);
        };
        let update_function;
        let modal;
        modal = createModal({
            header: _translations.cSI0hzCX || (_translations.cSI0hzCX = tr("Banlist")),
            body: () => {
                let template = $("#tmpl_ban_list").renderTag();
                apply_filter(template.find(".entry-filter"), template.find(".filter-flag-force-own"), template.find(".filter-flag-highlight-own"), template.find(".ban-entry-list"));
                update_function = apply_buttons(template.find(".manage-buttons"), template.find(".entry-container .entries"), callback_add, _callback_edit, _callback_delete);
                template.find(".button-close").on('click', _ => modal.close());
                template.find(".button-refresh").on('click', () => callback_update());
                return template;
            },
            footer: undefined,
            width: "80%",
            height: "80%"
        });
        modal.open();
        modal.close_listener.push(() => entries = []);
        const template_entry = $("#tmpl_ban_entry");
        result.addbans = (bans) => {
            for (const entry of bans) {
                entries.push(entry);
                template_entry.renderTag(entry).appendTo(modal.htmlTag.find(".entry-container .entries"));
            }
            modal.htmlTag.find(".entry-filter").trigger("change");
            update_function();
        };
        result.clear = () => {
            entries = [];
            modal.htmlTag.find(".entry-container .entries").children().detach();
            update_function();
        };
        result.modal = modal;
        return result;
    }
    Modals.spawnBanListModal = spawnBanListModal;
    function apply_filter(input, show_own_bans, highlight_own_bans, elements) {
        input.on('keyup change', event => {
            const filter = input.val().trim();
            const show_own_only = show_own_bans.prop("checked");
            const highlight_own = highlight_own_bans.prop("checked");
            console.log(_translations.UOiuqDnl || (_translations.UOiuqDnl = tr("Search for filter %s")), filter);
            let shown = 0, hidden = 0;
            elements.find(".ban-entry").each((_idx, _entry) => {
                const entry = $(_entry);
                if (entry.hasClass("ban-entry-own")) {
                    if (highlight_own)
                        entry.addClass("ban-entry-own-bold");
                    else
                        entry.removeClass("ban-entry-own-bold");
                }
                else if (show_own_only) {
                    if (entry.hide().hasClass("selected"))
                        entry.trigger("click");
                    hidden++;
                    return;
                }
                if (filter.length == 0 || entry.text().indexOf(filter) > 0) {
                    entry.show();
                    shown++;
                }
                else {
                    if (entry.hide().hasClass("selected"))
                        entry.trigger("click");
                    hidden++;
                }
            });
            $(".entry-count-info").text((shown + hidden) + " entries. " + shown + " entries shown");
        });
        show_own_bans.on('click', () => input.trigger('change'));
        highlight_own_bans.on('click', () => input.trigger('change'));
    }
    function apply_buttons(tag, elements, cb_add, cb_edit, cb_delete) {
        const update = () => {
            console.log(elements.find(".ban-entry.selected").length);
            $(".button-edit, .button-remove").prop("disabled", elements.find(".ban-entry.selected").length == 0);
        };
        tag.find(".button-add").on('click', event => cb_add());
        tag.find(".button-edit").on('click', event => {
            const selected = elements.find(".ban-entry.selected");
            if (!selected)
                return;
            cb_edit(parseInt(selected.attr("ban-id")));
        });
        tag.find(".button-remove").on('click', event => {
            const selected = elements.find(".ban-entry.selected");
            if (!selected)
                return;
            cb_delete(parseInt(selected.attr("ban-id")));
        });
        const element_selected = element => {
            elements.find(".ban-entry").removeClass("selected");
            if (element.is(":visible"))
                element.addClass("selected");
            update();
        };
        const click_handler = event => element_selected($(event.currentTarget));
        const context_handler = event => {
            const element = $(event.currentTarget);
            element_selected(element);
            event.preventDefault();
            spawn_context_menu(event.pageX, event.pageY, {
                name: "Edit",
                type: MenuEntryType.ENTRY,
                callback: () => cb_edit(parseInt(element.attr("ban-id")))
            }, {
                name: "Delete",
                type: MenuEntryType.ENTRY,
                callback: () => cb_delete(parseInt(element.attr("ban-id")))
            });
        };
        return () => {
            elements.find(".ban-entry").each((_idx, _entry) => {
                _entry.addEventListener("click", click_handler);
                _entry.addEventListener("contextmenu", context_handler);
            });
            update();
        };
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["ed5d1927bdeaef457479b42d396451a9ba0c2955439b637b977becfee03ca7d2"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["ed5d1927bdeaef457479b42d396451a9ba0c2955439b637b977becfee03ca7d2"] = "ed5d1927bdeaef457479b42d396451a9ba0c2955439b637b977becfee03ca7d2";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Gwkiik7n", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (214,36)" }, { name: "bsrLfEKb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (216,36)" }, { name: "tIW9El25", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (218,36)" }, { name: "xcZ_jAWP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (235,36)" }, { name: "mpHRKcfU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (237,36)" }, { name: "lAIwkJfh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (261,45)" }, { name: "cqDMP56z", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (263,45)" }, { name: "LeV1A4U_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (289,26)" }, { name: "xdgdNcBt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (289,50)" }, { name: "PVej25EQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (311,26)" }, { name: "djMNxUkt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (311,57)" }, { name: "REeyYcfP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (420,26)" }, { name: "ezZ4kUfN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (420,43)" }, { name: "wgpT5XjU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (426,37)" }, { name: "DmjQsHXx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (426,54)" }, { name: "TNf3C3tE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (429,38)" }, { name: "e_XE2qQM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (435,26)" }, { name: "xwqe45Sx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (435,49)" }, { name: "Xb8SqmsZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (445,34)" }, { name: "XrlqQv_w", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (445,66)" }, { name: "CKNGwZJI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (456,30)" }, { name: "WolPunTT", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (456,66)" }, { name: "WGkTAwuN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (463,30)" }, { name: "Oc2FIPnk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (463,58)" }, { name: "_Or0GbEq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (477,30)" }, { name: "oR3g12dm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (477,62)" }, { name: "zcZdCCAX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (546,47)" }, { name: "b9g7O_aI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (551,47)" }, { name: "B2S6nvgx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (604,30)" }, { name: "oGmq2Jg3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (604,66)" }, { name: "RDdL3DQe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (613,30)" }, { name: "vMZqcVsg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (613,62)" }, { name: "jMuBmB_7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (621,30)" }, { name: "ExphKLAE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/ControlBar.ts (621,62)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../modal/ModalSettings.ts" />
/// <reference path="../modal/ModalBanList.ts" />
/*
        client_output_hardware Value: '1'
        client_output_muted Value: '0'
        client_outputonly_muted Value: '0'

        client_input_hardware Value: '1'
        client_input_muted Value: '0'

        client_away Value: '0'
        client_away_message Value: ''
 */
let control_bar; /* global variable to access the control bar */
class ControlBar {
    constructor(htmlTag) {
        this.htmlTag = htmlTag;
    }
    initialize_connection_handler_state(handler) {
        /* setup the state like the last displayed one */
        handler.client_status.output_muted = this._button_speakers === "muted";
        handler.client_status.input_muted = this._button_microphone === "muted";
        handler.client_status.channel_subscribe_all = this._button_subscribe_all;
        handler.client_status.queries_visible = this._button_query_visible;
    }
    set_connection_handler(handler) {
        if (this.connection_handler == handler)
            return;
        this.connection_handler = handler;
        this.apply_server_state();
    }
    apply_server_state() {
        if (!this.connection_handler)
            return;
        const flag_away = typeof (this.connection_handler.client_status.away) === "string" || this.connection_handler.client_status.away;
        if (!flag_away)
            this.button_away_active = "online";
        else if (flag_away && this._button_away_active === "online")
            this.button_away_active = "away";
        this.button_query_visible = this.connection_handler.client_status.queries_visible;
        this.button_subscribe_all = this.connection_handler.client_status.channel_subscribe_all;
        this.apply_server_voice_state();
    }
    apply_server_voice_state() {
        if (!this.connection_handler)
            return;
        this.button_microphone = !this.connection_handler.client_status.input_hardware ? "disabled" : this.connection_handler.client_status.input_muted ? "muted" : "enabled";
        this.button_speaker = this.connection_handler.client_status.output_muted ? "muted" : "enabled";
    }
    current_connection_handler() {
        return this.connection_handler;
    }
    initialise() {
        let dropdownify = (tag) => {
            tag.find(".button-dropdown").on('click', () => {
                tag.addClass("displayed");
            }).hover(() => {
                tag.addClass("displayed");
            }, () => {
                if (tag.find(".dropdown:hover").length > 0)
                    return;
                tag.removeClass("displayed");
            });
            tag.on('mouseleave', () => {
                tag.removeClass("displayed");
            });
        };
        this.htmlTag.find(".btn_connect").on('click', this.on_open_connect.bind(this));
        this.htmlTag.find(".btn_disconnect").on('click', this.on_execute_disconnect.bind(this));
        this.htmlTag.find(".btn_mute_input").on('click', this.on_toggle_microphone.bind(this));
        this.htmlTag.find(".btn_mute_output").on('click', this.on_toggle_sound.bind(this));
        this.htmlTag.find(".button-subscribe-mode").on('click', this.on_toggle_channel_subscribe.bind(this));
        this.htmlTag.find(".btn_query_toggle").on('click', this.on_toggle_query_view.bind(this));
        this.htmlTag.find(".btn_open_settings").on('click', this.on_open_settings.bind(this));
        this.htmlTag.find(".btn_permissions").on('click', this.on_open_permissions.bind(this));
        this.htmlTag.find(".btn_banlist").on('click', this.on_open_banslist.bind(this));
        this.htmlTag.find(".button-playlist-manage").on('click', this.on_open_playlist_manage.bind(this));
        this.htmlTag.find(".btn_token_use").on('click', this.on_token_use.bind(this));
        this.htmlTag.find(".btn_token_list").on('click', this.on_token_list.bind(this));
        {
            this.htmlTag.find(".btn_away_disable").on('click', this.on_away_disable.bind(this));
            this.htmlTag.find(".btn_away_disable_global").on('click', this.on_away_disable_global.bind(this));
            this.htmlTag.find(".btn_away_enable").on('click', this.on_away_enable.bind(this));
            this.htmlTag.find(".btn_away_enable_global").on('click', this.on_away_enable_global.bind(this));
            this.htmlTag.find(".btn_away_message").on('click', this.on_away_set_message.bind(this));
            this.htmlTag.find(".btn_away_message_global").on('click', this.on_away_set_message_global.bind(this));
            this.htmlTag.find(".btn_away_toggle").on('click', this.on_away_toggle.bind(this));
        }
        dropdownify(this.htmlTag.find(".container-disconnect"));
        dropdownify(this.htmlTag.find(".btn_token"));
        dropdownify(this.htmlTag.find(".btn_away"));
        dropdownify(this.htmlTag.find(".btn_bookmark"));
        dropdownify(this.htmlTag.find(".btn_query"));
        dropdownify(this.htmlTag.find(".dropdown-audio"));
        dropdownify(this.htmlTag.find(".dropdown-servertools"));
        {
        }
        {
            this.htmlTag.find(".btn_bookmark_list").on('click', this.on_bookmark_manage.bind(this));
            this.htmlTag.find(".btn_bookmark_add").on('click', this.on_bookmark_server_add.bind(this));
        }
        {
            /* search for query buttons not only on the large device button */
            this.htmlTag.find(".btn_query_create").on('click', this.on_open_query_create.bind(this));
            this.htmlTag.find(".btn_query_manage").on('click', this.on_open_query_manage.bind(this));
        }
        this.update_bookmarks();
        this.update_bookmark_status();
        //Need an initialise
        this.button_speaker = settings.static_global(Settings.KEY_CONTROL_MUTE_OUTPUT, false) ? "muted" : "enabled";
        this.button_microphone = settings.static_global(Settings.KEY_CONTROL_MUTE_INPUT, false) ? "muted" : "enabled";
        this.button_subscribe_all = true;
        this.button_query_visible = false;
    }
    /* Update the UI */
    set button_away_active(flag) {
        if (this._button_away_active === flag)
            return;
        this._button_away_active = flag;
        this.update_button_away();
    }
    update_button_away() {
        const button_away_enable = this.htmlTag.find(".btn_away_enable");
        const button_away_disable = this.htmlTag.find(".btn_away_disable");
        const button_away_toggle = this.htmlTag.find(".btn_away_toggle");
        const button_away_disable_global = this.htmlTag.find(".btn_away_disable_global");
        const button_away_enable_global = this.htmlTag.find(".btn_away_enable_global");
        const button_away_message_global = this.htmlTag.find(".btn_away_message_global");
        button_away_toggle.toggleClass("activated", this._button_away_active !== "online");
        button_away_enable.toggle(this._button_away_active === "online");
        button_away_disable.toggle(this._button_away_active !== "online");
        const connections = server_connections.server_connection_handlers();
        if (connections.length <= 1) {
            button_away_disable_global.hide();
            button_away_enable_global.hide();
            button_away_message_global.hide();
        }
        else {
            button_away_message_global.show();
            button_away_enable_global.toggle(server_connections.server_connection_handlers().filter(e => !e.client_status.away).length > 0);
            button_away_disable_global.toggle(this._button_away_active === "away-global" ||
                server_connections.server_connection_handlers().filter(e => typeof (e.client_status.away) === "string" || e.client_status.away).length > 0);
        }
    }
    set button_microphone(state) {
        if (this._button_microphone === state)
            return;
        this._button_microphone = state;
        let tag = this.htmlTag.find(".btn_mute_input");
        const tag_icon = tag.find(".icon_x32, .icon");
        tag.toggleClass('activated', state === "muted");
        tag_icon
            .toggleClass('client-input_muted', state === "muted")
            .toggleClass('client-capture', state === "enabled")
            .toggleClass('client-activate_microphone', state === "disabled");
        if (state === "disabled")
            tag_icon.attr('title', _translations.Gwkiik7n || (_translations.Gwkiik7n = tr("Enable your microphone on this server")));
        else if (state === "enabled")
            tag_icon.attr('title', _translations.bsrLfEKb || (_translations.bsrLfEKb = tr("Mute microphone")));
        else
            tag_icon.attr('title', _translations.tIW9El25 || (_translations.tIW9El25 = tr("Unmute microphone")));
    }
    set button_speaker(state) {
        if (this._button_speakers === state)
            return;
        this._button_speakers = state;
        let tag = this.htmlTag.find(".btn_mute_output");
        const tag_icon = tag.find(".icon_x32, .icon");
        tag.toggleClass('activated', state === "muted");
        tag_icon
            .toggleClass('client-output_muted', state !== "enabled")
            .toggleClass('client-volume', state === "enabled");
        if (state === "enabled")
            tag_icon.attr('title', _translations.xcZ_jAWP || (_translations.xcZ_jAWP = tr("Mute sound")));
        else
            tag_icon.attr('title', _translations.mpHRKcfU || (_translations.mpHRKcfU = tr("Unmute sound")));
    }
    set button_subscribe_all(state) {
        if (this._button_subscribe_all === state)
            return;
        this._button_subscribe_all = state;
        this.htmlTag
            .find(".button-subscribe-mode")
            .toggleClass('activated', this._button_subscribe_all)
            .find('.icon_x32')
            .toggleClass('client-unsubscribe_from_all_channels', !this._button_subscribe_all)
            .toggleClass('client-subscribe_to_all_channels', this._button_subscribe_all);
    }
    set button_query_visible(state) {
        if (this._button_query_visible === state)
            return;
        this._button_query_visible = state;
        const button = this.htmlTag.find(".btn_query_toggle");
        button.toggleClass('activated', this._button_query_visible);
        if (this._button_query_visible)
            button.find(".query-text").text(_translations.lAIwkJfh || (_translations.lAIwkJfh = tr("Hide server queries")));
        else
            button.find(".query-text").text(_translations.cqDMP56z || (_translations.cqDMP56z = tr("Show server queries")));
    }
    /* UI listener */
    on_away_toggle() {
        if (this._button_away_active === "away" || this._button_away_active === "away-global")
            this.button_away_active = "online";
        else
            this.button_away_active = "away";
        if (this.connection_handler)
            this.connection_handler.set_away_status(this._button_away_active !== "online");
    }
    on_away_enable() {
        this.button_away_active = "away";
        if (this.connection_handler)
            this.connection_handler.set_away_status(true);
    }
    on_away_disable() {
        this.button_away_active = "online";
        if (this.connection_handler)
            this.connection_handler.set_away_status(false);
    }
    on_away_set_message() {
        createInputModal(_translations.LeV1A4U_ || (_translations.LeV1A4U_ = tr("Set away message")), _translations.xdgdNcBt || (_translations.xdgdNcBt = tr("Please enter your away message")), message => true, message => {
            if (typeof (message) === "string") {
                this.button_away_active = "away";
                if (this.connection_handler)
                    this.connection_handler.set_away_status(message);
            }
        }).open();
    }
    on_away_enable_global() {
        this.button_away_active = "away-global";
        for (const connection of server_connections.server_connection_handlers())
            connection.set_away_status(true);
    }
    on_away_disable_global() {
        this.button_away_active = "online";
        for (const connection of server_connections.server_connection_handlers())
            connection.set_away_status(false);
    }
    on_away_set_message_global() {
        createInputModal(_translations.PVej25EQ || (_translations.PVej25EQ = tr("Set global away message")), _translations.djMNxUkt || (_translations.djMNxUkt = tr("Please enter your global away message")), message => true, message => {
            if (typeof (message) === "string") {
                this.button_away_active = "away";
                for (const connection of server_connections.server_connection_handlers())
                    connection.set_away_status(message);
            }
        }).open();
    }
    on_toggle_microphone() {
        if (this._button_microphone === "disabled" || this._button_microphone === "muted")
            this.button_microphone = "enabled";
        else
            this.button_microphone = "muted";
        if (this.connection_handler) {
            this.connection_handler.client_status.input_muted = this._button_microphone !== "enabled";
            if (!this.connection_handler.client_status.input_hardware)
                this.connection_handler.acquire_recorder(default_recorder, true); /* acquire_recorder already updates the voice status */
            else
                this.connection_handler.update_voice_status(undefined);
            /* just update the last changed value */
            settings.changeGlobal(Settings.KEY_CONTROL_MUTE_INPUT, this.connection_handler.client_status.input_muted);
        }
    }
    on_toggle_sound() {
        if (this._button_speakers === "muted")
            this.button_speaker = "enabled";
        else
            this.button_speaker = "muted";
        if (this.connection_handler) {
            this.connection_handler.client_status.output_muted = this._button_speakers !== "enabled";
            this.connection_handler.update_voice_status(undefined);
            /* just update the last changed value */
            settings.changeGlobal(Settings.KEY_CONTROL_MUTE_OUTPUT, this.connection_handler.client_status.output_muted);
        }
    }
    on_toggle_channel_subscribe() {
        this.button_subscribe_all = !this._button_subscribe_all;
        if (this.connection_handler) {
            this.connection_handler.client_status.channel_subscribe_all = this._button_subscribe_all;
            if (this._button_subscribe_all)
                this.connection_handler.channelTree.subscribe_all_channels();
            else
                this.connection_handler.channelTree.unsubscribe_all_channels(true);
            this.connection_handler.settings.changeServer(Settings.KEY_CONTROL_CHANNEL_SUBSCRIBE_ALL, this._button_subscribe_all);
        }
    }
    on_toggle_query_view() {
        this.button_query_visible = !this._button_query_visible;
        if (this.connection_handler) {
            this.connection_handler.client_status.queries_visible = this._button_query_visible;
            this.connection_handler.channelTree.toggle_server_queries(this._button_query_visible);
            this.connection_handler.settings.changeServer(Settings.KEY_CONTROL_SHOW_QUERIES, this._button_subscribe_all);
        }
    }
    on_open_settings() {
        Modals.spawnSettingsModal();
    }
    on_open_connect() {
        if (this.connection_handler)
            this.connection_handler.cancel_reconnect();
        Modals.spawnConnectModal({
            url: "ts.TeaSpeak.de",
            enforce: false
        });
    }
    update_connection_state() {
        if (this.connection_handler.serverConnection && this.connection_handler.serverConnection.connected()) {
            this.htmlTag.find(".container-disconnect").show();
            this.htmlTag.find(".container-connect").hide();
        }
        else {
            this.htmlTag.find(".container-disconnect").hide();
            this.htmlTag.find(".container-connect").show();
        }
        /*
        switch (this.connection_handler.serverConnection ? this.connection_handler.serverConnection.connected() : ConnectionState.UNCONNECTED) {
            case ConnectionState.CONNECTED:
            case ConnectionState.CONNECTING:
            case ConnectionState.INITIALISING:
                this.htmlTag.find(".container-disconnect").show();
                this.htmlTag.find(".container-connect").hide();
                break;
            default:
                this.htmlTag.find(".container-disconnect").hide();
                this.htmlTag.find(".container-connect").show();
        }
        */
    }
    on_execute_disconnect() {
        this.connection_handler.cancel_reconnect();
        this.connection_handler.handleDisconnect(DisconnectReason.REQUESTED); //TODO message?
        this.update_connection_state();
        this.connection_handler.sound.play(Sound.CONNECTION_DISCONNECTED);
    }
    on_token_use() {
        createInputModal(_translations.REeyYcfP || (_translations.REeyYcfP = tr("Use token")), _translations.ezZ4kUfN || (_translations.ezZ4kUfN = tr("Please enter your token/priviledge key")), message => message.length > 0, result => {
            if (!result)
                return;
            if (this.connection_handler.serverConnection.connected)
                this.connection_handler.serverConnection.send_command("tokenuse", {
                    token: result
                }).then(() => {
                    createInfoModal(_translations.wgpT5XjU || (_translations.wgpT5XjU = tr("Use token")), _translations.DmjQsHXx || (_translations.DmjQsHXx = tr("Toke successfully used!"))).open();
                }).catch(error => {
                    //TODO tr
                    createErrorModal(_translations.TNf3C3tE || (_translations.TNf3C3tE = tr("Use token")), "Failed to use token: " + (error instanceof CommandResult ? error.message : error)).open();
                });
        }).open();
    }
    on_token_list() {
        createErrorModal(_translations.e_XE2qQM || (_translations.e_XE2qQM = tr("Not implemented")), _translations.xwqe45Sx || (_translations.xwqe45Sx = tr("Token list is not implemented yet!"))).open();
    }
    on_open_permissions() {
        let button = this.htmlTag.find(".btn_permissions");
        button.addClass("activated");
        setTimeout(() => {
            if (this.connection_handler)
                Modals.spawnPermissionEdit(this.connection_handler).open();
            else
                createErrorModal(_translations.Xb8SqmsZ || (_translations.Xb8SqmsZ = tr("You have to be connected")), _translations.XrlqQv_w || (_translations.XrlqQv_w = tr("You have to be connected!"))).open();
            button.removeClass("activated");
        }, 0);
    }
    on_open_banslist() {
        if (!this.connection_handler.serverConnection)
            return;
        if (this.connection_handler.permissions.neededPermission(PermissionType.B_CLIENT_BAN_LIST).granted(1)) {
            Modals.openBanList(this.connection_handler);
        }
        else {
            createErrorModal(_translations.CKNGwZJI || (_translations.CKNGwZJI = tr("You dont have the permission")), _translations.WolPunTT || (_translations.WolPunTT = tr("You dont have the permission to view the ban list"))).open();
            this.connection_handler.sound.play(Sound.ERROR_INSUFFICIENT_PERMISSIONS);
        }
    }
    on_bookmark_server_add() {
        if (this.connection_handler && this.connection_handler.connected) {
            createInputModal(_translations.WGkTAwuN || (_translations.WGkTAwuN = tr("Enter bookmarks name")), _translations.Oc2FIPnk || (_translations.Oc2FIPnk = tr("Please enter the bookmarks name:<br>")), text => true, result => {
                if (result) {
                    const bookmark = bookmarks.create_bookmark(result, bookmarks.bookmarks(), {
                        server_port: this.connection_handler.serverConnection.remote_address().port,
                        server_address: this.connection_handler.serverConnection.remote_address().host,
                        server_password: "",
                        server_password_hash: ""
                    }, this.connection_handler.getClient().clientNickName());
                    bookmarks.save_bookmark(bookmark);
                    this.update_bookmarks();
                }
            }).open();
        }
        else {
            createErrorModal(_translations._Or0GbEq || (_translations._Or0GbEq = tr("You have to be connected")), _translations.oR3g12dm || (_translations.oR3g12dm = tr("You have to be connected!"))).open();
        }
    }
    update_bookmark_status() {
        this.htmlTag.find(".btn_bookmark_add").removeClass("hidden").addClass("disabled");
        this.htmlTag.find(".btn_bookmark_remove").addClass("hidden");
    }
    update_bookmarks() {
        //<div class="btn_bookmark_connect" target="localhost"><a>Localhost</a></div>
        let tag_bookmark = this.htmlTag.find(".btn_bookmark .dropdown");
        tag_bookmark.find(".bookmark, .directory").detach();
        const build_entry = (bookmark) => {
            if (bookmark.type == bookmarks.BookmarkType.ENTRY) {
                const mark = bookmark;
                const bookmark_connect = (new_tab) => {
                    this.htmlTag.find(".btn_bookmark").find(".dropdown").removeClass("displayed"); //FIXME Not working
                    const profile = profiles.find_profile(mark.connect_profile) || profiles.default_profile();
                    if (profile.valid()) {
                        const connection = this.connection_handler && !new_tab ? this.connection_handler : server_connections.spawn_server_connection_handler();
                        server_connections.set_active_connection_handler(connection);
                        connection.startConnection(mark.server_properties.server_address + ":" + mark.server_properties.server_port, profile, {
                            nickname: mark.nickname,
                            password: {
                                password: mark.server_properties.server_password_hash,
                                hashed: true
                            }
                        });
                    }
                    else {
                        Modals.spawnConnectModal({
                            url: mark.server_properties.server_address + ":" + mark.server_properties.server_port,
                            enforce: true
                        }, {
                            profile: profile,
                            enforce: true
                        });
                    }
                };
                return $.spawn("div")
                    .addClass("bookmark")
                    .append($.spawn("div").addClass("icon client-server"))
                    .append($.spawn("div")
                    .addClass("name")
                    .text(bookmark.display_name)
                    .on('click', event => {
                    if (event.isDefaultPrevented())
                        return;
                    bookmark_connect(false);
                })
                    .on('contextmenu', event => {
                    if (event.isDefaultPrevented())
                        return;
                    event.preventDefault();
                    spawn_context_menu(event.pageX, event.pageY, {
                        type: MenuEntryType.ENTRY,
                        name: _translations.zcZdCCAX || (_translations.zcZdCCAX = tr("Connect")),
                        icon: 'client-connect',
                        callback: () => bookmark_connect(false)
                    }, {
                        type: MenuEntryType.ENTRY,
                        name: _translations.b9g7O_aI || (_translations.b9g7O_aI = tr("Connect in a new tab")),
                        icon: 'client-connect',
                        callback: () => bookmark_connect(true)
                    }, MenuEntry.CLOSE(() => {
                        setTimeout(() => {
                            this.htmlTag.find(".btn_bookmark.button-dropdown").removeClass("force-show");
                        }, 250);
                    }));
                    this.htmlTag.find(".btn_bookmark.button-dropdown").addClass("force-show");
                }));
            }
            else {
                const mark = bookmark;
                const container = $.spawn("div").addClass("sub-menu dropdown");
                for (const member of mark.content)
                    container.append(build_entry(member));
                return $.spawn("div")
                    .addClass("directory")
                    .append($.spawn("div").addClass("icon client-folder"))
                    .append($.spawn("div")
                    .addClass("name")
                    .text(bookmark.display_name))
                    .append($.spawn("div").addClass("arrow right"))
                    .append($.spawn("div").addClass("sub-container")
                    .append(container));
            }
        };
        for (const bookmark of bookmarks.bookmarks().content) {
            const entry = build_entry(bookmark);
            tag_bookmark.append(entry);
        }
    }
    on_bookmark_manage() {
        Modals.spawnBookmarkModal();
    }
    on_open_query_create() {
        if (this.connection_handler.permissions.neededPermission(PermissionType.B_CLIENT_CREATE_MODIFY_SERVERQUERY_LOGIN).granted(1)) {
            Modals.spawnQueryCreate(this.connection_handler);
        }
        else {
            createErrorModal(_translations.B2S6nvgx || (_translations.B2S6nvgx = tr("You dont have the permission")), _translations.oGmq2Jg3 || (_translations.oGmq2Jg3 = tr("You dont have the permission to create a server query login"))).open();
            this.connection_handler.sound.play(Sound.ERROR_INSUFFICIENT_PERMISSIONS);
        }
    }
    on_open_query_manage() {
        if (this.connection_handler && this.connection_handler.connected) {
            Modals.spawnQueryManage(this.connection_handler);
        }
        else {
            createErrorModal(_translations.RDdL3DQe || (_translations.RDdL3DQe = tr("You have to be connected")), _translations.vMZqcVsg || (_translations.vMZqcVsg = tr("You have to be connected!"))).open();
        }
    }
    on_open_playlist_manage() {
        if (this.connection_handler && this.connection_handler.connected) {
            Modals.spawnPlaylistManage(this.connection_handler);
        }
        else {
            createErrorModal(_translations.jMuBmB_7 || (_translations.jMuBmB_7 = tr("You have to be connected")), _translations.ExphKLAE || (_translations.ExphKLAE = tr("You have to be connected to use this function!"))).open();
        }
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["83670d382731e729c18189b4b249bc8126d4fe33c213133ced085cbd0dcb1b41"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["83670d382731e729c18189b4b249bc8126d4fe33c213133ced085cbd0dcb1b41"] = "83670d382731e729c18189b4b249bc8126d4fe33c213133ced085cbd0dcb1b41";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "mLDIyWWM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (142,53)" }, { name: "U_qWE0E1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (159,63)" }, { name: "nQ_oUE7z", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (180,21)" }, { name: "_pyitwhM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (181,46)" }, { name: "g5jlqRU3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (192,31)" }, { name: "iUyflniP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (193,34)" }, { name: "vGmkWmr4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (193,70)" }, { name: "VlsSXfw4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (199,50)" }, { name: "ljFBeMBb", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (207,54)" }, { name: "A1ZIGtaJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (313,39)" }, { name: "_Av5ZQb5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (332,51)" }, { name: "o0pBFghl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (349,51)" }, { name: "gtQkQhbi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (367,63)" }, { name: "Ig2q80G6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (377,31)" }, { name: "mXG3xdtZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (378,52)" }, { name: "qP0s77SN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (384,56)" }, { name: "R1oKn_pf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (387,31)" }, { name: "kut3LLGt", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (391,25)" }, { name: "jOhj93g8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (392,25)" }, { name: "o8LZVFS5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (401,25)" }, { name: "WnxRmpuC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (411,31)" }, { name: "FOuFq4_J", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (413,21)" }, { name: "nPmNfSPI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (414,21)" }, { name: "DuGKegzc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (419,21)" }, { name: "C6ERu5EA", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (420,49)" }, { name: "XuP1mhJz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (427,21)" }, { name: "hYRmLKgU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (428,49)" }, { name: "X2lRl3e1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (435,31)" }, { name: "YAaJfrR0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (437,21)" }, { name: "BhFFixj8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (438,21)" }, { name: "ogb_2TRi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (445,31)" }, { name: "Ci5oRZm1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (448,21)" }, { name: "uq7tW0jO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (449,21)" }, { name: "kBnm1UvX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (454,52)" }, { name: "o3B8hwft", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (456,21)" }, { name: "AGIMxkf3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (465,52)" }, { name: "nno1pWG0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (466,34)" }, { name: "ZGPcy7io", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (466,57)" }, { name: "r0BTvUxD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (478,21)" }, { name: "d0a_WEO6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (479,49)" }, { name: "eZ1kBBCk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (485,52)" }, { name: "V2ZymrjU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (491,52)" }, { name: "M4HhhQqn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (497,31)" }, { name: "trifzFpk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (498,31)" }, { name: "FZ4BwlKm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (514,29)" }, { name: "hrWsVQuD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (517,50)" }, { name: "JGdllxYO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (519,25)" }, { name: "hySl4B1e", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (525,54)" }, { name: "PSAsNznQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (526,50)" }, { name: "y_urLgF1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (536,50)" }, { name: "pVbLlP5u", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (583,51)" }, { name: "ywVT5C7p", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (584,56)" }, { name: "J2aqjes4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (606,31)" }, { name: "aP3ZdQht", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (608,31)" }, { name: "ZLJB2NlP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (610,31)" }, { name: "jFt143Fr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (612,38)" }, { name: "gQdUixIe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (642,47)" }, { name: "W3r4vZgM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (643,52)" }, { name: "SdbvJ9ol", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (656,43)" }, { name: "wiY2MJWv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (657,48)" }, { name: "Mmz7HTlI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ConnectionHandler.ts (672,27)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="log.ts" />
/// <reference path="proto.ts" />
/// <reference path="ui/view.ts" />
/// <reference path="settings.ts" />
/// <reference path="ui/frames/SelectedItemInfo.ts" />
/// <reference path="FileManager.ts" />
/// <reference path="permission/PermissionManager.ts" />
/// <reference path="permission/GroupManager.ts" />
/// <reference path="ui/frames/ControlBar.ts" />
/// <reference path="connection/ConnectionBase.ts" />
var DisconnectReason;
(function (DisconnectReason) {
    DisconnectReason[DisconnectReason["HANDLER_DESTROYED"] = 0] = "HANDLER_DESTROYED";
    DisconnectReason[DisconnectReason["REQUESTED"] = 1] = "REQUESTED";
    DisconnectReason[DisconnectReason["DNS_FAILED"] = 2] = "DNS_FAILED";
    DisconnectReason[DisconnectReason["CONNECT_FAILURE"] = 3] = "CONNECT_FAILURE";
    DisconnectReason[DisconnectReason["CONNECTION_CLOSED"] = 4] = "CONNECTION_CLOSED";
    DisconnectReason[DisconnectReason["CONNECTION_FATAL_ERROR"] = 5] = "CONNECTION_FATAL_ERROR";
    DisconnectReason[DisconnectReason["CONNECTION_PING_TIMEOUT"] = 6] = "CONNECTION_PING_TIMEOUT";
    DisconnectReason[DisconnectReason["CLIENT_KICKED"] = 7] = "CLIENT_KICKED";
    DisconnectReason[DisconnectReason["CLIENT_BANNED"] = 8] = "CLIENT_BANNED";
    DisconnectReason[DisconnectReason["HANDSHAKE_FAILED"] = 9] = "HANDSHAKE_FAILED";
    DisconnectReason[DisconnectReason["HANDSHAKE_TEAMSPEAK_REQUIRED"] = 10] = "HANDSHAKE_TEAMSPEAK_REQUIRED";
    DisconnectReason[DisconnectReason["HANDSHAKE_BANNED"] = 11] = "HANDSHAKE_BANNED";
    DisconnectReason[DisconnectReason["SERVER_CLOSED"] = 12] = "SERVER_CLOSED";
    DisconnectReason[DisconnectReason["SERVER_REQUIRES_PASSWORD"] = 13] = "SERVER_REQUIRES_PASSWORD";
    DisconnectReason[DisconnectReason["IDENTITY_TOO_LOW"] = 14] = "IDENTITY_TOO_LOW";
    DisconnectReason[DisconnectReason["UNKNOWN"] = 15] = "UNKNOWN";
})(DisconnectReason || (DisconnectReason = {}));
var ConnectionState;
(function (ConnectionState) {
    ConnectionState[ConnectionState["UNCONNECTED"] = 0] = "UNCONNECTED";
    ConnectionState[ConnectionState["CONNECTING"] = 1] = "CONNECTING";
    ConnectionState[ConnectionState["INITIALISING"] = 2] = "INITIALISING";
    ConnectionState[ConnectionState["CONNECTED"] = 3] = "CONNECTED";
    ConnectionState[ConnectionState["DISCONNECTING"] = 4] = "DISCONNECTING";
})(ConnectionState || (ConnectionState = {}));
var ViewReasonId;
(function (ViewReasonId) {
    ViewReasonId[ViewReasonId["VREASON_USER_ACTION"] = 0] = "VREASON_USER_ACTION";
    ViewReasonId[ViewReasonId["VREASON_MOVED"] = 1] = "VREASON_MOVED";
    ViewReasonId[ViewReasonId["VREASON_SYSTEM"] = 2] = "VREASON_SYSTEM";
    ViewReasonId[ViewReasonId["VREASON_TIMEOUT"] = 3] = "VREASON_TIMEOUT";
    ViewReasonId[ViewReasonId["VREASON_CHANNEL_KICK"] = 4] = "VREASON_CHANNEL_KICK";
    ViewReasonId[ViewReasonId["VREASON_SERVER_KICK"] = 5] = "VREASON_SERVER_KICK";
    ViewReasonId[ViewReasonId["VREASON_BAN"] = 6] = "VREASON_BAN";
    ViewReasonId[ViewReasonId["VREASON_SERVER_STOPPED"] = 7] = "VREASON_SERVER_STOPPED";
    ViewReasonId[ViewReasonId["VREASON_SERVER_LEFT"] = 8] = "VREASON_SERVER_LEFT";
    ViewReasonId[ViewReasonId["VREASON_CHANNEL_UPDATED"] = 9] = "VREASON_CHANNEL_UPDATED";
    ViewReasonId[ViewReasonId["VREASON_EDITED"] = 10] = "VREASON_EDITED";
    ViewReasonId[ViewReasonId["VREASON_SERVER_SHUTDOWN"] = 11] = "VREASON_SERVER_SHUTDOWN";
})(ViewReasonId || (ViewReasonId = {}));
class ConnectionHandler {
    constructor() {
        this._clientId = 0;
        this._reconnect_attempt = false;
        this._connect_initialize_id = 1;
        this.client_status = {
            input_hardware: false,
            input_muted: false,
            output_muted: false,
            away: false,
            channel_subscribe_all: true,
            queries_visible: false,
            sound_playback_supported: undefined,
            sound_record_supported: undefined,
            channel_codec_encoding_supported: undefined,
            channel_codec_decoding_supported: undefined
        };
        this.invoke_resized_on_activate = false;
        this.settings = new ServerSettings();
        this.select_info = new InfoBar(this);
        this.channelTree = new ChannelTree(this);
        this.chat = new ChatBox(this);
        this.sound = new sound.SoundManager(this);
        this.serverConnection = connection.spawn_server_connection(this);
        this.serverConnection.onconnectionstatechanged = this.on_connection_state_changed.bind(this);
        this.fileManager = new FileManager(this);
        this.permissions = new PermissionManager(this);
        this.groups = new GroupManager(this);
        this._local_client = new LocalClientEntry(this);
        this.channelTree.registerClient(this._local_client);
        //settings.static_global(Settings.KEY_DISABLE_VOICE, false)
        this.chat.initialize();
        this.tag_connection_handler = $.spawn("div").addClass("connection-container");
        $.spawn("div").addClass("server-icon icon client-server_green").appendTo(this.tag_connection_handler);
        $.spawn("div").addClass("server-name").text(_translations.mLDIyWWM || (_translations.mLDIyWWM = tr("Not connected"))).appendTo(this.tag_connection_handler);
        $.spawn("div").addClass("button-close icon client-tab_close_button").appendTo(this.tag_connection_handler);
        this.tag_connection_handler.on('click', event => {
            if (event.isDefaultPrevented())
                return;
            server_connections.set_active_connection_handler(this);
        });
        this.tag_connection_handler.find(".button-close").on('click', event => {
            server_connections.destroy_server_connection_handler(this);
            event.preventDefault();
        });
    }
    setup() { }
    startConnection(addr, profile, parameters) {
        return __awaiter(this, void 0, void 0, function* () {
            this.tag_connection_handler.find(".server-name").text(_translations.U_qWE0E1 || (_translations.U_qWE0E1 = tr("Connecting")));
            this.cancel_reconnect();
            this._reconnect_attempt = false;
            if (this.serverConnection)
                this.handleDisconnect(DisconnectReason.REQUESTED);
            let server_address = {
                host: "",
                port: -1
            };
            {
                let idx = addr.lastIndexOf(':');
                if (idx != -1) {
                    server_address.port = parseInt(addr.substr(idx + 1));
                    server_address.host = addr.substr(0, idx);
                }
                else {
                    server_address.host = addr;
                    server_address.port = 9987;
                }
            }
            console.log(_translations.nQ_oUE7z || (_translations.nQ_oUE7z = tr("Start connection to %s:%d")), server_address.host, server_address.port);
            this.chat.serverChat().appendMessage(_translations._pyitwhM || (_translations._pyitwhM = tr("Initializing connection to {0}{1}")), true, server_address.host, server_address.port == 9987 ? "" : ":" + server_address.port);
            this.channelTree.initialiseHead(addr, server_address);
            if (parameters.password && !parameters.password.hashed) {
                try {
                    const password = yield helpers.hashPassword(parameters.password.password);
                    parameters.password = {
                        hashed: true,
                        password: password
                    };
                }
                catch (error) {
                    console.error(_translations.g5jlqRU3 || (_translations.g5jlqRU3 = tr("Failed to hash connect password: %o")), error);
                    createErrorModal(_translations.iUyflniP || (_translations.iUyflniP = tr("Error while hashing password")), (_translations.vGmkWmr4 || (_translations.vGmkWmr4 = tr("Failed to hash server password!<br>"))) + error).open();
                }
            }
            if (dns.supported() && !server_address.host.match(Modals.Regex.IP_V4) && !server_address.host.match(Modals.Regex.IP_V6)) {
                const id = ++this._connect_initialize_id;
                this.chat.serverChat().appendMessage(_translations.VlsSXfw4 || (_translations.VlsSXfw4 = tr("Resolving hostname...")));
                try {
                    const resolved = (yield dns.resolve_address(server_address.host, { timeout: 5000 })) || {};
                    if (id != this._connect_initialize_id)
                        return; /* we're old */
                    server_address.port = resolved.target_port || server_address.port;
                    server_address.host = resolved.target_ip || server_address.host;
                    this.chat.serverChat().appendMessage(_translations.ljFBeMBb || (_translations.ljFBeMBb = tr("Hostname successfully resolved to {0}{1}")), true, server_address.host, server_address.port);
                }
                catch (error) {
                    if (id != this._connect_initialize_id)
                        return; /* we're old */
                    this.handleDisconnect(DisconnectReason.DNS_FAILED, error);
                }
            }
            yield this.serverConnection.connect(server_address, new connection.HandshakeHandler(profile, parameters));
        });
    }
    getClient() { return this._local_client; }
    getClientId() { return this._clientId; }
    set clientId(id) {
        this._clientId = id;
        this._local_client["_clientId"] = id;
    }
    get clientId() {
        return this._clientId;
    }
    getServerConnection() { return this.serverConnection; }
    /**
     * LISTENER
     */
    onConnected() {
        console.log("Client connected!");
        this.channelTree.registerClient(this._local_client);
        this.permissions.requestPermissionList();
        if (this.groups.serverGroups.length == 0)
            this.groups.requestGroups();
        this.initialize_server_settings();
        /* apply the server settings */
        if (this.client_status.channel_subscribe_all)
            this.channelTree.subscribe_all_channels();
        else
            this.channelTree.unsubscribe_all_channels();
        this.channelTree.toggle_server_queries(this.client_status.queries_visible);
        this.sync_status_with_server();
        /*
        No need to update the voice stuff because as soon we see ourself we're doing it
        this.update_voice_status();
        if(control_bar.current_connection_handler() === this)
            control_bar.apply_server_voice_state();
        */
    }
    initialize_server_settings() {
        let update_control = false;
        this.settings.setServer(this.channelTree.server);
        {
            const flag_subscribe = this.settings.server(Settings.KEY_CONTROL_CHANNEL_SUBSCRIBE_ALL, true);
            if (this.client_status.channel_subscribe_all != flag_subscribe) {
                this.client_status.channel_subscribe_all = flag_subscribe;
                update_control = true;
            }
        }
        {
            const flag_query = this.settings.server(Settings.KEY_CONTROL_SHOW_QUERIES, false);
            if (this.client_status.queries_visible != flag_query) {
                this.client_status.queries_visible = flag_query;
                update_control = true;
            }
        }
        if (update_control && server_connections.active_connection_handler() === this) {
            control_bar.apply_server_state();
        }
    }
    get connected() {
        return this.serverConnection && this.serverConnection.connected();
    }
    generate_ssl_certificate_accept() {
        const properties = {
            connect_default: true,
            connect_profile: this.serverConnection.handshake_handler().profile.id,
            connect_address: this.serverConnection.remote_address().host + (this.serverConnection.remote_address().port !== 9987 ? ":" + this.serverConnection.remote_address().port : "")
        };
        const build_url = props => {
            const parameters = [];
            for (const key of Object.keys(props))
                parameters.push(key + "=" + encodeURIComponent(props[key]));
            let callback = document.location.origin + document.location.pathname + document.location.search; /* don't use document.URL because it may contains a #! */
            if (document.location.search.length == 0)
                callback += "?" + parameters.join("&");
            else
                callback += "&" + parameters.join("&");
            return "https://" + this.serverConnection.remote_address().host + ":" + this.serverConnection.remote_address().port + "/?forward_url=" + encodeURIComponent(callback);
        };
        /* generate the tag */
        const tag = $.spawn("a").text(_translations.A1ZIGtaJ || (_translations.A1ZIGtaJ = tr("here")));
        if (bipc.supported()) {
            tag.attr('href', "#");
            let popup;
            tag.on('click', event => {
                const features = {
                    status: "no",
                    location: "no",
                    toolbar: "no",
                    menubar: "no",
                    width: 600,
                    height: 400
                };
                if (popup)
                    popup.close();
                properties["certificate_callback"] = bipc.get_handler().register_certificate_accept_callback(() => {
                    log.info(LogCategory.GENERAL, _translations._Av5ZQb5 || (_translations._Av5ZQb5 = tr("Received notification that the certificate has been accepted! Attempting reconnect!")));
                    if (this._certificate_modal)
                        this._certificate_modal.close();
                    popup.close(); /* no need, but nicer */
                    const profile = profiles.find_profile(properties.connect_profile) || profiles.default_profile();
                    const cprops = this.reconnect_properties(profile);
                    this.startConnection(properties.connect_address, profile, cprops);
                });
                const url = build_url(properties);
                const features_string = [...Object.keys(features)].map(e => e + "=" + features[e]).reduce((a, b) => a + "," + b);
                popup = window.open(url, "TeaWeb certificate accept", features_string);
                try {
                    popup.focus();
                }
                catch (e) {
                    log.warn(LogCategory.GENERAL, _translations.o0pBFghl || (_translations.o0pBFghl = tr("Certificate accept popup has been blocked. Trying a blank page and replacing href")));
                    window.open(url, "TeaWeb certificate accept"); /* trying without features */
                    tag.attr("target", "_blank");
                    tag.attr("href", url);
                    tag.unbind('click');
                }
            });
        }
        else {
            tag.attr('href', build_url(properties));
        }
        return tag;
    }
    handleDisconnect(type, data = {}) {
        this._connect_initialize_id++;
        this.tag_connection_handler.find(".server-name").text(_translations.gtQkQhbi || (_translations.gtQkQhbi = tr("Not connected")));
        let auto_reconnect = false;
        switch (type) {
            case DisconnectReason.REQUESTED:
                break;
            case DisconnectReason.HANDLER_DESTROYED:
                if (data)
                    this.sound.play(Sound.CONNECTION_DISCONNECTED);
                break;
            case DisconnectReason.DNS_FAILED:
                console.error(_translations.Ig2q80G6 || (_translations.Ig2q80G6 = tr("Failed to resolve hostname: %o")), data);
                this.chat.serverChat().appendError(_translations.mXG3xdtZ || (_translations.mXG3xdtZ = tr("Failed to resolve hostname: {0}")), data);
                this.sound.play(Sound.CONNECTION_REFUSED);
                break;
            case DisconnectReason.CONNECT_FAILURE:
                if (this._reconnect_attempt) {
                    auto_reconnect = true;
                    this.chat.serverChat().appendError(_translations.qP0s77SN || (_translations.qP0s77SN = tr("Connect failed")));
                    break;
                }
                console.error(_translations.R1oKn_pf || (_translations.R1oKn_pf = tr("Could not connect to remote host! Error: %o")), data);
                if (native_client) {
                    createErrorModal(_translations.kut3LLGt || (_translations.kut3LLGt = tr("Could not connect")), _translations.jOhj93g8 || (_translations.jOhj93g8 = tr("Could not connect to remote host (Connection refused)"))).open();
                }
                else {
                    const error_message_format = "Could not connect to remote host (Connection refused)\n" +
                        "If you're sure that the remote host is up, than you may not allow unsigned certificates.\n" +
                        "Click {0} to accept the remote certificate";
                    this._certificate_modal = createErrorModal(_translations.o8LZVFS5 || (_translations.o8LZVFS5 = tr("Could not connect")), MessageHelper.formatMessage(tr(error_message_format), this.generate_ssl_certificate_accept()));
                    this._certificate_modal.close_listener.push(() => this._certificate_modal = undefined);
                    this._certificate_modal.open();
                }
                this.sound.play(Sound.CONNECTION_REFUSED);
                break;
            case DisconnectReason.HANDSHAKE_FAILED:
                //TODO sound
                console.error(_translations.WnxRmpuC || (_translations.WnxRmpuC = tr("Failed to process handshake: %o")), data);
                createErrorModal(_translations.FOuFq4_J || (_translations.FOuFq4_J = tr("Could not connect")), (_translations.nPmNfSPI || (_translations.nPmNfSPI = tr("Failed to process handshake: "))) + data).open();
                break;
            case DisconnectReason.HANDSHAKE_TEAMSPEAK_REQUIRED:
                createErrorModal(_translations.DuGKegzc || (_translations.DuGKegzc = tr("Target server is a TeamSpeak server")), MessageHelper.formatMessage(_translations.C6ERu5EA || (_translations.C6ERu5EA = tr("The target server is a TeamSpeak 3 server!{:br:}Only TeamSpeak 3 based identities are able to connect.{:br:}Please select another profile or change the identify type.")))).open();
                this.sound.play(Sound.CONNECTION_DISCONNECTED);
                auto_reconnect = false;
                break;
            case DisconnectReason.IDENTITY_TOO_LOW:
                createErrorModal(_translations.XuP1mhJz || (_translations.XuP1mhJz = tr("Identity level is too low")), MessageHelper.formatMessage(_translations.hYRmLKgU || (_translations.hYRmLKgU = tr("You've been disconnected, because your Identity level is too low.{:br:}You need at least a level of {0}")), data["extra_message"])).open();
                this.sound.play(Sound.CONNECTION_DISCONNECTED);
                auto_reconnect = false;
                break;
            case DisconnectReason.CONNECTION_CLOSED:
                console.error(_translations.X2lRl3e1 || (_translations.X2lRl3e1 = tr("Lost connection to remote server!")));
                createErrorModal(_translations.YAaJfrR0 || (_translations.YAaJfrR0 = tr("Connection closed")), _translations.BhFFixj8 || (_translations.BhFFixj8 = tr("The connection was closed by remote host"))).open();
                this.sound.play(Sound.CONNECTION_DISCONNECTED);
                auto_reconnect = true;
                break;
            case DisconnectReason.CONNECTION_PING_TIMEOUT:
                console.error(_translations.ogb_2TRi || (_translations.ogb_2TRi = tr("Connection ping timeout")));
                this.sound.play(Sound.CONNECTION_DISCONNECTED_TIMEOUT);
                createErrorModal(_translations.Ci5oRZm1 || (_translations.Ci5oRZm1 = tr("Connection lost")), _translations.uq7tW0jO || (_translations.uq7tW0jO = tr("Lost connection to remote host (Ping timeout)<br>Even possible?"))).open();
                break;
            case DisconnectReason.SERVER_CLOSED:
                this.chat.serverChat().appendError(_translations.kBnm1UvX || (_translations.kBnm1UvX = tr("Server closed ({0})")), data.reasonmsg);
                createErrorModal(_translations.o3B8hwft || (_translations.o3B8hwft = tr("Server closed")), "The server is closed.<br>" + //TODO tr
                    "Reason: " + data.reasonmsg).open();
                this.sound.play(Sound.CONNECTION_DISCONNECTED);
                auto_reconnect = true;
                break;
            case DisconnectReason.SERVER_REQUIRES_PASSWORD:
                this.chat.serverChat().appendError(_translations.AGIMxkf3 || (_translations.AGIMxkf3 = tr("Server requires password")));
                createInputModal(_translations.nno1pWG0 || (_translations.nno1pWG0 = tr("Server password")), _translations.ZGPcy7io || (_translations.ZGPcy7io = tr("Enter server password:")), password => password.length != 0, password => {
                    if (!(typeof password === "string"))
                        return;
                    const cprops = this.reconnect_properties(this.serverConnection.handshake_handler().profile);
                    cprops.password = { password: password, hashed: false };
                    this.startConnection(this.serverConnection.remote_address().host + ":" + this.serverConnection.remote_address().port, this.serverConnection.handshake_handler().profile, cprops);
                }).open();
                break;
            case DisconnectReason.CLIENT_KICKED:
                createErrorModal(_translations.r0BTvUxD || (_translations.r0BTvUxD = tr("You've been banned")), MessageHelper.formatMessage(_translations.d0a_WEO6 || (_translations.d0a_WEO6 = tr("You've been banned from this server.{:br:}{0}")), data["extra_message"])).open();
                this.sound.play(Sound.SERVER_KICKED);
                auto_reconnect = false;
                break;
            case DisconnectReason.HANDSHAKE_BANNED:
                this.chat.serverChat().appendError(_translations.eZ1kBBCk || (_translations.eZ1kBBCk = tr("You got banned from the server by {0}{1}")), ClientEntry.chatTag(data["invokerid"], data["invokername"], data["invokeruid"]), data["reasonmsg"] ? " (" + data["reasonmsg"] + ")" : "");
                this.sound.play(Sound.CONNECTION_BANNED); //TODO findout if it was a disconnect or a connect refuse
                break;
            case DisconnectReason.CLIENT_BANNED:
                this.chat.serverChat().appendError(_translations.V2ZymrjU || (_translations.V2ZymrjU = tr("You got banned from the server by {0}{1}")), ClientEntry.chatTag(data["invokerid"], data["invokername"], data["invokeruid"]), data["reasonmsg"] ? " (" + data["reasonmsg"] + ")" : "");
                this.sound.play(Sound.CONNECTION_BANNED); //TODO findout if it was a disconnect or a connect refuse
                break;
            default:
                console.error(_translations.M4HhhQqn || (_translations.M4HhhQqn = tr("Got uncaught disconnect!")));
                console.error(_translations.trifzFpk || (_translations.trifzFpk = tr("Type: %o Data:")), type);
                console.error(data);
                break;
        }
        this.channelTree.reset();
        if (this.serverConnection)
            this.serverConnection.disconnect();
        if (control_bar.current_connection_handler() == this)
            control_bar.update_connection_state();
        this.select_info.setCurrentSelected(null);
        this.select_info.update_banner();
        if (auto_reconnect) {
            if (!this.serverConnection) {
                console.log(_translations.FZ4BwlKm || (_translations.FZ4BwlKm = tr("Allowed to auto reconnect but cant reconnect because we dont have any information left...")));
                return;
            }
            this.chat.serverChat().appendMessage(_translations.hrWsVQuD || (_translations.hrWsVQuD = tr("Reconnecting in 5 seconds")));
            console.log(_translations.JGdllxYO || (_translations.JGdllxYO = tr("Allowed to auto reconnect. Reconnecting in 5000ms")));
            const server_address = this.serverConnection.remote_address();
            const profile = this.serverConnection.handshake_handler().profile;
            this._reconnect_timer = setTimeout(() => {
                this._reconnect_timer = undefined;
                this.chat.serverChat().appendMessage(_translations.hySl4B1e || (_translations.hySl4B1e = tr("Reconnecting...")));
                log.info(LogCategory.NETWORKING, _translations.PSAsNznQ || (_translations.PSAsNznQ = tr("Reconnecting...")));
                this.startConnection(server_address.host + ":" + server_address.port, profile, this.reconnect_properties(profile));
                this._reconnect_attempt = true;
            }, 5000);
        }
    }
    cancel_reconnect() {
        if (this._reconnect_timer) {
            this.chat.serverChat().appendMessage(_translations.y_urLgF1 || (_translations.y_urLgF1 = tr("Reconnect canceled")));
            clearTimeout(this._reconnect_timer);
            this._reconnect_timer = undefined;
        }
    }
    on_connection_state_changed() {
        if (control_bar.current_connection_handler() == this)
            control_bar.update_connection_state();
    }
    update_voice_status(targetChannel) {
        targetChannel = targetChannel || this.getClient().currentChannel();
        const vconnection = this.serverConnection.voice_connection();
        const basic_voice_support = this.serverConnection.support_voice() && vconnection.connected();
        const support_record = basic_voice_support && (!targetChannel || vconnection.encoding_supported(targetChannel.properties.channel_codec));
        const support_playback = basic_voice_support && (!targetChannel || vconnection.decoding_supported(targetChannel.properties.channel_codec));
        const property_update = {
            client_input_muted: this.client_status.input_muted,
            client_output_muted: this.client_status.output_muted
        };
        if (!this.serverConnection.support_voice() || !vconnection.connected()) {
            property_update["client_input_hardware"] = false;
            property_update["client_output_hardware"] = false;
            this.client_status.input_hardware = true; /* IDK if we have input hardware or not, but it dosn't matter at all so */
        }
        else {
            const audio_source = vconnection.voice_recorder();
            const recording_supported = typeof (audio_source) !== "undefined" && audio_source.record_supported && (!targetChannel || vconnection.encoding_supported(targetChannel.properties.channel_codec));
            const playback_supported = !targetChannel || vconnection.decoding_supported(targetChannel.properties.channel_codec);
            property_update["client_input_hardware"] = recording_supported;
            property_update["client_output_hardware"] = playback_supported;
            this.client_status.input_hardware = recording_supported;
        }
        if (this.serverConnection && this.serverConnection.connected()) {
            const client_properties = this.getClient().properties;
            for (const key of Object.keys(property_update)) {
                if (client_properties[key] === property_update[key])
                    delete property_update[key];
            }
            if (Object.keys(property_update).length > 0) {
                this.serverConnection.send_command("clientupdate", property_update).catch(error => {
                    log.warn(LogCategory.GENERAL, _translations.pVbLlP5u || (_translations.pVbLlP5u = tr("Failed to update client audio hardware properties. Error: %o")), error);
                    this.chat.serverChat().appendError(_translations.ywVT5C7p || (_translations.ywVT5C7p = tr("Failed to update audio hardware properties.")));
                    /* Update these properties anyways (for case the server fails to handle the command) */
                    const updates = [];
                    for (const key of Object.keys(property_update))
                        updates.push({ key: key, value: (property_update[key]) + "" });
                    this.getClient().updateVariables(...updates);
                });
            }
        }
        else { /* no icons are shown so no update at all */ }
        if (targetChannel && (!vconnection || vconnection.connected())) {
            const encoding_supported = vconnection && vconnection.encoding_supported(targetChannel.properties.channel_codec);
            const decoding_supported = vconnection && vconnection.decoding_supported(targetChannel.properties.channel_codec);
            if (this.client_status.channel_codec_decoding_supported !== decoding_supported || this.client_status.channel_codec_encoding_supported !== encoding_supported) {
                this.client_status.channel_codec_decoding_supported = decoding_supported;
                this.client_status.channel_codec_encoding_supported = encoding_supported;
                let message;
                if (!encoding_supported && !decoding_supported)
                    message = _translations.J2aqjes4 || (_translations.J2aqjes4 = tr("This channel has an unsupported codec.<br>You cant speak or listen to anybody within this channel!"));
                else if (!encoding_supported)
                    message = _translations.aP3ZdQht || (_translations.aP3ZdQht = tr("This channel has an unsupported codec.<br>You cant speak within this channel!"));
                else if (!decoding_supported)
                    message = _translations.ZLJB2NlP || (_translations.ZLJB2NlP = tr("This channel has an unsupported codec.<br>You listen to anybody within this channel!")); /* implies speaking does not work as well */
                if (message)
                    createErrorModal(_translations.jFt143Fr || (_translations.jFt143Fr = tr("Channel codec unsupported")), message).open();
            }
        }
        this.client_status = this.client_status || {};
        this.client_status.sound_record_supported = support_record;
        this.client_status.sound_playback_supported = support_playback;
        if (vconnection && vconnection.voice_recorder() && vconnection.voice_recorder().record_supported) {
            const active = !this.client_status.input_muted && !this.client_status.output_muted;
            if (active)
                vconnection.voice_recorder().input.start();
            else
                vconnection.voice_recorder().input.stop();
        }
        if (control_bar.current_connection_handler() === this)
            control_bar.apply_server_voice_state();
    }
    sync_status_with_server() {
        if (this.serverConnection.connected())
            this.serverConnection.send_command("clientupdate", {
                client_input_muted: this.client_status.input_muted,
                client_output_muted: this.client_status.output_muted,
                client_away: typeof (this.client_status.away) === "string" || this.client_status.away,
                client_away_message: typeof (this.client_status.away) === "string" ? this.client_status.away : "",
                client_input_hardware: this.client_status.sound_record_supported && this.client_status.input_hardware,
                client_output_hardware: this.client_status.sound_playback_supported
            }).catch(error => {
                log.warn(LogCategory.GENERAL, _translations.gQdUixIe || (_translations.gQdUixIe = tr("Failed to sync handler state with server. Error: %o")), error);
                this.chat.serverChat().appendError(_translations.W3r4vZgM || (_translations.W3r4vZgM = tr("Failed to sync handler state with server.")));
            });
    }
    set_away_status(state) {
        if (this.client_status.away === state)
            return;
        this.client_status.away = state;
        this.serverConnection.send_command("clientupdate", {
            client_away: typeof (this.client_status.away) === "string" || this.client_status.away,
            client_away_message: typeof (this.client_status.away) === "string" ? this.client_status.away : "",
        }).catch(error => {
            log.warn(LogCategory.GENERAL, _translations.SdbvJ9ol || (_translations.SdbvJ9ol = tr("Failed to update away status. Error: %o")), error);
            this.chat.serverChat().appendError(_translations.wiY2MJWv || (_translations.wiY2MJWv = tr("Failed to update away status.")));
        });
        control_bar.update_button_away();
    }
    resize_elements() {
        this.channelTree.handle_resized();
        this.select_info.handle_resize();
        this.invoke_resized_on_activate = false;
    }
    acquire_recorder(voice_recoder, update_control_bar) {
        const vconnection = this.serverConnection.voice_connection();
        (vconnection ? vconnection.acquire_voice_recorder(voice_recoder) : Promise.resolve()).catch(error => {
            console.error(_translations.Mmz7HTlI || (_translations.Mmz7HTlI = tr("Failed to acquire recorder (%o)")), error);
        }).then(() => {
            this.update_voice_status(undefined);
        });
    }
    reconnect_properties(profile) {
        const name = (this.getClient() ? this.getClient().clientNickName() : "") ||
            (this.serverConnection && this.serverConnection.handshake_handler() ? this.serverConnection.handshake_handler().parameters.nickname : "") ||
            settings.static_global(Settings.KEY_CONNECT_USERNAME, profile ? profile.default_username : undefined) ||
            "Another TeaSpeak user";
        const channel = (this.getClient() && this.getClient().currentChannel() ? this.getClient().currentChannel().channelId : 0) ||
            (this.serverConnection && this.serverConnection.handshake_handler() ? (this.serverConnection.handshake_handler().parameters.channel || {}).target : "");
        const channel_password = (this.getClient() && this.getClient().currentChannel() ? this.getClient().currentChannel().cached_password() : "") ||
            (this.serverConnection && this.serverConnection.handshake_handler() ? (this.serverConnection.handshake_handler().parameters.channel || {}).password : "");
        return {
            channel: channel ? { target: "/" + channel, password: channel_password } : undefined,
            nickname: name,
            password: this.serverConnection && this.serverConnection.handshake_handler() ? this.serverConnection.handshake_handler().parameters.password : undefined
        };
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["f491ddd02a15848022df4b0c9eb5f77dc56a390b909e5f55d1a3688b337ba393"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["f491ddd02a15848022df4b0c9eb5f77dc56a390b909e5f55d1a3688b337ba393"] = "f491ddd02a15848022df4b0c9eb5f77dc56a390b909e5f55d1a3688b337ba393";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Q9VLf8do", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/PPTListener.ts (161,31)" }, { name: "cTr1XY6s", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/PPTListener.ts (163,31)" }, { name: "DIvQOyne", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/PPTListener.ts (165,31)" }, { name: "b0QTY_ci", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/PPTListener.ts (167,31)" }, { name: "Q7dYnfxi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/PPTListener.ts (169,58)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var KeyCode;
(function (KeyCode) {
    KeyCode[KeyCode["KEY_CANCEL"] = 3] = "KEY_CANCEL";
    KeyCode[KeyCode["KEY_HELP"] = 6] = "KEY_HELP";
    KeyCode[KeyCode["KEY_BACK_SPACE"] = 8] = "KEY_BACK_SPACE";
    KeyCode[KeyCode["KEY_TAB"] = 9] = "KEY_TAB";
    KeyCode[KeyCode["KEY_CLEAR"] = 12] = "KEY_CLEAR";
    KeyCode[KeyCode["KEY_RETURN"] = 13] = "KEY_RETURN";
    KeyCode[KeyCode["KEY_ENTER"] = 14] = "KEY_ENTER";
    KeyCode[KeyCode["KEY_SHIFT"] = 16] = "KEY_SHIFT";
    KeyCode[KeyCode["KEY_CONTROL"] = 17] = "KEY_CONTROL";
    KeyCode[KeyCode["KEY_ALT"] = 18] = "KEY_ALT";
    KeyCode[KeyCode["KEY_PAUSE"] = 19] = "KEY_PAUSE";
    KeyCode[KeyCode["KEY_CAPS_LOCK"] = 20] = "KEY_CAPS_LOCK";
    KeyCode[KeyCode["KEY_ESCAPE"] = 27] = "KEY_ESCAPE";
    KeyCode[KeyCode["KEY_SPACE"] = 32] = "KEY_SPACE";
    KeyCode[KeyCode["KEY_PAGE_UP"] = 33] = "KEY_PAGE_UP";
    KeyCode[KeyCode["KEY_PAGE_DOWN"] = 34] = "KEY_PAGE_DOWN";
    KeyCode[KeyCode["KEY_END"] = 35] = "KEY_END";
    KeyCode[KeyCode["KEY_HOME"] = 36] = "KEY_HOME";
    KeyCode[KeyCode["KEY_LEFT"] = 37] = "KEY_LEFT";
    KeyCode[KeyCode["KEY_UP"] = 38] = "KEY_UP";
    KeyCode[KeyCode["KEY_RIGHT"] = 39] = "KEY_RIGHT";
    KeyCode[KeyCode["KEY_DOWN"] = 40] = "KEY_DOWN";
    KeyCode[KeyCode["KEY_PRINTSCREEN"] = 44] = "KEY_PRINTSCREEN";
    KeyCode[KeyCode["KEY_INSERT"] = 45] = "KEY_INSERT";
    KeyCode[KeyCode["KEY_DELETE"] = 46] = "KEY_DELETE";
    KeyCode[KeyCode["KEY_0"] = 48] = "KEY_0";
    KeyCode[KeyCode["KEY_1"] = 49] = "KEY_1";
    KeyCode[KeyCode["KEY_2"] = 50] = "KEY_2";
    KeyCode[KeyCode["KEY_3"] = 51] = "KEY_3";
    KeyCode[KeyCode["KEY_4"] = 52] = "KEY_4";
    KeyCode[KeyCode["KEY_5"] = 53] = "KEY_5";
    KeyCode[KeyCode["KEY_6"] = 54] = "KEY_6";
    KeyCode[KeyCode["KEY_7"] = 55] = "KEY_7";
    KeyCode[KeyCode["KEY_8"] = 56] = "KEY_8";
    KeyCode[KeyCode["KEY_9"] = 57] = "KEY_9";
    KeyCode[KeyCode["KEY_SEMICOLON"] = 59] = "KEY_SEMICOLON";
    KeyCode[KeyCode["KEY_EQUALS"] = 61] = "KEY_EQUALS";
    KeyCode[KeyCode["KEY_A"] = 65] = "KEY_A";
    KeyCode[KeyCode["KEY_B"] = 66] = "KEY_B";
    KeyCode[KeyCode["KEY_C"] = 67] = "KEY_C";
    KeyCode[KeyCode["KEY_D"] = 68] = "KEY_D";
    KeyCode[KeyCode["KEY_E"] = 69] = "KEY_E";
    KeyCode[KeyCode["KEY_F"] = 70] = "KEY_F";
    KeyCode[KeyCode["KEY_G"] = 71] = "KEY_G";
    KeyCode[KeyCode["KEY_H"] = 72] = "KEY_H";
    KeyCode[KeyCode["KEY_I"] = 73] = "KEY_I";
    KeyCode[KeyCode["KEY_J"] = 74] = "KEY_J";
    KeyCode[KeyCode["KEY_K"] = 75] = "KEY_K";
    KeyCode[KeyCode["KEY_L"] = 76] = "KEY_L";
    KeyCode[KeyCode["KEY_M"] = 77] = "KEY_M";
    KeyCode[KeyCode["KEY_N"] = 78] = "KEY_N";
    KeyCode[KeyCode["KEY_O"] = 79] = "KEY_O";
    KeyCode[KeyCode["KEY_P"] = 80] = "KEY_P";
    KeyCode[KeyCode["KEY_Q"] = 81] = "KEY_Q";
    KeyCode[KeyCode["KEY_R"] = 82] = "KEY_R";
    KeyCode[KeyCode["KEY_S"] = 83] = "KEY_S";
    KeyCode[KeyCode["KEY_T"] = 84] = "KEY_T";
    KeyCode[KeyCode["KEY_U"] = 85] = "KEY_U";
    KeyCode[KeyCode["KEY_V"] = 86] = "KEY_V";
    KeyCode[KeyCode["KEY_W"] = 87] = "KEY_W";
    KeyCode[KeyCode["KEY_X"] = 88] = "KEY_X";
    KeyCode[KeyCode["KEY_Y"] = 89] = "KEY_Y";
    KeyCode[KeyCode["KEY_Z"] = 90] = "KEY_Z";
    KeyCode[KeyCode["KEY_LEFT_CMD"] = 91] = "KEY_LEFT_CMD";
    KeyCode[KeyCode["KEY_RIGHT_CMD"] = 93] = "KEY_RIGHT_CMD";
    KeyCode[KeyCode["KEY_CONTEXT_MENU"] = 93] = "KEY_CONTEXT_MENU";
    KeyCode[KeyCode["KEY_NUMPAD0"] = 96] = "KEY_NUMPAD0";
    KeyCode[KeyCode["KEY_NUMPAD1"] = 97] = "KEY_NUMPAD1";
    KeyCode[KeyCode["KEY_NUMPAD2"] = 98] = "KEY_NUMPAD2";
    KeyCode[KeyCode["KEY_NUMPAD3"] = 99] = "KEY_NUMPAD3";
    KeyCode[KeyCode["KEY_NUMPAD4"] = 100] = "KEY_NUMPAD4";
    KeyCode[KeyCode["KEY_NUMPAD5"] = 101] = "KEY_NUMPAD5";
    KeyCode[KeyCode["KEY_NUMPAD6"] = 102] = "KEY_NUMPAD6";
    KeyCode[KeyCode["KEY_NUMPAD7"] = 103] = "KEY_NUMPAD7";
    KeyCode[KeyCode["KEY_NUMPAD8"] = 104] = "KEY_NUMPAD8";
    KeyCode[KeyCode["KEY_NUMPAD9"] = 105] = "KEY_NUMPAD9";
    KeyCode[KeyCode["KEY_MULTIPLY"] = 106] = "KEY_MULTIPLY";
    KeyCode[KeyCode["KEY_ADD"] = 107] = "KEY_ADD";
    KeyCode[KeyCode["KEY_SEPARATOR"] = 108] = "KEY_SEPARATOR";
    KeyCode[KeyCode["KEY_SUBTRACT"] = 109] = "KEY_SUBTRACT";
    KeyCode[KeyCode["KEY_DECIMAL"] = 110] = "KEY_DECIMAL";
    KeyCode[KeyCode["KEY_DIVIDE"] = 111] = "KEY_DIVIDE";
    KeyCode[KeyCode["KEY_F1"] = 112] = "KEY_F1";
    KeyCode[KeyCode["KEY_F2"] = 113] = "KEY_F2";
    KeyCode[KeyCode["KEY_F3"] = 114] = "KEY_F3";
    KeyCode[KeyCode["KEY_F4"] = 115] = "KEY_F4";
    KeyCode[KeyCode["KEY_F5"] = 116] = "KEY_F5";
    KeyCode[KeyCode["KEY_F6"] = 117] = "KEY_F6";
    KeyCode[KeyCode["KEY_F7"] = 118] = "KEY_F7";
    KeyCode[KeyCode["KEY_F8"] = 119] = "KEY_F8";
    KeyCode[KeyCode["KEY_F9"] = 120] = "KEY_F9";
    KeyCode[KeyCode["KEY_F10"] = 121] = "KEY_F10";
    KeyCode[KeyCode["KEY_F11"] = 122] = "KEY_F11";
    KeyCode[KeyCode["KEY_F12"] = 123] = "KEY_F12";
    KeyCode[KeyCode["KEY_F13"] = 124] = "KEY_F13";
    KeyCode[KeyCode["KEY_F14"] = 125] = "KEY_F14";
    KeyCode[KeyCode["KEY_F15"] = 126] = "KEY_F15";
    KeyCode[KeyCode["KEY_F16"] = 127] = "KEY_F16";
    KeyCode[KeyCode["KEY_F17"] = 128] = "KEY_F17";
    KeyCode[KeyCode["KEY_F18"] = 129] = "KEY_F18";
    KeyCode[KeyCode["KEY_F19"] = 130] = "KEY_F19";
    KeyCode[KeyCode["KEY_F20"] = 131] = "KEY_F20";
    KeyCode[KeyCode["KEY_F21"] = 132] = "KEY_F21";
    KeyCode[KeyCode["KEY_F22"] = 133] = "KEY_F22";
    KeyCode[KeyCode["KEY_F23"] = 134] = "KEY_F23";
    KeyCode[KeyCode["KEY_F24"] = 135] = "KEY_F24";
    KeyCode[KeyCode["KEY_NUM_LOCK"] = 144] = "KEY_NUM_LOCK";
    KeyCode[KeyCode["KEY_SCROLL_LOCK"] = 145] = "KEY_SCROLL_LOCK";
    KeyCode[KeyCode["KEY_COMMA"] = 188] = "KEY_COMMA";
    KeyCode[KeyCode["KEY_PERIOD"] = 190] = "KEY_PERIOD";
    KeyCode[KeyCode["KEY_SLASH"] = 191] = "KEY_SLASH";
    KeyCode[KeyCode["KEY_BACK_QUOTE"] = 192] = "KEY_BACK_QUOTE";
    KeyCode[KeyCode["KEY_OPEN_BRACKET"] = 219] = "KEY_OPEN_BRACKET";
    KeyCode[KeyCode["KEY_BACK_SLASH"] = 220] = "KEY_BACK_SLASH";
    KeyCode[KeyCode["KEY_CLOSE_BRACKET"] = 221] = "KEY_CLOSE_BRACKET";
    KeyCode[KeyCode["KEY_QUOTE"] = 222] = "KEY_QUOTE";
    KeyCode[KeyCode["KEY_META"] = 224] = "KEY_META";
})(KeyCode || (KeyCode = {}));
var ppt;
(function (ppt) {
    let EventType;
    (function (EventType) {
        EventType[EventType["KEY_PRESS"] = 0] = "KEY_PRESS";
        EventType[EventType["KEY_RELEASE"] = 1] = "KEY_RELEASE";
        EventType[EventType["KEY_TYPED"] = 2] = "KEY_TYPED";
    })(EventType = ppt.EventType || (ppt.EventType = {}));
    let SpecialKey;
    (function (SpecialKey) {
        SpecialKey[SpecialKey["CTRL"] = 0] = "CTRL";
        SpecialKey[SpecialKey["WINDOWS"] = 1] = "WINDOWS";
        SpecialKey[SpecialKey["SHIFT"] = 2] = "SHIFT";
        SpecialKey[SpecialKey["ALT"] = 3] = "ALT";
    })(SpecialKey = ppt.SpecialKey || (ppt.SpecialKey = {}));
    function key_description(key) {
        let result = "";
        if (key.key_shift)
            result += " + " + (_translations.Q9VLf8do || (_translations.Q9VLf8do = tr("Shift")));
        if (key.key_alt)
            result += " + " + (_translations.cTr1XY6s || (_translations.cTr1XY6s = tr("Alt")));
        if (key.key_ctrl)
            result += " + " + (_translations.DIvQOyne || (_translations.DIvQOyne = tr("CTRL")));
        if (key.key_windows)
            result += " + " + (_translations.b0QTY_ci || (_translations.b0QTY_ci = tr("Win")));
        result += " + " + (key.key_code ? key.key_code : _translations.Q7dYnfxi || (_translations.Q7dYnfxi = tr("unset")));
        return result.substr(3);
    }
    ppt.key_description = key_description;
})(ppt || (ppt = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["2d49034738e89f669ffa9322659ac87731a542706c1a112481ff87ea19deed44"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["2d49034738e89f669ffa9322659ac87731a542706c1a112481ff87ea19deed44"] = "2d49034738e89f669ffa9322659ac87731a542706c1a112481ff87ea19deed44";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "EMgGRoo9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/bookmarks.ts (64,27)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var bookmarks;
(function (bookmarks_1) {
    function guid() {
        function s4() {
            return Math
                .floor((1 + Math.random()) * 0x10000)
                .toString(16)
                .substring(1);
        }
        return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
    }
    let BookmarkType;
    (function (BookmarkType) {
        BookmarkType[BookmarkType["ENTRY"] = 0] = "ENTRY";
        BookmarkType[BookmarkType["DIRECTORY"] = 1] = "DIRECTORY";
    })(BookmarkType = bookmarks_1.BookmarkType || (bookmarks_1.BookmarkType = {}));
    let _bookmark_config;
    function bookmark_config() {
        if (_bookmark_config)
            return _bookmark_config;
        let bookmark_json = localStorage.getItem("bookmarks");
        let bookmarks;
        try {
            bookmarks = JSON.parse(bookmark_json) || {};
        }
        catch (error) {
            console.error(_translations.EMgGRoo9 || (_translations.EMgGRoo9 = tr("Failed to load bookmarks: %o")), error);
            bookmarks = {};
        }
        _bookmark_config = bookmarks;
        _bookmark_config.root_bookmark = _bookmark_config.root_bookmark || { content: [], display_name: "root", type: BookmarkType.DIRECTORY };
        if (!_bookmark_config.default_added) {
            _bookmark_config.default_added = true;
            create_bookmark("TeaSpeak official Test-Server", _bookmark_config.root_bookmark, {
                server_address: "ts.teaspeak.de",
                server_port: 9987
            }, "Another TeaSpeak user");
            save_config();
        }
        return _bookmark_config;
    }
    function save_config() {
        localStorage.setItem("bookmarks", JSON.stringify(bookmark_config()));
    }
    function bookmarks() {
        return bookmark_config().root_bookmark;
    }
    bookmarks_1.bookmarks = bookmarks;
    function find_bookmark_recursive(parent, uuid) {
        for (const entry of parent.content) {
            if (entry.unique_id == uuid)
                return entry;
            if (entry.type == BookmarkType.DIRECTORY) {
                const result = find_bookmark_recursive(entry, uuid);
                if (result)
                    return result;
            }
        }
        return undefined;
    }
    function find_bookmark(uuid) {
        return find_bookmark_recursive(bookmarks(), uuid);
    }
    bookmarks_1.find_bookmark = find_bookmark;
    function parent_bookmark(bookmark) {
        const books = [bookmarks()];
        while (!books.length) {
            const directory = books.pop_front();
            if (directory.type == BookmarkType.DIRECTORY) {
                const cast = directory;
                if (cast.content.indexOf(bookmark) != -1)
                    return cast;
                books.push(...cast.content);
            }
        }
        return bookmarks();
    }
    bookmarks_1.parent_bookmark = parent_bookmark;
    function create_bookmark(display_name, directory, server_properties, nickname) {
        const bookmark = {
            display_name: display_name,
            server_properties: server_properties,
            nickname: nickname,
            type: BookmarkType.ENTRY,
            connect_profile: "default",
            unique_id: guid()
        };
        directory.content.push(bookmark);
        return bookmark;
    }
    bookmarks_1.create_bookmark = create_bookmark;
    function create_bookmark_directory(parent, name) {
        const bookmark = {
            type: BookmarkType.DIRECTORY,
            display_name: name,
            content: [],
            unique_id: guid()
        };
        parent.content.push(bookmark);
        return bookmark;
    }
    bookmarks_1.create_bookmark_directory = create_bookmark_directory;
    //TODO test if the new parent is within the old bookmark
    function change_directory(parent, bookmark) {
        delete_bookmark(bookmark);
        parent.content.push(bookmark);
    }
    bookmarks_1.change_directory = change_directory;
    function save_bookmark(bookmark) {
        save_config(); /* nvm we dont give a fuck... saving everything */
    }
    bookmarks_1.save_bookmark = save_bookmark;
    function delete_bookmark_recursive(parent, bookmark) {
        const index = parent.content.indexOf(bookmark);
        if (index != -1)
            parent.content.remove(bookmark);
        else
            for (const entry of parent.content)
                if (entry.type == BookmarkType.DIRECTORY)
                    delete_bookmark_recursive(entry, bookmark);
    }
    function delete_bookmark(bookmark) {
        delete_bookmark_recursive(bookmarks(), bookmark);
    }
    bookmarks_1.delete_bookmark = delete_bookmark;
})(bookmarks || (bookmarks = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["db009efb17dd345c53d960a26949372b62acbfd6427d950af2f9a2fb3f805ded"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["db009efb17dd345c53d960a26949372b62acbfd6427d950af2f9a2fb3f805ded"] = "db009efb17dd345c53d960a26949372b62acbfd6427d950af2f9a2fb3f805ded";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var dns;
(function (dns) {
    dns.default_options = {
        timeout: 5000,
        allow_cache: true,
        max_depth: 5,
        allow_a: true,
        allow_aaaa: true,
        allow_any: true,
        allow_cname: true,
        allow_srv: true
    };
    function supported() { return false; }
    dns.supported = supported;
    function resolve_address(address, options) {
        return Promise.reject("not supported");
    }
    dns.resolve_address = resolve_address;
    //TODO: Implement a remote server DNS request API
})(dns || (dns = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["0a04ed312537f7e8f94115c06e229c539ecf0af655a3be0176bf67e14d2e9ab0"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["0a04ed312537f7e8f94115c06e229c539ecf0af655a3be0176bf67e14d2e9ab0"] = "0a04ed312537f7e8f94115c06e229c539ecf0af655a3be0176bf67e14d2e9ab0";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "cgDPVPcu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (80,51)" }, { name: "neHZu7BZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (109,44)" }, { name: "SgoG2sZh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (255,23)" }, { name: "_o_sRXFZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (265,27)" }, { name: "Xweuv1hV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (273,23)" }, { name: "Yov2RzBn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (414,47)" }, { name: "fqjOt78e", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (422,49)" }, { name: "XQMGD4ya", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (423,48)" }, { name: "wsvcoiHP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (426,34)" }, { name: "MbH2rQt0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (431,48)" }, { name: "maZPjDuT", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (436,50)" }, { name: "OpK0TSHi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (437,48)" }, { name: "z5FVsQ5F", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (440,35)" }, { name: "CzRTyIte", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/frames/chat.ts (493,48)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var ChatType;
(function (ChatType) {
    ChatType[ChatType["GENERAL"] = 0] = "GENERAL";
    ChatType[ChatType["SERVER"] = 1] = "SERVER";
    ChatType[ChatType["CHANNEL"] = 2] = "CHANNEL";
    ChatType[ChatType["CLIENT"] = 3] = "CLIENT";
})(ChatType || (ChatType = {}));
var MessageHelper;
(function (MessageHelper) {
    function htmlEscape(message) {
        const div = document.createElement('div');
        div.innerText = message;
        message = div.innerHTML;
        return message.replace(/ /g, '&nbsp;').split(/<br>/);
    }
    MessageHelper.htmlEscape = htmlEscape;
    function formatElement(object, escape_html = true) {
        if ($.isArray(object)) {
            let result = [];
            for (let element of object)
                result.push(...formatElement(element, escape_html));
            return result;
        }
        else if (typeof (object) == "string") {
            if (object.length == 0)
                return [];
            return escape_html ?
                htmlEscape(object).map((entry, idx, array) => $.spawn("a").css("display", (idx == 0 || idx + 1 == array.length ? "inline" : "") + "block").html(entry == "" && idx != 0 ? "&nbsp;" : entry)) :
                [$.spawn("div").css("display", "inline-block").html(object)];
        }
        else if (typeof (object) === "object") {
            if (object instanceof $)
                return [object];
            return formatElement("<unknwon object>");
        }
        else if (typeof (object) === "function")
            return formatElement(object(), escape_html);
        else if (typeof (object) === "undefined")
            return formatElement("<undefined>");
        else if (typeof (object) === "number")
            return [$.spawn("a").text(object)];
        return formatElement("<unknown object type " + typeof object + ">");
    }
    MessageHelper.formatElement = formatElement;
    function formatMessage(pattern, ...objects) {
        let begin = 0, found = 0;
        let result = [];
        do {
            found = pattern.indexOf('{', found);
            if (found == -1 || pattern.length <= found + 1) {
                result.push(...formatElement(pattern.substr(begin)));
                break;
            }
            if (found > 0 && pattern[found - 1] == '\\') {
                //TODO remove the escape!
                found++;
                continue;
            }
            result.push(...formatElement(pattern.substr(begin, found - begin))); //Append the text
            let offset = 0;
            if (pattern[found + 1] == ':') {
                offset++; /* the beginning : */
                while (pattern[found + 1 + offset] != ':' && found + 1 + offset < pattern.length)
                    offset++;
                const tag = pattern.substr(found + 2, offset - 1);
                offset++; /* the ending : */
                if (pattern[found + offset + 1] != '}' && found + 1 + offset < pattern.length) {
                    found++;
                    continue;
                }
                result.push($.spawn(tag));
            }
            else {
                let number;
                while ("0123456789".includes(pattern[found + 1 + offset]))
                    offset++;
                number = parseInt(offset > 0 ? pattern.substr(found + 1, offset) : "0");
                if (pattern[found + offset + 1] != '}') {
                    found++;
                    continue;
                }
                if (objects.length < number)
                    log.warn(LogCategory.GENERAL, _translations.cgDPVPcu || (_translations.cgDPVPcu = tr("Message to format contains invalid index (%o)")), number);
                result.push(...formatElement(objects[number]));
            }
            found = found + 1 + offset;
            begin = found + 1;
        } while (found++);
        return result;
    }
    MessageHelper.formatMessage = formatMessage;
    function bbcode_chat(message) {
        let result = XBBCODE.process({
            text: message,
            escapeHtml: true,
            addInLineBreaks: false,
            /* TODO make this configurable and allow IMG */
            tag_whitelist: [
                "b",
                "i",
                "u",
                "color",
                "url"
            ]
        });
        if (result.error) {
            log.error(LogCategory.GENERAL, _translations.neHZu7BZ || (_translations.neHZu7BZ = tr("BBCode parse error: %o")), result.errorQueue);
            return formatElement(message);
        }
        return result.html.split("\n").map((entry, idx, array) => $.spawn("a").css("display", (idx == 0 ? "inline" : "") + "block").html(entry == "" && idx != 0 ? "&nbsp;" : entry));
    }
    MessageHelper.bbcode_chat = bbcode_chat;
})(MessageHelper || (MessageHelper = {}));
class ChatMessage {
    constructor(message) {
        this.date = new Date();
        this.message = message;
    }
    num(num) {
        let str = num.toString();
        while (str.length < 2)
            str = '0' + str;
        return str;
    }
    get html_tag() {
        if (this._html_tag)
            return this._html_tag;
        let tag = $.spawn("div");
        tag.addClass("message");
        let dateTag = $.spawn("div");
        dateTag.text("<" + this.num(this.date.getUTCHours()) + ":" + this.num(this.date.getUTCMinutes()) + ":" + this.num(this.date.getUTCSeconds()) + "> ");
        dateTag.css("margin-right", "4px");
        dateTag.css("color", "dodgerblue");
        this._html_tag = tag;
        tag.append(dateTag);
        this.message.forEach(e => e.appendTo(tag));
        return tag;
    }
}
class ChatEntry {
    constructor(handle, type, key) {
        this.history = [];
        this.send_history = [];
        this._flag_closeable = true;
        this._flag_unread = false;
        this._flag_offline = false;
        this.onClose = () => true;
        this.handle = handle;
        this.type = type;
        this.key = key;
        this._name = key;
    }
    appendError(message, ...args) {
        let entries = MessageHelper.formatMessage(message, ...args);
        entries.forEach(e => e.css("color", "red"));
        this.pushChatMessage(new ChatMessage(entries));
    }
    appendMessage(message, fmt = true, ...args) {
        this.pushChatMessage(new ChatMessage(MessageHelper.formatMessage(message, ...args)));
    }
    pushChatMessage(entry) {
        this.history.push(entry);
        while (this.history.length > 100) {
            let elm = this.history.pop_front();
            elm.html_tag.animate({ opacity: 0 }, 200, function () {
                $(this).detach();
            });
        }
        if (this.handle.activeChat === this) {
            let box = $(this.handle.htmlTag).find(".messages");
            let mbox = $(this.handle.htmlTag).find(".message_box");
            let bottom = box.scrollTop() + box.height() + 1 >= mbox.height();
            mbox.append(entry.html_tag);
            entry.html_tag.css("opacity", "0").animate({ opacity: 1 }, 100);
            if (bottom)
                box.scrollTop(mbox.height());
        }
        else {
            this.flag_unread = true;
        }
    }
    displayHistory() {
        this.flag_unread = false;
        let box = this.handle.htmlTag.find(".messages");
        let mbox = box.find(".message_box").detach(); /* detach the message box to improve performance */
        mbox.empty();
        for (let e of this.history) {
            mbox.append(e.html_tag);
            /* TODO Is this really totally useless?
                    Because its at least a performance bottleneck because is(...) recalculates the page style
                if(e.htmlTag.is(":hidden"))
                    e.htmlTag.show();
             */
        }
        mbox.appendTo(box);
        box.scrollTop(mbox.height());
    }
    get html_tag() {
        if (this._html_tag)
            return this._html_tag;
        let tag = $.spawn("div");
        tag.addClass("chat");
        if (this._flag_unread)
            tag.addClass('unread');
        if (this._flag_offline)
            tag.addClass('offline');
        if (this._flag_closeable)
            tag.addClass('closeable');
        tag.append($.spawn("div").addClass("chat-type icon " + this.chat_icon()));
        tag.append($.spawn("a").addClass("name").text(this._name));
        let tag_close = $.spawn("div");
        tag_close.addClass("btn_close icon client-tab_close_button");
        if (!this._flag_closeable)
            tag_close.hide();
        tag.append(tag_close);
        tag.click(() => { this.handle.activeChat = this; });
        tag.on("contextmenu", (e) => {
            e.preventDefault();
            let actions = [];
            actions.push({
                type: MenuEntryType.ENTRY,
                icon: "",
                name: _translations.SgoG2sZh || (_translations.SgoG2sZh = tr("Clear")),
                callback: () => {
                    this.history = [];
                    this.displayHistory();
                }
            });
            if (this.flag_closeable) {
                actions.push({
                    type: MenuEntryType.ENTRY,
                    icon: "client-tab_close_button",
                    name: _translations._o_sRXFZ || (_translations._o_sRXFZ = tr("Close")),
                    callback: () => this.handle.deleteChat(this)
                });
            }
            actions.push({
                type: MenuEntryType.ENTRY,
                icon: "client-tab_close_button",
                name: _translations.Xweuv1hV || (_translations.Xweuv1hV = tr("Close all private tabs")),
                callback: () => {
                    //TODO Implement this?
                },
                visible: false
            });
            spawn_context_menu(e.pageX, e.pageY, ...actions);
        });
        tag_close.click(() => {
            if ($.isFunction(this.onClose) && !this.onClose())
                return;
            this.handle.deleteChat(this);
        });
        return this._html_tag = tag;
    }
    focus() {
        this.handle.activeChat = this;
        this.handle.htmlTag.find(".input_box").focus();
    }
    set name(newName) {
        this._name = newName;
        this.html_tag.find(".name").text(this._name);
    }
    set flag_closeable(flag) {
        if (this._flag_closeable == flag)
            return;
        this._flag_closeable = flag;
        this.html_tag.toggleClass('closeable', flag);
    }
    set flag_unread(flag) {
        if (this._flag_unread == flag)
            return;
        this._flag_unread = flag;
        this.html_tag.find(".chat-type").attr("class", "chat-type icon " + this.chat_icon());
        this.html_tag.toggleClass('unread', flag);
    }
    get flag_offline() { return this._flag_offline; }
    set flag_offline(flag) {
        if (flag == this._flag_offline)
            return;
        this._flag_offline = flag;
        this.html_tag.toggleClass('offline', flag);
    }
    chat_icon() {
        if (this._flag_unread) {
            switch (this.type) {
                case ChatType.CLIENT:
                    return "client-new_chat";
            }
        }
        switch (this.type) {
            case ChatType.SERVER:
                return "client-server_log";
            case ChatType.CHANNEL:
                return "client-channel_chat";
            case ChatType.CLIENT:
                return "client-player_chat";
            case ChatType.GENERAL:
                return "client-channel_chat";
        }
        return "";
    }
}
class ChatBox {
    constructor(connection_handler) {
        this._history_index = 0;
        this.connection_handler = connection_handler;
    }
    initialize() {
        this.htmlTag = $("#tmpl_frame_chat").renderTag();
        this._button_send = this.htmlTag.find(".button-send");
        this._input_message = this.htmlTag.find(".input-message");
        this._button_send.click(this.onSend.bind(this));
        this._input_message.on('keypress', event => {
            if (!event.shiftKey) {
                console.log(event.keyCode);
                if (event.keyCode == KeyCode.KEY_RETURN) {
                    this.onSend();
                    return false;
                }
                else if (event.keyCode == KeyCode.KEY_UP || event.keyCode == KeyCode.KEY_DOWN) {
                    if (this._activeChat) {
                        const message = (this._input_message.val() || "").toString();
                        const history = this._activeChat.send_history;
                        if (history.length == 0 || this._history_index > history.length)
                            return;
                        if (message.replace(/[ \n\r\t]/, "").length == 0 || this._history_index == 0 || (this._history_index > 0 && message == this._activeChat.send_history[this._history_index - 1])) {
                            if (event.keyCode == KeyCode.KEY_UP)
                                this._history_index = Math.min(history.length, this._history_index + 1);
                            else
                                this._history_index = Math.max(0, this._history_index - 1);
                            if (this._history_index > 0)
                                this._input_message.val(this._activeChat.send_history[this._history_index - 1]);
                            else
                                this._input_message.val("");
                        }
                    }
                }
            }
        }).on('input', (event) => {
            let text = $(event.target).val().toString();
            if (this.testMessage(text))
                this._button_send.removeAttr("disabled");
            else
                this._button_send.attr("disabled", "true");
        }).trigger("input");
        this.chats = [];
        this._activeChat = undefined;
        this.createChat("chat_server", ChatType.SERVER).onMessageSend = (text) => {
            if (!this.connection_handler.serverConnection) {
                this.serverChat().appendError(_translations.Yov2RzBn || (_translations.Yov2RzBn = tr("Could not send chant message (Not connected)")));
                return;
            }
            this.connection_handler.serverConnection.command_helper.sendMessage(text, ChatType.SERVER).catch(error => {
                if (error instanceof CommandResult)
                    return;
                this.serverChat().appendMessage(_translations.fqjOt78e || (_translations.fqjOt78e = tr("Failed to send text message.")));
                log.error(LogCategory.GENERAL, _translations.XQMGD4ya || (_translations.XQMGD4ya = tr("Failed to send server text message: %o")), error);
            });
        };
        this.serverChat().name = _translations.wsvcoiHP || (_translations.wsvcoiHP = tr("Server chat"));
        this.serverChat().flag_closeable = false;
        this.createChat("chat_channel", ChatType.CHANNEL).onMessageSend = (text) => {
            if (!this.connection_handler.serverConnection) {
                this.channelChat().appendError(_translations.MbH2rQt0 || (_translations.MbH2rQt0 = tr("Could not send chant message (Not connected)")));
                return;
            }
            this.connection_handler.serverConnection.command_helper.sendMessage(text, ChatType.CHANNEL, this.connection_handler.getClient().currentChannel()).catch(error => {
                this.channelChat().appendMessage(_translations.maZPjDuT || (_translations.maZPjDuT = tr("Failed to send text message.")));
                log.error(LogCategory.GENERAL, _translations.OpK0TSHi || (_translations.OpK0TSHi = tr("Failed to send channel text message: %o")), error);
            });
        };
        this.channelChat().name = _translations.z5FVsQ5F || (_translations.z5FVsQ5F = tr("Channel chat"));
        this.channelChat().flag_closeable = false;
        this.connection_handler.permissions.initializedListener.push(flag => {
            if (flag)
                this.activeChat0(this._activeChat);
        });
    }
    createChat(key, type = ChatType.CLIENT) {
        let chat = new ChatEntry(this, type, key);
        this.chats.push(chat);
        this.htmlTag.find(".chats").append(chat.html_tag);
        if (!this._activeChat)
            this.activeChat = chat;
        return chat;
    }
    open_chats() {
        return this.chats;
    }
    findChat(key) {
        for (let e of this.chats)
            if (e.key == key)
                return e;
        return undefined;
    }
    deleteChat(chat) {
        this.chats.remove(chat);
        chat.html_tag.detach();
        if (this._activeChat === chat) {
            if (this.chats.length > 0)
                this.activeChat = this.chats.last();
            else
                this.activeChat = undefined;
        }
    }
    onSend() {
        let text = this._input_message.val().toString();
        if (!this.testMessage(text))
            return;
        this._input_message.val("");
        this._input_message.trigger("input");
        /* preprocessing text */
        const words = text.split(/[ \n]/);
        for (let index = 0; index < words.length; index++) {
            const flag_escaped = words[index].startsWith('!');
            const unescaped = flag_escaped ? words[index].substr(1) : words[index];
            _try: try {
                const url = new URL(unescaped);
                log.debug(LogCategory.GENERAL, _translations.CzRTyIte || (_translations.CzRTyIte = tr("Chat message contains URL: %o")), url);
                if (url.protocol !== 'http:' && url.protocol !== 'https:')
                    break _try;
                if (flag_escaped)
                    words[index] = unescaped;
                else {
                    text = undefined;
                    words[index] = "[url=" + url.toString() + "]" + url.toString() + "[/url]";
                }
            }
            catch (e) { /* word isn't an url */ }
            if (unescaped.match(ChatBox.URL_REGEX)) {
                if (flag_escaped)
                    words[index] = unescaped;
                else {
                    text = undefined;
                    words[index] = "[url=" + unescaped + "]" + unescaped + "[/url]";
                }
            }
        }
        text = text || words.join(" ");
        if (this._activeChat.send_history.length == 0 || this._activeChat.send_history[0] != text)
            this._activeChat.send_history.unshift(text);
        while (this._activeChat.send_history.length > 100)
            this._activeChat.send_history.pop();
        this._history_index = 0;
        if (this._activeChat && $.isFunction(this._activeChat.onMessageSend))
            this._activeChat.onMessageSend(text);
    }
    set activeChat(chat) {
        if (this.chats.indexOf(chat) === -1)
            return;
        if (this._activeChat == chat)
            return;
        this.activeChat0(chat);
    }
    activeChat0(chat) {
        this._activeChat = chat;
        for (let e of this.chats)
            e.html_tag.removeClass("active");
        let disable_input = !chat;
        if (this._activeChat) {
            this._activeChat.html_tag.addClass("active");
            this._activeChat.displayHistory();
            if (!disable_input && this.connection_handler && this.connection_handler.permissions && this.connection_handler.permissions.initialized())
                switch (this._activeChat.type) {
                    case ChatType.CLIENT:
                        disable_input = false;
                        break;
                    case ChatType.SERVER:
                        disable_input = !this.connection_handler.permissions.neededPermission(PermissionType.B_CLIENT_SERVER_TEXTMESSAGE_SEND).granted(1);
                        break;
                    case ChatType.CHANNEL:
                        disable_input = !this.connection_handler.permissions.neededPermission(PermissionType.B_CLIENT_CHANNEL_TEXTMESSAGE_SEND).granted(1);
                        break;
                }
        }
        this._input_message.prop("disabled", disable_input);
    }
    get activeChat() { return this._activeChat; }
    channelChat() {
        return this.findChat("chat_channel");
    }
    serverChat() {
        return this.findChat("chat_server");
    }
    focus() {
        this._input_message.focus();
    }
    testMessage(message) {
        message = message
            .replace(/ /gi, "")
            .replace(/<br>/gi, "")
            .replace(/\n/gi, "")
            .replace(/<br\/>/gi, "");
        return message.length > 0;
    }
}
//https://regex101.com/r/YQbfcX/2
//static readonly URL_REGEX = /^(?<hostname>([a-zA-Z0-9-]+\.)+[a-zA-Z0-9-]{2,63})(?:\/(?<path>(?:[^\s?]+)?)(?:\?(?<query>\S+))?)?$/gm;
ChatBox.URL_REGEX = /^(([a-zA-Z0-9-]+\.)+[a-zA-Z0-9-]{2,63})(?:\/((?:[^\s?]+)?)(?:\?(\S+))?)?$/gm;
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["9b68146576cee1df123d6a5159cf45f65bd453e76b8fd5ef5811532ca4437efa"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["9b68146576cee1df123d6a5159cf45f65bd453e76b8fd5ef5811532ca4437efa"] = "9b68146576cee1df123d6a5159cf45f65bd453e76b8fd5ef5811532ca4437efa";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
var Modals;
(function (Modals) {
    function spawnConnectModal(defaultHost = { url: "ts.TeaSpeak.de", enforce: false }, connect_profile) {
        let selected_profile;
        const random_id = (() => {
            const array = new Uint32Array(10);
            window.crypto.getRandomValues(array);
            return array.join("");
        })();
        const connect_modal = $("#tmpl_connect").renderTag({
            client: native_client,
            forum_path: settings.static("forum_path"),
            password_id: random_id,
            multi_tab: !settings.static_global(Settings.KEY_DISABLE_MULTI_SESSION, false)
        }).modalize((header, body, footer) => {
            const button_connect = footer.find(".button-connect");
            const button_connect_tab = footer.find(".button-connect-new-tab");
            const button_manage = body.find(".button-manage-profiles");
            const input_profile = body.find(".container-select-profile select");
            const input_address = body.find(".container-address input");
            const input_nickname = body.find(".container-nickname input");
            const input_password = body.find(".container-password input");
            let updateFields = function () {
                console.log("Updating");
                if (selected_profile)
                    input_nickname.attr("placeholder", selected_profile.default_username);
                else
                    input_nickname.attr("placeholder", "");
                let address = input_address.val().toString();
                settings.changeGlobal(Settings.KEY_CONNECT_ADDRESS, address);
                let flag_address = !!address.match(Modals.Regex.IP_V4) || !!address.match(Modals.Regex.DOMAIN);
                let nickname = input_nickname.val().toString();
                settings.changeGlobal(Settings.KEY_CONNECT_USERNAME, nickname);
                let flag_nickname = (nickname.length == 0 && selected_profile && selected_profile.default_username.length > 0) || nickname.length >= 3 && nickname.length <= 32;
                input_address.attr('pattern', flag_address ? null : '^[a]{1000}$').toggleClass('is-invalid', !flag_address);
                input_nickname.attr('pattern', flag_nickname ? null : '^[a]{1000}$').toggleClass('is-invalid', !flag_nickname);
                const flag_disabled = !flag_nickname || !flag_address || !selected_profile || !selected_profile.valid();
                button_connect.prop("disabled", flag_disabled);
                button_connect_tab.prop("disabled", flag_disabled);
            };
            input_address.val(defaultHost.enforce ? defaultHost.url : settings.static_global(Settings.KEY_CONNECT_ADDRESS, defaultHost.url));
            input_address
                .on("keyup", () => updateFields())
                .on('keydown', event => {
                if (event.keyCode == KeyCode.KEY_ENTER && !event.shiftKey)
                    button_connect.trigger('click');
            });
            button_manage.on('click', event => {
                const modal = Modals.spawnSettingsModal();
                setTimeout(() => {
                    modal.htmlTag.find(".tab-profiles").parent(".entry").trigger('click');
                }, 100);
                modal.close_listener.push(() => {
                    input_profile.trigger('change');
                });
                return true;
            });
            const last_nickname = settings.static_global(Settings.KEY_CONNECT_USERNAME, undefined);
            {
                for (const profile of profiles.profiles()) {
                    input_profile.append($.spawn("option").text(profile.profile_name).val(profile.id));
                }
                input_profile.on('change', event => {
                    selected_profile = profiles.find_profile(input_profile.val());
                    {
                        settings.changeGlobal(Settings.KEY_CONNECT_USERNAME, selected_profile.default_username);
                        input_nickname.val(selected_profile.default_username);
                    }
                    input_profile.toggleClass("is-invalid", !selected_profile || !selected_profile.valid());
                    updateFields();
                });
                input_profile.val(connect_profile && connect_profile.enforce ? connect_profile.profile.id : connect_profile && connect_profile.profile ? connect_profile.profile.id : 'default').trigger('change');
            }
            if (last_nickname) /* restore */
                settings.changeGlobal(Settings.KEY_CONNECT_USERNAME, last_nickname);
            input_nickname.val(last_nickname);
            input_nickname.on("keyup", () => updateFields());
            setTimeout(() => updateFields(), 100);
            button_connect.on('click', event => {
                connect_modal.close();
                const connection = server_connections.active_connection_handler();
                if (connection) {
                    connection.startConnection(input_address.val().toString(), selected_profile, {
                        nickname: input_nickname.val().toString() || selected_profile.default_username,
                        password: { password: input_password.val().toString(), hashed: false }
                    });
                }
                else {
                    button_connect_tab.trigger('click');
                }
            });
            button_connect_tab.on('click', event => {
                connect_modal.close();
                const connection = server_connections.spawn_server_connection_handler();
                server_connections.set_active_connection_handler(connection);
                connection.startConnection(input_address.val().toString(), selected_profile, {
                    nickname: input_nickname.val().toString() || selected_profile.default_username,
                    password: { password: input_password.val().toString(), hashed: false }
                });
            });
        }, {
            width: '70%'
        });
        connect_modal.open();
        return;
    }
    Modals.spawnConnectModal = spawnConnectModal;
    Modals.Regex = {
        //DOMAIN<:port>
        DOMAIN: /^(localhost|((([a-zA-Z0-9_-]{0,63}\.){0,253})?[a-zA-Z0-9_-]{0,63}\.[a-zA-Z]{2,64}))(|:(6553[0-5]|655[0-2][0-9]|65[0-4][0-9]{2}|6[0-4][0-9]{3}|[0-5]?[0-9]{1,46}))$/,
        //IP<:port>
        IP_V4: /(^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?))(|:(6553[0-5]|655[0-2][0-9]|65[0-4][0-9]{2}|6[0-4][0-9]{3}|[0-5]?[0-9]{1,4}))$/,
        IP_V6: /(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))/,
        IP: /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$|^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/,
    };
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["5d21d51e24a2f92ec6135955429996a48a48064d72bc8053c642c84ea4f5359d"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["5d21d51e24a2f92ec6135955429996a48a48064d72bc8053c642c84ea4f5359d"] = "5d21d51e24a2f92ec6135955429996a48a48064d72bc8053c642c84ea4f5359d";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "vb2B9RWq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanCreate.ts (8,46)" }, { name: "I655SsFU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanCreate.ts (8,63)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var Modals;
(function (Modals) {
    function spawnBanCreate(connection, base, callback) {
        let result = {};
        result.banid = base ? base.banid : 0;
        let modal;
        modal = createModal({
            header: base && base.banid > 0 ? _translations.vb2B9RWq || (_translations.vb2B9RWq = tr("Edit ban")) : _translations.I655SsFU || (_translations.I655SsFU = tr("Add ban")),
            body: () => {
                let template = $("#tmpl_ban_create").renderTag();
                const input_name = template.find(".input-name");
                const input_name_type = template.find(".input-name-type");
                const input_ip = template.find(".input-ip");
                const input_uid = template.find(".input-uid");
                const input_reason = template.find(".input-reason");
                const input_time = template.find(".input-time");
                const input_time_type = template.find(".input-time-unit");
                const input_hwid = template.find(".input-hwid");
                const input_global = template.find(".input-global");
                {
                    let maxTime = 0; //globalClient.permissions.neededPermission(PermissionType.I_CLIENT_BAN_MAX_BANTIME).value;
                    let unlimited = maxTime == 0 || maxTime == -1;
                    if (unlimited)
                        maxTime = 0;
                    input_time_type.find("option[value=\"sec\"]").prop("disabled", !unlimited && 1 > maxTime)
                        .attr("duration-scale", 1)
                        .attr("duration-max", maxTime);
                    input_time_type.find("option[value=\"min\"]").prop("disabled", !unlimited && 60 > maxTime)
                        .attr("duration-scale", 60)
                        .attr("duration-max", maxTime / 60);
                    input_time_type.find("option[value=\"hours\"]").prop("disabled", !unlimited && 60 * 60 > maxTime)
                        .attr("duration-scale", 60 * 60)
                        .attr("duration-max", maxTime / (60 * 60));
                    input_time_type.find("option[value=\"days\"]").prop("disabled", !unlimited && 60 * 60 * 24 > maxTime)
                        .attr("duration-scale", 60 * 60 * 24)
                        .attr("duration-max", maxTime / (60 * 60 * 24));
                    input_time_type.find("option[value=\"perm\"]").prop("disabled", !unlimited)
                        .attr("duration-scale", 0);
                    input_time_type.change(event => {
                        let element = $(event.target.selectedOptions.item(0));
                        if (element.val() !== "perm") {
                            input_time.prop("disabled", false);
                            let current = input_time.val();
                            let max = parseInt(element.attr("duration-max"));
                            if (max > 0 && current > max)
                                input_time.val(max);
                            else if (current <= 0)
                                input_time.val(1);
                            input_time.attr("max", max);
                        }
                        else {
                            input_time.prop("disabled", true);
                        }
                    });
                }
                template.find('input, textarea').on('keyup change', event => {
                    let valid = false;
                    if (input_name.val() || input_ip.val() || input_uid.val())
                        valid = true;
                    modal.htmlTag.find(".button-success").prop("disabled", !valid);
                });
                if (base) {
                    input_ip.val(base.ip);
                    input_uid.val(base.unique_id);
                    input_name.val(base.name);
                    input_hwid.val(base.hardware_id);
                    input_name_type[0].selectedIndex = base.name_type || 0;
                    input_reason.val(base.reason);
                    if (base.timestamp_expire.getTime() == 0) {
                        input_time_type.find("option[value=\"perm\"]").prop("selected", true);
                    }
                    else {
                        const time = (base.timestamp_expire.getTime() - base.timestamp_created.getTime()) / 1000;
                        if (time % (60 * 60 * 24) === 0) {
                            input_time_type.find("option[value=\"days\"]").prop("selected", true);
                            input_time.val(time / (60 * 60 * 24));
                        }
                        else if (time % (60 * 60) === 0) {
                            input_time_type.find("option[value=\"hours\"]").prop("selected", true);
                            input_time.val(time / (60 * 60));
                        }
                        else if (time % (60) === 0) {
                            input_time_type.find("option[value=\"min\"]").prop("selected", true);
                            input_time.val(time / (60));
                        }
                        else {
                            input_time_type.find("option[value=\"sec\"]").prop("selected", true);
                            input_time.val(time);
                        }
                    }
                    template.find(".container-global").detach(); //We cant edit this
                    input_global.prop("checked", base.server_id == 0);
                }
                if (connection && connection.permissions)
                    input_global.prop("disabled", !connection.permissions.neededPermission(base ? PermissionType.B_CLIENT_BAN_EDIT_GLOBAL : PermissionType.B_CLIENT_BAN_CREATE_GLOBAL));
                return template;
            },
            footer: undefined
        });
        modal.htmlTag.find(".button-close").on('click', () => modal.close());
        modal.htmlTag.find(".button-success").on('click', () => {
            {
                let length = modal.htmlTag.find(".input-time").val();
                let duration = modal.htmlTag.find(".input-time-unit option:selected");
                console.log(duration);
                console.log(length + "*" + duration.attr("duration-scale"));
                const time = length * parseInt(duration.attr("duration-scale"));
                if (!result.timestamp_created)
                    result.timestamp_created = new Date();
                if (time > 0)
                    result.timestamp_expire = new Date(result.timestamp_created.getTime() + time * 1000);
                else
                    result.timestamp_expire = new Date(0);
            }
            {
                result.name = modal.htmlTag.find(".input-name").val();
                {
                    const name_type = modal.htmlTag.find(".input-name-type");
                    result.name_type = name_type[0].selectedIndex;
                }
                result.ip = modal.htmlTag.find(".input-ip").val();
                result.unique_id = modal.htmlTag.find(".input-uid").val();
                result.reason = modal.htmlTag.find(".input-reason").val();
                result.hardware_id = modal.htmlTag.find(".input-hwid").val();
                result.server_id = modal.htmlTag.find(".input-global").prop("checked") ? 0 : -1;
            }
            modal.close();
            if (callback)
                callback(result);
        });
        modal.htmlTag.find("input").trigger("change");
        modal.open();
    }
    Modals.spawnBanCreate = spawnBanCreate;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["1dea15a652b4ec27da10d462194cdd450ba3319eb78315895ad0e45d72952cba"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["1dea15a652b4ec27da10d462194cdd450ba3319eb78315895ad0e45d72952cba"] = "1dea15a652b4ec27da10d462194cdd450ba3319eb78315895ad0e45d72952cba";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "AXFppQWm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBanClient.ts (15,24)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnBanClient(name, callback) {
        const connectModal = createModal({
            header: function () {
                return _translations.AXFppQWm || (_translations.AXFppQWm = tr("Ban client"));
            },
            body: function () {
                let tag = $("#tmpl_client_ban").renderTag({
                    client_name: $.isArray(name) ? '"' + name.join('", "') + '"' : name
                });
                let maxTime = 0; //globalClient.permissions.neededPermission(PermissionType.I_CLIENT_BAN_MAX_BANTIME).value;
                let unlimited = maxTime == 0 || maxTime == -1;
                if (unlimited)
                    maxTime = 0;
                let banTag = tag.find(".ban_duration_type");
                let durationTag = tag.find(".ban_duration");
                banTag.find("option[value=\"sec\"]").prop("disabled", !unlimited && 1 > maxTime)
                    .attr("duration-scale", 1)
                    .attr("duration-max", maxTime);
                banTag.find("option[value=\"min\"]").prop("disabled", !unlimited && 60 > maxTime)
                    .attr("duration-scale", 60)
                    .attr("duration-max", maxTime / 60);
                banTag.find("option[value=\"hours\"]").prop("disabled", !unlimited && 60 * 60 > maxTime)
                    .attr("duration-scale", 60 * 60)
                    .attr("duration-max", maxTime / (60 * 60));
                banTag.find("option[value=\"days\"]").prop("disabled", !unlimited && 60 * 60 * 24 > maxTime)
                    .attr("duration-scale", 60 * 60 * 24)
                    .attr("duration-max", maxTime / (60 * 60 * 24));
                banTag.find("option[value=\"perm\"]").prop("disabled", !unlimited)
                    .attr("duration-scale", 0);
                durationTag.change(() => banTag.trigger('change'));
                banTag.change(event => {
                    let element = $(event.target.selectedOptions.item(0));
                    if (element.val() !== "perm") {
                        durationTag.prop("disabled", false);
                        let current = durationTag.val();
                        let max = parseInt(element.attr("duration-max"));
                        if (max > 0 && current > max)
                            durationTag.val(max);
                        else if (current <= 0)
                            durationTag.val(1);
                        durationTag.attr("max", max);
                    }
                    else {
                        durationTag.prop("disabled", true);
                    }
                });
                return tag;
            },
            footer: function () {
                let tag = $.spawn("div");
                tag.css("text-align", "right");
                tag.css("margin-top", "3px");
                tag.css("margin-bottom", "6px");
                tag.addClass("modal-button-group");
                let buttonCancel = $.spawn("button");
                buttonCancel.text("Cancel");
                buttonCancel.on("click", () => connectModal.close());
                tag.append(buttonCancel);
                let buttonOk = $.spawn("button");
                buttonOk.text("OK").addClass("btn_success");
                tag.append(buttonOk);
                return tag;
            },
            width: 450
        });
        connectModal.open();
        connectModal.htmlTag.find(".btn_success").on('click', () => {
            connectModal.close();
            let length = connectModal.htmlTag.find(".ban_duration").val();
            let duration = connectModal.htmlTag.find(".ban_duration_type option:selected");
            console.log(duration);
            console.log(length + "*" + duration.attr("duration-scale"));
            callback({
                length: length * parseInt(duration.attr("duration-scale")),
                reason: connectModal.htmlTag.find(".ban_reason").val(),
                no_hwid: !connectModal.htmlTag.find(".ban-type-hardware-id").prop("checked"),
                no_ip: !connectModal.htmlTag.find(".ban-type-ip").prop("checked"),
                no_name: !connectModal.htmlTag.find(".ban-type-nickname").prop("checked")
            });
        });
    }
    Modals.spawnBanClient = spawnBanClient;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["8b657161de0389e7461335eb5fa0d2c6ede03792964b28f306c0aa95f3c9d6d0"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["8b657161de0389e7461335eb5fa0d2c6ede03792964b28f306c0aa95f3c9d6d0"] = "8b657161de0389e7461335eb5fa0d2c6ede03792964b28f306c0aa95f3c9d6d0";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "zH1VASlD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalYesNo.ts (12,69)" }, { name: "gxVYyIZV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalYesNo.ts (13,67)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
var Modals;
(function (Modals) {
    function spawnYesNo(header, body, callback, properties) {
        properties = properties || {};
        const props = ModalFunctions.warpProperties({});
        props.template_properties || (props.template_properties = {});
        props.template_properties.text_yes = properties.text_yes || (_translations.zH1VASlD || (_translations.zH1VASlD = tr("Yes")));
        props.template_properties.text_no = properties.text_no || (_translations.gxVYyIZV || (_translations.gxVYyIZV = tr("No")));
        props.template = "#tmpl_modal_yesno";
        props.header = header;
        props.template_properties.question = ModalFunctions.jqueriefy(body);
        const modal = createModal(props);
        let submited = false;
        const button_yes = modal.htmlTag.find(".button-yes");
        const button_no = modal.htmlTag.find(".button-no");
        button_yes.on('click', event => {
            if (!submited) {
                submited = true;
                callback(true);
            }
            modal.close();
        });
        button_no.on('click', event => {
            if (!submited) {
                submited = true;
                callback(false);
            }
            modal.close();
        });
        modal.close_listener.push(() => button_no.trigger('click'));
        modal.open();
        return modal;
    }
    Modals.spawnYesNo = spawnYesNo;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["57982bd12ba70f36deace6ed950191a7ddad5a1fbdc9c65773105c6b1144ecf6"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["57982bd12ba70f36deace6ed950191a7ddad5a1fbdc9c65773105c6b1144ecf6"] = "57982bd12ba70f36deace6ed950191a7ddad5a1fbdc9c65773105c6b1144ecf6";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "gKCN3029", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (97,23)" }, { name: "oC28EP4H", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (120,28)" }, { name: "_cSP6_SG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (127,22)" }, { name: "JN_62_aE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (139,21)" }, { name: "NsywXRQp", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (148,23)" }, { name: "iROcZg6O", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (149,30)" }, { name: "DeWyaZwI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (409,45)" }, { name: "lhFgh2eX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (411,35)" }, { name: "yL_4mPgz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (430,39)" }, { name: "E6lJ1e5l", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (435,43)" }, { name: "m8HBQ2d5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (447,55)" }, { name: "SJzXYWOF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (457,21)" }, { name: "G5XeX4J_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (466,43)" }, { name: "cDEdui4p", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (469,39)" }, { name: "NlAyCYR8", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (484,34)" }, { name: "wgIDn98w", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/main.ts (485,27)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="ui/frames/chat.ts" />
/// <reference path="ui/modal/ModalConnect.ts" />
/// <reference path="ui/modal/ModalCreateChannel.ts" />
/// <reference path="ui/modal/ModalBanCreate.ts" />
/// <reference path="ui/modal/ModalBanClient.ts" />
/// <reference path="ui/modal/ModalYesNo.ts" />
/// <reference path="ui/modal/ModalBanList.ts" />
/// <reference path="settings.ts" />
/// <reference path="log.ts" />
/// <reference path="PPTListener.ts" />
let settings;
const js_render = window.jsrender || $;
const native_client = window.require !== undefined;
function getUserMediaFunction() {
    if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia)
        return (settings, success, fail) => { navigator.mediaDevices.getUserMedia(settings).then(success).catch(fail); };
    return navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
}
function setup_close() {
    window.onbeforeunload = event => {
        if (profiles.requires_save())
            profiles.save();
        if (!settings.static(Settings.KEY_DISABLE_UNLOAD_DIALOG, false)) {
            const active_connections = server_connections.server_connection_handlers().filter(e => e.connected);
            if (active_connections.length == 0)
                return;
            if (!native_client) {
                event.returnValue = "Are you really sure?<br>You're still connected!";
            }
            else {
                if (window.open_connected_question) {
                    event.preventDefault();
                    event.returnValue = "question";
                    window.open_connected_question().then(result => {
                        if (result) {
                            window.onbeforeunload = undefined;
                            const { remote } = require('electron');
                            remote.getCurrentWindow().close();
                        }
                    });
                }
                else { /* we're in debugging mode */ }
            }
        }
    };
}
function setup_jsrender() {
    if (!js_render) {
        displayCriticalError("Missing jsrender extension!");
        return false;
    }
    if (!js_render.views) {
        displayCriticalError("Missing jsrender viewer extension!");
        return false;
    }
    js_render.views.settings.allowCode(true);
    js_render.views.tags("rnd", (argument) => {
        let min = parseInt(argument.substr(0, argument.indexOf('~')));
        let max = parseInt(argument.substr(argument.indexOf('~') + 1));
        return (Math.round(Math.random() * (min + max + 1) - min)).toString();
    });
    js_render.views.tags("fmt_date", (...args) => {
        return moment(args[0]).format(args[1]);
    });
    js_render.views.tags("tr", (...args) => {
        return tr(args[0]);
    });
    $(".jsrender-template").each((idx, _entry) => {
        if (!js_render.templates(_entry.id, _entry.innerHTML)) { //, _entry.innerHTML
            console.error("Failed to cache template " + _entry.id + " for js render!");
        }
        else
            console.debug("Successfully loaded jsrender template " + _entry.id);
    });
    return true;
}
function initialize() {
    return __awaiter(this, void 0, void 0, function* () {
        settings = new Settings();
        try {
            yield i18n.initialize();
        }
        catch (error) {
            console.error(_translations.gKCN3029 || (_translations.gKCN3029 = tr("Failed to initialized the translation system!\nError: %o")), error);
            displayCriticalError("Failed to setup the translation system");
            return;
        }
        bipc.setup();
    });
}
function initialize_app() {
    return __awaiter(this, void 0, void 0, function* () {
        const display_load_error = message => {
            if (typeof (display_critical_load) !== "undefined")
                display_critical_load(message);
            else
                displayCriticalError(message);
        };
        try { //Initialize main template
            const main = $("#tmpl_main").renderTag().dividerfy();
            $("body").append(main);
        }
        catch (error) {
            console.error(error);
            display_load_error(_translations.oC28EP4H || (_translations.oC28EP4H = tr("Failed to setup main page!")));
            return;
        }
        control_bar = new ControlBar($("#control_bar")); /* setup the control bar */
        if (!audio.player.initialize())
            console.warn(_translations._cSP6_SG || (_translations._cSP6_SG = tr("Failed to initialize audio controller!")));
        if (audio.player.set_master_volume)
            audio.player.set_master_volume(settings.global(Settings.KEY_SOUND_MASTER, 1) / 100);
        else
            console.warn("Client does not support audio.player.set_master_volume()... May client is too old?");
        if (audio.recorder.device_refresh_available())
            yield audio.recorder.refresh_devices();
        default_recorder = new RecorderProfile("default");
        yield default_recorder.initialize();
        sound.initialize().then(() => {
            console.log(_translations.JN_62_aE || (_translations.JN_62_aE = tr("Sounds initialitzed")));
        });
        sound.set_master_volume(settings.global(Settings.KEY_SOUND_MASTER_SOUNDS, 1) / 100);
        yield profiles.load();
        try {
            yield ppt.initialize();
        }
        catch (error) {
            console.error(_translations.NsywXRQp || (_translations.NsywXRQp = tr("Failed to initialize ppt!\nError: %o")), error);
            displayCriticalError(_translations.iROcZg6O || (_translations.iROcZg6O = tr("Failed to initialize ppt!")));
            return;
        }
        setup_close();
    });
}
function ab2str(buf) {
    return String.fromCharCode.apply(null, new Uint16Array(buf));
}
function str2ab8(str) {
    const buf = new ArrayBuffer(str.length);
    const bufView = new Uint8Array(buf);
    for (let i = 0, strLen = str.length; i < strLen; i++) {
        bufView[i] = str.charCodeAt(i);
    }
    return buf;
}
/* FIXME Dont use atob, because it sucks for non UTF-8 tings */
function arrayBufferBase64(base64) {
    base64 = atob(base64);
    const buf = new ArrayBuffer(base64.length);
    const bufView = new Uint8Array(buf);
    for (let i = 0, strLen = base64.length; i < strLen; i++) {
        bufView[i] = base64.charCodeAt(i);
    }
    return buf;
}
function base64ArrayBuffer(arrayBuffer) {
    var base64 = '';
    var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
    var bytes = new Uint8Array(arrayBuffer);
    var byteLength = bytes.byteLength;
    var byteRemainder = byteLength % 3;
    var mainLength = byteLength - byteRemainder;
    var a, b, c, d;
    var chunk;
    // Main loop deals with bytes in chunks of 3
    for (var i = 0; i < mainLength; i = i + 3) {
        // Combine the three bytes into a single integer
        chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];
        // Use bitmasks to extract 6-bit segments from the triplet
        a = (chunk & 16515072) >> 18; // 16515072 = (2^6 - 1) << 18
        b = (chunk & 258048) >> 12; // 258048   = (2^6 - 1) << 12
        c = (chunk & 4032) >> 6; // 4032     = (2^6 - 1) << 6
        d = chunk & 63; // 63       = 2^6 - 1
        // Convert the raw binary segments to the appropriate ASCII encoding
        base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d];
    }
    // Deal with the remaining bytes and padding
    if (byteRemainder == 1) {
        chunk = bytes[mainLength];
        a = (chunk & 252) >> 2; // 252 = (2^6 - 1) << 2
        // Set the 4 least significant bits to zero
        b = (chunk & 3) << 4; // 3   = 2^2 - 1
        base64 += encodings[a] + encodings[b] + '==';
    }
    else if (byteRemainder == 2) {
        chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1];
        a = (chunk & 64512) >> 10; // 64512 = (2^6 - 1) << 10
        b = (chunk & 1008) >> 4; // 1008  = (2^6 - 1) << 4
        // Set the 2 least significant bits to zero
        c = (chunk & 15) << 2; // 15    = 2^4 - 1
        base64 += encodings[a] + encodings[b] + encodings[c] + '=';
    }
    return base64;
}
function Base64EncodeUrl(str) {
    return str.replace(/\+/g, '-').replace(/\//g, '_').replace(/\=+$/, '');
}
function Base64DecodeUrl(str, pad) {
    if (typeof (pad) === 'undefined' || pad)
        str = (str + '===').slice(0, str.length + (str.length % 4));
    return str.replace(/-/g, '+').replace(/_/g, '/');
}
/*
class TestProxy extends bipc.MethodProxy {
    constructor(params: bipc.MethodProxyConnectParameters) {
        super(bipc.get_handler(), params.channel_id && params.client_id ? params : undefined);

        if(!this.is_slave()) {
            this.register_method(this.add_slave);
        }
        if(!this.is_master()) {
            this.register_method(this.say_hello);
            this.register_method(this.add_master);
        }
    }

    setup() {
        super.setup();
    }

    protected on_connected() {
        console.log("Test proxy connected");
    }

    protected on_disconnected() {
        console.log("Test proxy disconnected");
    }

    private async say_hello() : Promise<void> {
        console.log("Hello World");
    }

    private async add_slave(a: number, b: number) : Promise<number> {
        return a + b;
    }

    private async add_master(a: number, b: number) : Promise<number> {
        return a * b;
    }
}
interface Window {
    proxy_instance: TestProxy & {url: () => string};
}
*/
function main() {
    /*
    window.proxy_instance = new TestProxy({
        client_id: settings.static_global<string>("proxy_client_id", undefined),
        channel_id: settings.static_global<string>("proxy_channel_id", undefined)
    }) as any;
    if(window.proxy_instance.is_master()) {
        window.proxy_instance.setup();
        window.proxy_instance.url = () => {
            const data = window.proxy_instance.generate_connect_parameters();
            return "proxy_channel_id=" + data.channel_id + "&proxy_client_id=" + data.client_id;
        };
    }
    */
    //http://localhost:63343/Web-Client/index.php?_ijt=omcpmt8b9hnjlfguh8ajgrgolr&default_connect_url=true&default_connect_type=teamspeak&default_connect_url=localhost%3A9987&disableUnloadDialog=1&loader_ignore_age=1
    server_connections = new ServerConnectionManager($("#connection-handlers"));
    control_bar.initialise(); /* before connection handler to allow property apply */
    const initial_handler = server_connections.spawn_server_connection_handler();
    initial_handler.acquire_recorder(default_recorder, false);
    control_bar.set_connection_handler(initial_handler);
    /** Setup the XF forum identity **/
    profiles.identities.setup_forum();
    let _resize_timeout;
    $(window).on('resize', event => {
        if (event.target !== window)
            return;
        if (_resize_timeout)
            clearTimeout(_resize_timeout);
        _resize_timeout = setTimeout(() => {
            for (const connection of server_connections.server_connection_handlers())
                connection.invoke_resized_on_activate = true;
            const active_connection = server_connections.active_connection_handler();
            if (active_connection)
                active_connection.resize_elements();
            $(".window-resize-listener").trigger('resize');
        }, 1000);
    });
    stats.initialize({
        verbose: true,
        anonymize_ip_addresses: true,
        volatile_collection_only: false
    });
    stats.register_user_count_listener(status => {
        console.log("Received user count update: %o", status);
    });
    /*
    setTimeout(() => {
        Modals.spawnAvatarList(globalClient);
    }, 1000);
    */
    window.test_upload = (message) => {
        message = message || "Hello World";
        const connection = server_connections.active_connection_handler();
        connection.fileManager.upload_file({
            size: message.length,
            overwrite: true,
            channel: connection.getClient().currentChannel(),
            name: '/HelloWorld.txt',
            path: ''
        }).then(key => {
            console.log("Got key: %o", key);
            const upload = new RequestFileUpload(key);
            const buffer = new Uint8Array(message.length);
            {
                for (let index = 0; index < message.length; index++)
                    buffer[index] = message.charCodeAt(index);
            }
            upload.put_data(buffer).catch(error => {
                console.error(error);
            });
        });
    };
    server_connections.set_active_connection_handler(server_connections.server_connection_handlers()[0]);
    if (settings.static(Settings.KEY_FLAG_CONNECT_DEFAULT, false) && settings.static(Settings.KEY_CONNECT_ADDRESS, "")) {
        const profile_uuid = settings.static(Settings.KEY_CONNECT_PROFILE, (profiles.default_profile() || { id: 'default' }).id);
        console.log("UUID: %s", profile_uuid);
        const profile = profiles.find_profile(profile_uuid) || profiles.default_profile();
        const address = settings.static(Settings.KEY_CONNECT_ADDRESS, "");
        const username = settings.static(Settings.KEY_CONNECT_USERNAME, "Another TeaSpeak user");
        const password = settings.static(Settings.KEY_CONNECT_PASSWORD, "");
        const password_hashed = settings.static(Settings.KEY_FLAG_CONNECT_PASSWORD, false);
        if (profile && profile.valid()) {
            const connection = server_connections.active_connection_handler() || server_connections.spawn_server_connection_handler();
            connection.startConnection(address, profile, {
                nickname: username,
                password: password.length > 0 ? {
                    password: password,
                    hashed: password_hashed
                } : undefined
            });
        }
        else {
            Modals.spawnConnectModal({
                url: address,
                enforce: true
            }, {
                profile: profile,
                enforce: true
            });
        }
    }
}
const task_teaweb_starter = {
    name: "voice app starter",
    function: () => __awaiter(this, void 0, void 0, function* () {
        try {
            yield initialize_app();
            main();
            if (!audio.player.initialized()) {
                log.info(LogCategory.VOICE, _translations.DeWyaZwI || (_translations.DeWyaZwI = tr("Initialize audio controller later!")));
                if (!audio.player.initializeFromGesture) {
                    console.error(_translations.lhFgh2eX || (_translations.lhFgh2eX = tr("Missing audio.player.initializeFromGesture")));
                }
                else
                    $(document).one('click', event => audio.player.initializeFromGesture());
            }
        }
        catch (ex) {
            console.error(ex.stack);
            if (ex instanceof ReferenceError || ex instanceof TypeError)
                ex = ex.name + ": " + ex.message;
            displayCriticalError("Failed to invoke main function:<br>" + ex);
        }
    }),
    priority: 10
};
const task_certificate_callback = {
    name: "certificate accept tester",
    function: () => __awaiter(this, void 0, void 0, function* () {
        const certificate_accept = settings.static_global(Settings.KEY_CERTIFICATE_CALLBACK, undefined);
        if (certificate_accept) {
            log.info(LogCategory.IPC, _translations.yL_4mPgz || (_translations.yL_4mPgz = tr("Using this instance as certificate callback. ID: %s")), certificate_accept);
            try {
                try {
                    yield bipc.get_handler().post_certificate_accpected(certificate_accept);
                }
                catch (e) { } //FIXME remove!
                log.info(LogCategory.IPC, _translations.E6lJ1e5l || (_translations.E6lJ1e5l = tr("Other instance has acknowledged out work. Closing this window.")));
                const seconds_tag = $.spawn("a");
                let seconds = 5;
                let interval_id;
                interval_id = setInterval(() => {
                    seconds--;
                    seconds_tag.text(seconds.toString());
                    if (seconds <= 0) {
                        clearTimeout(interval_id);
                        log.info(LogCategory.GENERAL, _translations.m8HBQ2d5 || (_translations.m8HBQ2d5 = tr("Closing window")));
                        window.close();
                        return;
                    }
                }, 1000);
                const message = "You've successfully accepted the certificate.{:br:}" +
                    "This page will close in {0} seconds.";
                createInfoModal(_translations.SJzXYWOF || (_translations.SJzXYWOF = tr("Certificate acccepted successfully")), MessageHelper.formatMessage(tr(message), seconds_tag), {
                    closeable: false,
                    footer: undefined
                }).open();
                return;
            }
            catch (error) {
                log.warn(LogCategory.IPC, _translations.G5XeX4J_ || (_translations.G5XeX4J_ = tr("Failed to successfully post certificate accept status: %o")), error);
            }
        }
        else {
            log.info(LogCategory.IPC, _translations.cDEdui4p || (_translations.cDEdui4p = tr("We're not used to accept certificated. Booting app.")));
        }
        loader.register_task(loader.Stage.LOADED, task_teaweb_starter);
    }),
    priority: 10
};
loader.register_task(loader.Stage.JAVASCRIPT_INITIALIZING, {
    name: "jrendere initialize",
    function: () => __awaiter(this, void 0, void 0, function* () {
        try {
            if (!setup_jsrender())
                throw "invalid load";
        }
        catch (error) {
            displayCriticalError(_translations.NlAyCYR8 || (_translations.NlAyCYR8 = tr("Failed to setup jsrender")));
            console.error(_translations.wgIDn98w || (_translations.wgIDn98w = tr("Failed to load jsrender! %o")), error);
            return;
        }
    }),
    priority: 100
});
loader.register_task(loader.Stage.JAVASCRIPT_INITIALIZING, {
    name: "app starter",
    function: () => __awaiter(this, void 0, void 0, function* () {
        try {
            yield initialize();
            if (app.is_web()) {
                loader.register_task(loader.Stage.LOADED, task_certificate_callback);
            }
            else
                loader.register_task(loader.Stage.LOADED, task_teaweb_starter);
        }
        catch (ex) {
            if (ex instanceof Error || typeof (ex.stack) !== "undefined")
                console.error((tr || (msg => msg))("Critical error stack trace: %o"), ex.stack);
            if (ex instanceof ReferenceError || ex instanceof TypeError)
                ex = ex.name + ": " + ex.message;
            displayCriticalError("Failed to boot app function:<br>" + ex);
        }
    }),
    priority: 1000
});
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["9b7bcb12d9ea507fe80a01dd8ef11f5a719a7cb1ec16270714b76cdab8681da0"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["9b7bcb12d9ea507fe80a01dd8ef11f5a719a7cb1ec16270714b76cdab8681da0"] = "9b7bcb12d9ea507fe80a01dd8ef11f5a719a7cb1ec16270714b76cdab8681da0";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "eV9hAaEN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (76,38)" }, { name: "VypB3v5v", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (113,50)" }, { name: "CxiRw0QF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (123,50)" }, { name: "WjFBSHLR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (133,50)" }, { name: "vGnVh1zh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (144,55)" }, { name: "RDIYQezg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (173,42)" }, { name: "kWwJ7veM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (177,46)" }, { name: "peWBrMyz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (215,48)" }, { name: "SkSZPYWG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (218,43)" }, { name: "N0VoToP0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/stats.ts (234,46)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var stats;
(function (stats) {
    const LOG_PREFIX = "[Statistics] ";
    let CloseCodes;
    (function (CloseCodes) {
        CloseCodes[CloseCodes["UNSET"] = 3000] = "UNSET";
        CloseCodes[CloseCodes["RECONNECT"] = 3001] = "RECONNECT";
        CloseCodes[CloseCodes["INTERNAL_ERROR"] = 3002] = "INTERNAL_ERROR";
        CloseCodes[CloseCodes["BANNED"] = 3100] = "BANNED";
    })(CloseCodes = stats.CloseCodes || (stats.CloseCodes = {}));
    let ConnectionState;
    (function (ConnectionState) {
        ConnectionState[ConnectionState["CONNECTING"] = 0] = "CONNECTING";
        ConnectionState[ConnectionState["INITIALIZING"] = 1] = "INITIALIZING";
        ConnectionState[ConnectionState["CONNECTED"] = 2] = "CONNECTED";
        ConnectionState[ConnectionState["UNSET"] = 3] = "UNSET";
    })(ConnectionState || (ConnectionState = {}));
    class SessionConfig {
    }
    stats.SessionConfig = SessionConfig;
    class Config extends SessionConfig {
    }
    stats.Config = Config;
    let reconnect_timer;
    let current_config;
    let last_user_count_update;
    let user_count_listener = [];
    const DEFAULT_CONFIG = {
        verbose: true,
        reconnect_interval: 5000,
        anonymize_ip_addresses: true,
        volatile_collection_only: false
    };
    function initialize_config_object(target_object, source_object) {
        for (const key of Object.keys(source_object)) {
            if (typeof (source_object[key]) === 'object')
                initialize_config_object(target_object[key] || (target_object[key] = {}), source_object[key]);
            if (typeof (target_object[key]) !== 'undefined')
                continue;
            target_object[key] = source_object[key];
        }
        return target_object;
    }
    function initialize(config) {
        current_config = initialize_config_object(config || {}, DEFAULT_CONFIG);
        if (current_config.verbose)
            console.log(LOG_PREFIX + (_translations.eV9hAaEN || (_translations.eV9hAaEN = tr("Initializing statistics with this config: %o"))), current_config);
        connection.start_connection();
    }
    stats.initialize = initialize;
    function register_user_count_listener(listener) {
        user_count_listener.push(listener);
    }
    stats.register_user_count_listener = register_user_count_listener;
    function all_user_count_listener() {
        return user_count_listener;
    }
    stats.all_user_count_listener = all_user_count_listener;
    function deregister_user_count_listener(listener) {
        user_count_listener.remove(listener);
    }
    stats.deregister_user_count_listener = deregister_user_count_listener;
    let connection;
    (function (connection_3) {
        let connection;
        connection_3.connection_state = ConnectionState.UNSET;
        function start_connection() {
            cancel_reconnect();
            close_connection();
            connection_3.connection_state = ConnectionState.CONNECTING;
            connection = new WebSocket('wss://web-stats.teaspeak.de:27790');
            if (!connection)
                connection = new WebSocket('wss://localhost:27788');
            {
                const connection_copy = connection;
                connection.onclose = (event) => {
                    if (connection_copy !== connection)
                        return;
                    if (current_config.verbose)
                        console.log(LOG_PREFIX + (_translations.VypB3v5v || (_translations.VypB3v5v = tr("Lost connection to statistics server (Connection closed). Reason: %o. Event object: %o"))), CloseCodes[event.code] || event.code, event);
                    if (event.code != CloseCodes.BANNED)
                        invoke_reconnect();
                };
                connection.onopen = () => {
                    if (connection_copy !== connection)
                        return;
                    if (current_config.verbose)
                        console.log(LOG_PREFIX + (_translations.CxiRw0QF || (_translations.CxiRw0QF = tr("Successfully connected to server. Initializing session."))));
                    connection_3.connection_state = ConnectionState.INITIALIZING;
                    initialize_session();
                };
                connection.onerror = (event) => {
                    if (connection_copy !== connection)
                        return;
                    if (current_config.verbose)
                        console.log(LOG_PREFIX + (_translations.WjFBSHLR || (_translations.WjFBSHLR = tr("Received an error. Closing connection. Object: %o"))), event);
                    connection.close(CloseCodes.INTERNAL_ERROR);
                    invoke_reconnect();
                };
                connection.onmessage = (event) => {
                    if (connection_copy !== connection)
                        return;
                    if (typeof (event.data) !== 'string') {
                        if (current_config.verbose)
                            console.warn(LOG_PREFIX + (_translations.vGnVh1zh || (_translations.vGnVh1zh = tr("Received an message which isn't a string. Event object: %o"))), event);
                        return;
                    }
                    handle_message(event.data);
                };
            }
        }
        connection_3.start_connection = start_connection;
        function close_connection() {
            if (connection) {
                const connection_copy = connection;
                connection = undefined;
                try {
                    connection_copy.close(3001);
                }
                catch (_) { }
            }
        }
        connection_3.close_connection = close_connection;
        function invoke_reconnect() {
            close_connection();
            if (reconnect_timer) {
                clearTimeout(reconnect_timer);
                reconnect_timer = undefined;
            }
            if (current_config.verbose)
                console.log(LOG_PREFIX + (_translations.RDIYQezg || (_translations.RDIYQezg = tr("Scheduled reconnect in %dms"))), current_config.reconnect_interval);
            reconnect_timer = setTimeout(() => {
                if (current_config.verbose)
                    console.log(LOG_PREFIX + (_translations.kWwJ7veM || (_translations.kWwJ7veM = tr("Reconnecting"))));
                start_connection();
            }, current_config.reconnect_interval);
        }
        function cancel_reconnect() {
            if (reconnect_timer) {
                clearTimeout(reconnect_timer);
                reconnect_timer = undefined;
            }
        }
        connection_3.cancel_reconnect = cancel_reconnect;
        function send_message(type, data) {
            connection.send(JSON.stringify({
                type: type,
                data: data
            }));
        }
        function initialize_session() {
            const config_object = {};
            for (const key in SessionConfig) {
                if (SessionConfig.hasOwnProperty(key))
                    config_object[key] = current_config[key];
            }
            send_message('initialize', {
                config: config_object
            });
        }
        function handle_message(message) {
            const data_object = JSON.parse(message);
            const type = data_object.type;
            const data = data_object.data;
            if (typeof (handler[type]) === 'function') {
                if (current_config.verbose)
                    console.debug(LOG_PREFIX + (_translations.peWBrMyz || (_translations.peWBrMyz = tr("Handling message of type %s"))), type);
                handler[type](data);
            }
            else if (current_config.verbose) {
                console.warn(LOG_PREFIX + (_translations.SkSZPYWG || (_translations.SkSZPYWG = tr("Received message with an unknown type (%s). Dropping message. Full message: %o"))), type, data_object);
            }
        }
        let handler;
        (function (handler) {
            function handle_notify_user_count(data) {
                last_user_count_update = Date.now();
                for (const listener of [...user_count_listener])
                    listener(data);
            }
            function handle_notify_initialized(json) {
                if (current_config.verbose)
                    console.log(LOG_PREFIX + (_translations.N0VoToP0 || (_translations.N0VoToP0 = tr("Session successfully initialized."))));
                connection_3.connection_state = ConnectionState.CONNECTED;
            }
            handler["notifyinitialized"] = handle_notify_initialized;
            handler["notifyusercount"] = handle_notify_user_count;
        })(handler || (handler = {}));
    })(connection || (connection = {}));
})(stats || (stats = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["7c979c32e9d5f6c13ac1b6a7f9430e80811d7eb1a68dcac1ec4cd8e58017028e"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["7c979c32e9d5f6c13ac1b6a7f9430e80811d7eb1a68dcac1ec4cd8e58017028e"] = "7c979c32e9d5f6c13ac1b6a7f9430e80811d7eb1a68dcac1ec4cd8e58017028e";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["f45665cbd24b403c0800c8f87daae15b50962256e2aadd079564092111dbd02d"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["f45665cbd24b403c0800c8f87daae15b50962256e2aadd079564092111dbd02d"] = "f45665cbd24b403c0800c8f87daae15b50962256e2aadd079564092111dbd02d";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "LaqB8_8d", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (167,67)" }, { name: "YM2JYhkV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (199,63)" }, { name: "T3ky1um4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (218,67)" }, { name: "mQGjdB5E", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (249,63)" }, { name: "d0vzBDQ4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (263,63)" }, { name: "WvYCtobf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (286,63)" }, { name: "XsI1sY_J", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/CommandHelper.ts (307,63)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var connection;
(function (connection_4) {
    class CommandHelper extends connection_4.AbstractCommandHandler {
        constructor(connection) {
            super(connection);
            this._awaiters_unique_ids = {};
            this.volatile_handler_boss = false;
            this.ignore_consumed = true;
        }
        initialize() {
            this.connection.command_handler_boss().register_handler(this);
            /* notifyquerylist */
        }
        handle_command(command) {
            if (command.command == "notifyclientnamefromuid")
                this.handle_notifyclientnamefromuid(command.arguments);
            else
                return false;
            return true;
        }
        joinChannel(channel, password) {
            return this.connection.send_command("clientmove", {
                "clid": this.connection.client.getClientId(),
                "cid": channel.getChannelId(),
                "cpw": password || ""
            });
        }
        sendMessage(message, type, target) {
            if (type == ChatType.SERVER)
                return this.connection.send_command("sendtextmessage", { "targetmode": 3, "target": 0, "msg": message });
            else if (type == ChatType.CHANNEL)
                return this.connection.send_command("sendtextmessage", { "targetmode": 2, "target": target.getChannelId(), "msg": message });
            else if (type == ChatType.CLIENT)
                return this.connection.send_command("sendtextmessage", { "targetmode": 1, "target": target.clientId(), "msg": message });
        }
        updateClient(key, value) {
            let data = {};
            data[key] = value;
            return this.connection.send_command("clientupdate", data);
        }
        info_from_uid(..._unique_ids) {
            return __awaiter(this, void 0, void 0, function* () {
                const response = [];
                const request = [];
                const unique_ids = new Set(_unique_ids);
                const unique_id_resolvers = {};
                for (const unique_id of unique_ids) {
                    request.push({ 'cluid': unique_id });
                    (this._awaiters_unique_ids[unique_id] || (this._awaiters_unique_ids[unique_id] = []))
                        .push(unique_id_resolvers[unique_id] = info => response.push(info));
                }
                try {
                    yield this.connection.send_command("clientgetnamefromuid", request);
                }
                catch (error) {
                    if (error instanceof CommandResult && error.id == ErrorID.EMPTY_RESULT) {
                        /* nothing */
                    }
                    else {
                        throw error;
                    }
                }
                finally {
                    /* cleanup */
                    for (const unique_id of Object.keys(unique_id_resolvers))
                        (this._awaiters_unique_ids[unique_id] || []).remove(unique_id_resolvers[unique_id]);
                }
                return response;
            });
        }
        handle_notifyclientnamefromuid(json) {
            for (const entry of json) {
                const info = {
                    client_unique_id: entry["cluid"],
                    client_nickname: entry["clname"],
                    client_database_id: parseInt(entry["cldbid"])
                };
                const functions = this._awaiters_unique_ids[entry["cluid"]] || [];
                delete this._awaiters_unique_ids[entry["cluid"]];
                for (const fn of functions)
                    fn(info);
            }
        }
        request_query_list(server_id = undefined) {
            return new Promise((resolve, reject) => {
                const single_handler = {
                    command: "notifyquerylist",
                    function: command => {
                        const json = command.arguments;
                        const result = {};
                        result.flag_all = json[0]["flag_all"];
                        result.flag_own = json[0]["flag_own"];
                        result.queries = [];
                        for (const entry of json) {
                            const rentry = {};
                            rentry.bounded_server = entry["client_bounded_server"];
                            rentry.username = entry["client_login_name"];
                            rentry.unique_id = entry["client_unique_identifier"];
                            result.queries.push(rentry);
                        }
                        resolve(result);
                        return true;
                    }
                };
                this.handler_boss.register_single_handler(single_handler);
                let data = {};
                if (server_id !== undefined)
                    data["server_id"] = server_id;
                this.connection.send_command("querylist", data).catch(error => {
                    this.handler_boss.remove_single_handler(single_handler);
                    if (error instanceof CommandResult) {
                        if (error.id == ErrorID.EMPTY_RESULT) {
                            resolve(undefined);
                            return;
                        }
                    }
                    reject(error);
                });
            });
        }
        request_playlist_list() {
            return new Promise((resolve, reject) => {
                const single_handler = {
                    command: "notifyplaylistlist",
                    function: command => {
                        const json = command.arguments;
                        const result = [];
                        for (const entry of json) {
                            try {
                                result.push({
                                    playlist_id: parseInt(entry["playlist_id"]),
                                    playlist_bot_id: parseInt(entry["playlist_bot_id"]),
                                    playlist_title: entry["playlist_title"],
                                    playlist_type: parseInt(entry["playlist_type"]),
                                    playlist_owner_dbid: parseInt(entry["playlist_owner_dbid"]),
                                    playlist_owner_name: entry["playlist_owner_name"],
                                    needed_power_modify: parseInt(entry["needed_power_modify"]),
                                    needed_power_permission_modify: parseInt(entry["needed_power_permission_modify"]),
                                    needed_power_delete: parseInt(entry["needed_power_delete"]),
                                    needed_power_song_add: parseInt(entry["needed_power_song_add"]),
                                    needed_power_song_move: parseInt(entry["needed_power_song_move"]),
                                    needed_power_song_remove: parseInt(entry["needed_power_song_remove"])
                                });
                            }
                            catch (error) {
                                log.error(LogCategory.NETWORKING, _translations.LaqB8_8d || (_translations.LaqB8_8d = tr("Failed to parse playlist entry: %o")), error);
                            }
                        }
                        resolve(result);
                        return true;
                    }
                };
                this.handler_boss.register_single_handler(single_handler);
                this.connection.send_command("playlistlist").catch(error => {
                    this.handler_boss.remove_single_handler(single_handler);
                    if (error instanceof CommandResult) {
                        if (error.id == ErrorID.EMPTY_RESULT) {
                            resolve([]);
                            return;
                        }
                    }
                    reject(error);
                });
            });
        }
        request_playlist_songs(playlist_id) {
            return new Promise((resolve, reject) => {
                const single_handler = {
                    command: "notifyplaylistsonglist",
                    function: command => {
                        const json = command.arguments;
                        if (json[0]["playlist_id"] != playlist_id) {
                            log.error(LogCategory.NETWORKING, _translations.YM2JYhkV || (_translations.YM2JYhkV = tr("Received invalid notification for playlist songs")));
                            return false;
                        }
                        const result = [];
                        for (const entry of json) {
                            try {
                                result.push({
                                    song_id: parseInt(entry["song_id"]),
                                    song_invoker: entry["song_invoker"],
                                    song_previous_song_id: parseInt(entry["song_previous_song_id"]),
                                    song_url: entry["song_url"],
                                    song_url_loader: entry["song_url_loader"],
                                    song_loaded: entry["song_loaded"] == true || entry["song_loaded"] == "1",
                                    song_metadata: entry["song_metadata"]
                                });
                            }
                            catch (error) {
                                log.error(LogCategory.NETWORKING, _translations.T3ky1um4 || (_translations.T3ky1um4 = tr("Failed to parse playlist song entry: %o")), error);
                            }
                        }
                        resolve(result);
                        return true;
                    }
                };
                this.handler_boss.register_single_handler(single_handler);
                this.connection.send_command("playlistsonglist", { playlist_id: playlist_id }).catch(error => {
                    this.handler_boss.remove_single_handler(single_handler);
                    if (error instanceof CommandResult) {
                        if (error.id == ErrorID.EMPTY_RESULT) {
                            resolve([]);
                            return;
                        }
                    }
                    reject(error);
                });
            });
        }
        request_clients_by_server_group(group_id) {
            return __awaiter(this, void 0, void 0, function* () {
                //servergroupclientlist sgid=2
                //notifyservergroupclientlist sgid=6 cldbid=2 client_nickname=WolverinDEV client_unique_identifier=xxjnc14LmvTk+Lyrm8OOeo4tOqw=
                return new Promise((resolve, reject) => {
                    const single_handler = {
                        command: "notifyservergroupclientlist",
                        function: command => {
                            if (command.arguments[0]["sgid"] != group_id) {
                                log.error(LogCategory.NETWORKING, _translations.mQGjdB5E || (_translations.mQGjdB5E = tr("Received invalid notification for server group client list")));
                                return false;
                            }
                            try {
                                const result = [];
                                for (const entry of command.arguments)
                                    result.push({
                                        client_database_id: parseInt(entry["cldbid"]),
                                        client_nickname: entry["client_nickname"],
                                        client_unique_identifier: entry["client_unique_identifier"]
                                    });
                                resolve(result);
                            }
                            catch (error) {
                                log.error(LogCategory.NETWORKING, _translations.d0vzBDQ4 || (_translations.d0vzBDQ4 = tr("Failed to parse server group client list: %o")), error);
                                reject("failed to parse info");
                            }
                            return true;
                        }
                    };
                    this.handler_boss.register_single_handler(single_handler);
                    this.connection.send_command("servergroupclientlist", { sgid: group_id }).catch(error => {
                        this.handler_boss.remove_single_handler(single_handler);
                        reject(error);
                    });
                });
            });
        }
        request_playlist_info(playlist_id) {
            return new Promise((resolve, reject) => {
                const single_handler = {
                    command: "notifyplaylistinfo",
                    function: command => {
                        const json = command.arguments[0];
                        if (json["playlist_id"] != playlist_id) {
                            log.error(LogCategory.NETWORKING, _translations.WvYCtobf || (_translations.WvYCtobf = tr("Received invalid notification for playlist info")));
                            return;
                        }
                        try {
                            //resolve
                            resolve({
                                playlist_id: parseInt(json["playlist_id"]),
                                playlist_title: json["playlist_title"],
                                playlist_description: json["playlist_description"],
                                playlist_type: parseInt(json["playlist_type"]),
                                playlist_owner_dbid: parseInt(json["playlist_owner_dbid"]),
                                playlist_owner_name: json["playlist_owner_name"],
                                playlist_flag_delete_played: json["playlist_flag_delete_played"] == true || json["playlist_flag_delete_played"] == "1",
                                playlist_flag_finished: json["playlist_flag_finished"] == true || json["playlist_flag_finished"] == "1",
                                playlist_replay_mode: parseInt(json["playlist_replay_mode"]),
                                playlist_current_song_id: parseInt(json["playlist_current_song_id"]),
                            });
                        }
                        catch (error) {
                            log.error(LogCategory.NETWORKING, _translations.XsI1sY_J || (_translations.XsI1sY_J = tr("Failed to parse playlist info: %o")), error);
                            reject("failed to parse info");
                        }
                        return true;
                    }
                };
                this.handler_boss.register_single_handler(single_handler);
                this.connection.send_command("playlistinfo", { playlist_id: playlist_id }).catch(error => {
                    this.handler_boss.remove_single_handler(single_handler);
                    reject(error);
                });
            });
        }
        /**
         * @deprecated
         *  Its just a workaround for the query management.
         *  There is no garante that the whoami trick will work forever
         */
        current_virtual_server_id() {
            if (this._who_am_i)
                return Promise.resolve(parseInt(this._who_am_i["virtualserver_id"]));
            return new Promise((resolve, reject) => {
                const single_handler = {
                    function: command => {
                        if (command.command != "" && command.command.indexOf("=") == -1)
                            return false;
                        this._who_am_i = command.arguments[0];
                        resolve(parseInt(this._who_am_i["virtualserver_id"]));
                        return true;
                    }
                };
                this.handler_boss.register_single_handler(single_handler);
                this.connection.send_command("whoami").catch(error => {
                    this.handler_boss.remove_single_handler(single_handler);
                    reject(error);
                });
            });
        }
    }
    connection_4.CommandHelper = CommandHelper;
})(connection || (connection = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["1621d61ae4eb2a7dbf79a00eb76363cb18d8d3ccb7516104e844784241aebb1b"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["1621d61ae4eb2a7dbf79a00eb76363cb18d8d3ccb7516104e844784241aebb1b"] = "1621d61ae4eb2a7dbf79a00eb76363cb18d8d3ccb7516104e844784241aebb1b";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Z5qEiA9w", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/connection/HandshakeHandler.ts (75,39)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var connection;
(function (connection) {
    class HandshakeHandler {
        constructor(profile, parameters) {
            this.failed = false;
            this.profile = profile;
            this.parameters = parameters;
        }
        setConnection(con) {
            this.connection = con;
        }
        initialize() {
            this.handshake_handler = this.profile.spawn_identity_handshake_handler(this.connection);
            if (!this.handshake_handler) {
                this.handshake_failed("failed to create identity handler");
                return;
            }
            this.handshake_handler.register_callback((flag, message) => {
                if (flag)
                    this.handshake_finished();
                else
                    this.handshake_failed(message);
            });
        }
        get_identity_handler() {
            return this.handshake_handler;
        }
        startHandshake() {
            this.handshake_handler.start_handshake();
        }
        on_teamspeak() {
            const type = this.profile.selected_type();
            if (type == profiles.identities.IdentitifyType.TEAMSPEAK)
                this.handshake_finished();
            else {
                if (this.failed)
                    return;
                this.failed = true;
                this.connection.client.handleDisconnect(DisconnectReason.HANDSHAKE_TEAMSPEAK_REQUIRED);
            }
        }
        handshake_failed(message) {
            if (this.failed)
                return;
            this.failed = true;
            this.connection.client.handleDisconnect(DisconnectReason.HANDSHAKE_FAILED, message);
        }
        handshake_finished(version) {
            if (native_client && window["native"] && native.client_version && !version) {
                native.client_version()
                    .then(this.handshake_finished.bind(this))
                    .catch(error => {
                    console.error(_translations.Z5qEiA9w || (_translations.Z5qEiA9w = tr("Failed to get version:")));
                    console.error(error);
                    this.handshake_finished("?.?.?");
                });
                return;
            }
            const git_version = settings.static_global("version", "unknown");
            const browser_name = (navigator.browserSpecs || {})["name"] || " ";
            let data = {
                client_nickname: this.parameters.nickname || "Another TeaSpeak user",
                client_platform: (browser_name ? browser_name + " " : "") + navigator.platform,
                client_version: "TeaWeb " + git_version + " (" + navigator.userAgent + ")",
                client_version_sign: undefined,
                client_default_channel: (this.parameters.channel || {}).target,
                client_default_channel_password: (this.parameters.channel || {}).password,
                client_default_token: this.parameters.token,
                client_server_password: this.parameters.password ? this.parameters.password.password : undefined,
                client_browser_engine: navigator.product,
                client_input_hardware: this.connection.client.client_status.input_hardware,
                client_output_hardware: false,
                client_input_muted: this.connection.client.client_status.input_muted,
                client_output_muted: this.connection.client.client_status.output_muted,
            };
            //0.0.1 [Build: 1549713549]	Linux	7XvKmrk7uid2ixHFeERGqcC8vupeQqDypLtw2lY9slDNPojEv//F47UaDLG+TmVk4r6S0TseIKefzBpiRtLDAQ==
            if (version) {
                data.client_version = "TeaClient ";
                data.client_version += " " + version;
                const os = require("os");
                const arch_mapping = {
                    "x32": "32bit",
                    "x64": "64bit"
                };
                data.client_version += " " + (arch_mapping[os.arch()] || os.arch());
                const os_mapping = {
                    "win32": "Windows",
                    "linux": "Linux"
                };
                data.client_platform = (os_mapping[os.platform()] || os.platform());
            }
            /* required to keep compatibility */
            if (this.profile.selected_type() === profiles.identities.IdentitifyType.TEAMSPEAK) {
                data["client_key_offset"] = this.profile.selected_identity().hash_number;
            }
            this.connection.send_command("clientinit", data).catch(error => {
                if (error instanceof CommandResult) {
                    if (error.id == 1028) {
                        this.connection.client.handleDisconnect(DisconnectReason.SERVER_REQUIRES_PASSWORD);
                    }
                    else if (error.id == 783 || error.id == 519) {
                        error.extra_message = parseInt(error.extra_message) == NaN ? "8" : error.extra_message;
                        this.connection.client.handleDisconnect(DisconnectReason.IDENTITY_TOO_LOW, error);
                    }
                    else if (error.id == 3329) {
                        this.connection.client.handleDisconnect(DisconnectReason.HANDSHAKE_BANNED, error);
                    }
                    else {
                        this.connection.client.handleDisconnect(DisconnectReason.CLIENT_KICKED, error);
                    }
                }
                else
                    this.connection.disconnect();
            });
        }
    }
    connection.HandshakeHandler = HandshakeHandler;
})(connection || (connection = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["f8cf0f0bc977bde7260d697e2c4b6d1cb879d49fec3fdc9f69878b35175bb791"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["f8cf0f0bc977bde7260d697e2c4b6d1cb879d49fec3fdc9f69878b35175bb791"] = "f8cf0f0bc977bde7260d697e2c4b6d1cb879d49fec3fdc9f69878b35175bb791";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var ErrorID;
(function (ErrorID) {
    ErrorID[ErrorID["PERMISSION_ERROR"] = 2568] = "PERMISSION_ERROR";
    ErrorID[ErrorID["EMPTY_RESULT"] = 1281] = "EMPTY_RESULT";
    ErrorID[ErrorID["PLAYLIST_IS_IN_USE"] = 8451] = "PLAYLIST_IS_IN_USE";
    ErrorID[ErrorID["FILE_ALREADY_EXISTS"] = 2050] = "FILE_ALREADY_EXISTS";
})(ErrorID || (ErrorID = {}));
class CommandResult {
    constructor(json) {
        this.json = json;
        this.id = parseInt(json["id"]);
        this.message = json["msg"];
        this.extra_message = "";
        if (json["extra_msg"])
            this.extra_message = json["extra_msg"];
        this.success = this.id == 0;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["b0e3ba4186c9a379654f6f322d747e90f85a588c607876ea579136901a0d0be2"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["b0e3ba4186c9a379654f6f322d747e90f85a588c607876ea579136901a0d0be2"] = "b0e3ba4186c9a379654f6f322d747e90f85a588c607876ea579136901a0d0be2";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
// ASN.1 JavaScript decoder
// Copyright (c) 2008-2018 Lapo Luchini <lapo@lapo.it>
// Copyright (c) 2019-2019 Markus Hadenfeldt <git@teaspeak.de>
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
//
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
var asn1;
(function (asn1) {
    const ellipsis = "\u2026";
    function string_cut(str, len) {
        if (str.length > len)
            str = str.substring(0, len) + ellipsis;
        return str;
    }
    class Stream {
        constructor(data, position) {
            if (data instanceof Stream)
                this.data = data.data;
            else
                this.data = data;
            this.position = position;
        }
        length() {
            if (this.data instanceof ArrayBuffer)
                return this.data.byteLength;
            return this.data.length;
        }
        get(position) {
            if (position === undefined)
                position = this.position++;
            if (position >= this.length())
                throw 'Requesting byte offset ' + this.position + ' on a stream of length ' + this.length();
            return (typeof (this.data) === "string") ? this.data.charCodeAt(position) : this.data[position];
        }
        hexByte(byte) {
            return Stream.HEX_DIGITS.charAt((byte >> 4) & 0xF) + Stream.HEX_DIGITS.charAt(byte & 0xF);
        }
        parseStringISO(start, end) {
            let s = "";
            for (let i = start; i < end; ++i)
                s += String.fromCharCode(this.get(i));
            return s;
        }
        parseStringUTF(start, end) {
            let s = "";
            for (let i = start; i < end;) {
                let c = this.get(i++);
                if (c < 128)
                    s += String.fromCharCode(c);
                else if ((c > 191) && (c < 224))
                    s += String.fromCharCode(((c & 0x1F) << 6) | (this.get(i++) & 0x3F));
                else
                    s += String.fromCharCode(((c & 0x0F) << 12) | ((this.get(i++) & 0x3F) << 6) | (this.get(i++) & 0x3F));
            }
            return s;
        }
        parseStringBMP(start, end) {
            let str = "", hi, lo;
            for (let i = start; i < end;) {
                hi = this.get(i++);
                lo = this.get(i++);
                str += String.fromCharCode((hi << 8) | lo);
            }
            return str;
        }
        parseTime(start, end, shortYear) {
            let s = this.parseStringISO(start, end), m = (shortYear ? Stream.reTimeS : Stream.reTimeL).exec(s);
            if (!m)
                return "Unrecognized time: " + s;
            if (shortYear) {
                // to avoid querying the timer, use the fixed range [1970, 2069]
                // it will conform with ITU X.400 [-10, +40] sliding window until 2030
                //m[1] = +m[1];
                //m[1] += (parseInt(m[1]) < 70) ? 2000 : 1900;
                throw "fixme!";
            }
            s = m[1] + "-" + m[2] + "-" + m[3] + " " + m[4];
            if (m[5]) {
                s += ":" + m[5];
                if (m[6]) {
                    s += ":" + m[6];
                    if (m[7])
                        s += "." + m[7];
                }
            }
            if (m[8]) {
                s += " UTC";
                if (m[8] != 'Z') {
                    s += m[8];
                    if (m[9])
                        s += ":" + m[9];
                }
            }
            return s;
        }
        ;
        parseInteger(start, end) {
            let current = this.get(start);
            let negative = (current > 127);
            let padding = negative ? 255 : 0;
            let length;
            let descriptor;
            // skip unuseful bits (not allowed in DER)
            while (current == padding && ++start < end)
                current = this.get(start);
            length = end - start;
            if (length === 0)
                return negative ? '-1' : '0';
            // show bit length of huge integers
            if (length > 4) {
                descriptor = current;
                length <<= 3; /* calculate bit length */
                while (((descriptor ^ padding) & 0x80) == 0) {
                    descriptor <<= 1;
                    --length;
                }
                descriptor = "(" + length + " bit)\n";
            }
            // decode the integer
            if (negative)
                current = current - 256;
            let number = "";
            if (typeof (Int10) !== "undefined") {
                let n = new Int10(current);
                for (let i = start + 1; i < end; ++i)
                    n.mulAdd(256, this.get(i));
                number = n.toString();
            }
            else {
                let n = 0;
                for (let i = start + 1; i < end; ++i) {
                    n <<= 8;
                    n += this.get(i);
                }
                number = n.toString();
            }
            return descriptor + number;
        }
        ;
        isASCII(start, end) {
            for (let i = start; i < end; ++i) {
                const c = this.get(i);
                if (c < 32 || c > 176)
                    return false;
            }
            return true;
        }
        ;
        parseBitString(start, end, maxLength) {
            let unusedBit = this.get(start), lenBit = ((end - start - 1) << 3) - unusedBit, intro = "(" + lenBit + " bit)\n", s = "";
            for (let i = start + 1; i < end; ++i) {
                let b = this.get(i), skip = (i == end - 1) ? unusedBit : 0;
                for (let j = 7; j >= skip; --j)
                    s += (b >> j) & 1 ? "1" : "0";
                if (s.length > maxLength)
                    return intro + string_cut(s, maxLength);
            }
            return intro + s;
        }
        ;
        parseOctetString(start, end, maxLength) {
            if (this.isASCII(start, end))
                return string_cut(this.parseStringISO(start, end), maxLength);
            let len = end - start, s = "(" + len + " byte)\n";
            maxLength /= 2; // we work in bytes
            if (len > maxLength)
                end = start + maxLength;
            for (let i = start; i < end; ++i)
                s += this.hexByte(this.get(i));
            if (len > maxLength)
                s += ellipsis;
            return s;
        }
        ;
        parseOID(start, end, maxLength) {
            let s = '', n = new Int10(), bits = 0;
            for (let i = start; i < end; ++i) {
                let v = this.get(i);
                n.mulAdd(128, v & 0x7F);
                bits += 7;
                if (!(v & 0x80)) { // finished
                    if (s === '') {
                        n = n.simplify();
                        if (n instanceof Int10) {
                            n.sub(80);
                            s = "2." + n.toString();
                        }
                        else {
                            let m = n < 80 ? n < 40 ? 0 : 1 : 2;
                            s = m + "." + (n - m * 40);
                        }
                    }
                    else
                        s += "." + n.toString();
                    if (s.length > maxLength)
                        return string_cut(s, maxLength);
                    n = new Int10();
                    bits = 0;
                }
            }
            if (bits > 0)
                s += ".incomplete";
            /* FIXME
            if (typeof oids === 'object') {
                let oid = oids[s];
                if (oid) {
                    if (oid.d) s += "\n" + oid.d;
                    if (oid.c) s += "\n" + oid.c;
                    if (oid.w) s += "\n(warning!)";
                }
            }
            */
            return s;
        }
        ;
    }
    Stream.HEX_DIGITS = "0123456789ABCDEF";
    Stream.reTimeS = /^(\d\d)(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])([01]\d|2[0-3])(?:([0-5]\d)(?:([0-5]\d)(?:[.,](\d{1,3}))?)?)?(Z|[-+](?:[0]\d|1[0-2])([0-5]\d)?)?$/;
    Stream.reTimeL = /^(\d\d\d\d)(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])([01]\d|2[0-3])(?:([0-5]\d)(?:([0-5]\d)(?:[.,](\d{1,3}))?)?)?(Z|[-+](?:[0]\d|1[0-2])([0-5]\d)?)?$/;
    asn1.Stream = Stream;
    let TagClass;
    (function (TagClass) {
        TagClass[TagClass["UNIVERSAL"] = 0] = "UNIVERSAL";
        TagClass[TagClass["APPLICATION"] = 1] = "APPLICATION";
        TagClass[TagClass["CONTEXT"] = 2] = "CONTEXT";
        TagClass[TagClass["PRIVATE"] = 3] = "PRIVATE";
    })(TagClass = asn1.TagClass || (asn1.TagClass = {}));
    let TagType;
    (function (TagType) {
        TagType[TagType["EOC"] = 0] = "EOC";
        TagType[TagType["BOOLEAN"] = 1] = "BOOLEAN";
        TagType[TagType["INTEGER"] = 2] = "INTEGER";
        TagType[TagType["BIT_STRING"] = 3] = "BIT_STRING";
        TagType[TagType["OCTET_STRING"] = 4] = "OCTET_STRING";
        TagType[TagType["NULL"] = 5] = "NULL";
        TagType[TagType["OBJECT_IDENTIFIER"] = 6] = "OBJECT_IDENTIFIER";
        TagType[TagType["ObjectDescriptor"] = 7] = "ObjectDescriptor";
        TagType[TagType["EXTERNAL"] = 8] = "EXTERNAL";
        TagType[TagType["REAL"] = 9] = "REAL";
        TagType[TagType["ENUMERATED"] = 10] = "ENUMERATED";
        TagType[TagType["EMBEDDED_PDV"] = 11] = "EMBEDDED_PDV";
        TagType[TagType["UTF8String"] = 12] = "UTF8String";
        TagType[TagType["SEQUENCE"] = 16] = "SEQUENCE";
        TagType[TagType["SET"] = 17] = "SET";
        TagType[TagType["NumericString"] = 18] = "NumericString";
        TagType[TagType["PrintableString"] = 19] = "PrintableString";
        TagType[TagType["TeletextString"] = 20] = "TeletextString";
        TagType[TagType["VideotexString"] = 21] = "VideotexString";
        TagType[TagType["IA5String"] = 22] = "IA5String";
        TagType[TagType["UTCTime"] = 23] = "UTCTime";
        TagType[TagType["GeneralizedTime"] = 24] = "GeneralizedTime";
        TagType[TagType["GraphicString"] = 25] = "GraphicString";
        TagType[TagType["VisibleString"] = 26] = "VisibleString";
        TagType[TagType["GeneralString"] = 27] = "GeneralString";
        TagType[TagType["UniversalString"] = 28] = "UniversalString";
        TagType[TagType["BMPString"] = 30] = "BMPString";
    })(TagType = asn1.TagType || (asn1.TagType = {}));
    class ASN1Tag {
        constructor(stream) {
            let buf = stream.get();
            this.tagClass = buf >> 6;
            this.tagConstructed = ((buf & 0x20) !== 0);
            this.tagNumber = buf & 0x1F;
            if (this.tagNumber == 0x1F) { // long tag
                let n = new Int10();
                do {
                    buf = stream.get();
                    n.mulAdd(128, buf & 0x7F);
                } while (buf & 0x80);
                this.tagNumber = n.simplify();
            }
        }
        isUniversal() {
            return this.tagClass === 0x00;
        }
        ;
        isEOC() {
            return this.tagClass === 0x00 && this.tagNumber === 0x00;
        }
        ;
    }
    class ASN1 {
        constructor(stream, header, length, tag, children) {
            this.stream = stream;
            this.header = header;
            this.length = length;
            this.tag = tag;
            this.children = children;
        }
        content(max_length, type) {
            if (this.tag === undefined)
                return null;
            if (max_length === undefined)
                max_length = Infinity;
            let content = this.posContent(), len = Math.abs(this.length);
            if (!this.tag.isUniversal()) {
                if (this.children !== null)
                    return "(" + this.children.length + " elem)";
                return this.stream.parseOctetString(content, content + len, max_length);
            }
            switch (type || this.tag.tagNumber) {
                case 0x01: // BOOLEAN
                    return (this.stream.get(content) === 0) ? "false" : "true";
                case 0x02: // INTEGER
                    return this.stream.parseInteger(content, content + len);
                case 0x03: // BIT_STRING
                    return this.children ? "(" + this.children.length + " elem)" :
                        this.stream.parseBitString(content, content + len, max_length);
                case 0x04: // OCTET_STRING
                    return this.children ? "(" + this.children.length + " elem)" :
                        this.stream.parseOctetString(content, content + len, max_length);
                //case 0x05: // NULL
                case 0x06: // OBJECT_IDENTIFIER
                    return this.stream.parseOID(content, content + len, max_length);
                //case 0x07: // ObjectDescriptor
                //case 0x08: // EXTERNAL
                //case 0x09: // REAL
                //case 0x0A: // ENUMERATED
                //case 0x0B: // EMBEDDED_PDV
                case 0x10: // SEQUENCE
                case 0x11: // SET
                    if (this.children !== null)
                        return "(" + this.children.length + " elem)";
                    else
                        return "(no elem)";
                case 0x0C: // UTF8String
                    return string_cut(this.stream.parseStringUTF(content, content + len), max_length);
                case 0x12: // NumericString
                case 0x13: // PrintableString
                case 0x14: // TeletexString
                case 0x15: // VideotexString
                case 0x16: // IA5String
                //case 0x19: // GraphicString
                case 0x1A: // VisibleString
                    //case 0x1B: // GeneralString
                    //case 0x1C: // UniversalString
                    return string_cut(this.stream.parseStringISO(content, content + len), max_length);
                case 0x1E: // BMPString
                    return string_cut(this.stream.parseStringBMP(content, content + len), max_length);
                case 0x17: // UTCTime
                case 0x18: // GeneralizedTime
                    return this.stream.parseTime(content, content + len, (this.tag.tagNumber == 0x17));
            }
            return null;
        }
        ;
        typeName() {
            switch (this.tag.tagClass) {
                case 0: // universal
                    return TagType[this.tag.tagNumber] || ("Universal_" + this.tag.tagNumber.toString());
                case 1:
                    return "Application_" + this.tag.tagNumber.toString();
                case 2:
                    return "[" + this.tag.tagNumber.toString() + "]"; // Context
                case 3:
                    return "Private_" + this.tag.tagNumber.toString();
            }
        }
        ;
        toString() {
            return this.typeName() + "@" + this.stream.position + "[header:" + this.header + ",length:" + this.length + ",sub:" + ((this.children === null) ? 'null' : this.children.length) + "]";
        }
        toPrettyString(indent) {
            if (indent === undefined)
                indent = '';
            let s = indent + this.typeName() + " @" + this.stream.position;
            if (this.length >= 0)
                s += "+";
            s += this.length;
            if (this.tag.tagConstructed)
                s += " (constructed)";
            else if ((this.tag.isUniversal() && ((this.tag.tagNumber == 0x03) || (this.tag.tagNumber == 0x04))) && (this.children !== null))
                s += " (encapsulates)";
            let content = this.content();
            if (content)
                s += ": " + content.replace(/\n/g, '|');
            s += "\n";
            if (this.children !== null) {
                indent += '  ';
                for (let i = 0, max = this.children.length; i < max; ++i)
                    s += this.children[i].toPrettyString(indent);
            }
            return s;
        }
        ;
        posStart() {
            return this.stream.position;
        }
        ;
        posContent() {
            return this.stream.position + this.header;
        }
        ;
        posEnd() {
            return this.stream.position + this.header + Math.abs(this.length);
        }
        ;
        static decodeLength(stream) {
            let buf = stream.get();
            const len = buf & 0x7F;
            if (len == buf)
                return len;
            if (len > 6) // no reason to use Int10, as it would be a huge buffer anyways
                throw "Length over 48 bits not supported at position " + (stream.position - 1);
            if (len === 0)
                return null; // undefined
            buf = 0;
            for (let i = 0; i < len; ++i)
                buf = (buf << 8) + stream.get();
            return buf;
        }
        ;
        static encodeLength(buffer, offset, length) {
            if (length < 0x7F) {
                buffer[offset] = length;
            }
            else {
                buffer[offset] = 0x80;
                let index = 1;
                while (length > 0) {
                    buffer[offset + index++] = length & 0xFF;
                    length >>= 8;
                    buffer[offset] += 1;
                }
            }
        }
    }
    asn1.ASN1 = ASN1;
    function decode0(stream) {
        const streamStart = new Stream(stream, 0); /* copy */
        const tag = new ASN1Tag(stream);
        let len = ASN1.decodeLength(stream);
        const start = stream.position;
        const length_header = start - streamStart.position;
        let children = null;
        const query_children = () => {
            children = [];
            if (len !== null) {
                const end = start + len;
                if (end > stream.length())
                    throw 'Container at offset ' + start + ' has a length of ' + len + ', which is past the end of the stream';
                while (stream.position < end)
                    children[children.length] = decode0(stream);
                if (stream.position != end)
                    throw 'Content size is not correct for container at offset ' + start;
            }
            else {
                // undefined length
                try {
                    while (true) {
                        const s = decode0(stream);
                        if (s.tag.isEOC())
                            break;
                        children[children.length] = s;
                    }
                    len = start - stream.position; // undefined lengths are represented as negative values
                }
                catch (e) {
                    throw 'Exception while decoding undefined length content at offset ' + start + ': ' + e;
                }
            }
        };
        if (tag.tagConstructed) {
            // must have valid content
            query_children();
        }
        else if (tag.isUniversal() && ((tag.tagNumber == 0x03) || (tag.tagNumber == 0x04))) {
            // sometimes BitString and OctetString are used to encapsulate ASN.1
            try {
                if (tag.tagNumber == 0x03)
                    if (stream.get() != 0)
                        throw "BIT STRINGs with unused bits cannot encapsulate.";
                query_children();
                for (let i = 0; i < children.length; ++i)
                    if (children[i].tag.isEOC())
                        throw 'EOC is not supposed to be actual content.';
            }
            catch (e) {
                // but silently ignore when they don't
                children = null;
                //DEBUG console.log('Could not decode structure at ' + start + ':', e);
            }
        }
        if (children === null) {
            if (len === null)
                throw "We can't skip over an invalid tag with undefined length at offset " + start;
            stream.position = start + Math.abs(len);
        }
        return new ASN1(streamStart, length_header, len, tag, children);
    }
    function decode(stream) {
        return decode0(new Stream(stream, 0));
    }
    asn1.decode = decode;
})(asn1 || (asn1 = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["0619eace94c6c189a2abd0ae9f5a4c1c715817c1c692814398ce192ca9007038"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["0619eace94c6c189a2abd0ae9f5a4c1c715817c1c692814398ce192ca9007038"] = "0619eace94c6c189a2abd0ae9f5a4c1c715817c1c692814398ce192ca9007038";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
class Crc32 {
    constructor() {
        this.crc = -1 >>> 0;
    }
    update(data) {
        const dataView = new Uint8Array(data, 0);
        const len = dataView.length;
        for (let i = 0; i < len; i++) {
            this.crc = (this.crc >>> 8) ^ Crc32.lookup[(this.crc ^ dataView[i]) & 0xFF];
        }
    }
    ;
    digest(radix) {
        const buffer = new ArrayBuffer(4);
        const dv = new DataView(buffer);
        dv.setUint32(0, ~this.crc >>> 0, false);
        return dv.getUint32(0).toString(radix || 16);
    }
    ;
}
Crc32.lookup = [
    0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
    0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
    0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
    0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,
    0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
    0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
    0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
    0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,
    0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
    0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
    0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
    0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,
    0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
    0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
    0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
    0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,
    0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
    0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
    0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
    0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,
    0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
    0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
    0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
    0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,
    0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
    0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
    0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
    0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,
    0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
    0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
    0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
    0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,
    0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
    0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
    0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
    0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,
    0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
    0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
    0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
    0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,
    0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
    0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
    0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
    0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,
    0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
    0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
    0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
    0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,
    0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
    0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
    0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
    0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,
    0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
    0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
    0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
    0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,
    0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
    0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
    0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
    0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
    0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
    0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
    0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
    0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D
];
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["89c87838331c81b2d9826971aedf9f16f96ae2e1f4dfe0d583aa5bd01ca108fd"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["89c87838331c81b2d9826971aedf9f16f96ae2e1f4dfe0d583aa5bd01ca108fd"] = "89c87838331c81b2d9826971aedf9f16f96ae2e1f4dfe0d583aa5bd01ca108fd";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var hex;
(function (hex) {
    function encode(buffer) {
        let hexCodes = [];
        let view = new DataView(buffer);
        for (let i = 0; i < view.byteLength % 4; i++) {
            let value = view.getUint32(i * 4);
            let stringValue = value.toString(16);
            let padding = '00000000';
            let paddedValue = (padding + stringValue).slice(-padding.length);
            hexCodes.push(paddedValue);
        }
        for (let i = (view.byteLength % 4) * 4; i < view.byteLength; i++) {
            let value = view.getUint8(i).toString(16);
            let padding = '00';
            hexCodes.push((padding + value).slice(-padding.length));
        }
        return hexCodes.join("");
    }
    hex.encode = encode;
})(hex || (hex = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["df93665029bf23a837faf70378f7f9e065a38daf9b869d031e6c3c9aed2023ac"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["df93665029bf23a837faf70378f7f9e065a38daf9b869d031e6c3c9aed2023ac"] = "df93665029bf23a837faf70378f7f9e065a38daf9b869d031e6c3c9aed2023ac";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "HRyMZlYA", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/country.ts (1498,77)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var i18n;
(function (i18n) {
    const country_infos = [];
    const alpha_2_map = {};
    const fill_country_infos = (array) => {
        array.push({
            name: "Afghanistan",
            alpha_2: "AF",
            alpha_3: "AFG",
            un_code: 4
        });
        array.push({
            name: "Aland Islands",
            alpha_2: "AX",
            alpha_3: "ALA",
            un_code: 248
        });
        array.push({
            name: "Albania",
            alpha_2: "AL",
            alpha_3: "ALB",
            un_code: 8
        });
        array.push({
            name: "Algeria",
            alpha_2: "DZ",
            alpha_3: "DZA",
            un_code: 12
        });
        array.push({
            name: "American Samoa",
            alpha_2: "AS",
            alpha_3: "ASM",
            un_code: 16
        });
        array.push({
            name: "Andorra",
            alpha_2: "AD",
            alpha_3: "AND",
            un_code: 20
        });
        array.push({
            name: "Angola",
            alpha_2: "AO",
            alpha_3: "AGO",
            un_code: 24
        });
        array.push({
            name: "Anguilla",
            alpha_2: "AI",
            alpha_3: "AIA",
            un_code: 660
        });
        array.push({
            name: "Antarctica",
            alpha_2: "AQ",
            alpha_3: "ATA",
            un_code: 10
        });
        array.push({
            name: "Antigua and Barbuda",
            alpha_2: "AG",
            alpha_3: "ATG",
            un_code: 28
        });
        array.push({
            name: "Argentina",
            alpha_2: "AR",
            alpha_3: "ARG",
            un_code: 32
        });
        array.push({
            name: "Armenia",
            alpha_2: "AM",
            alpha_3: "ARM",
            un_code: 51
        });
        array.push({
            name: "Aruba",
            alpha_2: "AW",
            alpha_3: "ABW",
            un_code: 533
        });
        array.push({
            name: "Australia",
            alpha_2: "AU",
            alpha_3: "AUS",
            un_code: 36
        });
        array.push({
            name: "Austria",
            alpha_2: "AT",
            alpha_3: "AUT",
            un_code: 40
        });
        array.push({
            name: "Azerbaijan",
            alpha_2: "AZ",
            alpha_3: "AZE",
            un_code: 31
        });
        array.push({
            name: "Bahamas",
            alpha_2: "BS",
            alpha_3: "BHS",
            un_code: 44
        });
        array.push({
            name: "Bahrain",
            alpha_2: "BH",
            alpha_3: "BHR",
            un_code: 48
        });
        array.push({
            name: "Bangladesh",
            alpha_2: "BD",
            alpha_3: "BGD",
            un_code: 50
        });
        array.push({
            name: "Barbados",
            alpha_2: "BB",
            alpha_3: "BRB",
            un_code: 52
        });
        array.push({
            name: "Belarus",
            alpha_2: "BY",
            alpha_3: "BLR",
            un_code: 112
        });
        array.push({
            name: "Belgium",
            alpha_2: "BE",
            alpha_3: "BEL",
            un_code: 56
        });
        array.push({
            name: "Belize",
            alpha_2: "BZ",
            alpha_3: "BLZ",
            un_code: 84
        });
        array.push({
            name: "Benin",
            alpha_2: "BJ",
            alpha_3: "BEN",
            un_code: 204
        });
        array.push({
            name: "Bermuda",
            alpha_2: "BM",
            alpha_3: "BMU",
            un_code: 60
        });
        array.push({
            name: "Bhutan",
            alpha_2: "BT",
            alpha_3: "BTN",
            un_code: 64
        });
        array.push({
            name: "Bolivia",
            alpha_2: "BO",
            alpha_3: "BOL",
            un_code: 68
        });
        array.push({
            name: "Bosnia and Herzegovina",
            alpha_2: "BA",
            alpha_3: "BIH",
            un_code: 70
        });
        array.push({
            name: "Botswana",
            alpha_2: "BW",
            alpha_3: "BWA",
            un_code: 72
        });
        array.push({
            name: "Bouvet Island",
            alpha_2: "BV",
            alpha_3: "BVT",
            un_code: 74
        });
        array.push({
            name: "Brazil",
            alpha_2: "BR",
            alpha_3: "BRA",
            un_code: 76
        });
        array.push({
            name: "British Virgin Islands",
            alpha_2: "VG",
            alpha_3: "VGB",
            un_code: 92
        });
        array.push({
            name: "British Indian Ocean Territory",
            alpha_2: "IO",
            alpha_3: "IOT",
            un_code: 86
        });
        array.push({
            name: "Brunei Darussalam",
            alpha_2: "BN",
            alpha_3: "BRN",
            un_code: 96
        });
        array.push({
            name: "Bulgaria",
            alpha_2: "BG",
            alpha_3: "BGR",
            un_code: 100
        });
        array.push({
            name: "Burkina Faso",
            alpha_2: "BF",
            alpha_3: "BFA",
            un_code: 854
        });
        array.push({
            name: "Burundi",
            alpha_2: "BI",
            alpha_3: "BDI",
            un_code: 108
        });
        array.push({
            name: "Cambodia",
            alpha_2: "KH",
            alpha_3: "KHM",
            un_code: 116
        });
        array.push({
            name: "Cameroon",
            alpha_2: "CM",
            alpha_3: "CMR",
            un_code: 120
        });
        array.push({
            name: "Canada",
            alpha_2: "CA",
            alpha_3: "CAN",
            un_code: 124
        });
        array.push({
            name: "Cape Verde",
            alpha_2: "CV",
            alpha_3: "CPV",
            un_code: 132
        });
        array.push({
            name: "Cayman Islands",
            alpha_2: "KY",
            alpha_3: "CYM",
            un_code: 136
        });
        array.push({
            name: "Central African Republic",
            alpha_2: "CF",
            alpha_3: "CAF",
            un_code: 140
        });
        array.push({
            name: "Chad",
            alpha_2: "TD",
            alpha_3: "TCD",
            un_code: 148
        });
        array.push({
            name: "Chile",
            alpha_2: "CL",
            alpha_3: "CHL",
            un_code: 152
        });
        array.push({
            name: "China",
            alpha_2: "CN",
            alpha_3: "CHN",
            un_code: 156
        });
        array.push({
            name: "Hong Kong, SAR China",
            alpha_2: "HK",
            alpha_3: "HKG",
            un_code: 344
        });
        array.push({
            name: "Macao, SAR China",
            alpha_2: "MO",
            alpha_3: "MAC",
            un_code: 446
        });
        array.push({
            name: "Christmas Island",
            alpha_2: "CX",
            alpha_3: "CXR",
            un_code: 162
        });
        array.push({
            name: "Cocos (Keeling) Islands",
            alpha_2: "CC",
            alpha_3: "CCK",
            un_code: 166
        });
        array.push({
            name: "Colombia",
            alpha_2: "CO",
            alpha_3: "COL",
            un_code: 170
        });
        array.push({
            name: "Comoros",
            alpha_2: "KM",
            alpha_3: "COM",
            un_code: 174
        });
        array.push({
            name: "Congo (Brazzaville)",
            alpha_2: "CG",
            alpha_3: "COG",
            un_code: 178
        });
        array.push({
            name: "Congo, (Kinshasa)",
            alpha_2: "CD",
            alpha_3: "COD",
            un_code: 180
        });
        array.push({
            name: "Cook Islands",
            alpha_2: "CK",
            alpha_3: "COK",
            un_code: 184
        });
        array.push({
            name: "Costa Rica",
            alpha_2: "CR",
            alpha_3: "CRI",
            un_code: 188
        });
        array.push({
            name: "Côte d'Ivoire",
            alpha_2: "CI",
            alpha_3: "CIV",
            un_code: 384
        });
        array.push({
            name: "Croatia",
            alpha_2: "HR",
            alpha_3: "HRV",
            un_code: 191
        });
        array.push({
            name: "Cuba",
            alpha_2: "CU",
            alpha_3: "CUB",
            un_code: 192
        });
        array.push({
            name: "Cyprus",
            alpha_2: "CY",
            alpha_3: "CYP",
            un_code: 196
        });
        array.push({
            name: "Czech Republic",
            alpha_2: "CZ",
            alpha_3: "CZE",
            un_code: 203
        });
        array.push({
            name: "Denmark",
            alpha_2: "DK",
            alpha_3: "DNK",
            un_code: 208
        });
        array.push({
            name: "Djibouti",
            alpha_2: "DJ",
            alpha_3: "DJI",
            un_code: 262
        });
        array.push({
            name: "Dominica",
            alpha_2: "DM",
            alpha_3: "DMA",
            un_code: 212
        });
        array.push({
            name: "Dominican Republic",
            alpha_2: "DO",
            alpha_3: "DOM",
            un_code: 214
        });
        array.push({
            name: "Ecuador",
            alpha_2: "EC",
            alpha_3: "ECU",
            un_code: 218
        });
        array.push({
            name: "Egypt",
            alpha_2: "EG",
            alpha_3: "EGY",
            un_code: 818
        });
        array.push({
            name: "El Salvador",
            alpha_2: "SV",
            alpha_3: "SLV",
            un_code: 222
        });
        array.push({
            name: "Equatorial Guinea",
            alpha_2: "GQ",
            alpha_3: "GNQ",
            un_code: 226
        });
        array.push({
            name: "Eritrea",
            alpha_2: "ER",
            alpha_3: "ERI",
            un_code: 232
        });
        array.push({
            name: "Estonia",
            alpha_2: "EE",
            alpha_3: "EST",
            un_code: 233
        });
        array.push({
            name: "Ethiopia",
            alpha_2: "ET",
            alpha_3: "ETH",
            un_code: 231
        });
        array.push({
            name: "Falkland Islands (Malvinas)",
            alpha_2: "FK",
            alpha_3: "FLK",
            un_code: 238
        });
        array.push({
            name: "Faroe Islands",
            alpha_2: "FO",
            alpha_3: "FRO",
            un_code: 234
        });
        array.push({
            name: "Fiji",
            alpha_2: "FJ",
            alpha_3: "FJI",
            un_code: 242
        });
        array.push({
            name: "Finland",
            alpha_2: "FI",
            alpha_3: "FIN",
            un_code: 246
        });
        array.push({
            name: "France",
            alpha_2: "FR",
            alpha_3: "FRA",
            un_code: 250
        });
        array.push({
            name: "French Guiana",
            alpha_2: "GF",
            alpha_3: "GUF",
            un_code: 254
        });
        array.push({
            name: "French Polynesia",
            alpha_2: "PF",
            alpha_3: "PYF",
            un_code: 258
        });
        array.push({
            name: "French Southern Territories",
            alpha_2: "TF",
            alpha_3: "ATF",
            un_code: 260
        });
        array.push({
            name: "Gabon",
            alpha_2: "GA",
            alpha_3: "GAB",
            un_code: 266
        });
        array.push({
            name: "Gambia",
            alpha_2: "GM",
            alpha_3: "GMB",
            un_code: 270
        });
        array.push({
            name: "Georgia",
            alpha_2: "GE",
            alpha_3: "GEO",
            un_code: 268
        });
        array.push({
            name: "Germany",
            alpha_2: "DE",
            alpha_3: "DEU",
            un_code: 276
        });
        array.push({
            name: "Ghana",
            alpha_2: "GH",
            alpha_3: "GHA",
            un_code: 288
        });
        array.push({
            name: "Gibraltar",
            alpha_2: "GI",
            alpha_3: "GIB",
            un_code: 292
        });
        array.push({
            name: "Greece",
            alpha_2: "GR",
            alpha_3: "GRC",
            un_code: 300
        });
        array.push({
            name: "Greenland",
            alpha_2: "GL",
            alpha_3: "GRL",
            un_code: 304
        });
        array.push({
            name: "Grenada",
            alpha_2: "GD",
            alpha_3: "GRD",
            un_code: 308
        });
        array.push({
            name: "Guadeloupe",
            alpha_2: "GP",
            alpha_3: "GLP",
            un_code: 312
        });
        array.push({
            name: "Guam",
            alpha_2: "GU",
            alpha_3: "GUM",
            un_code: 316
        });
        array.push({
            name: "Guatemala",
            alpha_2: "GT",
            alpha_3: "GTM",
            un_code: 320
        });
        array.push({
            name: "Guernsey",
            alpha_2: "GG",
            alpha_3: "GGY",
            un_code: 831
        });
        array.push({
            name: "Guinea",
            alpha_2: "GN",
            alpha_3: "GIN",
            un_code: 324
        });
        array.push({
            name: "Guinea-Bissau",
            alpha_2: "GW",
            alpha_3: "GNB",
            un_code: 624
        });
        array.push({
            name: "Guyana",
            alpha_2: "GY",
            alpha_3: "GUY",
            un_code: 328
        });
        array.push({
            name: "Haiti",
            alpha_2: "HT",
            alpha_3: "HTI",
            un_code: 332
        });
        array.push({
            name: "Heard and Mcdonald Islands",
            alpha_2: "HM",
            alpha_3: "HMD",
            un_code: 334
        });
        array.push({
            name: "Holy See (Vatican City State)",
            alpha_2: "VA",
            alpha_3: "VAT",
            un_code: 336
        });
        array.push({
            name: "Honduras",
            alpha_2: "HN",
            alpha_3: "HND",
            un_code: 340
        });
        array.push({
            name: "Hungary",
            alpha_2: "HU",
            alpha_3: "HUN",
            un_code: 348
        });
        array.push({
            name: "Iceland",
            alpha_2: "IS",
            alpha_3: "ISL",
            un_code: 352
        });
        array.push({
            name: "India",
            alpha_2: "IN",
            alpha_3: "IND",
            un_code: 356
        });
        array.push({
            name: "Indonesia",
            alpha_2: "ID",
            alpha_3: "IDN",
            un_code: 360
        });
        array.push({
            name: "Iran, Islamic Republic of",
            alpha_2: "IR",
            alpha_3: "IRN",
            un_code: 364
        });
        array.push({
            name: "Iraq",
            alpha_2: "IQ",
            alpha_3: "IRQ",
            un_code: 368
        });
        array.push({
            name: "Ireland",
            alpha_2: "IE",
            alpha_3: "IRL",
            un_code: 372
        });
        array.push({
            name: "Isle of Man",
            alpha_2: "IM",
            alpha_3: "IMN",
            un_code: 833
        });
        array.push({
            name: "Israel",
            alpha_2: "IL",
            alpha_3: "ISR",
            un_code: 376
        });
        array.push({
            name: "Italy",
            alpha_2: "IT",
            alpha_3: "ITA",
            un_code: 380
        });
        array.push({
            name: "Jamaica",
            alpha_2: "JM",
            alpha_3: "JAM",
            un_code: 388
        });
        array.push({
            name: "Japan",
            alpha_2: "JP",
            alpha_3: "JPN",
            un_code: 392
        });
        array.push({
            name: "Jersey",
            alpha_2: "JE",
            alpha_3: "JEY",
            un_code: 832
        });
        array.push({
            name: "Jordan",
            alpha_2: "JO",
            alpha_3: "JOR",
            un_code: 400
        });
        array.push({
            name: "Kazakhstan",
            alpha_2: "KZ",
            alpha_3: "KAZ",
            un_code: 398
        });
        array.push({
            name: "Kenya",
            alpha_2: "KE",
            alpha_3: "KEN",
            un_code: 404
        });
        array.push({
            name: "Kiribati",
            alpha_2: "KI",
            alpha_3: "KIR",
            un_code: 296
        });
        array.push({
            name: "Korea (North)",
            alpha_2: "KP",
            alpha_3: "PRK",
            un_code: 408
        });
        array.push({
            name: "Korea (South)",
            alpha_2: "KR",
            alpha_3: "KOR",
            un_code: 410
        });
        array.push({
            name: "Kuwait",
            alpha_2: "KW",
            alpha_3: "KWT",
            un_code: 414
        });
        array.push({
            name: "Kyrgyzstan",
            alpha_2: "KG",
            alpha_3: "KGZ",
            un_code: 417
        });
        array.push({
            name: "Lao PDR",
            alpha_2: "LA",
            alpha_3: "LAO",
            un_code: 418
        });
        array.push({
            name: "Latvia",
            alpha_2: "LV",
            alpha_3: "LVA",
            un_code: 428
        });
        array.push({
            name: "Lebanon",
            alpha_2: "LB",
            alpha_3: "LBN",
            un_code: 422
        });
        array.push({
            name: "Lesotho",
            alpha_2: "LS",
            alpha_3: "LSO",
            un_code: 426
        });
        array.push({
            name: "Liberia",
            alpha_2: "LR",
            alpha_3: "LBR",
            un_code: 430
        });
        array.push({
            name: "Libya",
            alpha_2: "LY",
            alpha_3: "LBY",
            un_code: 434
        });
        array.push({
            name: "Liechtenstein",
            alpha_2: "LI",
            alpha_3: "LIE",
            un_code: 438
        });
        array.push({
            name: "Lithuania",
            alpha_2: "LT",
            alpha_3: "LTU",
            un_code: 440
        });
        array.push({
            name: "Luxembourg",
            alpha_2: "LU",
            alpha_3: "LUX",
            un_code: 442
        });
        array.push({
            name: "Macedonia, Republic of",
            alpha_2: "MK",
            alpha_3: "MKD",
            un_code: 807
        });
        array.push({
            name: "Madagascar",
            alpha_2: "MG",
            alpha_3: "MDG",
            un_code: 450
        });
        array.push({
            name: "Malawi",
            alpha_2: "MW",
            alpha_3: "MWI",
            un_code: 454
        });
        array.push({
            name: "Malaysia",
            alpha_2: "MY",
            alpha_3: "MYS",
            un_code: 458
        });
        array.push({
            name: "Maldives",
            alpha_2: "MV",
            alpha_3: "MDV",
            un_code: 462
        });
        array.push({
            name: "Mali",
            alpha_2: "ML",
            alpha_3: "MLI",
            un_code: 466
        });
        array.push({
            name: "Malta",
            alpha_2: "MT",
            alpha_3: "MLT",
            un_code: 470
        });
        array.push({
            name: "Marshall Islands",
            alpha_2: "MH",
            alpha_3: "MHL",
            un_code: 584
        });
        array.push({
            name: "Martinique",
            alpha_2: "MQ",
            alpha_3: "MTQ",
            un_code: 474
        });
        array.push({
            name: "Mauritania",
            alpha_2: "MR",
            alpha_3: "MRT",
            un_code: 478
        });
        array.push({
            name: "Mauritius",
            alpha_2: "MU",
            alpha_3: "MUS",
            un_code: 480
        });
        array.push({
            name: "Mayotte",
            alpha_2: "YT",
            alpha_3: "MYT",
            un_code: 175
        });
        array.push({
            name: "Mexico",
            alpha_2: "MX",
            alpha_3: "MEX",
            un_code: 484
        });
        array.push({
            name: "Micronesia, Federated States of",
            alpha_2: "FM",
            alpha_3: "FSM",
            un_code: 583
        });
        array.push({
            name: "Moldova",
            alpha_2: "MD",
            alpha_3: "MDA",
            un_code: 498
        });
        array.push({
            name: "Monaco",
            alpha_2: "MC",
            alpha_3: "MCO",
            un_code: 492
        });
        array.push({
            name: "Mongolia",
            alpha_2: "MN",
            alpha_3: "MNG",
            un_code: 496
        });
        array.push({
            name: "Montenegro",
            alpha_2: "ME",
            alpha_3: "MNE",
            un_code: 499
        });
        array.push({
            name: "Montserrat",
            alpha_2: "MS",
            alpha_3: "MSR",
            un_code: 500
        });
        array.push({
            name: "Morocco",
            alpha_2: "MA",
            alpha_3: "MAR",
            un_code: 504
        });
        array.push({
            name: "Mozambique",
            alpha_2: "MZ",
            alpha_3: "MOZ",
            un_code: 508
        });
        array.push({
            name: "Myanmar",
            alpha_2: "MM",
            alpha_3: "MMR",
            un_code: 104
        });
        array.push({
            name: "Namibia",
            alpha_2: "NA",
            alpha_3: "NAM",
            un_code: 516
        });
        array.push({
            name: "Nauru",
            alpha_2: "NR",
            alpha_3: "NRU",
            un_code: 520
        });
        array.push({
            name: "Nepal",
            alpha_2: "NP",
            alpha_3: "NPL",
            un_code: 524
        });
        array.push({
            name: "Netherlands",
            alpha_2: "NL",
            alpha_3: "NLD",
            un_code: 528
        });
        array.push({
            name: "Netherlands Antilles",
            alpha_2: "AN",
            alpha_3: "ANT",
            un_code: 530
        });
        array.push({
            name: "New Caledonia",
            alpha_2: "NC",
            alpha_3: "NCL",
            un_code: 540
        });
        array.push({
            name: "New Zealand",
            alpha_2: "NZ",
            alpha_3: "NZL",
            un_code: 554
        });
        array.push({
            name: "Nicaragua",
            alpha_2: "NI",
            alpha_3: "NIC",
            un_code: 558
        });
        array.push({
            name: "Niger",
            alpha_2: "NE",
            alpha_3: "NER",
            un_code: 562
        });
        array.push({
            name: "Nigeria",
            alpha_2: "NG",
            alpha_3: "NGA",
            un_code: 566
        });
        array.push({
            name: "Niue",
            alpha_2: "NU",
            alpha_3: "NIU",
            un_code: 570
        });
        array.push({
            name: "Norfolk Island",
            alpha_2: "NF",
            alpha_3: "NFK",
            un_code: 574
        });
        array.push({
            name: "Northern Mariana Islands",
            alpha_2: "MP",
            alpha_3: "MNP",
            un_code: 580
        });
        array.push({
            name: "Norway",
            alpha_2: "NO",
            alpha_3: "NOR",
            un_code: 578
        });
        array.push({
            name: "Oman",
            alpha_2: "OM",
            alpha_3: "OMN",
            un_code: 512
        });
        array.push({
            name: "Pakistan",
            alpha_2: "PK",
            alpha_3: "PAK",
            un_code: 586
        });
        array.push({
            name: "Palau",
            alpha_2: "PW",
            alpha_3: "PLW",
            un_code: 585
        });
        array.push({
            name: "Palestinian Territory",
            alpha_2: "PS",
            alpha_3: "PSE",
            un_code: 275
        });
        array.push({
            name: "Panama",
            alpha_2: "PA",
            alpha_3: "PAN",
            un_code: 591
        });
        array.push({
            name: "Papua New Guinea",
            alpha_2: "PG",
            alpha_3: "PNG",
            un_code: 598
        });
        array.push({
            name: "Paraguay",
            alpha_2: "PY",
            alpha_3: "PRY",
            un_code: 600
        });
        array.push({
            name: "Peru",
            alpha_2: "PE",
            alpha_3: "PER",
            un_code: 604
        });
        array.push({
            name: "Philippines",
            alpha_2: "PH",
            alpha_3: "PHL",
            un_code: 608
        });
        array.push({
            name: "Pitcairn",
            alpha_2: "PN",
            alpha_3: "PCN",
            un_code: 612
        });
        array.push({
            name: "Poland",
            alpha_2: "PL",
            alpha_3: "POL",
            un_code: 616
        });
        array.push({
            name: "Portugal",
            alpha_2: "PT",
            alpha_3: "PRT",
            un_code: 620
        });
        array.push({
            name: "Puerto Rico",
            alpha_2: "PR",
            alpha_3: "PRI",
            un_code: 630
        });
        array.push({
            name: "Qatar",
            alpha_2: "QA",
            alpha_3: "QAT",
            un_code: 634
        });
        array.push({
            name: "Réunion",
            alpha_2: "RE",
            alpha_3: "REU",
            un_code: 638
        });
        array.push({
            name: "Romania",
            alpha_2: "RO",
            alpha_3: "ROU",
            un_code: 642
        });
        array.push({
            name: "Russian Federation",
            alpha_2: "RU",
            alpha_3: "RUS",
            un_code: 643
        });
        array.push({
            name: "Rwanda",
            alpha_2: "RW",
            alpha_3: "RWA",
            un_code: 646
        });
        array.push({
            name: "Saint-Barthélemy",
            alpha_2: "BL",
            alpha_3: "BLM",
            un_code: 652
        });
        array.push({
            name: "Saint Helena",
            alpha_2: "SH",
            alpha_3: "SHN",
            un_code: 654
        });
        array.push({
            name: "Saint Kitts and Nevis",
            alpha_2: "KN",
            alpha_3: "KNA",
            un_code: 659
        });
        array.push({
            name: "Saint Lucia",
            alpha_2: "LC",
            alpha_3: "LCA",
            un_code: 662
        });
        array.push({
            name: "Saint-Martin (French part)",
            alpha_2: "MF",
            alpha_3: "MAF",
            un_code: 663
        });
        array.push({
            name: "Saint Pierre and Miquelon",
            alpha_2: "PM",
            alpha_3: "SPM",
            un_code: 666
        });
        array.push({
            name: "Saint Vincent and Grenadines",
            alpha_2: "VC",
            alpha_3: "VCT",
            un_code: 670
        });
        array.push({
            name: "Samoa",
            alpha_2: "WS",
            alpha_3: "WSM",
            un_code: 882
        });
        array.push({
            name: "San Marino",
            alpha_2: "SM",
            alpha_3: "SMR",
            un_code: 674
        });
        array.push({
            name: "Sao Tome and Principe",
            alpha_2: "ST",
            alpha_3: "STP",
            un_code: 678
        });
        array.push({
            name: "Saudi Arabia",
            alpha_2: "SA",
            alpha_3: "SAU",
            un_code: 682
        });
        array.push({
            name: "Senegal",
            alpha_2: "SN",
            alpha_3: "SEN",
            un_code: 686
        });
        array.push({
            name: "Serbia",
            alpha_2: "RS",
            alpha_3: "SRB",
            un_code: 688
        });
        array.push({
            name: "Seychelles",
            alpha_2: "SC",
            alpha_3: "SYC",
            un_code: 690
        });
        array.push({
            name: "Sierra Leone",
            alpha_2: "SL",
            alpha_3: "SLE",
            un_code: 694
        });
        array.push({
            name: "Singapore",
            alpha_2: "SG",
            alpha_3: "SGP",
            un_code: 702
        });
        array.push({
            name: "Slovakia",
            alpha_2: "SK",
            alpha_3: "SVK",
            un_code: 703
        });
        array.push({
            name: "Slovenia",
            alpha_2: "SI",
            alpha_3: "SVN",
            un_code: 705
        });
        array.push({
            name: "Solomon Islands",
            alpha_2: "SB",
            alpha_3: "SLB",
            un_code: 90
        });
        array.push({
            name: "Somalia",
            alpha_2: "SO",
            alpha_3: "SOM",
            un_code: 706
        });
        array.push({
            name: "South Africa",
            alpha_2: "ZA",
            alpha_3: "ZAF",
            un_code: 710
        });
        array.push({
            name: "South Georgia and the South Sandwich Islands",
            alpha_2: "GS",
            alpha_3: "SGS",
            un_code: 239
        });
        array.push({
            name: "South Sudan",
            alpha_2: "SS",
            alpha_3: "SSD",
            un_code: 728
        });
        array.push({
            name: "Spain",
            alpha_2: "ES",
            alpha_3: "ESP",
            un_code: 724
        });
        array.push({
            name: "Sri Lanka",
            alpha_2: "LK",
            alpha_3: "LKA",
            un_code: 144
        });
        array.push({
            name: "Sudan",
            alpha_2: "SD",
            alpha_3: "SDN",
            un_code: 736
        });
        array.push({
            name: "Suriname",
            alpha_2: "SR",
            alpha_3: "SUR",
            un_code: 740
        });
        array.push({
            name: "Svalbard and Jan Mayen Islands",
            alpha_2: "SJ",
            alpha_3: "SJM",
            un_code: 744
        });
        array.push({
            name: "Swaziland",
            alpha_2: "SZ",
            alpha_3: "SWZ",
            un_code: 748
        });
        array.push({
            name: "Sweden",
            alpha_2: "SE",
            alpha_3: "SWE",
            un_code: 752
        });
        array.push({
            name: "Switzerland",
            alpha_2: "CH",
            alpha_3: "CHE",
            un_code: 756
        });
        array.push({
            name: "Syrian Arab Republic (Syria)",
            alpha_2: "SY",
            alpha_3: "SYR",
            un_code: 760
        });
        array.push({
            name: "Taiwan, Republic of China",
            alpha_2: "TW",
            alpha_3: "TWN",
            un_code: 158
        });
        array.push({
            name: "Tajikistan",
            alpha_2: "TJ",
            alpha_3: "TJK",
            un_code: 762
        });
        array.push({
            name: "Tanzania, United Republic of",
            alpha_2: "TZ",
            alpha_3: "TZA",
            un_code: 834
        });
        array.push({
            name: "Thailand",
            alpha_2: "TH",
            alpha_3: "THA",
            un_code: 764
        });
        array.push({
            name: "Timor-Leste",
            alpha_2: "TL",
            alpha_3: "TLS",
            un_code: 626
        });
        array.push({
            name: "Togo",
            alpha_2: "TG",
            alpha_3: "TGO",
            un_code: 768
        });
        array.push({
            name: "Tokelau",
            alpha_2: "TK",
            alpha_3: "TKL",
            un_code: 772
        });
        array.push({
            name: "Tonga",
            alpha_2: "TO",
            alpha_3: "TON",
            un_code: 776
        });
        array.push({
            name: "Trinidad and Tobago",
            alpha_2: "TT",
            alpha_3: "TTO",
            un_code: 780
        });
        array.push({
            name: "Tunisia",
            alpha_2: "TN",
            alpha_3: "TUN",
            un_code: 788
        });
        array.push({
            name: "Turkey",
            alpha_2: "TR",
            alpha_3: "TUR",
            un_code: 792
        });
        array.push({
            name: "Turkmenistan",
            alpha_2: "TM",
            alpha_3: "TKM",
            un_code: 795
        });
        array.push({
            name: "Turks and Caicos Islands",
            alpha_2: "TC",
            alpha_3: "TCA",
            un_code: 796
        });
        array.push({
            name: "Tuvalu",
            alpha_2: "TV",
            alpha_3: "TUV",
            un_code: 798
        });
        array.push({
            name: "Uganda",
            alpha_2: "UG",
            alpha_3: "UGA",
            un_code: 800
        });
        array.push({
            name: "Ukraine",
            alpha_2: "UA",
            alpha_3: "UKR",
            un_code: 804
        });
        array.push({
            name: "United Arab Emirates",
            alpha_2: "AE",
            alpha_3: "ARE",
            un_code: 784
        });
        array.push({
            name: "United Kingdom",
            alpha_2: "GB",
            alpha_3: "GBR",
            un_code: 826
        });
        array.push({
            name: "United States of America",
            alpha_2: "US",
            alpha_3: "USA",
            un_code: 840
        });
        array.push({
            name: "US Minor Outlying Islands",
            alpha_2: "UM",
            alpha_3: "UMI",
            un_code: 581
        });
        array.push({
            name: "Uruguay",
            alpha_2: "UY",
            alpha_3: "URY",
            un_code: 858
        });
        array.push({
            name: "Uzbekistan",
            alpha_2: "UZ",
            alpha_3: "UZB",
            un_code: 860
        });
        array.push({
            name: "Vanuatu",
            alpha_2: "VU",
            alpha_3: "VUT",
            un_code: 548
        });
        array.push({
            name: "Venezuela (Bolivarian Republic)",
            alpha_2: "VE",
            alpha_3: "VEN",
            un_code: 862
        });
        array.push({
            name: "Viet Nam",
            alpha_2: "VN",
            alpha_3: "VNM",
            un_code: 704
        });
        array.push({
            name: "Virgin Islands, US",
            alpha_2: "VI",
            alpha_3: "VIR",
            un_code: 850
        });
        array.push({
            name: "Wallis and Futuna Islands",
            alpha_2: "WF",
            alpha_3: "WLF",
            un_code: 876
        });
        array.push({
            name: "Western Sahara",
            alpha_2: "EH",
            alpha_3: "ESH",
            un_code: 732
        });
        array.push({
            name: "Yemen",
            alpha_2: "YE",
            alpha_3: "YEM",
            un_code: 887
        });
        array.push({
            name: "Zambia",
            alpha_2: "ZM",
            alpha_3: "ZMB",
            un_code: 894
        });
        array.push({
            name: "Zimbabwe",
            alpha_2: "ZW",
            alpha_3: "ZWE",
            un_code: 716
        });
    };
    function country_name(alpha_code, fallback) {
        return (alpha_2_map[alpha_code.toUpperCase()] || { name: fallback || (_translations.HRyMZlYA || (_translations.HRyMZlYA = i18n.tr("unknown country"))) }).name;
    }
    i18n.country_name = country_name;
    fill_country_infos(country_infos);
    for (const country of country_infos)
        alpha_2_map[country.alpha_2] = country;
})(i18n || (i18n = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["1743b13e7848fd4aee3fa0db600be0816f672c8ae3f0ff1e6e786fab934a0fc2"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["1743b13e7848fd4aee3fa0db600be0816f672c8ae3f0ff1e6e786fab934a0fc2"] = "1743b13e7848fd4aee3fa0db600be0816f672c8ae3f0ff1e6e786fab934a0fc2";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "o59aQ4wU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (110,52)" }, { name: "TCwaP1oy", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (111,32)" }, { name: "bChUwJEm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (115,28)" }, { name: "fEuNI3pg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (123,40)" }, { name: "UEvirfqz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (127,40)" }, { name: "vPzSQSDy", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (149,32)" }, { name: "q9iArnVe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (202,48)" }, { name: "f2Tnmci1", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (205,48)" }, { name: "jtxFwUrL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (295,34)" }, { name: "jjNioBKj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (295,60)" }, { name: "AZE8K7d3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/i18n/localize.ts (295,196)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/*
"key": {
    "message": "Show permission description",
    "line": 374,
    "character": 30,
    "filename": "/home/wolverindev/TeaSpeak/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPermissionEdit.ts"
},
"translated": "Berechtigungsbeschreibung anzeigen",
"flags": [
    "google-translate",
    "verified"
]
 */
function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000)
            .toString(16)
            .substring(1);
    }
    return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}
var i18n;
(function (i18n) {
    let translations = [];
    let fast_translate = {};
    function tr(message, key) {
        const sloppy = fast_translate[message];
        if (sloppy)
            return sloppy;
        log.info(LogCategory.I18N, "Translating \"%s\". Default: \"%s\"", key, message);
        let translated = message;
        for (const translation of translations) {
            if (translation.key.message == message) {
                translated = translation.translated;
                break;
            }
        }
        fast_translate[message] = translated;
        return translated;
    }
    i18n.tr = tr;
    function tra(message, ...args) {
        message = tr(message);
        return MessageHelper.formatMessage(message, ...args);
    }
    i18n.tra = tra;
    function load_translation_file(url, path) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                $.ajax({
                    url: url,
                    async: true,
                    success: result => {
                        try {
                            const file = (typeof (result) === "string" ? JSON.parse(result) : result);
                            if (!file) {
                                reject("Invalid json");
                                return;
                            }
                            file.full_url = url;
                            file.path = path;
                            //TODO validate file
                            resolve(file);
                        }
                        catch (error) {
                            log.warn(LogCategory.I18N, _translations.o59aQ4wU || (_translations.o59aQ4wU = tr("Failed to load translation file %s. Failed to parse or process json: %o")), url, error);
                            reject(_translations.TCwaP1oy || (_translations.TCwaP1oy = tr("Failed to process or parse json!")));
                        }
                    },
                    error: (xhr, error) => {
                        reject((_translations.bChUwJEm || (_translations.bChUwJEm = tr("Failed to load file: "))) + error);
                    }
                });
            });
        });
    }
    function load_file(url, path) {
        return load_translation_file(url, path).then(result => {
            log.info(LogCategory.I18N, _translations.fEuNI3pg || (_translations.fEuNI3pg = tr("Successfully initialized up translation file from %s")), url);
            translations = result.translations;
            return Promise.resolve();
        }).catch(error => {
            log.warn(LogCategory.I18N, _translations.UEvirfqz || (_translations.UEvirfqz = tr("Failed to load translation file from \"%s\". Error: %o")), url, error);
            return Promise.reject(error);
        });
    }
    i18n.load_file = load_file;
    function load_repository0(repo, reload) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!repo.load_timestamp || repo.load_timestamp < 1000 || reload) {
                const info_json = yield new Promise((resolve, reject) => {
                    $.ajax({
                        url: repo.url + "/info.json",
                        async: true,
                        cache: !reload,
                        success: result => {
                            const file = (typeof (result) === "string" ? JSON.parse(result) : result);
                            if (!file) {
                                reject("Invalid json");
                                return;
                            }
                            resolve(file);
                        },
                        error: (xhr, error) => {
                            reject((_translations.vPzSQSDy || (_translations.vPzSQSDy = tr("Failed to load file: "))) + error);
                        }
                    });
                });
                Object.assign(repo, info_json);
            }
            if (!repo.unique_id)
                repo.unique_id = guid();
            repo.translations = repo.translations || [];
            repo.load_timestamp = Date.now();
        });
    }
    function load_repository(url) {
        return __awaiter(this, void 0, void 0, function* () {
            const result = {};
            result.url = url;
            yield load_repository0(result, false);
            return result;
        });
    }
    i18n.load_repository = load_repository;
    let config;
    (function (config_1) {
        const repository_config_key = "i18n.repository";
        let _cached_repository_config;
        function repository_config() {
            if (_cached_repository_config)
                return _cached_repository_config;
            const config_string = localStorage.getItem(repository_config_key);
            const config = config_string ? JSON.parse(config_string) : {};
            config.repositories = config.repositories || [];
            for (const repo of config.repositories)
                (repo.repository || { load_timestamp: 0 }).load_timestamp = 0;
            if (config.repositories.length == 0) {
                //Add the default TeaSpeak repository
                load_repository(StaticSettings.instance.static("i18n.default_repository", "i18n/")).then(repo => {
                    log.info(LogCategory.I18N, _translations.q9iArnVe || (_translations.q9iArnVe = tr("Successfully added default repository from \"%s\".")), repo.url);
                    register_repository(repo);
                }).catch(error => {
                    log.warn(LogCategory.I18N, _translations.f2Tnmci1 || (_translations.f2Tnmci1 = tr("Failed to add default repository. Error: %o")), error);
                });
            }
            return _cached_repository_config = config;
        }
        config_1.repository_config = repository_config;
        function save_repository_config() {
            localStorage.setItem(repository_config_key, JSON.stringify(_cached_repository_config));
        }
        config_1.save_repository_config = save_repository_config;
        const translation_config_key = "i18n.translation";
        let _cached_translation_config;
        function translation_config() {
            if (_cached_translation_config)
                return _cached_translation_config;
            const config_string = localStorage.getItem(translation_config_key);
            _cached_translation_config = config_string ? JSON.parse(config_string) : {};
            return _cached_translation_config;
        }
        config_1.translation_config = translation_config;
        function save_translation_config() {
            localStorage.setItem(translation_config_key, JSON.stringify(_cached_translation_config));
        }
        config_1.save_translation_config = save_translation_config;
    })(config = i18n.config || (i18n.config = {}));
    function register_repository(repository) {
        if (!repository)
            return;
        for (const repo of config.repository_config().repositories)
            if (repo.url == repository.url)
                return;
        config.repository_config().repositories.push(repository);
        config.save_repository_config();
    }
    i18n.register_repository = register_repository;
    function registered_repositories() {
        return config.repository_config().repositories.map(e => e.repository || { url: e.url, load_timestamp: 0 });
    }
    i18n.registered_repositories = registered_repositories;
    function delete_repository(repository) {
        if (!repository)
            return;
        for (const repo of [...config.repository_config().repositories])
            if (repo.url == repository.url) {
                config.repository_config().repositories.remove(repo);
            }
        config.save_repository_config();
    }
    i18n.delete_repository = delete_repository;
    function iterate_repositories(callback_entry) {
        return __awaiter(this, void 0, void 0, function* () {
            const promises = [];
            for (const repository of registered_repositories()) {
                promises.push(load_repository0(repository, false).then(() => callback_entry(repository)).catch(error => {
                    log.warn(LogCategory.I18N, "Failed to fetch repository %s. error: %o", repository.url, error);
                }));
            }
            yield Promise.all(promises);
        });
    }
    i18n.iterate_repositories = iterate_repositories;
    function select_translation(repository, entry) {
        const cfg = config.translation_config();
        if (entry && repository) {
            cfg.current_language = entry.name;
            cfg.current_repository_url = repository.url;
            cfg.current_translation_url = repository.url + entry.path;
            cfg.current_translation_path = entry.path;
        }
        else {
            cfg.current_language = undefined;
            cfg.current_repository_url = undefined;
            cfg.current_translation_url = undefined;
            cfg.current_translation_path = undefined;
        }
        config.save_translation_config();
    }
    i18n.select_translation = select_translation;
    function initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const rcfg = config.repository_config(); /* initialize */
            const cfg = config.translation_config();
            if (cfg.current_translation_url) {
                try {
                    yield load_file(cfg.current_translation_url, cfg.current_translation_path);
                }
                catch (error) {
                    createErrorModal(_translations.jtxFwUrL || (_translations.jtxFwUrL = tr("Translation System")), (_translations.jjNioBKj || (_translations.jjNioBKj = tr("Failed to load current selected translation file."))) + "<br>File: " + cfg.current_translation_url + "<br>Error: " + error + "<br>" + (_translations.AZE8K7d3 || (_translations.AZE8K7d3 = tr("Using default fallback translations.")))).open();
                }
            }
            // await load_file("http://localhost/home/TeaSpeak/TeaSpeak/Web-Client/web/environment/development/i18n/de_DE.translation");
            // await load_file("http://localhost/home/TeaSpeak/TeaSpeak/Web-Client/web/environment/development/i18n/test.json");
        });
    }
    i18n.initialize = initialize;
})(i18n || (i18n = {}));
// @ts-ignore
const tr = i18n.tr;
const tra = i18n.tra;
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["fd9efa9c872b2e0f9cc91c4bfce8e905035f0c692114b2c38c3f9e8bf007d40f"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["fd9efa9c872b2e0f9cc91c4bfce8e905035f0c692114b2c38c3f9e8bf007d40f"] = "fd9efa9c872b2e0f9cc91c4bfce8e905035f0c692114b2c38c3f9e8bf007d40f";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "lfPIXsNG", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (115,31)" }, { name: "Uf28jWUC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (116,34)" }, { name: "PE5tAMnM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (116,90)" }, { name: "TtCDUyU4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (131,35)" }, { name: "qJGOExk7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (156,38)" }, { name: "_P20y3w3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/ConnectionProfile.ts (156,81)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var profiles;
(function (profiles_1) {
    class ConnectionProfile {
        constructor(id) {
            this.selected_identity_type = "unset";
            this.identities = {};
            this.id = id;
        }
        selected_identity(current_type) {
            if (!current_type)
                current_type = this.selected_type();
            if (current_type === undefined)
                return undefined;
            if (current_type == profiles_1.identities.IdentitifyType.TEAFORO) {
                return profiles_1.identities.static_forum_identity();
            }
            else if (current_type == profiles_1.identities.IdentitifyType.TEAMSPEAK || current_type == profiles_1.identities.IdentitifyType.NICKNAME) {
                return this.identities[this.selected_identity_type.toLowerCase()];
            }
            return undefined;
        }
        selected_type() {
            return profiles_1.identities.IdentitifyType[this.selected_identity_type.toUpperCase()];
        }
        set_identity(type, identity) {
            this.identities[profiles_1.identities.IdentitifyType[type].toLowerCase()] = identity;
        }
        spawn_identity_handshake_handler(connection) {
            const identity = this.selected_identity();
            if (!identity)
                return undefined;
            return identity.spawn_identity_handshake_handler(connection);
        }
        encode() {
            const identity_data = {};
            for (const key in this.identities)
                if (this.identities[key])
                    identity_data[key] = this.identities[key].encode();
            return JSON.stringify({
                version: 1,
                username: this.default_username,
                password: this.default_password,
                profile_name: this.profile_name,
                identity_type: this.selected_identity_type,
                identity_data: identity_data,
                id: this.id
            });
        }
        valid() {
            const identity = this.selected_identity();
            if (!identity || !identity.valid())
                return false;
            return this.default_username !== undefined;
        }
    }
    profiles_1.ConnectionProfile = ConnectionProfile;
    function decode_profile(data) {
        return __awaiter(this, void 0, void 0, function* () {
            data = JSON.parse(data);
            if (data.version !== 1)
                return "invalid version";
            const result = new ConnectionProfile(data.id);
            result.default_username = data.username;
            result.default_password = data.password;
            result.profile_name = data.profile_name;
            result.selected_identity_type = (data.identity_type || "").toLowerCase();
            if (data.identity_data) {
                for (const key in data.identity_data) {
                    const type = profiles_1.identities.IdentitifyType[key.toUpperCase()];
                    const _data = data.identity_data[key];
                    if (type == undefined)
                        continue;
                    const identity = yield profiles_1.identities.decode_identity(type, _data);
                    if (identity == undefined)
                        continue;
                    result.identities[key.toLowerCase()] = identity;
                }
            }
            return result;
        });
    }
    let available_profiles = [];
    function load() {
        return __awaiter(this, void 0, void 0, function* () {
            available_profiles = [];
            const profiles_json = localStorage.getItem("profiles");
            let profiles_data = (() => {
                try {
                    return profiles_json ? JSON.parse(profiles_json) : { version: 0 };
                }
                catch (error) {
                    debugger;
                    console.error(_translations.lfPIXsNG || (_translations.lfPIXsNG = tr("Invalid profile json! Resetting profiles :( (%o)")), profiles_json);
                    createErrorModal(_translations.Uf28jWUC || (_translations.Uf28jWUC = tr("Profile data invalid")), MessageHelper.formatMessage(_translations.PE5tAMnM || (_translations.PE5tAMnM = tr("The profile data is invalid.{:br:}This might cause data loss.")))).open();
                    return { version: 0 };
                }
            })();
            if (profiles_data.version === 0) {
                profiles_data = {
                    version: 1,
                    profiles: []
                };
            }
            if (profiles_data.version == 1) {
                for (const profile_data of profiles_data.profiles) {
                    const profile = yield decode_profile(profile_data);
                    if (typeof (profile) === 'string') {
                        console.error(_translations.TtCDUyU4 || (_translations.TtCDUyU4 = tr("Failed to load profile. Reason: %s, Profile data: %s")), profile, profiles_data);
                        continue;
                    }
                    available_profiles.push(profile);
                }
            }
            if (!find_profile("default")) { //Create a default profile and teaforo profile
                {
                    const profile = create_new_profile("default", "default");
                    profile.default_password = "";
                    profile.default_username = "Another TeaSpeak user";
                    profile.profile_name = "Default Profile";
                    /* generate default identity */
                    try {
                        const identity = yield profiles_1.identities.TeaSpeakIdentity.generate_new();
                        let active = true;
                        setTimeout(() => {
                            active = false;
                        }, 1000);
                        yield identity.improve_level(8, 1, () => active);
                        profile.set_identity(profiles_1.identities.IdentitifyType.TEAMSPEAK, identity);
                        profile.selected_identity_type = profiles_1.identities.IdentitifyType[profiles_1.identities.IdentitifyType.TEAMSPEAK];
                    }
                    catch (error) {
                        createErrorModal(_translations.qJGOExk7 || (_translations.qJGOExk7 = tr("Failed to generate default identity")), _translations._P20y3w3 || (_translations._P20y3w3 = tr("Failed to generate default identity!<br>Please manually generate the identity within your settings => profiles"))).open();
                    }
                }
                { /* forum identity (works only when connected to the forum) */
                    const profile = create_new_profile("TeaSpeak Forum", "teaforo");
                    profile.default_password = "";
                    profile.default_username = "Another TeaSpeak user";
                    profile.profile_name = "TeaSpeak Forum profile";
                    profile.set_identity(profiles_1.identities.IdentitifyType.TEAFORO, profiles_1.identities.static_forum_identity());
                    profile.selected_identity_type = profiles_1.identities.IdentitifyType[profiles_1.identities.IdentitifyType.TEAFORO];
                }
                save();
            }
        });
    }
    profiles_1.load = load;
    function create_new_profile(name, id) {
        const profile = new ConnectionProfile(id || guid());
        profile.profile_name = name;
        profile.default_username = "Another TeaSpeak user";
        available_profiles.push(profile);
        return profile;
    }
    profiles_1.create_new_profile = create_new_profile;
    let _requires_save = false;
    function save() {
        const profiles = [];
        for (const profile of available_profiles)
            profiles.push(profile.encode());
        const data = JSON.stringify({
            version: 1,
            profiles: profiles
        });
        localStorage.setItem("profiles", data);
    }
    profiles_1.save = save;
    function mark_need_save() {
        _requires_save = true;
    }
    profiles_1.mark_need_save = mark_need_save;
    function requires_save() {
        return _requires_save;
    }
    profiles_1.requires_save = requires_save;
    function profiles() {
        return available_profiles;
    }
    profiles_1.profiles = profiles;
    function find_profile(id) {
        for (const profile of profiles())
            if (profile.id == id)
                return profile;
        return undefined;
    }
    profiles_1.find_profile = find_profile;
    function find_profile_by_name(name) {
        name = name.toLowerCase();
        for (const profile of profiles())
            if ((profile.profile_name || "").toLowerCase() == name)
                return profile;
        return undefined;
    }
    profiles_1.find_profile_by_name = find_profile_by_name;
    function default_profile() {
        return find_profile("default");
    }
    profiles_1.default_profile = default_profile;
    function set_default_profile(profile) {
        const old_default = default_profile();
        if (old_default && old_default != profile) {
            old_default.id = guid();
        }
        profile.id = "default";
    }
    profiles_1.set_default_profile = set_default_profile;
    function delete_profile(profile) {
        available_profiles.remove(profile);
    }
    profiles_1.delete_profile = delete_profile;
})(profiles || (profiles = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["179e2f2e0cf7f83e2f77ec1b184d6aea4a698d70aa99d964ecc8bbc2912d897c"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["179e2f2e0cf7f83e2f77ec1b184d6aea4a698d70aa99d964ecc8bbc2912d897c"] = "179e2f2e0cf7f83e2f77ec1b184d6aea4a698d70aa99d964ecc8bbc2912d897c";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "iaUv8S8m", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/NameIdentity.ts (23,51)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../Identity.ts" />
var profiles;
(function (profiles) {
    var identities;
    (function (identities) {
        class NameHandshakeHandler extends identities.AbstractHandshakeIdentityHandler {
            constructor(connection, identity) {
                super(connection);
                this.identity = identity;
                this.handler = new identities.HandshakeCommandHandler(connection, this);
                this.handler["handshakeidentityproof"] = () => this.trigger_fail("server requested unexpected proof");
            }
            start_handshake() {
                this.connection.command_handler_boss().register_handler(this.handler);
                this.connection.send_command("handshakebegin", {
                    intention: 0,
                    authentication_method: this.identity.type(),
                    client_nickname: this.identity.name()
                }).catch(error => {
                    log.error(LogCategory.IDENTITIES, _translations.iaUv8S8m || (_translations.iaUv8S8m = tr("Failed to initialize name based handshake. Error: %o")), error);
                    if (error instanceof CommandResult)
                        error = error.extra_message || error.message;
                    this.trigger_fail("failed to execute begin (" + error + ")");
                }).then(() => this.trigger_success());
            }
            trigger_fail(message) {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_fail(message);
            }
            trigger_success() {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_success();
            }
        }
        class NameIdentity {
            constructor(name) {
                this._name = name;
            }
            set_name(name) { this._name = name; }
            name() {
                return this._name;
            }
            uid() {
                return btoa(this._name); //FIXME hash!
            }
            type() {
                return identities.IdentitifyType.NICKNAME;
            }
            valid() {
                return this._name != undefined && this._name.length >= 3;
            }
            decode(data) {
                data = JSON.parse(data);
                if (data.version !== 1)
                    throw "invalid version";
                this._name = data["name"];
                return;
            }
            encode() {
                return JSON.stringify({
                    version: 1,
                    name: this._name
                });
            }
            spawn_identity_handshake_handler(connection) {
                return new NameHandshakeHandler(connection, this);
            }
        }
        identities.NameIdentity = NameIdentity;
    })(identities = profiles.identities || (profiles.identities = {}));
})(profiles || (profiles = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["cd9cf2e3f4c9796e4347083ef2a3499aa8b21883ba19f2a9b42a551f302ab8c5"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["cd9cf2e3f4c9796e4347083ef2a3499aa8b21883ba19f2a9b42a551f302ab8c5"] = "cd9cf2e3f4c9796e4347083ef2a3499aa8b21883ba19f2a9b42a551f302ab8c5";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "ZPzGAPyi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeaForumIdentity.ts (22,51)" }, { name: "L1C0ZHcn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeaForumIdentity.ts (35,51)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../Identity.ts" />
var profiles;
(function (profiles) {
    var identities;
    (function (identities) {
        class TeaForumHandshakeHandler extends identities.AbstractHandshakeIdentityHandler {
            constructor(connection, identity) {
                super(connection);
                this.identity = identity;
                this.handler = new identities.HandshakeCommandHandler(connection, this);
                this.handler["handshakeidentityproof"] = this.handle_proof.bind(this);
            }
            start_handshake() {
                this.connection.command_handler_boss().register_handler(this.handler);
                this.connection.send_command("handshakebegin", {
                    intention: 0,
                    authentication_method: this.identity.type(),
                    data: this.identity.data_json()
                }).catch(error => {
                    log.error(LogCategory.IDENTITIES, _translations.ZPzGAPyi || (_translations.ZPzGAPyi = tr("Failed to initialize TeaForum based handshake. Error: %o")), error);
                    if (error instanceof CommandResult)
                        error = error.extra_message || error.message;
                    this.trigger_fail("failed to execute begin (" + error + ")");
                });
            }
            handle_proof(json) {
                this.connection.send_command("handshakeindentityproof", {
                    proof: this.identity.data_sign()
                }).catch(error => {
                    log.error(LogCategory.IDENTITIES, _translations.L1C0ZHcn || (_translations.L1C0ZHcn = tr("Failed to proof the identity. Error: %o")), error);
                    if (error instanceof CommandResult)
                        error = error.extra_message || error.message;
                    this.trigger_fail("failed to execute proof (" + error + ")");
                }).then(() => this.trigger_success());
            }
            trigger_fail(message) {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_fail(message);
            }
            trigger_success() {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_success();
            }
        }
        class TeaForumIdentity {
            constructor(data, sign) {
                this.identity_data_raw = data;
                this.identity_data_sign = sign;
                try {
                    this.identity_data = data ? JSON.parse(this.identity_data_raw) : undefined;
                }
                catch (error) { }
            }
            valid() {
                return this.identity_data_raw.length > 0 && this.identity_data_raw.length > 0 && this.identity_data_sign.length > 0;
            }
            data_json() { return this.identity_data_raw; }
            data_sign() { return this.identity_data_sign; }
            name() { return this.identity_data["user_name"]; }
            uid() { return "TeaForo#" + this.identity_data["user_id"]; }
            type() { return identities.IdentitifyType.TEAFORO; }
            forum_user_id() { return this.identity_data["user_id"]; }
            forum_user_group() { return this.identity_data["user_group_id"]; }
            is_stuff() { return this.identity_data["is_staff"]; }
            is_premium() { return this.identity_data["user_groups"].indexOf(5) != -1; }
            data_age() { return new Date(this.identity_data["data_age"]); }
            /*
                $user_data["user_id"] = $user->user_id;
                $user_data["user_name"] = $user->username;
                $user_data["user_group"] = $user->user_group_id;
                $user_data["user_groups"] = $user->secondary_group_ids;
    
                $user_data["trophy_points"] = $user->trophy_points;
                $user_data["register_date"] = $user->register_date;
                $user_data["is_staff"] = $user->is_staff;
                $user_data["is_admin"] = $user->is_admin;
                $user_data["is_super_admin"] = $user->is_super_admin;
                $user_data["is_banned"] = $user->is_banned;
    
                $user_data["data_age"] = milliseconds();
             */
            decode(data) {
                data = JSON.parse(data);
                if (data.version !== 1)
                    throw "invalid version";
                this.identity_data_raw = data["identity_data"];
                this.identity_data_sign = data["identity_sign"];
                this.identity_data = JSON.parse(this.identity_data);
                return;
            }
            encode() {
                return JSON.stringify({
                    version: 1,
                    identity_data: this.identity_data_raw,
                    identity_sign: this.identity_data_sign
                });
            }
            spawn_identity_handshake_handler(connection) {
                return new TeaForumHandshakeHandler(connection, this);
            }
        }
        identities.TeaForumIdentity = TeaForumIdentity;
        let static_identity;
        function set_static_identity(identity) {
            static_identity = identity;
        }
        identities.set_static_identity = set_static_identity;
        function setup_forum() {
            const user_data = settings.static("forum_user_data");
            const user_sign = settings.static("forum_user_sign");
            if (user_data && user_sign)
                static_identity = new TeaForumIdentity(user_data, user_sign);
        }
        identities.setup_forum = setup_forum;
        function valid_static_forum_identity() {
            return static_identity && static_identity.valid();
        }
        identities.valid_static_forum_identity = valid_static_forum_identity;
        function static_forum_identity() {
            return static_identity;
        }
        identities.static_forum_identity = static_forum_identity;
    })(identities = profiles.identities || (profiles.identities = {}));
})(profiles || (profiles = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["27aee012016554653f235f647c3f1590f0a606db80a1c8599c0e4fe45be685ba"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["27aee012016554653f235f647c3f1590f0a606db80a1c8599c0e4fe45be685ba"] = "27aee012016554653f235f647c3f1590f0a606db80a1c8599c0e4fe45be685ba";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "gyFHYbLJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (217,51)" }, { name: "if2CzY3O", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (233,55)" }, { name: "bzD3dSlJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (284,55)" }, { name: "gyzCc5ch", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (397,51)" }, { name: "AcPVQaoe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (405,46)" }, { name: "qSSX8GZY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/profiles/identities/TeamSpeakIdentity.ts (415,51)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../Identity.ts" />
var profiles;
(function (profiles) {
    var identities;
    (function (identities) {
        let CryptoHelper;
        (function (CryptoHelper) {
            function export_ecc_key(crypto_key, public_key) {
                return __awaiter(this, void 0, void 0, function* () {
                    /*
                        Tomcrypt public key export:
                        if (type == PK_PRIVATE) {
                           flags[0] = 1;
                           err = der_encode_sequence_multi(out, outlen,
                                                     LTC_ASN1_BIT_STRING,      1UL, flags,
                                                     LTC_ASN1_SHORT_INTEGER,   1UL, &key_size,
                                                     LTC_ASN1_INTEGER,         1UL, key->pubkey.x,
                                                     LTC_ASN1_INTEGER,         1UL, key->pubkey.y,
                                                     LTC_ASN1_INTEGER,         1UL, key->k,
                                                     LTC_ASN1_EOL,             0UL, NULL);
                        } else {
                           flags[0] = 0;
                           err = der_encode_sequence_multi(out, outlen,
                                                     LTC_ASN1_BIT_STRING,      1UL, flags,
                                                     LTC_ASN1_SHORT_INTEGER,   1UL, &key_size,
                                                     LTC_ASN1_INTEGER,         1UL, key->pubkey.x,
                                                     LTC_ASN1_INTEGER,         1UL, key->pubkey.y,
                                                     LTC_ASN1_EOL,             0UL, NULL);
                        }
        
                     */
                    const key_data = yield crypto.subtle.exportKey("jwk", crypto_key);
                    let index = 0;
                    const length = public_key ? 79 : 114; /* max lengths! Depends on the padding could be less */
                    const buffer = new Uint8Array(length); /* fixed ASN1 length */
                    { /* the initial sequence */
                        buffer[index++] = 0x30; /* type */
                        buffer[index++] = 0x00; /* we will set the sequence length later */
                    }
                    { /* the flags bit string */
                        buffer[index++] = 0x03; /* type */
                        buffer[index++] = 0x02; /* length */
                        buffer[index++] = 0x07; /* data */
                        buffer[index++] = public_key ? 0x00 : 0x80; /* flag 1 or 0 (1 = private key)*/
                    }
                    { /* key size (const 32 for P-256) */
                        buffer[index++] = 0x02; /* type */
                        buffer[index++] = 0x01; /* length */
                        buffer[index++] = 0x20;
                    }
                    try { /* Public kex X */
                        buffer[index++] = 0x02; /* type */
                        buffer[index++] = 0x20; /* length */
                        const raw = atob(Base64DecodeUrl(key_data.x, false));
                        if (raw.charCodeAt(0) > 0x7F) {
                            buffer[index - 1] += 1;
                            buffer[index++] = 0;
                        }
                        for (let i = 0; i < 32; i++)
                            buffer[index++] = raw.charCodeAt(i);
                    }
                    catch (error) {
                        if (error instanceof DOMException)
                            throw "failed to parse x coordinate (invalid base64)";
                        throw error;
                    }
                    try { /* Public kex Y */
                        buffer[index++] = 0x02; /* type */
                        buffer[index++] = 0x20; /* length */
                        const raw = atob(Base64DecodeUrl(key_data.y, false));
                        if (raw.charCodeAt(0) > 0x7F) {
                            buffer[index - 1] += 1;
                            buffer[index++] = 0;
                        }
                        for (let i = 0; i < 32; i++)
                            buffer[index++] = raw.charCodeAt(i);
                    }
                    catch (error) {
                        if (error instanceof DOMException)
                            throw "failed to parse y coordinate (invalid base64)";
                        throw error;
                    }
                    if (!public_key) {
                        try { /* Public kex K */
                            buffer[index++] = 0x02; /* type */
                            buffer[index++] = 0x20; /* length */
                            const raw = atob(Base64DecodeUrl(key_data.d, false));
                            if (raw.charCodeAt(0) > 0x7F) {
                                buffer[index - 1] += 1;
                                buffer[index++] = 0;
                            }
                            for (let i = 0; i < 32; i++)
                                buffer[index++] = raw.charCodeAt(i);
                        }
                        catch (error) {
                            if (error instanceof DOMException)
                                throw "failed to parse y coordinate (invalid base64)";
                            throw error;
                        }
                    }
                    buffer[1] = index - 2; /* set the final sequence length */
                    return base64ArrayBuffer(buffer.buffer.slice(0, index));
                });
            }
            CryptoHelper.export_ecc_key = export_ecc_key;
            const crypt_key = "b9dfaa7bee6ac57ac7b65f1094a1c155e747327bc2fe5d51c512023fe54a280201004e90ad1daaae1075d53b7d571c30e063b5a62a4a017bb394833aa0983e6e";
            function c_strlen(buffer, offset) {
                let index = 0;
                while (index + offset < buffer.length && buffer[index + offset] != 0)
                    index++;
                return index;
            }
            function decrypt_ts_identity(buffer) {
                return __awaiter(this, void 0, void 0, function* () {
                    /* buffer could contains a zero! */
                    const hash = new Uint8Array(yield sha.sha1(buffer.buffer.slice(20, 20 + c_strlen(buffer, 20))));
                    for (let i = 0; i < 20; i++)
                        buffer[i] ^= hash[i];
                    const length = Math.min(buffer.length, 100);
                    for (let i = 0; i < length; i++)
                        buffer[i] ^= crypt_key.charCodeAt(i);
                    return ab2str(buffer);
                });
            }
            CryptoHelper.decrypt_ts_identity = decrypt_ts_identity;
            function encrypt_ts_identity(buffer) {
                return __awaiter(this, void 0, void 0, function* () {
                    const length = Math.min(buffer.length, 100);
                    for (let i = 0; i < length; i++)
                        buffer[i] ^= crypt_key.charCodeAt(i);
                    const hash = new Uint8Array(yield sha.sha1(buffer.buffer.slice(20, 20 + c_strlen(buffer, 20))));
                    for (let i = 0; i < 20; i++)
                        buffer[i] ^= hash[i];
                    return base64ArrayBuffer(buffer);
                });
            }
            CryptoHelper.encrypt_ts_identity = encrypt_ts_identity;
            /**
             * @param buffer base64 encoded ASN.1 string
             */
            function decode_tomcrypt_key(buffer) {
                let decoded;
                try {
                    decoded = asn1.decode(atob(buffer));
                }
                catch (error) {
                    if (error instanceof DOMException)
                        throw "failed to parse key buffer (invalid base64)";
                    throw error;
                }
                let { x, y, k } = {
                    x: decoded.children[2].content(Infinity, asn1.TagType.VisibleString),
                    y: decoded.children[3].content(Infinity, asn1.TagType.VisibleString),
                    k: decoded.children[4].content(Infinity, asn1.TagType.VisibleString)
                };
                if (x.length > 32) {
                    if (x.charCodeAt(0) != 0)
                        throw "Invalid X coordinate! (Too long)";
                    x = x.substr(1);
                }
                if (y.length > 32) {
                    if (y.charCodeAt(0) != 0)
                        throw "Invalid Y coordinate! (Too long)";
                    y = y.substr(1);
                }
                if (k.length > 32) {
                    if (k.charCodeAt(0) != 0)
                        throw "Invalid private coordinate! (Too long)";
                    k = k.substr(1);
                }
                /*
                console.log("Key x: %s (%d)", btoa(x), x.length);
                console.log("Key y: %s (%d)", btoa(y), y.length);
                console.log("Key k: %s (%d)", btoa(k), k.length);
                */
                return {
                    crv: "P-256",
                    d: Base64EncodeUrl(btoa(k)),
                    x: Base64EncodeUrl(btoa(x)),
                    y: Base64EncodeUrl(btoa(y)),
                    ext: true,
                    key_ops: ["deriveKey", "sign"],
                    kty: "EC",
                };
            }
            CryptoHelper.decode_tomcrypt_key = decode_tomcrypt_key;
        })(CryptoHelper = identities.CryptoHelper || (identities.CryptoHelper = {}));
        class TeaSpeakHandshakeHandler extends identities.AbstractHandshakeIdentityHandler {
            constructor(connection, identity) {
                super(connection);
                this.identity = identity;
                this.handler = new identities.HandshakeCommandHandler(connection, this);
                this.handler["handshakeidentityproof"] = this.handle_proof.bind(this);
            }
            start_handshake() {
                this.connection.command_handler_boss().register_handler(this.handler);
                this.connection.send_command("handshakebegin", {
                    intention: 0,
                    authentication_method: this.identity.type(),
                    publicKey: this.identity.public_key
                }).catch(error => {
                    log.error(LogCategory.IDENTITIES, _translations.gyFHYbLJ || (_translations.gyFHYbLJ = tr("Failed to initialize TeamSpeak based handshake. Error: %o")), error);
                    if (error instanceof CommandResult)
                        error = error.extra_message || error.message;
                    this.trigger_fail("failed to execute begin (" + error + ")");
                });
            }
            handle_proof(json) {
                if (!json[0]["digest"]) {
                    this.trigger_fail("server too old");
                    return;
                }
                this.identity.sign_message(json[0]["message"], json[0]["digest"]).then(proof => {
                    this.connection.send_command("handshakeindentityproof", { proof: proof }).catch(error => {
                        log.error(LogCategory.IDENTITIES, _translations.if2CzY3O || (_translations.if2CzY3O = tr("Failed to proof the identity. Error: %o")), error);
                        if (error instanceof CommandResult)
                            error = error.extra_message || error.message;
                        this.trigger_fail("failed to execute proof (" + error + ")");
                    }).then(() => this.trigger_success());
                }).catch(error => {
                    this.trigger_fail("failed to sign message");
                });
            }
            trigger_fail(message) {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_fail(message);
            }
            trigger_success() {
                this.connection.command_handler_boss().unregister_handler(this.handler);
                super.trigger_success();
            }
        }
        class IdentityPOWWorker {
            initialize(key) {
                return __awaiter(this, void 0, void 0, function* () {
                    this._worker = new Worker(settings.static("worker_directory", "js/workers/") + "WorkerPOW.js");
                    /* initialize */
                    yield new Promise((resolve, reject) => {
                        const timeout_id = setTimeout(() => reject("timeout"), 1000);
                        this._worker.onmessage = event => {
                            clearTimeout(timeout_id);
                            if (!event.data) {
                                reject("invalid data");
                                return;
                            }
                            if (!event.data.success) {
                                reject("initialize failed (" + event.data.success + " | " + (event.data.message || "unknown eroror") + ")");
                                return;
                            }
                            this._worker.onmessage = event => this.handle_message(event.data);
                            resolve();
                        };
                        this._worker.onerror = event => {
                            log.error(LogCategory.IDENTITIES, _translations.bzD3dSlJ || (_translations.bzD3dSlJ = tr("POW Worker error %o")), event);
                            clearTimeout(timeout_id);
                            reject("Failed to load worker (" + event.message + ")");
                        };
                    });
                    /* set data */
                    yield new Promise((resolve, reject) => {
                        this._worker.postMessage({
                            type: "set_data",
                            private_key: key,
                            code: "set_data"
                        });
                        const timeout_id = setTimeout(() => reject("timeout (data)"), 1000);
                        this._worker.onmessage = event => {
                            clearTimeout(timeout_id);
                            if (!event.data) {
                                reject("invalid data");
                                return;
                            }
                            if (!event.data.success) {
                                reject("initialize of data failed (" + event.data.success + " | " + (event.data.message || "unknown eroror") + ")");
                                return;
                            }
                            this._worker.onmessage = event => this.handle_message(event.data);
                            resolve();
                        };
                    });
                });
            }
            mine(hash, iterations, target, timeout) {
                return __awaiter(this, void 0, void 0, function* () {
                    this._current_hash = hash;
                    if (target < this._best_level)
                        return true;
                    return yield new Promise((resolve, reject) => {
                        this._worker.postMessage({
                            type: "mine",
                            hash: this._current_hash,
                            iterations: iterations,
                            target: target,
                            code: "mine"
                        });
                        const timeout_id = setTimeout(() => reject("timeout (mine)"), timeout || 5000);
                        this._worker.onmessage = event => {
                            this._worker.onmessage = event => this.handle_message(event.data);
                            clearTimeout(timeout_id);
                            if (!event.data) {
                                reject("invalid data");
                                return;
                            }
                            if (!event.data.success) {
                                reject("mining failed (" + event.data.success + " | " + (event.data.message || "unknown eroror") + ")");
                                return;
                            }
                            if (event.data.result) {
                                this._best_level = event.data.level;
                                this._current_hash = event.data.hash;
                                resolve(true);
                            }
                            else {
                                resolve(false); /* no result */
                            }
                        };
                    });
                });
            }
            current_hash() {
                return this._current_hash;
            }
            current_level() {
                return this._best_level;
            }
            finalize(timeout) {
                return __awaiter(this, void 0, void 0, function* () {
                    try {
                        yield new Promise((resolve, reject) => {
                            this._worker.postMessage({
                                type: "finalize",
                                code: "finalize"
                            });
                            const timeout_id = setTimeout(() => reject("timeout"), timeout || 250);
                            this._worker.onmessage = event => {
                                this._worker.onmessage = event => this.handle_message(event.data);
                                clearTimeout(timeout_id);
                                if (!event.data) {
                                    reject("invalid data");
                                    return;
                                }
                                if (!event.data.success) {
                                    reject("failed to finalize (" + event.data.success + " | " + (event.data.message || "unknown eroror") + ")");
                                    return;
                                }
                                resolve();
                            };
                        });
                    }
                    catch (error) {
                        log.error(LogCategory.IDENTITIES, _translations.gyzCc5ch || (_translations.gyzCc5ch = tr("Failed to finalize POW worker! (%o)")), error);
                    }
                    this._worker.terminate();
                    this._worker = undefined;
                });
            }
            handle_message(message) {
                log.info(LogCategory.IDENTITIES, _translations.AcPVQaoe || (_translations.AcPVQaoe = tr("Received message: %o")), message);
            }
        }
        class TeaSpeakIdentity {
            constructor(private_key, hash, name, initialize) {
                this.private_key = private_key;
                this.hash_number = hash || "0";
                this._name = name;
                if (this.private_key && (typeof (initialize) === "undefined" || initialize)) {
                    this.initialize().catch(error => {
                        log.error(LogCategory.IDENTITIES, "Failed to initialize TeaSpeakIdentity (%s)", error);
                        this._initialized = false;
                    });
                }
            }
            static generate_new() {
                return __awaiter(this, void 0, void 0, function* () {
                    let key;
                    try {
                        key = yield crypto.subtle.generateKey({ name: 'ECDH', namedCurve: 'P-256' }, true, ["deriveKey"]);
                    }
                    catch (e) {
                        log.error(LogCategory.IDENTITIES, _translations.qSSX8GZY || (_translations.qSSX8GZY = tr("Could not generate a new key: %o")), e);
                        throw "Failed to generate keypair";
                    }
                    const private_key = yield CryptoHelper.export_ecc_key(key.privateKey, false);
                    const identity = new TeaSpeakIdentity(private_key, "0", undefined, false);
                    yield identity.initialize();
                    return identity;
                });
            }
            static import_ts(ts_string, ini) {
                return __awaiter(this, void 0, void 0, function* () {
                    const parse_string = string => {
                        /* parsing without INI structure */
                        const V_index = string.indexOf('V');
                        if (V_index == -1)
                            throw "invalid input (missing V)";
                        return {
                            hash: string.substr(0, V_index),
                            data: string.substr(V_index + 1),
                            name: "TeaSpeak user"
                        };
                    };
                    const { hash, data, name } = (!ini ? () => parse_string(ts_string) : () => {
                        /* parsing with INI structure */
                        let identity, name;
                        for (const line of ts_string.split("\n")) {
                            if (line.startsWith("identity="))
                                identity = line.substr(9);
                            else if (line.startsWith("nickname="))
                                name = line.substr(9);
                        }
                        if (!identity)
                            throw "missing identity keyword";
                        if (identity[0] == "\"" && identity[identity.length - 1] == "\"")
                            identity = identity.substr(1, identity.length - 2);
                        const result = parse_string(identity);
                        result.name = name || result.name;
                        return result;
                    })();
                    if (!ts_string.match(/[0-9]+/g))
                        throw "invalid hash!";
                    const key64 = yield CryptoHelper.decrypt_ts_identity(new Uint8Array(arrayBufferBase64(data)));
                    const identity = new TeaSpeakIdentity(key64, hash, name, false);
                    yield identity.initialize();
                    return identity;
                });
            }
            name() {
                return this._name;
            }
            uid() {
                return this._unique_id;
            }
            type() {
                return identities.IdentitifyType.TEAMSPEAK;
            }
            valid() {
                return this._initialized && !!this._crypto_key && !!this._crypto_key_sign;
            }
            decode(data) {
                return __awaiter(this, void 0, void 0, function* () {
                    const json = JSON.parse(data);
                    if (!json)
                        throw "invalid json";
                    if (json.version == 2) {
                        this.private_key = json.key;
                        this.hash_number = json.hash;
                        this._name = json.name;
                    }
                    else if (json.version == 1) {
                        const key = json.key;
                        this._name = json.name;
                        const clone = yield TeaSpeakIdentity.import_ts(key, false);
                        this.private_key = clone.private_key;
                        this.hash_number = clone.hash_number;
                    }
                    else
                        throw "invalid version";
                    yield this.initialize();
                });
            }
            encode() {
                return JSON.stringify({
                    key: this.private_key,
                    hash: this.hash_number,
                    name: this._name,
                    version: 2
                });
            }
            level() {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this._initialized || !this.public_key)
                        throw "not initialized";
                    const hash = new Uint8Array(yield sha.sha1(this.public_key + this.hash_number));
                    let level = 0;
                    while (level < hash.byteLength && hash[level] == 0)
                        level++;
                    if (level >= hash.byteLength) {
                        level = 256;
                    }
                    else {
                        let byte = hash[level];
                        level <<= 3;
                        while ((byte & 0x1) == 0) {
                            level++;
                            byte >>= 1;
                        }
                    }
                    return level;
                });
            }
            /**
             * @param {string} a
             * @param {string} b
             * @description b must be smaller (in bytes) then a
             */
            string_add(a, b) {
                const char_result = [];
                const char_a = [...a].reverse().map(e => e.charCodeAt(0));
                const char_b = [...b].reverse().map(e => e.charCodeAt(0));
                let carry = false;
                while (char_b.length > 0) {
                    let result = char_b.pop_front() + char_a.pop_front() + (carry ? 1 : 0) - 48;
                    if ((carry = result > 57))
                        result -= 10;
                    char_result.push(result);
                }
                while (char_a.length > 0) {
                    let result = char_a.pop_front() + (carry ? 1 : 0);
                    if ((carry = result > 57))
                        result -= 10;
                    char_result.push(result);
                }
                if (carry)
                    char_result.push(49);
                return String.fromCharCode.apply(null, char_result.reverse());
            }
            improve_level_for(time, threads) {
                return __awaiter(this, void 0, void 0, function* () {
                    let active = true;
                    setTimeout(() => active = false, time);
                    return yield this.improve_level(-1, threads, () => active);
                });
            }
            improve_level(target, threads, active_callback, callback_level, callback_status) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this._initialized || !this.public_key)
                        throw "not initialized";
                    if (target == -1) /* get the highest level possible */
                        target = 0;
                    else if (target <= (yield this.level()))
                        return true;
                    const workers = [];
                    const iterations = 100000;
                    let current_hash;
                    const next_hash = () => {
                        if (!current_hash)
                            return (current_hash = this.hash_number);
                        if (current_hash.length < iterations.toString().length) {
                            current_hash = this.string_add(iterations.toString(), current_hash);
                        }
                        else {
                            current_hash = this.string_add(current_hash, iterations.toString());
                        }
                        return current_hash;
                    };
                    { /* init */
                        const initialize_promise = [];
                        for (let index = 0; index < threads; index++) {
                            const worker = new IdentityPOWWorker();
                            workers.push(worker);
                            initialize_promise.push(worker.initialize(this.public_key));
                        }
                        try {
                            yield Promise.all(initialize_promise);
                        }
                        catch (error) {
                            log.error(LogCategory.IDENTITIES, error);
                            throw "failed to initialize";
                        }
                    }
                    let result = false;
                    let best_level = 0;
                    let target_level = target > 0 ? target : (yield this.level()) + 1;
                    const worker_promise = [];
                    const hash_timestamps = [];
                    let last_hashrate_update = 0;
                    const update_hashrate = () => {
                        if (!callback_status)
                            return;
                        const now = Date.now();
                        hash_timestamps.push(now);
                        if (last_hashrate_update + 1000 < now) {
                            last_hashrate_update = now;
                            const timeout = now - 10 * 1000; /* 10s */
                            const rounds = hash_timestamps.filter(e => e > timeout);
                            callback_status(Math.ceil((rounds.length * iterations) / Math.ceil((now - rounds[0]) / 1000)));
                        }
                    };
                    try {
                        result = yield new Promise((resolve, reject) => {
                            let active = true;
                            const exit = () => {
                                const timeout = setTimeout(() => resolve(true), 1000);
                                Promise.all(worker_promise).then(result => {
                                    clearTimeout(timeout);
                                    resolve(true);
                                }).catch(error => resolve(true));
                                active = false;
                            };
                            for (const worker of workers) {
                                const worker_mine = () => {
                                    if (!active)
                                        return;
                                    const promise = worker.mine(next_hash(), iterations, target_level);
                                    const p = promise.then(result => {
                                        update_hashrate();
                                        worker_promise.remove(p);
                                        if (result.valueOf()) {
                                            if (worker.current_level() > best_level) {
                                                this.hash_number = worker.current_hash();
                                                log.info(LogCategory.IDENTITIES, "Found new best at %s (%d). Old was %d", this.hash_number, worker.current_level(), best_level);
                                                best_level = worker.current_level();
                                                if (callback_level)
                                                    callback_level(best_level);
                                            }
                                            if (active) {
                                                if (target > 0)
                                                    exit();
                                                else
                                                    target_level = best_level + 1;
                                            }
                                        }
                                        if (active && (active = active_callback()))
                                            setTimeout(() => worker_mine(), 0);
                                        else {
                                            exit();
                                        }
                                        return Promise.resolve();
                                    }).catch(error => {
                                        worker_promise.remove(p);
                                        log.warn(LogCategory.IDENTITIES, "POW worker error %o", error);
                                        reject(error);
                                        return Promise.resolve();
                                    });
                                    worker_promise.push(p);
                                };
                                worker_mine();
                            }
                        });
                    }
                    catch (error) {
                        //error already printed before reject had been called
                    }
                    { /* shutdown */
                        const finalize_promise = [];
                        for (const worker of workers)
                            finalize_promise.push(worker.finalize(250));
                        try {
                            yield Promise.all(finalize_promise);
                        }
                        catch (error) {
                            log.error(LogCategory.IDENTITIES, error);
                            throw "failed to finalize";
                        }
                    }
                    return result;
                });
            }
            initialize() {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this.private_key)
                        throw "Invalid private key";
                    let jwk;
                    try {
                        jwk = yield CryptoHelper.decode_tomcrypt_key(this.private_key);
                        if (!jwk)
                            throw "result undefined";
                    }
                    catch (error) {
                        throw "failed to parse key (" + error + ")";
                    }
                    try {
                        this._crypto_key_sign = yield crypto.subtle.importKey("jwk", jwk, { name: 'ECDSA', namedCurve: 'P-256' }, false, ["sign"]);
                    }
                    catch (error) {
                        log.error(LogCategory.IDENTITIES, error);
                        throw "failed to create crypto sign key";
                    }
                    try {
                        this._crypto_key = yield crypto.subtle.importKey("jwk", jwk, { name: 'ECDH', namedCurve: 'P-256' }, true, ["deriveKey"]);
                    }
                    catch (error) {
                        log.error(LogCategory.IDENTITIES, error);
                        throw "failed to create crypto key";
                    }
                    try {
                        this.public_key = yield CryptoHelper.export_ecc_key(this._crypto_key, true);
                        this._unique_id = base64ArrayBuffer(yield sha.sha1(this.public_key));
                    }
                    catch (error) {
                        log.error(LogCategory.IDENTITIES, error);
                        throw "failed to calculate unique id";
                    }
                    this._initialized = true;
                    //const public_key = await profiles.identities.CryptoHelper.export_ecc_key(key, true);
                });
            }
            export_ts(ini) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (!this.private_key)
                        throw "Invalid private key";
                    const identity = this.hash_number + "V" + (yield CryptoHelper.encrypt_ts_identity(new Uint8Array(str2ab8(this.private_key))));
                    if (!ini)
                        return identity;
                    return "[Identity]\n" +
                        "id=TeaWeb-Exported\n" +
                        "identity=\"" + identity + "\"\n" +
                        "nickname=\"" + this.name() + "\"\n" +
                        "phonetic_nickname=";
                });
            }
            sign_message(message, hash = "SHA-256") {
                return __awaiter(this, void 0, void 0, function* () {
                    /* bring this to libtomcrypt format */
                    const sign_buffer = yield crypto.subtle.sign({
                        name: "ECDSA",
                        hash: hash
                    }, this._crypto_key_sign, str2ab8(message));
                    const sign = new Uint8Array(sign_buffer);
                    /* first 32 r bits | last 32 s bits */
                    const buffer = new Uint8Array(72);
                    let index = 0;
                    { /* the initial sequence */
                        buffer[index++] = 0x30; /* type */
                        buffer[index++] = 0x00; /* we will set the sequence length later */
                    }
                    { /* integer r  */
                        buffer[index++] = 0x02; /* type */
                        buffer[index++] = 0x20; /* length */
                        if (sign[0] > 0x7F) {
                            buffer[index - 1] += 1;
                            buffer[index++] = 0;
                        }
                        for (let i = 0; i < 32; i++)
                            buffer[index++] = sign[i];
                    }
                    { /* integer s  */
                        buffer[index++] = 0x02; /* type */
                        buffer[index++] = 0x20; /* length */
                        if (sign[32] > 0x7F) {
                            buffer[index - 1] += 1;
                            buffer[index++] = 0;
                        }
                        for (let i = 0; i < 32; i++)
                            buffer[index++] = sign[32 + i];
                    }
                    buffer[1] = index - 2;
                    return base64ArrayBuffer(buffer.subarray(0, index));
                });
            }
            spawn_identity_handshake_handler(connection) {
                return new TeaSpeakHandshakeHandler(connection, this);
            }
        }
        identities.TeaSpeakIdentity = TeaSpeakIdentity;
    })(identities = profiles.identities || (profiles.identities = {}));
})(profiles || (profiles = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["30df4157b8dd68f39f713168a36d0e3b6c311e49e238c7945be34104a9ba955b"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["30df4157b8dd68f39f713168a36d0e3b6c311e49e238c7945be34104a9ba955b"] = "30df4157b8dd68f39f713168a36d0e3b6c311e49e238c7945be34104a9ba955b";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Axh_mIkE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (231,19)" }, { name: "W4AWr4Lx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (253,37)" }, { name: "zhK9MvBD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (257,43)" }, { name: "dGLVGK5m", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (285,33)" }, { name: "LlhUU7r7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (293,35)" }, { name: "eo_GiRfD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (302,34)" }, { name: "WCTBcSDx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (329,25)" }, { name: "GefCJcJ9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (339,30)" }, { name: "rytPYsZi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (348,33)" }, { name: "Tv_e4tXd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/sound/Sounds.ts (380,34)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var Sound;
(function (Sound) {
    Sound["SOUND_TEST"] = "sound.test";
    Sound["SOUND_EGG"] = "sound.egg";
    Sound["AWAY_ACTIVATED"] = "away_activated";
    Sound["AWAY_DEACTIVATED"] = "away_deactivated";
    Sound["CONNECTION_CONNECTED"] = "connection.connected";
    Sound["CONNECTION_DISCONNECTED"] = "connection.disconnected";
    Sound["CONNECTION_BANNED"] = "connection.banned";
    Sound["CONNECTION_DISCONNECTED_TIMEOUT"] = "connection.disconnected.timeout";
    Sound["CONNECTION_REFUSED"] = "connection.refused";
    Sound["SERVER_EDITED"] = "server.edited";
    Sound["SERVER_EDITED_SELF"] = "server.edited.self";
    Sound["SERVER_KICKED"] = "server.kicked";
    Sound["CHANNEL_CREATED"] = "channel.created";
    Sound["CHANNEL_MOVED"] = "channel.moved";
    Sound["CHANNEL_EDITED"] = "channel.edited";
    Sound["CHANNEL_EDITED_SELF"] = "channel.edited.self";
    Sound["CHANNEL_DELETED"] = "channel.deleted";
    Sound["CHANNEL_JOINED"] = "channel.joined";
    Sound["CHANNEL_KICKED"] = "channel.kicked";
    Sound["USER_MOVED"] = "user.moved";
    Sound["USER_MOVED_SELF"] = "user.moved.self";
    Sound["USER_POKED_SELF"] = "user.poked.self";
    Sound["USER_BANNED"] = "user.banned";
    Sound["USER_ENTERED"] = "user.joined";
    Sound["USER_ENTERED_MOVED"] = "user.joined.moved";
    Sound["USER_ENTERED_KICKED"] = "user.joined.kicked";
    Sound["USER_ENTERED_CONNECT"] = "user.joined.connect";
    Sound["USER_LEFT"] = "user.left";
    Sound["USER_LEFT_MOVED"] = "user.left.moved";
    Sound["USER_LEFT_KICKED_CHANNEL"] = "user.left.kicked.server";
    Sound["USER_LEFT_KICKED_SERVER"] = "user.left.kicked.channel";
    Sound["USER_LEFT_DISCONNECT"] = "user.left.disconnect";
    Sound["USER_LEFT_BANNED"] = "user.left.banned";
    Sound["USER_LEFT_TIMEOUT"] = "user.left.timeout";
    Sound["ERROR_INSUFFICIENT_PERMISSIONS"] = "error.insufficient_permissions";
    Sound["MESSAGE_SEND"] = "message.send";
    Sound["MESSAGE_RECEIVED"] = "message.received";
    Sound["GROUP_SERVER_ASSIGNED"] = "group.server.assigned";
    Sound["GROUP_SERVER_REVOKED"] = "group.server.revoked";
    Sound["GROUP_CHANNEL_CHANGED"] = "group.channel.changed";
    Sound["GROUP_SERVER_ASSIGNED_SELF"] = "group.server.assigned.self";
    Sound["GROUP_SERVER_REVOKED_SELF"] = "group.server.revoked.self";
    Sound["GROUP_CHANNEL_CHANGED_SELF"] = "group.channel.changed.self";
})(Sound || (Sound = {}));
var sound;
(function (sound_1) {
    let warned = false;
    let speech_mapping = {};
    let volume_require_save = false;
    let speech_volume = {};
    let master_volume;
    let overlap_sounds;
    let ignore_muted;
    let master_mixed;
    function register_sound(key, file) {
        speech_mapping[key] = { key: key, filename: file };
    }
    function get_sound_volume(sound, default_volume) {
        let result = speech_volume[sound];
        if (typeof (result) === "undefined") {
            if (typeof (default_volume) !== "undefined")
                result = default_volume;
            else
                result = 1;
        }
        return result;
    }
    sound_1.get_sound_volume = get_sound_volume;
    function set_sound_volume(sound, volume) {
        volume_require_save = volume_require_save || speech_volume[sound] != volume;
        speech_volume[sound] = volume == 1 ? undefined : volume;
    }
    sound_1.set_sound_volume = set_sound_volume;
    function get_master_volume() {
        return master_volume;
    }
    sound_1.get_master_volume = get_master_volume;
    function set_master_volume(volume) {
        volume_require_save = volume_require_save || master_volume != volume;
        master_volume = volume;
        if (master_mixed) {
            if (master_mixed.gain.setValueAtTime)
                master_mixed.gain.setValueAtTime(volume, 0);
            else
                master_mixed.gain.value = volume;
        }
    }
    sound_1.set_master_volume = set_master_volume;
    function overlap_activated() {
        return overlap_sounds;
    }
    sound_1.overlap_activated = overlap_activated;
    function set_overlap_activated(flag) {
        volume_require_save = volume_require_save || overlap_sounds != flag;
        overlap_sounds = flag;
    }
    sound_1.set_overlap_activated = set_overlap_activated;
    function ignore_output_muted() {
        return ignore_muted;
    }
    sound_1.ignore_output_muted = ignore_output_muted;
    function set_ignore_output_muted(flag) {
        volume_require_save = volume_require_save || ignore_muted != flag;
        ignore_muted = flag;
    }
    sound_1.set_ignore_output_muted = set_ignore_output_muted;
    function reinitialisize_audio() {
        const context = audio.player.context();
        const destination = audio.player.destination();
        if (master_mixed)
            master_mixed.disconnect();
        master_mixed = context.createGain();
        if (master_mixed.gain.setValueAtTime)
            master_mixed.gain.setValueAtTime(master_volume, 0);
        else
            master_mixed.gain.value = master_volume;
        master_mixed.connect(destination);
    }
    sound_1.reinitialisize_audio = reinitialisize_audio;
    function save() {
        if (volume_require_save) {
            volume_require_save = false;
            const data = {};
            data.version = 1;
            for (const sound in Sound) {
                if (typeof (speech_volume[sound]) !== "undefined")
                    data[sound] = speech_volume[sound];
            }
            data.master = master_volume;
            data.overlap = overlap_sounds;
            data.ignore_muted = ignore_muted;
            settings.changeGlobal("sound_volume", JSON.stringify(data));
            console.error(data);
        }
    }
    sound_1.save = save;
    function initialize() {
        $.ajaxSetup({
            beforeSend: function (jqXHR, settings) {
                if (settings.dataType === 'binary') {
                    settings.xhr().responseType = 'arraybuffer';
                    settings.processData = false;
                }
            }
        });
        /* volumes */
        {
            const data = JSON.parse(settings.static_global("sound_volume", "{}"));
            for (const sound in Sound) {
                if (typeof (data[sound]) !== "undefined")
                    speech_volume[sound] = data[sound];
            }
            console.error(data);
            master_volume = data.master || 1;
            overlap_sounds = data.overlap || true;
            ignore_muted = data.ignore_muted || true;
        }
        register_sound("message.received", "effects/message_received.wav");
        register_sound("message.send", "effects/message_send.wav");
        sound_1.manager = new SoundManager(undefined);
        audio.player.on_ready(reinitialisize_audio);
        return new Promise(resolve => {
            $.ajax({
                url: "audio/speech/mapping.json",
                success: response => {
                    if (typeof (response) === "string")
                        response = JSON.parse(response);
                    for (const entry of response)
                        register_sound(entry.key, "speech/" + entry.file);
                    resolve();
                },
                error: () => {
                    console.log("error!");
                    console.dir(...arguments);
                },
                timeout: 5000,
                async: true,
                type: 'GET'
            });
        });
    }
    sound_1.initialize = initialize;
    function resolve_sound(sound) {
        return __awaiter(this, void 0, void 0, function* () {
            const file = speech_mapping[sound];
            if (!file)
                throw _translations.Axh_mIkE || (_translations.Axh_mIkE = tr("Missing sound handle"));
            if (file.not_supported) {
                if (!file.not_supported_timeout || Date.now() < file.not_supported_timeout) //Test if the not supported flag has been expired
                    return file;
                file.not_supported = false;
                file.not_supported_timeout = undefined;
            }
            const context = audio.player.context();
            if (!context)
                return file;
            const path = "audio/" + file.filename;
            if (context.decodeAudioData) {
                if (!file.cached) {
                    const decode_data = buffer => {
                        console.log(buffer);
                        try {
                            console.log(_translations.W4AWr4Lx || (_translations.W4AWr4Lx = tr("Decoding data")));
                            context.decodeAudioData(buffer, result => {
                                file.cached = result;
                            }, error => {
                                console.error(_translations.zhK9MvBD || (_translations.zhK9MvBD = tr("Failed to decode audio data for %o")), sound);
                                console.error(error);
                                file.not_supported = true;
                                file.not_supported_timeout = Date.now() + 1000 * 60 * 2; //Try in 2min again!
                            });
                        }
                        catch (error) {
                            console.error(error);
                            file.not_supported = true;
                            file.not_supported_timeout = Date.now() + 1000 * 60 * 2; //Try in 2min again!
                        }
                    };
                    const xhr = new XMLHttpRequest();
                    xhr.open('GET', path, true);
                    xhr.responseType = 'arraybuffer';
                    try {
                        const result = new Promise((resolve, reject) => {
                            xhr.onload = resolve;
                            xhr.onerror = reject;
                        });
                        xhr.send();
                        yield result;
                        if (xhr.status != 200)
                            throw "invalid response code (" + xhr.status + ")";
                        console.log(_translations.dGLVGK5m || (_translations.dGLVGK5m = tr("Decoding data")));
                        try {
                            file.cached = yield context.decodeAudioData(xhr.response);
                        }
                        catch (error) {
                            console.error(error);
                            throw "failed to decode audio data";
                        }
                    }
                    catch (error) {
                        console.error(_translations.LlhUU7r7 || (_translations.LlhUU7r7 = tr("Failed to load audio file %s. Error: %o")), sound, error);
                        file.not_supported = true;
                        file.not_supported_timeout = Date.now() + 1000 * 60 * 2; //Try in 2min again!
                    }
                }
            }
            else {
                if (!file.node) {
                    if (!warned) {
                        warned = true;
                        console.warn(_translations.eo_GiRfD || (_translations.eo_GiRfD = tr("Your browser does not support decodeAudioData! Using a node to playback! This bypasses the audio output and volume regulation!")));
                    }
                    const container = $("#sounds");
                    const node = $.spawn("audio").attr("src", path);
                    node.appendTo(container);
                    file.node = node[0];
                }
            }
            return file;
        });
    }
    sound_1.resolve_sound = resolve_sound;
    class SoundManager {
        constructor(handle) {
            this._playing_sounds = {};
            this._handle = handle;
        }
        play(_sound, options) {
            options = options || {};
            const volume = get_sound_volume(_sound, options.default_volume);
            console.log(_translations.WCTBcSDx || (_translations.WCTBcSDx = tr("Replaying sound %s (Sound volume: %o | Master volume %o)")), _sound, volume, master_volume);
            if (volume == 0 || master_volume == 0)
                return;
            if (this._handle && !options.ignore_muted && !sound.ignore_output_muted() && this._handle.client_status.output_muted)
                return;
            const context = audio.player.context();
            if (!context) {
                console.warn(_translations.GefCJcJ9 || (_translations.GefCJcJ9 = tr("Tried to replay a sound without an audio context (Sound: %o). Dropping playback")), _sound);
                return;
            }
            sound.resolve_sound(_sound).then(handle => {
                if (!handle)
                    return;
                if (!options.ignore_overlap && (this._playing_sounds[_sound] > 0) && !sound.overlap_activated()) {
                    console.log(_translations.rytPYsZi || (_translations.rytPYsZi = tr("Dropping requested playback for sound %s because it would overlap.")), _sound);
                    return;
                }
                if (handle.cached) {
                    this._playing_sounds[_sound] = Date.now();
                    const player = context.createBufferSource();
                    player.buffer = handle.cached;
                    player.start(0);
                    handle.replaying = true;
                    player.onended = event => {
                        delete this._playing_sounds[_sound];
                    };
                    if (volume != 1 && context.createGain) {
                        const gain = context.createGain();
                        if (gain.gain.setValueAtTime)
                            gain.gain.setValueAtTime(volume, 0);
                        else
                            gain.gain.value = volume;
                        player.connect(gain);
                        gain.connect(master_mixed);
                    }
                    else {
                        player.connect(master_mixed);
                    }
                }
                else if (handle.node) {
                    handle.node.currentTime = 0;
                    handle.node.play();
                }
                else {
                    console.warn(_translations.Tv_e4tXd || (_translations.Tv_e4tXd = tr("Failed to replay sound because of missing handles.")), sound);
                    return;
                }
            });
        }
    }
    sound_1.SoundManager = SoundManager;
})(sound || (sound = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["b5cc862c8df6226394fd5871fa4fc231bfdda834dfb13d4057d783ad8f767e0b"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["b5cc862c8df6226394fd5871fa4fc231bfdda834dfb13d4057d783ad8f767e0b"] = "b5cc862c8df6226394fd5871fa4fc231bfdda834dfb13d4057d783ad8f767e0b";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var htmltags;
(function (htmltags) {
    let mouse_coordinates = { x: 0, y: 0 };
    function initialize() {
        document.addEventListener('mousemove', event => {
            mouse_coordinates.x = event.pageX;
            mouse_coordinates.y = event.pageY;
        });
    }
    initialize();
    /* required for the bbcodes */
    function generate_client_open(properties) {
        let result = "";
        /* build the opening tag: <div ...> */
        result = result + "<div class='htmltag-client' ";
        if (properties.client_id)
            result = result + "client-id='" + properties.client_id + "' ";
        if (properties.client_unique_id && properties.client_unique_id != "unknown")
            result = result + "client-unique-id='" + encodeURIComponent(properties.client_unique_id) + "' ";
        if (properties.client_name)
            result = result + "client-name='" + encodeURIComponent(properties.client_name) + "' ";
        /* add the click handler */
        result += "oncontextmenu='return htmltags.callbacks.callback_context_client($(this));'";
        result = result + ">";
        return result;
    }
    function generate_client(properties) {
        let result = generate_client_open(properties);
        /* content */
        {
            if (properties.add_braces)
                result = result + "\"";
            result = result + MessageHelper.htmlEscape(properties.client_name || "undefined").join(" ");
            if (properties.add_braces)
                result = result + "\"";
        }
        /* close tag */
        {
            result += "</div>";
        }
        return result;
    }
    htmltags.generate_client = generate_client;
    /* required for the bbcodes */
    function generate_channel_open(properties) {
        let result = "";
        /* build the opening tag: <div ...> */
        result = result + "<div class='htmltag-channel' ";
        if (properties.channel_id)
            result = result + "channel-id='" + properties.channel_id + "' ";
        if (properties.channel_name)
            result = result + "channel-name='" + encodeURIComponent(properties.channel_name) + "' ";
        /* add the click handler */
        result += "oncontextmenu='return htmltags.callbacks.callback_context_channel($(this));'";
        result = result + ">";
        return result;
    }
    function generate_channel(properties) {
        let result = generate_channel_open(properties);
        /* content */
        {
            if (properties.add_braces)
                result = result + "\"";
            result = result + MessageHelper.htmlEscape(properties.channel_display_name || properties.channel_name || "undefined").join(" ");
            if (properties.add_braces)
                result = result + "\"";
        }
        /* close tag */
        {
            result += "</div>";
        }
        return result;
    }
    htmltags.generate_channel = generate_channel;
    let callbacks;
    (function (callbacks) {
        function callback_context_client(element) {
            const client_id = parseInt(element.attr("client-id") || "0");
            const client_unique_id = decodeURIComponent(element.attr("client-unique-id") || "");
            /* we ignore the name, we cant find clients by name because the name is too volatile*/
            let client;
            const current_connection = server_connections.active_connection_handler();
            if (current_connection && current_connection.channelTree) {
                if (!client && client_id) {
                    client = current_connection.channelTree.findClient(client_id);
                    if (client && (client_unique_id && client.properties.client_unique_identifier != client_unique_id)) {
                        client = undefined; /* client id dosn't match anymore, lets search for the unique id */
                    }
                }
                if (!client && client_unique_id)
                    client = current_connection.channelTree.find_client_by_unique_id(client_unique_id);
            }
            if (!client) {
                /* we may should open a "offline" menu? */
                log.debug(LogCategory.GENERAL, "Failed to resolve client from html tag. Client id: %o, Client unique id: %o, Client name: %o", client_id, client_unique_id, decodeURIComponent(element.attr("client-name")));
                return false;
            }
            client.showContextMenu(mouse_coordinates.x, mouse_coordinates.y);
            return false;
        }
        callbacks.callback_context_client = callback_context_client;
        function callback_context_channel(element) {
            const channel_id = parseInt(element.attr("channel-id") || "0");
            const current_connection = server_connections.active_connection_handler();
            let channel;
            if (current_connection && current_connection.channelTree) {
                channel = current_connection.channelTree.findChannel(channel_id);
            }
            if (!channel)
                return false;
            channel.showContextMenu(mouse_coordinates.x, mouse_coordinates.y);
            return false;
        }
        callbacks.callback_context_channel = callback_context_channel;
    })(callbacks = htmltags.callbacks || (htmltags.callbacks = {}));
    let bbcodes;
    (function (bbcodes) {
        /* the = because we sometimes get that */
        //const url_client_regex = /(?:=)?client:\/\/(?<client_id>[0-9]+)\/(?<client_unique_id>[a-zA-Z0-9+=#]+)~(?<client_name>(?:[^%]|%[0-9A-Fa-f]{2})+)$/g;
        const url_client_regex = /(?:=)?client:\/\/([0-9]+)\/([a-zA-Z0-9+=/#]+)~((?:[^%]|%[0-9A-Fa-f]{2})+)$/g; /* IDK which browsers already support group naming */
        const url_channel_regex = /(?:=)?channel:\/\/([0-9]+)~((?:[^%]|%[0-9A-Fa-f]{2})+)$/g;
        function initialize() {
            const origin_url = XBBCODE.tags()["url"];
            XBBCODE.addTags({
                function: {
                    openTag: (params, content) => {
                        if (params) {
                            if (params.match(url_channel_regex)) {
                                const groups = url_channel_regex.exec(params);
                                return generate_channel_open({
                                    add_braces: false,
                                    channel_id: parseInt(groups[1]),
                                    channel_name: decodeURIComponent(groups[2])
                                });
                            }
                            else if (params.match(url_client_regex)) {
                                const groups = url_client_regex.exec(params);
                                return generate_client_open({
                                    add_braces: false,
                                    client_id: parseInt(groups[1]),
                                    client_unique_id: groups[2],
                                    client_name: decodeURIComponent(groups[3])
                                });
                            }
                        }
                        return origin_url.openTag(params, content);
                    },
                    closeTag: (params, content) => {
                        if (params) {
                            if (params.match(url_client_regex))
                                return "</div>";
                            if (params.match(url_channel_regex))
                                return "</div>";
                        }
                        return origin_url.closeTag(params, content);
                    }
                },
                tag: "url"
            });
            /*
              "img":  {
                    openTag: function(params,content) {
                        let myUrl;

                        if (!params) {
                            myUrl = content.replace(/<.*?>/g,"");
                        } else {
                            myUrl = params.substr(1);
                        }

                        urlPattern.lastIndex = 0;
                        if ( !urlPattern.test( myUrl ) ) {
                            myUrl = "#";
                        }

                        return '<a href="' + myUrl + '" target="_blank">';
                    },
                    closeTag: function(params,content) {
                        return '</a>';
                    }
                },
             */
        }
        initialize();
    })(bbcodes || (bbcodes = {}));
})(htmltags || (htmltags = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["9063a3ae94d95524f22f99d272f7d3cb1c25678f2e101ac0d16f34dfb5793a06"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["9063a3ae94d95524f22f99d272f7d3cb1c25678f2e101ac0d16f34dfb5793a06"] = "9063a3ae94d95524f22f99d272f7d3cb1c25678f2e101ac0d16f34dfb5793a06";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
var Modals;
(function (Modals) {
    function createServerModal(server, callback) {
        let properties = {}; //The changes properties
        const render_properties = {};
        Object.assign(render_properties, server.properties);
        render_properties["virtualserver_icon_tab"] = server.channelTree.client.fileManager.icons.generateTag(server.properties.virtualserver_icon_id);
        render_properties["virtualserver_icon_general"] = server.channelTree.client.fileManager.icons.generateTag(server.properties.virtualserver_icon_id);
        const modal_template = $("#tmpl_server_edit").renderTag(render_properties);
        const modal = modal_template.modalize((header, body, footer) => {
            return {
                body: body.tabify()
            };
        });
        server_applyGeneralListener(properties, server, modal.htmlTag.find(".properties-general"), modal.htmlTag.find(".button_ok"));
        server_applyTransferListener(properties, server, modal.htmlTag.find('.properties_transfer'));
        server_applyHostListener(server, properties, server.properties, modal.htmlTag.find(".properties_host"), modal.htmlTag.find(".button_ok"));
        server_applyMessages(properties, server, modal.htmlTag.find(".properties_messages"));
        server_applyFlood(properties, server, modal.htmlTag.find(".properties_flood"));
        server_applySecurity(properties, server, modal.htmlTag.find(".properties_security"));
        server_applyMisc(properties, server, modal.htmlTag.find(".properties_misc"));
        modal.htmlTag.find(".button_ok").click(() => {
            modal.close();
            callback(properties); //First may create the channel
        });
        modal.htmlTag.find(".button_cancel").click(() => {
            modal.close();
            callback();
        });
        modal.open();
    }
    Modals.createServerModal = createServerModal;
    function server_applyGeneralListener(properties, server, tag, button) {
        const connection_handler = server.channelTree.client;
        let updateButton = () => {
            if (tag.find(".input_error").length == 0)
                button.removeAttr("disabled");
            else
                button.attr("disabled", "true");
        };
        tag.find(".virtualserver_name").change(function () {
            properties.virtualserver_name = this.value;
            $(this).removeClass("input_error");
            if (this.value.length < 1 || this.value.length > 70)
                $(this).addClass("input_error");
            updateButton();
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_NAME).granted(1));
        tag.find(".virtualserver_name_phonetic").change(function () {
            properties.virtualserver_name_phonetic = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_NAME).granted(1));
        tag.find(".virtualserver_password").change(function () {
            properties.virtualserver_flag_password = this.value.length != 0;
            if (properties.virtualserver_flag_password)
                helpers.hashPassword(this.value).then(pass => properties.virtualserver_password = pass);
            $(this).removeClass("input_error");
            if (!properties.virtualserver_flag_password)
                if (connection_handler.permissions.neededPermission(PermissionType.B_CHANNEL_CREATE_MODIFY_WITH_FORCE_PASSWORD).granted(1))
                    $(this).addClass("input_error");
            updateButton();
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_PASSWORD).granted(1));
        tag.find(".virtualserver_maxclients").change(function () {
            properties.virtualserver_maxclients = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_MAXCLIENTS).granted(1));
        tag.find(".virtualserver_reserved_slots").change(function () {
            properties.virtualserver_reserved_slots = this.valueAsNumber;
            $(this).removeClass("input_error");
            if (this.valueAsNumber > properties.virtualserver_maxclients)
                $(this).addClass("input_error");
            updateButton();
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_RESERVED_SLOTS).granted(1));
        tag.find(".virtualserver_welcomemessage").change(function () {
            properties.virtualserver_welcomemessage = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_WELCOMEMESSAGE).granted(1));
        tag.find(".button-select-icon").on('click', event => {
            Modals.spawnIconSelect(connection_handler, id => {
                const icon_node = tag.find(".button-select-icon").find(".icon-node");
                icon_node.empty();
                icon_node.each((_, e) => { $(e).append(connection_handler.fileManager.icons.generateTag(id)); });
                //icon_node.append(connection_handler.fileManager.icons.generateTag(id));
                console.log("Selected icon ID: %d", id);
                properties.virtualserver_icon_id = id;
            }, server.properties.virtualserver_icon_id);
        });
    }
    function server_applyHostListener(server, properties, original_properties, tag, button) {
        const connection_handler = server.channelTree.client;
        tag.find(".virtualserver_host").change(function () {
            properties.virtualserver_host = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOST).granted(1));
        tag.find(".virtualserver_port").change(function () {
            properties.virtualserver_port = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_PORT).granted(1));
        tag.find(".virtualserver_hostmessage").change(function () {
            properties.virtualserver_hostmessage = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTMESSAGE).granted(1));
        tag.find(".virtualserver_hostmessage_mode").change(function () {
            properties.virtualserver_hostmessage_mode = this.selectedIndex;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTMESSAGE).granted(1))
            .find("option").eq(original_properties.virtualserver_hostmessage_mode).prop('selected', true);
        tag.find(".virtualserver_hostbanner_url").change(function () {
            properties.virtualserver_hostbanner_url = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBANNER).granted(1));
        tag.find(".virtualserver_hostbanner_gfx_url").change(function () {
            properties.virtualserver_hostbanner_gfx_url = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBANNER).granted(1));
        tag.find(".virtualserver_hostbanner_gfx_interval").change(function () {
            properties.virtualserver_hostbanner_gfx_interval = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBANNER).granted(1));
        tag.find(".virtualserver_hostbanner_mode").change(function () {
            properties.virtualserver_hostbanner_mode = this.selectedIndex;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTMESSAGE).granted(1))
            .find("option").eq(original_properties.virtualserver_hostbanner_mode).prop('selected', true);
        tag.find(".virtualserver_hostbutton_tooltip").change(function () {
            properties.virtualserver_hostbutton_tooltip = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBUTTON).granted(1));
        tag.find(".virtualserver_hostbutton_url").change(function () {
            properties.virtualserver_hostbutton_url = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBUTTON).granted(1));
        tag.find(".virtualserver_hostbutton_gfx_url").change(function () {
            properties.virtualserver_hostbutton_gfx_url = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_HOSTBUTTON).granted(1));
        server.updateProperties().then(() => {
            tag.find(".virtualserver_host").val(server.properties.virtualserver_host);
            tag.find(".virtualserver_port").val(server.properties.virtualserver_port);
        });
    }
    function server_applyMessages(properties, server, tag) {
        const connection_handler = server.channelTree.client;
        server.updateProperties().then(() => {
            tag.find(".virtualserver_default_client_description").val(server.properties.virtualserver_default_client_description);
            tag.find(".virtualserver_default_channel_description").val(server.properties.virtualserver_default_channel_description);
            tag.find(".virtualserver_default_channel_topic").val(server.properties.virtualserver_default_channel_topic);
        });
        tag.find(".virtualserver_default_client_description").change(function () {
            properties.virtualserver_default_client_description = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_DEFAULT_MESSAGES).granted(1));
        tag.find(".virtualserver_default_channel_description").change(function () {
            properties.virtualserver_default_channel_description = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_DEFAULT_MESSAGES).granted(1));
        tag.find(".virtualserver_default_channel_topic").change(function () {
            properties.virtualserver_default_channel_topic = this.value;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_DEFAULT_MESSAGES).granted(1));
    }
    function server_applyFlood(properties, server, tag) {
        const connection_handler = server.channelTree.client;
        server.updateProperties().then(() => {
            tag.find(".virtualserver_antiflood_points_tick_reduce").val(server.properties.virtualserver_antiflood_points_tick_reduce);
            tag.find(".virtualserver_antiflood_points_needed_command_block").val(server.properties.virtualserver_antiflood_points_needed_command_block);
            tag.find(".virtualserver_antiflood_points_needed_ip_block").val(server.properties.virtualserver_antiflood_points_needed_ip_block);
        });
        tag.find(".virtualserver_antiflood_points_tick_reduce").change(function () {
            properties.virtualserver_antiflood_points_tick_reduce = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
        tag.find(".virtualserver_antiflood_points_needed_command_block").change(function () {
            properties.virtualserver_antiflood_points_needed_command_block = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
        tag.find(".virtualserver_antiflood_points_needed_ip_block").change(function () {
            properties.virtualserver_antiflood_points_needed_ip_block = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
    }
    function server_applySecurity(properties, server, tag) {
        const connection_handler = server.channelTree.client;
        server.updateProperties().then(() => {
            tag.find(".virtualserver_needed_identity_security_level").val(server.properties.virtualserver_needed_identity_security_level);
        });
        tag.find(".virtualserver_needed_identity_security_level").change(function () {
            properties.virtualserver_needed_identity_security_level = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_NEEDED_IDENTITY_SECURITY_LEVEL).granted(1));
        tag.find(".virtualserver_codec_encryption_mode").change(function () {
            properties.virtualserver_codec_encryption_mode = this.selectedIndex;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1))
            .find("option").eq(server.properties.virtualserver_codec_encryption_mode).prop('selected', true);
    }
    function server_applyMisc(properties, server, tag) {
        const connection_handler = server.channelTree.client;
        { //TODO notify on tmp channeladmin group and vice versa
            {
                let groups_tag = tag.find(".default_server_group");
                groups_tag.change(function () {
                    properties.virtualserver_default_server_group = parseInt($(this.item(this.selectedIndex)).attr("group-id"));
                });
                for (let group of server.channelTree.client.groups.serverGroups.sort(GroupManager.sorter())) {
                    if (group.type != 2)
                        continue;
                    let group_tag = $.spawn("option").text(group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]").attr("group-id", group.id);
                    if (group.id == server.properties.virtualserver_default_server_group)
                        group_tag.prop("selected", true);
                    group_tag.appendTo(groups_tag);
                }
            }
            {
                let groups_tag = tag.find(".default_music_group");
                groups_tag.change(function () {
                    properties.virtualserver_default_music_group = parseInt($(this.item(this.selectedIndex)).attr("group-id"));
                });
                for (let group of server.channelTree.client.groups.serverGroups.sort(GroupManager.sorter())) {
                    if (group.type != 2)
                        continue;
                    let group_tag = $.spawn("option").text(group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]").attr("group-id", group.id);
                    if (group.id == server.properties.virtualserver_default_music_group)
                        group_tag.prop("selected", true);
                    group_tag.appendTo(groups_tag);
                }
            }
            {
                let groups_tag = tag.find(".default_channel_group");
                groups_tag.change(function () {
                    properties.virtualserver_default_channel_group = parseInt($(this.item(this.selectedIndex)).attr("group-id"));
                });
                for (let group of server.channelTree.client.groups.channelGroups.sort(GroupManager.sorter())) {
                    if (group.type != 2)
                        continue;
                    let group_tag = $.spawn("option").text(group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]").attr("group-id", group.id);
                    if (group.id == server.properties.virtualserver_default_channel_group)
                        group_tag.prop("selected", true);
                    group_tag.appendTo(groups_tag);
                }
            }
            {
                let groups_tag = tag.find(".default_channel_admin_group");
                groups_tag.change(function () {
                    properties.virtualserver_default_channel_admin_group = parseInt($(this.item(this.selectedIndex)).attr("group-id"));
                });
                for (let group of server.channelTree.client.groups.channelGroups.sort(GroupManager.sorter())) {
                    if (group.type != 2)
                        continue;
                    let group_tag = $.spawn("option").text(group.name + " [" + (group.properties.savedb ? "perm" : "tmp") + "]").attr("group-id", group.id);
                    if (group.id == server.properties.virtualserver_default_channel_admin_group)
                        group_tag.prop("selected", true);
                    group_tag.appendTo(groups_tag);
                }
            }
        }
        server.updateProperties().then(() => {
            //virtualserver_antiflood_points_needed_ip_block
            //virtualserver_antiflood_points_needed_command_block
            //virtualserver_antiflood_points_tick_reduce
            //virtualserver_complain_autoban_count
            //virtualserver_complain_autoban_time
            //virtualserver_complain_remove_time
            tag.find(".virtualserver_antiflood_points_needed_ip_block").val(server.properties.virtualserver_antiflood_points_needed_ip_block);
            tag.find(".virtualserver_antiflood_points_needed_command_block").val(server.properties.virtualserver_antiflood_points_needed_command_block);
            tag.find(".virtualserver_antiflood_points_tick_reduce").val(server.properties.virtualserver_antiflood_points_tick_reduce);
            tag.find(".virtualserver_complain_autoban_count").val(server.properties.virtualserver_complain_autoban_count);
            tag.find(".virtualserver_complain_autoban_time").val(server.properties.virtualserver_complain_autoban_time);
            tag.find(".virtualserver_complain_remove_time").val(server.properties.virtualserver_complain_remove_time);
            tag.find(".virtualserver_weblist_enabled").prop("checked", server.properties.virtualserver_weblist_enabled);
        });
        tag.find(".virtualserver_antiflood_points_needed_ip_block").change(function () {
            properties.virtualserver_antiflood_points_needed_ip_block = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
        tag.find(".virtualserver_antiflood_points_needed_command_block").change(function () {
            properties.virtualserver_antiflood_points_needed_command_block = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
        tag.find(".virtualserver_antiflood_points_tick_reduce").change(function () {
            properties.virtualserver_antiflood_points_tick_reduce = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_ANTIFLOOD).granted(1));
        tag.find(".virtualserver_complain_autoban_count").change(function () {
            properties.virtualserver_complain_autoban_count = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_COMPLAIN).granted(1));
        tag.find(".virtualserver_complain_autoban_time").change(function () {
            properties.virtualserver_complain_autoban_time = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_COMPLAIN).granted(1));
        tag.find(".virtualserver_complain_remove_time").change(function () {
            properties.virtualserver_complain_remove_time = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_COMPLAIN).granted(1));
        tag.find(".virtualserver_weblist_enabled").change(function () {
            properties.virtualserver_weblist_enabled = $(this).prop("checked");
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_WEBLIST).granted(1));
    }
    function server_applyTransferListener(properties, server, tag) {
        const connection_handler = server.channelTree.client;
        server.updateProperties().then(() => {
            //virtualserver_max_upload_total_bandwidth
            //virtualserver_upload_quota
            //virtualserver_max_download_total_bandwidth
            //virtualserver_download_quota
            tag.find(".virtualserver_max_upload_total_bandwidth").val(server.properties.virtualserver_max_upload_total_bandwidth);
            tag.find(".virtualserver_upload_quota").val(server.properties.virtualserver_upload_quota);
            tag.find(".virtualserver_max_download_total_bandwidth").val(server.properties.virtualserver_max_download_total_bandwidth);
            tag.find(".virtualserver_download_quota").val(server.properties.virtualserver_download_quota);
        });
        tag.find(".virtualserver_max_upload_total_bandwidth").change(function () {
            properties.virtualserver_max_upload_total_bandwidth = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_FT_SETTINGS).granted(1));
        tag.find(".virtualserver_max_download_total_bandwidth").change(function () {
            properties.virtualserver_max_download_total_bandwidth = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_FT_SETTINGS).granted(1));
        tag.find(".virtualserver_upload_quota").change(function () {
            properties.virtualserver_upload_quota = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_FT_QUOTAS).granted(1));
        tag.find(".virtualserver_download_quota").change(function () {
            properties.virtualserver_download_quota = this.valueAsNumber;
        }).prop("disabled", !connection_handler.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_MODIFY_FT_QUOTAS).granted(1));
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["c861e6fda7bc9f0bc7de5b6ae35ce3948aa699eb7c64b71f289c04904cddbd75"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["c861e6fda7bc9f0bc7de5b6ae35ce3948aa699eb7c64b71f289c04904cddbd75"] = "c861e6fda7bc9f0bc7de5b6ae35ce3948aa699eb7c64b71f289c04904cddbd75";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "FrLBMmAQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (141,23)" }, { name: "tbPonata", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (155,23)" }, { name: "Ujv7uHpF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (158,54)" }, { name: "zizRovmc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (159,37)" }, { name: "aumd8DVM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (169,23)" }, { name: "ee8M7x8_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (174,23)" }, { name: "xGOU_Z44", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (179,23)" }, { name: "Yt2tRQIy", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/server.ts (187,70)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="channel.ts" />
/// <reference path="modal/ModalServerEdit.ts" />
class ServerProperties {
    constructor() {
        this.virtualserver_host = "";
        this.virtualserver_port = 0;
        this.virtualserver_name = "";
        this.virtualserver_name_phonetic = "";
        this.virtualserver_icon_id = 0;
        this.virtualserver_version = "unknown";
        this.virtualserver_platform = "unknown";
        this.virtualserver_unique_identifier = "";
        this.virtualserver_clientsonline = 0;
        this.virtualserver_queryclientsonline = 0;
        this.virtualserver_channelsonline = 0;
        this.virtualserver_uptime = 0;
        this.virtualserver_maxclients = 0;
        this.virtualserver_reserved_slots = 0;
        this.virtualserver_password = "";
        this.virtualserver_flag_password = false;
        this.virtualserver_welcomemessage = "";
        this.virtualserver_hostmessage = "";
        this.virtualserver_hostmessage_mode = 0;
        this.virtualserver_hostbanner_url = "";
        this.virtualserver_hostbanner_gfx_url = "";
        this.virtualserver_hostbanner_gfx_interval = 0;
        this.virtualserver_hostbanner_mode = 0;
        this.virtualserver_hostbutton_tooltip = "";
        this.virtualserver_hostbutton_url = "";
        this.virtualserver_hostbutton_gfx_url = "";
        this.virtualserver_codec_encryption_mode = 0;
        this.virtualserver_default_music_group = 0;
        this.virtualserver_default_server_group = 0;
        this.virtualserver_default_channel_group = 0;
        this.virtualserver_default_channel_admin_group = 0;
        //Special requested properties
        this.virtualserver_default_client_description = "";
        this.virtualserver_default_channel_description = "";
        this.virtualserver_default_channel_topic = "";
        this.virtualserver_antiflood_points_tick_reduce = 0;
        this.virtualserver_antiflood_points_needed_command_block = 0;
        this.virtualserver_antiflood_points_needed_ip_block = 0;
        this.virtualserver_complain_autoban_count = 0;
        this.virtualserver_complain_autoban_time = 0;
        this.virtualserver_complain_remove_time = 0;
        this.virtualserver_needed_identity_security_level = 8;
        this.virtualserver_weblist_enabled = false;
        this.virtualserver_min_clients_in_channel_before_forced_silence = 0;
        this.virtualserver_max_upload_total_bandwidth = 0;
        this.virtualserver_upload_quota = 0;
        this.virtualserver_max_download_total_bandwidth = 0;
        this.virtualserver_download_quota = 0;
    }
}
class ServerEntry {
    constructor(tree, name, address) {
        this.info_request_promise = undefined;
        this.info_request_promise_resolve = undefined;
        this.info_request_promise_reject = undefined;
        this.lastInfoRequest = 0;
        this.nextInfoRequest = 0;
        this.properties = new ServerProperties();
        this.channelTree = tree;
        this.remote_address = address;
        this.properties.virtualserver_name = name;
    }
    get htmlTag() {
        if (this._htmlTag)
            return this._htmlTag;
        let tag = $.spawn("div").addClass("tree-entry server");
        tag.append($.spawn("div")
            .addClass("server_type icon client-server_green"));
        tag.append($.spawn("div")
            .addClass("name")
            .text(this.properties.virtualserver_name));
        tag.append($.spawn("div")
            .addClass("icon_property icon_empty"));
        return this._htmlTag = tag;
    }
    initializeListener() {
        this._htmlTag.click(() => {
            this.channelTree.onSelect(this);
        });
        if (!settings.static(Settings.KEY_DISABLE_CONTEXT_MENU, false)) {
            this.htmlTag.on("contextmenu", (event) => {
                event.preventDefault();
                if ($.isArray(this.channelTree.currently_selected)) { //Multiselect
                    (this.channelTree.currently_selected_context_callback || ((_) => null))(event);
                    return;
                }
                this.channelTree.onSelect(this, true);
                this.spawnContextMenu(event.pageX, event.pageY, () => { this.channelTree.onSelect(undefined, true); });
            });
        }
    }
    spawnContextMenu(x, y, on_close = () => { }) {
        let trigger_close = true;
        spawn_context_menu(x, y, {
            type: MenuEntryType.ENTRY,
            name: _translations.FrLBMmAQ || (_translations.FrLBMmAQ = tr("Show server info")),
            callback: () => {
                trigger_close = false;
                this.channelTree.client.select_info.open_popover();
            },
            icon: "client-about",
            visible: this.channelTree.client.select_info.is_popover()
        }, {
            type: MenuEntryType.HR,
            visible: this.channelTree.client.select_info.is_popover(),
            name: ''
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-virtualserver_edit",
            name: _translations.tbPonata || (_translations.tbPonata = tr("Edit")),
            callback: () => {
                Modals.createServerModal(this, properties => {
                    log.info(LogCategory.SERVER, _translations.Ujv7uHpF || (_translations.Ujv7uHpF = tr("Changing server properties %o")), properties);
                    console.log(_translations.zizRovmc || (_translations.zizRovmc = tr("Changed properties: %o")), properties);
                    if (properties)
                        this.channelTree.client.serverConnection.send_command("serveredit", properties).then(() => {
                            this.channelTree.client.sound.play(Sound.SERVER_EDITED_SELF);
                        });
                });
            }
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-iconviewer",
            name: _translations.aumd8DVM || (_translations.aumd8DVM = tr("View icons")),
            callback: () => Modals.spawnIconSelect(this.channelTree.client)
        }, {
            type: MenuEntryType.ENTRY,
            icon: 'client-iconsview',
            name: _translations.ee8M7x8_ || (_translations.ee8M7x8_ = tr("View avatars")),
            callback: () => Modals.spawnAvatarList(this.channelTree.client)
        }, {
            type: MenuEntryType.ENTRY,
            icon: "client-invite_buddy",
            name: _translations.xGOU_Z44 || (_translations.xGOU_Z44 = tr("Invite buddy")),
            callback: () => Modals.spawnInviteEditor(this.channelTree.client)
        }, MenuEntry.CLOSE(() => (trigger_close ? on_close : () => { })()));
    }
    updateVariables(is_self_notify, ...variables) {
        let group = log.group(log.LogType.DEBUG, LogCategory.SERVER, _translations.Yt2tRQIy || (_translations.Yt2tRQIy = tr("Update properties (%i)")), variables.length);
        {
            const entries = [];
            for (const variable of variables)
                entries.push({
                    key: variable.key,
                    value: variable.value,
                    type: typeof (this.properties[variable.key])
                });
            log.table("Server update properties", entries);
        }
        let update_bannner = false;
        for (let variable of variables) {
            JSON.map_field_to(this.properties, variable.value, variable.key);
            if (variable.key == "virtualserver_name") {
                this.htmlTag.find(".name").text(variable.value);
                this.channelTree.client.tag_connection_handler.find(".server-name").text(variable.value);
                server_connections.update_ui();
            }
            else if (variable.key == "virtualserver_icon_id") {
                /* For more detail lookup client::updateVariables and client_icon_id!
                 * ATTENTION: This is required!
                 */
                this.properties.virtualserver_icon_id = variable.value >>> 0;
                if (this.channelTree.client.fileManager && this.channelTree.client.fileManager.icons)
                    this.htmlTag.find(".icon_property").replaceWith(this.channelTree.client.fileManager.icons.generateTag(this.properties.virtualserver_icon_id).addClass("icon_property"));
            }
            else if (variable.key.indexOf('hostbanner') != -1) {
                update_bannner = true;
            }
        }
        if (update_bannner)
            this.channelTree.client.select_info.update_banner();
        group.end();
        if (is_self_notify && this.info_request_promise_resolve) {
            this.info_request_promise_resolve();
            this.info_request_promise = undefined;
            this.info_request_promise_reject = undefined;
            this.info_request_promise_resolve = undefined;
        }
    }
    updateProperties() {
        if (this.info_request_promise && Date.now() - this.lastInfoRequest < 1000)
            return this.info_request_promise;
        this.lastInfoRequest = Date.now();
        this.nextInfoRequest = this.lastInfoRequest + 10 * 1000;
        this.channelTree.client.serverConnection.send_command("servergetvariables").catch(error => {
            this.info_request_promise_reject(error);
            this.info_request_promise = undefined;
            this.info_request_promise_reject = undefined;
            this.info_request_promise_resolve = undefined;
        });
        return this.info_request_promise = new Promise((resolve, reject) => {
            this.info_request_promise_reject = reject;
            this.info_request_promise_resolve = resolve;
        });
    }
    shouldUpdateProperties() {
        return this.nextInfoRequest < Date.now();
    }
    calculateUptime() {
        if (this.properties.virtualserver_uptime == 0 || this.lastInfoRequest == 0)
            return this.properties.virtualserver_uptime;
        return this.properties.virtualserver_uptime + (new Date().getTime() - this.lastInfoRequest) / 1000;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e68b913bdd5a9fc74f81be3cb01e96611e72cb8e163176e9920969ce8a28a58d"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e68b913bdd5a9fc74f81be3cb01e96611e72cb8e163176e9920969ce8a28a58d"] = "e68b913bdd5a9fc74f81be3cb01e96611e72cb8e163176e9920969ce8a28a58d";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
if (!$.fn.dividerfy) {
    $.fn.dividerfy = function () {
        this.find(".container-seperator").each(function () {
            if (!this.previousElementSibling)
                return;
            if (!this.nextElementSibling)
                return;
            const element = $(this);
            const parent_element = $(this.parentElement);
            const previous_element = $(this.previousElementSibling);
            const next_element = $(this.nextElementSibling);
            const seperator_id = element.attr("seperator-id");
            const vertical = element.hasClass("vertical");
            const apply_view = (property, previous, next) => {
                previous_element.css(property, "calc(" + previous + "% - " + (vertical ? element.width() : element.height()) + "px)");
                next_element.css(property, "calc(" + next + "% - " + (vertical ? element.width() : element.height()) + "px)");
            };
            const listener_move = (event) => {
                const parent_offset = parent_element.offset();
                const min = vertical ? parent_offset.left : parent_offset.top;
                const max = vertical ? parent_offset.left + parent_element.width() : parent_offset.top + parent_element.height();
                const current = event instanceof MouseEvent ?
                    (vertical ? event.pageX : event.pageY) :
                    (vertical ? event.touches[event.touches.length - 1].clientX : event.touches[event.touches.length - 1].clientY);
                /*
                const previous_offset = previous_element.offset();
                const next_offset = next_element.offset();

                const min = vertical ? Math.min(previous_offset.left, next_offset.left) : Math.min(previous_offset.top, next_offset.top);
                const max = vertical ?
                    Math.max(previous_offset.left + previous_element.width(), next_offset.left + next_element.width()) :
                    Math.max(previous_offset.top + previous_element.height(), next_offset.top + next_element.height());
                */
                let previous = 0;
                let next = 0;
                if (current < min) {
                    previous = 0;
                    next = 1;
                }
                else if (current < max) {
                    const x_offset = current - min;
                    const x_offset_max = max - min;
                    previous = x_offset / x_offset_max;
                    next = 1 - previous;
                }
                else {
                    previous = 1;
                    next = 0;
                }
                const property = vertical ? "width" : "height";
                const previous_p = Math.ceil(previous * 100);
                const next_p = Math.ceil(next * 100);
                apply_view(property, previous_p, next_p);
                if (seperator_id)
                    settings.changeGlobal("seperator-settings-" + seperator_id, JSON.stringify({
                        previous: previous_p,
                        next: next_p,
                        property: property
                    }));
            };
            const listener_up = (event) => {
                document.removeEventListener('mousemove', listener_move);
                document.removeEventListener('touchmove', listener_move);
                document.removeEventListener('mouseup', listener_up);
                document.removeEventListener('touchend', listener_up);
                document.removeEventListener('touchcancel', listener_up);
                $(document.documentElement).css("user-select", "");
                element.removeClass("seperator-selected");
                next_element.find("[x-divider-require-resize]").trigger('resize');
                previous_element.find("[x-divider-require-resize]").trigger('resize');
            };
            element.on('mousedown', () => {
                document.addEventListener('mousemove', listener_move);
                document.addEventListener('touchmove', listener_move);
                document.addEventListener('mouseup', listener_up);
                document.addEventListener('touchend', listener_up);
                document.addEventListener('touchcancel', listener_up);
                $(document.documentElement).css("user-select", "none");
                element.addClass("seperator-selected");
            });
            element.on('touchstart', () => {
                element.trigger('mousedown');
            });
            if (seperator_id) {
                try {
                    const config = JSON.parse(settings.global("seperator-settings-" + seperator_id));
                    if (config) {
                        console.log("Apply previous changed: %o", config);
                        apply_view(config.property, config.previous, config.next);
                    }
                }
                catch (e) {
                    if (!(e instanceof SyntaxError))
                        console.error(e);
                }
            }
        });
        return this;
    };
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["67a60bc8efcd0cfe329d5e003a5aba09b76472794caa3f86d6abc13383fd852b"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["67a60bc8efcd0cfe329d5e003a5aba09b76472794caa3f86d6abc13383fd852b"] = "67a60bc8efcd0cfe329d5e003a5aba09b76472794caa3f86d6abc13383fd852b";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
let context_menu;
$(document).bind("click", function (e) {
    let menu = context_menu || (context_menu = $(".context-menu"));
    if (!menu.is(":visible"))
        return;
    if ($(e.target).parents(".context-menu").length == 0) {
        despawn_context_menu();
        e.preventDefault();
    }
});
let contextMenuCloseFn = undefined;
function despawn_context_menu() {
    let menu = context_menu || (context_menu = $(".context-menu"));
    if (!menu.is(":visible"))
        return;
    menu.animate({ opacity: 0 }, 100, () => menu.css("display", "none"));
    if (contextMenuCloseFn)
        contextMenuCloseFn();
}
var MenuEntryType;
(function (MenuEntryType) {
    MenuEntryType[MenuEntryType["CLOSE"] = 0] = "CLOSE";
    MenuEntryType[MenuEntryType["ENTRY"] = 1] = "ENTRY";
    MenuEntryType[MenuEntryType["HR"] = 2] = "HR";
    MenuEntryType[MenuEntryType["SUB_MENU"] = 3] = "SUB_MENU";
})(MenuEntryType || (MenuEntryType = {}));
class MenuEntry {
    static HR() {
        return {
            callback: () => { },
            type: MenuEntryType.HR,
            name: "",
            icon: ""
        };
    }
    ;
    static CLOSE(callback) {
        return {
            callback: callback,
            type: MenuEntryType.CLOSE,
            name: "",
            icon: ""
        };
    }
}
function generate_tag(entry) {
    if (entry.type == MenuEntryType.HR) {
        return $.spawn("hr");
    }
    else if (entry.type == MenuEntryType.ENTRY) {
        console.log(entry.icon);
        let icon = $.isFunction(entry.icon) ? entry.icon() : entry.icon;
        if (typeof (icon) === "string") {
            if (!icon || icon.length == 0)
                icon = "icon_empty";
            else
                icon = "icon " + icon;
        }
        let tag = $.spawn("div").addClass("entry");
        tag.append(typeof (icon) === "string" ? $.spawn("div").addClass(icon) : icon);
        tag.append($.spawn("div").html($.isFunction(entry.name) ? entry.name() : entry.name));
        if (entry.disabled || entry.invalidPermission)
            tag.addClass("disabled");
        else {
            tag.click(function () {
                if ($.isFunction(entry.callback))
                    entry.callback();
                despawn_context_menu();
            });
        }
        return tag;
    }
    else if (entry.type == MenuEntryType.SUB_MENU) {
        let icon = $.isFunction(entry.icon) ? entry.icon() : entry.icon;
        if (typeof (icon) === "string") {
            if (!icon || icon.length == 0)
                icon = "icon_empty";
            else
                icon = "icon " + icon;
        }
        let tag = $.spawn("div").addClass("entry").addClass("sub-container");
        tag.append(typeof (icon) === "string" ? $.spawn("div").addClass(icon) : icon);
        tag.append($.spawn("div").html($.isFunction(entry.name) ? entry.name() : entry.name));
        tag.append($.spawn("div").addClass("arrow right"));
        if (entry.disabled || entry.invalidPermission)
            tag.addClass("disabled");
        else {
            let menu = $.spawn("div").addClass("sub-menu").addClass("context-menu-container");
            for (const e of entry.sub_menu) {
                if (typeof (entry.visible) === 'boolean' && !entry.visible)
                    continue;
                menu.append(generate_tag(e));
            }
            menu.appendTo(tag);
        }
        return tag;
    }
    return $.spawn("div").text("undefined");
}
function spawn_context_menu(x, y, ...entries) {
    let menu_tag = context_menu || (context_menu = $(".context-menu"));
    menu_tag.finish().empty().css("opacity", "0");
    const menu_container = $.spawn("div").addClass("context-menu-container");
    contextMenuCloseFn = undefined;
    for (const entry of entries) {
        if (typeof (entry.visible) === 'boolean' && !entry.visible)
            continue;
        if (entry.type == MenuEntryType.CLOSE) {
            contextMenuCloseFn = entry.callback;
        }
        else
            menu_container.append(generate_tag(entry));
    }
    menu_tag.append(menu_container);
    menu_tag.animate({ opacity: 1 }, 100).css("display", "block");
    const width = menu_container.visible_width();
    if (x + width + 5 > window.innerWidth)
        menu_container.addClass("left");
    // In the right position (the mouse)
    menu_tag.css({
        "top": y + "px",
        "left": x + "px"
    });
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["14662f004e6e797618770d2b34f52bf7eeb468dbf9ba5b9992bc2bd7e2d4ea15"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["14662f004e6e797618770d2b34f52bf7eeb468dbf9ba5b9992bc2bd7e2d4ea15"] = "14662f004e6e797618770d2b34f52bf7eeb468dbf9ba5b9992bc2bd7e2d4ea15";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "AkUgG61Y", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/elements/tab.ts (26,18)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../i18n/localize.ts" />
if (typeof (customElements) !== "undefined") {
    try {
        class X_Tab extends HTMLElement {
        }
        class X_Entry extends HTMLElement {
        }
        class X_Tag extends HTMLElement {
        }
        class X_Content extends HTMLElement {
        }
        customElements.define('x-tab', X_Tab, { extends: 'div' });
        customElements.define('x-entry', X_Entry, { extends: 'div' });
        customElements.define('x-tag', X_Tag, { extends: 'div' });
        customElements.define('x-content', X_Content, { extends: 'div' });
    }
    catch (error) {
        console.warn("failed to define costum elements");
    }
}
else {
    console.warn(_translations.AkUgG61Y || (_translations.AkUgG61Y = tr("Could not defied tab customElements!")));
}
var TabFunctions = {
    tabify(template, copy = true) {
        console.log("Tabify: copy=" + copy);
        console.log(template);
        let tag = $.spawn("div");
        tag.addClass("tab");
        let header = $.spawn("div");
        header.addClass("tab-header");
        let content = $.spawn("div");
        content.addClass("tab-content");
        content.append($.spawn("div").addClass("height-watcher"));
        let silentContent = $.spawn("div");
        silentContent.addClass("tab-content-invisible");
        /* add some kind of min height */
        const update_height = () => {
            const height_watcher = tag.find("> .tab-content .height-watcher");
            const entries = tag.find("> .tab-content-invisible x-content, > .tab-content x-content");
            console.error(entries);
            let max_height = 0;
            entries.each((_, _e) => {
                const entry = $(_e);
                const height = entry.visible_height();
                if (height > max_height)
                    max_height = height;
            });
            height_watcher.css('min-height', max_height + "px");
            tag.find(".window-resize-listener").trigger('resize');
        };
        template.find("x-entry").each((_, _entry) => {
            const entry = $(_entry);
            const tag_header = $.spawn("div").addClass("entry");
            const tag_content = copy ? entry.find("x-content").clone(true, true) : entry.find("x-content");
            {
                const header_tag = entry.find("x-tag");
                const header_data = copy ? header_tag.contents().clone(true, true) : header_tag.contents();
                if (header_tag.attr("x-entry-class"))
                    tag_header.addClass(header_tag.attr("x-entry-class"));
                tag_header.append(header_data);
                /* listener if the tab might got removed */
                tag_header.addClass("window-resize-listener");
                tag_header.on('resize', event => {
                    if (!tag_header.is(':visible') && tag_header.hasClass('selected')) {
                        let element = tag_header.next('.entry:visible');
                        if (element.length == 0)
                            element = tag_header.prev('.entry:visible');
                        if (element.length == 0) {
                            tag_header.removeClass("selected");
                            tag_content.hide();
                        }
                        else {
                            element.first().trigger('click');
                        }
                        console.log("Next: %o", tag_header.next('.entry:visible'));
                        console.log("prev: %o", tag_header.prev('.entry:visible'));
                    }
                });
            }
            content.append(tag_content.hide());
            tag_header.on("click", () => {
                if (tag_header.hasClass("selected"))
                    return;
                tag.find(".tab-header .selected").removeClass("selected");
                tag_header.addClass("selected");
                content.find("> x-content").hide();
                /* don't show many nodes at once */
                let entries = tag_content.find(".tab-show-partitional");
                entries.hide();
                const show_next = index => {
                    console.log("Show " + index);
                    if (index >= entries.length)
                        return;
                    entries.eq(index).show();
                    setTimeout(show_next.bind(undefined, index + 1), 0);
                };
                show_next(0);
                tag_content.trigger('show');
                tag_content.show();
            });
            console.log(this);
            header.append(tag_header);
        });
        setTimeout(() => header.find(".entry").first().trigger("click"), 0);
        tag.append(header);
        tag.append(content);
        tag.append(silentContent);
        tag.on('tab.resize', update_height);
        return tag;
    }
};
if (!$.fn.asTabWidget) {
    $.fn.asTabWidget = function (copy) {
        if ($(this).prop("tagName") == "X-TAB")
            return TabFunctions.tabify($(this), typeof (copy) === "boolean" ? copy : true);
        else {
            throw "Invalid tag! " + $(this).prop("tagName");
        }
    };
}
if (!$.fn.tabify) {
    $.fn.tabify = function (copy) {
        const wrapped_tag = $.spawn("div").append(this);
        wrapped_tag.find("x-tab").each((_, _element) => {
            const element = $(_element);
            element.replaceWith(element.asTabWidget(copy));
        });
        return wrapped_tag.children();
    };
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["f0c42010c62d9a46b0e1cff1271f7bbcf69268946fdc719320447a9199bef823"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["f0c42010c62d9a46b0e1cff1271f7bbcf69268946fdc719320447a9199bef823"] = "f0c42010c62d9a46b0e1cff1271f7bbcf69268946fdc719320447a9199bef823";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
let server_connections;
class ServerConnectionManager {
    constructor(tag) {
        this.connection_handlers = [];
        this._tag = tag;
        if (settings.static_global(Settings.KEY_DISABLE_MULTI_SESSION, false))
            this._tag.hide();
        this._tag_connection_entries = this._tag.find(".connection-handlers");
        this._tag_buttons_scoll = this._tag.find(".container-scroll");
        this._tag_button_scoll_left = this._tag_buttons_scoll.find(".button-scroll-left");
        this._tag_button_scoll_right = this._tag_buttons_scoll.find(".button-scroll-right");
        this._tag_button_scoll_left.on('click', this._button_scroll_left_clicked.bind(this));
        this._tag_button_scoll_right.on('click', this._button_scroll_right_clicked.bind(this));
        this._container_channel_tree = $("#channelTree");
        this._container_select_info = $("#select_info");
        this._container_chat_box = $("#chat");
        this.set_active_connection_handler(undefined);
    }
    spawn_server_connection_handler() {
        const handler = new ConnectionHandler();
        this.connection_handlers.push(handler);
        control_bar.update_button_away();
        control_bar.initialize_connection_handler_state(handler);
        handler.tag_connection_handler.appendTo(this._tag_connection_entries);
        this._update_scroll();
        return handler;
    }
    destroy_server_connection_handler(handler) {
        this.connection_handlers.remove(handler);
        handler.tag_connection_handler.detach();
        this._update_scroll();
        if (handler.serverConnection) {
            const connected = handler.connected;
            handler.serverConnection.disconnect("handler destroyed");
            handler.handleDisconnect(DisconnectReason.HANDLER_DESTROYED, connected);
        }
        if (handler === this.active_handler)
            this.set_active_connection_handler(this.connection_handlers[0]);
    }
    set_active_connection_handler(handler) {
        if (handler && this.connection_handlers.indexOf(handler) == -1)
            throw "Handler hasn't been registrated or is already obsolete!";
        if (this.active_handler)
            this.active_handler.select_info.close_popover();
        this._tag_connection_entries.find(".active").removeClass("active");
        this._container_channel_tree.children().detach();
        this._container_select_info.children().detach();
        this._container_chat_box.children().detach();
        control_bar.set_connection_handler(handler);
        if (handler) {
            handler.tag_connection_handler.addClass("active");
            this._container_channel_tree.append(handler.channelTree.tag_tree());
            this._container_select_info.append(handler.select_info.get_tag());
            this._container_chat_box.append(handler.chat.htmlTag);
            if (handler.invoke_resized_on_activate)
                handler.resize_elements();
        }
        this.active_handler = handler;
    }
    active_connection_handler() {
        return this.active_handler;
    }
    server_connection_handlers() {
        return this.connection_handlers;
    }
    update_ui() {
        this._update_scroll();
    }
    _update_scroll() {
        const has_scroll = this._tag_connection_entries.hasScrollBar("width")
            && this._tag_connection_entries.width() + 10 >= this._tag_connection_entries.parent().width();
        this._tag_buttons_scoll.toggleClass("enabled", has_scroll);
        this._tag.toggleClass("scrollbar", has_scroll);
        if (has_scroll)
            this._update_scroll_buttons();
    }
    _button_scroll_right_clicked() {
        this._tag_connection_entries.scrollLeft((this._tag_connection_entries.scrollLeft() || 0) + 50);
        this._update_scroll_buttons();
    }
    _button_scroll_left_clicked() {
        this._tag_connection_entries.scrollLeft((this._tag_connection_entries.scrollLeft() || 0) - 50);
        this._update_scroll_buttons();
    }
    _update_scroll_buttons() {
        const scroll = this._tag_connection_entries.scrollLeft() || 0;
        this._tag_button_scoll_left.toggleClass("disabled", scroll <= 0);
        this._tag_button_scoll_right.toggleClass("disabled", scroll + this._tag_connection_entries.width() + 2 >= this._tag_connection_entries[0].scrollWidth);
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["122f0942680c3c4863530e7c9cf4517a00f3cada9f63434f2a5775c092f26f9b"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["122f0942680c3c4863530e7c9cf4517a00f3cada9f63434f2a5775c092f26f9b"] = "122f0942680c3c4863530e7c9cf4517a00f3cada9f63434f2a5775c092f26f9b";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "dbZk2vco", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (25,21)" }, { name: "VSZi0a0m", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (57,86)" }, { name: "e5IYgqIj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (58,88)" }, { name: "FUiDtEeC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (59,84)" }, { name: "dgp9s7To", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (89,28)" }, { name: "dlIQmwOZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (89,49)" }, { name: "ZGO0kGi7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (91,42)" }, { name: "mqc2Zx63", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (91,65)" }, { name: "QiPgqF3N", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (147,52)" }, { name: "rP4uA8rS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (148,38)" }, { name: "Dq9p12J3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (148,71)" }, { name: "LAO0V5KI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (152,48)" }, { name: "pCISuzaP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (153,34)" }, { name: "VsBy1L06", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalAvatarList.ts (153,64)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    const avatar_to_uid = (id) => {
        const buffer = new Uint8Array(id.length / 2);
        for (let index = 0; index < id.length; index += 2) {
            const upper_nibble = id.charCodeAt(index) - 97;
            const lower_nibble = id.charCodeAt(index + 1) - 97;
            buffer[index / 2] = (upper_nibble << 4) | lower_nibble;
        }
        return base64ArrayBuffer(buffer);
    };
    Modals.human_file_size = (size) => {
        if (size < 1000)
            return size + "B";
        const exp = Math.floor(Math.log2(size) / 10);
        return (size / Math.pow(1024, exp)).toFixed(2) + 'KMGTPE'.charAt(exp - 1) + "iB";
    };
    function spawnAvatarList(client) {
        const modal = createModal({
            header: _translations.dbZk2vco || (_translations.dbZk2vco = tr("Avatars")),
            footer: undefined,
            body: () => {
                const template = $("#tmpl_avatar_list").renderTag({});
                return template;
            }
        });
        let callback_download;
        let callback_delete;
        const button_download = modal.htmlTag.find(".button-download");
        const button_delete = modal.htmlTag.find(".button-delete");
        const container_list = modal.htmlTag.find(".container-list .list-entries-container");
        const list_entries = container_list.find(".list-entries");
        const container_info = modal.htmlTag.find(".container-info");
        const overlay_no_user = container_info.find(".disabled-overlay").show();
        const set_selected_avatar = (unique_id, avatar_id, size) => {
            button_download.prop("disabled", true);
            callback_download = undefined;
            if (!unique_id) {
                overlay_no_user.show();
                return;
            }
            const tag_username = container_info.find(".property-username");
            const tag_unique_id = container_info.find(".property-unique-id");
            const tag_avatar_id = container_info.find(".property-avatar-id");
            const container_avatar = container_info.find(".container-image");
            const tag_image_bytes = container_info.find(".property-image-size");
            const tag_image_width = container_info.find(".property-image-width").val(_translations.VSZi0a0m || (_translations.VSZi0a0m = tr("loading...")));
            const tag_image_height = container_info.find(".property-image-height").val(_translations.e5IYgqIj || (_translations.e5IYgqIj = tr("loading...")));
            const tag_image_type = container_info.find(".property-image-type").val(_translations.FUiDtEeC || (_translations.FUiDtEeC = tr("loading...")));
            tag_username.val("unknown");
            tag_unique_id.val(unique_id);
            tag_avatar_id.val(avatar_id);
            tag_image_bytes.val(size);
            container_avatar.empty().append(client.fileManager.avatars.generate_tag(avatar_id, undefined, {
                callback_image: image => {
                    tag_image_width.val(image[0].naturalWidth + 'px');
                    tag_image_height.val(image[0].naturalHeight + 'px');
                },
                callback_avatar: avatar => {
                    tag_image_type.val(media_image_type(avatar.type));
                    button_download.prop("disabled", false);
                    callback_download = () => {
                        const element = $.spawn("a")
                            .text("download")
                            .attr("href", avatar.url)
                            .attr("download", "avatar-" + unique_id + "." + media_image_type(avatar.type, true))
                            .css("display", "none")
                            .appendTo($("body"));
                        element[0].click();
                        element.detach();
                    };
                }
            }));
            callback_delete = () => {
                Modals.spawnYesNo(_translations.dgp9s7To || (_translations.dgp9s7To = tr("Are you sure?")), _translations.dlIQmwOZ || (_translations.dlIQmwOZ = tr("Do you really want to delete this avatar?")), result => {
                    if (result) {
                        createErrorModal(_translations.ZGO0kGi7 || (_translations.ZGO0kGi7 = tr("Not implemented")), _translations.mqc2Zx63 || (_translations.mqc2Zx63 = tr("Avatar delete hasn't implemented yet"))).open();
                        //TODO Implement avatar delete
                    }
                });
            };
            overlay_no_user.hide();
        };
        set_selected_avatar(undefined, undefined, 0);
        const update_avatar_list = () => {
            const template_entry = $("#tmpl_avatar_list-list_entry");
            list_entries.empty();
            client.fileManager.requestFileList("/").then(files => {
                const username_resolve = {};
                for (const entry of files) {
                    const avatar_id = entry.name.substr('avatar_'.length);
                    const unique_id = avatar_to_uid(avatar_id);
                    const tag = template_entry.renderTag({
                        username: 'loading',
                        unique_id: unique_id,
                        size: Modals.human_file_size(entry.size),
                        timestamp: moment(entry.datetime * 1000).format('YY-MM-DD HH:mm')
                    });
                    (username_resolve[unique_id] || (username_resolve[unique_id] = [])).push(name => {
                        const tag_username = tag.find(".column-username").empty();
                        if (name) {
                            tag_username.append(ClientEntry.chatTag(0, name, unique_id, false));
                        }
                        else {
                            tag_username.text("unknown");
                        }
                    });
                    list_entries.append(tag);
                    tag.on('click', () => {
                        list_entries.find('.selected').removeClass('selected');
                        tag.addClass('selected');
                        set_selected_avatar(unique_id, avatar_id, entry.size);
                    });
                }
                if (container_list.hasScrollBar())
                    container_list.addClass("scrollbar");
                client.serverConnection.command_helper.info_from_uid(...Object.keys(username_resolve)).then(result => {
                    for (const info of result) {
                        username_resolve[info.client_unique_id].forEach(e => e(info.client_nickname));
                        delete username_resolve[info.client_unique_id];
                    }
                    for (const uid of Object.keys(username_resolve)) {
                        (username_resolve[uid] || []).forEach(e => e(undefined));
                    }
                }).catch(error => {
                    log.error(LogCategory.GENERAL, _translations.QiPgqF3N || (_translations.QiPgqF3N = tr("Failed to fetch usernames from avatar names. Error: %o")), error);
                    createErrorModal(_translations.rP4uA8rS || (_translations.rP4uA8rS = tr("Failed to fetch usernames")), _translations.Dq9p12J3 || (_translations.Dq9p12J3 = tr("Failed to fetch usernames related to their avatar names")), undefined).open();
                });
            }).catch(error => {
                //TODO: Display no perms error
                log.error(LogCategory.GENERAL, _translations.LAO0V5KI || (_translations.LAO0V5KI = tr("Failed to receive avatar list. Error: %o")), error);
                createErrorModal(_translations.pCISuzaP || (_translations.pCISuzaP = tr("Failed to list avatars")), _translations.VsBy1L06 || (_translations.VsBy1L06 = tr("Failed to receive avatar list.")), undefined).open();
            });
        };
        button_download.on('click', () => (callback_download || (() => { }))());
        button_delete.on('click', () => (callback_delete || (() => { }))());
        setTimeout(() => update_avatar_list(), 250);
        modal.open();
    }
    Modals.spawnAvatarList = spawnAvatarList;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["36d4a01abc2b1722d712c6879b0c717adf59446c5fb3f02cadb1e413cd3e1052"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["36d4a01abc2b1722d712c6879b0c717adf59446c5fb3f02cadb1e413cd3e1052"] = "36d4a01abc2b1722d712c6879b0c717adf59446c5fb3f02cadb1e413cd3e1052";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "gQF0lHBo", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBookmarks.ts (43,21)" }, { name: "pGhNWRUg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBookmarks.ts (92,37)" }, { name: "ARu3gVq9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBookmarks.ts (143,36)" }, { name: "oczVQhEF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalBookmarks.ts (143,57)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function bookmark_tag(callback_select, bookmark) {
        const tag = $("#tmpl_manage_bookmarks-list_entry").renderTag({
            name: bookmark.display_name,
            type: bookmark.type == bookmarks.BookmarkType.DIRECTORY ? "directory" : "bookmark"
        });
        tag.find(".name").on('click', () => {
            callback_select(bookmark, tag);
            tag.addClass("selected");
        });
        if (bookmark.type == bookmarks.BookmarkType.DIRECTORY) {
            const casted = bookmark;
            for (const member of casted.content)
                tag.find("> .members").append(bookmark_tag(callback_select, member));
        }
        return tag;
    }
    function parent_tag(select_tag, prefix, bookmark) {
        if (bookmark.type == bookmarks.BookmarkType.DIRECTORY) {
            const casted = bookmark;
            select_tag.append($.spawn("option")
                .val(casted.unique_id)
                .text(prefix + casted.display_name));
            for (const member of casted.content)
                parent_tag(select_tag, prefix + "  ", member);
        }
    }
    function spawnBookmarkModal() {
        let modal;
        modal = createModal({
            header: _translations.gQF0lHBo || (_translations.gQF0lHBo = tr("Manage bookmarks")),
            body: () => {
                let template = $("#tmpl_manage_bookmarks").renderTag({});
                let selected_bookmark;
                let update_name;
                const update_bookmarks = () => {
                    template.find(".list").empty();
                    const callback_selected = (entry, tag) => {
                        template.find(".selected").removeClass("selected");
                        if (selected_bookmark == entry)
                            return;
                        selected_bookmark = entry;
                        update_name = () => tag.find("> .name").text(entry.display_name);
                        template.find(".bookmark-setting").hide();
                        template.find(".setting-bookmark-name").val(selected_bookmark.display_name);
                        if (selected_bookmark.type == bookmarks.BookmarkType.ENTRY) {
                            template.find(".bookmark-setting-bookmark").show();
                            const casted = selected_bookmark;
                            const profile = profiles.find_profile(casted.connect_profile) || profiles.default_profile();
                            template.find(".setting-bookmark-profile").val(profile.id);
                            template.find(".setting-server-host").val(casted.server_properties.server_address);
                            template.find(".setting-server-port").val(casted.server_properties.server_port);
                            template.find(".setting-server-password").val(casted.server_properties.server_password_hash || casted.server_properties.server_password);
                            template.find(".setting-username").val(casted.nickname);
                            template.find(".setting-channel").val(casted.default_channel);
                            template.find(".setting-channel-password").val(casted.default_channel_password_hash || casted.default_channel_password);
                        }
                        else {
                            template.find(".bookmark-setting-directory").show();
                        }
                    };
                    for (const bookmark of bookmarks.bookmarks().content) {
                        template.find(".list").append(bookmark_tag(callback_selected, bookmark));
                    }
                    console.log(template.find(".list").find(".bookmark, .directory"));
                    template.find(".list").find(".bookmark, .directory").eq(0).find("> .name").trigger('click');
                };
                { //General buttons
                    template.find(".button-create").on('click', event => {
                        let create_modal;
                        create_modal = createModal({
                            header: _translations.pGhNWRUg || (_translations.pGhNWRUg = tr("Create a new entry")),
                            body: () => {
                                let template = $("#tmpl_manage_bookmarks-create").renderTag({});
                                template = $.spawn("div").append(template);
                                for (const bookmark of bookmarks.bookmarks().content)
                                    parent_tag(template.find(".bookmark-parent"), "", bookmark);
                                if (selected_bookmark) {
                                    const parent = selected_bookmark.type == bookmarks.BookmarkType.ENTRY ?
                                        bookmarks.parent_bookmark(selected_bookmark) :
                                        selected_bookmark;
                                    if (parent)
                                        template.find(".bookmark-parent").val(parent.unique_id);
                                }
                                template.find(".bookmark-name").on('change, keyup', event => {
                                    template.find(".button-create").prop("disabled", event.target.value.length < 3);
                                });
                                template.find(".button-create").prop("disabled", true).on('click', event => {
                                    const name = template.find(".bookmark-name").val();
                                    const parent_uuid = template.find(".bookmark-parent").val();
                                    const parent = bookmarks.find_bookmark(parent_uuid);
                                    let bookmark;
                                    if (template.find(".bookmark-type").val() == "directory") {
                                        bookmark = bookmarks.create_bookmark_directory(parent || bookmarks.bookmarks(), name);
                                    }
                                    else {
                                        bookmark = bookmarks.create_bookmark(name, parent || bookmarks.bookmarks(), {
                                            server_port: 9987,
                                            server_address: "ts.teaspeak.de"
                                        }, "Another TeaSpeak user");
                                    }
                                    bookmarks.save_bookmark(bookmark);
                                    create_modal.close();
                                    update_bookmarks();
                                });
                                return template;
                            },
                            footer: 400
                        });
                        create_modal.open();
                    });
                    template.find(".button-delete").on('click', event => {
                        if (!selected_bookmark)
                            return;
                        Modals.spawnYesNo(_translations.ARu3gVq9 || (_translations.ARu3gVq9 = tr("Are you sure?")), _translations.oczVQhEF || (_translations.oczVQhEF = tr("Do you really want to delete this entry?")), result => {
                            if (result) {
                                bookmarks.delete_bookmark(selected_bookmark);
                                bookmarks.save_bookmark(selected_bookmark); /* save the deleted state */
                                update_bookmarks();
                            }
                        });
                    });
                    /* bookmark listener */
                    {
                        template.find(".setting-bookmark-profile").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.connect_profile = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-server-host").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.server_properties.server_address = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-server-port").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.server_properties.server_port = parseInt(element.value);
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-server-password").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.server_properties.server_password = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-username").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.nickname = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-channel").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.default_channel = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                        template.find(".setting-channel-password").on('change', event => {
                            if (!selected_bookmark || selected_bookmark.type != bookmarks.BookmarkType.ENTRY)
                                return;
                            const casted = selected_bookmark;
                            const element = event.target;
                            casted.default_channel_password = element.value;
                            bookmarks.save_bookmark(selected_bookmark);
                        });
                    }
                    /* listener for both */
                    {
                        template.find(".setting-bookmark-name").on('change', event => {
                            if (!selected_bookmark)
                                return;
                            const element = event.target;
                            if (element.value.length >= 3) {
                                selected_bookmark.display_name = element.value;
                                bookmarks.save_bookmark(selected_bookmark);
                                if (update_name)
                                    update_name();
                            }
                        });
                    }
                }
                /* connect profile initialisation */
                {
                    const list = template.find(".setting-bookmark-profile");
                    for (const profile of profiles.profiles()) {
                        const tag = $.spawn("option").val(profile.id).text(profile.profile_name);
                        if (profile.id == "default")
                            tag.css("font-weight", "bold");
                        list.append(tag);
                    }
                }
                update_bookmarks();
                template.find(".button-close").on('click', event => modal.close());
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.close_listener.push(() => control_bar.update_bookmarks());
        modal.open();
    }
    Modals.spawnBookmarkModal = spawnBookmarkModal;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["5a69d9d0a89164320998047f342f6d2ca69c994caae9c2794ba6ee63d580be1a"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["5a69d9d0a89164320998047f342f6d2ca69c994caae9c2794ba6ee63d580be1a"] = "5a69d9d0a89164320998047f342f6d2ca69c994caae9c2794ba6ee63d580be1a";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["85c45806235171c014dbdda508a484dd921180fffab99c18c2ad8fc5c8c42e9a"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["85c45806235171c014dbdda508a484dd921180fffab99c18c2ad8fc5c8c42e9a"] = "85c45806235171c014dbdda508a484dd921180fffab99c18c2ad8fc5c8c42e9a";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "H5EOm1iQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (11,21)" }, { name: "ZGR4g_2j", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (94,59)" }, { name: "qCR5UwAK", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (132,52)" }, { name: "gwQ18Gca", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (133,42)" }, { name: "HJkXKKiL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (145,30)" }, { name: "KUiIPbZk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (154,30)" }, { name: "KHelNXdA", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (158,34)" }, { name: "RkOMiCkY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (200,27)" }, { name: "XeqTywEg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (201,30)" }, { name: "ADQesnfL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (207,27)" }, { name: "zMJoXNgO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (208,30)" }, { name: "MpRK4FDC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (224,35)" }, { name: "avsTWtu7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (225,38)" }, { name: "kNa5QiJW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (232,35)" }, { name: "j9AilD8M", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (233,38)" }, { name: "GJU5Xf_7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (242,39)" }, { name: "Vs4NOD8N", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (243,42)" }, { name: "nSIkLEFe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (249,33)" }, { name: "wNflkdlV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (251,39)" }, { name: "uUfEcYoD", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (252,42)" }, { name: "xDw7ybSe", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (272,35)" }, { name: "qXuk3wQ7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (273,38)" }, { name: "pJhUsQ0r", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (278,35)" }, { name: "taB5XBPB", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (279,38)" }, { name: "fys2HsBP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (320,42)" }, { name: "OO6ruCoC", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (332,37)" }, { name: "onZqqjWH", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (350,31)" }, { name: "JZyfxtd3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (356,41)" }, { name: "yRWRKF8F", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (360,39)" }, { name: "cReU9yQc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (365,35)" }, { name: "U0_oaDtL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (373,37)" }, { name: "q64eV__R", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (389,45)" }, { name: "q0z7nmpR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (394,39)" }, { name: "mvNwTzi0", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (395,39)" }, { name: "cK4Zn14n", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (400,37)" }, { name: "lvJq5biL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (406,39)" }, { name: "Q_JfyqXr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (408,43)" }, { name: "dEwrAWeX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (410,43)" }, { name: "wUj2o1fW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (419,37)" }, { name: "Rf7B_g74", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (430,21)" }, { name: "CsDHd4Iy", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (571,39)" }, { name: "o24tU6_S", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalIconSelect.ts (575,39)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnIconSelect(client, callback_icon, selected_icon) {
        selected_icon = selected_icon || 0;
        let allow_manage = client.permissions.neededPermission(PermissionType.B_ICON_MANAGE).granted(1);
        const modal = createModal({
            header: _translations.H5EOm1iQ || (_translations.H5EOm1iQ = tr("Icons")),
            footer: undefined,
            body: () => {
                const template = $("#tmpl_icon_select").renderTag({
                    enable_select: !!callback_icon,
                    enable_upload: allow_manage,
                    enable_delete: allow_manage
                });
                return template;
            }
        });
        const button_select = modal.htmlTag.find(".button-select");
        const button_delete = modal.htmlTag.find(".button-delete").prop("disabled", true);
        const button_upload = modal.htmlTag.find(".button-upload").prop("disabled", !allow_manage);
        const container_loading = modal.htmlTag.find(".container-loading").hide();
        const container_no_permissions = modal.htmlTag.find(".container-no-permissions").hide();
        const container_error = modal.htmlTag.find(".container-error").hide();
        const selected_container = modal.htmlTag.find(".selected-item-container");
        const update_local_icons = (icons) => {
            const container_icons = modal.htmlTag.find(".container-icons .container-icons-local");
            container_icons.empty();
            for (const icon_id of icons) {
                const tag = client.fileManager.icons.generateTag(icon_id, { animate: false }).attr('title', "Icon " + icon_id);
                if (callback_icon) {
                    tag.on('click', event => {
                        container_icons.find(".selected").removeClass("selected");
                        tag.addClass("selected");
                        selected_container.empty().append(tag.clone());
                        selected_icon = icon_id;
                        button_select.prop("disabled", false);
                    });
                    tag.on('dblclick', event => {
                        callback_icon(icon_id);
                        modal.close();
                    });
                    if (icon_id == selected_icon)
                        tag.trigger('click');
                }
                tag.appendTo(container_icons);
            }
        };
        const update_remote_icons = () => {
            container_no_permissions.hide();
            container_error.hide();
            container_loading.show();
            const display_remote_error = (error) => {
                if (typeof (error) === "string") {
                    container_error.find(".error-message").text(error);
                    container_error.show();
                }
                else {
                    container_error.hide();
                }
            };
            client.fileManager.requestFileList("/icons").then(icons => {
                const container_icons = modal.htmlTag.find(".container-icons");
                const container_icons_remote = container_icons.find(".container-icons-remote");
                const container_icons_remote_parent = container_icons_remote.parent();
                container_icons_remote.detach().empty();
                const chunk_size = 50;
                const icon_chunks = [];
                let index = 0;
                while (icons.length > index) {
                    icon_chunks.push(icons.slice(index, index + chunk_size));
                    index += chunk_size;
                }
                const process_next_chunk = () => {
                    const chunk = icon_chunks.pop_front();
                    if (!chunk)
                        return;
                    for (const icon of chunk) {
                        const icon_id = parseInt(icon.name.substr("icon_".length));
                        if (icon_id == NaN) {
                            log.warn(LogCategory.GENERAL, _translations.ZGR4g_2j || (_translations.ZGR4g_2j = tr("Received an unparsable icon within icon list (%o)")), icon);
                            continue;
                        }
                        const tag = client.fileManager.icons.generateTag(icon_id, { animate: false }).attr('title', "Icon " + icon_id);
                        if (callback_icon || allow_manage) {
                            tag.on('click', event => {
                                container_icons.find(".selected").removeClass("selected");
                                tag.addClass("selected");
                                selected_container.empty().append(tag.clone());
                                selected_icon = icon_id;
                                button_select.prop("disabled", false);
                                button_delete.prop("disabled", !allow_manage);
                            });
                            tag.on('dblclick', event => {
                                if (!callback_icon)
                                    return;
                                callback_icon(icon_id);
                                modal.close();
                            });
                            if (icon_id == selected_icon)
                                tag.trigger('click');
                        }
                        tag.appendTo(container_icons_remote);
                    }
                    setTimeout(process_next_chunk, 100);
                };
                process_next_chunk();
                container_icons_remote_parent.append(container_icons_remote);
                container_error.hide();
                container_loading.hide();
                container_no_permissions.hide();
            }).catch(error => {
                if (error instanceof CommandResult && error.id == ErrorID.PERMISSION_ERROR) {
                    container_no_permissions.show();
                }
                else {
                    log.error(LogCategory.GENERAL, _translations.qCR5UwAK || (_translations.qCR5UwAK = tr("Failed to fetch icon list. Error: %o")), error);
                    display_remote_error(_translations.gwQ18Gca || (_translations.gwQ18Gca = tr("Failed to fetch icon list")));
                }
                container_loading.hide();
            });
        };
        button_delete.on('click', event => {
            if (!selected_icon)
                return;
            const selected = modal.htmlTag.find(".selected");
            if (selected.length != 1)
                console.warn(_translations.HJkXKKiL || (_translations.HJkXKKiL = tr("UI selected icon length does not equal with 1! (%o)")), selected.length);
            if (selected_icon < 1000)
                return; /* we cant delete local icons */
            client.fileManager.icons.delete_icon(selected_icon).then(() => {
                selected.detach();
            }).catch(error => {
                if (error instanceof CommandResult && error.id == ErrorID.PERMISSION_ERROR)
                    return;
                console.warn(_translations.KUiIPbZk || (_translations.KUiIPbZk = tr("Failed to delete icon %d: %o")), selected_icon, error);
                error = error instanceof CommandResult ? error.extra_message || error.message : error;
                createErrorModal(_translations.KHelNXdA || (_translations.KHelNXdA = tr("Failed to delete icon")), tra("Failed to delete icon.<br>Error: ", error)).open();
            });
        });
        button_upload.on('click', event => spawnIconUpload(client));
        update_local_icons([100, 200, 300, 500, 600]);
        update_remote_icons();
        modal.htmlTag.find('.button-reload').on('click', () => update_remote_icons());
        button_select.prop("disabled", true).on('click', () => {
            if (callback_icon)
                callback_icon(selected_icon);
            modal.close();
        });
        modal.htmlTag.find(".button-select-no-icon").on('click', () => {
            if (callback_icon)
                callback_icon(0);
            modal.close();
        });
        modal.open();
    }
    Modals.spawnIconSelect = spawnIconSelect;
    function handle_icon_upload(file, client) {
        const icon = {};
        icon.file = file;
        icon.upload_state = "unset";
        const file_too_big = () => {
            console.error(_translations.RkOMiCkY || (_translations.RkOMiCkY = tr("Failed to load file %s: File is too big!")), file.name);
            createErrorModal(_translations.XeqTywEg || (_translations.XeqTywEg = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>The given file is too big!", file.name)).open();
            icon.state = "error";
        };
        if (file.size > 1024 * 1024 * 512) {
            file_too_big();
        }
        else if ((file.size | 0) <= 0) {
            console.error(_translations.ADQesnfL || (_translations.ADQesnfL = tr("Failed to load file %s: Your browser does not support file sizes!")), file.name);
            createErrorModal(_translations.zMJoXNgO || (_translations.zMJoXNgO = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Your browser does not support file sizes!", file.name)).open();
            icon.state = "error";
            return;
        }
        else {
            icon.state = "loading";
            icon.loader = (() => __awaiter(this, void 0, void 0, function* () {
                const reader = new FileReader();
                try {
                    yield new Promise((resolve, reject) => {
                        reader.onload = resolve;
                        reader.onerror = reject;
                        reader.readAsDataURL(file);
                    });
                }
                catch (error) {
                    console.log("Image failed to load (%o)", error);
                    console.error(_translations.MpRK4FDC || (_translations.MpRK4FDC = tr("Failed to load file %s: Image failed to load")), file.name);
                    createErrorModal(_translations.avsTWtu7 || (_translations.avsTWtu7 = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Failed to load image", file.name)).open();
                    icon.state = "error";
                    return;
                }
                const result = reader.result;
                if (typeof (result) !== "string") {
                    console.error(_translations.kNa5QiJW || (_translations.kNa5QiJW = tr("Failed to load file %s: Result is not an media string (%o)")), file.name, result);
                    createErrorModal(_translations.j9AilD8M || (_translations.j9AilD8M = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Result is not an media string", file.name)).open();
                    icon.state = "error";
                    return;
                }
                /* get the CRC32 sum */
                {
                    if (!result.startsWith("data:image/")) {
                        console.error(_translations.GJU5Xf_7 || (_translations.GJU5Xf_7 = tr("Failed to load file %s: Invalid data media type (%o)")), file.name, result);
                        createErrorModal(_translations.Vs4NOD8N || (_translations.Vs4NOD8N = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>File is not an image", file.name)).open();
                        icon.state = "error";
                        return;
                    }
                    const semi = result.indexOf(';');
                    const type = result.substring(11, semi);
                    console.log(_translations.nSIkLEFe || (_translations.nSIkLEFe = tr("Given image has type %s")), type);
                    if (!result.substr(semi + 1).startsWith("base64,")) {
                        console.error(_translations.wNflkdlV || (_translations.wNflkdlV = tr("Failed to load file %s: Mimetype isnt base64 encoded (%o)")), file.name, result.substr(semi + 1));
                        createErrorModal(_translations.uUfEcYoD || (_translations.uUfEcYoD = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Decoder returned unknown result", file.name)).open();
                        icon.state = "error";
                        return;
                    }
                    const crc = new Crc32();
                    crc.update(arrayBufferBase64(result.substr(semi + 8)));
                    icon.icon_id = crc.digest(10);
                }
                const image = document.createElement("img");
                try {
                    yield new Promise((resolve, reject) => {
                        image.onload = resolve;
                        image.onerror = reject;
                        image.src = result;
                    });
                }
                catch (error) {
                    console.log("Image failed to load (%o)", error);
                    console.error(_translations.xDw7ybSe || (_translations.xDw7ybSe = tr("Failed to load file %s: Image failed to load")), file.name);
                    createErrorModal(_translations.qXuk3wQ7 || (_translations.qXuk3wQ7 = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Failed to load image", file.name)).open();
                    icon.state = "error";
                }
                const width_error = message => {
                    console.error(_translations.pJhUsQ0r || (_translations.pJhUsQ0r = tr("Failed to load file %s: Invalid bounds: %s")), file.name, message);
                    createErrorModal(_translations.taB5XBPB || (_translations.taB5XBPB = tr("Icon upload failed")), tra("Failed to upload icon {}.<br>Image is too large ({})", file.name, message)).open();
                    icon.state = "error";
                };
                if (image.naturalWidth > 32 && image.naturalHeight > 32) {
                    width_error("width and height (max 32px)");
                    return;
                }
                if (image.naturalWidth > 32) {
                    width_error("width (max 32px)");
                    return;
                }
                if (image.naturalHeight > 32) {
                    width_error("height (max 32px)");
                    return;
                }
                console.log("Image loaded (%dx%d) %s (%s)", image.naturalWidth, image.naturalHeight, image.name, icon.icon_id);
                icon.image_element = () => {
                    const image = document.createElement("img");
                    image.src = result;
                    return image;
                };
                icon.state = "valid";
            }))();
            icon.upload_icon = () => {
                const create_progress_bar = () => {
                    const html = $.spawn("div").addClass("progress");
                    const indicator = $.spawn("div").addClass("progress-bar bg-success progress-bar-striped progress-bar-animated");
                    const message = $.spawn("div").addClass("progress-message");
                    const set_value = value => {
                        indicator.stop(true, false).animate({ width: value + "%" }, 250);
                        if (value === 100)
                            setTimeout(() => indicator.removeClass("progress-bar-striped progress-bar-animated"), 900);
                    };
                    return {
                        html_tag: html.append(indicator).append(message),
                        set_value: set_value,
                        set_message: msg => message.text(msg),
                        set_error: msg => {
                            message.text((_translations.fys2HsBP || (_translations.fys2HsBP = tr("error: "))) + msg);
                            set_value(100);
                            indicator.removeClass("bg-success").addClass("bg-danger");
                        }
                    };
                };
                const container_image = $.spawn("div").addClass("container-icon");
                const bar = create_progress_bar();
                const set_error = message => {
                    bar.set_value(100);
                    bar.set_message((_translations.OO6ruCoC || (_translations.OO6ruCoC = tr("error: "))) + message);
                };
                const html_tag = $.spawn("div")
                    .addClass("upload-entry")
                    .append(container_image)
                    .append(bar.html_tag);
                icon.upload_html_tag = html_tag;
                let icon_added = false;
                if (icon.image_element) {
                    container_image.append(icon.image_element());
                    icon_added = true;
                }
                bar.set_value(0);
                bar.set_value(_translations.onZqqjWH || (_translations.onZqqjWH = tr("waiting")));
                return () => __awaiter(this, void 0, void 0, function* () {
                    const time_begin = Date.now();
                    if (icon.state === "loading") {
                        bar.set_message(_translations.JZyfxtd3 || (_translations.JZyfxtd3 = tr("Awaiting local processing")));
                        yield icon.loader;
                        // @ts-ignore Could happen because the loader function updates the state
                        if (icon.state !== "valid") {
                            set_error(_translations.yRWRKF8F || (_translations.yRWRKF8F = tr("local processing failed")));
                            icon.upload_state = "error";
                            return;
                        }
                    }
                    else if (icon.state === "error") {
                        set_error(_translations.cReU9yQc || (_translations.cReU9yQc = tr("local processing error")));
                        icon.upload_state = "error";
                        return;
                    }
                    if (!icon_added)
                        container_image.append(icon.image_element());
                    bar.set_value(25);
                    bar.set_message(_translations.U0_oaDtL || (_translations.U0_oaDtL = tr("initializing")));
                    let upload_key;
                    try {
                        upload_key = yield client.fileManager.upload_file({
                            channel: undefined,
                            channel_password: undefined,
                            name: '/icon_' + icon.icon_id,
                            overwrite: false,
                            path: '',
                            size: icon.file.size
                        });
                    }
                    catch (error) {
                        if (error instanceof CommandResult && error.id == ErrorID.FILE_ALREADY_EXISTS) {
                            if (!settings.static_global(Settings.KEY_DISABLE_COSMETIC_SLOWDOWN, false))
                                yield new Promise(resolve => setTimeout(resolve, 500 + Math.floor(Math.random() * 500)));
                            bar.set_message(_translations.q64eV__R || (_translations.q64eV__R = tr("icon already exists")));
                            bar.set_value(100);
                            icon.upload_state = "uploaded";
                            return;
                        }
                        console.error(_translations.q0z7nmpR || (_translations.q0z7nmpR = tr("Failed to initialize upload: %o")), error);
                        bar.set_error(_translations.mvNwTzi0 || (_translations.mvNwTzi0 = tr("failed to initialize upload")));
                        icon.upload_state = "error";
                        return;
                    }
                    bar.set_value(50);
                    bar.set_message(_translations.cK4Zn14n || (_translations.cK4Zn14n = tr("uploading")));
                    const connection = transfer.spawn_upload_transfer(upload_key);
                    try {
                        yield connection.put_data(icon.file);
                    }
                    catch (error) {
                        console.error(_translations.lvJq5biL || (_translations.lvJq5biL = tr("Icon upload failed for icon %s: %o")), icon.file.name, error);
                        if (typeof (error) === "string")
                            bar.set_error((_translations.Q_JfyqXr || (_translations.Q_JfyqXr = tr("upload failed: "))) + error);
                        else
                            bar.set_error(_translations.dEwrAWeX || (_translations.dEwrAWeX = tr("upload failed")));
                        icon.upload_state = "error";
                        return;
                    }
                    const time_end = Date.now();
                    if (!settings.static_global(Settings.KEY_DISABLE_COSMETIC_SLOWDOWN, false))
                        yield new Promise(resolve => setTimeout(resolve, Math.max(0, 1000 - (time_end - time_begin))));
                    bar.set_value(100);
                    bar.set_message(_translations.wUj2o1fW || (_translations.wUj2o1fW = tr("upload completed")));
                    icon.upload_state = "uploaded";
                });
            };
        }
        return icon;
    }
    function spawnIconUpload(client) {
        const modal = createModal({
            header: _translations.Rf7B_g74 || (_translations.Rf7B_g74 = tr("Upload Icons")),
            footer: undefined,
            body: () => {
                const template = $("#tmpl_icon_upload").renderTag();
                return template;
            },
            closeable: false
        });
        const button_upload = modal.htmlTag.find(".button-upload");
        const button_delete = modal.htmlTag.find(".button-remove").prop("disabled", true);
        const button_add = modal.htmlTag.find(".button-add");
        const button_upload_abort = modal.htmlTag.find(".button-upload-abort");
        const input_file = modal.htmlTag.find(".input-file-upload");
        const container_icons = modal.htmlTag.find(".container-icons");
        let selected_icon;
        let icons = [];
        const update_upload_button = () => {
            const icon_count = icons.filter(e => e.state === "valid").length;
            button_upload.empty();
            tra("Upload icons ({})", icon_count).forEach(e => e.appendTo(button_upload));
            button_upload.prop("disabled", icon_count == 0);
        };
        update_upload_button();
        const add_icon = (icon) => {
            icons.push(icon);
            icon.loader.then(e => {
                if (icon.state === "valid") {
                    const image = icon.image_element();
                    const element = $.spawn("div")
                        .addClass("icon-container")
                        .append(image);
                    container_icons.append(icon.html_tag = element);
                    element.on('click', event => {
                        container_icons.find(".selected").removeClass("selected");
                        element.addClass("selected");
                        selected_icon = icon;
                        button_delete.prop("disabled", false);
                    });
                    update_upload_button();
                }
            });
        };
        button_delete.on('click', event => {
            if (!selected_icon)
                return;
            icons = icons.filter(e => e !== selected_icon);
            if (selected_icon.html_tag)
                selected_icon.html_tag.detach();
            button_delete.prop("disabled", true);
            update_upload_button();
        });
        button_add.on('click', event => input_file.click());
        input_file.on('change', event => {
            if (input_file[0].files.length > 0) {
                for (let index = 0; index < input_file[0].files.length; index++) {
                    const file = input_file[0].files.item(index);
                    {
                        let duplicate = false;
                        for (const icon of icons)
                            if (icon.file.name === file.name && icon.file.lastModified === file.lastModified && icon.state !== "error") {
                                duplicate = true;
                                break;
                            }
                        if (duplicate)
                            continue;
                    }
                    add_icon(handle_icon_upload(file, client));
                }
            }
        });
        container_icons.on('dragover', ((event) => {
            event.stopPropagation();
            event.preventDefault();
            event.dataTransfer.dropEffect = 'copy';
        }));
        container_icons.on('drop', ((event) => {
            event.stopPropagation();
            event.preventDefault();
            for (let index = 0; index < event.dataTransfer.files.length; index++) {
                const file = event.dataTransfer.files.item(index);
                {
                    let duplicate = false;
                    for (const icon of icons)
                        if (icon.file === file && icon.state !== "error") {
                            duplicate = true;
                            break;
                        }
                    if (duplicate)
                        continue;
                }
                add_icon(handle_icon_upload(file, client));
            }
        }));
        /* upload process */
        {
            const container_upload = modal.htmlTag.find(".container-upload");
            const container_error = container_upload.find(".container-error");
            const container_success = container_upload.find(".container-success");
            const container_process = container_upload.find(".container-process");
            const container_info = container_upload.find(".container-info");
            const container_statistics = container_upload.find(".uploaded-statistics");
            const show_critical_error = message => {
                container_error.find(".error-message").text(message);
                container_error.show();
            };
            const finish_upload = () => {
                icons = icons.filter(e => {
                    if (e.upload_state === "uploaded") {
                        e.html_tag.detach();
                        return false;
                    }
                    return true;
                });
                update_upload_button();
                button_upload.prop("disabled", false);
                button_upload.prop("disabled", false);
                container_upload.hide();
                container_error.hide();
                modal.set_closeable(true);
            };
            const execute_upload = () => __awaiter(this, void 0, void 0, function* () {
                if (!client || !client.fileManager) {
                    show_critical_error(_translations.CsDHd4Iy || (_translations.CsDHd4Iy = tr("Invalid client handle")));
                    return;
                }
                if (!client.connected) {
                    show_critical_error(_translations.o24tU6_S || (_translations.o24tU6_S = tr("Not connected")));
                    return;
                }
                let invoke_count = 0;
                let succeed_count = 0;
                let failed_count = 0;
                const uploads = icons.filter(e => e.state !== "error");
                const executes = [];
                for (const icon of uploads) {
                    executes.push({
                        icon: icon,
                        task: icon.upload_icon()
                    });
                    if (!icon.upload_html_tag)
                        continue; /* TODO: error? */
                    icon.upload_html_tag.appendTo(container_process);
                }
                const update_state = () => container_statistics.text(invoke_count + " | " + succeed_count + " | " + failed_count);
                for (const execute of executes) {
                    invoke_count++;
                    update_state();
                    try {
                        yield execute.task();
                        if (execute.icon.upload_state !== "uploaded")
                            throw "failed";
                        succeed_count++;
                    }
                    catch (error) {
                        failed_count++;
                    }
                    update_state();
                }
                container_info.css({ opacity: 1 }).animate({ opacity: 0 }, 250, () => container_info.css({ opacity: undefined }).hide());
                container_success.find(".message").html("Total icons: " + invoke_count + "<br>" +
                    "Succeeded icons: " + succeed_count + "<br>" +
                    "Failed icons: " + failed_count);
                container_success.css({ opacity: 0 }).show().animate({ opacity: 1 }, 250, () => container_success.css({ opacity: undefined }));
            });
            button_upload.on('click', event => {
                modal.set_closeable(false);
                button_upload.prop("disabled", true);
                button_delete.prop("disabled", true);
                button_add.prop("disabled", true);
                container_process.empty();
                container_upload.show();
                execute_upload();
            });
            button_upload_abort.on('click', event => finish_upload());
            container_success.hide();
            container_upload.hide();
            container_error.hide();
        }
        modal.open();
        modal.set_closeable(true);
    }
    Modals.spawnIconUpload = spawnIconUpload;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["384de95565a88b808ccbe0c564c51661144c5363642411841c9c2eea7c532be5"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["384de95565a88b808ccbe0c564c51661144c5363642411841c9c2eea7c532be5"] = "384de95565a88b808ccbe0c564c51661144c5363642411841c9c2eea7c532be5";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "BmGWrsn3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalInvite.ts (9,21)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnInviteEditor(connection) {
        let modal;
        modal = createModal({
            header: _translations.BmGWrsn3 || (_translations.BmGWrsn3 = tr("Invalid URL creator")),
            body: () => {
                let template = $("#tmpl_invite").renderTag();
                template.find(".button-close").on('click', event => modal.close());
                return template;
            },
            footer: undefined
        });
        const container_url = modal.htmlTag.find(".text-output");
        const button_copy = modal.htmlTag.find(".button-copy");
        button_copy.on('click', event => {
            container_url.select();
            document.execCommand('copy');
        });
        let flag_direct_connect = true;
        let flag_resolved_address = false;
        const update_link = () => {
            const address = flag_resolved_address ? this.channelTree.client.serverConnection.remote_address() : connection.channelTree.server.remote_address;
            const parameter = "connect_default=" + (flag_direct_connect ? 1 : 0) + "&connect_address=" + encodeURIComponent(address.host + (address.port === 9987 ? "" : address.port));
            const url = document.location.origin + document.location.pathname + "?" + parameter;
            container_url.text(url);
        };
        {
            const input_direct_connect = modal.htmlTag.find(".flag-direct-connect input");
            input_direct_connect.on('change', event => {
                flag_direct_connect = input_direct_connect[0].checked;
                update_link();
            });
            input_direct_connect[0].checked = flag_direct_connect;
        }
        {
            const input = modal.htmlTag.find(".flag-resolved-address input");
            input.on('change', event => {
                flag_resolved_address = input[0].checked;
                update_link();
            });
            input[0].checked = flag_resolved_address;
        }
        update_link();
        modal.open();
    }
    Modals.spawnInviteEditor = spawnInviteEditor;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["d2835ed355b7a4b607394435121219f09c77ce916db2434281366d65a091c4e0"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["d2835ed355b7a4b607394435121219f09c77ce916db2434281366d65a091c4e0"] = "d2835ed355b7a4b607394435121219f09c77ce916db2434281366d65a091c4e0";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "vt2gWQe9", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (10,21)" }, { name: "PMYOTtOd", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (43,21)" }, { name: "g4m2cqML", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (83,21)" }, { name: "Pxdw_lII", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (108,46)" }, { name: "GliVAuor", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (108,82)" }, { name: "RbMIbfIr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (130,46)" }, { name: "TpF0XVoV", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (130,82)" }, { name: "JBct4wDx", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (137,36)" }, { name: "rBVaiib_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (137,57)" }, { name: "p7zZDMie", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (178,27)" }, { name: "DB7t0VAf", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (207,50)" }, { name: "ORoDpoiY", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (207,80)" }, { name: "Iq8b45uR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (230,31)" }, { name: "n9MzB3Nv", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (248,38)" }, { name: "TVPTydUN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (248,65)" }, { name: "g0cXMASX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (352,30)" }, { name: "rfUasQIu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistEdit.ts (352,67)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnPlaylistSongInfo(song) {
        let modal;
        modal = createModal({
            header: _translations.vt2gWQe9 || (_translations.vt2gWQe9 = tr("Song info")),
            body: () => {
                try {
                    song.metadata = JSON.parse(song.song_metadata);
                }
                catch (e) { }
                let template = $("#tmpl_playlist_edit-song_info").renderTag(song);
                template = $.spawn("div").append(template);
                const text_area = template.find(".property-metadata-raw textarea");
                template.find(".toggle-metadata").on('click', event => {
                    if (text_area.is(":visible")) {
                        template.find(".toggle-metadata").text("show");
                    }
                    else {
                        template.find(".toggle-metadata").text("hide");
                    }
                    text_area.slideToggle({ duration: 250 });
                });
                text_area.hide();
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
    }
    Modals.spawnPlaylistSongInfo = spawnPlaylistSongInfo;
    function spawnSongAdd(playlist, callback_add) {
        let modal;
        modal = createModal({
            header: _translations.PMYOTtOd || (_translations.PMYOTtOd = tr("Add a song")),
            body: () => {
                let template = $("#tmpl_playlist_edit-song_add").renderTag();
                template = $.spawn("div").append(template);
                const url = template.find(".property-url .value");
                const url_loader = template.find(".property-loader .value");
                const button_add = template.find(".container-buttons .button-add");
                const button_cancel = template.find(".container-buttons .button-cancel");
                url.on('change keyup', event => {
                    button_add.prop("disabled", url.val().toString().length == 0);
                }).trigger('change');
                button_cancel.on('click', event => modal.close());
                button_add.on('click', event => {
                    callback_add(url.val(), url_loader.val());
                    modal.close();
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
    }
    Modals.spawnSongAdd = spawnSongAdd;
    function spawnPlaylistEdit(client, playlist) {
        let modal;
        let changed_properties = {};
        let changed_permissions = {};
        let callback_permission_update;
        const update_save = () => {
            const save_button = modal.htmlTag.find(".buttons .button-save");
            save_button.prop("disabled", (Object.keys(changed_properties).length + Object.keys(changed_permissions).length) == 0);
        };
        modal = createModal({
            header: _translations.g4m2cqML || (_translations.g4m2cqML = tr("Edit playlist")),
            body: () => {
                let template = $("#tmpl_playlist_edit").renderTag().tabify();
                callback_permission_update = apply_permissions(template, client, playlist, (key, value) => {
                    console.log("Change permission %o => %o", key, value);
                    changed_permissions[key] = value;
                    update_save();
                });
                const callback_song_id = apply_songs(template, client, playlist);
                apply_properties(template, client, playlist, (key, value) => {
                    console.log("Change property %o => %o", key, value);
                    changed_properties[key] = value;
                    update_save();
                }, callback_song_id);
                template.find(".buttons .button-save").on('click', event => {
                    if (Object.keys(changed_properties).length != 0) {
                        changed_properties["playlist_id"] = playlist.playlist_id;
                        client.serverConnection.send_command("playlistedit", changed_properties).then(() => {
                            changed_properties = {};
                            update_save();
                        }).catch(error => {
                            if (error instanceof CommandResult)
                                error = error.extra_message || error.message;
                            createErrorModal(_translations.Pxdw_lII || (_translations.Pxdw_lII = tr("Failed to change properties.")), (_translations.GliVAuor || (_translations.GliVAuor = tr("Failed to change playlist properties.<br>Error: "))) + error).open();
                        });
                    }
                    if (Object.keys(changed_permissions).length != 0) {
                        const array = [];
                        for (const permission_key of Object.keys(changed_permissions)) {
                            array.push({
                                permvalue: changed_permissions[permission_key],
                                permnegated: false,
                                permskip: false,
                                permsid: permission_key
                            });
                        }
                        array[0]["playlist_id"] = playlist.playlist_id;
                        client.serverConnection.send_command("playlistaddperm", array).then(() => {
                            changed_permissions = {};
                            update_save();
                        }).catch(error => {
                            if (error instanceof CommandResult)
                                error = error.extra_message || error.message;
                            createErrorModal(_translations.RbMIbfIr || (_translations.RbMIbfIr = tr("Failed to change permission.")), (_translations.TpF0XVoV || (_translations.TpF0XVoV = tr("Failed to change playlist permissions.<br>Error: "))) + error).open();
                        });
                    }
                });
                template.find(".buttons .button-close").on('click', event => {
                    if ((Object.keys(changed_properties).length + Object.keys(changed_permissions).length) != 0) {
                        Modals.spawnYesNo(_translations.JBct4wDx || (_translations.JBct4wDx = tr("Are you sure?")), _translations.rBVaiib_ || (_translations.rBVaiib_ = tr("Do you really want to discard all your changes?")), result => {
                            if (result)
                                modal.close();
                        });
                        return;
                    }
                    modal.close();
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        update_save();
        modal.open();
        return modal;
    }
    Modals.spawnPlaylistEdit = spawnPlaylistEdit;
    function apply_songs(tag, client, playlist) {
        const owns_playlist = playlist.playlist_owner_dbid == client.getClient().properties.client_database_id;
        const song_tag = tag.find(".container-songs");
        let replaying_song_id = 0;
        let selected_song;
        const set_song_info = (text) => {
            const tag = song_tag.find(".info-message");
            if (text && text.length > 0) {
                tag.text(text).show();
            }
            else
                tag.hide();
        };
        const set_current_song = (id) => {
            /* this method shall enforce an update */
            replaying_song_id = id;
            update_songs();
        };
        const update_songs = () => {
            set_song_info(_translations.p7zZDMie || (_translations.p7zZDMie = tr("loading song list")));
            client.serverConnection.command_helper.request_playlist_songs(playlist.playlist_id).then(result => {
                const entries_tag = song_tag.find(".song-list-entries");
                const entry_template = $("#tmpl_playlist_edit-song_entry");
                entries_tag.empty();
                for (const song of result) {
                    const rendered = entry_template.renderTag(song);
                    rendered.find(".button-info").on('click', event => {
                        spawnPlaylistSongInfo(song);
                    });
                    const button_delete = rendered.find(".button-delete");
                    if (!owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_SONG_REMOVE_POWER).granted(playlist.needed_power_song_remove))
                        button_delete.detach();
                    else
                        button_delete.on('click', event => {
                            client.serverConnection.send_command("playlistsongremove", {
                                playlist_id: playlist.playlist_id,
                                song_id: song.song_id
                            }).then(() => {
                                rendered.slideToggle({ duration: 250, done(animation, jumpedToEnd) {
                                        rendered.detach();
                                    } });
                                rendered.hide(250);
                            }).catch(error => {
                                if (error instanceof CommandResult)
                                    error = error.extra_message || error.message;
                                createErrorModal(_translations.DB7t0VAf || (_translations.DB7t0VAf = tr("Failed to remove song.")), (_translations.ORoDpoiY || (_translations.ORoDpoiY = tr("Failed to remove song/url from the playlist.<br>Error: "))) + error).open();
                            });
                        });
                    if (song.song_id == replaying_song_id)
                        rendered.addClass("playing");
                    rendered.on('click', event => {
                        selected_song = song;
                        entries_tag.find(".selected").removeClass("selected");
                        rendered.addClass("selected");
                    });
                    entries_tag.append(rendered);
                }
                const entry_container = song_tag.find(".song-list-entries-container");
                if (entry_container.hasScrollBar())
                    entry_container.addClass("scrollbar");
                set_song_info("displaying " + result.length + " songs");
            }).catch(error => {
                console.error(error);
                set_song_info(_translations.Iq8b45uR || (_translations.Iq8b45uR = tr("failed to load song list")));
                //TODO improve error handling!
            });
        };
        song_tag.find(".button-refresh").on('click', event => update_songs());
        song_tag.find(".button-song-add").on('click', event => {
            spawnSongAdd(playlist, (url, loader) => {
                //playlist_id invoker previous url
                client.serverConnection.send_command("playlistsongadd", {
                    playlist_id: playlist.playlist_id,
                    invoker: loader,
                    url: url
                }).then(() => {
                    update_songs();
                }).catch(error => {
                    if (error instanceof CommandResult)
                        error = error.extra_message || error.message;
                    createErrorModal(_translations.n9MzB3Nv || (_translations.n9MzB3Nv = tr("Failed to add song.")), (_translations.TVPTydUN || (_translations.TVPTydUN = tr("Failed to add song/url to the playlist.<br>Error: "))) + error).open();
                });
            });
        }).prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_SONG_ADD_POWER).granted(playlist.needed_power_song_add));
        /* setTimeout(update_songs, 100); */ /* We dont have to call that here because it will get called over set_current_song when we received the current song id */
        return set_current_song;
    }
    function apply_permissions(tag, client, playlist, change_permission) {
        const owns_playlist = playlist.playlist_owner_dbid == client.getClient().properties.client_database_id;
        const permission_tag = tag.find(".container-permissions");
        const nopermission_tag = tag.find(".container-no-permissions");
        const update_permissions = () => {
            if (!client.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_PLAYLIST_PERMISSION_LIST).granted(1)) {
                nopermission_tag.show();
                permission_tag.hide();
            }
            else {
                nopermission_tag.hide();
                permission_tag.show();
                permission_tag.find(".permission input").prop("disabled", true);
                client.permissions.requestPlaylistPermissions(playlist.playlist_id).then(permissions => {
                    permission_tag.find(".permission input")
                        .val(0)
                        .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_PERMISSION_MODIFY_POWER).granted(playlist.needed_power_permission_modify));
                    for (const permission of permissions) {
                        const tag = permission_tag.find(".permission[permission='" + permission.type.name + "']");
                        if (permission.value != -2)
                            tag.find("input").val(permission.value);
                    }
                });
            }
        };
        permission_tag.find(".permission").each((index, _element) => {
            const element = $(_element);
            element.find("input").on('change', event => {
                console.log(element.find("input").val());
                change_permission(element.attr("permission"), parseInt(element.find("input").val().toString()));
            });
        });
        update_permissions();
        return update_permissions;
    }
    function apply_properties(tag, client, playlist, change_property, callback_current_song) {
        const owns_playlist = playlist.playlist_owner_dbid == client.getClient().properties.client_database_id;
        client.serverConnection.command_helper.request_playlist_info(playlist.playlist_id).then(info => {
            tag.find(".property-owner input")
                .val(info.playlist_owner_name + " (" + info.playlist_owner_dbid + ")");
            tag.find(".property-title input")
                .val(info.playlist_title)
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_title", event.target.value);
            });
            tag.find(".property-description textarea")
                .val(info.playlist_description)
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_description", event.target.value);
            });
            tag.find(".property-type select")
                .val(info.playlist_type.toString())
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_description", event.target.selectedIndex.toString());
            });
            tag.find(".property-replay-mode select")
                .val(info.playlist_replay_mode.toString())
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_replay_mode", event.target.selectedIndex.toString());
            });
            tag.find(".property-flag-delete-played input")
                .prop("checked", info.playlist_flag_delete_played)
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_flag_delete_played", event.target.checked ? "1" : "0");
            });
            tag.find(".property-current-song input")
                .val(info.playlist_current_song_id);
            callback_current_song(info.playlist_current_song_id);
            tag.find(".property-flag-finished input")
                .prop("checked", info.playlist_flag_finished)
                .prop("disabled", !owns_playlist && !client.permissions.neededPermission(PermissionType.I_PLAYLIST_MODIFY_POWER).granted(playlist.needed_power_modify))
                .on('change', event => {
                change_property("playlist_flag_finished", event.target.checked ? "1" : "0");
            });
        }).catch(error => {
            if (error instanceof CommandResult)
                error = error.extra_message || error.message;
            createErrorModal(_translations.g0cXMASX || (_translations.g0cXMASX = tr("Failed to query playlist info")), (_translations.rfUasQIu || (_translations.rfUasQIu = tr("Failed to query playlist info.<br>Error:"))) + error).open();
        });
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["b30d26f62c13c6ab1ade2fa1245ea724f18ddbccae583ed15fe06296b16e8eac"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["b30d26f62c13c6ab1ade2fa1245ea724f18ddbccae583ed15fe06296b16e8eac"] = "b30d26f62c13c6ab1ade2fa1245ea724f18ddbccae583ed15fe06296b16e8eac";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "_Xer4dCw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (81,21)" }, { name: "VAp0VwTc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (99,44)" }, { name: "PCL7nR2U", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (99,79)" }, { name: "KOVxDMFR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (120,42)" }, { name: "rBCFBVLB", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (120,75)" }, { name: "jqZ3M_9M", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (132,39)" }, { name: "JUeclVdi", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (132,60)" }, { name: "TWk164j2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (135,49)" }, { name: "RiFD37kL", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (135,84)" }, { name: "zw4tllur", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (143,50)" }, { name: "YnRHhXVO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPlaylistList.ts (143,83)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnPlaylistManage(client) {
        let modal;
        let selected_playlist;
        let available_playlists;
        let highlight_own = settings.global("playlist-list-highlight-own", true);
        const update_selected = () => {
            const buttons = modal.htmlTag.find(".header .buttons");
            buttons.find(".button-playlist-edit").prop("disabled", !selected_playlist);
            buttons.find(".button-playlist-delete").prop("disabled", !selected_playlist || !( /* not owner or permission */client.permissions.neededPermission(PermissionType.I_PLAYLIST_DELETE_POWER).granted(selected_playlist.needed_power_delete) || /* client has permissions */
                client.getClient().properties.client_database_id == selected_playlist.playlist_owner_dbid /* client is playlist owner */));
            buttons.find(".button-playlist-create").prop("disabled", !client.permissions.neededPermission(PermissionType.B_PLAYLIST_CREATE).granted(1));
            if (selected_playlist) {
                buttons.find(".button-playlist-edit").prop("disabled", false);
            }
        };
        const update_list = () => __awaiter(this, void 0, void 0, function* () {
            const info_tag = modal.htmlTag.find(".footer .info a");
            info_tag.text("loading...");
            selected_playlist = undefined;
            update_selected();
            try {
                available_playlists = yield client.serverConnection.command_helper.request_playlist_list();
            }
            catch (error) {
                info_tag.text("failed to query playlist list.");
                //FIXME error handling?
                return;
            }
            const entries_tag = modal.htmlTag.find(".playlist-list-entries");
            const entry_template = $("#tmpl_playlist_list-list_entry");
            entries_tag.empty();
            const owndbid = client.getClient().properties.client_database_id;
            for (const query of available_playlists) {
                const tag = entry_template.renderTag(query).on('click', event => {
                    entries_tag.find(".entry.selected").removeClass("selected");
                    $(event.target).parent(".entry").addClass("selected");
                    selected_playlist = query;
                    update_selected();
                });
                if (highlight_own && query.playlist_owner_dbid == owndbid)
                    tag.addClass("highlighted");
                entries_tag.append(tag);
            }
            const entry_container = modal.htmlTag.find(".playlist-list-entries-container");
            if (entry_container.hasScrollBar())
                entry_container.addClass("scrollbar");
            info_tag.text("Showing " + available_playlists.length + " entries");
            update_selected();
        });
        modal = createModal({
            header: _translations._Xer4dCw || (_translations._Xer4dCw = tr("Manage playlists")),
            body: () => {
                let template = $("#tmpl_playlist_list").renderTag();
                /* first open the modal */
                setTimeout(() => {
                    const entry_container = template.find(".playlist-list-entries-container");
                    if (entry_container.hasScrollBar())
                        entry_container.addClass("scrollbar");
                }, 100);
                template.find(".footer .buttons .button-refresh").on('click', update_list);
                template.find(".button-playlist-create").on('click', event => {
                    const single_handler = {
                        function: command => {
                            const json = command.arguments;
                            update_list().then(() => {
                                Modals.spawnYesNo(_translations.VAp0VwTc || (_translations.VAp0VwTc = tr("Playlist created successful")), _translations.PCL7nR2U || (_translations.PCL7nR2U = tr("The playlist has been successfully created.<br>Should we open the editor?")), result => {
                                    if (result) {
                                        for (const playlist of available_playlists) {
                                            if (playlist.playlist_id == json[0]["playlist_id"]) {
                                                Modals.spawnPlaylistEdit(client, playlist).close_listener.push(update_list);
                                                return;
                                            }
                                        }
                                    }
                                });
                            });
                            return true;
                        },
                        command: "notifyplaylistcreated"
                    };
                    client.serverConnection.command_handler_boss().register_single_handler(single_handler);
                    client.serverConnection.send_command("playlistcreate").catch(error => {
                        client.serverConnection.command_handler_boss().remove_single_handler(single_handler);
                        if (error instanceof CommandResult)
                            error = error.extra_message || error.message;
                        createErrorModal(_translations.KOVxDMFR || (_translations.KOVxDMFR = tr("Unable to create playlist")), (_translations.rBCFBVLB || (_translations.rBCFBVLB = tr("Failed to create playlist<br>Message: "))) + error).open();
                    });
                });
                template.find(".button-playlist-edit").on('click', event => {
                    if (!selected_playlist)
                        return;
                    Modals.spawnPlaylistEdit(client, selected_playlist).close_listener.push(update_list);
                });
                template.find(".button-playlist-delete").on('click', () => {
                    if (!selected_playlist)
                        return;
                    Modals.spawnYesNo(_translations.jqZ3M_9M || (_translations.jqZ3M_9M = tr("Are you sure?")), _translations.JUeclVdi || (_translations.JUeclVdi = tr("Do you really want to delete this playlist?")), result => {
                        if (result) {
                            client.serverConnection.send_command("playlistdelete", { playlist_id: selected_playlist.playlist_id }).then(() => {
                                createInfoModal(_translations.TWk164j2 || (_translations.TWk164j2 = tr("Playlist deleted successful")), _translations.RiFD37kL || (_translations.RiFD37kL = tr("This playlist has been deleted successfully."))).open();
                                update_list();
                            }).catch(error => {
                                if (error instanceof CommandResult) {
                                    /* TODO extra handling here */
                                    //if(error.id == ErrorID.PLAYLIST_IS_IN_USE) { }
                                    error = error.extra_message || error.message;
                                }
                                createErrorModal(_translations.zw4tllur || (_translations.zw4tllur = tr("Unable to delete playlist")), (_translations.YnRHhXVO || (_translations.YnRHhXVO = tr("Failed to delete playlist<br>Message: "))) + error).open();
                            });
                        }
                    });
                });
                template.find(".input-search").on('change keyup', () => {
                    const text = (template.find(".input-search").val() || "").toLowerCase();
                    if (text.length == 0) {
                        template.find(".playlist-list-entries .entry").show();
                    }
                    else {
                        template.find(".playlist-list-entries .entry").each((_, e) => {
                            const element = $(e);
                            if (element.text().toLowerCase().indexOf(text) == -1)
                                element.hide();
                            else
                                element.show();
                        });
                    }
                });
                template.find(".button-highlight-own").on('change', event => {
                    const flag = event.target.checked;
                    settings.changeGlobal("playlist-list-highlight-own", flag);
                    if (flag) {
                        const owndbid = client.getClient().properties.client_database_id;
                        template.find(".playlist-list-entries .entry").each((index, _element) => {
                            const element = $(_element);
                            if (parseInt(element.attr("playlist-owner-dbid")) == owndbid)
                                element.addClass("highlighted");
                        });
                    }
                    else {
                        template.find(".playlist-list-entries .highlighted").removeClass("highlighted");
                    }
                }).prop("checked", highlight_own);
                return template;
            },
            footer: undefined,
            width: 750
        });
        update_list();
        modal.open();
    }
    Modals.spawnPlaylistManage = spawnPlaylistManage;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["c757dcc55afb0da40ef3b02ddf1c73519fd8e007b7a3948ba9e9f41675c7fc4c"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["c757dcc55afb0da40ef3b02ddf1c73519fd8e007b7a3948ba9e9f41675c7fc4c"] = "c757dcc55afb0da40ef3b02ddf1c73519fd8e007b7a3948ba9e9f41675c7fc4c";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Ug6zoMJZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPoke.ts (19,25)" }, { name: "awUzVYhO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPoke.ts (61,66)" }, { name: "mPpoLczs", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalPoke.ts (64,66)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    let global_modal;
    class PokeModal {
        constructor() {
            this.source_map = [];
            this._handle = createModal({
                header: _translations.Ug6zoMJZ || (_translations.Ug6zoMJZ = tr("You have been poked!")),
                body: () => {
                    let template = $("#tmpl_poke_popup").renderTag();
                    template.find(".button-close").on('click', event => this._handle_close());
                    return template;
                },
                footer: undefined,
                width: 750
            });
            this._handle.close_listener.push(() => this._handle_close());
        }
        modal() { return this._handle; }
        add_poke(source, invoker, message) {
            let handler;
            for (const entry of this.source_map)
                if (entry.source === source) {
                    handler = entry;
                    break;
                }
            if (!handler) {
                const html_tag = $.spawn("div").addClass("server");
                const poke_list = $.spawn("div").addClass("poke-list");
                $.spawn("div")
                    .addClass("server-name")
                    .text(source && source.channelTree && source.channelTree.server ? source.channelTree.server.properties.virtualserver_name : "unknown")
                    .appendTo(html_tag);
                poke_list.appendTo(html_tag);
                this.source_map.push(handler = {
                    source: source,
                    add_message: (invoker, message) => {
                        const container = $.spawn("div").addClass("entry");
                        $.spawn("div").addClass("date").text(moment().format("HH:mm:ss") + " - ").appendTo(container);
                        $.spawn("div").addClass("user").append($(htmltags.generate_client({
                            add_braces: true,
                            client_id: invoker.id,
                            client_name: invoker.name,
                            client_unique_id: invoker.unique_id
                        }))).appendTo(container);
                        if (message) {
                            $.spawn("div").addClass("text").text(_translations.awUzVYhO || (_translations.awUzVYhO = tr("pokes you:"))).appendTo(container);
                            $.spawn("div").addClass("poke-message").append(...MessageHelper.bbcode_chat(message)).appendTo(container);
                        }
                        else {
                            $.spawn("div").addClass("text").text(_translations.mPpoLczs || (_translations.mPpoLczs = tr("pokes you."))).appendTo(container);
                        }
                        container.appendTo(poke_list);
                    }
                });
                this._handle.htmlTag.find(".container-servers").append(html_tag);
            }
            handler.add_message(invoker, message);
        }
        _handle_close() {
            this._handle.close();
            global_modal = undefined;
        }
    }
    function spawnPoke(source, invoker, message) {
        if (!global_modal)
            global_modal = new PokeModal();
        global_modal.add_poke(source, invoker, message);
        global_modal.modal().open();
    }
    Modals.spawnPoke = spawnPoke;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["5183bd66d2e6b68386d9775fe146abc3ac0726ae420288a8d62da9458ddd8202"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["5183bd66d2e6b68386d9775fe146abc3ac0726ae420288a8d62da9458ddd8202"] = "5183bd66d2e6b68386d9775fe146abc3ac0726ae420288a8d62da9458ddd8202";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "LCCLdjq2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (9,21)" }, { name: "FV9PQwSr", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (18,42)" }, { name: "zrsd5BiO", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (18,66)" }, { name: "tFq0TyRM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (45,42)" }, { name: "lCHtXQ0D", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (45,74)" }, { name: "awEQpjJz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (65,36)" }, { name: "k73_p8F2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQuery.ts (65,69)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnQueryCreate(connection, callback_created) {
        let modal;
        modal = createModal({
            header: _translations.LCCLdjq2 || (_translations.LCCLdjq2 = tr("Create a server query login")),
            body: () => {
                let template = $("#tmpl_query_create").renderTag();
                template = $.spawn("div").append(template);
                template.find(".button-close").on('click', event => modal.close());
                template.find(".button-create").on('click', event => {
                    const name = template.find(".input-name").val();
                    if (name.length < 3 || name.length > 64) {
                        createErrorModal(_translations.FV9PQwSr || (_translations.FV9PQwSr = tr("Invalid username")), _translations.zrsd5BiO || (_translations.zrsd5BiO = tr("Please enter a valid name!"))).open();
                        return;
                    }
                    //client_login_password
                    const single_handler = {
                        function: command => {
                            const json = command.arguments[0];
                            spawnQueryCreated({
                                username: name,
                                password: json.client_login_password
                            }, true);
                            if (callback_created)
                                callback_created(name, json.client_login_password);
                            return true;
                        }
                    };
                    connection.serverConnection.command_handler_boss().register_single_handler(single_handler);
                    connection.serverConnection.send_command("querycreate", {
                        client_login_name: name
                    }).catch(error => {
                        connection.serverConnection.command_handler_boss().remove_single_handler(single_handler);
                        if (error instanceof CommandResult)
                            error = error.extra_message || error.message;
                        createErrorModal(_translations.tFq0TyRM || (_translations.tFq0TyRM = tr("Unable to create account")), (_translations.lCHtXQ0D || (_translations.lCHtXQ0D = tr("Failed to create account<br>Message: "))) + error).open();
                    });
                    modal.close();
                    //TODO create account
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
    }
    Modals.spawnQueryCreate = spawnQueryCreate;
    function spawnQueryCreated(credentials, just_created) {
        let modal;
        modal = createModal({
            header: just_created ? _translations.awEQpjJz || (_translations.awEQpjJz = tr("Server query credentials")) : _translations.k73_p8F2 || (_translations.k73_p8F2 = tr("New server query credentials")),
            body: () => {
                let template = $("#tmpl_query_created").renderTag(credentials);
                template = $.spawn("div").append(template);
                template.find(".button-close").on('click', event => modal.close());
                template.find(".query_name").text(credentials.username);
                template.find(".query_password").text(credentials.password);
                template.find(".btn_copy_name").on('click', () => {
                    template.find(".query_name").select();
                    document.execCommand("copy");
                });
                template.find(".btn_copy_password").on('click', () => {
                    template.find(".query_password").select();
                    document.execCommand("copy");
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        modal.open();
    }
    Modals.spawnQueryCreated = spawnQueryCreated;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["d2e2249e273340724728aef2e72557902de612bb003704f20b4e6b7dbf11c077"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["d2e2249e273340724728aef2e72557902de612bb003704f20b4e6b7dbf11c077"] = "d2e2249e273340724728aef2e72557902de612bb003704f20b4e6b7dbf11c077";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "Uwzl8cWh", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (55,21)" }, { name: "dTGwS0kw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (74,38)" }, { name: "AVkholEQ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (74,65)" }, { name: "N_vW674v", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (82,50)" }, { name: "PvcMNDZZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (82,82)" }, { name: "I35DAhx7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (84,49)" }, { name: "qO82rDt5", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (84,85)" }, { name: "pANw5774", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (93,38)" }, { name: "PEHMK9sU", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (93,71)" }, { name: "n33EjAur", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (115,50)" }, { name: "L0FiM43s", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (115,83)" }, { name: "gTLRFtIX", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (123,39)" }, { name: "A9NkElkq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (123,60)" }, { name: "vVxRMSeN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (130,50)" }, { name: "EXsPUkEy", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (130,82)" }, { name: "e9OJtgT7", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (132,49)" }, { name: "KE7XDn37", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/ModalQueryManage.ts (132,85)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../ui/elements/modal.ts" />
/// <reference path="../../ConnectionHandler.ts" />
/// <reference path="../../proto.ts" />
var Modals;
(function (Modals) {
    function spawnQueryManage(client) {
        let modal;
        let selected_query;
        const update_selected = () => {
            const buttons = modal.htmlTag.find(".header .buttons");
            //TODO gray out if no permissions (Server needs to send that... :D)
            buttons.find(".button-query-delete").prop("disabled", selected_query === undefined);
            buttons.find(".button-query-rename").prop("disabled", selected_query === undefined);
            buttons.find(".button-query-change-password").prop("disabled", selected_query === undefined);
        };
        const update_list = () => {
            const info_tag = modal.htmlTag.find(".footer .info a");
            info_tag.text("loading...");
            client.serverConnection.command_helper.current_virtual_server_id().then(server_id => {
                client.serverConnection.command_helper.request_query_list(server_id).then(result => {
                    selected_query = undefined;
                    const entries_tag = modal.htmlTag.find(".query-list-entries");
                    const entry_template = $("#tmpl_query_manager-list_entry");
                    entries_tag.empty();
                    for (const query of result.queries || []) {
                        entries_tag.append(entry_template.renderTag(query).on('click', event => {
                            entries_tag.find(".entry.selected").removeClass("selected");
                            $(event.target).parent(".entry").addClass("selected");
                            selected_query = query;
                            update_selected();
                        }));
                    }
                    const entry_container = modal.htmlTag.find(".query-list-entries-container");
                    if (entry_container.hasScrollBar())
                        entry_container.addClass("scrollbar");
                    if (!result || result.flag_all) {
                        info_tag.text("Showing all server queries");
                    }
                    else {
                        info_tag.text("Showing your server queries");
                    }
                    update_selected();
                });
            });
            //TODO error handling
        };
        modal = createModal({
            header: _translations.Uwzl8cWh || (_translations.Uwzl8cWh = tr("Manage query accounts")),
            body: () => {
                let template = $("#tmpl_query_manager").renderTag();
                template = $.spawn("div").append(template);
                /* first open the modal */
                setTimeout(() => {
                    const entry_container = template.find(".query-list-entries-container");
                    if (entry_container.hasScrollBar())
                        entry_container.addClass("scrollbar");
                }, 100);
                template.find(".footer .buttons .button-refresh").on('click', update_list);
                template.find(".button-query-create").on('click', () => {
                    Modals.spawnQueryCreate(client, (user, pass) => update_list());
                });
                template.find(".button-query-rename").on('click', () => {
                    if (!selected_query)
                        return;
                    createInputModal(_translations.dTGwS0kw || (_translations.dTGwS0kw = tr("Change account name")), _translations.AVkholEQ || (_translations.AVkholEQ = tr("Enter the new name for the login:<br>")), text => text.length >= 3, result => {
                        if (result) {
                            client.serverConnection.send_command("queryrename", {
                                client_login_name: selected_query.username,
                                client_new_login_name: result
                            }).catch(error => {
                                if (error instanceof CommandResult)
                                    error = error.extra_message || error.message;
                                createErrorModal(_translations.N_vW674v || (_translations.N_vW674v = tr("Unable to rename account")), (_translations.PvcMNDZZ || (_translations.PvcMNDZZ = tr("Failed to rename account<br>Message: "))) + error).open();
                            }).then(() => {
                                createInfoModal(_translations.I35DAhx7 || (_translations.I35DAhx7 = tr("Account successfully renamed")), _translations.qO82rDt5 || (_translations.qO82rDt5 = tr("The query account has been renamed!"))).open();
                                update_list();
                            });
                        }
                    }).open();
                });
                template.find(".button-query-change-password").on('click', () => {
                    if (!selected_query)
                        return;
                    createInputModal(_translations.pANw5774 || (_translations.pANw5774 = tr("Change account's password")), _translations.PEHMK9sU || (_translations.PEHMK9sU = tr("Enter a new password (leave blank for auto generation):<br>")), text => true, result => {
                        if (result !== false) {
                            const single_handler = {
                                command: "notifyquerypasswordchanges",
                                function: command => {
                                    Modals.spawnQueryCreated({
                                        username: command.arguments[0]["client_login_name"],
                                        password: command.arguments[0]["client_login_password"]
                                    }, false);
                                    return true;
                                }
                            };
                            client.serverConnection.command_handler_boss().register_single_handler(single_handler);
                            client.serverConnection.send_command("querychangepassword", {
                                client_login_name: selected_query.username,
                                client_login_password: result
                            }).catch(error => {
                                client.serverConnection.command_handler_boss().remove_single_handler(single_handler);
                                if (error instanceof CommandResult)
                                    error = error.extra_message || error.message;
                                createErrorModal(_translations.n33EjAur || (_translations.n33EjAur = tr("Unable to change password")), (_translations.L0FiM43s || (_translations.L0FiM43s = tr("Failed to change password<br>Message: "))) + error).open();
                            });
                        }
                    }).open();
                });
                template.find(".button-query-delete").on('click', () => {
                    if (!selected_query)
                        return;
                    Modals.spawnYesNo(_translations.gTLRFtIX || (_translations.gTLRFtIX = tr("Are you sure?")), _translations.A9NkElkq || (_translations.A9NkElkq = tr("Do you really want to delete this account?")), result => {
                        if (result) {
                            client.serverConnection.send_command("querydelete", {
                                client_login_name: selected_query.username
                            }).catch(error => {
                                if (error instanceof CommandResult)
                                    error = error.extra_message || error.message;
                                createErrorModal(_translations.vVxRMSeN || (_translations.vVxRMSeN = tr("Unable to delete account")), (_translations.EXsPUkEy || (_translations.EXsPUkEy = tr("Failed to delete account<br>Message: "))) + error).open();
                            }).then(() => {
                                createInfoModal(_translations.e9OJtgT7 || (_translations.e9OJtgT7 = tr("Account successfully deleted")), _translations.KE7XDn37 || (_translations.KE7XDn37 = tr("The query account has been successfully deleted!"))).open();
                                update_list();
                            });
                        }
                    });
                });
                template.find(".input-search").on('change keyup', () => {
                    const text = (template.find(".input-search").val() || "").toLowerCase();
                    if (text.length == 0) {
                        template.find(".query-list-entries .entry").show();
                    }
                    else {
                        template.find(".query-list-entries .entry").each((_, e) => {
                            const element = $(e);
                            if (element.text().toLowerCase().indexOf(text) == -1)
                                element.hide();
                            else
                                element.show();
                        });
                    }
                });
                return template;
            },
            footer: undefined,
            width: 750
        });
        update_list();
        modal.open();
    }
    Modals.spawnQueryManage = spawnQueryManage;
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["fb646e65b2a2e6999980f3bd63607a01afbbed5792f915bedf33a10c06582f43"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["fb646e65b2a2e6999980f3bd63607a01afbbed5792f915bedf33a10c06582f43"] = "fb646e65b2a2e6999980f3bd63607a01afbbed5792f915bedf33a10c06582f43";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "bLJUjtIu", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (187,39)" }, { name: "qZFh3nDJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (192,39)" }, { name: "Yy9wx6Wn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (197,39)" }, { name: "RpwodN2w", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (202,39)" }, { name: "GNHIri8c", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (365,51)" }, { name: "n3wDJdfZ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (372,51)" }, { name: "_jFEmNv2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (403,51)" }, { name: "ngf6ePIz", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (410,51)" }, { name: "vBWTCNhp", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (419,47)" }, { name: "Z0ahzRGJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (425,47)" }, { name: "E8tyFbxN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (432,47)" }, { name: "QSacWv3L", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (435,49)" }, { name: "yfCBI3go", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (436,49)" }, { name: "OCXNojUq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/HTMLPermissionEditor.ts (443,47)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/**
 * RIP old HTML based editor (too many nodes, made the browser laggy)
 */
var unused;
(function (unused) {
    let PermissionEditorMode;
    (function (PermissionEditorMode) {
        PermissionEditorMode[PermissionEditorMode["VISIBLE"] = 0] = "VISIBLE";
        PermissionEditorMode[PermissionEditorMode["NO_PERMISSION"] = 1] = "NO_PERMISSION";
        PermissionEditorMode[PermissionEditorMode["UNSET"] = 2] = "UNSET";
    })(PermissionEditorMode || (PermissionEditorMode = {}));
    class PermissionEditor {
        constructor(permissions) {
            /* references within the container tag */
            this.permission_value_map = {};
            this.listener_change = () => Promise.resolve();
            this.permissions = permissions;
        }
        build_tag() {
            this.permission_map = {};
            this.container = $("#tmpl_permission_editor").renderTag();
            /* search for that as long we've not that much nodes */
            this.mode_container_permissions = this.container.find(".container-mode-permissions");
            this.mode_container_error_permission = this.container.find(".container-mode-no-permissions");
            this.mode_container_unset = this.container.find(".container-mode-unset");
            this.set_mode(PermissionEditorMode.UNSET);
            /* the filter */
            {
                const tag_filter_input = this.container.find(".filter-input");
                const tag_filter_granted = this.container.find(".filter-granted");
                tag_filter_granted.on('change', event => tag_filter_input.trigger('change'));
                tag_filter_input.on('keyup change', event => {
                    let filter_mask = tag_filter_input.val();
                    let req_granted = tag_filter_granted.prop("checked");
                    /* we've to disable this function because its sometimes laggy */
                    const org_fn = $.fn.dropdown && $.fn.dropdown.Constructor ? $.fn.dropdown.Constructor._clearMenus : undefined;
                    if (org_fn)
                        $.fn.dropdown.Constructor._clearMenus = () => { };
                    /* update each permission */
                    {
                        const start = Date.now();
                        for (const permission_id of Object.keys(this.permission_map)) {
                            const permission = this.permission_map[permission_id];
                            let shown = filter_mask.length == 0 || permission.filter.indexOf(filter_mask) != -1;
                            if (shown && req_granted) {
                                const value = this.permission_value_map[permission_id];
                                shown = value && (value.hasValue() || value.hasGrant());
                            }
                            permission.tag.attr("match", shown ? 1 : 0);
                            /* this is faster then .hide() or .show() */
                            if (shown)
                                permission.tag.css('display', 'flex');
                            else
                                permission.tag.css('display', 'none');
                        }
                        const end = Date.now();
                        console.error("Filter update required %oms", end - start);
                    }
                    /* update group visibility (hide empty groups) */
                    {
                        const start = Date.now();
                        this.container.find(".group").each((idx, _entry) => {
                            let entry = $(_entry);
                            let target = entry.find(".entry:not(.group)[match=\"1\"]").length > 0;
                            /* this is faster then .hide() or .show() */
                            if (target)
                                entry.css('display', 'flex');
                            else
                                entry.css('display', 'none');
                        });
                        const end = Date.now();
                        console.error("Group update required %oms", end - start);
                    }
                    if (org_fn)
                        $.fn.dropdown.Constructor._clearMenus = org_fn;
                });
            }
            /* update button */
            {
                this.container.find(".button-update").on('click', this.trigger_update.bind(this));
            }
            /* global context menu listener */
            {
                this.container.on('contextmenu', event => {
                    if (event.isDefaultPrevented())
                        return;
                    event.preventDefault();
                    /* TODO allow collapse and expend all */
                });
            }
            /* actual permissions */
            {
                const tag_entries = this.container.find(".entries");
                const template_entry = $("#tmpl_permission_entry");
                const build_group = (group) => {
                    const tag_group = template_entry.renderTag({
                        type: "group",
                        name: group.group.name
                    });
                    const tag_group_entries = tag_group.find(".group-entries");
                    const update_collapse_status = (status, recursive) => {
                        const tag = recursive ? this.container.find(".entry.group") : tag_group;
                        /* this is faster then .hide() or .show() */
                        if (status) {
                            tag.find("> .group-entries").css('display', 'block');
                        }
                        else {
                            tag.find("> .group-entries").css('display', 'none');
                        }
                        tag.find("> .title .arrow").toggleClass("down", status).toggleClass("right", !status);
                    };
                    /* register collapse and context listener */
                    {
                        const tag_arrow = tag_group.find(".arrow");
                        tag_arrow.on('click', event => {
                            if (event.isDefaultPrevented())
                                return;
                            event.preventDefault();
                            update_collapse_status(tag_arrow.hasClass("right"), false);
                        });
                        const tag_title = tag_group.find(".title");
                        tag_title.on('contextmenu', event => {
                            if (event.isDefaultPrevented())
                                return;
                            event.preventDefault();
                            spawn_context_menu(event.pageX, event.pageY, {
                                type: MenuEntryType.ENTRY,
                                icon: "",
                                name: _translations.bLJUjtIu || (_translations.bLJUjtIu = tr("Expend group")),
                                callback: () => update_collapse_status(true, false)
                            }, {
                                type: MenuEntryType.ENTRY,
                                icon: "",
                                name: _translations.qZFh3nDJ || (_translations.qZFh3nDJ = tr("Expend all")),
                                callback: () => update_collapse_status(true, true)
                            }, {
                                type: MenuEntryType.ENTRY,
                                icon: "",
                                name: _translations.Yy9wx6Wn || (_translations.Yy9wx6Wn = tr("Collapse group")),
                                callback: () => update_collapse_status(false, false)
                            }, {
                                type: MenuEntryType.ENTRY,
                                icon: "",
                                name: _translations.RpwodN2w || (_translations.RpwodN2w = tr("Collapse all")),
                                callback: () => update_collapse_status(false, true)
                            });
                        });
                    }
                    /* build the permissions */
                    {
                        for (const permission of group.permissions) {
                            const tag_permission = template_entry.renderTag({
                                type: "permission",
                                permission_name: permission.name,
                                permission_id: permission.id,
                                permission_description: permission.description,
                            });
                            const tag_value = tag_permission.find(".column-value input");
                            const tag_granted = tag_permission.find(".column-granted input");
                            const tag_flag_skip = tag_permission.find(".column-skip input");
                            const tag_flag_negate = tag_permission.find(".column-negate input");
                            /* double click listener */
                            {
                                tag_permission.on('dblclick', event => {
                                    if (event.isDefaultPrevented())
                                        return;
                                    event.preventDefault();
                                    if (tag_permission.hasClass("value-unset")) {
                                        tag_flag_skip.prop("checked", false);
                                        tag_flag_negate.prop("checked", false);
                                        tag_permission.removeClass("value-unset");
                                        if (permission.name.startsWith("b_")) {
                                            tag_permission.find(".column-value input")
                                                .prop("checked", true)
                                                .trigger('change');
                                        }
                                        else {
                                            /* TODO auto value */
                                            tag_value.val('').focus();
                                        }
                                    }
                                    else if (!permission.name.startsWith("b_")) {
                                        tag_value.focus();
                                    }
                                });
                                tag_permission.find(".column-granted").on('dblclick', event => {
                                    if (event.isDefaultPrevented())
                                        return;
                                    event.preventDefault();
                                    if (tag_permission.hasClass("grant-unset")) {
                                        tag_permission.removeClass("grant-unset");
                                        tag_granted.focus();
                                    }
                                });
                            }
                            /* focus out listener */
                            {
                                tag_granted.on('focusout', event => {
                                    try {
                                        const value = tag_granted.val();
                                        if (isNaN(parseInt(value)))
                                            throw "";
                                    }
                                    catch (_) {
                                        tag_granted.val("");
                                        tag_permission.addClass("grant-unset");
                                        const element = this.permission_value_map[permission.id];
                                        if (element && element.hasGrant()) {
                                            this.listener_change(permission, {
                                                remove: true,
                                                granted: -2
                                            }).then(() => {
                                                element.granted_value = undefined;
                                            }).catch(() => {
                                                tag_granted.val(element.granted_value);
                                            });
                                        }
                                    }
                                });
                                tag_value.on('focusout', event => {
                                    try {
                                        if (isNaN(parseInt(tag_value.val())))
                                            throw "";
                                    }
                                    catch (_) {
                                        const element = this.permission_value_map[permission.id];
                                        if (element && element.hasValue()) {
                                            tag_value.val(element.value);
                                        }
                                        else {
                                            tag_value.val("");
                                            tag_permission.addClass("value-unset");
                                        }
                                    }
                                });
                            }
                            /* change listener */
                            {
                                tag_flag_negate.on('change', () => tag_value.trigger('change'));
                                tag_flag_skip.on('change', () => tag_value.trigger('change'));
                                tag_granted.on('change', event => {
                                    const value = parseInt(tag_granted.val());
                                    if (isNaN(value))
                                        return;
                                    this.listener_change(permission, {
                                        remove: false,
                                        granted: value,
                                    }).then(() => {
                                        const element = this.permission_value_map[permission.id] || (this.permission_value_map[permission.id] = new PermissionValue(permission));
                                        element.granted_value = value;
                                    }).catch(() => {
                                        const element = this.permission_value_map[permission.id];
                                        tag_granted.val(element && element.hasGrant() ? element.granted_value : "");
                                        tag_permission.toggleClass("grant-unset", !element || !element.hasGrant());
                                    });
                                });
                                tag_value.on('change', event => {
                                    const value = permission.is_boolean() ? tag_value.prop("checked") ? 1 : 0 : parseInt(tag_value.val());
                                    if (isNaN(value))
                                        return;
                                    const flag_negate = tag_flag_negate.prop("checked");
                                    const flag_skip = tag_flag_skip.prop("checked");
                                    this.listener_change(permission, {
                                        remove: false,
                                        value: value,
                                        flag_negate: flag_negate,
                                        flag_skip: flag_skip
                                    }).then(() => {
                                        const element = this.permission_value_map[permission.id] || (this.permission_value_map[permission.id] = new PermissionValue(permission));
                                        element.value = value;
                                        element.flag_skip = flag_skip;
                                        element.flag_negate = flag_negate;
                                    }).catch(error => {
                                        const element = this.permission_value_map[permission.id];
                                        /* reset or set the fields */
                                        if (permission.is_boolean())
                                            tag_value.prop('checked', element && element.hasValue() && element.value > 0);
                                        else
                                            tag_value.val(element && element.hasValue() ? element.value : "");
                                        tag_flag_negate.prop("checked", element && element.flag_negate);
                                        tag_flag_skip.prop("checked", element && element.flag_skip);
                                        tag_permission.toggleClass("value-unset", !element || !element.hasValue());
                                    });
                                });
                            }
                            /* context menu */
                            {
                                tag_permission.on('contextmenu', event => {
                                    if (event.isDefaultPrevented())
                                        return;
                                    event.preventDefault();
                                    let entries = [];
                                    if (tag_permission.hasClass("value-unset")) {
                                        entries.push({
                                            type: MenuEntryType.ENTRY,
                                            icon: "",
                                            name: _translations.GNHIri8c || (_translations.GNHIri8c = tr("Add permission")),
                                            callback: () => tag_permission.trigger('dblclick')
                                        });
                                    }
                                    else {
                                        entries.push({
                                            type: MenuEntryType.ENTRY,
                                            icon: "",
                                            name: _translations.n3wDJdfZ || (_translations.n3wDJdfZ = tr("Remove permission")),
                                            callback: () => {
                                                this.listener_change(permission, {
                                                    remove: true,
                                                    value: -2
                                                }).then(() => {
                                                    const element = this.permission_value_map[permission.id];
                                                    if (!element)
                                                        return; /* This should never happen, if so how are we displaying this permission?! */
                                                    element.value = undefined;
                                                    element.flag_negate = false;
                                                    element.flag_skip = false;
                                                    tag_permission.toggleClass("value-unset", true);
                                                }).catch(() => {
                                                    const element = this.permission_value_map[permission.id];
                                                    /* reset or set the fields */
                                                    tag_value.val(element && element.hasValue() ? element.value : "");
                                                    tag_flag_negate.prop("checked", element && element.flag_negate);
                                                    tag_flag_skip.prop("checked", element && element.flag_skip);
                                                    tag_permission.toggleClass("value-unset", !element || !element.hasValue());
                                                });
                                            }
                                        });
                                    }
                                    if (tag_permission.hasClass("grant-unset")) {
                                        entries.push({
                                            type: MenuEntryType.ENTRY,
                                            icon: "",
                                            name: _translations._jFEmNv2 || (_translations._jFEmNv2 = tr("Add grant permission")),
                                            callback: () => tag_permission.find(".column-granted").trigger('dblclick')
                                        });
                                    }
                                    else {
                                        entries.push({
                                            type: MenuEntryType.ENTRY,
                                            icon: "",
                                            name: _translations.ngf6ePIz || (_translations.ngf6ePIz = tr("Remove grant permission")),
                                            callback: () => tag_granted.val('').trigger('focusout') /* empty values are handled within focus out */
                                        });
                                    }
                                    entries.push(MenuEntry.HR());
                                    entries.push({
                                        type: MenuEntryType.ENTRY,
                                        icon: "",
                                        name: _translations.vBWTCNhp || (_translations.vBWTCNhp = tr("Expend all")),
                                        callback: () => update_collapse_status(true, true)
                                    });
                                    entries.push({
                                        type: MenuEntryType.ENTRY,
                                        icon: "",
                                        name: _translations.Z0ahzRGJ || (_translations.Z0ahzRGJ = tr("Collapse all")),
                                        callback: () => update_collapse_status(false, true)
                                    });
                                    entries.push(MenuEntry.HR());
                                    entries.push({
                                        type: MenuEntryType.ENTRY,
                                        icon: "",
                                        name: _translations.E8tyFbxN || (_translations.E8tyFbxN = tr("Show permission description")),
                                        callback: () => {
                                            createInfoModal(_translations.QSacWv3L || (_translations.QSacWv3L = tr("Permission description")), (_translations.yfCBI3go || (_translations.yfCBI3go = tr("Permission description for permission "))) + permission.name + ": <br>" + permission.description).open();
                                        }
                                    });
                                    entries.push({
                                        type: MenuEntryType.ENTRY,
                                        icon: "",
                                        name: _translations.OCXNojUq || (_translations.OCXNojUq = tr("Copy permission name")),
                                        callback: () => {
                                            copy_to_clipboard(permission.name);
                                        }
                                    });
                                    spawn_context_menu(event.pageX, event.pageY, ...entries);
                                });
                            }
                            this.permission_map[permission.id] = {
                                tag: tag_permission,
                                id: permission.id,
                                filter: permission.name,
                                tag_flag_negate: tag_flag_negate,
                                tag_flag_skip: tag_flag_skip,
                                tag_grant: tag_granted,
                                tag_value: tag_value,
                                is_bool: permission.is_boolean()
                            };
                            tag_group_entries.append(tag_permission);
                        }
                    }
                    /* append the subgroups */
                    for (const child of group.children) {
                        tag_group_entries.append(build_group(child));
                    }
                    return tag_group;
                };
                /* build the groups */
                for (const group of this.permissions)
                    tag_entries.append(build_group(group));
            }
        }
        set_permissions(permissions) {
            permissions = permissions || [];
            this.permission_value_map = {};
            for (const permission of permissions)
                this.permission_value_map[permission.type.id] = permission;
            for (const permission_id of Object.keys(this.permission_map)) {
                const permission = this.permission_map[permission_id];
                const value = this.permission_value_map[permission_id];
                permission.tag
                    .toggleClass("value-unset", !value || !value.hasValue())
                    .toggleClass("grant-unset", !value || !value.hasGrant());
                if (value && value.hasValue()) {
                    if (value.type.is_boolean())
                        permission.tag_value.prop("checked", value.value);
                    else
                        permission.tag_value.val(value.value);
                    permission.tag_flag_skip.prop("checked", value.flag_skip);
                    permission.tag_flag_negate.prop("checked", value.flag_negate);
                }
                if (value && value.hasGrant()) {
                    permission.tag_grant.val(value.granted_value);
                }
            }
        }
        set_listener(listener) {
            this.listener_change = listener || (() => Promise.resolve());
        }
        set_listener_update(listener) {
            this.listener_update = listener;
        }
        trigger_update() {
            if (this.listener_update)
                this.listener_update();
        }
        set_mode(mode) {
            this.mode_container_permissions.css('display', mode == PermissionEditorMode.VISIBLE ? 'flex' : 'none');
            this.mode_container_error_permission.css('display', mode == PermissionEditorMode.NO_PERMISSION ? 'flex' : 'none');
            this.mode_container_unset.css('display', mode == PermissionEditorMode.UNSET ? 'block' : 'none');
        }
    }
})(unused || (unused = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["cc5597f22d2fbbaa2e920b8f535c7f59ac35dbc918ea77752be453a18ae105b4"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["cc5597f22d2fbbaa2e920b8f535c7f59ac35dbc918ea77752be453a18ae105b4"] = "cc5597f22d2fbbaa2e920b8f535c7f59ac35dbc918ea77752be453a18ae105b4";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "FwvFgu_4", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (136,31)" }, { name: "v93qudUS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (141,31)" }, { name: "mMvMnVYl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (179,46)" }, { name: "f6lLnUbn", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (229,35)" }, { name: "L845WByI", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (236,35)" }, { name: "ZcybO0Lm", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (248,35)" }, { name: "RdqEYRnW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (255,35)" }, { name: "Lg2ZTfbq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (266,31)" }, { name: "TLRLoK0N", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (272,31)" }, { name: "bMXgKPky", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (279,31)" }, { name: "vkI3OluJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (282,33)" }, { name: "SqJ00S80", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (283,33)" }, { name: "cemo7jF6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (290,31)" }, { name: "CnUICelg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (322,42)" }, { name: "NTpecomE", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (371,24)" }, { name: "QqZM5pwJ", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (507,63)" }, { name: "b2iY7R6E", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (518,63)" }, { name: "uGrY55PR", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (533,63)" }, { name: "SUqKn_6l", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (550,63)" }, { name: "gsUlYUVk", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (663,63)" }, { name: "uDWnYLtW", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (673,63)" }, { name: "KlT1mEH_", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (687,63)" }, { name: "v2EatgRw", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (703,63)" }, { name: "pf3IpQRp", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (799,63)" }, { name: "HB5SIL7k", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (814,63)" }, { name: "M5HCqx7J", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (828,63)" }, { name: "MRBficeB", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (849,63)" }, { name: "N3nl8IFP", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (910,63)" }, { name: "glRsM3NF", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (924,63)" }, { name: "WEcHERrg", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (938,63)" }, { name: "Bb_P7APl", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (958,63)" }, { name: "SQC4bjgM", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1112,63)" }, { name: "ER5q0mh3", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1126,63)" }, { name: "MxvdebsN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1140,63)" }, { name: "MBTn6mvN", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1160,63)" }, { name: "zoR5dRrS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1225,39)" }, { name: "IdXRFISj", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1237,39)" }, { name: "n0lvjWf2", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/ModalPermissionEdit.ts (1247,34)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
/// <reference path="../../../ui/elements/modal.ts" />
/// <reference path="../../../ConnectionHandler.ts" />
/// <reference path="../../../proto.ts" />
var Modals;
(function (Modals) {
    let PermissionEditorMode;
    (function (PermissionEditorMode) {
        PermissionEditorMode[PermissionEditorMode["VISIBLE"] = 0] = "VISIBLE";
        PermissionEditorMode[PermissionEditorMode["NO_PERMISSION"] = 1] = "NO_PERMISSION";
        PermissionEditorMode[PermissionEditorMode["UNSET"] = 2] = "UNSET";
    })(PermissionEditorMode || (PermissionEditorMode = {}));
    class PermissionEditor {
        constructor(permissions) {
            /* references within the container tag */
            this.permission_value_map = {};
            this.listener_change = () => Promise.resolve();
            this.permissions = permissions;
            this.entry_editor = new ui.PermissionEditor(permissions);
        }
        build_tag() {
            this.container = $("#tmpl_permission_editor").renderTag();
            /* search for that as long we've not that much nodes */
            this.mode_container_permissions = this.container.find(".container-mode-permissions");
            this.mode_container_error_permission = this.container.find(".container-mode-no-permissions");
            this.mode_container_unset = this.container.find(".container-mode-unset");
            this.set_mode(PermissionEditorMode.UNSET);
            /* the filter */
            {
                const tag_filter_input = this.container.find(".filter-input");
                const tag_filter_granted = this.container.find(".filter-granted");
                tag_filter_granted.on('change', event => tag_filter_input.trigger('change'));
                tag_filter_input.on('keyup change', event => {
                    let filter_mask = tag_filter_input.val();
                    let req_granted = tag_filter_granted.prop("checked");
                    for (const entry of this.entry_editor.permission_entries()) {
                        const permission = entry.permission();
                        let shown = filter_mask.length == 0 || permission.name.indexOf(filter_mask) != -1;
                        if (shown && req_granted) {
                            const value = this.permission_value_map[permission.id];
                            shown = value && (value.hasValue() || value.hasGrant());
                        }
                        entry.hidden = !shown;
                    }
                    this.entry_editor.request_draw(true);
                });
            }
            /* update button */
            {
                this.container.find(".button-update").on('click', this.trigger_update.bind(this));
            }
            /* global context menu listener */
            {
                this.container.on('contextmenu', event => {
                    if (event.isDefaultPrevented())
                        return;
                    event.preventDefault();
                    /* TODO allow collapse and expend all */
                });
            }
            {
                const tag_container = this.container.find(".entry-editor-container");
                tag_container.append(this.entry_editor.canvas_container);
                tag_container.parent().on('contextmenu', event => {
                    if (event.isDefaultPrevented())
                        return;
                    event.preventDefault();
                    spawn_context_menu(event.pageX, event.pageY, {
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.FwvFgu_4 || (_translations.FwvFgu_4 = tr("Expend all")),
                        callback: () => this.entry_editor.expend_all()
                    }, {
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.v93qudUS || (_translations.v93qudUS = tr("Collapse all")),
                        callback: () => this.entry_editor.collapse_all()
                    });
                });
            }
            /* setup the permissions */
            for (const entry of this.entry_editor.permission_entries()) {
                const permission = entry.permission();
                entry.on_change = () => {
                    const flag_remove = typeof (entry.value) !== "number";
                    this.listener_change(permission, {
                        remove: flag_remove,
                        flag_negate: entry.flag_negate,
                        flag_skip: entry.flag_skip,
                        value: flag_remove ? -2 : entry.value
                    }).then(() => {
                        if (flag_remove) {
                            const element = this.permission_value_map[permission.id];
                            if (!element)
                                return; /* This should never happen, if so how are we displaying this permission?! */
                            element.value = undefined;
                            element.flag_negate = false;
                            element.flag_skip = false;
                        }
                        else {
                            const element = this.permission_value_map[permission.id] || (this.permission_value_map[permission.id] = new PermissionValue(permission));
                            element.value = entry.value;
                            element.flag_skip = entry.flag_skip;
                            element.flag_negate = entry.flag_negate;
                        }
                        if (permission.name === "i_icon_id") {
                            this.icon_resolver(entry.value).then(e => {
                                entry.set_icon_id_image(e);
                                entry.request_full_draw();
                                this.entry_editor.request_draw(false);
                            }).catch(error => {
                                console.warn(_translations.mMvMnVYl || (_translations.mMvMnVYl = tr("Failed to load icon for permission editor: %o")), error);
                            });
                        }
                        entry.request_full_draw();
                        this.entry_editor.request_draw(false);
                    }).catch(() => {
                        const element = this.permission_value_map[permission.id];
                        entry.value = element && element.hasValue() ? element.value : undefined;
                        entry.flag_skip = element && element.flag_skip;
                        entry.flag_negate = element && element.flag_negate;
                        entry.request_full_draw();
                        this.entry_editor.request_draw(false);
                    });
                };
                entry.on_grant_change = () => {
                    const flag_remove = typeof (entry.granted) !== "number";
                    this.listener_change(permission, {
                        remove: flag_remove,
                        granted: flag_remove ? -2 : entry.granted,
                    }).then(() => {
                        if (flag_remove) {
                            const element = this.permission_value_map[permission.id];
                            if (!element)
                                return; /* This should never happen, if so how are we displaying this permission?! */
                            element.granted_value = undefined;
                        }
                        else {
                            const element = this.permission_value_map[permission.id] || (this.permission_value_map[permission.id] = new PermissionValue(permission));
                            element.granted_value = entry.granted;
                        }
                        entry.request_full_draw();
                        this.entry_editor.request_draw(false);
                    }).catch(() => {
                        const element = this.permission_value_map[permission.id];
                        entry.granted = element && element.hasGrant() ? element.granted_value : undefined;
                        entry.request_full_draw();
                        this.entry_editor.request_draw(false);
                    });
                };
                entry.on_context_menu = (x, y) => {
                    let entries = [];
                    if (typeof (entry.value) === "undefined") {
                        entries.push({
                            type: MenuEntryType.ENTRY,
                            icon: "",
                            name: _translations.f6lLnUbn || (_translations.f6lLnUbn = tr("Add permission")),
                            callback: () => entry.trigger_value_assign()
                        });
                    }
                    else {
                        entries.push({
                            type: MenuEntryType.ENTRY,
                            icon: "",
                            name: _translations.L845WByI || (_translations.L845WByI = tr("Remove permission")),
                            callback: () => {
                                entry.value = undefined;
                                entry.on_change();
                            }
                        });
                    }
                    if (typeof (entry.granted) === "undefined") {
                        entries.push({
                            type: MenuEntryType.ENTRY,
                            icon: "",
                            name: _translations.ZcybO0Lm || (_translations.ZcybO0Lm = tr("Add grant permission")),
                            callback: () => entry.trigger_grant_assign()
                        });
                    }
                    else {
                        entries.push({
                            type: MenuEntryType.ENTRY,
                            icon: "",
                            name: _translations.RdqEYRnW || (_translations.RdqEYRnW = tr("Remove grant permission")),
                            callback: () => {
                                entry.granted = undefined;
                                entry.on_grant_change();
                            }
                        });
                    }
                    entries.push(MenuEntry.HR());
                    entries.push({
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.Lg2ZTfbq || (_translations.Lg2ZTfbq = tr("Expend all")),
                        callback: () => this.entry_editor.expend_all()
                    });
                    entries.push({
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.TLRLoK0N || (_translations.TLRLoK0N = tr("Collapse all")),
                        callback: () => this.entry_editor.collapse_all()
                    });
                    entries.push(MenuEntry.HR());
                    entries.push({
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.bMXgKPky || (_translations.bMXgKPky = tr("Show permission description")),
                        callback: () => {
                            createInfoModal(_translations.vkI3OluJ || (_translations.vkI3OluJ = tr("Permission description")), (_translations.SqJ00S80 || (_translations.SqJ00S80 = tr("Permission description for permission "))) + permission.name + ": <br>" + permission.description).open();
                        }
                    });
                    entries.push({
                        type: MenuEntryType.ENTRY,
                        icon: "",
                        name: _translations.cemo7jF6 || (_translations.cemo7jF6 = tr("Copy permission name")),
                        callback: () => {
                            copy_to_clipboard(permission.name);
                        }
                    });
                    spawn_context_menu(x, y, ...entries);
                };
            }
        }
        set_permissions(permissions) {
            permissions = permissions || [];
            this.permission_value_map = {};
            for (const permission of permissions)
                this.permission_value_map[permission.type.id] = permission;
            for (const entry of this.entry_editor.permission_entries()) {
                const permission = entry.permission();
                const value = this.permission_value_map[permission.id];
                if (value && value.hasValue()) {
                    entry.value = value.value;
                    entry.flag_skip = value.flag_skip;
                    entry.flag_negate = value.flag_negate;
                    if (permission.name === "i_icon_id") {
                        this.icon_resolver(value.value).then(e => {
                            entry.set_icon_id_image(e);
                            entry.request_full_draw();
                            this.entry_editor.request_draw(false);
                        }).catch(error => {
                            console.warn(_translations.CnUICelg || (_translations.CnUICelg = tr("Failed to load icon for permission editor: %o")), error);
                        });
                        entry.on_icon_select = this.icon_selector;
                    }
                }
                else {
                    entry.value = undefined;
                    entry.flag_skip = false;
                    entry.flag_negate = false;
                    entry.set_icon_id_image(undefined);
                }
                if (value && value.hasGrant()) {
                    entry.granted = value.granted_value;
                }
                else {
                    entry.granted = undefined;
                }
            }
            this.entry_editor.request_draw(true);
        }
        set_listener(listener) {
            this.listener_change = listener || (() => Promise.resolve());
        }
        set_listener_update(listener) {
            this.listener_update = listener;
        }
        trigger_update() {
            if (this.listener_update)
                this.listener_update();
        }
        set_mode(mode) {
            this.mode_container_permissions.css('display', mode == PermissionEditorMode.VISIBLE ? 'flex' : 'none');
            this.mode_container_error_permission.css('display', mode == PermissionEditorMode.NO_PERMISSION ? 'flex' : 'none');
            this.mode_container_unset.css('display', mode == PermissionEditorMode.UNSET ? 'block' : 'none');
            if (mode == PermissionEditorMode.VISIBLE)
                this.entry_editor.draw(true);
        }
        update_ui() {
            this.entry_editor.draw(true);
        }
    }
    function spawnPermissionEdit(connection) {
        const modal = createModal({
            header: function () {
                return _translations.NTpecomE || (_translations.NTpecomE = tr("Server Permissions"));
            },
            body: function () {
                let properties = {};
                let tag = $("#tmpl_server_permissions").renderTag(properties);
                const pe = new PermissionEditor(connection.permissions.groupedPermissions());
                pe.build_tag();
                pe.icon_resolver = id => connection.fileManager.icons.resolve_icon(id).then((icon) => __awaiter(this, void 0, void 0, function* () {
                    if (!icon)
                        return undefined;
                    const tag = document.createElement("img");
                    yield new Promise((resolve, reject) => {
                        tag.onerror = reject;
                        tag.onload = resolve;
                        tag.src = icon.url;
                    });
                    return tag;
                }));
                pe.icon_selector = current_icon => new Promise(resolve => {
                    Modals.spawnIconSelect(connection, id => resolve(new Int32Array([id])[0]), current_icon);
                });
                /* initialisation */
                {
                    const pe_server = tag.find("permission-editor.group-server");
                    pe_server.append(pe.container); /* fuck off workaround to initialize form listener */
                }
                setTimeout(() => {
                    pe.update_ui();
                }, 500);
                apply_server_groups(connection, pe, tag.find(".tab-group-server"));
                apply_channel_groups(connection, pe, tag.find(".tab-group-channel"));
                apply_channel_permission(connection, pe, tag.find(".tab-channel"));
                apply_client_permission(connection, pe, tag.find(".tab-client"));
                apply_client_channel_permission(connection, pe, tag.find(".tab-client-channel"));
                return tag.tabify(false);
            },
            footer: undefined,
            width: "90%",
            height: "80%",
            trigger_tab: false,
            full_size: true
        });
        const tag = modal.htmlTag;
        tag.find(".btn_close").on('click', () => {
            modal.close();
        });
        return modal;
    }
    Modals.spawnPermissionEdit = spawnPermissionEdit;
    function build_channel_tree(connection, channel_list, select_callback) {
        const root = connection.channelTree.get_first_channel();
        if (!root)
            return;
        const build_channel = (channel) => {
            let tag = $.spawn("div").addClass("channel").attr("channel-id", channel.channelId);
            let icon_tag = connection.fileManager.icons.generateTag(channel.properties.channel_icon_id);
            icon_tag.appendTo(tag);
            const _update_icon = icon_id => icon_tag.replaceWith(icon_tag = connection.fileManager.icons.generateTag(icon_id));
            {
                let name = $.spawn("a").text(channel.channelName() + " (" + channel.channelId + ")").addClass("name");
                //if(connection.channelTree.server.properties. == group.id)
                //    name.addClass("default");
                name.appendTo(tag);
            }
            tag.on('click', event => {
                channel_list.find(".selected").removeClass("selected");
                tag.addClass("selected");
                select_callback(channel, _update_icon);
            });
            return tag;
        };
        const build_channels = (root) => {
            build_channel(root).appendTo(channel_list);
            for (const child of root.children())
                build_channels(child);
            while (root.channel_next) {
                root = root.channel_next;
                build_channel(root).appendTo(channel_list);
            }
        };
        build_channels(root);
        setTimeout(() => channel_list.find('.channel').first().trigger('click'), 0);
    }
    function apply_client_channel_permission(connection, editor, tab_tag) {
        let current_cldbid = 0;
        let current_channel;
        /* the editor */
        {
            const pe_client = tab_tag.find("permission-editor.client-channel");
            tab_tag.on('show', event => {
                console.error("Channel tab show");
                pe_client.append(editor.container);
                if (connection.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_CLIENT_PERMISSION_LIST).granted(1)) {
                    if (current_cldbid && current_channel)
                        editor.set_mode(PermissionEditorMode.VISIBLE);
                    else
                        editor.set_mode(PermissionEditorMode.UNSET);
                }
                else {
                    editor.set_mode(PermissionEditorMode.NO_PERMISSION);
                    return;
                }
                editor.set_listener_update(() => {
                    if (!current_cldbid || !current_channel)
                        return;
                    connection.permissions.requestClientChannelPermissions(current_cldbid, current_channel.channelId).then(result => {
                        editor.set_permissions(result);
                        editor.set_mode(PermissionEditorMode.VISIBLE);
                    }).catch(error => {
                        console.log(error); //TODO handling?
                    });
                });
                editor.set_listener((permission, value) => {
                    if (!current_cldbid)
                        return Promise.reject("unset client");
                    if (!current_channel)
                        return Promise.reject("unset channel");
                    if (value.remove) {
                        /* remove the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.QqZM5pwJ || (_translations.QqZM5pwJ = tr("Removing client channel permission %s. permission.id: %o")), permission.name, permission.id);
                            return connection.serverConnection.send_command("channelclientdelperm", {
                                cldbid: current_cldbid,
                                cid: current_channel.channelId,
                                permid: permission.id,
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.b2iY7R6E || (_translations.b2iY7R6E = tr("Removing client channel grant permission %s. permission.id: %o")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channelclientdelperm", {
                                cldbid: current_cldbid,
                                cid: current_channel.channelId,
                                permid: permission.id_grant(),
                            });
                        }
                    }
                    else {
                        /* add the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.uGrY55PR || (_translations.uGrY55PR = tr("Adding or updating client channel permission %s. permission.{id: %o, value: %o, flag_skip: %o, flag_negate: %o}")), permission.name, permission.id, value.value, value.flag_skip, value.flag_negate);
                            return connection.serverConnection.send_command("channelclientaddperm", {
                                cldbid: current_cldbid,
                                cid: current_channel.channelId,
                                permid: permission.id,
                                permvalue: value.value,
                                permskip: value.flag_skip,
                                permnegate: value.flag_negate
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.SUqKn_6l || (_translations.SUqKn_6l = tr("Adding or updating client channel grant permission %s. permission.{id: %o, value: %o}")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channelclientaddperm", {
                                cldbid: current_cldbid,
                                cid: current_channel.channelId,
                                permid: permission.id_grant(),
                                permvalue: value.granted,
                                permskip: false,
                                permnegate: false
                            });
                        }
                    }
                });
                /* FIXME: Use cached permissions */
                editor.trigger_update();
            });
        }
        build_channel_tree(connection, tab_tag.find(".list-channel .entries"), channel => {
            if (current_channel == channel)
                return;
            current_channel = channel;
            /* TODO: Test for visibility */
            editor.trigger_update();
        });
        {
            const tag_select_uid = tab_tag.find(".client-select input");
            const tag_select_error = tab_tag.find(".client-select .invalid-feedback");
            const tag_client_name = tab_tag.find(".client-name");
            const tag_client_uid = tab_tag.find(".client-uid");
            const tag_client_dbid = tab_tag.find(".client-dbid");
            const resolve_client = () => {
                let client_uid = tag_select_uid.val();
                connection.serverConnection.command_helper.info_from_uid(client_uid).then(result => {
                    if (!result || result.length == 0)
                        return Promise.reject("invalid data");
                    tag_select_uid.attr('pattern', null).removeClass('is-invalid');
                    tag_client_name.val(result[0].client_nickname);
                    tag_client_uid.val(result[0].client_unique_id);
                    tag_client_dbid.val(result[0].client_database_id);
                    current_cldbid = result[0].client_database_id;
                    editor.trigger_update();
                }).catch(error => {
                    console.log(error);
                    if (error instanceof CommandResult) {
                        if (error.id == ErrorID.EMPTY_RESULT)
                            error = "unknown client";
                        else
                            error = error.extra_message || error.message;
                    }
                    tag_client_name.val("");
                    tag_client_uid.val("");
                    tag_client_dbid.val("");
                    tag_select_error.text(error);
                    tag_select_uid.attr('pattern', '^[a]{1000}$').addClass('is-invalid');
                    editor.set_mode(PermissionEditorMode.UNSET);
                });
            };
            tab_tag.find(".client-select-uid").on('change', event => resolve_client());
        }
    }
    function apply_client_permission(connection, editor, tab_tag) {
        let current_cldbid = 0;
        /* the editor */
        {
            const pe_client = tab_tag.find("permission-editor.client");
            tab_tag.on('show', event => {
                console.error("Channel tab show");
                pe_client.append(editor.container);
                if (connection.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_CLIENT_PERMISSION_LIST).granted(1)) {
                    if (current_cldbid)
                        editor.set_mode(PermissionEditorMode.VISIBLE);
                    else
                        editor.set_mode(PermissionEditorMode.UNSET);
                }
                else {
                    editor.set_mode(PermissionEditorMode.NO_PERMISSION);
                    return;
                }
                editor.set_listener_update(() => {
                    if (!current_cldbid)
                        return;
                    connection.permissions.requestClientPermissions(current_cldbid).then(result => {
                        editor.set_permissions(result);
                        editor.set_mode(PermissionEditorMode.VISIBLE);
                    }).catch(error => {
                        console.log(error); //TODO handling?
                    });
                });
                editor.set_listener((permission, value) => {
                    if (!current_cldbid)
                        return Promise.reject("unset client");
                    if (value.remove) {
                        /* remove the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.gsUlYUVk || (_translations.gsUlYUVk = tr("Removing client permission %s. permission.id: %o")), permission.name, permission.id);
                            return connection.serverConnection.send_command("clientaddperm", {
                                cldbid: current_cldbid,
                                permid: permission.id,
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.uDWnYLtW || (_translations.uDWnYLtW = tr("Removing client grant permission %s. permission.id: %o")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("clientaddperm", {
                                cldbid: current_cldbid,
                                permid: permission.id_grant(),
                            });
                        }
                    }
                    else {
                        /* add the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.KlT1mEH_ || (_translations.KlT1mEH_ = tr("Adding or updating client permission %s. permission.{id: %o, value: %o, flag_skip: %o, flag_negate: %o}")), permission.name, permission.id, value.value, value.flag_skip, value.flag_negate);
                            return connection.serverConnection.send_command("clientaddperm", {
                                cldbid: current_cldbid,
                                permid: permission.id,
                                permvalue: value.value,
                                permskip: value.flag_skip,
                                permnegate: value.flag_negate
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.v2EatgRw || (_translations.v2EatgRw = tr("Adding or updating client grant permission %s. permission.{id: %o, value: %o}")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("clientaddperm", {
                                cldbid: current_cldbid,
                                permid: permission.id_grant(),
                                permvalue: value.granted,
                                permskip: false,
                                permnegate: false
                            });
                        }
                    }
                });
                /* FIXME: Use cached permissions */
                editor.trigger_update();
            });
        }
        const tag_select_uid = tab_tag.find(".client-select input");
        const tag_select_error = tab_tag.find(".client-select .invalid-feedback");
        const tag_client_name = tab_tag.find(".client-name");
        const tag_client_uid = tab_tag.find(".client-uid");
        const tag_client_dbid = tab_tag.find(".client-dbid");
        const resolve_client = () => {
            let client_uid = tag_select_uid.val();
            connection.serverConnection.command_helper.info_from_uid(client_uid).then(result => {
                if (!result || result.length == 0)
                    return Promise.reject("invalid data");
                tag_select_uid.attr('pattern', null).removeClass('is-invalid');
                tag_client_name.val(result[0].client_nickname);
                tag_client_uid.val(result[0].client_unique_id);
                tag_client_dbid.val(result[0].client_database_id);
                current_cldbid = result[0].client_database_id;
                editor.trigger_update();
            }).catch(error => {
                console.log(error);
                if (error instanceof CommandResult) {
                    if (error.id == ErrorID.EMPTY_RESULT)
                        error = "unknown client";
                    else
                        error = error.extra_message || error.message;
                }
                tag_client_name.val("");
                tag_client_uid.val("");
                tag_client_dbid.val("");
                tag_select_error.text(error);
                tag_select_uid.attr('pattern', '^[a]{1000}$').addClass('is-invalid');
                editor.set_mode(PermissionEditorMode.UNSET);
            });
        };
        tab_tag.find(".client-select-uid").on('change', event => resolve_client());
    }
    function apply_channel_permission(connection, editor, tab_tag) {
        let current_channel;
        let update_channel_icon;
        /* the editor */
        {
            const pe_channel = tab_tag.find("permission-editor.channel");
            tab_tag.on('show', event => {
                console.error("Channel tab show");
                pe_channel.append(editor.container);
                if (connection.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_CHANNEL_PERMISSION_LIST).granted(1))
                    editor.set_mode(PermissionEditorMode.VISIBLE);
                else {
                    editor.set_mode(PermissionEditorMode.NO_PERMISSION);
                    return;
                }
                editor.set_listener_update(() => {
                    if (!current_channel)
                        return;
                    connection.permissions.requestChannelPermissions(current_channel.channelId).then(result => editor.set_permissions(result)).catch(error => {
                        console.log(error); //TODO handling?
                    });
                });
                editor.set_listener((permission, value) => {
                    if (!current_channel)
                        return Promise.reject("unset channel");
                    if (value.remove) {
                        /* remove the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.pf3IpQRp || (_translations.pf3IpQRp = tr("Removing channel permission %s. permission.id: %o")), permission.name, permission.id);
                            return connection.serverConnection.send_command("channeldelperm", {
                                cid: current_channel.channelId,
                                permid: permission.id,
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_channel_icon)
                                    update_channel_icon(undefined);
                                return e;
                            });
                        }
                        else {
                            /* TODO Remove this because its totally useless. Remove this from the UI as well */
                            log.info(LogCategory.PERMISSIONS, _translations.HB5SIL7k || (_translations.HB5SIL7k = tr("Removing channel grant permission %s. permission.id: %o")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channeldelperm", {
                                cid: current_channel.channelId,
                                permid: permission.id_grant(),
                            });
                        }
                    }
                    else {
                        /* add the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.M5HCqx7J || (_translations.M5HCqx7J = tr("Adding or updating channel permission %s. permission.{id: %o, value: %o, flag_skip: %o, flag_negate: %o}")), permission.name, permission.id, value.value, value.flag_skip, value.flag_negate);
                            return connection.serverConnection.send_command("channeladdperm", {
                                cid: current_channel.channelId,
                                permid: permission.id,
                                permvalue: value.value,
                                permskip: value.flag_skip,
                                permnegate: value.flag_negate
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_channel_icon)
                                    update_channel_icon(value.value);
                                return e;
                            });
                        }
                        else {
                            /* TODO Remove this because its totally useless. Remove this from the UI as well */
                            log.info(LogCategory.PERMISSIONS, _translations.MRBficeB || (_translations.MRBficeB = tr("Adding or updating channel grant permission %s. permission.{id: %o, value: %o}")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channeladdperm", {
                                cid: current_channel.channelId,
                                permid: permission.id_grant(),
                                permvalue: value.granted,
                                permskip: false,
                                permnegate: false
                            });
                        }
                    }
                });
                /* FIXME: Use cached permissions */
                editor.trigger_update();
            });
        }
        let channel_list = tab_tag.find(".list-channel .entries");
        build_channel_tree(connection, channel_list, (channel, update) => {
            current_channel = channel;
            update_channel_icon = update;
            editor.trigger_update();
        });
    }
    function apply_channel_groups(connection, editor, tab_tag) {
        let current_group;
        let update_group_icon;
        /* the editor */
        {
            const pe_server = tab_tag.find("permission-editor.group-channel");
            tab_tag.on('show', event => {
                console.error("Channel group tab show");
                pe_server.append(editor.container);
                if (connection.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_CHANNELGROUP_PERMISSION_LIST).granted(1))
                    editor.set_mode(PermissionEditorMode.VISIBLE);
                else {
                    editor.set_mode(PermissionEditorMode.NO_PERMISSION);
                    return;
                }
                editor.set_listener_update(() => {
                    if (!current_group)
                        return;
                    connection.groups.request_permissions(current_group).then(result => editor.set_permissions(result)).catch(error => {
                        console.log(error); //TODO handling?
                    });
                });
                editor.set_listener((permission, value) => {
                    if (!current_group)
                        return Promise.reject("unset channel group");
                    if (value.remove) {
                        /* remove the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.N3nl8IFP || (_translations.N3nl8IFP = tr("Removing channel group permission %s. permission.id: %o")), permission.name, permission.id);
                            return connection.serverConnection.send_command("channelgroupdelperm", {
                                cgid: current_group.id,
                                permid: permission.id,
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_group_icon)
                                    update_group_icon(undefined);
                                return e;
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.glRsM3NF || (_translations.glRsM3NF = tr("Removing channel group grant permission %s. permission.id: %o")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channelgroupdelperm", {
                                cgid: current_group.id,
                                permid: permission.id_grant(),
                            });
                        }
                    }
                    else {
                        /* add the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.WEcHERrg || (_translations.WEcHERrg = tr("Adding or updating channel group permission %s. permission.{id: %o, value: %o, flag_skip: %o, flag_negate: %o}")), permission.name, permission.id, value.value, value.flag_skip, value.flag_negate);
                            return connection.serverConnection.send_command("channelgroupaddperm", {
                                cgid: current_group.id,
                                permid: permission.id,
                                permvalue: value.value,
                                permskip: value.flag_skip,
                                permnegate: value.flag_negate
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_group_icon)
                                    update_group_icon(value.value);
                                return e;
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.Bb_P7APl || (_translations.Bb_P7APl = tr("Adding or updating channel group grant permission %s. permission.{id: %o, value: %o}")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("channelgroupaddperm", {
                                cgid: current_group.id,
                                permid: permission.id_grant(),
                                permvalue: value.granted,
                                permskip: false,
                                permnegate: false
                            });
                        }
                    }
                });
                /* FIXME: Use cached permissions */
                editor.trigger_update();
            });
        }
        /* list all channel groups */
        {
            let group_list = tab_tag.find(".list-group-channel .entries");
            const allow_query_groups = connection.permissions.neededPermission(PermissionType.B_SERVERINSTANCE_MODIFY_QUERYGROUP).granted(1);
            const allow_template_groups = connection.permissions.neededPermission(PermissionType.B_SERVERINSTANCE_MODIFY_TEMPLATES).granted(1);
            for (let group of connection.groups.channelGroups.sort(GroupManager.sorter())) {
                if (group.type == GroupType.QUERY) {
                    if (!allow_query_groups)
                        continue;
                }
                else if (group.type == GroupType.TEMPLATE) {
                    if (!allow_template_groups)
                        continue;
                }
                let tag = $.spawn("div").addClass("group").attr("group-id", group.id);
                let icon_tag = connection.fileManager.icons.generateTag(group.properties.iconid);
                icon_tag.appendTo(tag);
                const _update_icon = icon_id => icon_tag.replaceWith(icon_tag = connection.fileManager.icons.generateTag(icon_id));
                {
                    let name = $.spawn("a").text(group.name + " (" + group.id + ")").addClass("name");
                    if (group.properties.savedb)
                        name.addClass("savedb");
                    if (connection.channelTree.server.properties.virtualserver_default_channel_group == group.id)
                        name.addClass("default");
                    name.appendTo(tag);
                }
                tag.appendTo(group_list);
                tag.on('click', event => {
                    current_group = group;
                    update_group_icon = _update_icon;
                    group_list.find(".selected").removeClass("selected");
                    tag.addClass("selected");
                    //TODO trigger only if the editor is in channel group mode!
                    editor.trigger_update();
                });
            }
            /* because the server menu is the first which will be shown */
            setTimeout(() => group_list.find('.group').first().trigger('click'), 0);
        }
    }
    /*
        b_virtualserver_servergroup_permission_list
        b_virtualserver_channel_permission_list
        b_virtualserver_client_permission_list
        b_virtualserver_channelgroup_permission_list
        b_virtualserver_channelclient_permission_list
        b_virtualserver_playlist_permission_list
     */
    function apply_server_groups(connection, editor, tab_tag) {
        let current_group;
        let current_group_changed;
        /* list all groups */
        let update_icon;
        {
            let group_list = tab_tag.find(".list-group-server .entries");
            const allow_query_groups = connection.permissions.neededPermission(PermissionType.B_SERVERINSTANCE_MODIFY_QUERYGROUP).granted(1);
            const allow_template_groups = connection.permissions.neededPermission(PermissionType.B_SERVERINSTANCE_MODIFY_TEMPLATES).granted(1);
            for (const group of connection.groups.serverGroups.sort(GroupManager.sorter())) {
                if (group.type == GroupType.QUERY) {
                    if (!allow_query_groups)
                        continue;
                }
                else if (group.type == GroupType.TEMPLATE) {
                    if (!allow_template_groups)
                        continue;
                }
                let tag = $.spawn("div").addClass("group").attr("group-id", group.id);
                let icon_tag = connection.fileManager.icons.generateTag(group.properties.iconid);
                icon_tag.appendTo(tag);
                const _update_icon = icon_id => icon_tag.replaceWith(icon_tag = connection.fileManager.icons.generateTag(icon_id));
                {
                    let name = $.spawn("a").text(group.name + " (" + group.id + ")").addClass("name");
                    if (group.properties.savedb)
                        name.addClass("savedb");
                    if (connection.channelTree.server.properties.virtualserver_default_server_group == group.id)
                        name.addClass("default");
                    name.appendTo(tag);
                }
                tag.appendTo(group_list);
                tag.on('click', event => {
                    if (current_group === group)
                        return;
                    current_group = group;
                    update_icon = _update_icon;
                    current_group_changed();
                    group_list.find(".selected").removeClass("selected");
                    tag.addClass("selected");
                    editor.trigger_update();
                });
            }
            /* because the server menu is the first which will be shown */
            setTimeout(() => group_list.find('.group').first().trigger('click'), 0);
        }
        /* the editor */
        {
            const pe_server = tab_tag.find("permission-editor.group-server");
            tab_tag.on('show', event => {
                console.error("Server tab show");
                pe_server.append(editor.container);
                if (connection.permissions.neededPermission(PermissionType.B_VIRTUALSERVER_SERVERGROUP_PERMISSION_LIST).granted(1))
                    editor.set_mode(PermissionEditorMode.VISIBLE);
                else {
                    editor.set_mode(PermissionEditorMode.NO_PERMISSION);
                    return;
                }
                editor.set_listener_update(() => {
                    connection.groups.request_permissions(current_group).then(result => editor.set_permissions(result)).catch(error => {
                        console.log(error); //TODO handling?
                    });
                });
                editor.set_listener((permission, value) => {
                    if (!current_group)
                        return Promise.reject("unset server group");
                    if (value.remove) {
                        /* remove the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.SQC4bjgM || (_translations.SQC4bjgM = tr("Removing server group permission %s. permission.id: %o")), permission.name, permission.id);
                            return connection.serverConnection.send_command("servergroupdelperm", {
                                sgid: current_group.id,
                                permid: permission.id,
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_icon)
                                    update_icon(0);
                                return e;
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.ER5q0mh3 || (_translations.ER5q0mh3 = tr("Removing server group grant permission %s. permission.id: %o")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("servergroupdelperm", {
                                sgid: current_group.id,
                                permid: permission.id_grant(),
                            });
                        }
                    }
                    else {
                        /* add the permission */
                        if (typeof (value.value) !== "undefined") {
                            log.info(LogCategory.PERMISSIONS, _translations.MxvdebsN || (_translations.MxvdebsN = tr("Adding or updating server group permission %s. permission.{id: %o, value: %o, flag_skip: %o, flag_negate: %o}")), permission.name, permission.id, value.value, value.flag_skip, value.flag_negate);
                            return connection.serverConnection.send_command("servergroupaddperm", {
                                sgid: current_group.id,
                                permid: permission.id,
                                permvalue: value.value,
                                permskip: value.flag_skip,
                                permnegate: value.flag_negate
                            }).then(e => {
                                if (permission.name === "i_icon_id" && update_icon)
                                    update_icon(value.value);
                                return e;
                            });
                        }
                        else {
                            log.info(LogCategory.PERMISSIONS, _translations.MBTn6mvN || (_translations.MBTn6mvN = tr("Adding or updating server group grant permission %s. permission.{id: %o, value: %o}")), permission.name, permission.id_grant(), value.granted);
                            return connection.serverConnection.send_command("servergroupaddperm", {
                                sgid: current_group.id,
                                permid: permission.id_grant(),
                                permvalue: value.granted,
                                permskip: false,
                                permnegate: false
                            });
                        }
                    }
                });
                editor.trigger_update();
            });
        }
        /* client list */
        {
            //filter-client-list
            const container_clients = tab_tag.find(".container-clients");
            const container_client_list = container_clients.find(".list-clients");
            const input_filter = container_clients.find(".filter-client-list");
            const update_filter = () => {
                const filter_text = (input_filter.val() || "").toString().toLowerCase();
                if (!filter_text) {
                    container_client_list.find(".entry").css('display', 'block');
                }
                else {
                    const entries = container_client_list.find(".entry");
                    for (const _entry of entries) {
                        const entry = $(_entry);
                        if (entry.attr("search-string").toLowerCase().indexOf(filter_text) !== -1)
                            entry.css('display', 'block');
                        else
                            entry.css('display', 'none');
                    }
                }
            };
            const update_client_list = () => {
                container_client_list.empty();
                connection.serverConnection.command_helper.request_clients_by_server_group(current_group.id).then(clients => {
                    for (const client of clients) {
                        const tag = $.spawn("div").addClass("entry").text(client.client_nickname);
                        tag.attr("search-string", client.client_nickname + "-" + client.client_unique_identifier + "-" + client.client_database_id);
                        container_client_list.append(tag);
                        tag.on('click contextmenu', event => {
                            container_client_list.find(".selected").removeClass("selected");
                            tag.addClass("selected");
                        });
                        tag.on('contextmenu', event => {
                            if (event.isDefaultPrevented())
                                return;
                            event.preventDefault();
                            spawn_context_menu(event.pageX, event.pageY, {
                                type: MenuEntryType.ENTRY,
                                name: _translations.zoR5dRrS || (_translations.zoR5dRrS = tr("Remove client")),
                                icon: 'client-delete',
                                callback: () => {
                                    connection.serverConnection.send_command("servergroupdelclient", {
                                        sgid: current_group.id,
                                        cldbid: client.client_database_id
                                    }).then(() => {
                                        tag.detach();
                                    });
                                }
                            }, {
                                type: MenuEntryType.ENTRY,
                                name: _translations.IdXRFISj || (_translations.IdXRFISj = tr("Copy unique id")),
                                icon: 'client-copy',
                                callback: () => copy_to_clipboard(client.client_unique_identifier)
                            });
                        });
                    }
                    update_filter();
                }).catch(error => {
                    if (error instanceof CommandResult && error.id === ErrorID.PERMISSION_ERROR)
                        return;
                    console.warn(_translations.n0lvjWf2 || (_translations.n0lvjWf2 = tr("Failed to receive server group clients for group %d: %o")), current_group.id, error);
                });
            };
            input_filter.on('change keyup', event => update_filter());
            current_group_changed = update_client_list;
        }
    }
})(Modals || (Modals = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e1b03bb9c4d0fad90c30641dc1c22bab730849a7382da032eb2865eeaa19f855"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e1b03bb9c4d0fad90c30641dc1c22bab730849a7382da032eb2865eeaa19f855"] = "e1b03bb9c4d0fad90c30641dc1c22bab730849a7382da032eb2865eeaa19f855";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "bSGGpt_Q", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/ui/modal/permission/PermissionEditor.ts (764,42)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var ui;
(function (ui) {
    let RepaintMode;
    (function (RepaintMode) {
        RepaintMode[RepaintMode["NONE"] = 0] = "NONE";
        RepaintMode[RepaintMode["REPAINT"] = 1] = "REPAINT";
        RepaintMode[RepaintMode["REPAINT_OBJECT_FULL"] = 2] = "REPAINT_OBJECT_FULL";
        RepaintMode[RepaintMode["REPAINT_FULL"] = 3] = "REPAINT_FULL";
    })(RepaintMode = ui.RepaintMode || (ui.RepaintMode = {}));
    let ClickEventType;
    (function (ClickEventType) {
        ClickEventType[ClickEventType["SIGNLE"] = 0] = "SIGNLE";
        ClickEventType[ClickEventType["DOUBLE"] = 1] = "DOUBLE";
        ClickEventType[ClickEventType["CONTEXT_MENU"] = 2] = "CONTEXT_MENU";
    })(ClickEventType = ui.ClickEventType || (ui.ClickEventType = {}));
    class DrawableObject {
        constructor() {
            this._object_full_draw = false;
            this._width = 0;
            this._transforms = [];
            this.colors = {};
        }
        set_width(value) {
            this._width = value;
        }
        request_full_draw() {
            this._object_full_draw = true;
        }
        pop_full_draw() {
            const result = this._object_full_draw;
            this._object_full_draw = false;
            return result;
        }
        width() { return this._width; }
        push_transform(context) {
            this._transforms.push(context.getTransform());
        }
        pop_transform(context) {
            const transform = this._transforms.pop();
            context.setTransform(transform.a, transform.b, transform.c, transform.d, transform.e, transform.f);
        }
        original_x(context, x) {
            return context.getTransform().e + x;
        }
        original_y(context, y) {
            return context.getTransform().f + y;
        }
        set_color_scheme(scheme) {
            this.colors = scheme;
        }
        set_manager(manager) {
            this.manager = manager;
        }
    }
    class PermissionGroup extends DrawableObject {
        constructor(group) {
            super();
            this._sub_elements = [];
            this.collapsed = false;
            this.group = group;
            this._element_permissions = new PermissionList(this.group.permissions);
            for (const sub of this.group.children)
                this._sub_elements.push(new PermissionGroup(sub));
        }
        draw(context, full) {
            const _full = this.pop_full_draw() || full;
            this.push_transform(context);
            context.translate(PermissionGroup.ARROW_SIZE + 20, PermissionGroup.HEIGHT);
            let sum_height = 0;
            /* let first draw the elements, because if the sum height is zero then we could hide ourselves */
            if (!this.collapsed) { /* draw the next groups */
                for (const group of this._sub_elements) {
                    group.draw(context, full);
                    const height = group.height();
                    sum_height += height;
                    context.translate(0, height);
                }
                this._element_permissions.draw(context, full);
                if (sum_height == 0)
                    sum_height += this._element_permissions.height();
            }
            else {
                const process_group = (group) => {
                    for (const g of group._sub_elements)
                        process_group(g);
                    group._element_permissions.handle_hide();
                    if (sum_height == 0 && group._element_permissions.height() > 0) {
                        sum_height = 1;
                    }
                };
                process_group(this);
            }
            this.pop_transform(context);
            if (_full && sum_height > 0) {
                const arrow_stretch = 2 / 3;
                if (!full) {
                    context.clearRect(0, 0, this.width(), PermissionGroup.HEIGHT);
                }
                context.fillStyle = this.colors.group.name;
                /* arrow */
                {
                    const x1 = this.collapsed ? PermissionGroup.ARROW_SIZE * arrow_stretch / 2 : 0;
                    const y1 = (PermissionGroup.HEIGHT - PermissionGroup.ARROW_SIZE) / 2 + (this.collapsed ? 0 : PermissionGroup.ARROW_SIZE * arrow_stretch / 2); /* center arrow  */
                    const x2 = this.collapsed ? x1 + PermissionGroup.ARROW_SIZE * arrow_stretch : x1 + PermissionGroup.ARROW_SIZE / 2;
                    const y2 = this.collapsed ? y1 + PermissionGroup.ARROW_SIZE / 2 : y1 + PermissionGroup.ARROW_SIZE * arrow_stretch;
                    const x3 = this.collapsed ? x1 : x1 + PermissionGroup.ARROW_SIZE;
                    const y3 = this.collapsed ? y1 + PermissionGroup.ARROW_SIZE : y1;
                    context.beginPath();
                    context.moveTo(x1, y1);
                    context.lineTo(x2, y2);
                    context.lineTo(x3, y3);
                    context.moveTo(x2, y2);
                    context.lineTo(x3, y3);
                    context.fill();
                    this._listener_colaps.region.x = this.original_x(context, 0);
                    this._listener_colaps.region.y = this.original_y(context, y1);
                }
                /* text */
                {
                    context.font = this.colors.group.name_font;
                    context.textBaseline = "middle";
                    context.textAlign = "start";
                    context.fillText(this.group.group.name, PermissionGroup.ARROW_SIZE + 5, PermissionGroup.HEIGHT / 2);
                }
            }
        }
        set_width(value) {
            super.set_width(value);
            for (const element of this._sub_elements)
                element.set_width(value - PermissionGroup.ARROW_SIZE - 20);
            this._element_permissions.set_width(value - PermissionGroup.ARROW_SIZE - 20);
        }
        set_color_scheme(scheme) {
            super.set_color_scheme(scheme);
            for (const child of this._sub_elements)
                child.set_color_scheme(scheme);
            this._element_permissions.set_color_scheme(scheme);
        }
        set_manager(manager) {
            super.set_manager(manager);
            for (const child of this._sub_elements)
                child.set_manager(manager);
            this._element_permissions.set_manager(manager);
        }
        height() {
            let result = 0;
            if (!this.collapsed) {
                for (const element of this._sub_elements)
                    result += element.height();
                result += this._element_permissions.height();
            }
            else {
                //We've to figure out if we have permissions
                const process_group = (group) => {
                    if (result == 0 && group._element_permissions.height() > 0) {
                        result = 1;
                    }
                    else {
                        for (const g of group._sub_elements)
                            process_group(g);
                    }
                };
                process_group(this);
                if (result > 0)
                    return PermissionGroup.HEIGHT;
                return 0;
            }
            if (result > 0) {
                result += PermissionGroup.HEIGHT;
                return result;
            }
            else {
                return 0;
            }
        }
        initialize() {
            for (const child of this._sub_elements)
                child.initialize();
            this._element_permissions.initialize();
            this._listener_colaps = {
                region: {
                    x: 0,
                    y: 0,
                    height: PermissionGroup.ARROW_SIZE,
                    width: PermissionGroup.ARROW_SIZE
                },
                region_weight: 10,
                /*
                on_mouse_enter: () => {
                    this.collapsed_hovered = true;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    this.collapsed_hovered = false;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                */
                on_click: () => {
                    this.collapsed = !this.collapsed;
                    return RepaintMode.REPAINT_FULL;
                },
                set_full_draw: () => this.request_full_draw(),
                mouse_cursor: "pointer"
            };
            this.manager.intercept_manager().register_listener(this._listener_colaps);
        }
        finalize() {
            for (const child of this._sub_elements)
                child.finalize();
            this._element_permissions.finalize();
        }
        collapse_group() {
            for (const child of this._sub_elements)
                child.collapse_group();
            this.collapsed = true;
        }
        expend_group() {
            for (const child of this._sub_elements)
                child.expend_group();
            this.collapsed = false;
        }
    }
    PermissionGroup.HEIGHT = parseFloat(getComputedStyle(document.documentElement).fontSize) * (3 / 2); /* 24 */
    PermissionGroup.ARROW_SIZE = 10; /* 12 */
    class PermissionList extends DrawableObject {
        constructor(permissions) {
            super();
            this.permissions = [];
            for (const permission of permissions)
                this.permissions.push(new PermissionEntry(permission));
        }
        set_width(value) {
            super.set_width(value);
            for (const entry of this.permissions)
                entry.set_width(value);
        }
        draw(context, full) {
            this.push_transform(context);
            for (const permission of this.permissions) {
                permission.draw(context, full);
                context.translate(0, permission.height());
            }
            this.pop_transform(context);
        }
        height() {
            let height = 0;
            for (const permission of this.permissions)
                height += permission.height();
            return height;
        }
        set_color_scheme(scheme) {
            super.set_color_scheme(scheme);
            for (const entry of this.permissions)
                entry.set_color_scheme(scheme);
        }
        set_manager(manager) {
            super.set_manager(manager);
            for (const entry of this.permissions)
                entry.set_manager(manager);
        }
        initialize() {
            for (const entry of this.permissions)
                entry.initialize();
        }
        finalize() {
            for (const entry of this.permissions)
                entry.finalize();
        }
        handle_hide() {
            for (const entry of this.permissions)
                entry.handle_hide();
        }
    }
    class PermissionEntry extends DrawableObject {
        constructor(permission) {
            super();
            this.granted = 22;
            this.flag_skip = true;
            this._prev_selected = false;
            this.flag_skip_hovered = false;
            this.flag_negate_hovered = false;
            this.flag_value_hovered = false;
            this.flag_grant_hovered = false;
            this._permission = permission;
        }
        set_icon_id_image(image) {
            if (this._icon_image === image)
                return;
            this._icon_image = image;
            if (image) {
                image.height = 16;
                image.width = 16;
            }
        }
        permission() { return this._permission; }
        draw(ctx, full) {
            if (!this.pop_full_draw() && !full) { /* Note: do not change this order! */
                /* test for update! */
                return;
            }
            if (this.hidden) {
                this.handle_hide();
                return;
            }
            ctx.lineWidth = 1;
            /* debug box */
            if (false) {
                ctx.fillStyle = "#FF0000";
                ctx.fillRect(0, 0, this.width(), PermissionEntry.HEIGHT);
                ctx.fillStyle = "#000000";
                ctx.strokeRect(0, 0, this.width(), PermissionEntry.HEIGHT);
            }
            if (!full) {
                const off = this.selected || this._prev_selected ? ctx.getTransform().e : 0;
                ctx.clearRect(-off, 0, this.width() + off, PermissionEntry.HEIGHT);
            }
            if (this.selected)
                ctx.fillStyle = this.colors.permission.background_selected;
            else
                ctx.fillStyle = this.colors.permission.background;
            const off = this.selected ? ctx.getTransform().e : 0;
            ctx.fillRect(-off, 0, this.width() + off, PermissionEntry.HEIGHT);
            this._prev_selected = this.selected;
            /* permission name */
            {
                ctx.fillStyle = typeof (this.value) !== "undefined" ? this.colors.permission.name : this.colors.permission.name_unset;
                ctx.textBaseline = "middle";
                ctx.textAlign = "start";
                ctx.font = this.colors.permission.name_font;
                ctx.fillText(this._permission.name, 0, PermissionEntry.HALF_HEIGHT);
            }
            const original_y = this.original_y(ctx, 0);
            const original_x = this.original_x(ctx, 0);
            const width = this.width();
            /* draw granted */
            let w = width - PermissionEntry.COLUMN_GRANTED;
            if (typeof (this.granted) === "number") {
                this._listener_grant.region.x = original_x + w;
                this._listener_grant.region.y = original_y;
                this._draw_number_field(ctx, this.colors.permission.granted, w, 0, PermissionEntry.COLUMN_VALUE, this.granted, this.flag_grant_hovered);
            }
            else {
                this._listener_grant.region.y = original_y;
                this._listener_grant.region.x =
                    original_x
                        + width
                        - PermissionEntry.COLUMN_GRANTED;
            }
            /* draw value and the skip stuff */
            if (typeof (this.value) === "number") {
                w -= PermissionEntry.COLUMN_SKIP + PermissionEntry.COLUMN_PADDING;
                {
                    const x = w + (PermissionEntry.COLUMN_SKIP - PermissionEntry.CHECKBOX_HEIGHT) / 2;
                    const y = 1;
                    this._listener_checkbox_skip.region.x = original_x + x;
                    this._listener_checkbox_skip.region.y = original_y + y;
                    this._draw_checkbox_field(ctx, this.colors.permission.skip, x, y, PermissionEntry.CHECKBOX_HEIGHT, this.flag_skip, this.flag_skip_hovered);
                }
                w -= PermissionEntry.COLUMN_NEGATE + PermissionEntry.COLUMN_PADDING;
                {
                    const x = w + (PermissionEntry.COLUMN_NEGATE - PermissionEntry.CHECKBOX_HEIGHT) / 2;
                    const y = 1;
                    this._listener_checkbox_negate.region.x = original_x + x;
                    this._listener_checkbox_negate.region.y = original_y + y;
                    this._draw_checkbox_field(ctx, this.colors.permission.negate, x, y, PermissionEntry.CHECKBOX_HEIGHT, this.flag_negate, this.flag_negate_hovered);
                }
                w -= PermissionEntry.COLUMN_VALUE + PermissionEntry.COLUMN_PADDING;
                if (this._permission.is_boolean()) {
                    const x = w + PermissionEntry.COLUMN_VALUE - PermissionEntry.CHECKBOX_HEIGHT;
                    const y = 1;
                    this._listener_value.region.width = PermissionEntry.CHECKBOX_HEIGHT;
                    this._listener_value.region.x = original_x + x;
                    this._listener_value.region.y = original_y + y;
                    this._draw_checkbox_field(ctx, this.colors.permission.value_b, x, y, PermissionEntry.CHECKBOX_HEIGHT, this.value > 0, this.flag_value_hovered);
                }
                else if (this._permission.name === "i_icon_id" && this._icon_image) {
                    this._listener_value.region.x = original_x + w;
                    this._listener_value.region.y = original_y;
                    this._listener_value.region.width = PermissionEntry.CHECKBOX_HEIGHT;
                    this._draw_icon_field(ctx, this.colors.permission.value_b, w, 0, PermissionEntry.COLUMN_VALUE, this.flag_value_hovered, this._icon_image);
                }
                else {
                    this._listener_value.region.width = PermissionEntry.COLUMN_VALUE;
                    this._listener_value.region.x = original_x + w;
                    this._listener_value.region.y = original_y;
                    this._draw_number_field(ctx, this.colors.permission.value, w, 0, PermissionEntry.COLUMN_VALUE, this.value, this.flag_value_hovered);
                }
                this._listener_value.disabled = false;
            }
            else {
                this._listener_checkbox_skip.region.y = -1e8;
                this._listener_checkbox_negate.region.y = -1e8;
                this._listener_value.region.y = original_y;
                this._listener_value.region.x =
                    original_x
                        + width
                        - PermissionEntry.COLUMN_GRANTED
                        - PermissionEntry.COLUMN_NEGATE
                        - PermissionEntry.COLUMN_VALUE
                        - PermissionEntry.COLUMN_PADDING * 4;
                this._listener_value.disabled = true;
            }
            this._listener_general.region.y = original_y;
            this._listener_general.region.x = original_x;
        }
        handle_hide() {
            /* so the listener wound get triggered */
            this._listener_value.region.x = -1e8;
            this._listener_grant.region.x = -1e8;
            this._listener_checkbox_negate.region.x = -1e8;
            this._listener_checkbox_skip.region.x = -1e8;
            this._listener_general.region.x = -1e8;
        }
        _draw_icon_field(ctx, scheme, x, y, width, hovered, image) {
            const line = ctx.lineWidth;
            ctx.lineWidth = 2;
            ctx.fillStyle = scheme.border;
            ctx.strokeRect(x + 1, y + 1, PermissionEntry.HEIGHT - 2, PermissionEntry.HEIGHT - 2);
            ctx.lineWidth = line;
            ctx.fillStyle = hovered ? scheme.background_hovered : scheme.background;
            ctx.fillRect(x + 1, y + 1, PermissionEntry.HEIGHT - 2, PermissionEntry.HEIGHT - 2);
            const center_y = y + PermissionEntry.HEIGHT / 2;
            const center_x = x + PermissionEntry.HEIGHT / 2;
            ctx.drawImage(image, center_x - image.width / 2, center_y - image.height / 2);
        }
        _draw_number_field(ctx, scheme, x, y, width, value, hovered) {
            ctx.fillStyle = hovered ? scheme.background_hovered : scheme.background;
            ctx.fillRect(x, y, width, PermissionEntry.HEIGHT);
            ctx.fillStyle = scheme.color;
            ctx.font = scheme.font; //Math.floor(2/3 * PermissionEntry.HEIGHT) + "px Arial";
            ctx.textAlign = "start";
            ctx.fillText(value + "", x, y + PermissionEntry.HALF_HEIGHT, width);
            ctx.strokeStyle = "#6e6e6e";
            const line = ctx.lineWidth;
            ctx.lineWidth = 2;
            ctx.beginPath();
            ctx.moveTo(x, y + PermissionEntry.HEIGHT - 2);
            ctx.lineTo(x + width, y + PermissionEntry.HEIGHT - 2);
            ctx.stroke();
            ctx.lineWidth = line;
        }
        _draw_checkbox_field(ctx, scheme, x, y, height, checked, hovered) {
            ctx.fillStyle = scheme.border;
            ctx.strokeRect(x, y, height, height);
            ctx.fillStyle = checked ?
                (hovered ? scheme.background_checked_hovered : scheme.background_checked) :
                (hovered ? scheme.background_hovered : scheme.background);
            ctx.fillRect(x + 1, y + 1, height - 2, height - 2);
            if (checked) {
                ctx.textAlign = "center";
                ctx.textBaseline = "middle";
                ctx.fillStyle = scheme.checkmark;
                ctx.font = scheme.checkmark_font; //Math.floor((5/4) * PermissionEntry.HEIGHT) + "px Arial";
                ctx.fillText("✓", x + height / 2, y + height / 2);
            }
        }
        height() {
            return this.hidden ? 0 : PermissionEntry.HEIGHT;
        }
        set_width(value) {
            super.set_width(value);
            this._listener_general.region.width = value;
        }
        initialize() {
            this._listener_checkbox_skip = {
                region: {
                    x: -1e8,
                    y: -1e8,
                    height: PermissionEntry.CHECKBOX_HEIGHT,
                    width: PermissionEntry.CHECKBOX_HEIGHT
                },
                region_weight: 10,
                on_mouse_enter: () => {
                    this.flag_skip_hovered = true;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    this.flag_skip_hovered = false;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_click: () => {
                    this.flag_skip = !this.flag_skip;
                    if (this.on_change)
                        this.on_change();
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                set_full_draw: () => this.request_full_draw(),
                mouse_cursor: "pointer"
            };
            this._listener_checkbox_negate = {
                region: {
                    x: -1e8,
                    y: -1e8,
                    height: PermissionEntry.CHECKBOX_HEIGHT,
                    width: PermissionEntry.CHECKBOX_HEIGHT
                },
                region_weight: 10,
                on_mouse_enter: () => {
                    this.flag_negate_hovered = true;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    this.flag_negate_hovered = false;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_click: () => {
                    this.flag_negate = !this.flag_negate;
                    if (this.on_change)
                        this.on_change();
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                set_full_draw: () => this.request_full_draw(),
                mouse_cursor: "pointer"
            };
            this._listener_value = {
                region: {
                    x: -1e8,
                    y: -1e8,
                    height: this._permission.is_boolean() ? PermissionEntry.CHECKBOX_HEIGHT : PermissionEntry.HEIGHT,
                    width: this._permission.is_boolean() ? PermissionEntry.CHECKBOX_HEIGHT : PermissionEntry.COLUMN_VALUE
                },
                region_weight: 10,
                on_mouse_enter: () => {
                    this.flag_value_hovered = true;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    this.flag_value_hovered = false;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_click: () => {
                    if (this._permission.is_boolean()) {
                        this.value = this.value > 0 ? 0 : 1;
                        if (this.on_change)
                            this.on_change();
                        return RepaintMode.REPAINT_OBJECT_FULL;
                    }
                    else if (this._permission.name === "i_icon_id") {
                        this.on_icon_select(this.value).then(value => {
                            this.value = value;
                            if (this.on_change)
                                this.on_change();
                        }).catch(error => {
                            console.warn(_translations.bSGGpt_Q || (_translations.bSGGpt_Q = tr("Failed to select icon: %o")), error);
                        });
                    }
                    else {
                        this._spawn_number_edit(this._listener_value.region.x, this._listener_value.region.y, this._listener_value.region.width, this._listener_value.region.height, this.colors.permission.value, this.value || 0, value => {
                            if (typeof (value) === "number") {
                                this.value = value;
                                this.request_full_draw();
                                this.manager.request_draw(false);
                                if (this.on_change)
                                    this.on_change();
                            }
                        });
                    }
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                set_full_draw: () => this.request_full_draw(),
                mouse_cursor: "pointer"
            };
            this._listener_grant = {
                region: {
                    x: -1e8,
                    y: -1e8,
                    height: PermissionEntry.HEIGHT,
                    width: PermissionEntry.COLUMN_VALUE
                },
                region_weight: 10,
                on_mouse_enter: () => {
                    this.flag_grant_hovered = true;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    this.flag_grant_hovered = false;
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_click: () => {
                    this._spawn_number_edit(this._listener_grant.region.x, this._listener_grant.region.y, this._listener_grant.region.width, this._listener_grant.region.height, this.colors.permission.granted, this.granted || 0, //TODO use max assignable value?
                    //TODO use max assignable value?
                    //TODO use max assignable value?
                    value => {
                        if (typeof (value) === "number") {
                            this.granted = value;
                            this.request_full_draw();
                            this.manager.request_draw(false);
                            if (this.on_grant_change)
                                this.on_grant_change();
                        }
                    });
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                set_full_draw: () => this.request_full_draw(),
                mouse_cursor: "pointer"
            };
            this._listener_general = {
                region: {
                    x: -1e8,
                    y: -1e8,
                    height: PermissionEntry.HEIGHT,
                    width: 0
                },
                region_weight: 0,
                /*
                on_mouse_enter: () => {
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                on_mouse_leave: () => {
                    return RepaintMode.REPAINT_OBJECT_FULL;
                },
                */
                on_click: (event) => {
                    this.manager.set_selected_entry(this);
                    if (event.type == ClickEventType.DOUBLE && typeof (this.value) === "undefined")
                        return this._listener_value.on_click(event);
                    else if (event.type == ClickEventType.CONTEXT_MENU) {
                        const mouse = this.manager.mouse;
                        if (this.on_context_menu) {
                            this.on_context_menu(mouse.x, mouse.y);
                            event.consumed = true;
                        }
                    }
                    return RepaintMode.NONE;
                },
                set_full_draw: () => this.request_full_draw(),
            };
            this.manager.intercept_manager().register_listener(this._listener_checkbox_negate);
            this.manager.intercept_manager().register_listener(this._listener_checkbox_skip);
            this.manager.intercept_manager().register_listener(this._listener_value);
            this.manager.intercept_manager().register_listener(this._listener_grant);
            this.manager.intercept_manager().register_listener(this._listener_general);
        }
        finalize() { }
        _spawn_number_edit(x, y, width, height, color, value, callback) {
            const element = $.spawn("div");
            element.prop("contentEditable", true);
            element
                .css("pointer-events", "none")
                .css("background", color.background)
                .css("display", "block")
                .css("position", "absolute")
                .css("top", y)
                .css("left", x)
                .css("width", width)
                .css("height", height)
                .css("z-index", 1e6);
            element.text(value);
            element.appendTo(this.manager.canvas_container);
            element.focus();
            element.on('focusout', event => {
                console.log("permission changed to " + element.text());
                if (!isNaN(parseInt(element.text()))) {
                    callback(parseInt(element.text()));
                }
                else {
                    callback(undefined);
                }
                element.remove();
            });
            element.on('keypress', event => {
                if (event.which == KeyCode.KEY_RETURN)
                    element.trigger('focusout');
                const text = String.fromCharCode(event.which);
                if (isNaN(parseInt(text)) && text != "-")
                    event.preventDefault();
                if (element.text().length > 7)
                    event.preventDefault();
            });
            if (window.getSelection) {
                const selection = window.getSelection();
                const range = document.createRange();
                range.selectNodeContents(element[0]);
                selection.removeAllRanges();
                selection.addRange(range);
            }
        }
        trigger_value_assign() {
            this._listener_value.on_click(undefined);
        }
        trigger_grant_assign() {
            this._listener_grant.on_click(undefined);
        }
    }
    PermissionEntry.HEIGHT = PermissionGroup.HEIGHT; /* 24 */
    PermissionEntry.HALF_HEIGHT = PermissionEntry.HEIGHT / 2;
    PermissionEntry.CHECKBOX_HEIGHT = PermissionEntry.HEIGHT - 2;
    PermissionEntry.COLUMN_PADDING = 2;
    PermissionEntry.COLUMN_VALUE = 75;
    PermissionEntry.COLUMN_GRANTED = 75;
    //public static readonly COLUMN_NEGATE = 25;
    //public static readonly COLUMN_SKIP = 25;
    PermissionEntry.COLUMN_NEGATE = 75;
    PermissionEntry.COLUMN_SKIP = 75;
    class InteractionManager {
        constructor() {
            this._listeners = [];
            this._entered_listeners = [];
        }
        register_listener(listener) {
            this._listeners.push(listener);
        }
        remove_listener(listener) {
            this._listeners.remove(listener);
        }
        process_mouse_move(new_x, new_y) {
            let _entered_listeners = [];
            for (const listener of this._listeners) {
                const aabb = listener.region;
                if (listener.disabled)
                    continue;
                if (new_x < aabb.x || new_x > aabb.x + aabb.width)
                    continue;
                if (new_y < aabb.y || new_y > aabb.y + aabb.height)
                    continue;
                _entered_listeners.push(listener);
            }
            let repaint = RepaintMode.NONE;
            _entered_listeners.sort((a, b) => (a.region_weight || 0) - (b.region_weight || 0));
            for (const listener of this._entered_listeners) {
                if (listener.on_mouse_leave && _entered_listeners.indexOf(listener) == -1) {
                    let mode = listener.on_mouse_leave();
                    if (mode == RepaintMode.REPAINT_OBJECT_FULL) {
                        mode = RepaintMode.REPAINT;
                        if (listener.set_full_draw)
                            listener.set_full_draw();
                    }
                    if (mode > repaint)
                        repaint = mode;
                }
            }
            for (const listener of _entered_listeners) {
                if (listener.on_mouse_enter && this._entered_listeners.indexOf(listener) == -1) {
                    let mode = listener.on_mouse_enter();
                    if (mode == RepaintMode.REPAINT_OBJECT_FULL) {
                        mode = RepaintMode.REPAINT;
                        if (listener.set_full_draw)
                            listener.set_full_draw();
                    }
                    if (mode > repaint)
                        repaint = mode;
                }
            }
            this._entered_listeners = _entered_listeners;
            let cursor;
            for (const listener of _entered_listeners)
                if (typeof (listener.mouse_cursor) === "string") {
                    cursor = listener.mouse_cursor;
                }
            return {
                repaint: repaint,
                cursor: cursor
            };
        }
        process_click_event(x, y, event) {
            const move_result = this.process_mouse_move(x, y);
            let repaint = move_result.repaint;
            for (const listener of this._entered_listeners)
                if (listener.on_click) {
                    let mode = listener.on_click(event);
                    if (mode == RepaintMode.REPAINT_OBJECT_FULL) {
                        mode = RepaintMode.REPAINT;
                        if (listener.set_full_draw)
                            listener.set_full_draw();
                    }
                    if (mode > repaint)
                        repaint = mode;
                }
            return repaint;
        }
        process_click(x, y) {
            const event = {
                consumed: false,
                type: ClickEventType.SIGNLE,
                offset_x: x,
                offset_y: y
            };
            return this.process_click_event(x, y, event);
        }
        process_dblclick(x, y) {
            const event = {
                consumed: false,
                type: ClickEventType.DOUBLE,
                offset_x: x,
                offset_y: y
            };
            return this.process_click_event(x, y, event);
        }
        process_context_menu(js_event, x, y) {
            const event = {
                consumed: js_event.defaultPrevented,
                type: ClickEventType.CONTEXT_MENU,
                offset_x: x,
                offset_y: y
            };
            const result = this.process_click_event(x, y, event);
            if (event.consumed)
                js_event.preventDefault();
            return result;
        }
    }
    ui.InteractionManager = InteractionManager;
    class PermissionEditor {
        constructor(permissions) {
            this._max_height = 0;
            this._permission_count = 0;
            this._permission_group_count = 0;
            this._draw_requested = false;
            this._draw_requested_full = false;
            this._elements = [];
            this._permission_entry_map = {};
            this.mouse = {
                x: 0,
                y: 0
            };
            this.grouped_permissions = permissions;
            this.canvas_container = $.spawn("div")
                .addClass("window-resize-listener") /* we want to handle resized */
                .css("min-width", "750px")
                .css("position", "relative")
                .css("user-select", "none")[0];
            this.canvas = $.spawn("canvas")[0];
            this.canvas_container.appendChild(this.canvas);
            this._intersect_manager = new InteractionManager();
            this.canvas_container.onmousemove = event => {
                this.mouse.x = event.pageX;
                this.mouse.y = event.pageY;
                const draw = this._intersect_manager.process_mouse_move(event.offsetX, event.offsetY);
                this.canvas_container.style.cursor = draw.cursor || "";
                this._handle_repaint(draw.repaint);
            };
            this.canvas_container.onclick = event => {
                this._handle_repaint(this._intersect_manager.process_click(event.offsetX, event.offsetY));
            };
            this.canvas_container.ondblclick = event => {
                this._handle_repaint(this._intersect_manager.process_dblclick(event.offsetX, event.offsetY));
            };
            this.canvas_container.oncontextmenu = (event) => {
                this._handle_repaint(this._intersect_manager.process_context_menu(event, event.offsetX, event.offsetY));
            };
            this.canvas_container.onresize = () => this.request_draw(true);
            this.initialize();
        }
        _handle_repaint(mode) {
            if (mode == RepaintMode.REPAINT || mode == RepaintMode.REPAINT_FULL)
                this.request_draw(mode == RepaintMode.REPAINT_FULL);
        }
        request_draw(full) {
            this._draw_requested_full = this._draw_requested_full || full;
            if (this._draw_requested)
                return;
            this._draw_requested = true;
            requestAnimationFrame(() => {
                this.draw(this._draw_requested_full);
            });
        }
        draw(full) {
            this._draw_requested = false;
            this._draw_requested_full = false;
            /* clear max height */
            this.canvas_container.style.overflowY = "shown";
            this.canvas_container.style.height = undefined;
            const max_height = this._max_height;
            const max_width = this.canvas_container.clientWidth;
            const update_width = this.canvas.width != max_width;
            const full_draw = typeof (full) !== "boolean" || full || update_width;
            if (update_width) {
                this.canvas.width = max_width;
                for (const element of this._elements)
                    element.set_width(max_width);
            }
            console.log("Drawing%s on %dx%d", full_draw ? " full" : "", max_width, max_height);
            if (full_draw)
                this.canvas.height = max_height;
            const ctx = this._canvas_context;
            ctx.resetTransform();
            if (full_draw)
                ctx.clearRect(0, 0, max_width, max_height);
            let sum_height = 0;
            for (const element of this._elements) {
                element.draw(ctx, full_draw);
                const height = element.height();
                sum_height += height;
                ctx.translate(0, height);
            }
            this.canvas_container.style.overflowY = "hidden";
            this.canvas_container.style.height = sum_height + "px";
        }
        initialize() {
            /* setup the canvas */
            {
                const apply_group = (group) => {
                    for (const g of group.children || [])
                        apply_group(g);
                    this._permission_group_count++;
                    this._permission_count += group.permissions.length;
                };
                for (const group of this.grouped_permissions)
                    apply_group(group);
                this._max_height = this._permission_count * PermissionEditor.PERMISSION_HEIGHT + this._permission_group_count * PermissionEditor.PERMISSION_GROUP_HEIGHT;
                console.log("%d permissions and %d groups required %d height", this._permission_count, this._permission_group_count, this._max_height);
                this.canvas.style.width = "100%";
                this.canvas.style.flexShrink = "0";
                this.canvas_container.style.flexShrink = "0";
                this._canvas_context = this.canvas.getContext("2d");
            }
            const font = Math.floor(2 / 3 * PermissionEntry.HEIGHT) + "px Arial";
            const font_checkmark = Math.floor((5 / 4) * PermissionEntry.HEIGHT) + "px Arial";
            const checkbox = {
                background: "#FFFFFF",
                background_hovered: "#CCCCCC",
                background_checked: "#0000AA",
                background_checked_hovered: "#0000AA77",
                border: "#000000",
                checkmark: "#FFFFFF",
                checkmark_font: font_checkmark
            };
            const input = {
                color: "#000000",
                font: font,
                background_hovered: "#CCCCCCCC",
                background: "#FFFFFF00"
            };
            const color_scheme = {
                group: {
                    name: "black",
                    name_font: font
                },
                permission: {
                    name: "black",
                    name_unset: "#888888",
                    name_font: font,
                    background: "#FFFFFF",
                    background_selected: "#00007788",
                    value: input,
                    value_b: checkbox,
                    granted: input,
                    negate: checkbox,
                    skip: checkbox
                }
            };
            window.scheme = color_scheme;
            /* setup elements to draw */
            {
                const process_group = (group) => {
                    for (const permission of group._element_permissions.permissions)
                        this._permission_entry_map[permission.permission().id] = permission;
                    for (const g of group._sub_elements)
                        process_group(g);
                };
                for (const group of this.grouped_permissions) {
                    const element = new PermissionGroup(group);
                    element.set_color_scheme(color_scheme);
                    element.set_manager(this);
                    process_group(element);
                    this._elements.push(element);
                }
                for (const element of this._elements) {
                    element.initialize();
                }
            }
        }
        intercept_manager() {
            return this._intersect_manager;
        }
        set_selected_entry(entry) {
            if (this._selected_entry === entry)
                return;
            if (this._selected_entry) {
                this._selected_entry.selected = false;
                this._selected_entry.request_full_draw();
            }
            this._selected_entry = entry;
            if (this._selected_entry) {
                this._selected_entry.selected = true;
                this._selected_entry.request_full_draw();
            }
            this.request_draw(false);
        }
        permission_entries() {
            return Object.keys(this._permission_entry_map).map(e => this._permission_entry_map[e]);
        }
        collapse_all() {
            for (const group of this._elements)
                group.collapse_group();
            this.request_draw(true);
        }
        expend_all() {
            for (const group of this._elements)
                group.expend_group();
            this.request_draw(true);
        }
    }
    PermissionEditor.PERMISSION_HEIGHT = PermissionEntry.HEIGHT;
    PermissionEditor.PERMISSION_GROUP_HEIGHT = PermissionGroup.HEIGHT;
    ui.PermissionEditor = PermissionEditor;
})(ui || (ui = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["3fea603cc06dc1d64bebe142740a66d2c69ee01d1588cd1fc0879f47cbec3917"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["3fea603cc06dc1d64bebe142740a66d2c69ee01d1588cd1fc0879f47cbec3917"] = "3fea603cc06dc1d64bebe142740a66d2c69ee01d1588cd1fc0879f47cbec3917";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of []) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
var audio;
(function (audio) {
    let recorder;
    (function (recorder) {
        let InputConsumerType;
        (function (InputConsumerType) {
            InputConsumerType[InputConsumerType["CALLBACK"] = 0] = "CALLBACK";
            InputConsumerType[InputConsumerType["NODE"] = 1] = "NODE";
            InputConsumerType[InputConsumerType["NATIVE"] = 2] = "NATIVE";
        })(InputConsumerType = recorder.InputConsumerType || (recorder.InputConsumerType = {}));
        let filter;
        (function (filter) {
            let Type;
            (function (Type) {
                Type[Type["THRESHOLD"] = 0] = "THRESHOLD";
                Type[Type["VOICE_LEVEL"] = 1] = "VOICE_LEVEL";
                Type[Type["STATE"] = 2] = "STATE";
            })(Type = filter.Type || (filter.Type = {}));
        })(filter = recorder.filter || (recorder.filter = {}));
        let InputState;
        (function (InputState) {
            InputState[InputState["PAUSED"] = 0] = "PAUSED";
            InputState[InputState["INITIALIZING"] = 1] = "INITIALIZING";
            InputState[InputState["RECORDING"] = 2] = "RECORDING";
            InputState[InputState["DRY"] = 3] = "DRY";
        })(InputState = recorder.InputState || (recorder.InputState = {}));
    })(recorder = audio.recorder || (audio.recorder = {}));
})(audio || (audio = {}));
typeof _translations !== "undefined" || (_translations = {});
_translations["declared"] = _translations["declared"] || (_translations["declared"] = {});
_translations["declared_files"] = _translations["declared_files"] || (_translations["declared_files"] = {});
unique_translation_check: {
    if (_translations["declared_files"]["e11aa6bf60b36443c58a596efcfc80423a8df91b5f35948fd824f403e454b9ca"] !== undefined) {
        console.warn("This file has already been loaded!\nAre you executing scripts twice?");
        break unique_translation_check;
    }
    else
        _translations["declared_files"]["e11aa6bf60b36443c58a596efcfc80423a8df91b5f35948fd824f403e454b9ca"] = "e11aa6bf60b36443c58a596efcfc80423a8df91b5f35948fd824f403e454b9ca";
    /*Auto generated helper for testing if the translation keys are unique*/
    for (var { name: _i, path: _a } of [{ name: "DSqyWAoc", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/voice/RecorderProfile.ts (85,26)" }, { name: "oJHMjVh6", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/voice/RecorderProfile.ts (145,25)" }, { name: "CvEXCWqS", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/voice/RecorderProfile.ts (149,31)" }, { name: "WWhmoiIq", path: "/home/wolverindev/TeaSpeak/Web-Client/shared/js/voice/RecorderProfile.ts (199,30)" }]) {
        if (_translations["declared"][_i] !== undefined)
            throw "Translation with generated name \"" + _i + "\" already exists!\nIt has been already defined here: " + _translations["declared"][_i] + "\nAttempted to redefine here: " + _a + "\nRegenerate and/or fix your program!";
        else
            _translations["declared"][_i] = _a;
    }
}
let default_recorder; /* needs initialize */
class RecorderProfile {
    constructor(name, volatile) {
        this.name = name;
        this.volatile = typeof (volatile) === "boolean" ? volatile : false;
        this.initialize_input();
        this._ppt_hook = {
            callback_release: () => {
                if (this._ppt_timeout)
                    clearTimeout(this._ppt_timeout);
                this._ppt_timeout = setTimeout(() => {
                    const filter = this.input.get_filter(audio.recorder.filter.Type.STATE);
                    if (filter)
                        filter.set_state(true);
                }, this.config.vad_push_to_talk.delay);
            },
            callback_press: () => {
                if (this._ppt_timeout)
                    clearTimeout(this._ppt_timeout);
                const filter = this.input.get_filter(audio.recorder.filter.Type.STATE);
                if (filter)
                    filter.set_state(false);
            },
            cancel: false
        };
        this._ppt_hook_registered = false;
        this.record_supported = true;
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.load();
            yield this.reinitialize_filter();
            try {
                yield this.input.start();
            }
            catch (error) {
                console.warn(_translations.DSqyWAoc || (_translations.DSqyWAoc = tr("Failed to start recorder after initialize (%o)")), error);
            }
        });
    }
    initialize_input() {
        this.input = audio.recorder.create_input();
        this.input.callback_begin = () => {
            console.log("Voice start");
            if (this.callback_start)
                this.callback_start();
        };
        this.input.callback_end = () => {
            console.log("Voice end");
            if (this.callback_stop)
                this.callback_stop();
        };
        /*
        this.input.callback_state_change = () => {
            const new_state = this.input.current_state() === audio.recorder.InputState.RECORDING || this.input.current_state() === audio.recorder.InputState.DRY;

            if(new_state === this.record_supported)
                return;

            this.record_supported = new_state;
            if(this.callback_support_change)
                this.callback_support_change();
        }
        */
    }
    load() {
        return __awaiter(this, void 0, void 0, function* () {
            this.config = settings.static_global(Settings.FN_PROFILE_RECORD(this.name), {});
            if (typeof (this.config.version) === "undefined") {
                /* default config */
                this.config = {
                    version: 1,
                    device_id: undefined,
                    vad_threshold: {
                        threshold: 50
                    },
                    vad_type: "threshold",
                    vad_push_to_talk: {
                        delay: 300,
                        key_alt: false,
                        key_ctrl: false,
                        key_shift: false,
                        key_windows: false,
                        key_code: 't'
                    }
                };
            }
            {
                const all_devices = audio.recorder.devices();
                const devices = all_devices.filter(e => e.default_input || e.unique_id === this.config.device_id);
                const device = devices.find(e => e.unique_id === this.config.device_id) || devices[0];
                console.log(_translations.oJHMjVh6 || (_translations.oJHMjVh6 = tr("Loaded record profile device %s | %o (%o)")), this.config.device_id, device, all_devices);
                try {
                    yield this.input.set_device(device);
                }
                catch (error) {
                    console.error(_translations.CvEXCWqS || (_translations.CvEXCWqS = tr("Failed to set input device (%o)")), error);
                }
            }
        });
    }
    save(enforce) {
        if (enforce || !this.volatile) {
            settings.changeGlobal(Settings.FN_PROFILE_RECORD(this.name), this.config);
        }
    }
    reinitialize_filter() {
        return __awaiter(this, void 0, void 0, function* () {
            this.input.clear_filter();
            if (this._ppt_hook_registered) {
                ppt.unregister_key_hook(this._ppt_hook);
                this._ppt_hook_registered = false;
            }
            if (this.config.vad_type === "threshold") {
                const filter = this.input.get_filter(audio.recorder.filter.Type.THRESHOLD);
                yield filter.set_threshold(this.config.vad_threshold.threshold);
                yield filter.set_margin_frames(10); /* 500ms */
                /* legacy client support */
                if ('set_attack_smooth' in filter)
                    filter.set_attack_smooth(.25);
                if ('set_release_smooth' in filter)
                    filter.set_release_smooth(.9);
                this.input.enable_filter(audio.recorder.filter.Type.THRESHOLD);
            }
            else if (this.config.vad_type === "push_to_talk") {
                const filter = this.input.get_filter(audio.recorder.filter.Type.STATE);
                yield filter.set_state(true);
                for (const key of ["key_alt", "key_ctrl", "key_shift", "key_windows", "key_code"])
                    this._ppt_hook[key] = this.config.vad_push_to_talk[key];
                ppt.register_key_hook(this._ppt_hook);
                this._ppt_hook_registered = true;
                this.input.enable_filter(audio.recorder.filter.Type.STATE);
            }
            else if (this.config.vad_type === "active") { }
        });
    }
    unmount() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.callback_unmount)
                this.callback_unmount();
            if (this.input) {
                try {
                    yield this.input.set_consumer(undefined);
                }
                catch (error) {
                    console.warn(_translations.WWhmoiIq || (_translations.WWhmoiIq = tr("Failed to unmount input consumer for profile (%o)")), error);
                }
            }
            this.callback_start = undefined;
            this.callback_stop = undefined;
            this.callback_unmount = undefined;
            this.current_handler = undefined;
        });
    }
    get_vad_type() { return this.config.vad_type; }
    set_vad_type(type) {
        if (this.config.vad_type === type)
            return;
        this.config.vad_type = type;
        this.reinitialize_filter();
        this.save();
    }
    get_vad_threshold() { return this.config.vad_threshold.threshold; }
    set_vad_threshold(value) {
        if (this.config.vad_threshold.threshold === value)
            return;
        this.config.vad_threshold.threshold = value;
        this.reinitialize_filter();
        this.save();
    }
    get_vad_ppt_key() { return this.config.vad_push_to_talk; }
    set_vad_ppt_key(key) {
        for (const _key of ["key_alt", "key_ctrl", "key_shift", "key_windows", "key_code"])
            this.config.vad_push_to_talk[_key] = key[_key];
        this.reinitialize_filter();
        this.save();
    }
    get_vad_ppt_delay() { return this.config.vad_push_to_talk.delay; }
    set_vad_ppt_delay(value) {
        if (this.config.vad_push_to_talk.delay === value)
            return;
        this.config.vad_push_to_talk.delay = value;
        this.reinitialize_filter();
        this.save();
    }
    current_device() { return this.input.current_device(); }
    set_device(device) {
        this.config.device_id = device ? device.unique_id : undefined;
        this.save();
        return this.input.set_device(device);
    }
}
//# sourceMappingURL=shared.js.map
//# sourceMappingURL=client.js.map